(*---------------------------------------------------------------------------
   :Program.    ControlDemo
   :Author.     Fridtjof Bjrn Siebert
   :Address.    Nobileweg 67, D-7-Stgt-40
   :Phone.      (0)711/822509
   :Shortcut.   [fbs]
   :Version.    1.0
   :Date.       31-May-88
   :Copyright.  PD
   :Language.   MODULA-II
   :Translator. M2Amiga
   :Imports.    ControlIntuition [fbs]
   :Contents.   DemonstrationsPrgramm zu ControlIntuition;
   :Remark.     I didn't believe this could be so easy !
---------------------------------------------------------------------------*)
MODULE ControlDemo;

FROM ControlIntuition IMPORT DisableIntuition, EnableIntuition, LeftButton,
       LeftButtonRel, RightButton, RightButtonRel, MouseX, MouseY,
       LastRawKey, LastRawKeyTime;

FROM Timer IMPORT TimeVal;

FROM InOut IMPORT WriteString, WriteLn, WriteCard, WriteInt;

PROCEDURE CmpTime(a,b: TimeVal): BOOLEAN;

BEGIN
  RETURN (a.secs=b.secs) AND (a.micro=b.micro);
END CmpTime;

VAR
  LastR, LastL, LastRrel, LastLrel, LastKey: TimeVal;
  OldX,OldY: LONGINT;
  CountRight: CARDINAL;

BEGIN
  DisableIntuition();
  WriteString("Intuition Disabled"); WriteLn;
  LastL := LeftButton;  LastLrel := LeftButtonRel;
  LastR := RightButton; LastRrel := RightButtonRel;
  LastKey := LastRawKeyTime;
  OldX := MouseX; OldY := MouseY;
  CountRight := 0;
  REPEAT
    IF NOT(CmpTime(LastL,LeftButton)) THEN
      LastL := LeftButton;
      INC(CountRight);
      WriteString("Left pressed"); WriteLn;
    END;
    IF NOT(CmpTime(LastLrel,LeftButtonRel)) THEN
      LastLrel := LeftButtonRel;
      WriteString("Left released"); WriteLn;
    END;
    IF NOT(CmpTime(LastR,RightButton)) THEN
      LastR := RightButton;
      WriteString("Right pressed"); WriteLn;
    END;
    IF NOT(CmpTime(LastRrel,RightButtonRel)) THEN
      LastRrel := RightButtonRel;
      WriteString("Right released"); WriteLn;
    END;
    IF NOT(CmpTime(LastKey,LastRawKeyTime)) THEN
      LastKey := LastRawKeyTime;
      WriteString("Key Pressed. Code: "); WriteCard(LastRawKey,6); WriteLn;
    END;
    IF (MouseX#OldX) OR (MouseY#OldY) THEN
      OldX := MouseX;
      OldY := MouseY;
      WriteString("Mouse Position: "); WriteLn;
      WriteString(" x: "); WriteInt(MouseX,10); WriteLn;
      WriteString(" y: "); WriteInt(MouseY,10); WriteLn;
    END;
  UNTIL CountRight=3;
  EnableIntuition();
  WriteString("Intuition Enabled"); WriteLn;
END ControlDemo.

