(*********************************************************************
 
   -:Program.  	 dostime.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      07031/273873
   -:shortcut. 	 [pit]
   -:Version.  	 1.0   
   -:Date.     	 06.04.1988
   -:Copyright.  Intern
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 
    :Remark.	 "AMOK - Amiga Modula-2 Klub / Stuttgart"
    
**********************************************************************
Dieses Implementation Modul enthlt Procuduren zum Auslesen und 
Abspeichern von System-Zeit und -Datum. 
Ursprnglich wollte ich ein kleines Programm zum Einstellen von Zeit 
und Datum ber Gadgets von Intuition aus schreiben 
(mit den Tasten "<" "<<" ">" ">>" wie ein Cassettenrecorder) aber 
dann fehlte mir die ntige Geduld. 
Sollte irgendjemand ein solches Programm (in Modula-II!) geschrieben 
haben: Bitte melden! 
**********************************************************************)
IMPLEMENTATION MODULE dostime;

FROM Arts IMPORT	Assert;

FROM SYSTEM IMPORT	ADR;

FROM Strings IMPORT	Insert, Occurs, Copy, Delete;

FROM RealConversions 
		IMPORT	RealToStr;	

FROM Dos IMPORT		Date, DatePtr, DateStamp, Execute;

VAR			Datum		:Date;
                        Minute,
                      	Stunde,
                        Tag,
                        Monat,
                        Jahr		:LONGINT;
                        SekundeStr,
                        MinuteStr,
                      	StundeStr,
                        TagStr,
                        MonatStr,
                        JahrStr		:ARRAY [0..1] OF CHAR;
                        error		:INTEGER;
                        err		:BOOLEAN;
                        MonatName	:ARRAY [1..12] OF ARRAY [0..2] OF CHAR;
                        CommandStr	:ARRAY [0..23] OF CHAR;
                        
PROCEDURE IntToChar (Dat :LONGINT; VAR DatStr :ARRAY OF CHAR);
  VAR	BlankLoc	:INTEGER;
  BEGIN
  RealToStr(FLOAT(Dat),DatStr,-2,0,FALSE,err);  (* Int zu Char machen *)
  BlankLoc:=Occurs(DatStr,0," ",FALSE);
  IF (BlankLoc<>-1) THEN			(* wenn Leerzeichen : *)
	Insert(DatStr,BlankLoc-1,"0");		(* durch "0" ersetzen *)
  END; (*IF*)
  END IntToChar;
    
PROCEDURE InitAll;
  BEGIN
  CommandStr:="Date                    ";
  SekundeStr:="00";
  MonatName[1]:="Jan";
  MonatName[2]:="Feb";
  MonatName[3]:="Mar";
  MonatName[4]:="Apr";
  MonatName[5]:="May";
  MonatName[6]:="Jun";
  MonatName[7]:="Jul";
  MonatName[8]:="Aug";
  MonatName[9]:="Sep";
  MonatName[10]:="Oct";
  MonatName[11]:="Nov";
  MonatName[12]:="Dec";
  END InitAll;
  
PROCEDURE AddStrings;
  BEGIN
  Delete(CommandStr,0,50);		(* Alten String lschen     *)
  Insert(CommandStr,0,"Date");   	(* So soll der neue String  *)
  Insert(CommandStr,4," ");		(* aussehen:		    *)
  Insert(CommandStr,5,TagStr);		(*"Date TT-MMM-JJ HH:MM:SS "*)
  Insert(CommandStr,7,"-");		(*"012345678901234567890123"*)
  Insert(CommandStr,8,MonatName[Monat]);
  Insert(CommandStr,11,"-");
  Insert(CommandStr,12,JahrStr);
  Insert(CommandStr,14," ");
  Insert(CommandStr,15,StundeStr);
  Insert(CommandStr,17,":");
  Insert(CommandStr,18,MinuteStr);
  Insert(CommandStr,20,":");
  Insert(CommandStr,21,SekundeStr);
  END AddStrings;

PROCEDURE ReadDiscDate(VAR Jahr,Monat,Tag,Stunde,Minute :LONGINT);		
  VAR	n,l	:LONGINT;	
  BEGIN
  DateStamp(ADR(Datum));	(* Datum von Startdisc lesen *)
  n:=Datum.days-2251;
  Jahr:=(4*n+3) DIV 1461;
  n:=n-1461*Jahr DIV 4;
  Jahr:=Jahr+84;
  Monat:=(5*n+2) DIV 153;
  Tag:=n-(153*Monat+2) DIV 5+1;
  Monat:=Monat+3;
  IF (Monat>12) THEN
  	Jahr:=Jahr+1;
        Monat:=Monat-12;
  END; (*IF*)
  l:=Datum.minute;
  Stunde:=l DIV 60;
  Minute:=l-Stunde*60;
  END ReadDiscDate;

PROCEDURE MakeCommandStr;
  BEGIN
  IntToChar(Tag,TagStr);
  IntToChar(Jahr,JahrStr);
  IntToChar(Stunde,StundeStr);
  IntToChar(Minute,MinuteStr);
  AddStrings;
  END MakeCommandStr;

PROCEDURE WriteDiscDate(VAR Jahr,Monat,Tag,Stunde,Minute :LONGINT);
  BEGIN
  MakeCommandStr;
  error:=Execute(ADR(CommandStr),NIL,NIL);
  Assert((error<>0),ADR("Datum-Sicherung fehlgeschlagen"));
  END WriteDiscDate;

BEGIN
 InitAll;
END dostime.mod
