(*********************************************************************
 
   -:Program.  	 DragDemo.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      ----
   -:shortcut. 	 [pit]
   -:Version.  	 1.0   
   -:Date.     	 13.04.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 16.05.1988
   -:Contents.	 Demonstration of DragNum	 
    :Remark.	 
    
**********************************************************************
Dieses Programm demonstriert die Arbeitsweise des 
Implementation Moduls DragNum.mod.
ShowNumber(Window-Pointer,Zahlenwert) zeigt den bergebenen Zahlenwert 
in dem Window an, auf das der bergebene Window-Pointer zeigt.
Es ist wichtig, da die Konstanten MINWIDTH und MINHEIGHT ebenfalls
importiert und an den NewWindow-Record bergeben werden, kleinere
Werte knnen bei brutaler Handhabung des Windows nach Indien fhren.
**********************************************************************)
MODULE dragdemo;

FROM SYSTEM IMPORT 	ADDRESS,ADR;

FROM Arts IMPORT	Assert,TermProcedure;

FROM RandomNumber 
		IMPORT 	RND;

FROM Intuition IMPORT	NewWindow, WindowPtr, OpenWindow, ScreenPtr, 
			CloseWindow, IDCMPFlags, IDCMPFlagSet, WindowFlags, 
                        WindowFlagSet, RemakeDisplay, Window, otherRefresh,
                        ScreenFlagSet, ScreenFlags, IntuiMessagePtr;

FROM Exec IMPORT	GetMsg, ReplyMsg; 

FROM DragNum IMPORT 	ShowNumber, SetNumPrefs, MINWIDTH, MINHEIGHT;

FROM Graphics IMPORT	RastPortPtr, BitMap, AllocRaster, FreeRaster, 
			InitBitMap, BltClear;

CONST	MAXWIDTH=640;
	MAXHEIGHT=352;
        DEPTH=2;

	(* Variable fr window *)

VAR	rp		:RastPortPtr;
	nWindow		:NewWindow;
	WindowP		:WindowPtr;
        i,j,Dauer	:LONGINT;
        error		:LONGINT;
        errorP1,
        errorP2		:ADDRESS;
 	Zahl,
        Schritt,
        Ende		:INTEGER;
	Farbe		:CARDINAL;
        ScreenP		:ScreenPtr;
        WindowBM	:BitMap;
        MsgPtr		:IntuiMessagePtr;
        class		:IDCMPFlagSet;

PROCEDURE Cleanup;
 BEGIN
  IF WindowP<>NIL THEN CloseWindow(WindowP) END;
  FOR i:=0 TO DEPTH-1 DO
  END;
 END Cleanup;


PROCEDURE MakeWindow(WTitel:ADDRESS;Lagex,Lagey,Breite,Hoehe:INTEGER);
 BEGIN
  TermProcedure(Cleanup);
  WITH nWindow DO
  	leftEdge:=Lagex;	topEdge:=Lagey; 
  	width:=Breite; 		height:=Hoehe;
  	detailPen:=0; 
  	blockPen:=1;
  	idcmpFlags:=IDCMPFlagSet{closeWindow};  
  	flags:=WindowFlagSet{ 	windowSizing, windowDrag, windowDepth,
        			gimmeZeroZero, activate, noCareRefresh,
                                windowClose};
  	title:=WTitel;
  	type:=ScreenFlagSet{wbenchScreen};
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=NIL; 
  	bitMap:=NIL;
  	minWidth:=MINWIDTH;     	
  	minHeight:=MINHEIGHT; 		
  	maxWidth:=MAXWIDTH; 		
  	maxHeight:=MAXHEIGHT;		
  END; (*WITH*)
  WindowP:=OpenWindow(nWindow);
  Assert(WindowP<>NIL,ADR("konnte Fenster nicht ffnen"));	
  rp:=WindowP^.rPort;
  ScreenP:=WindowP^.wScreen;
 END MakeWindow;

PROCEDURE DoDemo;
 BEGIN
  LOOP
    Zahl:=ScreenP^.mouseX;	
    ShowNumber(WindowP,Zahl);
    MsgPtr:=GetMsg(WindowP^.userPort);
    class:=MsgPtr^.class;
    IF class=IDCMPFlagSet{closeWindow} THEN EXIT END;
    IF MsgPtr<>NIL THEN ReplyMsg(MsgPtr) END;                
  END;  
 END DoDemo;

BEGIN
 MakeWindow(ADR("Change Size!"),0,10,2*MINWIDTH,2*MINHEIGHT);
 SetNumPrefs(3,0,2,0.9,0.9);
 DoDemo;
END dragdemo.
