(*********************************************************************
 
   -:Program.  	 numwindow.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      ----
   -:shortcut. 	 [pit]
   -:Version.  	 0.9   
   -:Date.     	 11.04.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 PROCEDUREs, creating 7-Segment-Numbers of variable height
    :Remark.	 see DEFINITION MODULE for interface explanation
    
**********************************************************************)

IMPLEMENTATION MODULE DragNum;

FROM SYSTEM IMPORT	ADDRESS, ADR;

FROM Arts IMPORT	Assert;

FROM Intuition IMPORT	WindowPtr;

FROM Graphics IMPORT	RastPortPtr, RectFill, SetAPen, SetRast, InitTmpRas,
			AllocRaster, TmpRas, AreaInfo, AreaMove,
                        AreaDraw, InitArea, AreaEnd, AreaEllipse;


FROM GfxMacros IMPORT	SetOPen;

CONST	WIDTH=320;
	MAXHEIGHT=256;
 	DEPTH=5;
 	POINTS=60;	(*maximale Anzahl an Punkten, die eine Area begrenzen*) 
        		(*knnen					     *)
        ELEMENTSX=42.0; (* mssen REAL-Typ sein *)
        ELEMENTSY=22.0;
                                 

VAR	rp		:RastPortPtr;
 	trp		:ADDRESS;
 	AInfo		:AreaInfo;
 	tr		:TmpRas;
 	ABuffer		:ARRAY [0..POINTS*5] OF CARDINAL;
	
        (* Variable zur Ziffernberechnung *)
        
        SegPtX		:ARRAY [0..5] OF ARRAY [0..7] OF ARRAY [0..2] 
        (*		      SegmentEck......SegmentNr.........Potenz	*) 
        		OF INTEGER;
        SegPtY		:ARRAY [0..5] OF ARRAY [0..7] OF INTEGER; 
        (*		      SegmentEck......SegmentNr			*) 
	ZiffLageX,
        ZiffLageY,
        ZiffBr,
        ZiffH0,
        ZiffH1,
        ZiffZwRX,
        ZiffEinhX,
        ZiffEinhY,
        XVersatz	:INTEGER;
        Zahl		:INTEGER;
        ZifferAlt	:ARRAY [0..2] OF INTEGER;
        Neuerort	:BOOLEAN;
        Segment		:INTEGER;
        WBreite,
        WHoehe,
        WBreiteAlt,
        WHoeheAlt	:INTEGER;	
 	Wert,
        WertAlt,		
        i		:INTEGER;
        AlreadyInit	:BOOLEAN;
        error		:LONGINT;
        
        (* Prefs	*)
        
        APen,BPen,OPen	:INTEGER;
        PercentX,
        PercentY	:REAL;

PROCEDURE Prepare(wp:WindowPtr);
 BEGIN
 rp:=wp^.rPort;					      (* RastPort feststellen *)
 InitArea(AInfo, ADR(ABuffer), SIZE(ABuffer) DIV 5);
 trp:=AllocRaster(WIDTH, MAXHEIGHT);			(* maximale Flche fr
                                                           Area-Funktionen fest-
                                                           legen...	      *)
 Assert(trp<>NIL, ADR('cannot alloc raster'));
 InitTmpRas(tr, trp, ((WIDTH+15) DIV 16) * MAXHEIGHT);	(*..und initialisieren*)
 rp^.areaInfo:=ADR(AInfo);
 rp^.tmpRas:=ADR(tr);
 AlreadyInit:=TRUE;
 END Prepare;

PROCEDURE ZeichneSegment(Segment,Potenz:INTEGER);
 VAR	p,x,y	:INTEGER;
 BEGIN
  SetOPen(rp,OPen);
  SetAPen(rp,APen);
  error:=AreaMove(rp,SegPtX[0,Segment,Potenz],SegPtY[0,Segment]);   
  FOR p:=1 TO 5 DO
     x:=SegPtX[p,Segment,Potenz];
     y:=SegPtY[p,Segment];
     error:=AreaDraw(rp,x,y);
  END;
 END ZeichneSegment;   

PROCEDURE ZeichneZiffer(Ziffer,Potenz:INTEGER);
 BEGIN
  IF (NOT Neuerort) THEN		(* Alte Ziffer lschen *)
    SetOPen(rp,BPen);
    SetAPen(rp,BPen);
    RectFill(rp,SegPtX[2,4,Potenz],SegPtY[5,0],SegPtX[5,2,Potenz],SegPtY[1,6]);
  END;
  CASE Ziffer OF
  	0:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	1:ZeichneSegment(2,Potenz);
  	  ZeichneSegment(5,Potenz);|
        2:ZeichneSegment(0,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(6,Potenz);|
 	3:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	4:ZeichneSegment(1,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);|
  	5:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	6:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	7:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(5,Potenz);|
  	8:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	9:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
        ELSE			  ;
  END; (*CASE Segment*)
  error:=AreaEnd(rp);
 END ZeichneZiffer;      

PROCEDURE BerechneSenkSeg(Zx,Zy,Seg,Pot:INTEGER);
 BEGIN
  SegPtX[0,Seg,Pot]:=Zx;   
  SegPtX[1,Seg,Pot]:=SegPtX[0,Seg,Pot]-ZiffEinhX;   
  SegPtX[2,Seg,Pot]:=SegPtX[1,Seg,Pot]-XVersatz;   
  SegPtX[3,Seg,Pot]:=SegPtX[2,Seg,Pot]+ZiffEinhX;   
  SegPtX[4,Seg,Pot]:=SegPtX[3,Seg,Pot]+ZiffEinhX;   
  SegPtX[5,Seg,Pot]:=SegPtX[4,Seg,Pot]+XVersatz;
  SegPtY[0,Seg]:=Zy;
  SegPtY[1,Seg]:=SegPtY[0,Seg]+ZiffEinhY;
  SegPtY[3,Seg]:=SegPtY[0,Seg]+ZiffH1;
  SegPtY[2,Seg]:=SegPtY[3,Seg]-ZiffEinhY;
  SegPtY[4,Seg]:=SegPtY[2,Seg];
  SegPtY[5,Seg]:=SegPtY[1,Seg];
 END BerechneSenkSeg;  

PROCEDURE BerechneWaagSeg(Zx,Zy,Seg,Pot:INTEGER);
 BEGIN
  SegPtX[0,Seg,Pot]:=Zx;   
  SegPtX[1,Seg,Pot]:=SegPtX[0,Seg,Pot]+ZiffEinhX;   
  SegPtX[3,Seg,Pot]:=SegPtX[0,Seg,Pot]+ZiffBr;   
  SegPtX[2,Seg,Pot]:=SegPtX[3,Seg,Pot]-ZiffEinhX;   
  SegPtX[4,Seg,Pot]:=SegPtX[2,Seg,Pot];   
  SegPtX[5,Seg,Pot]:=SegPtX[1,Seg,Pot];
  SegPtY[0,Seg]:=Zy;
  SegPtY[1,Seg]:=SegPtY[0,Seg]+ZiffEinhY;
  SegPtY[2,Seg]:=SegPtY[1,Seg];
  SegPtY[3,Seg]:=SegPtY[0,Seg];
  SegPtY[4,Seg]:=SegPtY[0,Seg]-ZiffEinhY;
  SegPtY[5,Seg]:=SegPtY[4,Seg];
 END BerechneWaagSeg;  
 
PROCEDURE InitZiffGr;
 BEGIN
  ZiffEinhX:=TRUNC(FLOAT(WBreite)*PercentX/ELEMENTSX);
  ZiffEinhY:=TRUNC(FLOAT(WHoehe)*PercentY/ELEMENTSY);
  ZiffLageX:=ZiffEinhX*41;
  ZiffLageY:=ZiffEinhY;
  XVersatz:=ZiffEinhX;
  ZiffBr:=ZiffEinhX*10;
  ZiffH1:=ZiffEinhY*11;
  ZiffH0:=ZiffEinhY*21;;
  ZiffZwRX:=4*ZiffEinhX;
 END InitZiffGr;

PROCEDURE BerechneEckPunkte(WindowP:WindowPtr);
 VAR	PosX,PosY,Pot	:INTEGER;
 BEGIN
  Neuerort:=TRUE;
  InitZiffGr;
  FOR Pot:=0 TO 2 DO
     PosX:=ZiffLageX-Pot*(ZiffBr+ZiffZwRX)-ZiffBr;
     PosY:=ZiffLageY;
     BerechneWaagSeg(PosX,PosY,0,Pot);
     BerechneSenkSeg(PosX,PosY,1,Pot);
     BerechneSenkSeg(PosX+ZiffBr,PosY,2,Pot);
     PosY:=PosY+ZiffH1;
     PosX:=PosX-ZiffEinhX;
     BerechneWaagSeg(PosX,PosY,3,Pot);
     BerechneSenkSeg(PosX,PosY,4,Pot);
     BerechneSenkSeg(PosX+ZiffBr,PosY,5,Pot);
     PosY:=PosY+ZiffH1;
     PosX:=PosX-ZiffEinhX;
     BerechneWaagSeg(PosX,PosY,6,Pot);
  END; (*FOR Pot*);
 END BerechneEckPunkte;


PROCEDURE ExtractZiff(Wert:INTEGER);
 VAR	ErsteZiff,Ziffer,Ziffer0,Potenz,Potenz0		:INTEGER;
 BEGIN
  ErsteZiff:=0;
  IF Neuerort THEN 				(* ClearWindow *)
    SetRast(rp,BPen);
  END;
  FOR Potenz:=2 TO 0 BY -1 DO
    Potenz0:=1;
    IF Potenz>0 THEN
    	FOR i:=0 TO Potenz-1 DO			(* --> Potenz0=10^Potenz *)
    		Potenz0:=Potenz0*10;
    	END; (*FOR i*)
    END; (*IF*)    
    Ziffer0:=Wert DIV Potenz0;
    Ziffer:=Ziffer0;
    IF (NOT Neuerort) THEN
      IF Ziffer<>ZifferAlt[Potenz] THEN 
        IF Ziffer>0 THEN
          ErsteZiff:=1;
          ZeichneZiffer(Ziffer,Potenz);                      
        ELSIF (Ziffer=0) AND (ErsteZiff=0) THEN
          Ziffer:=10;
          IF ZifferAlt[Potenz]<10 THEN ZeichneZiffer(Ziffer,Potenz) END;
        ELSIF (Ziffer=0) AND (ErsteZiff=1) THEN
          ZeichneZiffer(Ziffer,Potenz);
        END; (*IF*)
      ELSIF (Ziffer=0) AND (ZifferAlt[Potenz]=0) AND (ErsteZiff=0) THEN    
        Ziffer:=10;
        ZeichneZiffer(Ziffer,Potenz);                                    
      ELSIF (Ziffer=0) AND (ZifferAlt[Potenz]=10) AND (ErsteZiff=1) THEN  
        ZeichneZiffer(Ziffer,Potenz);
      ELSIF ZifferAlt[Potenz]>0 THEN
        IF  ZifferAlt[Potenz]<10 THEN ErsteZiff:=1 END;
        Ziffer:=ZifferAlt[Potenz];
      END; (*IF*)
    ELSE 
      IF (Ziffer>0) THEN
        ErsteZiff:=1;
        ZeichneZiffer(Ziffer,Potenz);
      ELSIF (Ziffer=0) AND (ErsteZiff=0) THEN
        Ziffer:=10;
        IF ZifferAlt[Potenz]<10 THEN ZeichneZiffer(Ziffer,Potenz) END;
      ELSIF (Ziffer=0) AND (ErsteZiff=1) THEN
        ZeichneZiffer(Ziffer,Potenz);
      END; (*IF*)
    END; (*IF*)
    Wert:=Wert-Ziffer0*Potenz0;
    ZifferAlt[Potenz]:=Ziffer;
  END; (*FOR*)
  Neuerort:=FALSE;
 END ExtractZiff;   


PROCEDURE ShowNumber(wp:WindowPtr;W:INTEGER);
 BEGIN
  IF (W>-1000) AND (W<1000) AND (wp<>NIL) THEN (* unerlaubtes ignorieren*)
     Wert:=ABS(W);
     
     IF NOT AlreadyInit THEN Prepare(wp) END; (* Area schon initialisiert? *)
     
     WBreite:=wp^.width-4;		(* Breite und Hoehe aus dem..	*)
     WHoehe:=wp^.height-4;		(*        ..Window-Record lesen	*)
     
     IF WBreite<0 THEN WBreite:=0 END;	(* negative Werte fr Hoehe..	*)
     IF WHoehe<0 THEN WHoehe:=0 END;  	(*      ..und Breite verhindern	*)
     
     IF (WBreite>0) AND (WHoehe>0) THEN	(* wenn Window > Mindestgre..	*)
        
        IF (WBreite<>WBreiteAlt) OR (WHoehe<>WHoeheAlt) THEN
           BerechneEckPunkte(wp);	(*    ..Ziffern-Eckp. berechnen *)
        END; (*IF*)
        
        ExtractZiff(Wert);		(*        ..Ziffern extrahieren	*)
        
        WertAlt:=Wert;
  	WBreiteAlt:=WBreite;
  	WHoeheAlt:=WHoehe;
     ELSE
        Neuerort:=TRUE;
     END;
  END;
 END ShowNumber; 

PROCEDURE SetNumPrefs(AP,BP,OP:INTEGER;PX,PY:REAL);
 BEGIN
  IF (PX>=0.0) AND (PX<=1.0) THEN PercentX:=PX END;
  IF (PY>=0.0) AND (PY<=1.0) THEN PercentY:=PY END;
  APen:=AP;
  BPen:=BP;
  OPen:=OP;
  Neuerort:=TRUE;
 END SetNumPrefs;  

PROCEDURE InitNum;
 BEGIN
  PercentX:=1.0;
  PercentY:=1.0;
  APen:=3;
  BPen:=0;
  OPen:=2;
  WertAlt:=-10;
  Neuerort:=FALSE;
  WBreiteAlt:=-10;
  WHoeheAlt:=-10;
  AlreadyInit:=FALSE;
 END InitNum;


BEGIN
 InitNum;
END DragNum.
