(*********************************************************************
 
   -:Program.  	 numwindow.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      07031/273873
   -:shortcut. 	 [pit]
   -:Version.  	 0.9   
   -:Date.     	 11.04.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 PROCEDUREs, creating 7-Block-Numbers
    :Remark.	 See also DragNumber, it's more beautiful but slower
    
**********************************************************************)

IMPLEMENTATION MODULE numwindow;

FROM SYSTEM IMPORT	ADDRESS, ADR;

FROM Arts IMPORT	Assert;

FROM Intuition IMPORT	WindowPtr;

FROM Graphics IMPORT	RastPortPtr, RectFill, SetAPen, SetRast;


VAR	rp		:RastPortPtr;
	
        (* Variable zur Ziffernberechnung *)
        
        NumPX		:ARRAY [0..2] OF ARRAY [0..3] OF INTEGER;
	NumPY		:ARRAY [0..5] OF INTEGER;
	ZiffLageX,
        ZiffLageY,
        ZiffBr,
        ZiffH0,
        ZiffH1,
        StrichStX	:INTEGER;
        StrichStY	:INTEGER;
        Zahl		:INTEGER;
        ZifferAlt	:ARRAY [0..2] OF INTEGER;
        Neuerort	:BOOLEAN;
        Segment		:INTEGER;
        WBreite,
        WHoehe,
        WBreiteAlt,
        WHoeheAlt	:INTEGER;	
 	Wert,
        WertAlt,		
        i		:INTEGER;




PROCEDURE ZeichneSegment(Segment,Potenz:INTEGER);
 BEGIN
  IF Potenz<3 THEN
    SetAPen(rp,3);
    CASE Segment OF
  	0:RectFill(rp,NumPX[Potenz,3],NumPY[0],NumPX[Potenz,0],NumPY[1]);| 
 	1:RectFill(rp,NumPX[Potenz,3],NumPY[0],NumPX[Potenz,2],NumPY[3]);| 
  	2:RectFill(rp,NumPX[Potenz,1],NumPY[0],NumPX[Potenz,0],NumPY[3]);| 
  	3:RectFill(rp,NumPX[Potenz,3],NumPY[2],NumPX[Potenz,0],NumPY[3]);| 
  	4:RectFill(rp,NumPX[Potenz,3],NumPY[2],NumPX[Potenz,2],NumPY[5]);| 
  	5:RectFill(rp,NumPX[Potenz,1],NumPY[2],NumPX[Potenz,0],NumPY[5]);| 
  	6:RectFill(rp,NumPX[Potenz,3],NumPY[4],NumPX[Potenz,0],NumPY[5]);|
        ELSE;
    END; (*CASE*)
  END; (*IF*) 
END ZeichneSegment;  


PROCEDURE ZeichneZiffer(Ziffer,Potenz:INTEGER);
 BEGIN
  IF (NOT Neuerort) THEN		(* Alte Ziffer lschen *)
     SetAPen(rp,0);
     RectFill(rp, NumPX[Potenz,3], NumPY[0], NumPX[Potenz,0], NumPY[5]);
  END;
  CASE Ziffer OF
  	0:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	1:ZeichneSegment(2,Potenz);
  	  ZeichneSegment(5,Potenz);|
        2:ZeichneSegment(0,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(6,Potenz);|
 	3:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	4:ZeichneSegment(1,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);|
  	5:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	6:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	7:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(5,Potenz);|
  	8:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	9:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
        ELSE			  ;
  END; (*CASE Segment*)
 END ZeichneZiffer;      

PROCEDURE InitZiffGr;
 BEGIN
  ZiffLageX:=WBreite;
  ZiffLageY:=0;
  ZiffBr:=WBreite*4 DIV 14;
  ZiffH0:=WHoehe;
  ZiffH1:=WHoehe*3 DIV 8;
  StrichStX:=WBreite DIV 16;
  StrichStY:=WHoehe DIV 8;
 END InitZiffGr;


PROCEDURE BerechneEckPunkte(WindowP:WindowPtr);
 VAR	PosX,PosY,Pot	:INTEGER;
 BEGIN
  IF (WBreite<>WBreiteAlt) OR (WHoehe<>WHoeheAlt) THEN
	Neuerort:=TRUE;
  	InitZiffGr;
  	NumPX[0,0]:=ZiffLageX;
  	NumPX[0,1]:=NumPX[0,0]-StrichStX;
  	NumPX[0,3]:=NumPX[0,0]-ZiffBr;
  	NumPX[0,2]:=NumPX[0,3]+StrichStX;
  	FOR Pot:=1 TO 2 DO
  	  FOR PosX:=0 TO 3 DO	
  		NumPX[Pot,PosX]:=NumPX[0,PosX]-(ZiffBr+StrichStX)*Pot;
  	  END; 
  	END;
  	NumPY[0]:=ZiffLageY;
  	NumPY[1]:=NumPY[0]+StrichStY;
  	NumPY[2]:=ZiffH1;
  	NumPY[3]:=NumPY[2]+StrichStY;
  	NumPY[5]:=ZiffH0;
  	NumPY[4]:=NumPY[5]-StrichStY;
  	WBreiteAlt:=WBreite;
  	WHoeheAlt:=WHoehe;
  END; (*IF*)
 END BerechneEckPunkte;


PROCEDURE ExtractZiff(Wert:INTEGER);
 VAR	ErsteZiff,Ziffer,Ziffer0,Potenz,Potenz0		:INTEGER;
 BEGIN
  ErsteZiff:=0;
  IF Neuerort THEN 				(* ClearWindow *)
  	SetRast(rp,0);
  END;
  FOR Potenz:=2 TO 0 BY -1 DO
    Potenz0:=1;
    IF Potenz>0 THEN
    	FOR i:=0 TO Potenz-1 DO			(* --> Potenz0=10^Potenz *)
    		Potenz0:=Potenz0*10;
    	END; (*FOR i*)
    END; (*IF*)    
    Ziffer0:=Wert DIV Potenz0;
    Ziffer:=Ziffer0;
    IF (NOT Neuerort) THEN
      IF Ziffer<>ZifferAlt[Potenz] THEN 
        IF Ziffer>0 THEN
          ErsteZiff:=1;
          ZeichneZiffer(Ziffer,Potenz);                      
        ELSIF (Ziffer=0) AND (ErsteZiff=0) THEN
          Ziffer:=10;
          IF ZifferAlt[Potenz]<10 THEN ZeichneZiffer(Ziffer,Potenz) END;
        ELSIF (Ziffer=0) AND (ErsteZiff=1) THEN
          ZeichneZiffer(Ziffer,Potenz);
        END; (*IF*)
      ELSIF (Ziffer=0) AND (ZifferAlt[Potenz]=0) AND (ErsteZiff=0) THEN    
        Ziffer:=10;
        ZeichneZiffer(Ziffer,Potenz);                                    
      ELSIF (Ziffer=0) AND (ZifferAlt[Potenz]=10) AND (ErsteZiff=1) THEN  
        ZeichneZiffer(Ziffer,Potenz);
      ELSIF ZifferAlt[Potenz]>0 THEN
        IF  ZifferAlt[Potenz]<10 THEN ErsteZiff:=1 END;
        Ziffer:=ZifferAlt[Potenz];
      END; (*IF*)
    ELSE 
      IF (Ziffer>0) THEN
        ErsteZiff:=1;
        ZeichneZiffer(Ziffer,Potenz);
      ELSIF (Ziffer=0) AND (ErsteZiff=0) THEN
        Ziffer:=10;
        IF ZifferAlt[Potenz]<10 THEN ZeichneZiffer(Ziffer,Potenz) END;
      ELSIF (Ziffer=0) AND (ErsteZiff=1) THEN
        ZeichneZiffer(Ziffer,Potenz);
      END; (*IF*)
    END; (*IF*)
    Wert:=Wert-Ziffer0*Potenz0;
    ZifferAlt[Potenz]:=Ziffer;
  END; (*FOR*)
  Neuerort:=FALSE;
 END ExtractZiff;   


PROCEDURE ShowNumber(wp:WindowPtr;W:INTEGER);
 BEGIN
  IF (W>-1000) AND (W<1000) THEN	(* unerlaubte Werte ignorieren	*)
     Wert:=ABS(W);
     rp:=wp^.rPort;			(* RastPort feststellen		*)
     
     WBreite:=wp^.width-25;		(* Breite und Hoehe aus dem..	*)
     WHoehe:=wp^.height-20;		(*        ..Window-Record lesen	*)
     
     IF WBreite<0 THEN WBreite:=0 END;	(* negative Werte fr Hoehe..	*)
     IF WHoehe<0 THEN WHoehe:=0 END;  	(*      ..und Breite verhindern	*)
     
     IF (WBreite>0) AND (WHoehe>0) THEN	(* wenn Window > Mindestgre..	*)
        BerechneEckPunkte(wp);		(*    ..Ziffern-Eckp. berechnen *)
        ExtractZiff(Wert);		(*        ..Ziffern extrahieren	*)
        WertAlt:=Wert;
     ELSE
        Neuerort:=TRUE;
     END;
  END;
 END ShowNumber; 


PROCEDURE InitNum;
 BEGIN
  WertAlt:=-10;
  Neuerort:=FALSE;
  WBreiteAlt:=-10;
  WHoeheAlt:=-10;
 END InitNum;


BEGIN
 InitNum;
END numwindow.
