(*********************************************************************
 
   -:Program.  	 nwdemo.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      ----
   -:shortcut. 	 [pit]
   -:Version.  	 1.0   
   -:Date.     	 13.04.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 Demonstration of NumWindow and Super-BitMap-Window 
    :Remark.	 Drag the Window's size to realize what happens	 
    
**********************************************************************
Dieses Programm demonstriert die Arbeitsweise des 
Implementation Moduls NumWindow.mod.
ShowNumber(Window-Pointer,Zahlenwert) zeigt den bergebenen Zahlenwert 
in dem Window an, auf das der bergebene Window-Pointer zeigt.
Hier wird ein superBitMap-Window verwendet, das ist zwar nicht unbedingt 
ntig kann aber nie schaden (auer man hat zu wenig Speicher..).
Es ist wichtig, da die Konstanten MINWIDTH und MINHEIGHT ebenfalls
importiert und an den NewWindow-Record bergeben werden, kleinere
Werte knnen bei brutaler Handhabung des Windows nach Indien fhren.
**********************************************************************)
MODULE nwdemo;

FROM SYSTEM IMPORT 	ADDRESS,ADR;

FROM Arts IMPORT	Assert,TermProcedure;

FROM RandomNumber 
		IMPORT 	RND;

FROM Intuition IMPORT	NewWindow, WindowPtr, OpenWindow, ScreenPtr, 
			CloseWindow, IDCMPFlags, IDCMPFlagSet, WindowFlags, 
                        WindowFlagSet, RemakeDisplay, Window, otherRefresh,
                        ScreenFlagSet, ScreenFlags, IntuiMessagePtr;

FROM Exec IMPORT	GetMsg, ReplyMsg; 

FROM numwindow IMPORT 	ShowNumber, MINWIDTH, MINHEIGHT;

FROM Graphics IMPORT	RastPortPtr, BitMap, AllocRaster, FreeRaster, 
			InitBitMap, BltClear;

CONST	MAXWIDTH=640;
	MAXHEIGHT=352;
        DEPTH=2;

	(* Variable fr window *)

VAR	rp		:RastPortPtr;
	nWindow		:NewWindow;
	WindowP		:WindowPtr;
        i,j,Dauer	:LONGINT;
        error		:LONGINT;
        errorP1,
        errorP2		:ADDRESS;
 	Zahl,
        Schritt,
        Ende		:INTEGER;
	Farbe		:CARDINAL;
        ScreenP		:ScreenPtr;
        WindowBM	:BitMap;
        MsgPtr		:IntuiMessagePtr;
        class		:IDCMPFlagSet;

PROCEDURE Cleanup;
 BEGIN
  IF WindowP<>NIL THEN CloseWindow(WindowP) END;
  FOR i:=0 TO DEPTH-1 DO
     IF WindowBM.planes[i]<>NIL THEN 
        FreeRaster(WindowBM.planes[i],MAXWIDTH,MAXHEIGHT); 
     END;
  END;
 END Cleanup;

PROCEDURE MakeBitMap;  (* BitMap initialisieren, Raster reservieren *)
 BEGIN
  InitBitMap(WindowBM,DEPTH,MAXWIDTH,MAXHEIGHT);

  errorP1:=AllocRaster(MAXWIDTH,MAXHEIGHT);
  Assert(errorP1<>NIL,ADR("konnte Raster [0] nicht allozieren"));
  BltClear(errorP1,MAXWIDTH DIV 8*MAXHEIGHT,1);
  
  errorP2:=AllocRaster(MAXWIDTH,MAXHEIGHT);
  IF errorP2=NIL THEN
     FreeRaster(errorP1,MAXWIDTH,MAXHEIGHT);
     Assert(errorP2<>NIL,ADR("konnte Raster [1] nicht allozieren"));
  END;
  BltClear(errorP1,MAXWIDTH DIV 8*MAXHEIGHT,1);
  
  WindowBM.planes[0]:=errorP1;
  WindowBM.planes[1]:=errorP2;	
 END MakeBitMap;

PROCEDURE MakeWindow(WTitel:ADDRESS;Lagex,Lagey,Breite,Hoehe:INTEGER);
 BEGIN
  TermProcedure(Cleanup);
  MakeBitMap;
  WITH nWindow DO
  	leftEdge:=Lagex;	topEdge:=Lagey; 
  	width:=Breite; 		height:=Hoehe;
  	detailPen:=0; 
  	blockPen:=1;
  	idcmpFlags:=IDCMPFlagSet{closeWindow};  
  	flags:=WindowFlagSet{ windowSizing, windowDrag, windowDepth,
        			gimmeZeroZero, activate, noCareRefresh,
                                windowClose, superBitMap };
                                
        (* Achtung Fehler im M2-Buch: "superBitmap" ist falsch,..	*)
        (*		..."superBitMap" ist richtig geschrieben	*)
                                
  	title:=WTitel;
  	type:=ScreenFlagSet{wbenchScreen};
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=NIL; 
  	bitMap:=ADR(WindowBM);
  	minWidth:=MINWIDTH;     	
  	minHeight:=MINHEIGHT; 		
  	maxWidth:=MAXWIDTH; 		
  	maxHeight:=MAXHEIGHT;		
  END; (*WITH*)
  WindowP:=OpenWindow(nWindow);
  Assert(WindowP<>NIL,ADR("konnte Fenster nicht ffnen"));	
  rp:=WindowP^.rPort;
 END MakeWindow;

PROCEDURE DoDemo;
 BEGIN
  LOOP
    Zahl:=RND(900);	
    Ende:=Zahl-50+RND(100);	
    Dauer:=RND(5000);	
    IF Zahl>Ende THEN
       Schritt:=-1;
    ELSIF Zahl<Ende THEN
       Schritt:=1;
    ELSE
       Schritt:=0;
    END;	
    REPEAT
       ShowNumber(WindowP,Zahl);
       Zahl:=Zahl+Schritt;
       FOR i:=0 TO Dauer DO   		
          MsgPtr:=GetMsg(WindowP^.userPort);
     	  class:=MsgPtr^.class;
          IF class=IDCMPFlagSet{closeWindow} THEN EXIT END;
   	  IF MsgPtr<>NIL THEN ReplyMsg(MsgPtr) END;                
       END;
    UNTIL (Zahl=Ende);
  END; (*LOOP*) 
 END DoDemo;

BEGIN
 MakeWindow(ADR("Change Size!"),0,10,MINWIDTH,MINHEIGHT);
 DoDemo;
END nwdemo.
