(*********************************************************************
 
   -:Program.  	 nwdemo.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      ----
   -:shortcut. 	 [pit]
   -:Version.  	 1.0   
   -:Date.     	 13.04.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 Demonstration of DragNumber and Super-BitMap-Window	 
    :Remark.	 Have Fun!	 
    
**********************************************************************
Dieses Programm demonstriert die Arbeitsweise des 
Implementation Moduls DragNumber.mod.
ShowNumber(Window-Pointer,Zahlenwert) zeigt den bergebenen Zahlenwert 
in dem Window an, auf das der bergebene Window-Pointer zeigt.
Hier wird ein superBitMap-Window verwendet, das ist zwar nicht unbedingt 
ntig kann aber nie schaden (auer man hat zu wenig Speicher..).
Es ist wichtig, da die Konstanten MINWIDTH und MINHEIGHT ebenfalls
importiert und an den NewWindow-Record bergeben werden, kleinere
Werte knnen bei brutaler Handhabung des Windows nach Indien fhren.
**********************************************************************)
MODULE nwscreen;

FROM SYSTEM IMPORT 	ADDRESS,ADR;

FROM Arts IMPORT	Assert,TermProcedure;

FROM RandomNumber 
		IMPORT 	RND;

FROM Intuition IMPORT	NewWindow, WindowPtr, OpenWindow, ScreenPtr, 
			CloseWindow, IDCMPFlags, IDCMPFlagSet, WindowFlags, 
                        WindowFlagSet, RemakeDisplay, Window, otherRefresh,
                        ScreenFlagSet, ScreenFlags, IntuiMessagePtr, 
                        OpenScreen, NewScreen, customScreen, CloseScreen,
                        MoveWindow, SizeWindow;

FROM Exec IMPORT	GetMsg, ReplyMsg; 

FROM DragNum IMPORT 	ShowNumber, SetNumPrefs, MINWIDTH, MINHEIGHT;

FROM Graphics IMPORT	RastPortPtr, BitMap, AllocRaster, FreeRaster, 
			InitBitMap, BltClear, ViewPortPtr, ViewModeSet, 
                        ViewModes, TextAttr, FontStyleSet, FontFlagSet,
                        SetRGB4;

CONST	MAXWIDTH=640;
	MAXHEIGHT=200;
        DEPTH=4;
        	
	(* Variable fr screen *)

VAR	vp		:ViewPortPtr;
        nScreen		:NewScreen;   	 
        ScreenP		:ScreenPtr;
        TAttr		:TextAttr;

	(* Variable fr window *)

	rp		:RastPortPtr;
	nWindow		:NewWindow;
	WindowP		:WindowPtr;
        i,j,Dauer,
        plane		:LONGINT;
        error		:LONGINT;
        errorP		:ARRAY [0..DEPTH-1] OF ADDRESS;
 	Zahl,
        Schritt,
        Ende		:INTEGER;
	Farbe		:CARDINAL;
        WindowBM	:BitMap;
        MsgPtr		:IntuiMessagePtr;
        class		:IDCMPFlagSet;

PROCEDURE Cleanup;
 BEGIN
  IF WindowP<>NIL THEN CloseWindow(WindowP) END;
  IF ScreenP<>NIL THEN CloseScreen(ScreenP) END;
  FOR i:=0 TO DEPTH-1 DO
     IF WindowBM.planes[i]<>NIL THEN 
        FreeRaster(WindowBM.planes[i],MAXWIDTH,MAXHEIGHT); 
     END;
  END;
 END Cleanup;

PROCEDURE MakeBitMap;  (* BitMap initialisieren, Raster reservieren *)
 BEGIN
  InitBitMap(WindowBM,DEPTH,MAXWIDTH,MAXHEIGHT);
  FOR plane:=0 TO DEPTH-1 DO
     errorP[plane]:=AllocRaster(MAXWIDTH,MAXHEIGHT);
     BltClear(errorP[plane],MAXWIDTH DIV 8*MAXHEIGHT,1);
     IF errorP[plane]=NIL THEN
       FOR i:=1 TO plane-1 DO
     	  FreeRaster(errorP[i],MAXWIDTH,MAXHEIGHT);
  	  Assert(errorP[plane]<>NIL,ADR("konnte Raster nicht allozieren"));
       END;
     END;
     WindowBM.planes[plane]:=errorP[plane];
  END; (*FOR plane*)
 END MakeBitMap;

PROCEDURE MakeScreen;
  BEGIN
   WITH TAttr DO
   	name:=ADR("topaz.font");
        ySize:=8;
        style:=FontStyleSet{};
        flags:=FontFlagSet{};
   END; (*WITH*)
   WITH nScreen DO
  	leftEdge:=0;	topEdge:=0;
        width:=640;	height:=200; 	(*stdScreenHeight;*)
        depth:=DEPTH;
        detailPen:=0;	blockPen:=1;
        viewModes:=ViewModeSet{hires};
        type:=customScreen;		(*ScreenFlagSet{customBitMap};*)
        font:=ADR(TAttr);
        defaultTitle:=NIL;
        gadgets:=NIL;
        customBitMap:=NIL;
   END; (*WITH*)
   ScreenP:=OpenScreen(nScreen);
   Assert(ScreenP<>NIL,ADR("konnte den Screen nicht ffnen"));
   vp:=ADR(ScreenP^.viewPort);
   SetRGB4(vp,0,0,0,0);
   SetRGB4(vp,1,0,0,10);
   SetRGB4(vp,2,0,0,8);
   SetRGB4(vp,3,0,0,15);
  END MakeScreen;

PROCEDURE MakeWindow(WTitel:ADDRESS;Lagex,Lagey,Breite,Hoehe:INTEGER);
 BEGIN
  TermProcedure(Cleanup);
  MakeBitMap;
  WITH nWindow DO
  	leftEdge:=Lagex;	topEdge:=Lagey; 
  	width:=Breite; 		height:=Hoehe;
  	detailPen:=0; 
  	blockPen:=1;
  	idcmpFlags:=IDCMPFlagSet{closeWindow};  
  	flags:=WindowFlagSet{ (*windowSizing, windowDrag, windowDepth,*)
        			gimmeZeroZero, activate, noCareRefresh,
                               (* windowClose,*) superBitMap };
                                
        (* Achtung Fehler im M2-Buch: "superBitmap" ist falsch,..	*)
        (*		..."superBitMap" ist richtig geschrieben	*)
                                
  	title:=WTitel;
  	type:=customScreen;
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=ScreenP; 
  	bitMap:=ADR(WindowBM);
  	minWidth:=MINWIDTH;     	
  	minHeight:=MINHEIGHT; 		
  	maxWidth:=MAXWIDTH; 		
  	maxHeight:=MAXHEIGHT;		
  END; (*WITH*)
  WindowP:=OpenWindow(nWindow);
  Assert(WindowP<>NIL,ADR("konnte Fenster nicht ffnen"));	
  rp:=WindowP^.rPort;
 END MakeWindow;

PROCEDURE DoDemo;
 VAR	ScreenDown:BOOLEAN;
 BEGIN
  ScreenDown:=FALSE;
  LOOP
    Zahl:=ScreenP^.mouseX;	
    IF ScreenP^.mouseY>190 THEN 
       EXIT; 
    ELSIF (ScreenP^.mouseY<20) AND (ScreenDown=TRUE) THEN
       SizeWindow(WindowP,-150,-50);
       SetNumPrefs(3,0,2,1.0,1.0);
       ScreenDown:=FALSE;
    ELSIF (ScreenP^.mouseY>100) AND (ScreenDown=FALSE) THEN
       SizeWindow(WindowP,150,50);
       SetNumPrefs(0,2,3,1.0,1.0);
       ScreenDown:=TRUE;
    END;
    ShowNumber(WindowP,Zahl);    
  END; (*LOOP*)
 END DoDemo;

BEGIN
 MakeScreen;
 MakeWindow(NIL,0,10,340,102);
 DoDemo;
END nwscreen.
