(*-------------------------------------------------------------------------*)
(*                                                                         *)
(*       This File includes the Fish' Imagery and all needed Bob,          *)
(*                BSprite and AnimComp- Structures !!!                     *)
(*                                                                         *)
(*  Ported to MODULA-2 by Fridtjof Siebert.                                *)
(*        Thanks to Matt Dillon for his wonderful Editor DME, without      *)
(*           this wouldn't have been possible !!!                          *)
(*                                                                         *)
(*-------------------------------------------------------------------------*)

IMPLEMENTATION MODULE FishData;

FROM SYSTEM IMPORT INLINE,ADR,ADDRESS,SHIFT,BITSET;
FROM Arts IMPORT TermProcedure;
FROM Graphics IMPORT VSprite,BobPtr,VSpriteFlagSet,VSpriteFlags,
       AnimComp,AnimCompPtr,AnimObPtr,BobFlags,BobFlagSet,Bob,VSpritePtr;
FROM Exec IMPORT AllocMem, MemReqs, MemReqSet, FreeMem;

FROM FishInit IMPORT fish1Routine, fishOb;

(*
TYPE
  FishData = ARRAY[0..377] OF CARDINAL;

VAR
  color: ARRAY[0..7] OF INTEGER;
  image1,image2,image3,image4,image5,image6,image7,image8,image9,
  FishDataPtr: POINTER TO FishData;
  fish1Comp ,fish2Comp ,fish3Comp ,fish4Comp ,fish5Comp ,fish6Comp,
  fish7Comp ,fish8Comp ,fish9Comp ,fish10Comp,fish11Comp,fish12Comp,
  fish13Comp,fish14Comp,fish15Comp,fish16Comp,fish17Comp: AnimComp;
  fish1Bob, fish2Bob, fish3Bob, fish4Bob, fish5Bob,fish6Bob,fish7Bob,
  fish8Bob,fish9Bob,fish10Bob,fish11Bob,fish12Bob,fish13Bob,fish14Bob,
  fish15Bob,fish16Bob,fish17Bob: Bob;
  fish1Sprite, fish2Sprite, fish3Sprite, fish4Sprite, fish5Sprite,
  fish6Sprite,fish7Sprite,fish8Sprite,fish9Sprite, fish10Sprite,
  fish11Sprite,fish12Sprite,fish13Sprite,fish14Sprite,fish15Sprite,
  fish16Sprite,fish17Sprite: VSprite;
*)

PROCEDURE Image1Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   00H,   00H,   00H,   0F80H, 00H,   00H,
0FC0H, 00H,   00H,   0860H, 00H,   00H,   0EC0H, 00H,   00H,   018H,
00H,   00H,   021H,  00H,   00H,   021H,  08000H,00H,   031H,  08000H,
00H,   07H,   00H,   0F800H,00H,   00H,   0FC03H,00H,   00H,   0FE03H,
0C000H,07800H,0FF03H,0E001H,0C400H,0FF83H,0F800H,06000H,0FFE3H,0FE00H,
03800H,0FFE3H,0FF80H,00H,   0FFF3H,0FFE0H,00H,   0FFF8H,00H,   00H,
0FFFCH,00H,   00H,   0FFFEH,00H,   00H,   0FF81H,00H,   00H,   0FF81H,
08060H,00H,   0FF81H,0C1E0H,00H,   0FFFFH,0E0E0H,00H,   0FFFFH,0F060H,
00H,   0FFFFH,0F800H,04H,   0FFFFH,0F000H,00H,   0FFFFH,0C000H,00H,
0FFFFH,0FF0H, 00H,   0FFFCH,0FC0H, 00H,   0FFF0H,0F00H, 00H,   0FFC0H,
0C00H, 00H,   0FF00H,0800H, 00H,   0FC00H,00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,
00H,   00H,   00H,   0F80H, 00H,   00H,   0FC0H, 00H,   00H,   0860H,
00H,   00H,   0EC0H, 00H,   00H,   018H,  00H,   00H,   021H,  00H,
00H,   021H,  08000H,00H,   031H,  08000H,00H,   07H,   00H,   00H,
00H,   00H,   03H,   00H,   00H,   03H,   0C000H,07800H,03H,   0E001H,
0C400H,03H,   0F800H,06000H,023H,  0FE00H,03800H,03H,   0FF80H,00H,
03H,   0FFE0H,00H,   03H,   0FFF8H,00H,   03H,   0FFFEH,00H,   01H,
0FFFFH,08000H,00H,   0FFFFH,0E000H,00H,   07F9FH,0F800H,00H,   03E1FH,
0F000H,00H,   01F1FH,0E000H,00H,   0F9FH, 0E000H,00H,   07FFH, 0F004H,
00H,   0FFFH, 0F800H,00H,   03FFFH,0FE00H,00H,   0F00FH,0F800H,01H,
0F03FH,0C000H,01H,   0F0FFH,00H,   01H,   0F3FCH,00H,   01H,   0F7E0H,
00H,   01H,   0FF00H,00H,   01H,   0F800H,00H,   01H,   0E000H,00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   0F80H,
00H,   00H,   0FC0H, 00H,   00H,   0860H, 00H,   00H,   0EC0H, 00H,
00H,   018H,  00H,   00H,   021H,  00H,   00H,   021H,  08000H,00H,
031H,  08000H,00H,   07H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   07800H,00H,   01H,   0C400H,00H,   00H,   06000H,
020H,  00H,   03800H,00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   0300H, 00H,   07EH,  07C0H,
00H,   07EH,  07E0H, 00H,   07EH,  03E0H, 0F00H, 00H,   0E0H,  01C00H,
00H,   060H,  01C00H,00H,   00H,   0E04H, 00H,   00H,   0700H, 00H,
00H,   00H,   00H,   0FF0H, 00H,   00H,   0FC0H, 04H,   00H,   0F00H,
00H,   00H,   0C00H, 00H,   00H,   0800H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image1Data;

PROCEDURE Image2Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   00H,   00H,   00H,   03E0H, 00H,   00H,
03F0H, 00H,   00H,   0218H, 00H,   00H,   03B0H, 00H,   00H,   06H,
00H,   00H,   08H,   04000H,00H,   08H,   06000H,00H,   0CH,   06000H,
00H,   01H,   0C000H,00H,   00H,   00H,   0700H, 06000H,00H,   0780H,
07000H,01E00H,07C0H, 07800H,07100H,07E0H, 07E00H,01800H,07F8H, 07F80H,
0E00H, 07F8H, 07FE0H,00H,   07FCH, 07FF8H,00H,   07FEH, 00H,   00H,
07FFH, 00H,   00H,   07FFH, 08000H,00H,   07E0H, 04000H,00H,   07E0H,
06018H,00H,   07E0H, 07078H,00H,   07FFH, 0F838H,00H,   07FFH, 0FC18H,
00H,   07FFH, 0FE00H,04H,   07FFH, 0FC00H,00H,   07FFH, 0F000H,00H,
07FFH, 0C3FCH,00H,   07FFH, 03F0H, 00H,   07FCH, 03C0H, 00H,   07F0H,
0300H, 00H,   07C0H, 0200H, 00H,   0700H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,
00H,   00H,   00H,   03E0H, 00H,   00H,   03F0H, 00H,   00H,   0218H,
00H,   00H,   03B0H, 00H,   00H,   06H,   00H,   00H,   08H,   04000H,
00H,   08H,   06000H,00H,   0CH,   06000H,00H,   01H,   0C000H,00H,
00H,   00H,   00H,   06000H,00H,   00H,   07000H,01E00H,00H,   07800H,
07100H,00H,   07E00H,01800H,08H,   07F80H,0E00H, 00H,   07FE0H,00H,
00H,   07FF8H,00H,   00H,   07FFCH,00H,   00H,   07FFFH,00H,   00H,
07FFFH,0C000H,00H,   03FFFH,0F000H,00H,   01FE7H,0FC00H,00H,   0F87H,
0F000H,00H,   07C7H, 0E000H,00H,   03E7H, 0E000H,00H,   01FFH, 0E004H,
00H,   03FFH, 0F800H,00H,   0FFFH, 0FC00H,00H,   01C03H,0F800H,00H,
01C0FH,0C000H,00H,   01C3FH,00H,   00H,   01CF8H,00H,   00H,   01DF0H,
00H,   00H,   01FC0H,00H,   00H,   01E00H,00H,   00H,   01800H,00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   03E0H,
00H,   00H,   03F0H, 00H,   00H,   0218H, 00H,   00H,   03B0H, 00H,
00H,   06H,   00H,   00H,   08H,   04000H,00H,   08H,   06000H,00H,
0CH,   06000H,00H,   01H,   0C000H,00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   01E00H,00H,   00H,   07100H,00H,   00H,   01800H,
08H,   00H,   0E00H, 00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   0C0H,  00H,   01FH,  081F0H,
00H,   01FH,  081F8H,00H,   01FH,  080F8H,0F00H, 00H,   038H,  01C00H,
00H,   018H,  01C00H,00H,   00H,   01C04H,00H,   00H,   0600H, 00H,
00H,   0300H, 00H,   03FCH, 00H,   00H,   03F0H, 04H,   00H,   03C0H,
00H,   00H,   0300H, 00H,   00H,   0200H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image2Data;

PROCEDURE Image3Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   00H,   00H,   00H,   03E0H, 00H,   00H,
03F0H, 00H,   00H,   0218H, 00H,   00H,   03B0H, 00H,   00H,   06H,
00H,   00H,   08H,   04000H,00H,   08H,   06000H,00H,   0CH,   06000H,
00H,   01H,   0C000H,00H,   00H,   00H,   0100H, 02000H,00H,   0180H,
03000H,01E00H,01C0H, 03800H,07100H,01E0H, 03E00H,01800H,01F8H, 03F80H,
0E00H, 01F8H, 03FE0H,00H,   01FCH, 03FF8H,00H,   01FEH, 00H,   00H,
01FFH, 00H,   00H,   01FFH, 08000H,00H,   01E0H, 04000H,00H,   01E0H,
06018H,00H,   01E0H, 07078H,00H,   01FFH, 0F838H,00H,   01FFH, 0FC18H,
00H,   01FFH, 0FE00H,04H,   01FFH, 0FC00H,00H,   01FFH, 0F000H,00H,
01FFH, 0C3FCH,00H,   01FFH, 03F0H, 00H,   01FCH, 03C0H, 00H,   01F0H,
0300H, 00H,   01C0H, 0200H, 00H,   0100H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,
00H,   00H,   00H,   03E0H, 00H,   00H,   03F0H, 00H,   00H,   0218H,
00H,   00H,   03B0H, 00H,   00H,   06H,   00H,   00H,   08H,   04000H,
00H,   08H,   06000H,00H,   0CH,   06000H,00H,   01H,   0C000H,00H,
00H,   00H,   00H,   02000H,00H,   00H,   03000H,01E00H,00H,   03800H,
07100H,00H,   03E00H,01800H,08H,   03F80H,0E00H, 00H,   03FE0H,00H,
00H,   03FF8H,00H,   00H,   03FFCH,00H,   00H,   03FFFH,00H,   00H,
03FFFH,0C000H,00H,   03FFFH,0F000H,00H,   01FE7H,0FC00H,00H,   0F87H,
0F000H,00H,   07C7H, 0F000H,00H,   03E7H, 0F000H,00H,   01FFH, 0F004H,
00H,   03FFH, 0F800H,00H,   0FFFH, 0FC00H,00H,   0C03H, 0F800H,00H,
0C0FH, 0C000H,00H,   0C3FH, 00H,   00H,   0CF8H, 00H,   00H,   0DF0H,
00H,   00H,   0FC0H, 00H,   00H,   0E00H, 00H,   00H,   0800H, 00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   03E0H,
00H,   00H,   03F0H, 00H,   00H,   0218H, 00H,   00H,   03B0H, 00H,
00H,   06H,   00H,   00H,   08H,   04000H,00H,   08H,   06000H,00H,
0CH,   06000H,00H,   01H,   0C000H,00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   01E00H,00H,   00H,   07100H,00H,   00H,   01800H,
08H,   00H,   0E00H, 00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   0C0H,  00H,   01FH,  081F0H,
00H,   01FH,  081F8H,00H,   01FH,  080F8H,0F00H, 00H,   038H,  0C00H,
00H,   018H,  0C00H, 00H,   00H,   0C04H, 00H,   00H,   0600H, 00H,
00H,   0300H, 00H,   03FCH, 00H,   00H,   03F0H, 04H,   00H,   03C0H,
00H,   00H,   0300H, 00H,   00H,   0200H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image3Data;

PROCEDURE Image4Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   02000H,00H,   00H,   07800H,00H,   00H,
0800H, 00H,   00H,   09000H,00H,   00H,   07800H,00H,   00H,   030H,
00H,   00H,   07CH,  00H,   00H,   044H,  00H,   00H,   07CH,  00H,
00H,   08H,   00H,   00H,   00H,   00H,   00H,   0FH,   00H,   00H,
08010H,08000H,00H,   0C01BH,08000H,080H,  0E01EH,00H,   0C0H,  0F000H,
00H,   0E0H,  0F800H,00H,   0F0H,  00H,   00H,   0F8H,  00H,   00H,
0FCH,  00H,   00H,   0FEH,  00H,   00H,   0C7H,  00H,   00H,   0C7H,
080C0H,00H,   0C7H,  0C3C0H,00H,   0FFH,  0E0C0H,00H,   0FFH,  0F040H,
00H,   0FFH,  0F800H,04H,   0FFH,  0E000H,00H,   0FFH,  08000H,00H,
0FCH,  01F00H,00H,   0F0H,  01C00H,00H,   0E0H,  01000H,00H,   080H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,
02000H,00H,   00H,   07800H,00H,   00H,   0800H, 00H,   00H,   09000H,
00H,   00H,   07800H,00H,   00H,   030H,  00H,   00H,   07CH,  00H,
00H,   044H,  00H,   00H,   07CH,  00H,   00H,   08H,   00H,   00H,
00H,   00H,   00H,   0FH,   00H,   00H,   08010H,08000H,00H,   0C01BH,
08000H,00H,   0E01EH,00H,   00H,   0F000H,00H,   00H,   0F800H,00H,
00H,   0FC00H,00H,   00H,   0FF00H,00H,   00H,   0FFC0H,00H,   00H,
0FFE0H,00H,   00H,   0FFF0H,00H,   00H,   07F38H,00H,   00H,   03C3EH,
00H,   00H,   01F3CH,00H,   00H,   0FB8H, 00H,   00H,   07F8H, 04H,
00H,   01FF8H,00H,   00H,   07FF8H,00H,   00H,   060FCH,00H,   00H,
063F0H,00H,   00H,   06F80H,00H,   00H,   07F00H,00H,   00H,   07800H,
00H,   00H,   06000H,00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   02000H,00H,   00H,   07800H,
00H,   00H,   0800H, 00H,   00H,   09000H,00H,   00H,   07800H,00H,
00H,   030H,  00H,   00H,   07CH,  00H,   00H,   044H,  00H,   00H,
07CH,  00H,   00H,   08H,   00H,   00H,   00H,   00H,   00H,   0FH,
00H,   00H,   010H,  08000H,00H,   01BH,  08000H,00H,   01EH,  00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   038H,  0380H,
00H,   038H,  07C0H, 00H,   038H,  03C0H, 00H,   00H,   0C3H,  08000H,
00H,   047H,  00H,   00H,   06H,   04H,   00H,   06H,   00H,   00H,
07H,   00H,   00H,   01F03H,08000H,00H,   01C00H,04H,   00H,   01000H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image4Data;

PROCEDURE Image5Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   02000H,00H,   00H,   07800H,00H,   00H,
0800H, 00H,   00H,   09000H,00H,   00H,   07800H,00H,   00H,   030H,
00H,   00H,   07CH,  00H,   00H,   044H,  00H,   00H,   07CH,  00H,
04H,   08H,   00H,   04H,   00H,   00H,   06H,   0FH,   00H,   06H,
02010H,08000H,07H,   0201BH,08000H,07H,   0301EH,00H,   07H,   03800H,
00H,   07H,   0BC00H,00H,   07H,   0BE00H,00H,   07H,   0BF00H,00H,
07H,   08000H,00H,   06H,   08000H,00H,   06H,   08000H,00H,   06H,
08000H,00H,   06H,   08800H,00H,   07H,   0C000H,00H,   07H,   0C000H,
00H,   07H,   0C000H,04H,   07H,   08000H,00H,   07H,   08000H,00H,
07H,   08000H,00H,   07H,   00H,   00H,   07H,   00H,   00H,   07H,
00H,   00H,   07H,   00H,   00H,   06H,   00H,   00H,   04H,   00H,
00H,   04H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,
02000H,00H,   00H,   07800H,00H,   00H,   0800H, 00H,   00H,   09000H,
00H,   00H,   07800H,00H,   00H,   030H,  00H,   00H,   07CH,  00H,
00H,   044H,  00H,   00H,   07CH,  00H,   00H,   08H,   00H,   00H,
00H,   00H,   00H,   0FH,   00H,   00H,   02010H,08000H,00H,   0201BH,
08000H,00H,   0301EH,00H,   00H,   03800H,00H,   00H,   03C00H,00H,
00H,   03E00H,00H,   00H,   03F00H,00H,   00H,   07F80H,00H,   00H,
07FC0H,00H,   00H,   07FE0H,00H,   00H,   07FF0H,00H,   00H,   071E0H,
00H,   00H,   03980H,00H,   00H,   03980H,00H,   00H,   03D80H,04H,
00H,   07F80H,00H,   00H,   07FE0H,00H,   00H,   043C0H,00H,   00H,
0CF80H,00H,   00H,   0DF00H,00H,   01H,   0FC00H,00H,   01H,   0F800H,
00H,   00H,   0F000H,00H,   00H,   0C000H,00H,   00H,   0C000H,00H,
00H,   08000H,00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   02000H,00H,   00H,   07800H,
00H,   00H,   0800H, 00H,   00H,   09000H,00H,   00H,   07800H,00H,
00H,   030H,  00H,   00H,   07CH,  00H,   00H,   044H,  00H,   00H,
07CH,  00H,   00H,   08H,   00H,   00H,   00H,   00H,   00H,   0FH,
00H,   00H,   010H,  08000H,00H,   01BH,  08000H,00H,   01EH,  00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   01H,   00H,   00H,   01H,   01C00H,
00H,   01H,   01E00H,00H,   01H,   081CH, 00H,   00H,   070H,  00H,
00H,   040H,  00H,   00H,   040H,  04H,   00H,   070H,  00H,   00H,
018H,  00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,   00H,
00H,   01H,   00H,   00H,   01H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image5Data;

PROCEDURE Image6Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   02000H,00H,   00H,   07800H,00H,   00H,
0800H, 00H,   00H,   09000H,00H,   00H,   07800H,00H,   00H,   030H,
00H,   00H,   07CH,  00H,   00H,   044H,  00H,   00H,   07CH,  00H,
04H,   08H,   00H,   04H,   00H,   00H,   06H,   0FH,   00H,   06H,
02010H,08000H,07H,   0201BH,08000H,07H,   0301EH,00H,   07H,   0B000H,
00H,   07H,   0B800H,00H,   07H,   0FC00H,00H,   07H,   0FC00H,00H,
07H,   08000H,00H,   07H,   00H,   00H,   07H,   08000H,00H,   07H,
08000H,00H,   07H,   09800H,00H,   07H,   09800H,00H,   07H,   01000H,
00H,   07H,   00H,   04H,   07H,   00H,   00H,   07H,   00H,   00H,
07H,   00H,   00H,   07H,   00H,   00H,   07H,   00H,   00H,   07H,
00H,   00H,   07H,   00H,   00H,   06H,   00H,   00H,   04H,   00H,
00H,   04H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,
02000H,00H,   00H,   07800H,00H,   00H,   0800H, 00H,   00H,   09000H,
00H,   00H,   07800H,00H,   00H,   030H,  00H,   00H,   07CH,  00H,
00H,   044H,  00H,   00H,   07CH,  00H,   00H,   08H,   00H,   00H,
00H,   00H,   00H,   0FH,   00H,   00H,   02010H,08000H,00H,   0201BH,
08000H,00H,   0301EH,00H,   00H,   03000H,00H,   00H,   03800H,00H,
00H,   07C00H,00H,   00H,   07C00H,00H,   00H,   07E00H,00H,   00H,
0FF00H,00H,   00H,   07F00H,00H,   00H,   07F80H,00H,   00H,   04780H,
00H,   00H,   06780H,00H,   00H,   0E980H,00H,   00H,   0E080H,04H,
00H,   0E000H,00H,   00H,   0E000H,00H,   00H,   0F000H,00H,   00H,
0F900H,00H,   00H,   0FE00H,00H,   01H,   0FC00H,00H,   01H,   0F000H,
00H,   00H,   0E000H,00H,   00H,   0C000H,00H,   00H,   0C000H,00H,
00H,   08000H,00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   02000H,00H,   00H,   07800H,
00H,   00H,   0800H, 00H,   00H,   09000H,00H,   00H,   07800H,00H,
00H,   030H,  00H,   00H,   07CH,  00H,   00H,   044H,  00H,   00H,
07CH,  00H,   00H,   08H,   00H,   00H,   00H,   00H,   00H,   0FH,
00H,   00H,   010H,  08000H,00H,   01BH,  08000H,00H,   01EH,  00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   03800H,
00H,   00H,   03800H,00H,   00H,   01800H,00H,   00H,   01800H,00H,
00H,   01600H,00H,   00H,   01F00H,04H,   00H,   01180H,00H,   00H,
01980H,00H,   00H,   0F00H, 00H,   00H,   0600H, 04H,   00H,   00H,
00H,   01H,   00H,   00H,   01H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image6Data;

PROCEDURE Image7Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   00H,   00H,   00H,   07C00H,00H,   00H,
06300H,00H,   00H,   01880H,00H,   00H,   01980H,00H,   02H,   0E00H,
00H,   03H,   00H,   00H,   03H,   08000H,00H,   03H,   08000H,00H,
03H,   0C000H,00H,   03H,   0C3E0H,00H,   03H,   0E420H,00H,   03H,
0E610H,00H,   03H,   0F1F0H,00H,   03H,   0F800H,00H,   03H,   0F000H,
00H,   03H,   0F800H,00H,   03H,   0FC00H,00H,   00H,   0200H, 00H,
00H,   00H,   00H,   00H,   0100H, 00H,   00H,   00H,   00H,   00H,
00H,   00H,   03H,   0C780H,00H,   03H,   08380H,00H,   03H,   0100H,
00H,   00H,   00H,   04H,   00H,   01000H,00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
04000H,00H,   00H,   07800H,00H,   00H,   07000H,00H,   00H,   07000H,
00H,   00H,   07000H,00H,   00H,   07000H,00H,   00H,   06000H,00H,
00H,   06000H,00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,
00H,   00H,   00H,   07C00H,00H,   00H,   06300H,00H,   00H,   01880H,
00H,   00H,   01980H,00H,   00H,   0E00H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
03E0H, 00H,   00H,   0420H, 00H,   00H,   0610H, 00H,   00H,   0C1F0H,
00H,   00H,   0E000H,00H,   00H,   0F000H,00H,   00H,   0F800H,00H,
01H,   0FC00H,00H,   03H,   0FE00H,00H,   07H,   0FE00H,00H,   07H,
0FF00H,00H,   07H,   0FFC0H,00H,   07H,   0FFC0H,00H,   04H,   03800H,
00H,   04H,   07C80H,00H,   04H,   0FE80H,00H,   03H,   0C380H,04H,
03H,   0C380H,00H,   03H,   0C300H,00H,   03H,   0FE00H,00H,   01H,
0FE00H,00H,   00H,   0F800H,00H,   00H,   03800H,00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   02000H,00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   07C00H,
00H,   00H,   06300H,00H,   00H,   01880H,00H,   00H,   01980H,00H,
00H,   0E00H, 00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   03E0H, 00H,   00H,   0420H,
00H,   00H,   0610H, 00H,   00H,   01F0H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   08100H,00H,   03H,   087C0H,
00H,   03H,   0C7C0H,00H,   03H,   0C780H,00H,   03H,   08380H,00H,
03H,   0100H, 00H,   00H,   03C00H,04H,   00H,   03400H,00H,   00H,
03C00H,00H,   00H,   00H,   00H,   00H,   00H,   04H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   02000H,00H,   00H,   00H,   00H);
END Image7Data;

PROCEDURE Image8Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   00H,   00H,   00H,   07C00H,00H,   00H,
06300H,00H,   080H,  01880H,00H,   02H,   01980H,00H,   03H,   0E00H,
00H,   03H,   08000H,00H,   03H,   0C000H,00H,   03H,   0E000H,00H,
03H,   0F000H,00H,   03H,   0FBE0H,00H,   03H,   0FC20H,00H,   00H,
010H,  00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
08H,   00H,   0FEH,  03F0H, 00H,   05CH,  01F0H, 00H,   07CH,  01E0H,
00H,   03CH,  0C0H,  04H,   038H,  0C0H,  00H,   018H,  0C0H,  00H,
00H,   00H,   00H,   00H,   07C01H,04000H,00H,   07C00H,00H,   00H,
07C00H,00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   07800H,00H,   00H,   07000H,00H,
00H,   06000H,00H,   00H,   04000H,00H,   00H,   00H,   04H,   00H,
00H,   00H,   00H,   07C00H,00H,   00H,   06300H,00H,   080H,  01880H,
00H,   00H,   01980H,00H,   00H,   0E00H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   01H,   00H,   00H,   01H,
083E0H,00H,   01H,   0C020H,00H,   0FH,   0FFD0H,00H,   01FH,  0FFE0H,
00H,   03FH,  0FFF0H,00H,   0FFH,  0FFF8H,00H,   01FFH, 0FFFCH,00H,
03FFH, 0FFFEH,00H,   07FFH, 0FFFFH,00H,   07FFH, 0FFFFH,00H,   0FFFH,
0FFFFH,08000H,0FFFH, 0FFFFH,08000H,0FFFH, 0FFFFH,08000H,0F00H, 0FC07H,
08000H,0F81H, 0FE0FH,08000H,0F83H, 0FE1FH,08000H,0FC3H, 0FF3FH,08004H,
0FC7H, 0FF3FH,08000H,07E7H, 0833FH,00H,   07FFH, 01FFH, 00H,   03FFH,
07DFEH,00H,   0FFH,  07DFCH,00H,   07FH,  07DF8H,00H,   03FH,  01F0H,
00H,   0FH,   083C0H,00H,   03H,   0FF80H,00H,   00H,   0FC00H,00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   07C00H,
00H,   00H,   06300H,00H,   080H,  01880H,00H,   00H,   01980H,00H,
00H,   0E00H, 00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   03E0H, 00H,   00H,   020H,
00H,   00H,   010H,  00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   01CH,
01C0H, 00H,   03EH,  03E0H, 00H,   0FFH,  03F0H, 00H,   0FFH,  03F0H,
00H,   0FFH,  03F8H, 00H,   0FEH,  03F0H, 00H,   05CH,  01F0H, 00H,
07CH,  01E0H, 00H,   03CH,  0C0H,  04H,   038H,  0C0H,  00H,   018H,
07CC0H,00H,   00H,   0FE00H,00H,   00H,   0FE01H,04004H,00H,   0FE00H,
00H,   00H,   0FE00H,00H,   00H,   0FE00H,00H,   00H,   07C00H,00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image8Data;

PROCEDURE Image9Data(); (* $E- *)

BEGIN
INLINE(
00H,   00H,   04H,   00H,   00H,   00H,   00H,   07C00H,00H,   00H,
06300H,00H,   080H,  01880H,00H,   02H,   01980H,00H,   03H,   0E00H,
00H,   03H,   08000H,00H,   03H,   0C000H,00H,   03H,   0E000H,00H,
03H,   0F000H,00H,   03H,   0FBE0H,00H,   03H,   0FC20H,00H,   00H,
010H,  00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
08H,   00H,   0FEH,  03F0H, 00H,   05CH,  01F0H, 00H,   07CH,  01E0H,
00H,   03CH,  0C0H,  04H,   038H,  0C0H,  00H,   018H,  0C0H,  00H,
00H,   01C00H,00H,   00H,   07E00H,00H,   00H,   07E00H,04000H,00H,
03C00H,00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   07800H,00H,   00H,   07000H,00H,
00H,   06000H,00H,   00H,   04000H,00H,   00H,   00H,   04H,   00H,
00H,   00H,   00H,   07C00H,00H,   00H,   06300H,00H,   080H,  01880H,
00H,   00H,   01980H,00H,   00H,   0E00H, 00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   01H,   00H,   00H,   01H,
083E0H,00H,   01H,   0C020H,00H,   01FH,  0FFF0H,00H,   03FH,  0FFF8H,
00H,   07FH,  0FFFCH,00H,   01FFH, 0FFFFH,00H,   03FFH, 0FFFFH,08000H,
07FFH, 0FFFFH,0C000H,01FFFH,0FFFFH,0C000H,01FFFH,0FFFFH,0E000H,03FFFH,
0FFFFH,0F000H,03FFFH,0FFFFH,0F800H,03FFFH,0FFFFH,0F800H,03F00H,0FC07H,
0F800H,03F81H,0FE0FH,0F800H,03F83H,0FE1FH,0F800H,03FC3H,0FF3FH,0F804H,
03FC7H,0FF3FH,0F800H,01FE7H,0813FH,0F800H,0FFEH, 01C7FH,0F000H,07FEH,
07E7FH,0E000H,01FEH, 07E7FH,0C000H,0FEH,  03C7EH,00H,   03FH,  0FCH,
00H,   01FH,  083F0H,00H,   07H,   0FFC0H,00H,   01H,   0FF80H,00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   04H,   00H,   00H,   00H,   00H,   07C00H,
00H,   00H,   06300H,00H,   080H,  01880H,00H,   00H,   01980H,00H,
00H,   0E00H, 00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   03E0H, 00H,   00H,   020H,
00H,   00H,   010H,  00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   01CH,
01C0H, 00H,   03EH,  03E0H, 00H,   0FFH,  03F0H, 00H,   0FFH,  03F0H,
00H,   0FFH,  03F8H, 00H,   0FEH,  03F0H, 00H,   05CH,  01F0H, 00H,
07CH,  01E0H, 00H,   03CH,  0C0H,  04H,   038H,  0C0H,  00H,   018H,
07EC0H,00H,   01H,   0FF80H,00H,   01H,   0FF80H,04H,   01H,   0FF80H,
04000H,01H,   0FF80H,00H,   00H,   0FF00H,00H,   00H,   07C00H,00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H,
00H,   00H,   00H,   00H,   00H,   00H,   00H,   00H);
END Image9Data;

PROCEDURE SetSprite(VAR sprite:VSprite; image: ADDRESS; bob: BobPtr);

BEGIN
  WITH sprite  DO
    nextVSprite := NIL;
    prevVSprite := NIL;
    drawPath := NIL;
    clearPath := NIL;
    oldY := 0;    oldX := 0;
    flags := VSpriteFlagSet{overlay,saveBack};
    y := 0;       x := 0;
    height := 42; width := 3; depth := 3;
    meMask := {}; hitMask := {};
    imageData := image;
    borderLine := NIL;
    collMask := NIL;
    sprColors := NIL;
    vsBob := bob;
    planePick := 7;
    planeOnOff := 0;
  END;
END SetSprite;

PROCEDURE SetComp(VAR Comp: AnimComp; next,prev: AnimCompPtr;
                  Ob: AnimObPtr; bob: BobPtr);

BEGIN
  WITH Comp DO
    flags := 0;
    timer := 0;
    timeSet := 0;
    nextComp := NIL;
    prevComp := NIL;
    nextSeq := next;
    prevSeq := prev;
    animCRoutine := NIL;
    yTrans := 0; xTrans := 0;
    headOb := Ob;
    animBob := bob;
  END;
END SetComp;

PROCEDURE SetBob(VAR bob: Bob; vs: VSpritePtr; comp: AnimCompPtr);

BEGIN
  WITH bob DO
    flags := BobFlagSet{};
    saveBuffer := NIL; imageShadow := NIL; before := NIL; after := NIL;
    bobVSprite := vs;
    bobComp := comp;
    dBuffer := NIL;
  END;
END SetBob;

PROCEDURE CleanUp();

BEGIN
  FreeMem(image1,SIZE(FishData));
  FreeMem(image2,SIZE(FishData));
  FreeMem(image3,SIZE(FishData));
  FreeMem(image4,SIZE(FishData));
  FreeMem(image5,SIZE(FishData));
  FreeMem(image6,SIZE(FishData));
  FreeMem(image7,SIZE(FishData));
  FreeMem(image8,SIZE(FishData));
  FreeMem(image9,SIZE(FishData));
END CleanUp;

BEGIN
  TermProcedure(CleanUp);
  color[0] := 028FH;
  color[1] := 0FFAH;
  color[2] := 0FBFH;
  color[3] := 0DBH;
  color[4] := 0F30H;
  color[5] := 090DH;
  color[6] := 0FFH;
  color[7] := 016AH;
  FishDataPtr := ADR(Image1Data);
  image1 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image1^ := FishDataPtr^;
  FishDataPtr := ADR(Image2Data);
  image2 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image2^ := FishDataPtr^;
  FishDataPtr := ADR(Image3Data);
  image3 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image3^ := FishDataPtr^;
  FishDataPtr := ADR(Image4Data);
  image4 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image4^ := FishDataPtr^;
  FishDataPtr := ADR(Image5Data);
  image5 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image5^ := FishDataPtr^;
  FishDataPtr := ADR(Image6Data);
  image6 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image6^ := FishDataPtr^;
  FishDataPtr := ADR(Image7Data);
  image7 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image7^ := FishDataPtr^;
  FishDataPtr := ADR(Image8Data);
  image8 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image8^ := FishDataPtr^;
  FishDataPtr := ADR(Image9Data);
  image9 := AllocMem(SIZE(FishData),MemReqSet{chip});
  image9^ := FishDataPtr^;
  WITH fishOb DO
    nextOb := NIL;   prevOb := NIL;
    clock  := 0;
    anOldY := 0;     anOldX := 0;
    anY := 0;        anX := 0;
    yVel := 0;       xVel := 0;
    yAccel := 0;     xAccel := 0;
    ringYTrans := 0; ringXTrans := 0;
    animORoutine := ADR(fish1Routine);
    headComp := ADR(fish1Comp);
  END;
(* Happy Imaging!  =RJM= *)

(* animation component file *)
(* 1 *)
  SetComp(fish1Comp,ADR(fish2Comp),ADR(fish17Comp),ADR(fishOb),ADR(fish1Bob));
  SetBob(fish1Bob,ADR(fish1Sprite),ADR(fish1Comp));
  SetSprite(fish1Sprite,image1,ADR(fish1Bob));
(* 2 *)
  SetComp(fish2Comp,ADR(fish3Comp),ADR(fish1Comp),ADR(fishOb),ADR(fish2Bob));
  SetBob(fish2Bob,ADR(fish2Sprite),ADR(fish2Comp));
  SetSprite(fish2Sprite,image2,ADR(fish2Bob));
(* 3 *)
  SetComp(fish3Comp,ADR(fish4Comp),ADR(fish2Comp),ADR(fishOb),ADR(fish3Bob));
  SetBob(fish3Bob,ADR(fish3Sprite),ADR(fish3Comp));
  SetSprite(fish3Sprite,image3,ADR(fish3Bob));
(* 4 *)
  SetComp(fish4Comp,ADR(fish5Comp),ADR(fish3Comp),ADR(fishOb),ADR(fish4Bob));
  SetBob(fish4Bob,ADR(fish4Sprite),ADR(fish4Comp));
  SetSprite(fish4Sprite,image4,ADR(fish4Bob));
(* 5 *)
  SetComp(fish5Comp,ADR(fish6Comp),ADR(fish4Comp),ADR(fishOb),ADR(fish5Bob));
  SetBob(fish5Bob,ADR(fish5Sprite),ADR(fish5Comp));
  SetSprite(fish5Sprite,image5,ADR(fish5Bob));
(* 6 *)
  SetComp(fish6Comp,ADR(fish7Comp),ADR(fish5Comp),ADR(fishOb),ADR(fish6Bob));
  SetBob(fish6Bob,ADR(fish6Sprite),ADR(fish6Comp));
  SetSprite(fish6Sprite,image6,ADR(fish6Bob));
(* 7 *)
  SetComp(fish7Comp,ADR(fish8Comp),ADR(fish6Comp),ADR(fishOb),ADR(fish7Bob));
  SetBob(fish7Bob,ADR(fish7Sprite),ADR(fish7Comp));
  SetSprite(fish7Sprite,image7,ADR(fish7Bob));
(* 8 *)
  SetComp(fish8Comp,ADR(fish9Comp),ADR(fish7Comp),ADR(fishOb),ADR(fish8Bob));
  SetBob(fish8Bob,ADR(fish8Sprite),ADR(fish8Comp));
  SetSprite(fish8Sprite,image8,ADR(fish8Bob));
(* 9 *)
  SetComp(fish9Comp,ADR(fish10Comp),ADR(fish8Comp),ADR(fishOb),ADR(fish9Bob));
  SetBob(fish9Bob,ADR(fish9Sprite),ADR(fish9Comp));
  SetSprite(fish9Sprite,image9,ADR(fish9Bob));
(* 10 *)
  SetComp(fish10Comp,ADR(fish11Comp),ADR(fish9Comp),ADR(fishOb),ADR(fish10Bob));
  SetBob(fish10Bob,ADR(fish10Sprite),ADR(fish10Comp));
  SetSprite(fish10Sprite,image8,ADR(fish10Bob));
(* 11 *)
  SetComp(fish11Comp,ADR(fish12Comp),ADR(fish10Comp),ADR(fishOb),ADR(fish11Bob));
  SetBob(fish11Bob,ADR(fish11Sprite),ADR(fish11Comp));
  SetSprite(fish11Sprite,image7,ADR(fish11Bob));
(* 12 *)
  SetComp(fish12Comp,ADR(fish13Comp),ADR(fish11Comp),ADR(fishOb),ADR(fish12Bob));
  SetBob(fish12Bob,ADR(fish12Sprite),ADR(fish12Comp));
  SetSprite(fish12Sprite,image6,ADR(fish12Bob));
(* 13 *)
  SetComp(fish13Comp,ADR(fish14Comp),ADR(fish12Comp),ADR(fishOb),ADR(fish13Bob));
  SetBob(fish13Bob,ADR(fish13Sprite),ADR(fish13Comp));
  SetSprite(fish13Sprite,image5,ADR(fish13Bob));
(* 14 *)
  SetComp(fish14Comp,ADR(fish15Comp),ADR(fish13Comp),ADR(fishOb),ADR(fish14Bob));
  SetBob(fish14Bob,ADR(fish14Sprite),ADR(fish14Comp));
  SetSprite(fish14Sprite,image4,ADR(fish14Bob));
(* 15 *)
  SetComp(fish15Comp,ADR(fish16Comp),ADR(fish14Comp),ADR(fishOb),ADR(fish15Bob));
  SetBob(fish15Bob,ADR(fish15Sprite),ADR(fish15Comp));
  SetSprite(fish15Sprite,image3,ADR(fish15Bob));
(* 16 *)
  SetComp(fish16Comp,ADR(fish17Comp),ADR(fish15Comp),ADR(fishOb),ADR(fish16Bob));
  SetBob(fish16Bob,ADR(fish16Sprite),ADR(fish16Comp));
  SetSprite(fish16Sprite,image2,ADR(fish16Bob));
(* 17 *)
  SetComp(fish17Comp,ADR(fish1Comp),ADR(fish16Comp),ADR(fishOb),ADR(fish17Bob));
  SetBob(fish17Bob,ADR(fish17Sprite),ADR(fish17Comp));
  SetSprite(fish17Sprite,image1,ADR(fish17Bob));

END FishData.
