(*********************************************************************
 
   -:Program.  	 sundown.mod
   -:Author.   	 Pit + Mike Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    		 / Breslauerstrae 28 7332 Eislingen 
    :Phone.      ----
   -:shortcut. 	 [pit]
   -:Version.  	 1.0   
   -:Date.     	 11.03.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 Workbench-Copper-Demo
    :Remark.	 Gru an alle ATARI-Programmierer, Mike ist auch einer!
    
**********************************************************************
Eine kleine Copper-Spielerei, gibt der Workbench einen Abendhimmel.
Bevor ihr mde werdet, das kleine Fenster schlieen, und es erscheint
wieder der azurblaue Workbench-Himmel.
Experimentiert mal mit dem Copper, wenn man die Farben innerhalb einer
Bildschirmzeile zu oft ndert passieren wilde Dinge...
**********************************************************************)
MODULE sundown; 

FROM SYSTEM IMPORT	ADDRESS, ADR;

FROM Arts IMPORT	Assert, TermProcedure;

FROM Graphics IMPORT	RastPortPtr, TextAttr, TmpRas, UCopListPtr, 
			ViewModeSet, ViewPortPtr, AllocRaster, CBump, 
                        CMove, CWait, Draw, FreeRaster, InitTmpRas, 
                        FreeVPortCopLists;
                        
FROM Intuition IMPORT	IDCMPFlags, IDCMPFlagSet, NewWindow, ScreenPtr, 
			WindowFlags, WindowFlagSet, WindowPtr, ScreenFlagSet, 
                        ScreenFlags, CloseWindow, RethinkDisplay, OpenWindow;
                        
FROM Hardware IMPORT	custom;

FROM Exec IMPORT	MemReqs, MemReqSet, AllocMem, WaitPort, FreeMem;

VAR	s		:ScreenPtr;
 	w		:WindowPtr;
 	rp		:RastPortPtr;
 	vp		:ViewPortPtr;
 	cl		:UCopListPtr;
 	clalt		:UCopListPtr;
 	nw		:NewWindow;

                
PROCEDURE Cleanup;	(* Urzustand wiederherstellen *)
  BEGIN
  vp^.uCopIns:=clalt;
  RethinkDisplay;
  FreeMem(cl, SIZE(cl^)); 
  IF w#NIL THEN CloseWindow(w) END;
  END Cleanup;

PROCEDURE OpenAll;	(* Fenster ffnen, Zeiger initialisieren *)
  BEGIN
  vp:=NIL;  
  nw.leftEdge:=450; nw.topEdge:=5; nw.width:=100; nw.height:=20;
  nw.detailPen:=255; nw.blockPen:=255;
  nw.idcmpFlags:=IDCMPFlagSet{closeWindow};
  nw.flags:=WindowFlagSet{windowDrag, windowClose, activate};
  nw.title:=ADR('SunDown');
  nw.screen:=NIL;     (*s;*)
  nw.type:=ScreenFlagSet{wbenchScreen};
  nw.firstGadget:=NIL; nw.checkMark:=NIL; nw.bitMap:=NIL;
  nw.minWidth:=0; nw.minHeight:=0; nw.maxWidth:=0; nw.maxHeight:=0;
  w:=OpenWindow(nw);
  Assert(w#NIL, ADR("couldn't open window"));
  rp:=w^.rPort;
  s:=w^.wScreen;
  vp:=ADR(s^.viewPort);
  END OpenAll;

PROCEDURE InitAll;	(* Copperlist erstellen *)
  VAR 	i:CARDINAL;
  BEGIN
  cl:=AllocMem(SIZE(cl^), MemReqSet{chip, memClear});
  CWait(cl, 0,0); CBump(cl);
  CMove(cl, ADR(custom.color[0]),0FH); CBump(cl);
  FOR i:=0 TO 9 DO
   	    CWait(cl, 20+i*4,0); CBump(cl);
   	    CMove(cl, ADR(custom.color[0]),0FH-i+100H*i); CBump(cl);
  END;
  FOR i:=10 TO 15 DO
   	    CWait(cl, 36+i*2,0); CBump(cl);
   	    CMove(cl, ADR(custom.color[0]),0FH-i+100H*i); CBump(cl);
  END;
  FOR i:=0 TO 7 DO
   	    CWait(cl, 66+i,0); CBump(cl);
   	    CMove(cl, ADR(custom.color[0]),0F00H+10H*i); CBump(cl);
  END;
  CWait(cl, 73, 0); CBump(cl);
  CMove(cl, ADR(custom.color[0]), 0H); CBump(cl);
  CMove(cl, ADR(custom.color[2]), 444H); CBump(cl);
  CWait(cl, 10000, 255); CBump(cl);
  clalt:=vp^.uCopIns;
  vp^.uCopIns:=cl;
  RethinkDisplay
  END InitAll;

BEGIN
 s:=NIL; w:=NIL; 
 TermProcedure(Cleanup);
 OpenAll;
 InitAll; 
 WaitPort(w^.userPort);
END sundown.mod
