(*********************************************************************
 
   -:Program.  	 showhalfbrite.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      ----
   -:shortcut. 	 [pit]
   -:Version.  	 1.0   
   -:Date.     	 01.03.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 Demo of Extra-HalfBrite-Mode 
    :Remark.	 "AMOK - Amiga Modula-2 Klub / Stuttgart"
    
**********************************************************************
Dieses kleine Demo-Programm zeigt den ExtraHalfBrite-Mode des AMIGA.
Dieser Mode verfgt ber 64 verschiedene Farben, wobei die Farben
0-31 frei whlbar sind (beispielsweise ber SetRGB4), whrend fr 
die Farben 32-63 folgendes gilt:
Die Farbe X hat die halbe Leuchtdichte der Farbe X-32.
Im Demo sind die Farben X jeweils unter den Farben X-32 angeordnet.
**********************************************************************)
MODULE showHalfBrite;

FROM SYSTEM IMPORT	ADDRESS, ADR;

FROM Arts IMPORT	Assert, TermProcedure;

FROM Intuition IMPORT	NewWindow, WindowPtr, OpenWindow, OpenScreen, 
			CloseWindow, IDCMPFlags, IDCMPFlagSet, WindowFlags, 
                        WindowFlagSet, ScreenFlags,ScreenFlagSet, NewScreen,
                        ScreenPtr, customScreen, CloseScreen, RemakeDisplay,
                        stdScreenHeight; 

FROM Graphics IMPORT	RastPortPtr, ViewPortPtr, ViewModeSet, ViewModes,
			TextAttr, FontStyleSet, FontFlagSet, RectFill, 
                        SetDrMd, jam1, SetAPen, SetRGB4;
	

VAR			rp		:RastPortPtr;
			vp		:ViewPortPtr;
			nWindow		:NewWindow;
        		nScreen		:NewScreen;   	 
			WindowP		:WindowPtr;
        		ScreenP		:ScreenPtr;
        		TAttr		:TextAttr;
        	

PROCEDURE CleanUp;
 BEGIN
  IF WindowP<>NIL THEN CloseWindow(WindowP) END;
  IF ScreenP<>NIL THEN CloseScreen(ScreenP) END;
  RemakeDisplay; 		
 END CleanUp;

PROCEDURE MakeScreen;
  BEGIN
   WITH TAttr DO
   	name:=ADR("topaz.font");
        ySize:=8;
        style:=FontStyleSet{};
        flags:=FontFlagSet{};
   END; (*WITH*)
   WITH nScreen DO
  	leftEdge:=0;	topEdge:=0;
        width:=320;	height:=256; 	(*stdScreenHeight;*)
        depth:=6;
        detailPen:=0;	blockPen:=23;
        viewModes:=ViewModeSet{extraHalfbrite};	
        type:=customScreen;		
        font:=ADR(TAttr);
        defaultTitle:=ADR("extraHalfBrite");
        gadgets:=NIL;
        customBitMap:=NIL;
   END; (*WITH*)
   ScreenP:=OpenScreen(nScreen);
   Assert(ScreenP<>NIL,ADR("konnte den HAM-Screen nicht ffnen"));
   vp:=ADR(ScreenP^.viewPort);
  END MakeScreen;
VAR	i	:LONGCARD;
  
PROCEDURE MakeWindow(titel: ADDRESS);
 CONST	Lagex=0;	Lagey=10;	Breite=320;	Hoehe=190;
 BEGIN
  TermProcedure(CleanUp);
  WITH nWindow DO
  	leftEdge:=Lagex;	topEdge:=Lagey; 
  	width:=Breite; 		height:=Hoehe;
  	detailPen:=0; 
  	blockPen:=23;
  	idcmpFlags:=IDCMPFlagSet{closeWindow};  
  	flags:=WindowFlagSet{	windowSizing, windowDrag, windowDepth,
        			gimmeZeroZero, activate, noCareRefresh	};
  	title:=ADR("64 Farben");;
  	type:=customScreen;	(*ScreenFlagSet{wbenchScreen};*)
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=ScreenP; 
  	bitMap:=NIL;
  	minWidth:=5;     	
  	minHeight:=5; 		
  	maxWidth:=320; 		
  	maxHeight:=256;		
  END; (*WITH*)
  WindowP:=OpenWindow(nWindow);
  Assert(WindowP<>NIL,ADR("konnte Fenster nicht ffnen"));	
  rp:=WindowP^.rPort
END MakeWindow;

PROCEDURE SetUpColors;		(* die Farben 0-31 sind frei whlbar, 	*)
 VAR	ColNum	:CARDINAL;	(* Sie werden hier festgelegt		*)
 BEGIN
 ColNum:=0;
 FOR i:=1 TO 15 BY 2 DO
 	SetRGB4(vp,ColNum,i,0,0);
        INC(ColNum);
 END; (*FOR*)
 FOR i:=1 TO 15 BY 2 DO
 	SetRGB4(vp,ColNum,0,i,0);
        INC(ColNum);
 END; (*FOR*)
 FOR i:=1 TO 15 BY 2 DO
 	SetRGB4(vp,ColNum,0,0,i);
	INC(ColNum);
 END; (*FOR*)
 FOR i:=1 TO 15 BY 2 DO
 	SetRGB4(vp,ColNum,i,i,0);
	INC(ColNum);
 END; (*FOR*)
 END SetUpColors;

PROCEDURE MakeHalfB;			(* Die Boxes in den verschiedenen *)
 VAR	x,y,x1,x2,y1,y2	:CARDINAL; 	(* Farben werden gezeichnet	  *)
 BEGIN 
 SetDrMd(rp, jam1);
 FOR x:=0 TO 31 DO
   x1:=9*x;
   x2:=x1+8;
   FOR y:=0 TO 1 DO
        y1:=50+y*9;
        y2:=y1+8;
        SetAPen(rp, x+32*y);
  	RectFill(rp,x1 , y1, x2, y2);
        END; (*FOR red*)
 END; (*FOR blue*)
 END MakeHalfB;
   
BEGIN
 MakeScreen;				(* --> Screen ffnen		*)
 MakeWindow(ADR('SimpleWindow'));	(* --> Window ffnen		*)
 MakeHalfB;				(* --> Boxes zeichnen		*)
 FOR i:=0 TO 500000 BY 1 DO  END;	(* --> warten			*) 
 SetUpColors;;				(* --> Farben ndern		*)
 FOR i:=0 TO 500000 BY 1 DO  END; 	(* --> nochmal warten		*)
END showHalfBrite.
