MODULE Draw;

FROM DrawLines IMPORT DrawLines;
FROM SYSTEM IMPORT ADR,ADDRESS,NULL,BYTE;
FROM Intuition IMPORT ScreenPtr,ScreenFlags,ScreenFlagSet,CustomScreen,
      IntuitionName,IntuitionBase;
FROM Screens IMPORT NewScreen,OpenScreen,CloseScreen;
FROM Views IMPORT ModeSet,Modes;
FROM GraphicsLibrary IMPORT GraphicsName,GraphicsBase,DrawingModes,
      DrawingModeSet;
FROM Libraries IMPORT OpenLibrary,CloseLibrary;
FROM Pens IMPORT SetDrMd,Draw,Move;

VAR
  MyScreen: ScreenPtr;
  MyNewScreen: NewScreen;
  x: INTEGER;

BEGIN
  IntuitionBase := OpenLibrary(IntuitionName,0);
  GraphicsBase := OpenLibrary(GraphicsName,0);

  WITH MyNewScreen DO
    LeftEdge := 0;    TopEdge  := 0;
    Width    := 640;  Height   := 256;  Depth   := 1;
    DetailPen:= BYTE(0); BlockPen:= BYTE(1);
    ViewModes:= ModeSet{Hires};
    Type     := ScreenFlagSet{ScreenQuiet}+CustomScreen;
    Font     := NULL; DefaultTitle := NULL; Gadgets := NULL;
    CustomBitMap := NULL;
  END;
  MyScreen := OpenScreen(ADR(MyNewScreen));
  SetDrMd(ADR(MyScreen^.RPort),DrawingModeSet{Complement});

  DrawLines(ADR(MyScreen^.RPort),ADDRESS(GraphicsBase));

  CloseScreen(MyScreen);

  CloseLibrary(IntuitionBase);
  CloseLibrary(GraphicsBase);

END Draw.
