(**********************************************************************

    :Program.  	 DosSupport.mod
    :Contents.	 Useful AmigaDos Items missing in the Dos-Module
    :CoFiles.	 Amok#3:DosSupport/DosSupport.doc
    :Author.   	 Nicolas Benezan [bne]
    :Support.	 thanks to Philip Lindsay and Dewi Williams
    :Remark.	 I learned a lot from their C-sources AssignDev, LockMon
    :Address.    Postwiesenstr. 2, D7000 Stuttgart 60
    :Phone.      711/333679
    :Copyright.  Public Domain
    :Language. 	 Modula-II
    :Translator. M2Amiga AMSoft
    :ModHistory. V1.0a [bne] 26.06.88 (first public version, Amok#3)
    
**********************************************************************)

IMPLEMENTATION MODULE DosSupport;

FROM Dos	IMPORT DeviceList,BPTR,BSTR,dosName,DosLibrary,RootNode,
		DosInfo;
FROM Exec	IMPORT execBase,LibraryPtr,FindName,List;
FROM SYSTEM	IMPORT ADDRESS,ADR,CAST,SHIFT,LONGSET;
FROM ASCII	IMPORT nul;
FROM Arts	IMPORT Assert;

CONST	MaxChar=ORD(MAX(CHAR));

PROCEDURE GetDevList():DeviceListPtr;
VAR	DosLibPtr:POINTER TO DosLibrary;
	RootNodePtr:POINTER TO RootNode;
        InfoPtr:POINTER TO DosInfo;
BEGIN
  DosLibPtr:=ADDRESS(DosBase);
  IF DosLibPtr#NIL THEN
    RootNodePtr:=DosLibPtr^.root;
    InfoPtr:=BPTRtoADR(RootNodePtr^.info);
    RETURN BPTRtoADR(InfoPtr^.devInfo);
  ELSE
    RETURN NIL;
  END;
END GetDevList;

PROCEDURE BPTRtoADR(BCPLPtr:BPTR):ADDRESS;
BEGIN
  RETURN SHIFT(BCPLPtr,2);
END BPTRtoADR;

PROCEDURE ADRtoBPTR(Ptr:ADDRESS):BPTR;
BEGIN
  Assert(CAST(LONGSET,Ptr)*LONGSET{0,1}=LONGSET{},
  	ADR("BPTR not Longword aligned"));
  RETURN SHIFT(Ptr,-2);
END ADRtoBPTR;

PROCEDURE BSTRtoStr(BCPLStr:BSTR;VAR Str:ARRAY OF CHAR);
TYPE	StringPtr=POINTER TO ARRAY [0..MaxChar] OF CHAR;
VAR	StrPtr:StringPtr;
	Len,Count:INTEGER;
BEGIN
  StrPtr:=BPTRtoADR(BCPLStr);
  Len:=ORD(StrPtr^[0]);
  IF Len>HIGH(Str) THEN
    Len:=HIGH(Str);
  END;
  INC(StrPtr);
  FOR Count:=0 TO Len-1 DO
    Str[Count]:=StrPtr^[Count];
  END;
  Str[Len]:=nul;
END BSTRtoStr;

PROCEDURE StrToBCPL(VAR Str:ARRAY OF CHAR);
VAR	Count,Len,Range:INTEGER;
BEGIN
  Range:=HIGH(Str);
  IF Range>MaxChar THEN
    Range:=MaxChar;
  END;
  Len:=0;
  WHILE (Str[Len]#nul)AND(Len<HIGH(Str)) DO
    INC(Len);
  END;
  FOR Count:=Len TO 1 BY -1 DO
    Str[Count]:=Str[Count-1];
  END;
  Str[0]:=CHAR(Len);
END StrToBCPL;

BEGIN
  DosBase:=CAST(LibraryPtr,FindName(execBase^.libList.head,ADR(dosName)));
END DosSupport.
