(*********************************************************************
 
   -:Program.  	 GelMacros.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      -------------
   -:shortcut. 	 [pit]
   -:Version.  	 0.1   
   -:Date.     	 19.06.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 Gels initializing Macros
    :Remark.	 This was hard work, please leave my Name in!
    
**********************************************************************)

IMPLEMENTATION MODULE GelMacros;

FROM SYSTEM IMPORT 	ADR,ADDRESS,BITSET,WORD;

FROM Exec IMPORT	UByte;

FROM Graphics IMPORT 	RastPortPtr,GelsInfo,InitGels,VSpriteFlags,
			VSpriteFlagSet,InitMasks,(*collTable,*)
                        BobFlags,BobFlagSet,VSpritePtr,BobPtr,GelsInfoPtr,
                        AllocRaster,FreeRaster,AnimCompPtr,CollTablePtr,
                        AnimComp,AnimOb,AnimObPtr,AddAnimOb,ringtrigger;

FROM Arts IMPORT 	TermProcedure,BreakPoint,Assert;

FROM Heap IMPORT 	AllocMem;

VAR     collmaskP		:ADDRESS;
        GelsIntitialized	:BOOLEAN;  
      

PROCEDURE BackMem(BobP:BobPtr);
 BEGIN   
    IF BobP^.saveBuffer<>NIL THEN
     (* BreakPoint(ADR("saveBuffer<>NIL"));*)
     FreeRaster(BobP^.saveBuffer,BobP^.bobVSprite^.width,
      		BobP^.bobVSprite^.height*BobP^.bobVSprite^.depth);  	
    END;
 END BackMem;



PROCEDURE prepare(RPort:RastPortPtr);
 
 VAR	s1,s2			:VSpritePtr;
    	gelsinfo		:GelsInfoPtr;
        lastCol			:POINTER TO LONGCARD;
        nextL			:POINTER TO WORD;
        collH			:CollTablePtr;
 
 BEGIN  
  IF NOT GelsIntitialized THEN 
   AllocMem(gelsinfo,SIZE(gelsinfo^),TRUE);
   Assert(gelsinfo<>NIL,ADR("GelMacros:gelsinfo nicht alloziert"));
   
   AllocMem(s1,SIZE(s1^),TRUE);
   AllocMem(s2,SIZE(s2^),TRUE);
   Assert((s1<>NIL) OR (s2<>NIL),ADR("GelMacros:s1/s2 nicht alloziert"));
   
   AllocMem(nextL,SIZE(nextL^)*8,TRUE);
   Assert(nextL<>NIL,ADR("GelMacros:nextL nicht alloziert"));
   
   AllocMem(lastCol,SIZE(lastCol^)*8,TRUE);
   Assert(lastCol<>NIL,ADR("GelMacros:lastCol nicht alloziert"));
   
   AllocMem(collH,SIZE(collH^),TRUE);
   Assert(collH<>NIL,ADR("GelMacros:collH nicht alloziert"));
   
   WITH gelsinfo^ DO
   	sprRsrvd:=252;		(* Sprite 0 und 1 werden nicht genutzt	*)
        nextLine:=nextL;
   	lastColor:=lastCol;
        collHandler:=collH;
        (*
        gelHead:=s1;
        gelTail:=s2;
        *)
        leftmost:=0;
        rightmost:=640;
        topmost:=0;
        bottommost:=256;
   END;
   InitGels(s1,s2, gelsinfo);
   RPort^.gelsInfo := gelsinfo;
   GelsIntitialized:=TRUE;
  END; (*IF*)
 END prepare;





PROCEDURE MakeVSprite(  VAR VSprP	:VSpritePtr;
			Imageheight	:INTEGER;
			ImageP		:ADDRESS;
                        ColorSet	:ARRAY OF CARDINAL;  (* [0..2] *) 
                        XPos,YPos,
                        Wordwidth,
                        Imagedepth	:INTEGER;
                        VSflags		:VSpriteFlagSet;
                        PlPick,PlOnOff	:UByte;
                        rp		:RastPortPtr		);
 
 TYPE			ColorSetType=RECORD
 				Color	:ARRAY [0..2] OF CARDINAL;
        		END;
 
 VAR			borderlineP	:ADDRESS;
        		ColorSetP	:POINTER TO ColorSetType;
        		i		:INTEGER;
 
 BEGIN
   IF NOT GelsIntitialized THEN		(* GelsInfo nur 1mal aufrufen *)
     prepare(rp);
   END;
   
   AllocMem(VSprP,SIZE(VSprP^),TRUE);
   Assert(VSprP<>NIL,ADR("GelMacros:VSprP nicht alloziert"));
   
   AllocMem(borderlineP,2*Wordwidth*Imageheight,TRUE);
   Assert(borderlineP<>NIL,ADR("GelMacros:borderlineP nicht alloziert"));
   
   AllocMem(collmaskP,Imageheight*Wordwidth*Imagedepth*2,TRUE);
   Assert(collmaskP<>NIL,ADR("GelMacros:collmaskP nicht alloziert"));
   
   AllocMem(ColorSetP,SIZE(ColorSetP^)*8,TRUE);
   Assert(ColorSetP<>NIL,ADR("GelMacros:ColorSetP nicht alloziert"));
   
 (* 	
   	Individual ColorPointer for every sprite! This can have disadvatages,
	you might like all your sprites to point to the same colorset, thus
        allowing more sprites to be displayed in a single row. This can be
        achieved by getting the ColorPointer from any sprite
        
                MyColP:=MyVSpriteP^.sprColors;
                
        ..and placing it into all your SpriteRecords
        
                MyOtherVSpriteP^.sprColors:=MyColP;
                ...
                
        If you use VSprites to initialize Bobs, you don't need the ColorPinter 
        at all. It will be initialized anyway, needing your precious 
        Chip-Mem. This might be fixed in an UpDate.
*)                             	
   
   WITH ColorSetP^ DO
   	FOR i:=0 TO 2 DO
          Color[i]:=ColorSet[i];
   	END;
   END;     
   
   WITH VSprP^ DO
   	x:=XPos;
   	y:=YPos;
   	flags:=VSflags;
   	height:=Imageheight;
   	width:=Wordwidth;
   	depth:=Imagedepth;   
        meMask:=BITSET{1};		(* Voreinstellung *)
   	hitMask:=BITSET{1}; 
        imageData:=ImageP; 
   	collMask:=collmaskP;		
   	borderLine:=borderlineP;	
   	sprColors:=ColorSetP;
        planePick:=PlPick;		(* nur von Bobs genutzt 	*)
        planeOnOff:=PlOnOff;		
  END; (*WITH VSprP*)
  (* BreakPoint(ADR("DoBob:InitMasks "));*)
  InitMasks(VSprP);
 END MakeVSprite;




PROCEDURE MakeBob(	VAR BobP	:BobPtr;
			VAR VSprP	:VSpritePtr;
			Imagewidth,
                        Imageheight,
                        Imagedepth	:INTEGER;
			ImageP		:ADDRESS; 
                        PlPick,PlOnOff	:UByte;
                        XPos,YPos	:INTEGER;
                        Bbflags		:BobFlagSet; 
                        VSflags		:VSpriteFlagSet;
                        Comp		:AnimCompPtr;
                        rp		:RastPortPtr		);

 VAR    		BufferLocation	:ADDRESS;
       			Wordwidth	:INTEGER;
                        ColDummy	:ARRAY [0..2] OF CARDINAL;
			
 BEGIN
  Wordwidth:=(Imagewidth+15) DIV 16;
  MakeVSprite(	VSprP,Imageheight,ImageP,ColDummy,XPos,YPos,Wordwidth,
  		Imagedepth,VSflags,PlPick,PlOnOff,rp);
  (* BreakPoint(ADR("DoBob:AllocMem "));*)
  AllocMem(BobP,SIZE(BobP^),TRUE);
  Assert(BobP<>NIL,ADR("GelMacros:BobP nicht alloziert"));
  (* BreakPoint(ADR("DoBob:BufferLocation "));*)
  BufferLocation:=AllocRaster(Imagewidth,Imageheight*Imagedepth);
  Assert(BufferLocation<>NIL,ADR("GelMacros:saveBuffer nicht alloziert")); 
  WITH BobP^ DO
   	flags:=Bbflags;
   	saveBuffer:=BufferLocation; 	(* show where to save background *) 	
        imageShadow:=collmaskP;   	(* collision and shadow are same *)
   	before:=NIL;           		(* dont care about drawing order *)
   	after:=NIL;
	bobComp:=Comp;               	(* NIL if not animation comp.	*)
	dBuffer:=NIL;               	(* not double buffered 		*)
	bobVSprite:=VSprP;              
  END;
  VSprP^.vsBob:=BobP;			(* link Bob and VSprite together*)
 END MakeBob;
 




PROCEDURE MakeAnimComp(	VAR AnCoP	:AnimCompPtr;
                        AnObP		:AnimObPtr;
			BobP		:BobPtr;
                        Time		:INTEGER;
                        RingTrig	:BOOLEAN		);
 BEGIN
   AllocMem(AnCoP,SIZE(AnCoP^),TRUE);	(* Ins Chip-Mem setzen		*)
   WITH AnCoP^ DO
     IF RingTrig THEN
     	flags:=ringtrigger;
     ELSE
     	flags:=0;
     END;
     					(* Time<>0 sonst entsteht..	*) 
     timeSet:=Time;			(* ...keine Sequenz		*)
     nextComp:=NIL;
     prevComp:=NIL;
     nextSeq:=NIL;			(* Wird spter erledigt		*)
     prevSeq:=NIL;
     animCRoutine:=NIL;
     yTrans:=0;				(* Konstanter Offset 		*)
     xTrans:=XOFFSET*POSFAKTOR;
     headOb:=AnObP;
     animBob:=BobP;
   END;
   WITH BobP^ DO			(* Bob ist AnimComp 		*)
     bobComp:=AnCoP;
     flags:=BobFlagSet{bobIsComp};
     before:=NIL;
     after:=NIL;
   END;
   WITH BobP^.bobVSprite^ DO		(* Position auf 0 stellen 	*)
     x:=0;
     y:=0;
     flags:=VSpriteFlagSet{saveBack,overlay};
   END;  
 END MakeAnimComp;




PROCEDURE LinkAnimComps(VAR AnCoP	:ARRAY OF AnimCompPtr;
			Count		:INTEGER		);
                        
 VAR			i		:INTEGER;
 
 BEGIN
  FOR i:=1 TO Count-1 DO
    WITH AnCoP[i]^ DO
      nextSeq:=AnCoP[i+1];
      prevSeq:=AnCoP[i-1];
    END;
  END; (*FOR*)
  WITH AnCoP[0]^ DO
    nextSeq:=AnCoP[1];
    prevSeq:=AnCoP[Count];
  END;
  WITH AnCoP[Count]^ DO
    nextSeq:=AnCoP[0];
    prevSeq:=AnCoP[Count-1];
  END;
 END LinkAnimComps; 
                                                 



PROCEDURE MakeAnimOb(	VAR AnObP	:AnimObPtr;
			AnCoP		:ARRAY OF AnimCompPtr;
                        BobP		:ARRAY OF BobPtr;
                        XPos,YPos	:INTEGER;
                        Time		:ARRAY OF INTEGER;
                        Count		:INTEGER;
                        CheckProc	:ADDRESS;
                        RingTrigger	:BOOLEAN		);
 
 VAR			i		:INTEGER;
 
 BEGIN                        
   FOR i:=0 TO Count DO
	MakeAnimComp(AnCoP[i],AnObP,BobP[i],Time[i],RingTrigger);
   END;     
   LinkAnimComps(AnCoP,Count);     
   AllocMem(AnObP,SIZE(AnObP^),TRUE);	(* Ins Chip-Mem setzen	*)
   WITH AnObP^ DO
     anY:=POSFAKTOR*YPos;	(* Lage			des AnimObjects	*)
     anX:=POSFAKTOR*(XPos-128);
     yVel:=0;		(* Geschwindigkeit	      -/-	*)
     xVel:=0;
     yAccel:=0;		(* Beschleunigung	      -/-	*)
     xAccel:=0;
     ringYTrans:=0;	(* Translation pro AnimComp-Loop	*)
     ringXTrans:=0;
     animORoutine:=CheckProc;
     headComp:=AnCoP[0];
   END; 
 END MakeAnimOb;        



PROCEDURE DoRingTrigger(AnObP:AnimObPtr; per64timesX,per64timesY:INTEGER); 
 BEGIN  
   WITH AnObP^ DO
     ringYTrans:=per64timesY;	(* Translation pro AnimComp-Loop	*)
     ringXTrans:=per64timesX;
   END; 
 END DoRingTrigger;



PROCEDURE DoRingTriggerOFF(AnObP:AnimObPtr); 
 BEGIN  
   WITH AnObP^ DO
     ringYTrans:=0;	(* Translation pro AnimComp-Loop	*)
     ringXTrans:=0;
   END; 
 END DoRingTriggerOFF;




PROCEDURE MoveAnimOb(AnObP:AnimObPtr; XPos,YPos:INTEGER); 
 BEGIN  
   WITH AnObP^ DO
     anY:=POSFAKTOR*YPos;	(* Lage	des AnimObjects	*)
     anX:=POSFAKTOR*(XPos-XOFFSET);
   END; 
 END MoveAnimOb;
  


PROCEDURE Velocity(AnObP:AnimObPtr; Xv,Yv:INTEGER); 
 BEGIN  
   WITH AnObP^ DO
     yVel:=Yv;		(* Geschwindigkeit *)
     xVel:=Xv;
   END; 
 END Velocity;
  


PROCEDURE Acceleration(AnObP:AnimObPtr; XAcc,YAcc:INTEGER); 
 BEGIN  
   WITH AnObP^ DO
     yAccel:=YAcc;		(* Beschleunigung*)
     xAccel:=XAcc;
   END; 
 END Acceleration;


 
      
BEGIN
  GelsIntitialized:=FALSE;
  
END GelMacros.

