(*********************************************************************
 
   -:Program.  	 OpenBDW.mod
   -:Author.   	 Pit Burkhardt  
    :Address.    Stettinerstrae 25 7030 Bblingen
    :Phone.      -------------
   -:shortcut. 	 [pit]
   -:Version.  	 0.1   
   -:Date.     	 19.06.1988
   -:Copyright.  PD
   -:Language. 	 Modula-II
   -:Translator. M2Amiga
   -:Imports.	 ----
   -:UpDate.	 ----
   -:Contents.	 Opens Screen and borderless BackDropWindow (looks like nothing)
    :Remark.	 
    
**********************************************************************)

IMPLEMENTATION MODULE OpenBDW;

FROM SYSTEM IMPORT      ADDRESS,ADR;

FROM Arts IMPORT	TermProcedure,Assert,BreakPoint;

FROM Intuition IMPORT	NewWindow, WindowPtr, OpenWindow, ScreenPtr, 
			CloseWindow, IDCMPFlags, IDCMPFlagSet, WindowFlags, 
                        WindowFlagSet, RemakeDisplay, Window, otherRefresh,
                        ScreenFlagSet, ScreenFlags, OpenScreen, NewScreen, 
                        customScreen, CloseScreen, ShowTitle;

FROM Graphics IMPORT	ViewModeSet, ViewModes, TextAttr, FontStyleSet, 
			FontFlagSet, SetRGB4;

(* ============== externe Variablen und Konstanten ==================

CONST	SCRH=200;
	SCRW=640;

VAR	ScreenP		:ScreenPtr; 
	BDWindowP  	:WindowPtr;

=====================================================================*)

VAR     nWindow		:NewWindow;
        nScreen		:NewScreen;   	 
        TAttr		:TextAttr;
        

PROCEDURE Cleanup;
 BEGIN
  IF BDWindowP<>NIL THEN CloseWindow(BDWindowP) END;
  IF ScreenP<>NIL THEN CloseScreen(ScreenP) END;
 END Cleanup;

PROCEDURE OpenBackDrop(ScrDepth:INTEGER); 

PROCEDURE MakeScreen;
  BEGIN
   WITH TAttr DO
   	name:=ADR("topaz.font");
        ySize:=8;
        style:=FontStyleSet{};
        flags:=FontFlagSet{};
   END; (*WITH*)
   WITH nScreen DO
  	leftEdge:=0;	topEdge:=0;
        width:=SCRW;	height:=SCRH; 	
        depth:=ScrDepth;
        detailPen:=0;	blockPen:=1;
        viewModes:=ViewModeSet{hires};
        type:=customScreen;	
        font:=ADR(TAttr);
        defaultTitle:=NIL;
        gadgets:=NIL;
        customBitMap:=NIL;
   END; (*WITH*)
   ScreenP:=OpenScreen(nScreen);
   Assert(ScreenP<>NIL,ADR("konnte den Screen nicht ffnen"));
  END MakeScreen;

PROCEDURE MakeWindow;
 BEGIN
  WITH nWindow DO
  	leftEdge:=0;	topEdge:=0; 
  	width:=SCRW; 	height:=SCRH;
  	detailPen:=0; 
  	blockPen:=1;
  	idcmpFlags:=IDCMPFlagSet{closeWindow};  
  	flags:=WindowFlagSet{   gimmeZeroZero, backDrop, borderless};
  	title:=NIL;
  	type:=customScreen; 	(*ScreenFlagSet{wbenchScreen};*)
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=ScreenP;
  	bitMap:=NIL;
  	minWidth:=40;     	
  	minHeight:=20; 		
  	maxWidth:=SCRW; 		
  	maxHeight:=SCRH;		
  END; (*WITH*)
  BDWindowP:=OpenWindow(nWindow);
  Assert(BDWindowP<>NIL,ADR("konnte Fenster nicht ffnen"));	
 END MakeWindow;

 BEGIN
 TermProcedure(Cleanup);
 MakeScreen;
 MakeWindow;
 ShowTitle(ScreenP,FALSE); 
END OpenBackDrop;

END OpenBDW.
