(*********************************************************************
 
    :Program.  	BinaerAnz.mod
    :Author.   	Pit Burkhardt  
    :Address.   Stettinerstrae 25 D-7030 Bblingen
    :shortcut. 	[pit]
    :Version.  	1.0   
    :Date.     	June 1988
    :Copyright. PD
    :Language. 	Modula-II
    :Translator.M2Amiga
    :Imports.	GearCode
    		BinCode
                Grafiken 
                GelMacros
    :UpDate.	none
    :Contents.	Opens Windows for DragNumbers and "hide-behind".
    		PROCEDUREs for initializing, displaying and removing BOBs.
    :Remark.	Studienarbeit 
    		Im Kernfach TECHNISCHES DESIGN
                an der Universitt Stuttgart	 
    
**********************************************************************)

IMPLEMENTATION MODULE BinaerAnz;

FROM SYSTEM IMPORT 	ADDRESS,ADR;

FROM Arts IMPORT	Assert,TermProcedure,BreakPoint;

FROM Intuition IMPORT	MakeScreen;

FROM GfxMacros IMPORT	RemBob,OffDisplay,OnDisplay;

FROM Grafiken IMPORT	MAXWIDTH,MAXHEIGHT,MINWIDTH,MINHEIGHT,
			TEMPL,TEMPH,TANK,ECO1,ECO2,BINB,ANUMB,TACHOE,TACHOT,
                        LASTWINDOW,
                        MakeTag,ShowWindow,HideWindow,PlaceWindow,ReturnWindow,
                        Display,WriteAlpha,WriteNumber,ScrRpP,ScreenP,AWinDat,
                        vp,Prepare;
                        
FROM Exec IMPORT	UByte;

FROM GelMacros IMPORT	BackMem(*	BobP		:BobPtr*),
			MakeBob(*	VAR BobP	:BobPtr;
					VAR VSprP	:VSpritePtr;
					Imagewidth,
                        		Imageheight,
                        		Imagedepth	:INTEGER;
					ImageP		:ADDRESS; 
                        		PlPick,PlOnOff	:UByte;
                        		XPos,YPos	:INTEGER;
                        		Bbflags		:BobFlagSet; 
                        		VSflags		:VSpriteFlagSet;
                        		Comp		:AnimCompPtr;
                        		rp		:RastPortPtr
                                        		*);

FROM Graphics IMPORT	Text,BobPtr,VSpritePtr,BobFlagSet,BobFlags,
			VSpriteFlagSet,VSpriteFlags,AddBob,DrawGList,SortGList,
                        RastPortPtr,CollTablePtr,GelsInfoPtr,InitGels,
			BitMap, AllocRaster, FreeRaster,WaitTOF, 
			InitBitMap, BltClear, ViewPortPtr, ViewModeSet, 
                        ViewModes, TextAttr, FontStyleSet, FontFlagSet;

FROM Intuition IMPORT	NewWindow,WindowPtr,ScreenPtr,IDCMPFlagSet,IDCMPFlags,
			WindowFlagSet,WindowFlags,OpenWindow,CloseWindow,
                        customScreen,Image,DrawImage,SizeWindow,MoveWindow,	
			RemakeDisplay,Window,otherRefresh,
                        WindowToBack,ScreenToBack;

FROM DragNum IMPORT	ELEMENTSX,ELEMENTSY,FIRSTSIZE,LASTSIZE,
			PrepareNumber(*	RastP		:RastPortPtr;
					ANumWidth,
                                        ANumHeight,
                                        AlinkerRand	:ARRAY OF INTEGER;
					PlaneWidth,
                                        PlaneHeight	:INTEGER*),
			SetNumSize(*Size:INTEGER*),
			ShowSpeed(*Speed:INTEGER*),
			SetNumPrefs(*AP,BP,OP:INTEGER*);

FROM BinCode IMPORT	WARN,BATT,OELS,GURT,FLIT,HABR,HECK,BLIL,BLIR,
			Imgwidth,Imgheight,Imgdepth,ImgPtr;
                        
FROM GearCode IMPORT   	FAST,SLOW,BACK,NEUT,PARK,Gearwidth,Gearheight,
			Geardepth,GearPtr;


CONST		SPEEDWRAND=40;
		
                SPEEDWHEIGHT=110; (* grte Ausdehnug der Speed-Ziffern  *) 
                SPEEDWWIDTH=430;
		
                SPEEDWHEIGHT2=84; (* kleinste Ausdehnug der Speed-Ziffern *)
                SPEEDWWIDTH2=257;
                
                BITMAPBREITE=512; (* MUSS >= SPEEDWWIDTH+SPEEDWRAND sein  *)
                BITMAPHOEHE=150;  (* MUSS >= SPEEDWHEIGHT SEIN		  *)
                
                SPEEDWX=150;	  (* Lage des Speed-Windows		  *)  
                SPEEDWY=53 ;

(*-------------------------------Externe Konstante                              

CONST		KLEIN=0; BREIT=1; HOCH=2; GROSS=3;                

------------------------------------------------*)

VAR		BinSymbP	:ARRAY[WARN..HECK] OF BobPtr;
		BinVSP		:ARRAY[WARN..HECK] OF VSpritePtr;
		GearSymb	:ARRAY[FAST..PARK] OF Image;
		BinXPos		:ARRAY[WARN..HECK] OF INTEGER;
		SymbActive	:ARRAY[WARN..HECK] OF BOOLEAN;
                BinYPos,i	:INTEGER;
                LastGear	:INTEGER;
		DEPTH		:INTEGER;
                
                NumWidth,
                NumHeight,
                NumRand		:ARRAY [FIRSTSIZE..LASTSIZE] OF INTEGER;

		rp		:RastPortPtr;	(* RastPort des Speed-Windows *)
		nWindow		:NewWindow;
                SpeedWindowP,
                SpareWindowP	:WindowPtr;
        	plane		:LONGINT;
        	error		:LONGINT;
        	errorP		:ARRAY [0..6] OF ADDRESS;
        	Ende		:INTEGER;
        	WindowBM	:BitMap;



PROCEDURE CleanUp;
 BEGIN
   FOR i:=0 TO 8 DO
    IF BinSymbP[i]<>NIL THEN
      RemBob(BinSymbP[i]);
      SortGList(AWinDat[BINB].rp);
      DrawGList(AWinDat[BINB].rp,vp);
      BackMem(BinSymbP[i]);
    ELSE
      BreakPoint(ADR("Kein Bob gelscht"));
    END;
  END;
  IF SpeedWindowP<>NIL THEN CloseWindow(SpeedWindowP) END;
  FOR plane:=0 TO DEPTH-1 DO
    IF errorP[plane]<>NIL THEN 
      FreeRaster(errorP[plane],BITMAPBREITE,BITMAPHOEHE) 
    ELSE
      BreakPoint(ADR("Keine BitMap gelscht"));
    END;
  END;
 END CleanUp;


PROCEDURE MakeBitMap;  (* BitMap initialisieren, Raster reservieren *)
 BEGIN
  InitBitMap(WindowBM,DEPTH,BITMAPBREITE,BITMAPHOEHE);
  FOR plane:=0 TO DEPTH-1 DO
     errorP[plane]:=AllocRaster(BITMAPBREITE,BITMAPHOEHE);
     BltClear(errorP[plane],BITMAPBREITE DIV 8*BITMAPHOEHE,1);
     IF errorP[plane]=NIL THEN
       FOR i:=1 TO plane-1 DO
     	  FreeRaster(errorP[i],BITMAPBREITE,BITMAPHOEHE);
  	  Assert(errorP[plane]<>NIL,ADR("konnte Raster nicht allozieren"));
       END;
     END;
     WindowBM.planes[plane]:=errorP[plane];
  END; (*FOR plane*)
 END MakeBitMap;


PROCEDURE InitNum;
 BEGIN
   NumWidth[KLEIN]:=SPEEDWWIDTH2;
  NumHeight[KLEIN]:=SPEEDWHEIGHT2;
    NumRand[KLEIN]:=SPEEDWRAND;
   NumWidth[BREIT]:=319;
  NumHeight[BREIT]:=SPEEDWHEIGHT2;
    NumRand[BREIT]:=169;
   NumWidth[HOCH] :=SPEEDWWIDTH2;
  NumHeight[HOCH] :=SPEEDWHEIGHT;
    NumRand[HOCH] :=SPEEDWRAND;
   NumWidth[GROSS]:=SPEEDWWIDTH;
  NumHeight[GROSS]:=SPEEDWHEIGHT;
    NumRand[GROSS]:=SPEEDWRAND;
  PrepareNumber(	rp,NumWidth,NumHeight,NumRand,
  			SPEEDWWIDTH,SPEEDWHEIGHT);	
 END InitNum;


PROCEDURE MakeWindow;
 BEGIN
  DEPTH:=ScrRpP^.bitMap^.depth;	(* Tiefe des ScrRpP^ Screens-RastPorts *)
  MakeBitMap; 
  WITH nWindow DO
  	leftEdge:=SPEEDWX;	
        topEdge:=SPEEDWY;
  	width:=SPEEDWWIDTH+SPEEDWRAND; 		
        height:=SPEEDWHEIGHT;
  	detailPen:=0; 
  	blockPen:=1;
  	idcmpFlags:=IDCMPFlagSet{closeWindow,newSize};  
  	flags:=WindowFlagSet{gimmeZeroZero,borderless,superBitMap  };
  	title:=NIL;
  	type:=customScreen;
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=ScreenP; 
  	bitMap:=ADR(WindowBM);
  	minWidth:=0;     	
  	minHeight:=0; 		
  	maxWidth:=MAXWIDTH; 		
  	maxHeight:=MAXHEIGHT;		
  END; (*WITH*)
  SpeedWindowP:=OpenWindow(nWindow);
  Assert(SpeedWindowP<>NIL,ADR("konnte Speed Fenster nicht ffnen"));	
  rp:=SpeedWindowP^.rPort;
  InitNum;
  SetNumPrefs(2,0,1);
 END MakeWindow;


PROCEDURE MakeSpareWindow;
 BEGIN
  DEPTH:=ScrRpP^.bitMap^.depth;	(* Tiefe des ScrRpP^ Screens-RastPorts *)
  WITH nWindow DO
  	leftEdge:=0;	
        topEdge:=0; 
  	width:=MAXWIDTH; 		
        height:=MAXHEIGHT;
  	detailPen:=0; 
  	blockPen:=1;
  	idcmpFlags:=IDCMPFlagSet{closeWindow,newSize};  
  	flags:=WindowFlagSet{borderless,simpleRefresh,noCareRefresh  };
  	title:=NIL;
  	type:=customScreen;
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=ScreenP; 
  	bitMap:=NIL;
  	minWidth:=0;     	
  	minHeight:=0; 		
  	maxWidth:=MAXWIDTH; 		
  	maxHeight:=MAXHEIGHT;		
  END; (*WITH*)
  SpareWindowP:=OpenWindow(nWindow);
  Assert(SpareWindowP<>NIL,ADR("konnte Hintergrund-Fenster nicht ffnen"));
 END MakeSpareWindow;


PROCEDURE InitBobs;
 BEGIN
  BinXPos[WARN]:=36;
  BinXPos[BATT]:=102;
  BinXPos[OELS]:=168;
  BinXPos[GURT]:=234;
  BinXPos[FLIT]:=399;
  BinXPos[BLIR]:=298;
  BinXPos[BLIL]:=298;
  BinXPos[HABR]:=465;
  BinXPos[HECK]:=531;
  BinYPos:=5;
  FOR i:=WARN TO HECK DO
    SymbActive[i]:=FALSE;
  END; 
  FOR i:=WARN TO HECK DO 
    MakeBob(	BinSymbP[i],BinVSP[i],Imgwidth,Imgheight,Imgdepth,
    		ImgPtr[i],7,0,BinXPos[i],BinYPos,BobFlagSet{},
                VSpriteFlagSet{saveBack,overlay},NIL,AWinDat[BINB].rp);
  END;
 END InitBobs;


PROCEDURE InitGear;
 BEGIN
  FOR i:=FAST TO PARK DO
    WITH GearSymb[i] DO
      leftEdge:=0;
      topEdge:=18;
      width:=Gearwidth;
      height:=Gearheight;
      depth:=Geardepth;
      imageData:=GearPtr[i];
      planePick:=011;
      planeOnOff:=0;
      nextImage:=NIL;
    END;
  END;
  DrawImage(rp,ADR(GearSymb[PARK]),0,0);
  LastGear:=-1;
 END InitGear;


PROCEDURE SetGear(Curr:INTEGER);
 BEGIN
  IF Curr<>LastGear THEN
    DrawImage(rp,ADR(GearSymb[Curr]),0,0);
    LastGear:=Curr;
  END;
 END SetGear;


PROCEDURE RedrawGear;
 BEGIN
    DrawImage(rp,ADR(GearSymb[LastGear]),0,0);
 END RedrawGear;


PROCEDURE CheckSymbol(Curr:INTEGER; On:BOOLEAN);
 BEGIN
  IF (SymbActive[Curr]=FALSE) AND On THEN
    AddBob(BinSymbP[Curr],AWinDat[BINB].rp);
    SortGList(AWinDat[BINB].rp);
    WaitTOF;
    DrawGList(AWinDat[BINB].rp,vp);
    SymbActive[Curr]:=TRUE;
  ELSIF (SymbActive[Curr]=TRUE) AND NOT On THEN
    RemBob(BinSymbP[Curr]);
    SortGList(AWinDat[BINB].rp);
    WaitTOF;
    DrawGList(AWinDat[BINB].rp,vp);
    SymbActive[Curr]:=FALSE;
  END;
 END CheckSymbol;


BEGIN	(* MAIN *)
 TermProcedure(CleanUp);
 ScreenToBack(ScreenP);
 
 Prepare(BINB);
 Prepare(ANUMB);
 Prepare(TACHOT);
 Prepare(TACHOE);
 Prepare(TANK);
 Prepare(TEMPH);
 Prepare(TEMPL);
 Prepare(ECO1);
 Prepare(ECO2);
 MakeSpareWindow;
 MakeWindow;
 
 InitBobs;
 InitGear;
 
 END BinaerAnz.

