(*********************************************************************
 
    :Program.  	Checker.mod
    :Author.   	Pit Burkhardt  
    :Address.   Stettinerstrae 25 D-7030 Bblingen
    :shortcut. 	[pit]
    :Version.  	1.0   
    :Date.     	July 1988
    :Copyright. PD
    :Language. 	Modula-II
    :Translator.M2Amiga
    :Imports.	ReadDat
    		BinaerAnz
                DragNum
                Grafiken
                GearCode
                BinCode
    :UpDate.	none
    :Contents.	This is the MAIN-MODULE, indicating situations and 
    		managing information-display.
    :Remark.	Studienarbeit 
    		Im Kernfach TECHNISCHES DESIGN
                an der Universitt Stuttgart	 
    
**********************************************************************)

MODULE Checker;

FROM Arts IMPORT	BreakPoint,Assert;

FROM SYSTEM IMPORT	ADR;

FROM Intuition IMPORT	ScreenToFront,ScreenToBack;

FROM ReadDat IMPORT	Speed,
			Verb,Sprit,Temp,SSt,BinSum,Blink,
			ALicht,FLicht,HeckSH,HandBr,GurtKl,Oelstd,Batter,
                	WarnBl,BlinkR,BlinkL,Ende,ReadAll,OpenDat,km;

FROM Grafiken IMPORT	MAXWIDTH,MAXHEIGHT,MINWIDTH,MINHEIGHT,
			TEMPL,TEMPH,TANK,ECO1,ECO2,BINB,ANUMB,TACHOE,TACHOT,
                        LASTWINDOW,
                        MakeTag,ShowWindow,HideWindow,PlaceWindow,ReturnWindow,
                        Display,WriteAlpha,WriteNumber,ScrRpP,ScreenP,AWinDat,
                        vp,Prepare;
                        
FROM GearCode IMPORT   	FAST,SLOW,BACK,NEUT,PARK,Gearwidth,Gearheight,
			Geardepth,GearPtr;


FROM DragNum IMPORT	ELEMENTSX,ELEMENTSY,FIRSTSIZE,LASTSIZE,
			PrepareNumber(*	RastP		:RastPortPtr;
					ANumWidth,
                                        ANumHeight,
                                        AlinkerRand	:ARRAY OF INTEGER;
					PlaneWidth,
                                        PlaneHeight	:INTEGER*),
			SetNumSize(*Size:INTEGER*),
			ShowSpeed(*Speed:INTEGER*),
			SetNumPrefs(*AP,BP,OP:INTEGER*);

FROM BinaerAnz IMPORT	RedrawGear,
			SetGear(*Curr:INTEGER*),
			CheckSymbol(*Curr:INTEGER; On:BOOLEAN*),
 			KLEIN,BREIT,HOCH,GROSS;
                        
FROM BinCode IMPORT	WARN,BATT,OELS,GURT,FLIT,HABR,HECK,BLIL,BLIR,
			Imgwidth,Imgheight,Imgdepth,ImgPtr;
                        
FROM InOut IMPORT	WriteString,WriteLn,ReadString,CloseInput;


TYPE	MsgType=RECORD
		Text1:ARRAY [0..79] OF CHAR;
                Count1:INTEGER;
                alpha:BOOLEAN;			(* Anzeigertyp *)
                Text2:ARRAY [0..15] OF CHAR;
                Count2:INTEGER;
        END;

CONST	TEMPHMAX=120; 
	TEMPHMIN=90; 
        TEMPLMAX=60;
        DELTATEMPHMAX=TEMPHMAX-TEMPHMIN;
	SPRITMAX=40;
        SPRITMIN=5; 
        VERBMAX=20;
        REICHWMIN=50;
        
        (* Fahrsituationen *)
        
        STAND=1;
        STADT=2;
        LAND=4;
        AUTOB=8;
        
        (* Warnsituationen *)
        
        TEMPLOW=16;
        TEMPHIGH=32;
        TEMPFATAL=64;
        SPRITKNAPP=128;
        
        INFORMATION=256;
        
        (* Nachrichten / Messages an den KFZ-Lenker *)
        
        NOMESSAGE=0;
        ANSCHNALLEN=1;
        HANDBREMSE=2;
        OELNACHF=3;
        MOTORABK=4;
        REICHW=5;
        INFORM=6;
        DELTAVERB=7;
        TANKINHALT=8;
        
        LASTMESSAGE=8;
        
        (* Farben *)
        
        APNORM=2;
        APALARM=7;
        OP=1;
        BP=0;
        
        
        

VAR		Msg		:ARRAY [0..LASTMESSAGE] OF MsgType;
		Eing		:ARRAY [0..79] OF CHAR;
		i		:INTEGER;
                AnyMessages,
                NoErr		:LONGINT;
                LastMessage,
                Message,
                Situation	:INTEGER;
                DVerb,
                LastDVerb,
                Reichw,
                LastReichw,
                Tageskm,
                LastTageskm,
                Lastkm,
                Anfangskm,
                AnfangsSprit,
                SpritVerb,
                LastSprit,
                LastSpeed	:INTEGER;
                LastRDisplayed	:BOOLEAN;


PROCEDURE ButtonPressed():BOOLEAN;
 VAR Ciapra [0BFE001H]	:SET OF (s0,s1,s2,s3,s4,s5,lmb);
 BEGIN			(* Hardwareabfrage, ob linke Maustaste gedrckt ist *)
  IF lmb IN Ciapra THEN
    RETURN FALSE
  ELSE
    RETURN TRUE
  END;
 END ButtonPressed;



PROCEDURE InitMessages;
 BEGIN
   
   (*  $=  %=  &=   (=  )=  *=  #=PB  *)
   
   WITH Msg[ANSCHNALLEN] DO
     Text1 :="Bitte legen Sie den Sicherheitsgurt an";
     Count1:=38;
     alpha :=TRUE;
     Text2 :="";
     Count2:=0;
   END;
   WITH Msg[HANDBREMSE] DO
     Text1 :="Bitte l)sen Sie die Handbremse";
     Count1:=30;
     alpha :=TRUE;
     Text2 :="";
     Count2:=0;
   END;
   WITH Msg[OELNACHF] DO
     Text1 :="Bitte f*llen Sie Motor)l nach";
     Count1:=29;
     alpha :=TRUE;
     Text2 :="";
     Count2:=0;
   END;
   WITH Msg[MOTORABK] DO
     Text1 :="Motor*berhitzung! Bitte halten Sie an";
     Count1:=37;
     alpha :=TRUE;
     Text2 :="";
     Count2:=0;
   END;
   WITH Msg[REICHW] DO
     Text1 :="Die voraussichtliche Reichweite betr(gt ";
     Count1:=40;
     alpha :=FALSE;
     Text2 :=" km";
     Count2:=3;
   END;
   WITH Msg[INFORM] DO
     Text1 :="     >>>>>>>>>>> Information <<<<<<<<<<<";
     Count1:=41;
     alpha :=TRUE;
     Text2 :="";
     Count2:=0;
   END;
   WITH Msg[DELTAVERB] DO
     Text1 :="Ihr letzter Durchschnittsverbrauch betr(gt ";
     Count1:=43;
     alpha :=FALSE;
     Text2 :=" l/100km";
     Count2:=8;
   END;
   WITH Msg[TANKINHALT] DO
     Text1 :="Tankinhalt ";
     Count1:=11;
     alpha :=FALSE;
     Text2 :=" Liter";
     Count2:=6;
   END;
   LastMessage:=NOMESSAGE;
   Message:=NOMESSAGE;
 END InitMessages;


PROCEDURE DisplayMessages;
 BEGIN
  IF Message<>NOMESSAGE THEN
    ShowWindow(ANUMB);
    WITH Msg[Message] DO
      IF alpha THEN
        IF Message<>LastMessage THEN
          WriteAlpha(ANUMB,Text1,Count1);
          LastMessage:=Message;
        END;
      ELSE
        CASE Message OF
          REICHW    :IF Reichw<>LastReichw THEN
                       WriteNumber(ANUMB,Text1,Reichw,Text2,Count1,Count2); 
                       LastReichw:=Reichw;
                     ELSIF LastMessage<>REICHW THEN 
                       WriteNumber(ANUMB,Text1,LastReichw,Text2,Count1,Count2); 
                     END;|
          DELTAVERB :IF (DVerb<>LastDVerb) OR (LastMessage<>DELTAVERB) THEN
          	      IF DVerb<>0 THEN
                       WriteNumber(ANUMB,Text1,DVerb,Text2,Count1,Count2); 
                       LastDVerb:=DVerb;
                      ELSIF LastMessage<>DELTAVERB THEN 
                       WriteNumber(ANUMB,Text1,LastDVerb,Text2,Count1,Count2); 
                      END;
                     END;|
          TANKINHALT:IF (Sprit<>LastSprit) OR (LastMessage<>TANKINHALT) THEN
                       WriteNumber(ANUMB,Text1,Sprit,Text2,Count1,Count2); 
                       LastSprit:=Sprit;
                     END;|
          ELSE	;
        END;
        LastMessage:=Message;
      END;
    END;
  ELSE
    HideWindow(ANUMB);
  END;
 END DisplayMessages;


PROCEDURE AnalyseSituation;
 BEGIN
  IF Tageskm>0 THEN
     DVerb:=100*SpritVerb DIV Tageskm;
  END;						     
  IF Verb>15 THEN 
     Reichw:=10 * ((10*Sprit) DIV 15);	(* Ein hherer Durchschnittsverbrauch *)
  ELSIF Verb>0 THEN 			(* wre unrealistisch		      *)
     Reichw:=10 * ((10*Sprit) DIV Verb);
  ELSE
     Reichw:=LastReichw;
  END;						      
  Message:=NOMESSAGE;
  Situation:=0;
  
  (* Geschwindigkeit *)
  
  CASE Speed OF
  	0       : IF SSt=PARK THEN 
        	    Situation:=STAND;
                    LastSpeed:=Speed;
                    IF    Oelstd THEN   Message:=OELNACHF;
                    ELSIF (Sprit>20) AND (SpritVerb>2) THEN 
                      			Message:=DELTAVERB;
                    ELSIF Sprit<10 THEN	Message:=TANKINHALT;
                    END;
                  ELSE 
                    Situation:=STADT;
                    LastSpeed:=Speed;
                  END;
                  SetNumPrefs(APNORM,BP,OP);			|
        
        1..50   : Situation:=STADT;
        	  LastSpeed:=Speed;
                  SetNumPrefs(APNORM,BP,OP);
                  IF    GurtKl THEN 	Message:=ANSCHNALLEN;
                  ELSIF HandBr THEN	Message:=HANDBREMSE
                  END;						|
        
        51..60 : IF Speed>LastSpeed THEN
        	    Situation:=STADT;				
                    SetNumPrefs(APALARM,BP,APALARM);
                 ELSE
        	    Situation:=LAND;				
                    SetNumPrefs(APNORM,BP,OP);
                 END;
                 IF HandBr THEN	Message:=HANDBREMSE END;|
        
        61..100 : Situation:=LAND;
        	  LastSpeed:=Speed;				
                  SetNumPrefs(APNORM,BP,OP);
                  IF HandBr THEN	Message:=HANDBREMSE END;|
        	
        101..110: IF Speed>LastSpeed THEN
        	    Situation:=LAND;				
                    SetNumPrefs(APALARM,BP,APALARM);
                  ELSE
        	    Situation:=AUTOB;				
                    SetNumPrefs(APNORM,BP,OP);
                  END;
                  IF HandBr THEN	Message:=HANDBREMSE END;|
        
        ELSE      Situation:=AUTOB;
        	  LastSpeed:=Speed;
                  SetNumPrefs(APNORM,BP,OP);
                  IF HandBr THEN	Message:=HANDBREMSE END;
  END;
  
  (* TankInhalt *)
  
  CASE Sprit OF
  	0..SPRITMIN	: Situation:=Situation+SPRITKNAPP;
        		  Message:=REICHW ;			|
        ELSE 		  (* Ausreichend Benzin *);
  END;
  
  (* Temperatur *)
  
  IF Temp<TEMPLMAX THEN 
     Situation:=Situation+TEMPLOW;	 
  ELSIF (Temp>TEMPHMIN) AND (Temp<TEMPHMAX) THEN
     Situation:=Situation+TEMPHIGH; 	
  ELSIF (Temp>TEMPHMAX) THEN
     Situation:=Situation+TEMPFATAL;
     Message:=MOTORABK;
  END;
 
  (* Informationstaste gedrckt *)
  
  IF ButtonPressed() THEN 
    Situation:=INFORMATION;
    IF Message=NOMESSAGE THEN Message:=INFORM END;
  END; 
 
 END AnalyseSituation;


PROCEDURE FollowSituation;
 BEGIN
    IF Situation=1 THEN	(* Stand, keine Warnsituation *)
    	SetNumSize(GROSS);
        HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	ShowWindow(TACHOT);			 
    ELSIF Situation=2 THEN	(* Stadtverkehr, keine Warnsituation *)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	HideWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=4 THEN	(* Landstrae, keine Warnsituation *)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	ShowWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=8 THEN	(* Autobahn, keine Warnsituation *)
    	SetNumSize(HOCH);
    	HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	ShowWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=17 THEN	(* Stand, Temperatur niedrig *)
    	SetNumSize(GROSS);
        HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	ShowWindow(TACHOT);			 
    ELSIF Situation=18 THEN	(* Stadtverkehr, Temperatur niedrig  *)
    	SetNumSize(GROSS);
    	ShowWindow(TEMPL);
    	HideWindow(TEMPH);
    	HideWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=20 THEN	(* Landstrae, Temperatur niedrig  *)
    	SetNumSize(GROSS);
    	ShowWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=24 THEN	(* Autobahn, Temperatur niedrig  *)
    	SetNumSize(HOCH);
    	ShowWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	ShowWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=33 THEN	(* Stand, Temperatur hoch *)
    	SetNumSize(GROSS);
        HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=34 THEN	(* Stadtverkehr, Temperatur hoch  *)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	HideWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=36 THEN	(* Landstrae, Temperatur hoch  *)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=40 THEN	(* Autobahn, Temperatur hoch  *)
    	SetNumSize(HOCH);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	ShowWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=65 THEN	(* Stand, Temperatur wesentlich zu hoch *)
    	SetNumSize(KLEIN);
        HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=66 THEN	(* Stadtverkehr, Temperatur wesentlich zu hoch*)
    	SetNumSize(KLEIN);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	HideWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=68 THEN	(* Landstrae, Temperatur wesentlich zu hoch  *)
    	SetNumSize(KLEIN);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=72 THEN	(* Autobahn, Temperatur wesentlich zu hoch  *)
    	SetNumSize(KLEIN);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=129 THEN(* Stand, Tankinhalt knapp *)
    	SetNumSize(GROSS);
        HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	ShowWindow(TACHOT);			 
    ELSIF Situation=130 THEN(* Stadtverkehr, Tankinhalt knapp *)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=132 THEN(* Landstrae, Tankinhalt knapp *)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	ShowWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=136 THEN(* Autobahn, Tankinhalt knapp *)
    	SetNumSize(HOCH);
    	HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	ShowWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=145 THEN(* Stand, Tankinhalt knapp, Temperatur niedrig *)
    	SetNumSize(GROSS);
        HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	ShowWindow(TACHOT);			 
    ELSIF Situation=146 THEN(* Stadtverkehr, Tankinhalt, Temperatur niedrig  *)
    	SetNumSize(GROSS);
    	ShowWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=148 THEN(* Landstrae, Tankinhalt, Temperatur niedrig  *)
    	SetNumSize(GROSS);
    	ShowWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=152 THEN(* Autobahn, Tankinhalt knapp, Temperatur niedrig *)
    	SetNumSize(HOCH);
    	ShowWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	ShowWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=161 THEN(* Stand, Tankinhalt knapp, Temperatur hoch *)
    	SetNumSize(GROSS);
        HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=162 THEN(* Stadtverkehr, Tankinhalt knapp, Temperatur hoch*)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=164 THEN(* Landstrae, Tankinhalt knapp, Temperatur hoch  *)
    	SetNumSize(GROSS);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=168 THEN(* Autobahn, Tankinhalt knapp, Temperatur hoch  *)
    	SetNumSize(HOCH);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=193 THEN(* Stand, Tankinhalt, Temperatur zu hoch *)
    	SetNumSize(KLEIN);
        HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=194 THEN(* Stadtverkehr, Tankinhalt, Temperatur zu hoch  *)
    	SetNumSize(KLEIN);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=196 THEN(* Landstrae, Tankinhalt, Temperatur zu hoch  *)
    	SetNumSize(KLEIN);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=200 THEN(* Autobahn, Tankinhalt knapp, Temperatur wesentlich zu hoch  *)
    	SetNumSize(KLEIN);
    	HideWindow(TEMPL);
    	ShowWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	HideWindow(TACHOE);
    	HideWindow(TACHOT);			 
    ELSIF Situation=INFORMATION THEN(* Informationstaste gedrckt *)
    	SetNumSize(BREIT);
    	HideWindow(TEMPL);
    	HideWindow(TEMPH);
    	ShowWindow(TANK);
    	HideWindow(ECO1);
    	HideWindow(ECO2);
    	ShowWindow(TACHOE);
    	ShowWindow(TACHOT);			 
  ELSE	BreakPoint(ADR("Keine Fahrsituation gefunden"));
  END;
 END FollowSituation;


PROCEDURE CheckThemAll;
 BEGIN
  MakeTag(NOT ALicht AND NOT FLicht);
  SetGear(SSt);
  CheckSymbol(WARN,WarnBl);
  CheckSymbol(BATT,Batter);
  CheckSymbol(OELS,Oelstd);
  CheckSymbol(FLIT,FLicht);
  CheckSymbol(GURT,GurtKl);
  CheckSymbol(HABR,HandBr);
  CheckSymbol(HECK,HeckSH);
  CheckSymbol(BLIL,BlinkL);
  CheckSymbol(BLIR,BlinkR);
  IF (BinSum<=1) AND (Blink=0) THEN	(* Anzeigerbalken nur einblenden,   *)
    HideWindow(BINB);			(* wenn irgendwelche Binaeranzeiger *)
  ELSE					(* aktiv sind			    *)
    ShowWindow(BINB);
  END;		
 END CheckThemAll;


PROCEDURE DisplayThemAll;
 BEGIN
   ShowSpeed(Speed);
   Display(TEMPL,Temp,TEMPLMAX);
   Display(TEMPH,Temp-TEMPHMIN,DELTATEMPHMAX);
   Display(TANK,Sprit,SPRITMAX);
   Display(ECO1,Verb,VERBMAX);
   Display(ECO2,Verb,VERBMAX);
   IF km>Lastkm THEN
     WriteNumber(TACHOT,"",km,"",0,0);
     Lastkm:=km;
   END;
   SpritVerb:=AnfangsSprit -Sprit;
   Tageskm:=km-Anfangskm;
   IF Tageskm>LastTageskm THEN
     WriteNumber(TACHOE,"",Tageskm,"",0,0);
     LastTageskm:=Tageskm;
   END;
 END DisplayThemAll;


PROCEDURE Process;
 BEGIN
      ReadAll;
      IF NOT Ende THEN
        AnalyseSituation;
        FollowSituation;
        DisplayThemAll;
        CheckThemAll;
        DisplayMessages;
      END;
 END Process;


PROCEDURE SaveStartDat;
 BEGIN
  Anfangskm:=km-123;
  AnfangsSprit:=Sprit;
  LastSprit:=Sprit;
  LastDVerb:=6;
  DVerb:=6;
  LastReichw:=10*((10 * Sprit) DIV 6);
  Lastkm:=-1;
  LastTageskm:=-1;
 END SaveStartDat;


PROCEDURE MainLoop;
 BEGIN
  Eing:="J";
  REPEAT 
    OpenDat;
    Process;
    SaveStartDat;
    ScreenToFront(ScreenP);
    REPEAT
      Process;
    UNTIL Ende;
    ScreenToBack(ScreenP);
    CloseInput;
    WriteLn;
    WriteLn;
    WriteString("   Neue Eingabedatei ffnen?     (J/N) "); 
    FOR i:=0 TO 8000 DO END;		(* letzte Eingabe abpuffern *) 
    ReadString(Eing);
    FOR i:=0 TO 2000 DO END;		(* letzte Eingabe abpuffern *) 
  UNTIL (Eing[0]="N") OR (Eing[0]="n");  
 END MainLoop;

BEGIN
 InitMessages;
 WriteString("...fertig!");
 WriteLn;
 WriteLn;
 
 MainLoop;				   
 ScreenToBack(ScreenP);                                       
 
 END Checker.
