(*********************************************************************
 
    :Program.  	DragNum.mod
    :Author.   	Pit Burkhardt  
    :Address.   Stettinerstrae 25 D-7030 Bblingen
    :shortcut. 	[pit]
    :Version.  	1.1b   
    :Date.     	some fine Day in July 1988
    :Copyright. PD
    :Language. 	Modula-II
    :Translator.M2Amiga
    :Imports.	none 
    :UpDate.	none
    :Contents.	Creates 7-segment-like Numbers of variable size.
    :Remark.	Studienarbeit 
    		Im Kernfach TECHNISCHES DESIGN
                an der Universitt Stuttgart
                
                This MODULE is slightly different from the one that was
                issued in some AMOK-Disk before.	 
    
**********************************************************************)

IMPLEMENTATION MODULE DragNum;

FROM SYSTEM IMPORT	ADDRESS, ADR;

FROM Graphics IMPORT	AreaDraw, InitArea, AreaEnd, AreaInfo, AreaMove; 

FROM Arts IMPORT	Assert, BreakPoint, TermProcedure;

FROM Intuition IMPORT	WindowPtr;

FROM Graphics IMPORT	RastPortPtr, RectFill, SetAPen, SetRast, InitTmpRas,
			AllocRaster, TmpRas, FreeRaster;


FROM GfxMacros IMPORT	SetOPen;

CONST	POINTS=60;	(*maximale Anzahl an Punkten, die eine Area begrenzen*) 
        		(*knnen					     *)

(*--------------------------Externe Konstante
CONST   ELEMENTSX=42;
        ELEMENTSY=22;
        FIRSTSIZE=0; LASTSIZE=5;
---------------------------*)
                                 

VAR	rp		:RastPortPtr;
 	trp		:ADDRESS;
 	AInfo		:AreaInfo;
 	tr		:TmpRas;
 	ABuffer		:ARRAY [0..POINTS*5] OF CARDINAL;
	
        (* Variable zur Ziffernberechnung *)
        
        SegPtX		:ARRAY [0..5] OF ARRAY [0..7] OF ARRAY [0..2] 
        (*		      SegmentEck......SegmentNr.........Potenz	*) 
        		OF ARRAY [FIRSTSIZE..LASTSIZE] OF INTEGER;
        SegPtY		:ARRAY [0..5] OF ARRAY [0..7] 
        (*		      SegmentEck......SegmentNr			*) 
        			OF ARRAY [FIRSTSIZE..LASTSIZE] 
			OF INTEGER;
        ZiffLageX,
        ZiffLageY,
        ZiffBr,
        ZiffH0,
        ZiffH1,
        ZiffZwRX,
        ZiffEinhX,
        ZiffEinhY,
        XVersatz	:INTEGER;
        Zahl		:INTEGER;
        ZifferAlt	:ARRAY [0..2] OF INTEGER;
        Neuerort	:BOOLEAN;
        Segment		:INTEGER;
        MaxWidth,
        MaxHeight	:INTEGER;	
        Wert,
        WertAlt,		
        i		:INTEGER;
        error		:LONGINT;
        Shift,
        LastShift	:INTEGER;
        
        (* Prefs	*)
        
        APen,BPen,OPen,
        
        LastAPen	:INTEGER;


PROCEDURE CleanUp;
 BEGIN
  IF trp<>NIL THEN 
    FreeRaster(trp,MaxWidth, MaxHeight);
  ELSE
    BreakPoint(ADR("DragNum:TempRaster nicht freigegeben"));
  END;
 END CleanUp;


PROCEDURE ZeichneSegment(Segment,Potenz:INTEGER);
 VAR	p	:INTEGER;
 BEGIN
  SetOPen(rp,OPen);
  SetAPen(rp,APen);
  error:=AreaMove(rp,SegPtX[0,Segment,Potenz,Shift],SegPtY[0,Segment,Shift]);   
  FOR p:=1 TO 5 DO
   error:=AreaDraw(rp,SegPtX[p,Segment,Potenz,Shift],SegPtY[p,Segment,Shift]);
  END;
 END ZeichneSegment;   


PROCEDURE ZeichneZiffer(Ziffer,Potenz:INTEGER);
 BEGIN
  IF (NOT Neuerort) THEN		(* Alte Ziffer lschen *)
    SetOPen(rp,BPen);
    SetAPen(rp,BPen);
    RectFill(rp,SegPtX[2,4,Potenz,Shift],SegPtY[5,0,Shift],
    		SegPtX[5,2,Potenz,Shift],SegPtY[1,6,Shift]);
  END;
  CASE Ziffer OF
  	0:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	1:ZeichneSegment(2,Potenz);
  	  ZeichneSegment(5,Potenz);|
        2:ZeichneSegment(0,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(6,Potenz);|
 	3:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	4:ZeichneSegment(1,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);|
  	5:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	6:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	7:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(2,Potenz);
          ZeichneSegment(5,Potenz);|
  	8:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(4,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
  	9:ZeichneSegment(0,Potenz);
  	  ZeichneSegment(1,Potenz);
          ZeichneSegment(2,Potenz);
          ZeichneSegment(3,Potenz);
          ZeichneSegment(5,Potenz);
          ZeichneSegment(6,Potenz);|
        ELSE (* unsichtbare fhrende Nullen *) ;
  END; (*CASE Segment*)
  error:=AreaEnd(rp);
 END ZeichneZiffer;      


PROCEDURE BerechneSenkSeg(Zx,Zy,Seg,Pot,Current:INTEGER);
 BEGIN
  SegPtX[0,Seg,Pot,Current]:=Zx;   
  SegPtX[1,Seg,Pot,Current]:=SegPtX[0,Seg,Pot,Current]-ZiffEinhX;   
  SegPtX[2,Seg,Pot,Current]:=SegPtX[1,Seg,Pot,Current]-XVersatz;   
  SegPtX[3,Seg,Pot,Current]:=SegPtX[2,Seg,Pot,Current]+ZiffEinhX;   
  SegPtX[4,Seg,Pot,Current]:=SegPtX[3,Seg,Pot,Current]+ZiffEinhX;   
  SegPtX[5,Seg,Pot,Current]:=SegPtX[4,Seg,Pot,Current]+XVersatz;
  SegPtY[0,Seg,Current]:=Zy;
  SegPtY[1,Seg,Current]:=SegPtY[0,Seg,Current]+ZiffEinhY;
  SegPtY[3,Seg,Current]:=SegPtY[0,Seg,Current]+ZiffH1;
  SegPtY[2,Seg,Current]:=SegPtY[3,Seg,Current]-ZiffEinhY;
  SegPtY[4,Seg,Current]:=SegPtY[2,Seg,Current];
  SegPtY[5,Seg,Current]:=SegPtY[1,Seg,Current];
 END BerechneSenkSeg;  


PROCEDURE BerechneWaagSeg(Zx,Zy,Seg,Pot,Current:INTEGER);
 BEGIN
  SegPtX[0,Seg,Pot,Current]:=Zx;   
  SegPtX[1,Seg,Pot,Current]:=SegPtX[0,Seg,Pot,Current]+ZiffEinhX;   
  SegPtX[3,Seg,Pot,Current]:=SegPtX[0,Seg,Pot,Current]+ZiffBr;   
  SegPtX[2,Seg,Pot,Current]:=SegPtX[3,Seg,Pot,Current]-ZiffEinhX;   
  SegPtX[4,Seg,Pot,Current]:=SegPtX[2,Seg,Pot,Current];   
  SegPtX[5,Seg,Pot,Current]:=SegPtX[1,Seg,Pot,Current];
  SegPtY[0,Seg,Current]:=Zy;
  SegPtY[1,Seg,Current]:=SegPtY[0,Seg,Current]+ZiffEinhY;
  SegPtY[2,Seg,Current]:=SegPtY[1,Seg,Current];
  SegPtY[3,Seg,Current]:=SegPtY[0,Seg,Current];
  SegPtY[4,Seg,Current]:=SegPtY[0,Seg,Current]-ZiffEinhY;
  SegPtY[5,Seg,Current]:=SegPtY[4,Seg,Current];
 END BerechneWaagSeg;  
 

PROCEDURE BerechneEckPunkte(NumWidth,NumHeight,AliRand:ARRAY OF INTEGER);
 VAR	PosX,PosY,Pot,Current	:INTEGER;
 BEGIN
  FOR Current:=FIRSTSIZE TO LASTSIZE DO
   ZiffEinhX:=NumWidth[Current] DIV ELEMENTSX;
   ZiffEinhY:=NumHeight[Current] DIV ELEMENTSY;
   ZiffLageX:=AliRand[Current]+ZiffEinhX*41;		(* Rechts auen *)
   ZiffLageY:=ZiffEinhY;
   XVersatz:=ZiffEinhX;
   ZiffBr:=ZiffEinhX*10;
   ZiffH1:=ZiffEinhY*11;
   ZiffH0:=ZiffEinhY*21;;
   ZiffZwRX:=4*ZiffEinhX;
   FOR Pot:=0 TO 2 DO
     PosX:=ZiffLageX-Pot*(ZiffBr+ZiffZwRX)-ZiffBr;
     PosY:=ZiffLageY;
     BerechneWaagSeg(PosX,PosY,0,Pot,Current);
     BerechneSenkSeg(PosX,PosY,1,Pot,Current);
     BerechneSenkSeg(PosX+ZiffBr,PosY,2,Pot,Current);
     PosY:=PosY+ZiffH1;
     PosX:=PosX-ZiffEinhX;
     BerechneWaagSeg(PosX,PosY,3,Pot,Current);
     BerechneSenkSeg(PosX,PosY,4,Pot,Current);
     BerechneSenkSeg(PosX+ZiffBr,PosY,5,Pot,Current);
     PosY:=PosY+ZiffH1;
     PosX:=PosX-ZiffEinhX;
     BerechneWaagSeg(PosX,PosY,6,Pot,Current);
   END; (*FOR Pot*)
  END; (*FOR Current*)
 END BerechneEckPunkte;


PROCEDURE ExtractZiff(Wert:INTEGER);
 VAR	ErsteZiff,Ziffer,Ziffer0,Potenz,Potenz0		:INTEGER;
 BEGIN
  ErsteZiff:=0;
  IF Neuerort THEN 				(* ClearNumbers *)
    SetOPen(rp,0);
    SetAPen(rp,0);
    RectFill(rp,SegPtX[2,4,2,LastShift],SegPtY[5,0,LastShift],
    		SegPtX[5,2,0,LastShift],SegPtY[1,6,LastShift]);
    SetOPen(rp,BPen);
    SetAPen(rp,BPen);
    RectFill(rp,SegPtX[2,4,2,Shift],SegPtY[5,0,Shift],
    		SegPtX[5,2,0,Shift],SegPtY[1,6,Shift]);
  END;
  FOR Potenz:=2 TO 0 BY -1 DO
    Potenz0:=1;
    IF Potenz>0 THEN
    	FOR i:=0 TO Potenz-1 DO			(* --> Potenz0=10^Potenz *)
    		Potenz0:=Potenz0*10;
    	END; (*FOR i*)
    END; (*IF*)    
    Ziffer0:=Wert DIV Potenz0;
    Ziffer:=Ziffer0;
    IF (NOT Neuerort) THEN
      IF Ziffer<>ZifferAlt[Potenz] THEN 
        IF Ziffer>0 THEN
          ErsteZiff:=1;
          ZeichneZiffer(Ziffer,Potenz);                      
        ELSIF (Ziffer=0) AND (ErsteZiff=0) THEN
          Ziffer:=10;
          IF ZifferAlt[Potenz]<10 THEN ZeichneZiffer(Ziffer,Potenz) END;
        ELSIF (Ziffer=0) AND (ErsteZiff=1) THEN
          ZeichneZiffer(Ziffer,Potenz);
        END; (*IF*)
      ELSIF (Ziffer=0) AND (ZifferAlt[Potenz]=0) AND (ErsteZiff=0) THEN    
        Ziffer:=10;
        ZeichneZiffer(Ziffer,Potenz);                                    
      ELSIF (Ziffer=0) AND (ZifferAlt[Potenz]=10) AND (ErsteZiff=1) THEN  
        ZeichneZiffer(Ziffer,Potenz);
      ELSIF ZifferAlt[Potenz]>0 THEN
        IF  ZifferAlt[Potenz]<10 THEN ErsteZiff:=1 END;
        Ziffer:=ZifferAlt[Potenz];
      END; (*IF*)
    ELSE 
      IF (Ziffer>0) THEN
        ErsteZiff:=1;
        ZeichneZiffer(Ziffer,Potenz);
      ELSIF (Ziffer=0) AND (ErsteZiff=0) THEN
        Ziffer:=10;
        IF ZifferAlt[Potenz]<10 THEN ZeichneZiffer(Ziffer,Potenz) END;
      ELSIF (Ziffer=0) AND (ErsteZiff=1) THEN
        ZeichneZiffer(Ziffer,Potenz);
      END; (*IF*)
    END; (*IF*)
    Wert:=Wert-Ziffer0*Potenz0;
    ZifferAlt[Potenz]:=Ziffer;
  END; (*FOR*)
  Neuerort:=FALSE;
 END ExtractZiff;   


PROCEDURE SetNumSize(Size:INTEGER);
 BEGIN
  IF (Size>=FIRSTSIZE) AND (Size<=LASTSIZE) THEN Shift:=Size END;
 END SetNumSize;


PROCEDURE ShowSpeed(Speed:INTEGER);
 BEGIN
  IF (Speed<1000) AND (Speed>=0) THEN	(* unerlaubtes ignorieren	*)
     IF Shift=LastShift THEN		(* Zifferngre unverndert	*)
       IF WertAlt<>Speed THEN 		(* neuer Zahlenwert		*)  
         ExtractZiff(Speed);		(*        ..Ziffern extrahieren	*)
       END;
     ELSE				(* neue Zifferngre		*)
       Neuerort:=TRUE;
       ExtractZiff(Speed);		(*        ..Ziffern extrahieren	*)
     END;
     WertAlt:=Speed;
     LastShift:=Shift;
  END;
 END ShowSpeed; 


PROCEDURE SetNumPrefs(AP,BP,OP:INTEGER);
 BEGIN
  IF AP<>LastAPen THEN
    APen:=AP;
    BPen:=BP;
    OPen:=OP;
    Neuerort:=TRUE;
    LastAPen:=APen;
  END;
 END SetNumPrefs;  

PROCEDURE InitNum;
 BEGIN
  APen:=2;
  BPen:=0;
  OPen:=1;
  WertAlt:=-10;
  Shift:=FIRSTSIZE;
  LastShift:=Shift;
  LastAPen:=-1;
  Neuerort:=FALSE;
 END InitNum;


PROCEDURE PrepareNumber(RastP:RastPortPtr;
			ANumWidth,ANumHeight,AlinkerRand:ARRAY OF INTEGER;
			PlaneWidth,PlaneHeight:INTEGER);
 BEGIN
  
  (* konstante Werte initialisieren *)
  
  MaxWidth:=PlaneWidth;
  MaxHeight:=PlaneHeight;
  
  BerechneEckPunkte(ANumWidth,ANumHeight,AlinkerRand);
     
  (* RastPort feststellen *)
  
  rp:=RastP;	
  
  (* maximale Flche fr  Area-Funktionen festlegen, initialisieren	     *)
  
  InitArea(AInfo, ADR(ABuffer), SIZE(ABuffer) DIV 5);
  trp:=AllocRaster(MaxWidth, MaxHeight);	     
  Assert(trp<>NIL, ADR('DragNum:cannot alloc raster'));
  InitTmpRas(tr, trp, ((MaxWidth+15) DIV 16) * MaxHeight);
  rp^.areaInfo:=ADR(AInfo);
  rp^.tmpRas:=ADR(tr);
 END PrepareNumber;


BEGIN
 TermProcedure(CleanUp);
 InitNum;
END DragNum.
