 (*********************************************************************

    :Program.  	Grafiken.mod
    :Author.   	Pit Burkhardt  
    :Address.   Stettinerstrae 25 D-7030 Bblingen
    :shortcut. 	[pit]
    :Version.  	1.0   
    :Date.     	10.07.1988
    :Copyright. PD
    :Language. 	Modula-II
    :Translator.M2Amiga
    :Imports.	IFFload 
    :UpDate.	none
    :Contents.	Opens Super-Bitmapped Windows and fills them with
    		IFF-Brushes.
                PROCEDUREs for Window-moving, -hiding and -showing.
                PROCEDUREs for writing and drawing into Windowgraphics.
    :Remark.	Studienarbeit 
    		Im Kernfach TECHNISCHES DESIGN
                an der Universitt Stuttgart	 
    
**********************************************************************)

IMPLEMENTATION MODULE Grafiken;

FROM SYSTEM IMPORT 	ADDRESS,ADR;

FROM Arts IMPORT	Assert,TermProcedure,BreakPoint;

FROM GfxMacros IMPORT	RasSize;

FROM Intuition IMPORT	NewWindow, WindowPtr, OpenWindow, ScreenPtr, 
			CloseWindow,WindowFlags,WindowFlagSet, RemakeDisplay, 
                        Window,ScreenFlagSet,ScreenFlags,OpenScreen, 
                        NewScreen,customScreen,CloseScreen,
                        MoveWindow,SizeWindow,DisplayBeep,SetWindowTitles,
                        IDCMPFlagSet,IDCMPFlags,WindowToBack,WindowToFront;

FROM Exec IMPORT	FreeMem,UByte;

FROM RealConversions IMPORT	RealToStr;

FROM DiskFont IMPORT	OpenDiskFont;

FROM Graphics IMPORT	RastPortPtr,BitMap,FreeRaster,ViewPortPtr, ViewModeSet, 
                        ViewModes, TextAttr, FontStyleSet, FontFlagSet,
                        SetRGB4,BitMapPtr,FontFlags,FontStyles,TextFontPtr,
                        OpenFont,SetFont,CloseFont,
			RectFill, SetAPen, SetRast, InitTmpRas,
			AllocRaster, TmpRas, Move,Draw,SetDrMd,jam1,LoadRGB4,
                        Text,TextLength,AreaInfo, AreaInfoPtr, AreaMove,
                        AreaDraw, InitArea, AreaEnd,WaitTOF; 
                        
FROM IFFLoad IMPORT 	ReadILBM,ReadILBMFlags,ReadILBMFlagSet,NuScreen,IFFInfo,
       			IFFInfoType;

(* --------------------------------------Externe Typen	
        
TYPE	WinDatPtr=POINTER TO WinDatType;

        AnzFlags=(Trans,TransRev,rotator,num,alphanum,non);
        AnzFlagSet=SET OF AnzFlags;


TYPE	WinDatType=RECORD	(* Daten des Anzeiger-Windows		*)
	  AnzTyp:AnzFlagSet;	(* Anzeigertyp				*)
          FPen:UByte;		(* Farbe des Anzeige-Elements		*)
          x:INTEGER;		(* Koordinaten: Window-Ecke links oben	*)
          y:INTEGER;
          width:INTEGER;	(* Windowgre				*)
          height:INTEGER;
          rp:RastPortPtr;	(* Pointer auf RastPort			*)
          Ptr:WindowPtr;	(* Pointer auf Windowstruktur		*)
          Wx0L:INTEGER;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:INTEGER;
          Wy0:INTEGER;
          Wx1L:INTEGER;
          Wx1R:INTEGER;
          Wy1:INTEGER;
        END;

	WinAnzType=RECORD	(* Daten des Anzeige-Elements		  *)
          Typ:AnzFlagSet;	(* AnzeigerTyp				  *)
          Pen:UByte;		(* Farbe des Anzeige-Elements		*)
          x0:INTEGER;		(* Koordinaten Balken minimal links unten *)
          y0:INTEGER;
          x1:INTEGER;		(* Koordinaten Balken maximal links oben  *)
          y1:INTEGER;
          dx:INTEGER;		(* berstreichbarer Bereich in x-Richtung *)  
          dy:INTEGER;		(* berstreichbarer Bereich in y-Richtung *)
          Bx:INTEGER;		(* BalkenBreite (x-Ausdehnung)		  *)
        END;

--------------------------------------------------------------------------*)	
        
TYPE    Koord=RECORD
          x:INTEGER;
          y:INTEGER;
          xR:INTEGER;
        END;

(* externe Konstanten fr die Screen-Mae ---------------------------------

CONST	MAXWIDTH=640;
	MAXHEIGHT=210;
        DEPTH=3;
	MINWIDTH=0;
        MINHEIGHT=0;
        
        externe  Konstante fr die ARRAY-Kontrolle 
        
        TEMPL=0; TEMPH=1; TANK=2; ECO1=3; ECO2=4; BINB=5;
        ANUMB=6; TACHOE=7; TACHOT=8; 
        LASTWINDOW=8;
        MAXPOINTS=10;

---------------------------------------------------------------------------*)

TYPE	AreaPoints=ARRAY [0..MAXPOINTS*5] OF CARDINAL;
	AreaPointsPtr=POINTER TO AreaPoints;
        

(*----------------------Externe Variablen

VAR	vp		:ViewPortPtr;
        ScreenP		:ScreenPtr;
	ScrRpP		:RastPortPtr;
        AWinDat		:ARRAY [0..LASTWINDOW] OF WinDatType;
        AWinAnz		:ARRAY [0..LASTWINDOW] OF WinAnzType;       	
	AInfo		:ARRAY [0..LASTWINDOW] OF AreaInfo;
	
---------------------------------------------------------------------------*)
        
        
        (* Variablen fr Screen, Windowinitialisierung *)

VAR     nScreen		:NewScreen;
        nWindow		:NewWindow;   	 
        TAttr		:TextAttr;
        TextFontP	:TextFontPtr;
          
  	(* Variablen fr IFFload *)
  
  	MyScreenDummy	:ScreenPtr;        	
  	WindowDummy	:WindowPtr;     	
  	
        (* ARRAYs fr die Daten der einzelnen Anzeiger-Windows *)
        
        AWindowP	:ARRAY [0..LASTWINDOW] OF WindowPtr;
  	AIFFInfo	:ARRAY [0..LASTWINDOW] OF IFFInfoType;     	
  	ABitMapP	:ARRAY [0..LASTWINDOW] OF BitMapPtr;        	
  	AName		:ARRAY [0..LASTWINDOW] OF ARRAY [0..79] OF CHAR;  	
  	
        ABufferP	:ARRAY [0..LASTWINDOW] OF 
        			ARRAY [0..MAXPOINTS*5] OF CARDINAL;
 	ATmpBuffP	:ARRAY [0..LASTWINDOW] OF ADDRESS;
 	ATempR		:ARRAY [0..LASTWINDOW] OF TmpRas;
 	AltKo		:ARRAY [0..LASTWINDOW] OF Koord;
 	Ko		:ARRAY [0..LASTWINDOW] OF Koord;
        InFront		:ARRAY [0..LASTWINDOW] OF BOOLEAN;	
        TagColor,
        NachtColor	:ARRAY [0..7] OF CARDINAL;
        LichtAus	:BOOLEAN;
        
	(* Kontroll-Variablen *)
 	
        BaseLine	:INTEGER;
        NoErr		:LONGINT;
        i		:INTEGER;
        back		:LONGINT;



PROCEDURE Free(Curr:INTEGER); (* Window schlieen, Speicher freigeben *) 
 BEGIN
  IF AWinDat[Curr].Ptr<>NIL THEN 
    CloseWindow(AWinDat[Curr].Ptr); 		(* Window schlieen  *)
  END;
  IF ABitMapP[Curr]<>NIL THEN			(* planes freigeben  *)
    FOR i:=0 TO ABitMapP[Curr]^.depth-1 DO
      FreeRaster(	ABitMapP[Curr]^.planes[i],
        		AIFFInfo[Curr].BMHD.scrnWidth,
                        AIFFInfo[Curr].BMHD.scrnHeight	); 
    END;
    FreeMem(ABitMapP[Curr],SIZE(BitMap)); 	(* BitMap-Structur freigeben *)
  END; (*IF*)
  WITH AWinDat[Curr] DO
    IF (Trans IN AnzTyp) OR (TransRev IN AnzTyp) THEN
      IF ATmpBuffP[Curr]<>NIL THEN FreeRaster(ATmpBuffP[Curr],width,height) END; 
    END;
  END;
 END Free;
 
 

PROCEDURE CleanUp;	(* Wird bei Programmende aufgerufen *)
 BEGIN
  Free(TEMPL);
  Free(TEMPH);
  Free(TANK);
  Free(ECO1);
  Free(ECO2);
  Free(BINB);
  Free(ANUMB);
  Free(TACHOE);
  Free(TACHOT);
  IF TextFontP<>NIL THEN CloseFont(TextFontP) END;
  IF ScreenP<>NIL THEN CloseScreen(ScreenP) END;  (* Bye Bye... *)
 END CleanUp;



PROCEDURE MakeScreen;		(* initialisiert und ffnet den hires-Screen *)
  BEGIN
   WITH TAttr DO		(* Text-Font initialisiern... *)
   	name:=ADR("CheckerFont.font");
        ySize:=20;
        style:=FontStyleSet{};
        flags:=FontFlagSet{diskFont,proportional};
   END; (*WITH*)
   TextFontP:=OpenDiskFont(ADR(TAttr));
   Assert(TextFontP<>NIL,ADR("Font wurde nicht geffnet"));
   WITH nScreen DO		(* hires-Screen initialisieren... *)
  	leftEdge:=0;	
        topEdge:=0;
        width:=MAXWIDTH;	
        height:=MAXHEIGHT; 	
        depth:=DEPTH;
        detailPen:=0;	
        blockPen:=1;
        viewModes:=ViewModeSet{hires};
        type:=customScreen;		
        font:=ADR(TAttr);
        defaultTitle:=NIL;
        gadgets:=NIL;
        customBitMap:=NIL;
   END; (*WITH*)
   ScreenP:=OpenScreen(nScreen);	(* Screen ffnen *)
   Assert(ScreenP<>NIL,ADR("konnte den Screen nicht ffnen"));
   ScrRpP:=ADR(ScreenP^.rastPort);
   SetRast(ScrRpP,0);
   vp:=ADR(ScreenP^.viewPort);
   (* Colortable initialisieren	*)
   
   TagColor[0]:=0005H;
   TagColor[1]:=000BH;
   TagColor[2]:=000FH;
   TagColor[3]:=000DH;
   TagColor[4]:=0555H;
   TagColor[5]:=0777H;
   TagColor[6]:=0BBBH;
   TagColor[7]:=0F00H;

   NachtColor[0]:=0000H;
   NachtColor[1]:=000CH;
   NachtColor[2]:=000FH;
   NachtColor[3]:=000FH;
   NachtColor[4]:=0009H;
   NachtColor[5]:=0006H;
   NachtColor[6]:=0005H;
   NachtColor[7]:=0F00H;
  END MakeScreen;


PROCEDURE MakeTag(Tag:BOOLEAN);
 BEGIN
   IF Tag AND NOT LichtAus THEN
     WaitTOF;    
     LoadRGB4(vp,ADR(TagColor),8);
     LichtAus:=TRUE;
   ELSIF NOT Tag AND LichtAus THEN
     WaitTOF;    
     LoadRGB4(vp,ADR(NachtColor),8);
     LichtAus:=FALSE;
   END;
   RemakeDisplay;
 END MakeTag;


PROCEDURE Write(Curr:INTEGER;TextString:ARRAY OF CHAR;Count:INTEGER);
 BEGIN
     Text(AWinDat[Curr].rp,ADR(TextString),Count);
 END Write;  
    

PROCEDURE WriteAlpha(Curr:INTEGER;TextString:ARRAY OF CHAR;Count:INTEGER);
 BEGIN
  IF (alphanum IN AWinDat[Curr].AnzTyp) THEN
    WITH AWinAnz[Curr] DO
      SetAPen(AWinDat[Curr].rp,0);		(* Alten Text lschen *)
      RectFill(AWinDat[Curr].rp,x0,y1,x1,dy);
      SetAPen(AWinDat[Curr].rp,Pen);
      Move(AWinDat[Curr].rp,x0,y0);
      Write(Curr,TextString,Count)
    END;
  END;
 END WriteAlpha;

 
PROCEDURE WriteNumber(	Curr		:INTEGER;
			TextString1	:ARRAY OF CHAR;
			Num		:LONGINT;
                        TextString2	:ARRAY OF CHAR;
                        Count1,Count2	:INTEGER);
 
 VAR 			NumString	:ARRAY [0..3] OF CHAR;
 			NumCount	:INTEGER;
        		NoErr		:BOOLEAN;
        		RealNum		:REAL;
                        CardNum		:LONGCARD;
                        LastNum		:LONGINT;
 BEGIN
  WITH AWinAnz[Curr] DO
    SetAPen(AWinDat[Curr].rp,0);		(* Alten Text lschen *)
    RectFill(AWinDat[Curr].rp,x0,y1,x1,dy);
    SetAPen(AWinDat[Curr].rp,Pen);
    Move(AWinDat[Curr].rp,x0,y0);
    IF (alphanum IN AWinDat[Curr].AnzTyp) AND (Count1>0) THEN
      Write(Curr,TextString1,Count1)	
    END;
    IF (alphanum IN AWinDat[Curr].AnzTyp) OR (num IN AWinDat[Curr].AnzTyp) THEN
      IF    Num>=1000000 THEN NumCount:=7;
      ELSIF Num>=100000  THEN NumCount:=6;
      ELSIF Num>=10000 	 THEN NumCount:=5;
      ELSIF Num>=1000 	 THEN NumCount:=4; 
      ELSIF Num>=100 	 THEN NumCount:=3;
      ELSIF Num>=10 	 THEN NumCount:=2;
      ELSIF Num>=1 	 THEN NumCount:=1
      ELSE NumCount:=0; 
      END;
      CardNum:=Num;
      RealNum:=FLOAT(CardNum);
      RealToStr(RealNum,NumString,-NumCount,0,FALSE,NoErr);
      IF (alphanum IN AWinDat[Curr].AnzTyp) OR (Num<>LastNum) THEN
        Write(Curr,NumString,NumCount)
      END;
    END;
    IF (alphanum IN AWinDat[Curr].AnzTyp) AND (Count2>0) THEN
      Write(Curr,TextString2,Count2)	
    END;
    LastNum:=Num;
  END;
 END WriteNumber;
 
 
PROCEDURE MakeWindow(Curr:INTEGER);	(* initialisiert und ffnet Window *)
 BEGIN
 IF ReadILBM(	AName[Curr],ReadILBMFlagSet{front,visible,dontopen},
 		MyScreenDummy,WindowDummy) THEN	(* IFF-Datei einlesen 	*)
    AIFFInfo[Curr] := IFFInfo;			(* Infos sichern 	*)
    ABitMapP[Curr] := NuScreen.customBitMap;	(* BitMapPointer sichern*)
    WITH nWindow DO				(* Window initialisieren*)
  	leftEdge:=AWinDat[Curr].x;	
        topEdge:=AWinDat[Curr].y;
  	width:=AWinDat[Curr].width; 	
        height:=AWinDat[Curr].height;
  	detailPen:=0; 
  	blockPen:=1;
  	idcmpFlags:=IDCMPFlagSet{};  
  	flags:=WindowFlagSet{	gimmeZeroZero,
        			borderless,superBitMap		};
  	title:=NIL;
  	type:=customScreen;
  	firstGadget:=NIL; 
  	checkMark:=NIL; 
  	screen:=ScreenP; 
  	bitMap:=ABitMapP[Curr];   
  	minWidth:=MINWIDTH;     	
  	minHeight:=MINHEIGHT; 		
  	maxWidth:=MAXWIDTH; 		
  	maxHeight:=MAXHEIGHT;		
    END; (*WITH*)
    AWinDat[Curr].Ptr:=OpenWindow(nWindow);	(* Window ffnen... 	*)
    Assert(AWinDat[Curr].Ptr<>NIL,ADR("Konnte Anzeiger nicht ffnen"));	
    AWinDat[Curr].rp:=AWinDat[Curr].Ptr^.rPort;	(* RastPortPointer sichern *)
    Assert(AWinDat[Curr].rp<>NIL,ADR("Rastport=NIL!"));	
    SetFont(AWinDat[Curr].rp,TextFontP);
    BaseLine:=AWinDat[Curr].rp^.txBaseline;
    ELSE					(* Fehler beim IFF-Laden ? *)
      BreakPoint(ADR("Fehler beim IFF-Laden aufgetreten"));
    END;
 END MakeWindow;


PROCEDURE ShowWindow(Curr:INTEGER);	(* Zeigt das Anzeiger-Window *)
 BEGIN
   WITH AWinDat[Curr] DO
     IF NOT InFront[Curr] THEN WindowToFront(Ptr) END;	
     InFront[Curr]:=TRUE;
   END;  
 END ShowWindow;


PROCEDURE HideWindow(Curr:INTEGER);	(* Versteckt das Anzeiger-Window *)
 BEGIN
   WITH AWinDat[Curr] DO	
     IF InFront[Curr] THEN WindowToBack(Ptr) END;
     InFront[Curr]:=FALSE;
   END;  
 END HideWindow;


PROCEDURE PlaceWindow(Curr,XPos,YPos:INTEGER);
 VAR dx,dy:INTEGER;	(* Setzt Anzeiger-Window auf absolute Koordinaten *)
 BEGIN
   WITH AWinDat[Curr].Ptr^ DO
     IF (XPos+AWinDat[Curr].width<=MAXWIDTH) AND (XPos>=0) THEN
       dx:=XPos-leftEdge;
     ELSE
       dx:=0;
     END;
     IF (YPos+AWinDat[Curr].height<=MAXHEIGHT) AND (YPos>=0) THEN
       dy:=YPos-topEdge;
     ELSE
       dy:=0;
     END;
     MoveWindow(AWinDat[Curr].Ptr,dx,dy);
   END;
 END PlaceWindow;


PROCEDURE ReturnWindow(Curr:INTEGER);	(* Setzt Anzeiger-Window auf den... *)
 VAR dx,dy:INTEGER;			(* ursprnglichen Platz zurck	    *)
 BEGIN
   WITH AWinDat[Curr].Ptr^ DO
     dx:=AWinDat[Curr].x-leftEdge;
     dy:=AWinDat[Curr].y-topEdge;
     MoveWindow(AWinDat[Curr].Ptr,dx,dy);
   END;
 END ReturnWindow;



PROCEDURE Display(Curr,Value,MaxVal:INTEGER);
 VAR Faktor	:INTEGER;
 BEGIN
  IF (MaxVal>=Value) AND (Value>=0) THEN
   WITH AWinAnz[Curr] DO
     Faktor:=(dx*Value DIV MaxVal);
     Ko[Curr].x:=x0+Faktor;		(* Neue Koordinaten errechnen *)
     Ko[Curr].y:=y0-Faktor;
     Ko[Curr].xR:=Ko[Curr].x+Bx;
     IF Trans IN Typ THEN 	(* Translatorischer Analog-Anzeiger *)
       IF AltKo[Curr].x < Ko[Curr].x THEN		
     	  SetAPen(AWinDat[Curr].rp,Pen);
       ELSIF AltKo[Curr].x > Ko[Curr].x THEN          
     	  SetAPen(AWinDat[Curr].rp,0);
       END; 
     ELSIF TransRev IN Typ THEN (* Transl. Analog-Anzeiger rckw. *)
       IF AltKo[Curr].x < Ko[Curr].x THEN		
     	  SetAPen(AWinDat[Curr].rp,0);
       ELSIF AltKo[Curr].x > Ko[Curr].x THEN          
     	  SetAPen(AWinDat[Curr].rp,Pen);
       END; 
    END;
    IF AltKo[Curr].x <> Ko[Curr].x THEN	(* Nur zeichnen wenn ungleich *)	
    	back:=AreaMove(AWinDat[Curr].rp,AltKo[Curr].x,AltKo[Curr].y);
    	back:=AreaDraw(AWinDat[Curr].rp,AltKo[Curr].xR,AltKo[Curr].y);
    	back:=AreaDraw(AWinDat[Curr].rp,Ko[Curr].xR,Ko[Curr].y);
    	back:=AreaDraw(AWinDat[Curr].rp,Ko[Curr].x,Ko[Curr].y);
    	back:=AreaEnd(AWinDat[Curr].rp);
    END;
    AltKo[Curr]:=Ko[Curr];	(* Koordinate merken *) 
   END;
  END;
 END Display;


PROCEDURE InitAreaFunctions(Curr:INTEGER);
 BEGIN
   WITH AWinDat[Curr] DO
     IF (Trans IN AnzTyp) OR (TransRev IN AnzTyp) THEN
       InitArea(AInfo[Curr],ADR(ABufferP[Curr,0]),MAXPOINTS);
       
       ATmpBuffP[Curr]:=AllocRaster(width,height);	(* Windowgre *) 
       Assert(ATmpBuffP[Curr]<>NIL, ADR("Kein Raster fr ATempBuff"));
       
       InitTmpRas(ATempR[Curr],ATmpBuffP[Curr],RasSize(width,height));
       
       Assert(rp<>NIL,ADR("RastPort existiert nicht!"));
       rp^.areaInfo:=ADR(AInfo[Curr]);
       rp^.tmpRas:=ADR(ATempR[Curr]);
     END;
   END;
 END InitAreaFunctions;
 
 
PROCEDURE MakeWinAnz(Curr:INTEGER); (* Initialisiert Anzeige-Element-Daten *)
 BEGIN
   WITH AWinDat[Curr] DO	
     InFront[Curr]:=FALSE;
     IF Trans IN AnzTyp THEN (* Translatorischer Analog-Anzeiger *)
       WITH AWinAnz[Curr] DO  
          Typ:=AnzTyp;
          Pen:=FPen;
          x0:=Wx0L;		(* Bedeutung wie bei Type-Deklaration	*)	
          y0:=Wy0;
          x1:=Wx1L;		
          y1:=Wy1;
          dx:=Wx1L-Wx0L;	(* ergibt positives dx!		*)	 
          dy:=Wy1-Wy0;		(* ergibt negatives dy!		*)		
          Bx:=Wx0R-Wx0L;	
          AltKo[Curr].x:=x0;	(* Alte Koordinaten setzen	*)
          AltKo[Curr].y:=y0;
          AltKo[Curr].xR:=x0+Bx;
       END;
     ELSIF TransRev IN AnzTyp THEN (* Transl. Analog-Anzeiger rckwrts *)
       WITH AWinAnz[Curr] DO  
          Typ:=AnzTyp;
          Pen:=FPen;
          x0:=Wx0L;		(* Bedeutung wie bei Type-Deklaration	*)	
          y0:=Wy0;
          x1:=Wx1L;		
          y1:=Wy1;
          dx:=Wx1L-Wx0L;	(* ergibt positives dx!		*)	 
          dy:=Wy1-Wy0;		(* ergibt negatives dy!		*)		
          Bx:=Wx0R-Wx0L;	
          AltKo[Curr].x:=x1;	(* Alte Koordinaten setzen	*)
          AltKo[Curr].y:=y1;
          AltKo[Curr].xR:=x1+Bx;
       END;
     ELSIF alphanum IN AnzTyp THEN (* alphanumerischer Anzeiger *)
       WITH AWinAnz[Curr] DO  
          Pen:=FPen;
          Typ:=AnzTyp;
          x0:=Wx0L;		(* Koordinaten fr GrafikKursor *)		
          y0:=Wy1+BaseLine;          
          x1:=Wx0R;		
          y1:=Wy1;
          dy:=Wy0;		
          Bx:=Wx0R-Wx0L;	(* Max Textbreite		*)	
       END;
     ELSIF num IN AnzTyp THEN 	(* numerischer Anzeiger 	*)
       WITH AWinAnz[Curr] DO  
          Pen:=FPen;
          Typ:=AnzTyp;
          x0:=Wx0L;		(* Koordinaten fr GrafikKursor *)		
          y0:=Wy1+BaseLine;
          x1:=Wx0R;
          y1:=Wy1;
          dy:=Wy0;		
          Bx:=Wx0R-Wx0L;	(* Max Textbreite		*)	
       END;
     ELSE 			(* alle anderen Typen werden	*) 
       WITH AWinAnz[Curr] DO	(* bisher nicht untersttzt	*)
          Typ:=AnzFlagSet{non};
       END;
     END; (*IF*)
   END;
 END MakeWinAnz;



PROCEDURE Init; (* Initialisiert die Anzeiger-Daten und Namen der IFF-Dateien *)
 BEGIN
   AName[TEMPL]:="IFF:TEMPLAnz";
   AName[TEMPH]:="IFF:TEMPHAnz";
   AName[TANK]:="IFF:TANKAnz";
   AName[ECO1]:="IFF:ECO1Anz";
   AName[ECO2]:="IFF:ECO2Anz";
   AName[BINB]:="IFF:BinBar";
   AName[ANUMB]:="IFF:ANumBar";
   AName[TACHOE]:="IFF:TACHOE"; 
   AName[TACHOT]:="IFF:TACHOT";    
   
   (* Temperatur-Anzeiger, bei hoher Temperatur	*)
   
   WITH	AWinDat[TEMPH] DO	
	  AnzTyp:=AnzFlagSet{Trans};
          FPen:=7;
          x:=0;			(* Koordinaten: Window-Ecke links oben	*)
          y:=102;
          width:=128;		(* Windowgre				*)
          height:=67;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=44;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=62;
          Wy0:=62;
          Wx1L:=102;
          Wx1R:=120;
          Wy1:=4;
   END;
   
   (* Temperatur-Anzeiger fr niedrige Temperaturen	*)   
            
   WITH	AWinDat[TEMPL] DO	
	  AnzTyp:=AnzFlagSet{TransRev};
          FPen:=2;
          x:=0;			(* Koordinaten: Window-Ecke links oben	*)
          y:=102;
          width:=128;		(* Windowgre				*)
          height:=67;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=44;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=62;
          Wy0:=62;
          Wx1L:=102;
          Wx1R:=120;
          Wy1:=4;
   END;
      
   (* Benzinstand-Anzeiger	*)
   
   WITH	AWinDat[TANK] DO
	  AnzTyp:=AnzFlagSet{Trans};
          FPen:=2;
	  x:=0;			(* Koordinaten: Window-Ecke links oben	*)
          y:=34;
          width:=128;		(* Windowgre				*)
          height:=67;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=44;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=62;
          Wy0:=62;
          Wx1L:=102;
          Wx1R:=120;
          Wy1:=4;
   END;
   
   (* Verbrauch-Anzeiger, kleine Ausfhrung *)
   
   WITH	AWinDat[ECO1] DO
	  AnzTyp:=AnzFlagSet{Trans};
          FPen:=7;
	  x:=0;			(* Koordinaten: Window-Ecke links oben	*)
          y:=102;
          width:=128;		(* Windowgre				*)
          height:=67;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=44;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=62;
          Wy0:=62;
          Wx1L:=102;
          Wx1R:=120;
          Wy1:=4;
   END;
   
   (* Verbrauch-Anzeiger, groe Ausfhrung *)
   
   WITH	AWinDat[ECO2] DO
	  AnzTyp:=AnzFlagSet{Trans};
          FPen:=7;
	  x:=467;			(* Koordinaten: Window-Ecke links oben	*)
          y:=34;
          width:=173;		(* Windowgre				*)
          height:=135;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=20;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=38;
          Wy0:=130;
          Wx1L:=146;
          Wx1R:=164;
          Wy1:=4;
   END;
   
   (* Balken zur Aufnahme der Binr-Anzeiger *)
   
   WITH	AWinDat[BINB] DO
	  AnzTyp:=AnzFlagSet{non};
          FPen:=2;
	  x:=0;			(* Koordinaten: Window-Ecke links oben	*)
          y:=0;
          width:=640;		(* Windowgre				*)
          height:=33;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=-1;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=-1;
          Wy0:=-1;
          Wx1L:=-1;
          Wx1R:=-1;
          Wy1:=-1;
   END;

   (* Balken zur Anzeige alpha-numerischer Informationen *)
   
   WITH	AWinDat[ANUMB] DO
	  AnzTyp:=AnzFlagSet{alphanum};
          FPen:=2;
	  x:=0;			(* Koordinaten: Window-Ecke links oben	*)
          y:=170;
          width:=640;		(* Windowgre				*)
          height:=33;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=106;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=606;
          Wy0:=28;
          Wx1L:=-1;
          Wx1R:=-1;
          Wy1:=9;
   END;

   (* Balken zur Anzeige des totalen Kilometerstandes *)
   
   WITH	AWinDat[TACHOT] DO
	  AnzTyp:=AnzFlagSet{num};
          FPen:=2;
	  x:=0;			(* Koordinaten: Window-Ecke links oben	*)
          y:=136;
          width:=319;		(* Windowgre				*)
          height:=33;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=183;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=285;
          Wy0:=28;
          Wx1L:=-1;
          Wx1R:=-1;
          Wy1:=9;
   END;

   (* Balken zur Anzeige des Tages-Kilometerstandes *)
   
   WITH	AWinDat[TACHOE] DO
	  AnzTyp:=AnzFlagSet{num};
          FPen:=2;
	  x:=321;			(* Koordinaten: Window-Ecke links oben	*)
          y:=136;
          width:=319;		(* Windowgre				*)
          height:=33;
          rp:=NIL;		(* Pointer auf RastPort			*)
          Ptr:=NIL;		(* Pointer auf Windowstruktur		*)
          Wx0L:=183;		(* Eckpunkte des Anzeigebalkens 	*)
          Wx0R:=285;
          Wy0:=28;
          Wx1L:=-1;
          Wx1R:=-1;
          Wy1:=9;
   END;
   
END Init;



PROCEDURE Prepare(Curr:INTEGER);
 BEGIN
  MakeWindow(Curr);		(* Window ffnen, RastPort initialisieren *)
  MakeWinAnz(Curr);		(* Anzeige-Element-Daten berechnen	  *)
  InitAreaFunctions(Curr);	(* Initialisierung der Area-Funktionen	  *)
 END Prepare;



(*======================================================================*)

BEGIN	(* MAIN*)	(* Daten initialisieren, Screen, Windows ffnen *)
 TermProcedure(CleanUp);
 MakeScreen;
 
 (* alle Anzeiger-Daten initialisieren 	*)
 
 Init;

 (* Farben auf "Tag" stellen	*)
 
 LichtAus:=FALSE;
 MakeTag(TRUE); 
  
END Grafiken.
