(*********************************************************************
 
    :Program.  	ReadDat.mod
    :Author.   	Pit Burkhardt  
    :Address.   Stettinerstrae 25 D-7030 Bblingen
    :shortcut. 	[pit]
    :Version.  	1.0   
    :Date.     	June 1988
    :Copyright. PD
    :Language. 	Modula-II
    :Translator.M2Amiga
    :Imports.	none
    :UpDate.	none
    :Contents.	Opens, closes and reads from Data-Files.
    :Remark.	Studienarbeit 
    		Im Kernfach TECHNISCHES DESIGN
                an der Universitt Stuttgart	 
    
**********************************************************************)

IMPLEMENTATION MODULE ReadDat;

FROM InOut IMPORT	OpenInput,ReadString,WriteInt,WriteString,WriteLn,
			CloseInput,eol,done,termCh;


FROM RealConversions IMPORT	StrToReal;

FROM SYSTEM IMPORT	ADR,SHIFT;

FROM Arts IMPORT	TermProcedure,Assert;

VAR		Err		:BOOLEAN;
		
(*--------------Externe VARs
                                
VAR             Speed,
		Verb,
                Sprit,
                Temp,
                SSt,
                BinSum,
                Blink,
                km		:LONGINT;
                
                ALicht,
                FLicht,
                HeckSH,
                HandBr,
                GurtKl,
                Oelstd,
                Batter,
                WarnBl,
                
                BlinkR,
                BlinkL		:BOOLEAN;
                Ende		:BOOLEAN;

----------------*)

PROCEDURE Contains(Sum,Wert:INTEGER):BOOLEAN;
 BEGIN
  IF  ODD(SHIFT(Sum,-Wert)) THEN
    RETURN TRUE
  ELSE
    RETURN FALSE
  END;
 END Contains;


PROCEDURE CheckBinaer(Sum:INTEGER);
 BEGIN
   ALicht:=Contains(Sum,0);
   FLicht:=Contains(Sum,1);
   HeckSH:=Contains(Sum,2);
   HandBr:=Contains(Sum,3);
   GurtKl:=Contains(Sum,4);
   Oelstd:=Contains(Sum,5);
   Batter:=Contains(Sum,6);
   WarnBl:=Contains(Sum,7);
 END CheckBinaer;


PROCEDURE CheckBlink(Blink:INTEGER);
 BEGIN
  IF Blink=0 THEN
    BlinkR:=FALSE;
    BlinkL:=FALSE;
  ELSIF Blink=1 THEN
    BlinkR:=TRUE;
    BlinkL:=FALSE;
  ELSIF Blink=-1 THEN
    BlinkR:=FALSE;
    BlinkL:=TRUE;
  END;
 END CheckBlink;


PROCEDURE Read(VAR Wert:LONGINT);
 VAR	WertR:REAL;
        Str  :ARRAY [0..8] OF CHAR;
 BEGIN
  ReadString(Str);
  IF Str[1]<>" " THEN
    StrToReal(Str,WertR,Err);
    Wert:=TRUNC(WertR);
    IF Err<>FALSE THEN
      Ende:=TRUE;
    END;
  ELSE
    Ende:=TRUE;
    WriteLn;
    WriteString("  Eingabedatei abgebrochen!");
    WriteLn;
  END;
 END Read; 


PROCEDURE CleanUp;
 BEGIN
   WriteLn;
   WriteLn;
   WriteString("   ...SIDIS beendet.");
   WriteLn;
   WriteLn;
   CloseInput;
 END CleanUp;
 

PROCEDURE ReadAll;
 BEGIN 
  IF NOT Ende THEN 
   Read(Speed);
   Read(Verb);
   Read(Sprit);
   Read(Temp);
   Read(SSt);
   Read(BinSum);
   Read(Blink);
   Read(km);
   CheckBinaer(BinSum);
   CheckBlink(Blink);
  ELSE
   CleanUp;
  END;
 END ReadAll;

 
PROCEDURE OpenDat;
 BEGIN 
   ALicht:=FALSE;
   FLicht:=FALSE;
   HeckSH:=FALSE;
   HandBr:=FALSE;
   GurtKl:=FALSE;
   Oelstd:=FALSE;
   Batter:=FALSE;
   WarnBl:=FALSE;
   BlinkR:=FALSE;
   BlinkL:=FALSE;
   Ende:=FALSE;
   WriteLn;
   WriteString("   Name der Eingabedatei eingeben");
   WriteLn;
   WriteLn;
   OpenInput("");
   WriteLn;
 END OpenDat;

BEGIN
 TermProcedure(CleanUp);
 WriteLn;
 WriteString("   SIDIS - Situation Indicating Driver Information System");
 WriteLn;
 WriteLn;
 WriteString("   Bitte Geduld, SIDIS wird geladen");
END ReadDat.
