(*************************************************************************
    :Program.    SoftScroll
    :Author.     Frank Staudte
    :Address.    Hasenbergstr. 91, 7000 Stuttgart 1
    :Shortcut.   [fst]
    :Support.	 [bne pit fbs]
    :Version.    1.4
    :Date.       25-MAY-88
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga
    :Imports.    None
    :UpDate.     2-JUN-88 [fst], 1-AUG-88 [fst], 9/10-AUG-88
    :Contents.   Procedure to >>>Scroll<<< your IntuiScreen
    :Remark.     See Documentation for Copyright!
*************************************************************************)

IMPLEMENTATION MODULE SoftScroll;
		
FROM Intuition  IMPORT ScreenPtr, MakeScreen, RethinkDisplay;

FROM Graphics	IMPORT RasInfo, BitMap;

PROCEDURE ScrollScreen(screen: ScreenPtr; pixX,pixY,loop: INTEGER): BOOLEAN;

  VAR i: INTEGER;
      xdelta,ydelta: CARDINAL;  
      BitMapX,BitMapY:INTEGER;
      Okay	     :BOOLEAN;
            
  BEGIN
    Okay:=TRUE;
    WITH screen^.bitMap DO
      BitMapX:=bytesPerRow*8;
      BitMapY:=rows;
    END;
    WITH screen^ DO
      WITH viewPort DO
        WITH rasInfo^ DO
          IF (rxOffset+pixX*loop < 0) OR 
             (rxOffset+pixX*loop >= BitMapX-width)
          THEN     
  	  Okay:=FALSE;
            pixX:=0;
          END;
          IF (ryOffset+pixY*loop < 0) OR
             (ryOffset+pixY*loop >= BitMapY-height) 
          THEN
            Okay:=FALSE;
            pixY:=0;
          END;    
          FOR i:=1 TO loop DO
            INC(rxOffset, pixX);
            INC(ryOffset, pixY);
            MakeScreen(screen); RethinkDisplay;
          END;
        END;
      END;
    END; 
    RETURN Okay;   
END ScrollScreen;  
   
END SoftScroll.MOD              
