(*---------------------------------------------------------------------------
    :Program.    SoftScrollDemo
    :Author.     Frank Staudte
    :Address.    Hasenbergstr. 91, D-7-Stgt-1
    :Shortcut.   [fst]
    :Version.    1.0
    :Date.       1-AUG-88
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga
    :Imports.    IFFLoad [fbs].
    :UpDate.     none.
    :Contents.   Demo zu ScrollScreen.
    :Remark.     -
---------------------------------------------------------------------------*)

MODULE SoftScrollDemo;

FROM SoftScroll IMPORT ScrollScreen;

FROM SYSTEM IMPORT ADR, ADDRESS;

FROM Arguments IMPORT NumArgs, GetArg;

FROM Intuition IMPORT ScreenPtr, CloseScreen, DisplayBeep, WindowPtr,
  ScreenToFront, MakeScreen, RethinkDisplay, IntuitionBase;

FROM Exec      IMPORT OpenLibrary, CloseLibrary, LibraryPtr;

FROM IFFLoad IMPORT ReadILBM, ReadILBMFlags, ReadILBMFlagSet;

FROM Graphics IMPORT ViewModes, ViewModeSet;

VAR
  MyScreen: ScreenPtr;        
  WindowDummy: WindowPtr;     
  Name: ARRAY[0..79] OF CHAR; 
  length: INTEGER;           
  Intuitionbase: POINTER TO IntuitionBase;
  oldX,oldY,newX,newY: INTEGER;
  Ciaapra [0BFE001H]: SET OF (s0,s1,s2,s3,s4,s5,lmb);
    
BEGIN

  Intuitionbase := ADDRESS(OpenLibrary(ADR("intuition.library"),0));

  IF NumArgs()#0 THEN
    GetArg(1,Name,length);
  ELSE
    HALT; 
  END;

  IF ReadILBM(Name,ReadILBMFlagSet{visible},MyScreen,WindowDummy) THEN
    WITH MyScreen^ DO
      width:=320;
      height:=256;
      WITH viewPort DO
        modes:=ViewModeSet{};
        dWidth:=320; dHeight:=256;
      END;
    END; (* WITH *)  
    MakeScreen(MyScreen);
    RethinkDisplay;
    ScreenToFront(MyScreen);
    WITH Intuitionbase^ DO
      oldX := mouseX; oldY := mouseY;
      REPEAT (* Until Button in Port 1 is pressed *)
        newX := mouseX; newY := mouseY;
        IF ScrollScreen(MyScreen,newX-oldX,newY-oldY,2) THEN END;
        oldX := newX; oldY := newY;  
      UNTIL NOT(lmb IN Ciaapra);
    END;  
  ELSE
    DisplayBeep(NIL); 
  END;
  CloseScreen(MyScreen);  
  CloseLibrary(LibraryPtr(Intuitionbase));
END SoftScrollDemo.MOD
