(*********************************************************************
 *                                                                   *
 *  :Program.    TestOfList.mod                                      *
 *  :Author.     Michael Frie                                       *
 *  :Address.    Kernerstr. 22a                                      *
 *  :shortcut.   [MiF]                                               *
 *  :Version.    1.0                                                 *
 *  :Date.       14.09.88                                            *
 *  :Copyright.  PD                                                  *
 *  :Language.   Modula-II                                           *
 *  :Translator. M2Amiga                                             *
 *  :Imports.    List      (at least V1.0 --> Amok#7)                *
 *  :Contents.   Test of module List                                 *
 *                                                                   *
 *********************************************************************)

MODULE TestOfList;

FROM SYSTEM   IMPORT BYTE, ADR;
FROM Exec     IMPORT CopyMem;
FROM InOut    IMPORT WriteString, WriteLn;
FROM Strings  IMPORT Compare;
IMPORT List;

TYPE data = ARRAY [1..30] OF CHAR;

VAR l : List.list;
    a : List.action;
    Data : data;

PROCEDURE Action (VAR d : ARRAY OF BYTE; VAR More : BOOLEAN);

VAR Data : data;

BEGIN
 CopyMem (ADR(d), ADR(Data), SIZE(data));
 WriteString (Data);
 WriteLn;
 More := (Compare (Data, 0, 15, "Test of special", TRUE) # 0);
 IF More THEN
   WriteString ("More Data ..."); WriteLn
 END
END Action;


BEGIN
  WriteString ("Test of module list:"); WriteLn;
  WriteLn;

  WriteString ("* Initialize list l"); WriteLn;
  List.Init (l);

  WriteString ("* insert first element"); WriteLn;
  Data := "First entry";
  List.Insert (l, Data);

  WriteString ("* insert second element"); WriteLn;
  Data := "Second entry";
  List.Insert (l, Data);

  WriteString ("* insert third element"); WriteLn;
  Data := "Third entry";
  List.Insert (l, Data);

  WriteString ("* reset list"); WriteLn;
  List.Reset (l);

  WriteString ("* read first element"); WriteLn;
  List.Read (l, Data);
  WriteString (Data); WriteLn;

  WriteString ("* read all elements until end of list"); WriteLn;
  WHILE NOT List.End (l) DO
   List.Read (l, Data);
   WriteString (Data); WriteLn
  END;

  WriteString ("* write on end of list"); WriteLn;
  Data := "A new entry";
  List.Write (l, Data);

  WriteString ("* reset list"); WriteLn;
  List.Reset (l);

  WriteString ("* overwrite first element"); WriteLn;
  Data := "New first entry";
  List.Write (l, Data);

  WriteString ("* delete second element"); WriteLn;
  List.Delete (l);

  WriteString ("* insert behind current element"); WriteLn;
  Data := "Test of special end";
  List.Insert (l, Data);

  WriteString ("* reset list"); WriteLn;
  List.Reset (l);

(*
  WriteString ("* read all elements"); WriteLn;
  WHILE NOT List.End (l) DO
    List.Read (l, Data);
    WriteString (Data); WriteLn
  END;
*)


  WriteString ("* do Action until special end"); WriteLn;
  a := Action;
  List.Do (l, a);

  WriteString ("* discard list"); WriteLn;
  List.Discard (l);

  WriteString ("* End of Test"); WriteLn;

END TestOfList.
