(*********************************************************************
 *                                                                   *
 *  :Program.    TestStrings.mod                                     *
 *  :Author.     Michael Frie                                       *
 *  :Address.    Kernerstr. 22a                                      *
 *  :shortcut.   [MiF]                                               *
 *  :Version.    1.0                                                 *
 *  :Date.       30.09.88                                            *
 *  :Copyright.  PD                                                  *
 *  :Language.   Modula-II                                           *
 *  :Translator. M2Amiga                                             *
 *  :Contents.   Test of module Strings                              *
 *                                                                   *
 *********************************************************************)

MODULE TestStrings;

FROM Strings  IMPORT Compare;
FROM InOut    IMPORT WriteInt, WriteString, WriteLn,
                     OpenOutput, CloseOutput;

CONST Short = "String";

VAR   Long   : ARRAY [1..30] OF CHAR;
      Result : INTEGER;

PROCEDURE TestCompare (VAR str: ARRAY OF CHAR;
                       start, length: INTEGER;
                       token: ARRAY OF CHAR;
                       caseSens: BOOLEAN;
                       expected: INTEGER);
 VAR result: INTEGER;
 BEGIN
  WriteString (" PROCEDURE Compare"); WriteLn;
  result := Compare (str, start, length, token, caseSens);
  WriteString ("  str    = "); WriteString (str);    WriteLn;
  WriteString ("  start  = "); WriteInt (start,  4); WriteLn;
  WriteString ("  length = "); WriteInt (length, 4); WriteLn;
  WriteString ("  token  = "); WriteString (token);  WriteLn;
  WriteString ("  caseS. = ");
   IF caseSens THEN
    WriteString ("TRUE")
   ELSE
    WriteString ("FALSE")
   END;
  WriteLn;
  WriteLn;
  WriteString ("  expect = "); WriteInt (expected, 4); WriteLn;
  WriteString ("  result = "); WriteInt (result, 4); WriteLn;
  IF result = expected THEN
    WriteString (" result ist korrekt.")
  ELSE
    WriteString (" FEHLER!!")
  END;
  WriteLn;
  WriteLn
 END TestCompare;

BEGIN
 WriteString ("Nur Enter-Taste eingeben fr Ausgabe auf Bildschirm!");
 WriteLn;
 WriteString ("Name der Ausgabedatei ");
 OpenOutput ("Errors");
 WriteString ("Test des Moduls Strings"); WriteLn;
 WriteLn;
 WriteString (" V3.11d: Prozedur Compare bercksichtigt den");
 WriteLn;
 WriteString (" Parameter length nicht."); WriteLn;
 Long := "String mit weiteren Zeichen";
 TestCompare (Long, 0, 6, Long,  TRUE, 0);
 TestCompare (Long, 0, 0, Long,  TRUE, 0);
 TestCompare (Long, 0, 6, Short, TRUE, 0);
 TestCompare (Long, 0, 5, Short, TRUE, 0);
 TestCompare (Long, 0,10, Short, TRUE, -7);
 Long := Short;
 TestCompare (Long, 0, 6, Short, TRUE, 0);
 CloseOutput;
 WriteString ("Ende des Tests."); WriteLn
END TestStrings.

