(*********************************************************************
 *                                                                   *
 *  :Program.    TestOfQueue.mod                                     *
 *  :Author.     Michael Frie                                       *
 *  :Address.    Kernerstr. 22a                                      *
 *  :shortcut.   [MiF]                                               *
 *  :Version.    1.0                                                 *
 *  :Date.       14.09.88                                            *
 *  :Copyright.  PD                                                  *
 *  :Language.   Modula-II                                           *
 *  :Translator. M2Amiga                                             *
 *  :Imports.    Queue     (at least V1.0 --> Amok#7)                *
 *  :Contents.   Test of module Queue                                *
 *                                                                   *
 *********************************************************************)

MODULE TestOfQueue;

FROM InOut    IMPORT WriteString, WriteLn;
IMPORT Queue;

TYPE data = ARRAY [1..30] OF CHAR;

VAR q : Queue.queue;
    Data : data;

BEGIN
  WriteString ("Test of module queue:"); WriteLn;
  WriteLn;

  WriteString ("* Initialize queue q"); WriteLn;
  Queue.Init (q);

  WriteString ("* insert first element"); WriteLn;
  Data := "First entry";
  Queue.Write (q, Data);

  WriteString ("* insert second element"); WriteLn;
  Data := "Second entry";
  Queue.Write (q, Data);

  WriteString ("* insert third element"); WriteLn;
  Data := "Third entry";
  Queue.Write (q, Data);

  WriteString ("* read first element"); WriteLn;
  Queue.Read (q, Data);
  WriteString (Data); WriteLn;

  WriteString ("* insert fourth element"); WriteLn;
  Data := "Fourth entry";
  Queue.Write (q, Data);

  WriteString ("* read all elements until end of queue"); WriteLn;
  WHILE NOT Queue.Empty (q) DO
   Queue.Read (q, Data);
   WriteString (Data); WriteLn
  END;

  WriteString ("* discard queue"); WriteLn;
  Queue.Discard (q);

  WriteString ("* End of Test"); WriteLn;

END TestOfQueue.
