(*---------------------------------------------------------------------------
   :Program.    Reminder
   :Author.     Hans-Joachim Siebert (Amok)
   :Address.    Nobileweg 67, D-7000 Stuttgart-40
   :Phone.      (0)711/822509
   :Shortcut.   [acs]
   :Version.    0.99
   :Date.       12.08.88
   :Copyright.  PD
   :Language.   Modula-II
   :Translator. M2Amiga
   :Imports.    none.
   :Update.     none.
   :Contents.   Program disturbing you at a certain time
   :Remark.     Usage: Dump Source [[TO] Dest] [WIDTH xx]
---------------------------------------------------------------------------*)

MODULE Reminder;

FROM Windows   IMPORT Window, OpenWindow, CloseWindow, WinGadSet, WinGad,
                      Clear, WriteS, WriteC, WriteL, SetScreen;

FROM DOS       IMPORT Delay;

FROM InOut     IMPORT WriteString, WriteLn, ReadString, WriteCard;

FROM Arguments IMPORT GetArg, NumArgs;

FROM Exec      IMPORT OpenLibrary, CloseLibrary, MsgPortPtr, DoIO,
                      OpenDevice, CloseDevice;

FROM ExecSupport IMPORT CreatePort, DeletePort, CreateExtIO, 
                        DeleteExtIO;
                        
FROM Timer     IMPORT   TimeVal, TimeValPtr, timerName, vBlank, 
                        TimeRequestPtr, TimeRequest, addRequest;

FROM SYSTEM    IMPORT SHIFT, ADR, LONGSET, ADDRESS;

FROM Intuition IMPORT IntuitionBase, DisplayBeep, CurrentTime;

FROM Strings   IMPORT Length;

VAR Ausgabefenster : Window;
    Stunde, Minute : ARRAY [0..1] OF CHAR;
    Text: ARRAY [1..78] OF CHAR;
    Laenge: INTEGER;
    days, Currentsecs, Currentmics: LONGCARD;
    hour, minit : LONGCARD;
    Csecs : CARDINAL;
    Zeit : TimeVal;
    TimerPort: MsgPortPtr;
    TimeRequestBlock: TimeRequestPtr;    
    Basis : POINTER TO IntuitionBase;
    i : CARDINAL;
    
CONST intuitionName = "intuition.library";

PROCEDURE GetArgs(VAR Std, Min, Rem: ARRAY OF CHAR):BOOLEAN;
   BEGIN
   GetArg(1, Std, Laenge);
   IF Laenge<>2 THEN RETURN FALSE END;
   GetArg(2, Min, Laenge);
   IF Laenge<>2 THEN RETURN FALSE END;
   GetArg(3, Rem, Laenge);
   RETURN TRUE     
END GetArgs;

PROCEDURE OpenTimer();

BEGIN
  TimerPort := CreatePort(NIL,0);
  TimeRequestBlock := CreateExtIO(TimerPort,SIZE(TimeRequest));
  OpenDevice(ADR(timerName),vBlank,TimeRequestBlock,LONGSET{});
END OpenTimer;

PROCEDURE CloseTimer();

BEGIN
  CloseDevice(TimeRequestBlock);
  DeleteExtIO(TimeRequestBlock);
  DeletePort(TimerPort);
END CloseTimer;

PROCEDURE WaitForTimer(HowLong: TimeValPtr);

BEGIN
  WITH TimeRequestBlock^ DO
    node.command := addRequest;
    time := HowLong^;
  END;
  DoIO(TimeRequestBlock);
END WaitForTimer;

PROCEDURE Mod(a,b:LONGCARD): LONGCARD;
VAR ShiftedB : LONGCARD;
CONST ZweiHoch31 = 2147483648;
BEGIN
  IF a<=b THEN RETURN a END;
  IF b=0 THEN a := a DIV (a-a) END;
  ShiftedB := b;
  WHILE (ShiftedB<a) AND (ShiftedB<ZweiHoch31) DO
    ShiftedB := SHIFT(ShiftedB,1);
  END;
  IF ShiftedB>a THEN ShiftedB := SHIFT(ShiftedB,-1) END;
  WHILE a>b DO
    WHILE a<ShiftedB DO
      ShiftedB := SHIFT(ShiftedB,-1);
    END;
    DEC(a,ShiftedB);
  END;
  RETURN a;
END Mod;

BEGIN
   IF NumArgs()=3 THEN
      IF GetArgs(Stunde, Minute, Text) THEN
         hour  := 10 * (ORD(Stunde[0]) - ORD("0")) 
                     + (ORD(Stunde[1]) - ORD("0"));
         minit := 10 * (ORD(Minute[0]) - ORD("0"))
                     + (ORD(Minute[1]) - ORD("0"));
         Zeit.secs  := LONGCARD(hour) * 3600 + minit * 60;
         Zeit.micro := 0;
         CurrentTime(ADR(Currentsecs),ADR(Currentmics));
         Currentsecs := Mod(Currentsecs,86400);
         IF Zeit.secs<Currentsecs THEN INC(Zeit.secs,86400) END; 
         Zeit.secs := Zeit.secs-Currentsecs;
         OpenTimer();
         WaitForTimer(ADR(Zeit));
         CloseTimer();
         Basis := ADDRESS(OpenLibrary(ADR(intuitionName),0));
         DisplayBeep(Basis^.activeScreen);
         SetScreen(Basis^.activeScreen);
         OpenWindow(Ausgabefenster, 0, 0, 640, 50,
                    " Reminder ", WinGadSet{});
         WriteL(Ausgabefenster);
         i := (77-Length(Text))/2;
         WHILE i > 0 DO
            WriteC(Ausgabefenster," ");
            DEC(i);
         END;
         WriteS(Ausgabefenster, Text);           
         Delay(1000);
         CloseWindow(Ausgabefenster);
         CloseLibrary(ADDRESS(Basis));
         ELSE WriteLn;
              WriteString("Bad Arguments !");
              WriteLn;
      END;
      
   ELSE WriteLn;
        WriteString("USAGE: Reminder hh mm ...(reminding text in quotes)...");
        WriteLn;
   END;     

END Reminder.  
