(*********************************************************************
 *                                                                   *
 *  :Program.    TestOfStack.mod                                     *
 *  :Author.     Michael Frie                                       *
 *  :Address.    Kernerstr. 22a                                      *
 *  :shortcut.   [MiF]                                               *
 *  :Version.    1.0                                                 *
 *  :Date.       14.09.88                                            *
 *  :Copyright.  PD                                                  *
 *  :Language.   Modula-II                                           *
 *  :Translator. M2Amiga                                             *
 *  :Imports.    Stack     (at least V1.0 --> Amok#7)                *
 *  :Contents.   Test of module Stack                                *
 *                                                                   *
 *********************************************************************)

MODULE TestOfStack;

FROM InOut    IMPORT WriteString, WriteLn;
IMPORT Stack;

TYPE data = ARRAY [1..30] OF CHAR;

VAR s : Stack.stack;
    Data : data;

BEGIN
  WriteString ("Test of module stack:"); WriteLn;
  WriteLn;

  WriteString ("* Initialize stack s"); WriteLn;
  Stack.Init (s);

  WriteString ("* insert first element"); WriteLn;
  Data := "First entry";
  Stack.Write (s, Data);

  WriteString ("* insert second element"); WriteLn;
  Data := "Second entry";
  Stack.Write (s, Data);

  WriteString ("* insert third element"); WriteLn;
  Data := "Third entry";
  Stack.Write (s, Data);

  WriteString ("* read last element"); WriteLn;
  Stack.Read (s, Data);
  WriteString (Data); WriteLn;

  WriteString ("* insert fourth element"); WriteLn;
  Data := "Fourth entry";
  Stack.Write (s, Data);

  WriteString ("* read all elements until end of stack"); WriteLn;
  WHILE NOT Stack.Empty(s) DO
   Stack.Read (s, Data);
   WriteString (Data); WriteLn
  END;

  WriteString ("* discard stack"); WriteLn;
  Stack.Discard (s);

  WriteString ("* End of Test"); WriteLn;

END TestOfStack.
