(* WarpText Quickie Test
 *
 * Thanx to Anson Mah for his C-Demo. I made it Modula.
 *  -- Fridtjof.
 *)

MODULE WarpDemo;

FROM SYSTEM    IMPORT ADR, ADDRESS, SHIFT;

FROM Arts      IMPORT Assert, TermProcedure;

FROM Exec      IMPORT AllocMem, FreeMem, MemReqs, MemReqSet, WaitPort,
                      GetMsg, ReplyMsg;

FROM Graphics  IMPORT TextAttr, FontStyles, FontStyleSet, FontFlags,
                      FontFlagSet, OpenFont, CloseFont;

FROM Intuition IMPORT NewWindow, WindowPtr, WindowFlags, WindowFlagSet,
                      IDCMPFlags, IDCMPFlagSet, ScreenFlags, ScreenFlagSet,
                      IntuiMessagePtr, OpenWindow, CloseWindow;

FROM Strings   IMPORT Length;

FROM WarpText  IMPORT InitWarpInfo, GotoXY, WarpText, WarpInfoPtr;

VAR
  w: WindowPtr;
  winfo: WarpInfoPtr;
  taTopaz80: TextAttr;
  wdef: NewWindow;
  text: ARRAY[0..16] OF POINTER TO ARRAY[0..79] OF CHAR;
  msg: IntuiMessagePtr;
  class: IDCMPFlagSet;
  i: CARDINAL;

PROCEDURE CloseStuff();

BEGIN
  IF winfo#NIL THEN FreeMem(winfo,SIZE(winfo^)) END;
  IF w#NIL     THEN CloseWindow(w) END;
END CloseStuff;

PROCEDURE OpenStuff();

BEGIN
  winfo := AllocMem(SIZE(winfo^),MemReqSet{memClear});
  Assert(winfo#NIL,ADR("oom"));
  w := OpenWindow(wdef);
  Assert(w#NIL,ADR("kudndopnwndo"));
END OpenStuff;

TYPE
  ptaoc = POINTER TO ARRAY[0..79] OF CHAR;

PROCEDURE Text(x:CARDINAL; s: ptaoc);

BEGIN
  text[x] := ADDRESS(s);
  text[x]^[Length(s^)-1] := CHAR(10);
END Text;

BEGIN
  w := NIL;
  winfo := NIL;
  WITH taTopaz80 DO
    name  := ADR("topaz.font");
    ySize := 8;
    style := FontStyleSet{};
    flags := FontFlagSet{romFont};
  END;
  WITH wdef DO
    leftEdge    := 0;
    topEdge     := 0;
    width       := 640;
    height      := 200;
    detailPen   := 0;
    blockPen    := 1;
    idcmpFlags  := IDCMPFlagSet{closeWindow};
    flags       := WindowFlagSet{windowClose,windowDepth,activate};
    firstGadget := NIL;
    checkMark   := NIL;
    title       := ADR("WarpText Test");
    screen      := NIL;
    bitMap      := NIL;
    type        := ScreenFlagSet{wbenchScreen};
  END;
  TermProcedure(CloseStuff);

  OpenStuff();


  Text( 0,ADR("Hello World!\"));
  Text( 1,ADR("   This is a Demonstration of Bill Kelly's WarpText routines\"));
  Text( 2,ADR("I transferred to MODULA-II. As you see they are as quick\"));
  Text( 3,ADR("as the original C implementation is. So all Modula fans and\"));
  Text( 4,ADR("C - Haters like me are able to use them. Soon the whole\"));
  Text( 5,ADR("world will speak MODULA-II! This Demonstration was written\"));
  Text( 6,ADR("first in C by Anson Mah. Then I made it Modula-II. I could\"));
  Text( 7,ADR("have written a new demo in Modula-II, but was too lazy.\"));
  Text( 8,ADR("    Thanx to Bill for his machinecode routines and to\"));
  Text( 9,ADR("Anson for his demo!\"));
  Text(10,ADR("    I've just assemblered Bill's source pc-relative and\"));
  Text(11,ADR("splittet it into the Procedures. The code is included in the\"));
  Text(12,ADR("Modula source via SYSTEM.INLINE(). So you can easily compile\"));
  Text(13,ADR("it or make some changes in it. The Procedures get their\"));
  Text(14,ADR("stuff directly via the 68000-Registers. That's why I\"));
  Text(15,ADR("had to make some small changes in Bill's code.\"));
  Text(16,ADR("                                          Fridjof\"));

  (* set up warpinfo *)
  WITH winfo^ DO
    textFont   := OpenFont(ADR(taTopaz80));
    bitMap     := ADR(w^.wScreen^.bitMap);
    whichPlane := 0;
    left       := 10;
    top        := 3;
    width      := 70;
    height     := 21;
  END;
  InitWarpInfo(winfo);

  (* warp out text *)

  FOR i:=0 TO 16 DO
    WarpText(winfo,text[i],Length(text[i]^));
  END;

  GotoXY(winfo,25,19);
  WarpText(winfo,ADR("Hey, I'm here!"),14);
  GotoXY(winfo, 10, 20);
  WarpText(winfo,ADR("And here!!"),10);

  CloseFont(winfo^.textFont);

  LOOP
    WaitPort(w^.userPort);
    msg := GetMsg(w^.userPort);
    class := msg^.class;
    ReplyMsg(msg);
    IF closeWindow IN class THEN EXIT END;
  END;

END WarpDemo.
