(*---------------------------------------------------------------------------
    :Program.    WarpText
    :Author.     Fridtjof Siebert
    :Address.    Nobileweg 67, D-7-Stgt-40
    :Phone.      Please write a letter.
    :Shortcut.   [fbs]
    :Version.    1.0
    :Date.       24-Sep-88
    :Copyright.  PD
    :Language.   Modula-II/Assembler
    :Translator. M2Amiga
    :Imports.    none.
    :UpDate.     Bug fixed in Bill's SetUpFont() procedure. Works fine now.
    :Contents.   Procedure for fast Text printing.
    :Remark.     Assembler Source and Docs by Bill Kelly.
---------------------------------------------------------------------------*)

IMPLEMENTATION MODULE WarpText;

FROM SYSTEM   IMPORT ADDRESS,LONGSET,INLINE,SETREG,REG, CAST;
FROM Graphics IMPORT TextFontPtr;

(* ---------------------------------------------------- *
 * Call: InitWarpInfo(winfo);                           *
 *       struct WarpInfo *winfo;                        *
 * ---------------------------------------------------- *)

PROCEDURE InitWarpInfo(WInfo{8}: WarpInfoPtr);

BEGIN
  INLINE(048E7H,0F860H,07800H,03144H,0001EH,03168H,0000EH,00020H);
  INLINE(00468H,00001H,00020H,02268H,00004H,07400H,03429H,00000H);
  INLINE(03142H,00022H,03828H,00008H,0E584H,02271H,04808H,07600H);
  INLINE(02468H,00000H,0362AH,00014H,07200H,02202H,0C2C3H,03141H);
  INLINE(00024H,07800H,02801H,0C8E8H,0000CH,0D868H,0000AH,02449H);
  INLINE(0D5C4H,0214AH,00012H,0214AH,00016H,07400H,03428H,0000CH);
  INLINE(0D468H,00010H,02801H,0C8C2H,0D868H,0000AH,02449H,0D5C4H);
  INLINE(0214AH,0001AH,04CDFH,0061FH);
END InitWarpInfo;

(* ---------------------------------------------------- *
 * Call: GotoXY(winfo, x, y);                           *
 *       struct WarpInfo *winfo;                        *
 *       UWORD x, y;                                    *
 * ---------------------------------------------------- *)

PROCEDURE GotoXY(WInfo{8}:WarpInfoPtr; x{0},y{1}: CARDINAL);

BEGIN
  INLINE(03140H,0001EH,0C2E8H,00024H,0D2A8H,00012H,02141H,00016H);
END GotoXY;

(* ---------------------------------------------------- *
 * Call: GetXY(winfo, &x, &y);                          *
 *       struct WarpInfo *winfo;                        *
 *       UWORD x, y;                                    *
 * ---------------------------------------------------- *)

PROCEDURE GetXY(winfo: WarpInfoPtr; VAR x,y: CARDINAL);

BEGIN
  SETREG(8,winfo);
  INLINE(02228H,00016H,092A8H,00012H,082E8H,00024H);
  INLINE(07000H,03028H,0001EH);
  x := CAST(LONGCARD,CAST(LONGSET,REG(0))*LONGSET{0..15});
  y := CAST(LONGCARD,CAST(LONGSET,REG(1))*LONGSET{0..15});
END GetXY;

(* ---------------------------------------------------- *
 * Call: WarpText(winfo, text, len);                    *
 *       struct WarpInfo *winfo;                        *
 *       char *text;     /* pointer to string */        *
 *       ULONG len;      /* length of string */         *
 * ---------------------------------------------------- *)

PROCEDURE WarpText(WInfo{8}: WarpInfoPtr;
                   Text{9}:  ADDRESS;
                   len{0}:   LONGCARD);

BEGIN
  INLINE(048E7H,07D3CH);
  INLINE(07800H,03828H,0001EH,07A00H,03A28H,00020H,02F05H,03A28H);
  INLINE(00024H,02F05H,02468H,00000H,07400H,0142AH,00020H,07600H);
  INLINE(0162AH,00021H,03A2AH,00026H,02F05H,03A2AH,00014H,02F05H);
  INLINE(0246AH,00022H,02868H,00012H,02F0CH,02868H,0001AH,02F0CH);
  INLINE(02668H,00016H,07E00H,03E28H,00022H,05340H,07200H,05344H);
  INLINE(05244H,01219H,00C01H,00020H,06700H,0002AH,0B202H,06D00H);
  INLINE(00046H,0B203H,06D00H,00036H,0284AH,09282H,0D9C1H,02A4BH);
  INLINE(0DBC4H,02A2FH,00008H,05385H,01A94H,0D9EFH,0000CH,0DBC7H);
  INLINE(051CDH,0FFF6H,0B8AFH,00014H,06D00H,00042H,07800H,0B7D7H);
  INLINE(06700H,00042H,0D7EFH,00010H,06000H,0003AH,0284AH,0D9FCH);
  INLINE(00000H,00100H,060C8H,00C81H,00000H,0000AH,067DEH,00C81H);
  INLINE(00000H,0000CH,06700H,0000CH,00C81H,00000H,0000DH,067CEH);
  INLINE(060DAH,07800H,0266FH,00004H,06000H,0000AH,051C8H,0FF82H);
  INLINE(06000H,00006H,051C8H,0FF7CH,0508FH,0508FH,0508FH,03144H);
  INLINE(0001EH,0214BH,00016H,04CDFH,03CBEH);
END WarpText;


(* ------------------------------------------------------ *
 * Call: SetupFont(nwinfo, tf);                    WT 2.0 *
 *       struct NewWarpInfo *nwinfo;               billk  *
 *       struct TextFont *tf;  /* pointer to open font */ *
 * ------------------------------------------------------ *)


PROCEDURE SetUpFont(nwi{9}: NewWarpInfoPtr;
                    tf{10}: TextFontPtr);

BEGIN
  INLINE(048E7H,080F0H,02069H,00008H);
  INLINE(0203CH,00000H,0001FH,0117CH,000FEH,00400H,010FCH,000FEH);
  INLINE(0117CH,000C6H,00400H,010FCH,000C6H,0117CH,000C6H,00400H);
  INLINE(010FCH,000C6H,0117CH,000C6H,00400H,010FCH,000C6H,0117CH);
  INLINE(000C6H,00400H,010FCH,000C6H,0117CH,000C6H,00400H,010FCH);
  INLINE(000C6H,0117CH,000FEH,00400H,010FCH,000FEH,0117CH,00000H);
  INLINE(00400H,010FCH,00000H,051C8H,0FFAEH,0246AH,00022H,0264AH);
  INLINE(07000H,0D5C0H,010D2H,0D5FCH,00000H,000C0H,010D2H,0D5FCH);
  INLINE(00000H,000C0H,010D2H,0D5FCH,00000H,000C0H,010D2H,0D5FCH);
  INLINE(00000H,000C0H,010D2H,0D5FCH,00000H,000C0H,010D2H,0D5FCH);
  INLINE(00000H,000C0H,010D2H,0D5FCH,00000H,000C0H,010D2H,0B07CH);
  INLINE(0005FH,06600H,00008H,0D1FCH,00000H,00100H,0244BH,05200H);
  INLINE(0B07CH,000BFH,06FACH,04CDFH,00F01H);
END SetUpFont;

(* ------------------------------------------------------ *
 * Call: NewWarp(nwinfo, text, len);               WT 2.0 *
 *       struct NewWarpInfo *nwinfo;               billk  *
 *       char *text;     /* pointer to string */          *
 *       ULONG len;      /* length of string */           *
 * ------------------------------------------------------ *)


PROCEDURE NewWarp(nwi{8}: NewWarpInfoPtr;
                  text{9}: ADDRESS;
                  len{0}: LONGCARD);

BEGIN
  INLINE(048E7H,0F0F8H,02600H,02449H,02848H,0302CH,00000H);
  INLINE(0D76CH,00000H,05343H,0322CH,00002H,0206CH,00004H,0226CH);
  INLINE(00008H,02649H,0EF41H,03401H,0E541H,0D242H,0D240H,0D0C1H);
  INLINE(07000H,0101AH,0E740H,0D2C0H,01099H,0D0FCH,00050H,01099H);
  INLINE(0D0FCH,00050H,01099H,0D0FCH,00050H,01099H,0D0FCH,00050H);
  INLINE(01099H,0D0FCH,00050H,01099H,0D0FCH,00050H,01099H,0D0FCH);
  INLINE(00050H,01099H,090FCH,0022FH,0224BH,051CBH,0FFC4H,04CDFH);
  INLINE(01F0FH);
END NewWarp;

(* ------------------------------------------------------ *
 * Call: XORCursor(nwinfo);                        WT 2.0 *
 *       struct NewWarpInfo *nwinfo;               billk  *
 * ------------------------------------------------------ *)


PROCEDURE XORCursor(nwi{9}: NewWarpInfoPtr);

BEGIN
  INLINE(048E7H,0C0C0H,0226FH,00014H,03029H);
  INLINE(00002H,02069H,00004H,0EF40H,03200H,0E540H,0D041H,0D069H);
  INLINE(00000H,0D0C0H,00A10H,000FFH,0D0FCH,00050H,00A10H,000FFH);
  INLINE(0D0FCH,00050H,00A10H,000FFH,0D0FCH,00050H,00A10H,000FFH);
  INLINE(0D0FCH,00050H,00A10H,000FFH,0D0FCH,00050H,00A10H,000FFH);
  INLINE(0D0FCH,00050H,00A10H,000FFH,0D0FCH,00050H,00A10H,000FFH);
  INLINE(04CDFH,00303H);
END XORCursor;

BEGIN
END WarpText.
