MODULE MoveDraw;

FROM SYSTEM    IMPORT ADR, ADDRESS, SHIFT, BITSET, CAST;

FROM Dos       IMPORT Delay;

FROM Graphics  IMPORT OwnBlitter, DisownBlitter, WaitBlit, ViewModes,
                      ViewModeSet, RastPortPtr, Draw, Move, DrawModes,
                      DrawModeSet, SetDrMd;

FROM Intuition IMPORT OpenScreen, CloseScreen, customScreen, NewScreen,
                      ScreenPtr, CurrentTime;

FROM InOut     IMPORT WriteInt, WriteString, WriteLn;

VAR
  NuScreen: NewScreen;
  Screen: ScreenPtr;
  i: INTEGER;
  x0,y0,x1,y1: INTEGER;
  Secs,secs,Micros,micros: LONGINT;
  RP: RastPortPtr;


BEGIN
  WITH NuScreen DO
    leftEdge := 0; topEdge := 0; width := 320; height := 256; depth := 1;
    detailPen := 0; blockPen := 1;
    viewModes := ViewModeSet{};
    type := customScreen;
    font := NIL;
    defaultTitle := ADR("Blitter");
    gadgets := NIL;
    customBitMap := NIL;
  END;
  Screen := OpenScreen(NuScreen);
  RP := ADR(Screen^.rastPort);
  SetDrMd(RP,DrawModeSet{complement});
  CurrentTime(ADR(Secs),ADR(Micros));
  FOR i:=0 TO 31 DO
    FOR x0:=0 TO 319 DO
      Move(RP,0,  0); Draw(RP,x0,255); Draw(RP,319,  0);
      Move(RP,0,255); Draw(RP,x0,  0); Draw(RP,319,255);
    END;
  END;
  CurrentTime(ADR(secs),ADR(micros));
  IF micros<Micros THEN
    INC(micros,1000000);
    DEC(secs,1);
  END;
  WriteString("This took");
  WriteInt(secs-Secs,3); WriteString(" seconds and");
  WriteInt(micros-Micros,7); WriteString(" micros."); WriteLn;
  CloseScreen(Screen);
END MoveDraw.
