(**********************************************************************

    :Program.  	 IDCMP.mod
    :Contents.	 Intuition Direct Communication Message Port handler
    :Author.   	 Nicolas Benezan [bne]
    :Address.    Postwiesenstr. 2, D7000 Stuttgart 60
    :Phone.      711/333679
    :Copyright.  Public Domain
    :Language. 	 Modula-2
    :Translator. M2Amiga AMSoft
    :ModHistory. V1.1a [bne] 23.10.88
    
**********************************************************************)

IMPLEMENTATION MODULE IDCMP;

FROM Exec	IMPORT WaitPort,GetMsg,ReplyMsg,MsgPortPtr;
FROM Intuition	IMPORT IntuiMessagePtr,IDCMPFlagSet,IDCMPFlags,WindowPtr;
FROM SYSTEM	IMPORT ADDRESS,SHIFT,CAST;
FROM InputEvent IMPORT QualifierSet;

PROCEDURE FlagSet2Flags(Flags:IDCMPFlagSet;VAR Class:IDCMPFlags);
CONST	Flag0=VAL(IDCMPFlags,0);
BEGIN
  Class:=Flag0;
  WHILE NOT(Flag0 IN Flags) DO
    Flags:=CAST(IDCMPFlagSet,SHIFT(CAST(LONGCARD,Flags),-1));
    INC(Class);
  END;
END FlagSet2Flags;

PROCEDURE GetIntuiMessage(IDCMPort:MsgPortPtr;VAR Class:IDCMPFlags;
	VAR Code:CARDINAL;VAR Qualifier:QualifierSet;VAR ItemAdr:
        ADDRESS;VAR X,Y:INTEGER);
VAR	Message:IntuiMessagePtr;
BEGIN
  Message:=GetMsg(IDCMPort);
  IF Message=NIL THEN
    WaitPort(IDCMPort);
    Message:=GetMsg(IDCMPort);
  END;
  WITH Message^ DO
    FlagSet2Flags(class,Class);
    Code:=code;
    Qualifier:=qualifier;
    ItemAdr:=iAddress;
    X:=mouseX;
    Y:=mouseY;
  END;
  ReplyMsg(Message);
END GetIntuiMessage;


PROCEDURE PollMessage(IDCMPort:MsgPortPtr;VAR Class:IDCMPFlags;
	VAR Code:CARDINAL;VAR Qualifier:QualifierSet;VAR ItemAdr:ADDRESS;
        VAR X,Y:INTEGER):BOOLEAN;
VAR	Message:IntuiMessagePtr;
BEGIN
  Message:=GetMsg(IDCMPort);
  IF Message#NIL THEN
    WITH Message^ DO
      FlagSet2Flags(class,Class);
      Code:=code;
      Qualifier:=qualifier;
      ItemAdr:=iAddress;
      X:=mouseX;
      Y:=mouseY;
    END;
    ReplyMsg(Message);
    RETURN TRUE;
  ELSE
    Class:=lonelyMessage;
    Code:=0;
    Qualifier:=QualifierSet{};
    ItemAdr:=NIL;
    X:=0;
    Y:=0;
    RETURN FALSE;
  END;
END PollMessage;  

PROCEDURE EmptyIDCMP(IDCMPort:MsgPortPtr);
VAR	Message:IntuiMessagePtr;
BEGIN
  REPEAT
    Message:=GetMsg(IDCMPort);
    IF Message#NIL THEN
      ReplyMsg(Message);
    END;
  UNTIL Message=NIL;
END EmptyIDCMP;

PROCEDURE ActiveFlags(Window:WindowPtr):IDCMPFlagSet;
BEGIN
  RETURN Window^.idcmpFlags;
END ActiveFlags;

END IDCMP.
