(*********************************************************************)
(*
   :Program.
   :Author.
   :Address.
   :Phone.
   :shortcut.
   :Version.
   :Date.
   :Copyright.
   :Language.   Modula-II.
   :Translator. M2Amiga.
   :Imports.    GraphikSupport V1.0 [fst]
   :UpDate.     -
   :Contents.
   :Remark.

**********************************************************************)

MODULE ;

FROM SYSTEM             IMPORT ADR;

FROM Arts               IMPORT TermProcedure;

FROM GraphicSupport     IMPORT CreateBitMap, CreateViewPort, CreateView,
  CreateRastPort, FreeViewPort, FreeView, FreeBitMap, FreeRastPort,
  Standard, Remake, Swap;

FROM Intuition          IMPORT ViewAddress, OpenWorkBench, ScreenPtr;

FROM Graphics           IMPORT ViewPtr, ViewPortPtr, BitMapPtr, RasInfoPtr,
  RastPortPtr;

FROM MemSystem          IMPORT ErrHeader, DeadEndExit;


CONST           Depth   =   4;    (* Eigene Werte einsetzen *)
                Colors  =  16;
                Height  = 200;
                Width   = 320;
                PRGNAME = "Your PRG's Name";
                OutOfMemMsg = "Out Of Mem";

VAR             MyView: ViewPtr;
                OldView: ViewPtr;
                NewView: ViewPtr;
                MyViewPort: ViewPortPtr;
                MyBitMap: BitMapPtr;
                MyRPort: RastPortPtr;
                MyRInfo: RasInfoPtr;
                WB: ScreenPtr;

PROCEDURE MyCleanUp();
BEGIN
  FreeBitMap(MyBitMap);
  FreeViewPort(MyViewPort,MyRInfo);
  FreeRastPort(MyRPort);
  IF OldView#NIL THEN FreeView(NewView,MyView,OldView) END;
  WB:=OpenWorkBench();
END MyCleanUp;

PROCEDURE SetUp();
BEGIN
  MyBitMap := CreateBitMap(Width,Height,Depth);
  IF MyBitMap = NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyViewPort:=CreateViewPort(MyRInfo,NIL,0,0,Width,Height,
                                MyBitMap,Standard,Colors);
   IF MyViewPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyRPort:=CreateRastPort(MyBitMap);
   IF MyRPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyView:=CreateView(MyViewPort);
   IF MyView=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  OldView:=ViewAddress();
  Remake(MyView,MyViewPort);
END SetUp;

BEGIN
  SetUp; TermProcedure(MyCleanUp); ErrHeader:=PRGNAME;

END .MOD


