(*********************************************************************)
(*
   :Program.     SimpleDiskFontDemo
   :Author.      Frank Staudte. [fst]
   :Address.     Hasenbergstr. 91
   :Version.     1.0
   :Date.        11-OKT-88
   :Copyright.   PD
   :Language.    Modula-II.
   :Translator.  M2Amiga.
   :Imports.     IntuiStruct (V1.3) [bne]
   :UpDate.      -
   :Contents.    This is a very Simple Demo for OpenDiskFont()
   :Remark.      Ju-he--Ju-he----Jahr--Jahr !!!

**********************************************************************)

MODULE SimpleDiskFontDemo;

FROM SYSTEM             IMPORT ADR;
FROM Arts               IMPORT TermProcedure, Assert;
FROM IntuiStruct        IMPORT StructScreen;
FROM DiskFont           IMPORT OpenDiskFont;   (* !!!! *)
FROM Intuition          IMPORT OpenScreen, CloseScreen, customScreen,
  ScreenPtr, NewScreen;
FROM Graphics           IMPORT RastPortPtr, ViewModeSet, ViewModes,
  TextAttr, TextFontPtr, FontStyleSet, FontStyles, FontFlagSet,
  FontFlags, SetFont, Move, Text, CloseFont;

CONST           ScreenTitle = "FontDemo";
                FontName = "ruby.font";
                FontNameLength = 10;

VAR
  NuScreen: NewScreen;
  MyScreen: ScreenPtr;
  MyRPort: RastPortPtr;
  Ciaapra [0BFE001H]: SET OF (s0,s1,s2,s3,s4,s5,lmb);
  MyTextFont: TextFontPtr;
  MyTextAttr: TextAttr;

PROCEDURE CleanUp;
BEGIN
  CloseScreen(MyScreen);
END CleanUp;

PROCEDURE SetUp;
BEGIN
  StructScreen(NuScreen,3,2,1,ViewModeSet{hires},customScreen,
    ADR(ScreenTitle));
  MyScreen:=OpenScreen(NuScreen); MyRPort:=ADR(MyScreen^.rastPort);
END SetUp;

BEGIN (* Main *)
  TermProcedure(CleanUp);
  SetUp;

  WITH MyTextAttr DO
    name:=ADR(FontName);
    ySize:=20;
    style:=FontStyleSet{bold};  (* Freie Wahl!! (bold,underlined,italic,..*)
    flags:=FontFlagSet{diskFont};
  END;
  MyTextFont:=OpenDiskFont(ADR(MyTextAttr));

  IF MyTextFont = NIL THEN Assert(FALSE,ADR("Font nicht gefunden")); END;

  SetFont(MyRPort,MyTextFont);
  Move(MyRPort,100,100);
  Text(MyRPort,ADR("This is "),8);
  Text(MyRPort,ADR(FontName),FontNameLength);
  REPEAT
  UNTIL NOT (lmb IN Ciaapra);
  CloseFont(MyTextFont);
END SimpleDiskFontDemo.MOD

