(**********************************************************************

    :Program.  	 FileRequest.mod
    :Contents.	 supports file selection requesters
    :Reamrk.     similar to the DPaint(tm) "Load" funktion
    :Author.   	 Nicolas Benezan [bne]
    :Address.    Postwiesenstr. 2, D7000 Stuttgart 60
    :Phone.      711/333679
    :Copyright.  Shareware (see Copyright File !)
    :Language. 	 Modula-2
    :Translator. M2Amiga AMSoft
    :Imports.	 IntuiStruct1.3, SuperLists1.3, DosSopport, IDCMP [bne]
    :Imports.	 Stack [mif]
    :ModHistory. V1.0c [bne] 01.Nov.88
    
**********************************************************************)

IMPLEMENTATION MODULE FileRequest;

FROM IntuiStruct IMPORT StructText,StructGadget,StructString,StructProp,
		StructBorder,Rectangle,BorderEnd,StructRequest,Word,
                StructImage,ImageEnd,FreeImage,FreeBorder;
FROM Intuition	IMPORT Gadget,StringInfo,PropInfo,PropInfoFlags,
		PropInfoFlagSet,GadgetFlags,GadgetFlagSet,ActivationFlags,
                ActivationFlagSet,Requester,RequesterPtr,Border,
                DrawBorder,Request,boolGadget,reqGadget,propGadget,
                strGadget,GadgetPtr,IntuiText,Image,gadgHNone,IDCMPFlags,
                IDCMPFlagSet,EndRequest,OnGadget,OffGadget,WindowPtr,
                RefreshGList,ModifyIDCMP;
FROM SuperLists IMPORT SuperList,EntryPtr,Directions,RethinkList,RefreshList,
		RedrawEntry,ScrollList,MakeEntry,GetEntry,ClickRow,
                GetProp,SetProp,InsertEntry,RemoveEntry,showIt,hideIt,
                deallocIt,newList,oldList,SuperListPtr,ClearList;
FROM SYSTEM	IMPORT ADR,ADDRESS,LONGSET;
FROM Dos	IMPORT FileLockPtr,CurrentDir,ParentDir,Examine,ExNext,
		FileInfoBlockPtr,Lock,UnLock,sharedLock,DeviceListType;
FROM DosSupport	IMPORT GetDevList,BSTRtoStr,BPTRtoADR,DeviceListPtr;
FROM Graphics	IMPORT jam1,jam2,RastPortPtr,TextFont;
FROM ExecSupport IMPORT NewList;
FROM Strings	IMPORT Insert,Occurs,Length,Copy,last;
FROM Exec	IMPORT MsgPortPtr,Forbid,Permit;
FROM IDCMP	IMPORT GetIntuiMessage,ActiveFlags;
FROM Arts	IMPORT Assert;
FROM Stack	IMPORT Init,Write,Read,Empty,Discard,stack;
FROM InputEvent	IMPORT QualifierSet;

TYPE	String=ARRAY [0..255] OF CHAR;
CONST	NoExcl=LONGSET{};
VAR	OkFrame1,OkFrame2,ListFrame,ReqFrame:Border;
	VolumeText,RootText,ParentText,OkText,CancelText:IntuiText;
        Knob:Image;
        Prop:PropInfo;
        FileRequester:Requester;
        PathBuffer,UndoBuffer:String;
        List:SuperList;

PROCEDURE FailAllocate(VAR Dummy1:ADDRESS;Dummy2:LONGINT);
BEGIN
  Assert(FALSE,ADR("FileRequest: No AllocProc installed"));
END FailAllocate;

PROCEDURE FailDeallocate(VAR Dummy1:ADDRESS);
BEGIN
  Assert(FALSE,ADR("FileRequest: No DeallocProc installed"));
END FailDeallocate;

PROCEDURE InitStdGadgets(ActionText:ADDRESS;Requester:BOOLEAN):GadgetPtr;
VAR	ReqFlag:CARDINAL;

  PROCEDURE InitGadget(VAR Gadg:Gadget;VAR IText:IntuiText;Text:ADDRESS;
		TopEdge,ID:INTEGER;Next:GadgetPtr);
  BEGIN
    StructGadget(Gadg,-80,TopEdge,60,12,GadgetFlagSet{gRelRight},
      ActivationFlagSet{relVerify},boolGadget+reqGadget,
      ADR(OkFrame1),ADR(IText),NoExcl,ID,Next);
    StructText(IText,1,0,jam2,2,2,Text,NIL);
  END InitGadget;

BEGIN
  IF Requester THEN
    ReqFlag:=reqGadget;
  ELSE
    ReqFlag:=0;
  END;
  StructBorder(OkFrame1,0,0,1,jam1,4,ADR(OkFrame2));
  Rectangle(60,12);
  BorderEnd;
  StructBorder(OkFrame2,1,1,0,jam1,4,NIL);
  Rectangle(58,10);
  BorderEnd;
  InitGadget(VolumeGadg,VolumeText,ADR("Volumes"),6,VolumeID,ADR(RootGadg));
  InitGadget(RootGadg,RootText,ADR("Root   "),20,RootID,ADR(ParentGadg));
  InitGadget(ParentGadg,ParentText,ADR("Parent "),34,ParentID,ADR(OkGadg));
  InitGadget(OkGadg,OkText,ActionText,48,OkID,ADR(CancelGadg));
  InitGadget(CancelGadg,CancelText,ADR("Cancel "),-18,CancelID,ADR(PathGadg));
  INCL(CancelGadg.flags,gRelBottom);
  StructGadget(PathGadg,9,6,273,8,GadgetFlagSet{},
    ActivationFlagSet{relVerify},strGadget+ReqFlag,
    NIL,NIL,NoExcl,PathID,NIL);
  PathGadg.specialInfo:=ADR(PathInfo);
  StructString(PathInfo,PathBuffer,UndoBuffer);
  StructImage(UpImage,0,0,16,8,1,{0},{},NIL);
  Word(1111111111111111L);
  Word(1111111001111111L);
  Word(1111110000111111L);
  Word(1111100000011111L);
  Word(1111000000001111L);
  Word(1110000000000111L);
  Word(1100000000000011L);
  Word(1111111111111111L);
  ImageEnd;
  StructImage(DownImage,0,0,16,8,1,{0},{},NIL);
  Word(1111111111111111L);
  Word(1100000000000011L);
  Word(1110000000000111L);
  Word(1111000000001111L);
  Word(1111100000011111L);
  Word(1111110000111111L);
  Word(1111111001111111L);
  Word(1111111111111111L);
  ImageEnd;
  StructGadget(UpGadg,296,6,16,8,GadgetFlagSet{gadgImage},
    ActivationFlagSet{relVerify},boolGadget+ReqFlag,
    ADR(UpImage),NIL,NoExcl,UpID,ADR(DownGadg));
  StructGadget(DownGadg,296,66,16,8,GadgetFlagSet{gadgImage},
    ActivationFlagSet{relVerify},boolGadget+ReqFlag,
    ADR(DownImage),NIL,NoExcl,DownID,ADR(VolumeGadg));
  StructGadget(ScrollGadg,296,14,16,52,GadgetFlagSet{gadgImage}+gadgHNone,
    ActivationFlagSet{relVerify},propGadget+ReqFlag,
    ADR(Knob),NIL,NoExcl,PropID,ADR(UpGadg));
  ScrollGadg.specialInfo:=ADR(Prop);
  StructProp(Prop,PropInfoFlagSet{autoKnob,freeVert},0,0,0,0FFFFH);
  StructGadget(BoxGadg,StdBoxLeft,StdBoxTop,StdBoxWidth,StdBoxHeight,
    gadgHNone,ActivationFlagSet{relVerify},boolGadget+ReqFlag,
    ADR(ListFrame),NIL,NoExcl,BoxID,ADR(ScrollGadg));
  StructBorder(ListFrame,-1,-1,1,jam1,4,NIL);
  Rectangle(StdBoxWidth+2,StdBoxHeight+2);
  BorderEnd;
  RETURN ADR(BoxGadg);
END InitStdGadgets;

PROCEDURE InitList(RastPort:RastPortPtr);
BEGIN
  WITH SelectList^ DO
    NewList(ADR(list));
    rastPort:=RastPort;
    backPen:=0;
    propX:=NIL;
    propY:=ADR(ScrollGadg);
    leftEdge:=StdBoxLeft;
    topEdge:=StdBoxTop;
    width:=StdBoxWidth;
    height:=StdBoxHeight;
    WITH RastPort^.font^ DO
      FontXsize:=xSize;
      FontYsize:=ySize;
      FontBaseLine:=baseline;
    END;
    dispRow:=0;
    dispColumn:=0;
  END;
  RethinkList(SelectList,newList);
END InitList;

PROCEDURE ResizeList(Left,Top,Width,Height:INTEGER);
BEGIN
  WITH SelectList^ DO
    leftEdge:=Left;
    topEdge:=Top;
    width:=Width;
    height:=Height;
  END;
  RethinkList(SelectList,oldList);
  FreeBorder(ListFrame);
  StructBorder(ListFrame,-1,-1,1,jam1,4,NIL);
  Rectangle(Width+2,Height+2);
  BorderEnd;
  WITH BoxGadg DO
    leftEdge:=Left;
    topEdge:=Top;
    width:=Width;
    height:=Height;
  END;
  RefreshList(SelectList);
  DrawBorder(SelectList^.rastPort,ADR(ListFrame),Left,Top);
END ResizeList;

PROCEDURE BuildRequest(Left,Top,Width,Height:INTEGER;
		GadgetStrip:GadgetPtr):RequesterPtr;
BEGIN
  StructRequest(FileRequester,Left,Top,Width,Height,GadgetStrip,
    ADR(ReqFrame),NIL,0);
  StructBorder(ReqFrame,0,0,1,jam1,4,NIL);
  Rectangle(Width,Height);
  BorderEnd;
  RETURN ADR(FileRequester);
END BuildRequest;

PROCEDURE StdHandler(Class:IDCMPFlags;Code:CARDINAL;Qualifier:QualifierSet;
		iAddress:ADDRESS;X,Y:INTEGER);
END StdHandler;

PROCEDURE GetPath(File:FileLockPtr;VAR Path:ARRAY OF CHAR);
VAR	Info:FileInfoBlockPtr;
	Ok:BOOLEAN;
BEGIN
  Path:="";
  Ok:=FALSE;
  AllocProc(Info,SIZE(Info^));
  IF Info#NIL THEN
    WHILE File#NIL DO
      IF (Examine(File,Info)#0) AND (Info^.dirEntryType>0) THEN
        Insert(Path,0,"/");
        Insert(Path,0,Info^.fileName);
        Ok:=TRUE;
      END;
      File:=ParentDir(File);
    END;
    IF Ok THEN
      Path[Occurs(Path,0,"/",FALSE)]:=":";
    END;
    DeallocProc(Info);
  END;
END GetPath;

PROCEDURE ReadDeviceList(List:SuperListPtr;Types:DeviceListTypeSet);
VAR	DevList:DeviceListPtr;
	Entry:EntryPtr;
        VolName:ARRAY [0..30] OF CHAR;
BEGIN
  Forbid;
  DevList:=GetDevList();
  WHILE DevList#NIL DO
    WITH DevList^ DO
      IF type IN Types THEN
        BSTRtoStr(name,VolName);
        Insert(VolName,last,":");
        Entry:=MakeEntry(ADR(VolName),1,0,jam1);
        WITH Entry^ DO
          userFlags:={dev};
          userData:=node.pri-1;
        END;
        InsertEntry(SelectList,Entry,-1,showIt);
      END;
      DevList:=BPTRtoADR(next);
    END;
  END;
  Permit;
END ReadDeviceList;
  
PROCEDURE ReadDirectory(List:SuperListPtr;InsertAt:INTEGER;Dir:FileLockPtr;
		CreateEntry:CreateEntryProc);
VAR	OldDir:FileLockPtr;
	Info:FileInfoBlockPtr;
        Entry:EntryPtr;
        Increment:BOOLEAN;
BEGIN
  Increment:=InsertAt>0;
  IF Dir#NIL THEN
    OldDir:=CurrentDir(Dir);
    AllocProc(Info,SIZE(Info^));
    IF Info#NIL THEN
      IF Examine(Dir,Info)#0 THEN
        WHILE ExNext(Dir,Info)#NIL DO
          Entry:=CreateEntry(Info);
          IF Entry#NIL THEN
            InsertEntry(SelectList,Entry,InsertAt,showIt);
            IF Increment THEN
              INC(InsertAt);
            END;
          END;
        END;
      END;
      DeallocProc(Info);
    END;
  END;
END ReadDirectory;
  
PROCEDURE RequestFile(VAR Dir:FileLockPtr;VAR Name:ARRAY OF CHAR;
		Window:WindowPtr;Requester:RequesterPtr;CreateEntry:
                CreateEntryProc;OtherMsgHandler:MsgHandler):BOOLEAN;
CONST	MyIDCMPFlags=IDCMPFlagSet{gadgetUp};
VAR	Ok:BOOLEAN;
	IDCMPort:MsgPortPtr;
        Path:String;
        Class:IDCMPFlags;
        Code:CARDINAL;
        Qualifier:QualifierSet;
        Item:ADDRESS;
        OffsetX,OffsetY,X,Y,Row,LastSelect:INTEGER;
        ItemPtr:GadgetPtr;
        Entry,LastEntry:EntryPtr;
        StringPtr:POINTER TO String;
        OldDir:FileLockPtr;
        LockStack:stack;
        Info:FileInfoBlockPtr;
        OldIDCMPFlags:IDCMPFlagSet;

  PROCEDURE NewProp;
  BEGIN
    SetProp(SelectList,Window,Requester);
  END NewProp;
  
  PROCEDURE EmptyList;
  BEGIN
    ClearList(SelectList,showIt);
  END EmptyList;
  
  PROCEDURE Deselect;
  BEGIN
    LastSelect:=-1;
    OffGadget(ADR(OkGadg),Window,Requester);
  END Deselect;
    
  PROCEDURE ReadDir(Dir:FileLockPtr);
  BEGIN
    EmptyList;
    Deselect;
    ReadDirectory(SelectList,-1,Dir,CreateEntry);
    NewProp;
  END ReadDir;
  
  PROCEDURE PrintPath;
  VAR	Len,Width:INTEGER;
  BEGIN
    Forbid;
    UndoBuffer:=PathBuffer;
    PathBuffer:=Path;
    Len:=Length(Path);
    Width:=PathGadg.width DIV 8;
    WITH PathInfo DO
      undoPos:=dispPos;
      IF Len>Width THEN
        dispPos:=Len-Width;
      ELSE
        dispPos:=0;
      END;
      bufferPos:=Len;
      numChars:=Len;
      dispCount:=Len-dispPos;
    END;
    Permit;
    RefreshGList(ADR(PathGadg),Window,Requester,1);
  END PrintPath;

  PROCEDURE NewPath(Dir:FileLockPtr);
  BEGIN
    Deselect;
    GetPath(Dir,Path);
    PrintPath;
  END NewPath;
  
  PROCEDURE Volumes;
  BEGIN
    Deselect;
    EmptyList;
    ReadDeviceList(SelectList,DeviceListTypeSet{volume});
    Path:="";
    PrintPath;
    NewProp;
  END Volumes;
  
  PROCEDURE OtherMsg;
  BEGIN
    OtherMsgHandler(Class,Code,Qualifier,Item,X,Y);
  END OtherMsg;
  
  PROCEDURE RememberLock(FileName:ADDRESS):FileLockPtr;
  VAR	NewLock:FileLockPtr;
  BEGIN
    NewLock:=Lock(FileName,sharedLock);
    IF NewLock#NIL THEN
      Write(LockStack,NewLock);
    END;
    RETURN NewLock;
  END RememberLock;
  
  PROCEDURE FreeAllLocks;
  VAR	OldLock:FileLockPtr;
  BEGIN
    WHILE NOT Empty(LockStack) DO
      Read(LockStack,OldLock);
      UnLock(OldLock);
    END;
  END FreeAllLocks;
  
BEGIN
  Ok:=FALSE;
  Init(LockStack);
  IDCMPort:=Window^.userPort;
  OldIDCMPFlags:=ActiveFlags(Window);
  ModifyIDCMP(Window,OldIDCMPFlags+MyIDCMPFlags);
  IF Dir#NIL THEN
    NewPath(Dir);
    ReadDir(Dir);
  ELSE
    Volumes;
  END;
  IF Requester#NIL THEN
    OffsetX:=Requester^.leftEdge;
    OffsetY:=Requester^.topEdge;
  ELSE
    OffsetX:=0;
    OffsetY:=0;
  END;
  LOOP
    GetIntuiMessage(IDCMPort,Class,Code,Qualifier,Item,X,Y);
    IF Class=gadgetUp THEN
      ItemPtr:=Item;
      CASE ItemPtr^.gadgetID OF
        |PathID:
          Path:=PathBuffer;
          OldDir:=Dir;
          Dir:=RememberLock(ADR(Path));
          IF Dir#NIL THEN
            AllocProc(Info,SIZE(Info^));
            IF Info#NIL THEN
              IF Examine(Dir,Info)#0 THEN
                OldDir:=CurrentDir(Dir);
                IF Info^.dirEntryType>0 THEN
                  NewPath(Dir);
                  ReadDir(Dir);
                ELSE
                  Copy(Name,Info^.fileName,0,107);
                  DeallocProc(Info);
                  Ok:=TRUE;
                  EXIT
                END;
              ELSE
                Dir:=OldDir;
              END;
              DeallocProc(Info);
            ELSE
              Dir:=OldDir;
            END;
          ELSE
            Dir:=OldDir;
          END;
        |BoxID:
          Row:=ClickRow(SelectList,X-OffsetX,Y-OffsetY);
          IF Row#-1 THEN
            Entry:=GetEntry(SelectList,Row);
            WITH Entry^ DO
              IF dev IN userFlags THEN
                StringPtr:=node.name;
                Copy(Path,StringPtr^,0,userData);
                Insert(Path,last,":");
                Dir:=RememberLock(ADR(Path));
                OldDir:=CurrentDir(Dir);
                NewPath(Dir);
                ReadDir(Dir);
              ELSIF dir IN userFlags THEN
                Dir:=CurrentDir(Dir);
                StringPtr:=node.name;
                Copy(Path,StringPtr^,0,userData);
                Dir:=RememberLock(ADR(Path));
                NewPath(Dir);
                ReadDir(Dir);
              ELSE
                backPen:=1;
                frontPen:=0;
                RedrawEntry(SelectList,Row);
                StringPtr:=node.name;
                Copy(Name,StringPtr^,0,userData);
                OnGadget(ADR(OkGadg),Window,Requester);
                IF (LastSelect#-1)AND(LastSelect#Row) THEN
                  LastEntry:=GetEntry(SelectList,LastSelect);
                  WITH LastEntry^ DO
                    backPen:=0;
                    frontPen:=1;
                  END;
                  RedrawEntry(SelectList,LastSelect);
                END;
                LastSelect:=Row;
              END;
            END;
          END;
        |UpID: ScrollList(SelectList,Up); NewProp;
        |DownID: ScrollList(SelectList,Down); NewProp;
        |PropID: GetProp(SelectList); RefreshList(SelectList);
        |VolumeID: 
          Volumes;
          Dir:=NIL;
        |RootID:
          IF Dir#NIL THEN
            REPEAT
              OldDir:=Dir;
              Dir:=ParentDir(Dir);
            UNTIL Dir=NIL;
            Dir:=OldDir;
            NewPath(Dir);
            ReadDir(Dir);
          END;
        |ParentID:
          IF Dir#NIL THEN
            OldDir:=Dir;
            Dir:=ParentDir(Dir);
            IF Dir=NIL THEN
              Dir:=OldDir;
            END;
            NewPath(Dir);
            ReadDir(Dir);
          END;
        |OkID: Ok:=TRUE; EXIT;
        |CancelID: EXIT;
      ELSE
        OtherMsg;
      END;
    ELSE
      OtherMsg;
    END;
  END;
  ClearList(SelectList,hideIt);
  FreeAllLocks;
  Discard(LockStack);
  ModifyIDCMP(Window,OldIDCMPFlags);
  RETURN Ok;
END RequestFile;

PROCEDURE CreateStdEntry(Info:FileInfoBlockPtr):EntryPtr;
VAR     FileName:ARRAY [0..34] OF CHAR;
        SubDir:BOOLEAN;
        Entry:EntryPtr;
BEGIN
  Copy(FileName,Info^.fileName,0,34);
  SubDir:=Info^.dirEntryType>0;
  IF SubDir THEN
    Insert(FileName,last," (dir)");
  END;
  Entry:=MakeEntry(ADR(FileName),1,0,jam2);
  WITH Entry^ DO
    IF SubDir THEN
      userFlags:={dir};
      userData:=node.pri-6;
    ELSE
      userFlags:={file};
      userData:=node.pri;
    END;
  END;
  RETURN Entry;
END CreateStdEntry;

BEGIN
  AllocProc:=FailAllocate;
  DeallocProc:=FailDeallocate;
  SelectList:=ADR(List);
END FileRequest.
