(**********************************************************************
   :Program.    AddBitPlaneTest
   :Author.     Frank Staudte. [fst]
   :Address.    Hasenbergstr. 91 D-7000 Stuttgart 1
   :modHistory  17-APR-89 V1.0
   :Copyright.  (C) Frank Staudte 1989. This is in the public domain.
   :Language.   Modula-II.
   :Translator. M2Amiga. V3.2d
   :Imports.    GraphicSupportV1.2
   :Remark.     Please read the Copyright-file about copyright!!!
   :Contains.   Demo/Test of AddBitPlane/FreeBitPlane.
**********************************************************************)
MODULE AddBitPlaneTest;

FROM GraphicSupport IMPORT
 AddBitPlane, FreeBitPlane, CreateBitMap, FreeBitMap;
FROM Exec IMPORT
 AvailMem, MemReqSet, MemReqs, UByte;
FROM Graphics IMPORT
 BitMapPtr;
FROM InOut IMPORT
 WriteString, WriteLn, WriteInt;

VAR  BitMap: BitMapPtr;
     StartMem, OldMem, NewMem: LONGINT;

PROCEDURE PrintFreeMem();
 BEGIN
 WriteLn;
  WriteString("Available ChipMem: "); WriteLn;
  OldMem:=NewMem; NewMem:=AvailMem(MemReqSet{chip});
  WriteString("OldMem was:     "); WriteInt(OldMem,6); WriteLn;
  WriteString("NewMem is:      "); WriteInt(NewMem,6); WriteLn;
  WriteString("Difference is:  "); WriteInt(NewMem-OldMem,6);
  WriteLn;
 END PrintFreeMem;

PROCEDURE PrintDepth();
 BEGIN
  WriteLn; WriteString("Depth-Paramer is: ");
  WriteInt(INTEGER(BitMap^.depth),3);
  WriteLn;
 END PrintDepth;

BEGIN
  WriteString("AddBitPlane/FreeBitPlane Test/Demo"); WriteLn; WriteLn;

  PrintFreeMem; StartMem:=NewMem;

  WriteString("Createing a BitMap: Size: 300 * 200; depth = 2"); WriteLn;
  BitMap:=CreateBitMap(300,200,2);

  PrintFreeMem; PrintDepth;

  WriteString("Adding one Plane to BitMap:"); WriteLn;
  IF AddBitPlane(BitMap,1) THEN
    WriteString("One BitMap added"); WriteLn;
  ELSE
    WriteString("Adding failed"); WriteLn;
  END;
  PrintFreeMem; PrintDepth;

  WriteLn;
  WriteString("Now I try to add 6 BitPlanes to BitMap. Supposed to fail");
  WriteLn;
  IF AddBitPlane(BitMap,6) THEN
    WriteString("Adding done"); WriteLn;
    PrintDepth;
  ELSE
    WriteString("can't add the 6 planes!"); WriteLn;
    PrintDepth;
  END;

  WriteLn; WriteLn;
  PrintFreeMem; PrintDepth;
  WriteString("Now I Free one BitMap. Pay attention to FreeMem & Depth!");
  WriteLn;
  IF FreeBitPlane(BitMap,1) THEN
    WriteString("Freeing was successful"); WriteLn;
  ELSE
    WriteString("Error while Freeing"); WriteLn;
  END;
  PrintFreeMem; PrintDepth; WriteLn;

  WriteString("Now I try to free 5 BitPlanes. Supposed to fail"); WriteLn;
  IF FreeBitPlane(BitMap,5) THEN
    WriteString("Freeing was successful"); WriteLn;
    PrintFreeMem; PrintDepth;
  ELSE
    WriteString("Can't free 5 BitPlanes"); WriteLn;
  END;
  PrintFreeMem; PrintDepth;

  WriteLn; WriteLn;
  WriteString("Now I Free the whole BitMap via FreeBitMap");
  FreeBitMap(BitMap);
  PrintFreeMem; PrintDepth;

  WriteString("Total difference in memory: (start-end): ");
  WriteInt(StartMem-AvailMem(MemReqSet{chip}),3);
  WriteLn; WriteLn;

  WriteString("By now"); WriteLn;

END AddBitPlaneTest.MOD
