(*********************************************************************)
(*
   :Program.    DBuffDemo
   :Author.     Frank Staudte [fst]
   :Address.    Hasenbergstr. 91 D-7000 Stuttgart 1
   :History.    V1.1 for GS V1.0 03-SEP-89 [fst]
   :History.    V1.2 for GS V1.3 30-MAY-89 [fst]
   :Copyright.  PD
   :Language.   Modula-II.
   :Translator. M2Amiga V3.2d.
   :Imports.    GraphicSupport V1.3 [fst]; ErrorReq V1.2 [bne]

**********************************************************************)

MODULE DBuffDemo;

FROM SYSTEM             IMPORT ADR;
FROM Arts               IMPORT TermProcedure;
FROM GraphicSupport     IMPORT CreateBitMap, CreateViewPort, CreateView,
  CreateRastPort, FreeViewPort, FreeView, FreeBitMap, FreeRastPort,
  Standard, Remake, Swap;
FROM Intuition          IMPORT ViewAddress, OpenWorkBench, ScreenPtr;
FROM Graphics           IMPORT ViewPtr, ViewPortPtr, BitMapPtr, RasInfoPtr,
  RastPortPtr, Move, Draw, SetAPen, Text, WaitTOF;
FROM ErrorReq           IMPORT ErrHeader, DeadEndExit;
FROM Dos                IMPORT Delay;


CONST           Depth   =   3;
                Colors  =   8;
                Height  = 200; (* IF PAL THEN 256!! *)
                Width   = 320;
                PRGNAME = "DBuffDemo";
                OutOfMemMsg = "Kein freier Speicher";

VAR             MyView: ViewPtr;
                OldView: ViewPtr;
                NewView: ViewPtr;
                MyViewPort: ViewPortPtr;
                MyBitMap1: BitMapPtr;
                MyBitMap2: BitMapPtr;
                MyRPort: RastPortPtr;
                MyRInfo: RasInfoPtr;
                WB: ScreenPtr;
                Ciaapra [0BFE001H]: SET OF (s0,s1,s2,s3,s4,s5,lmb);

PROCEDURE MyCleanUp();
BEGIN
  FreeBitMap(MyBitMap1);
  FreeBitMap(MyBitMap2);
  FreeViewPort(MyViewPort,MyRInfo);
  FreeRastPort(MyRPort);
  IF OldView#NIL THEN FreeView(NewView,MyView,OldView) END;
  WB:=OpenWorkBench();
END MyCleanUp;

PROCEDURE SetUp();
BEGIN
  MyBitMap1 := CreateBitMap(Width,Height,Depth);
  IF MyBitMap1 = NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyBitMap2 := CreateBitMap(Width,Height,Depth);
  IF MyBitMap2 = NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyViewPort:=CreateViewPort(MyRInfo,NIL,0,0,Width,Height,
                                MyBitMap2,Standard,Colors);
   IF MyViewPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyRPort:=CreateRastPort(MyBitMap1);
   IF MyRPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyView:=CreateView(MyViewPort);
   IF MyView=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  OldView:=ViewAddress();
  Remake(MyView,MyViewPort);
END SetUp;

PROCEDURE MyWait;
VAR     i: INTEGER;
BEGIN
  FOR i:=0 TO 15 DO
    WaitTOF;
  END;
END MyWait;

BEGIN
  SetUp; TermProcedure(MyCleanUp); ErrHeader:=PRGNAME;

  SetAPen(MyRPort,1); Move(MyRPort,75,90);
  Text(MyRPort,ADR("Dies ist BitMap Nummer 1"),24);

  Delay(50); WaitTOF; Swap(MyRPort,MyViewPort^.rasInfo);
  Remake(MyView,MyViewPort);

  SetAPen(MyRPort,2); Move(MyRPort,75,110);
  Text(MyRPort,ADR("Dies ist BitMap Nummer 2"),24);

  REPEAT
    MyWait; Swap(MyRPort,MyViewPort^.rasInfo);
    Remake(MyView,MyViewPort);
  UNTIL NOT(lmb IN Ciaapra);
END DBuffDemo.MOD


