(*********************************************************************)
(*
   :Program.    DualPFDemo
   :Author.     Frank Staudte [fst]
   :History.    V1.0 for GS V1.0 04-SEP-88 [fst]
   :History.    V1.1 for GS V1.1 30-MAY-89 [fst]
   :Copyright.  PD
   :Language.   Modula-II.
   :Translator. M2Amiga V3.2d
   :Imports.    GraphicSupport V1.2 [fst], MemSystem V1.3 [bne]
   :Imports.    ErrorReq V1.2 [bne]

**********************************************************************)

MODULE DualPFDemo;

FROM SYSTEM             IMPORT ADR;
FROM Arts               IMPORT TermProcedure;
FROM GraphicSupport     IMPORT CreateBitMap, CreateViewPort, CreateView,
  CreateRastPort, FreeViewPort, FreeView, FreeBitMap, FreeRastPort,
  Standard, dualPF, Remake, Swap, MakeVPDualPF;
FROM Intuition          IMPORT ViewAddress, OpenWorkBench, ScreenPtr;
FROM Graphics           IMPORT ViewPtr, ViewPortPtr, BitMapPtr, RasInfoPtr,
  RastPortPtr, SetAPen, Draw, Move, Text;
FROM ErrorReq           IMPORT ErrHeader, DeadEndExit;
FROM MemSystem          IMPORT Deallocate;

CONST           Depth   =   2;
                Colors  =   4;
                Height  = 200; (* Set this to 256 if your Amiga is Pal *)
                Width   = 320;
                PRGNAME = "DualPFDemo";
                OutOfMemMsg = "Out Of Memory";

VAR             MyView: ViewPtr;
                OldView: ViewPtr;
                NewView: ViewPtr;
                MyViewPort: ViewPortPtr;
                MyBitMap1: BitMapPtr;
                MyBitMap2: BitMapPtr;
                MyRPort: RastPortPtr;
                MyRInfo1: RasInfoPtr;
                MyRInfo2: RasInfoPtr;
                WB: ScreenPtr;
                loop: INTEGER;
                Ciaapra [0BFE001H]: SET OF (s0,s1,s2,s3,s4,s5,lmb);

PROCEDURE MyCleanUp();
BEGIN
  FreeBitMap(MyBitMap1);
  FreeBitMap(MyBitMap2);
  Deallocate(MyRInfo2);
  FreeViewPort(MyViewPort,MyRInfo1);
  FreeRastPort(MyRPort);
  IF OldView#NIL THEN FreeView(NewView,MyView,OldView) END;
  WB:=OpenWorkBench();
END MyCleanUp;

PROCEDURE SetUp();
BEGIN
  MyBitMap1 := CreateBitMap(Width,Height,Depth);
  IF MyBitMap1 = NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyBitMap2 := CreateBitMap(Width,Height,Depth);
  IF MyBitMap2 = NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyViewPort:=CreateViewPort(MyRInfo1,NIL,0,0,Width,Height,
                                MyBitMap1,Standard,Colors);
   IF MyViewPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyRPort:=CreateRastPort(MyBitMap1);
   IF MyRPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyView:=CreateView(MyViewPort);
   IF MyView=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  OldView:=ViewAddress();
END SetUp;

BEGIN
  SetUp; TermProcedure(MyCleanUp); ErrHeader:=PRGNAME;

  MyRInfo2:=MakeVPDualPF(MyViewPort,MyBitMap2);      (* !!!!!! <--- *)

  SetAPen(MyRPort,1);


  Move(MyRPort,75,100); Text(MyRPort,ADR("BitMap1 "),8);

  MyRPort^.bitMap:=MyBitMap2;

  Move(MyRPort,75,150); Text(MyRPort,ADR("BitMap2 "),8);

  Remake(MyView,MyViewPort);

  REPEAT
  UNTIL NOT(lmb IN Ciaapra);
END DualPFDemo.MOD


