(**********************************************************************
   :Program.    ScrollGP
   :Author.     Frank Staudte. [fst]
   :Address.    Hasenbergstr. 91 D-7000 Stuttgart 1
   :Support.    [bne] & [pit] Thanks!
   :History.    V1.0 GS V1.0 24-AUG-88 [fst]
   :History.    V1.1 GS V1.3 30-MAY-89 [fst]
   :Copyright.  PD. Use it, as you like, but please leave my name in!!
   :Language.   Modula-II.
   :Translator. M2Amiga V3.2d
   :Contents.   Demo. This is not the same as on Amok#6!!
   :Usage.      ScrollDemo NameOfOversizePicture
**********************************************************************)

MODULE ScrollDemo;

FROM SYSTEM     IMPORT ADR, ADDRESS;
FROM Arguments  IMPORT NumArgs, GetArg;
FROM Arts       IMPORT TermProcedure, BreakPoint, Assert;
FROM Graphics   IMPORT RastPortPtr, ViewPtr, ViewPortPtr, BitMapPtr,
                       Move, Draw, SetAPen, Text, BitMap, InitBitMap,
                       BltClear, AllocRaster, GfxBase, LoadView, MakeVPort,
                       MrgCop, RasInfoPtr, LoadRGB4;
FROM GraphicSupport
                IMPORT CreateBitMap, CreateRastPort, CreateViewPort,
                       CreateView, FreeBitMap, FreeViewPort, FreeView,
                       Swap, Remake, FreeRastPort, Standard, ScrollVPort,
                       ReadILBMBitMap, SetILBMColors, ILBMColors, RasSize,
                       FreeILBMBitMap;
FROM Intuition  IMPORT OpenWorkBench, ScreenPtr, ViewAddress, IntuitionBase,
                       WindowPtr;
FROM Exec       IMPORT OpenLibrary, CloseLibrary, LibraryPtr;

CONST
  NumberOFColors = 32;
  DEPTH          = 4;
  WIDTH          = 320;
  HEIGHT         = 200;  (* Please Set to 256 if you have a PAL-Amiga *)

VAR
  MyView, OldView, NewView: ViewPtr;
  MyViewPort: ViewPortPtr;
  MyBitMap: BitMapPtr;
  MyBitMap2: BitMapPtr;
  MyRPort: RastPortPtr;
  MyRInfo: RasInfoPtr;
  WBScreen: ScreenPtr;
  i: INTEGER;
  Name: ARRAY[0..79] OF CHAR;
  length: INTEGER;
  Intuitionbase: POINTER TO IntuitionBase;
  oldX,oldY,newX,newY: INTEGER;
  Ciaapra [0BFE001H]: SET OF (s0,s1,s2,s3,s4,s5,lmb);
  Opend: BOOLEAN;
  w,h,d: INTEGER;
  MyColors: ARRAY [0..NumberOFColors] OF CARDINAL;
  Colors: ILBMColors;
  err: BOOLEAN;

PROCEDURE MyCleanUp();
BEGIN
  FreeViewPort(MyViewPort,MyRInfo);
  FreeILBMBitMap(MyBitMap);
  FreeView(NewView,MyView,OldView);
  FreeRastPort(MyRPort);
  IF OldView # NIL THEN LoadView(OldView) END;
  WBScreen:=OpenWorkBench();
  CloseLibrary(ADDRESS(Intuitionbase));
END MyCleanUp;

BEGIN
  Opend:=FALSE;
  TermProcedure(MyCleanUp);

  Intuitionbase := ADDRESS(OpenLibrary(ADR("intuition.library"),0));
  Opend:=TRUE;

  IF NumArgs()#0 THEN
    GetArg(1,Name,length);
  ELSE
    HALT;
  END;

  MyBitMap:=ReadILBMBitMap(Name,w,h,d,Colors,err);
  IF (MyBitMap = NIL) OR err THEN Assert(TRUE,ADR("Error in ILBM")) END;

  MyRPort:=CreateRastPort(MyBitMap);
  Assert(MyRPort#NIL,ADR("kein RastPort"));
  MyViewPort:=CreateViewPort(MyRInfo,NIL,0,10,WIDTH,HEIGHT,MyBitMap,Standard,16);
  Assert(MyViewPort#NIL,ADR("kein ViewPort"));
  MyView:=CreateView(MyViewPort);
  Assert(MyView#NIL,ADR("kein View"));
  OldView:=ViewAddress();
  SetILBMColors(MyViewPort,Colors);
  Remake(MyView,MyViewPort);

  WITH Intuitionbase^ DO
    oldX := mouseX; oldY := mouseY;
    REPEAT
      newX := mouseX; newY := mouseY;
      IF ScrollVPort(MyViewPort,MyRInfo,newX-oldX,newY-oldY) THEN END;
      oldX := newX; oldY := newY;
      Remake(MyView,MyViewPort);
    UNTIL NOT(lmb IN Ciaapra);
  END;

END ScrollDemo.MOD
