(*********************************************************************)
(*
   :Program.    SimpleDemo
   :Author.     Frank Staudte [fst]
   :History.    V1.0  9-OKT-88 [fst] Demo for GraphSupp V1.0
   :History.    V1.1 30-MAY-89 [fst] Demo for GraphSupp V1.2 m2c V3.2
   :Copyright.  PD - no commercial use
   :Language.   Modula-II.
   :Translator. M2Amiga V3.2d.
   :Imports.    GraphicSupport V1.2 [fst], ErrorReq V1.2 [bne]
   :Contents.   Simple Demo of the Graphic Primitives.

**********************************************************************)

MODULE SimpleDemo;

FROM SYSTEM             IMPORT ADR;
FROM Arts               IMPORT TermProcedure;
FROM GraphicSupport     IMPORT CreateBitMap, CreateViewPort, CreateView,
  CreateRastPort, FreeViewPort, FreeView, FreeBitMap, FreeRastPort,
  Standard, Remake;
FROM Intuition          IMPORT ViewAddress, OpenWorkBench, ScreenPtr;
FROM Graphics           IMPORT ViewPtr, ViewPortPtr, BitMapPtr, RasInfoPtr,
  RastPortPtr, SetAPen, Draw, Move, Text;
FROM ErrorReq           IMPORT ErrHeader, DeadEndExit;  (* This is new *)
FROM Dos                IMPORT Delay;

CONST           Depth   =   4;
                Colors  =  16;
                Height  = 200; (* Set this to 256 if your Amiga is PAL *)
                Width   = 320;
                PRGNAME = "SimpleDemo";
                OutOfMemMsg = "Out Of Memory";

VAR             MyView: ViewPtr;
                OldView: ViewPtr;
                NewView: ViewPtr;
                MyViewPort: ViewPortPtr;
                MyBitMap: BitMapPtr;
                MyRPort: RastPortPtr;
                MyRInfo: RasInfoPtr;
                WB: ScreenPtr;
                Ciaapra [0BFE001H]: SET OF (s0,s1,s2,s3,s4,s5,lmb);

PROCEDURE MyCleanUp();
BEGIN
  FreeBitMap(MyBitMap);
  FreeViewPort(MyViewPort,MyRInfo);
  FreeRastPort(MyRPort);
  IF OldView#NIL THEN FreeView(NewView,MyView,OldView) END;
  WB:=OpenWorkBench();
END MyCleanUp;

PROCEDURE SetUp();
BEGIN
  MyBitMap := CreateBitMap(Width,Height,Depth);
  IF MyBitMap = NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyViewPort:=CreateViewPort(MyRInfo,NIL,0,0,Width,Height,
                                MyBitMap,Standard,Colors);
   IF MyViewPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyRPort:=CreateRastPort(MyBitMap);
   IF MyRPort=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  MyView:=CreateView(MyViewPort);
   IF MyView=NIL THEN DeadEndExit(ADR(OutOfMemMsg)); END;

  OldView:=ViewAddress();
  Remake(MyView,MyViewPort);
END SetUp;

BEGIN
  SetUp; TermProcedure(MyCleanUp); ErrHeader:=PRGNAME;

  SetAPen(MyRPort,2); Move(MyRPort,100,100);
  Draw(MyRPort,200,100); Draw(MyRPort,200,198);
  Draw(MyRPort,100,198); Draw(MyRPort,100,100);
  Move(MyRPort,50,50);
  Text(MyRPort,ADR("AMOK Amiga-Modula Klub!!"),24);
  REPEAT
  UNTIL NOT(lmb IN Ciaapra);

END SimpleDemo.MOD


