MODULE PopMenuTest;

FROM Arts	IMPORT	CurrentLevel, TermProcedure;
FROM Exec	IMPORT	GetMsg, ReplyMsg, WaitPort;
FROM Intuition	IMPORT	WindowFlags, IDCMPFlags, IDCMPFlagSet,
			menuUp, menuDown, ModifyIDCMP, IntuiMessagePtr;
FROM PopMenu	IMPORT  PopUpItem, PopUpMenu, StructPopUp, AddItem,
			InitPopUp, PopUp, DisposePopUp, NOITEMSELECTED,
			OUTSIDEWINDOW;
FROM SYSTEM	IMPORT	ADR;
FROM Windows	IMPORT	Window, OpenWindow, CloseWindow, WriteC, WriteS,
			WriteL, WinGad, WinGadSet;

VAR
  MyWindow: Window;
  MyMenu: PopUpMenu;
  MyItems: ARRAY [1..5] OF PopUpItem;
  Texte: ARRAY[1..5] OF ARRAY[0..31] OF CHAR;
  i,
  StartLevel: INTEGER;
  Quit: BOOLEAN;
  
PROCEDURE Cleanup;
BEGIN
  IF CurrentLevel()<=StartLevel THEN
    DisposePopUp(MyMenu);
    IF MyWindow#NIL THEN
      CloseWindow(MyWindow);
      MyWindow:=NIL;
    END;
  END
END Cleanup;

PROCEDURE InitWindow;
BEGIN
  OpenWindow(MyWindow, 100,40,300,100, 'PopMenu Window',
  	     WinGadSet{sizing, moving, arranging, closing});
  ModifyIDCMP(MyWindow, IDCMPFlagSet{mouseButtons, closeWindow});
END InitWindow;

PROCEDURE InitMenu;
BEGIN
  StructPopUp(MyMenu, 2, 3, 1); (* Tiefe 2, Randfarbe 3, Hintergrund 1 *)
  
  (* Dies, wenn die rechte Maustaste zur Menauswahl dienen soll: *)
  MyMenu.deactivate:=menuUp;
  INCL(MyWindow^.flags,rmbTrap);
  
  Texte[1]:='Erster Item';
  Texte[2]:='Zwei';
  Texte[3]:='Dritter, aber nicht letzter';
  Texte[4]:='Vierter Item';
  Texte[5]:='--- ENDE ---';

  FOR i:=1 TO 5 DO
    AddItem(MyMenu, MyItems[i], ADR(Texte[i]), i, 2); (* Farbe 2 *)
  END;
  MyItems[5].top:=5; (* etwas weiter runter *)
  MyItems[5].color:=0; (* andere Farbe *)
  InitPopUp(MyMenu);
END InitMenu;

PROCEDURE DoIDCMP;
VAR InMsg:IntuiMessagePtr;
    Code: CARDINAL;
    Action : INTEGER;
    Class: IDCMPFlagSet;
BEGIN
  WaitPort(MyWindow^.userPort);
  InMsg:=GetMsg(MyWindow^.userPort);
  Code:=InMsg^.code;
  Class:=InMsg^.class;
  ReplyMsg(InMsg);
  IF (Class = IDCMPFlagSet{mouseButtons}) AND (Code = menuDown) THEN
    Action:=PopUp(MyMenu, MyWindow);
    CASE Action OF
      | NOITEMSELECTED:	WriteS(MyWindow, 'No Item selected');
      | OUTSIDEWINDOW:	WriteS(MyWindow, 'Outside Window');
      | 1..4:		WriteS(MyWindow, 'Item #');
			WriteC(MyWindow, CHAR(Action+30H));
      | 5:		WriteS(MyWindow, 'Quit');
    	 		Quit:=TRUE;
    END;
    WriteL(MyWindow);
  ELSIF Class=IDCMPFlagSet{closeWindow} THEN
    Quit:=TRUE
  END;
END DoIDCMP;

BEGIN
  MyWindow:=NIL;
  StartLevel:=CurrentLevel();
  TermProcedure(Cleanup);
  InitWindow;
  InitMenu;
  Quit:=FALSE;
  REPEAT
    DoIDCMP
  UNTIL Quit;
END PopMenuTest.
