(*
  :Program.       Bin2Obj
  :Author.        Volker Rudolph
  :Address.       Medicusstr. 31 / 6750 Kaiserslautern
  :Phone.         0631/17160
  :ShortCut.      [vor]
  :Version.       1.2
  :Date.          1.7.1989
  :Copyright.     PD
  :Language.      Modula-II
  :Translator.    M2Amiga 3.2d
  :Imports.       Printf [vor]
  :Remark.        Nur CLI !
  :Usage.         Bin2Obj inputfile [outputfile]
  :Contents.      Bin2Obj entfernt die Hunk-Informationen aus einem
  :Contents.      ausfhrbaren Programm und schreibt die Daten des ersten
  :Contents.      CODE-Hunks nach <outputfile>.
*)
MODULE Bin2Obj;

FROM Arguments IMPORT NumArgs,GetArg;
FROM Arts IMPORT Assert,Terminate,CurrentLevel,wbStarted;
FROM Dos IMPORT Lock,UnLock,Open,Close,Read,Write,Examine,Delay,FileLockPtr,
  sharedLock,newFile,oldFile,FileInfoBlockPtr,FileHandlePtr;
FROM Heap IMPORT Allocate,Deallocate;
FROM Printf IMPORT Printf0,Printf1;
FROM Str IMPORT Copy,Concat,LastPos,last;
FROM SYSTEM IMPORT ADDRESS,ADR;

TYPE
  String = ARRAY [0..70] OF CHAR;
  CardPtr = POINTER TO LONGCARD;

VAR
  readName:String;
  writeName:String;
  len:INTEGER;
  pos:INTEGER;
  bufLen:LONGINT;
  buffer,ptr:CardPtr;
  count :LONGINT;
  whandle:FileHandlePtr;

  PROCEDURE ReadFile(file:ADDRESS;VAR buffer:ADDRESS;VAR len:LONGINT);
  VAR
    lock:FileLockPtr;
    handle:FileHandlePtr;
    fib:FileInfoBlockPtr;
    ok:BOOLEAN;
  BEGIN
    lock := Lock(file,sharedLock);
    IF lock = NIL THEN
      Printf1("File '%s' not found.\n",file);
      Terminate(CurrentLevel());
    END; (* IF *)
    Allocate(fib,SIZE(fib^));
    ok := Examine(lock,fib);
    UnLock(lock);
    Allocate(buffer,fib^.size);
    Delay(1);
    handle := Open(file,oldFile);
    Assert(handle # NIL,ADR("Can't open file"));
    len := Read(handle,buffer,fib^.size);
    Close(handle);
    Deallocate(fib);
  END ReadFile;

BEGIN
  Assert(NOT wbStarted,ADR("CLI ONLY !"));
  GetArg(1,readName,len);
  IF ((NumArgs() # 2) AND (NumArgs() # 1)) OR (readName[0] = '?') THEN
    Printf0("Bin2Obj inputfile [outputfile]\n");
  ELSE
    IF NumArgs() = 1 THEN
      Copy(writeName,readName);
      pos := LastPos(writeName,MAX(INTEGER),'.');
      IF pos # last THEN
        writeName[pos] := 0C;
      END; (* IF *)
      Concat(writeName,".obj");
    ELSE
      GetArg(2,writeName,len);
    END; (* IF *)

    ReadFile(ADR(readName),buffer,bufLen);
    ptr := buffer;

    WHILE ptr^ # 1001 DO
      INC(ptr,SIZE(ptr^));
    END;
    INC(ptr,SIZE(ptr^));
    count := ptr^*4;
    INC(ptr,SIZE(ptr^));

    Printf1("Object-length %ld bytes.\n",count);

    whandle := Open(ADR(writeName),newFile);
    Assert(whandle # NIL,ADR("Can't open write file"));

    len := Write(whandle,ptr,count);
    Close(whandle);
  END;
END Bin2Obj.

