(*
  :Program.       HotKeyTest
  :Author.        Volker Rudolph
  :Address.       Medicusstr. 31 / 6750 Kaiserslautern
  :Phone.         0631/17160
  :ShortCut.      [vor]
  :Version.       1.0
  :Date.          1.7.1989
  :Copyright.     PD
  :Language.      Modula-II
  :Translator.    M2Amiga 3.2d
  :Imports.       HotKey
  :Contents.      Testprogramm zum Modul HotKey
*)

MODULE HotKeyTest;

FROM Arts IMPORT Assert;
FROM Ascii IMPORT lf;
FROM Dos IMPORT Open,Close,FileHandlePtr,Read,Write,newFile;
FROM HotKey IMPORT WaitHotKey;
FROM InputEvent IMPORT Qualifiers, QualifierSet;
FROM Strings IMPORT Length;
FROM SYSTEM IMPORT ADR;

CONST
  f1 = 208;  (* raw-keycode *)

TYPE
  StrPtr = POINTER TO ARRAY [1..80] OF CHAR;

VAR
  handle:FileHandlePtr;
  buf:ARRAY [1..2] OF CHAR;
  len:LONGINT;

  PROCEDURE Puts(str:StrPtr);
  VAR
    len:LONGINT;
    ch:CHAR;
  BEGIN
    ch := lf;
    len := Write(handle,str,Length(str^));
    len := Write(handle,ADR(ch),1);
  END Puts;

BEGIN
  handle := Open(ADR("CON:0/11/400/150/HotKey"),newFile);
  Assert(handle # NIL,ADR("AARRGH!"));
  Puts(ADR("Bei Eingabe von <RETURN> verschwinde ich, und"));
  Puts(ADR("tauche erst wieder auf, wenn F1 zusammen mit"));
  Puts(ADR("einer ALT-Taste eingegeben wird."));
  len := Read(handle,ADR(buf),1);
  Close(handle);

  WaitHotKey(f1,QualifierSet{lAlt,rAlt});

  handle := Open(ADR("CON:0/11/400/150/HotKey"),newFile);
  Assert(handle # NIL,ADR("AARRGH!"));
  Puts(ADR("Ich bin wieder da !"));
  Puts(ADR(""));
  Puts(ADR("Mit <RETURN> verschwinde ich endgltig."));
  len := Read(handle,ADR(buf),1);
  Close(handle);
END HotKeyTest.

