(*---------------------------------------------------------------------------
    :Program.    UPNTest
    :Author.     Philippe Gressly
    :Address.    Nfenhaus, CH-8926 Kappel a/Albis
    :Phone.      
    :Shortcut.   [Philu]
    :Version.    2.6
    :Date.       (8.) 1989
    :Copyright.  PD.
    :Language.   Modula-II
    :Translator. M2Amiga
    :Imports.    UPN
    :UpDate.     
    :Contents.   A test to UPN.def  (see there)
    :Remarks     none
---------------------------------------------------------------------------*)
MODULE UPNTest;

FROM InOut IMPORT WriteString, ReadString, WriteLn, Read, Write;

FROM UPN IMPORT ErrorType, UPN, UPNError, WriteError, AllocUPN, AddVarsToUPN,
                Compile, GetNumVars, GetVarName, SetVar, Execute,
                KillUPN, IsVarInFormel;
FROM LongRealInOut IMPORT ReadReal, WriteReal;
      
                
VAR formel: UPN;
    VarString, FormelString: ARRAY[0..70] OF  CHAR;
    VarWert, ErgWert: LONGREAL;
    i: CARDINAL;
    
    
   PROCEDURE Again(str: ARRAY OF CHAR): BOOLEAN;
   VAR ch: ARRAY [0..10] OF CHAR;
   BEGIN
      WriteString(str); WriteString("  (enter j/n) ?");
      ReadString(ch); WriteString(ch); WriteLn;
      RETURN CAP(ch[0]) # "N"
   END Again;
   
   
   PROCEDURE ErrPrint(str: ARRAY OF CHAR);
   BEGIN
      WriteString("  "); WriteString(str); WriteLn;
      FOR i := 0 TO UPNError.Wo DO
         WriteString(" ")
      END;
      WriteString("/^\"); WriteLn;
      WriteError; WriteLn
   END ErrPrint;
   
   
   
BEGIN (* UPNTest *)
   REPEAT
      Write(CHR(12));
      UPNError.ET := None;
      WriteLn;
      WriteString("          ************************** "); WriteLn; 
      WriteString("          *****  Compiler Test ***** "); WriteLn;
      WriteString("          ************************** "); WriteLn; WriteLn;
      IF NOT AllocUPN(formel) THEN  WriteError; HALT END;
      IF NOT AddVarsToUPN(formel,
             "a,b,c,d,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z") THEN
         ErrPrint(" ????????? NO MEMORY ?????????"); HALT
      END;
      WriteString("Die Namen A..Z sind bereits als Variablen zugelassen");
      WriteLn;
      WHILE Again("Noch eigene Variable ") DO
         WriteString("Gib eigene Variablenamen ein:");
         ReadString(VarString);
         IF NOT AddVarsToUPN(formel, VarString) THEN
            ErrPrint(VarString)
         END
      END;
      REPEAT (* Formel eingeben *)
         Write(CHR(12));
         UPNError.ET := None;
         WriteString("Gib Formel ein:"); ReadString(FormelString);
         IF NOT Compile(formel, FormelString) THEN
            ErrPrint(FormelString)
         END;
         IF UPNError.ET = None THEN
            REPEAT (* Belegen *)
               UPNError.ET := None;
               WriteLn;
               i := 1;
               WHILE i <= GetNumVars(formel) DO
                  IF IsVarInFormel(formel, i) THEN
                     GetVarName(formel, i, VarString);
                     WriteString(VarString); WriteString(" := ");
                     ReadReal(VarWert); 
                     SetVar(formel, i, VarWert)
                  END;
                  INC(i)
               END;
               ErgWert := Execute(formel);
               IF UPNError.ET # None THEN
                  WriteLn;
                  WriteError;
                  WriteLn
               ELSE
                  WriteString("Ergebnis:  ");
                  WriteReal(ErgWert, 15, 12);
                  WriteLn
               END
            UNTIL NOT Again("Eventuell andere Belegung der Variable")
         END
      UNTIL NOT Again("andere Formel");
      KillUPN(formel)
   UNTIL NOT Again("Neue Vars, neue Formeln")       
END UPNTest.
