(*---------------------------------------------------------------------------
    :Program.    Arguments.mod
    :Author.     ???, backtranslated by Bernd Preusing
    :Address.    Gerhardstr. 16  D-2200 Elmshorn
    :Phone.      04121/22486
    :Copyright.  Public Domain
    :Language.   Modula-II
    :Translator. M2Amiga V3.2d
    :History.    V1.0 [bep]    Oct.1988 (backtranslated original V3.1)
    :History.    V1.1 [bne] 22.Aug.1989 (- side effects on current dir)

---------------------------------------------------------------------------*)
IMPLEMENTATION MODULE Arguments;

FROM SYSTEM IMPORT CAST, SHIFT, ADDRESS, ADR, SETREG;

FROM Dos IMPORT
        FileLockPtr, Process, CommandLineInterface, CurrentDir;

FROM Exec IMPORT
        CopyMem, FindTask;

FROM Arts IMPORT
        dosCmdBuf, startupMsg, wbStarted;

FROM ASCII IMPORT
        nul;

FROM Scan IMPORT
        ScanString;

FROM Workbench IMPORT
        WBStartupPtr, WBArg, WBArgumentsPtr, WBStartup;


TYPE
        CharPtr = POINTER TO CHAR;
        ProcessPtr = POINTER TO Process;


VAR
        WBSt: WBStartupPtr;
        CommLine,
        CommandName: CharPtr;
        MyProcess: ProcessPtr;


PROCEDURE GetChar(VAR ch: CHAR);
BEGIN
  ch:=CommLine^;
  INC(CAST(LONGINT,CommLine)) (* mu CAST, damit TRAPV statt TRAP #15 *)
END GetChar;

PROCEDURE NumArgs(): INTEGER;
VAR cnt,len:INTEGER; ch: ARRAY[0..0] OF CHAR; termCh: CHAR;
BEGIN
  IF wbStarted THEN
    RETURN WBSt^.numArgs-1
  ELSE
    cnt:=0;
    CommLine:=dosCmdBuf;
    REPEAT
      ScanString(GetChar,ch,len,termCh);
      IF len#0 THEN
        INC(cnt)
      END;
    UNTIL termCh<' ';
    RETURN cnt
  END
END NumArgs;

PROCEDURE GetArg(    arg: INTEGER;
                 VAR argument: ARRAY OF CHAR);
VAR
  ArgPtr: CharPtr;
  termCh: CHAR;
  ActArg, i, Last, len: INTEGER;
BEGIN
  IF wbStarted THEN
    WITH WBSt^ DO
      ArgPtr:=ADR(argument);
      IF arg<numArgs THEN
        CopyMem(argList^[arg].name,ArgPtr,HIGH(argument)+1);
        len:=0;
        WHILE (len<=HIGH(argument)) AND (ArgPtr^#nul) DO
          INC(len);
          INC(ArgPtr)
        END;
      ELSE
        ArgPtr^:=nul;
        len:=0
      END
    END (* WITH *)
  ELSE (* cli *)
    IF arg=0 THEN
      Last:=HIGH(argument);
      IF Last>INTEGER(CommandName^) THEN
        Last:=INTEGER(CommandName^);
        argument[Last]:=nul
      END;
      CommLine:=CommandName;
      FOR i:=0 TO Last-1 DO
        INC(CommLine);
        argument[i]:=CommLine^
      END
    ELSE (* arg#0 *)
      CommLine:=dosCmdBuf;
      ActArg:=0;
      REPEAT
        INC(ActArg);
        ScanString(GetChar,argument,len,termCh);
      UNTIL (ActArg=arg) OR (termCh<' ');
      IF ActArg#arg THEN
        argument[0]:=nul;
        len:=0
      END
    END (* if arg=0 *)
  END (* if wbstarted *)
END GetArg;

PROCEDURE GetLock(arg: INTEGER): FileLockPtr;
BEGIN
  IF wbStarted THEN
    WITH WBSt^ DO
      IF arg<numArgs THEN
        RETURN argList^[arg].lock
      END
    END (* WITH *)
  END;
  RETURN NIL
END GetLock;

BEGIN
  WBSt:=CAST(WBStartupPtr,startupMsg);
  IF wbStarted THEN
    CommandName:=NIL (* Name ist in arglist^[0].name *)
  ELSE
    MyProcess:=CAST(ProcessPtr,FindTask(NIL));
    CommandName:=ADR(MyProcess^.cli^.commandName^);
  END
END Arguments.mod
