(*
  :Program.       RunTime
  :Author.        Volker Rudolph
  :Address.       Medicusstr. 31 / 6750 Kaiserslautern
  :Phone.         0631/17160
  :Version.       1.0
  :Date.          24.4.1989
  :Copyright.     PD
  :Language.      Modula-II
  :Translator.    M2Amiga 3.2d
  :Imports.       MicroTimer [vor], Printf [vor]
  :Contents.      RunTime ermittelt die Ausfhrungsdauer eines Programmes
  :Usage.         RunTime "<program> <arguments>"
*)

MODULE RunTime;

FROM Arts IMPORT Assert,wbStarted;
FROM Arguments IMPORT NumArgs, GetArg;
FROM Dos IMPORT Execute;
FROM MicroTimer IMPORT StartTimer, StopTimer, MicrosToTime;
FROM Printf IMPORT Printf1, Printf3;
FROM SYSTEM IMPORT ADR;

VAR
  arg:ARRAY [1..40] OF CHAR;
  len:INTEGER;
  result:LONGINT;
  minutes:CARDINAL;
  seconds:CARDINAL;
  micros:LONGINT;
BEGIN
  Assert(NOT wbStarted,ADR("PLEASE USE FROM CLI"));

  GetArg(1,arg,len);
  IF (NumArgs() = 1) AND ~((arg[1] = '?') AND (arg[2] = 0C)) THEN
    StartTimer;
    result := Execute(ADR(arg),NIL,NIL);
    StopTimer(micros);
    MicrosToTime(minutes, seconds, micros, micros);
    Printf3("Runtime: %ld mins %ld secs %06ld micros\n",minutes,seconds,micros);
  ELSE
    GetArg(0,arg,len);
    Printf1('Usage:\n  %s "<program> <arguments>"\n',ADR(arg));
  END; (* IF *)
END RunTime.
