(**********************************************************************

    :Program.    TimerTest.def
    :Contents.   test module for TimerSupport V2.0
    :Author.     Nicolas Benezan [bne]
    :Address.    Postwiesenstr. 2, D7000 Stuttgart 60
    :Phone.      711/333679
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Imports.    TimerSupport2.0
    :Translator. M2Amiga A+L V3.2d
    :History.    V1.0 [bne] 03.Sep.1989

**********************************************************************)

MODULE TimerTest;

FROM InOut        IMPORT Write, WriteInt, WriteLn, WriteString;
FROM Timer        IMPORT TimeVal;
FROM TimerSupport IMPORT TimerMode, OpenTimer, CloseTimer, GetSysTime,
                         SysToNormalTime, NormalToSysTime, SubTime,
                         CmpTime;
FROM SYSTEM       IMPORT ADR;

CONST
  SekProTag=60*60*24;

VAR
  Jetzt, Tag0, Noch: TimeVal;
  Jahr, Monat, Tag, Stunde, Minute, Sekunde, Lage: LONGINT;

BEGIN
  IF OpenTimer(vBlank) THEN
    GetSysTime(Jetzt);
    SysToNormalTime(Jetzt, Jahr, Monat, Tag, Stunde, Minute, Sekunde);
    WriteString("Es ist jetzt der ");
    WriteInt(Tag, 1);
    Write(".");
    WriteInt(Monat, 2);
    Write(".");
    WriteInt(Jahr, 4);
    WriteLn;
    NormalToSysTime(1990, 9, 1, 0, 0, 0, Tag0);
    IF CmpTime(Tag0, Jetzt)<0 THEN
      Noch:=Tag0;
      SubTime(Noch, Jetzt);
      Lage:=Noch.secs DIV SekProTag;
      IF Lage=0 THEN
        WriteString("Aaaauuuuschaaiiiiedr !!!");
      ELSE
        WriteString("Meine Lage: ");
        WriteInt(Lage, 1);
      END;
    ELSE
      WriteString("Aus is !");
    END;
    WriteLn;
    CloseTimer;
  END;
END TimerTest.

