(*---------------------------------------------------------------------------
    :Program.    ConvTabs.mod
    :Author.     Bernd Preusing
    :Address.    Gerhardstr. 16  D-2200 Elmshorn
    :Phone.      04121/22486
    :Shortcut.   [bep]
    :Version.	 2.0 (update zu StripText 1.0)
    :Date.       Aug-89
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga
    :Imports.    TabConversions, FileIO (Bernd Preusing)
    :UpDate.	 2.0 speed up, korrekte Behandlung von Strings in '' und ""
    :Contents.   convert text to tabs, kill trailing spaces
---------------------------------------------------------------------------*)
MODULE ConvTabs;

FROM SYSTEM	IMPORT ADDRESS;
FROM Terminal	IMPORT WriteString, WriteLn;
FROM Arguments	IMPORT GetArg, NumArgs;
FROM TabConversions IMPORT SpacesToTabs;
FROM FileIO	IMPORT GetFile, PutFile, FileIOResult;

VAR
 Buff:ADDRESS;
 Len:LONGINT; NameLen:INTEGER;
 InName, OutName: ARRAY[0..127] OF CHAR;

BEGIN
 WriteString('ConvTabs 2.0   1989 Bernd Preusing'); WriteLn;
 IF NumArgs()=2 THEN
   GetArg(1,InName,NameLen);
   GetArg(2,OutName,NameLen);
   IF GetFile(InName,Buff,Len,0)=noError THEN
     Len:=SpacesToTabs(Buff,Buff);
     IF PutFile(OutName,Buff,Len,FALSE,TRUE)=noError THEN
       WriteString('--- fertig ---');
     ELSE
       WriteString('--- write error ---');
     END;
   ELSE
     WriteString('--- read error ---');
   END;
 ELSE
   WriteString('--- usage: ConvTabs InFile OutFile ---');
 END;
 WriteLn;
END ConvTabs.
