(*---------------------------------------------------------------------------
    :Program.     HexEdit.mod
    :Contents.	  Files patchen
    :Author.      Bernd Preusing
    :Address.	  Gerhardstr. 16  D-2200 Elmshorn
    :Phone.	  04121/22486
    :Copyright.	  Public Domain
    :Language.	  Modula-2
    :Translator.  M2Amiga V3.27d
    :History.	  1.0  15-Sep-89 Bernd Preusing
    :History.	  2,0  23-Sep-89 Suchfunktion rein, Assert raus, BLength vari!
    :Imports.	  TextWindow, Dump, Sound, FileIO (Bernd Preusing)
    :Remark.	  hnlich NewZap, aber auch Insert/Delete-Modus!!
    :Remark.	  Sollte fr Geschwindigkeit mit $VRF- kompiliert werden!
    :Usage.	  HexEdit [filename]
---------------------------------------------------------------------------*)
MODULE HexEdit;

FROM SYSTEM	IMPORT	CAST, ADR, ADDRESS, INLINE;
FROM Arts	IMPORT	Assert, Terminate, CurrentLevel, TermProcedure;
FROM TextWindow	IMPORT	cUp, cDown, cLeft, cRight, scUp, scDown, scLeft,
			scRight, kHelp, kDel, kF1, acUp, acDown, Style,
			Printable, WriteS, WriteC, WriteLn, WriteL,
			Format, WriteHex, Sleep, MayGetC, ReadC,
			ReadLn, GotoXY, CurOn, CurOff, CurX, CurY, CurMax,
			ClearWindow, ClearEOL, Colour, GetWindow,
			NormColours, Title, ClearEOS;
FROM Dump	IMPORT	ByteCount, AddrLen, Offset, BLength, Dump;
FROM Sound	IMPORT	Sound;
FROM FileIO	IMPORT	GetFile, PutFile, FreeFile, FileIOResult;
FROM Arguments	IMPORT	GetArg, NumArgs;
FROM Heap	IMPORT	AllocMem, Deallocate;
FROM Exec	IMPORT	CopyMem, FindTask;
FROM Intuition	IMPORT	IntuiText, IntuiTextPtr, IDCMPFlagSet,
			ClearPointer, SetPointer, AutoRequest;
FROM Str	IMPORT	Length, Copy, CapString, Concat, LastPos;
FROM Dos	IMPORT	ProcessPtr;
FROM ARP	IMPORT	FileRequest, FileRequester, FileName, DirName,
			FileReqFlags, FileReqFlagSet;

CONST
  LeftOff = 8;
  TopOff  = 3;
  esc = CHAR(27);
  BUFFERADD = 6000;
  UNKNOWNERR = 'Unbekannter Fehler!';

TYPE
  UByte = [0..255];
  CharPtr = POINTER TO CHAR;

VAR
  MyProcess: ProcessPtr;
  OldWindow:ADDRESS;
  AscOff: INTEGER;
  Top : LONGINT;
  MaxLength,
  MomLength,
  ActPos, MaxPos: LONGINT;
  Start: LONGINT;
  c: CHAR;
  Header: ARRAY [0..79] OF CHAR;
  Asc: BOOLEAN;
  Name,
  SearchString,
  SearchCode: ARRAY [0..79] OF CHAR;
  SearchLen: INTEGER;
  NameLen: INTEGER;
  GotArg: BOOLEAN;
  Changed: BOOLEAN;
  Backup: BOOLEAN;
  CaseEgal: BOOLEAN;
  LINES, MAXLINE: INTEGER;


(*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*)
MODULE Pointer;
IMPORT ADDRESS, ADR, CopyMem, AllocMem, Deallocate, TermProcedure, Assert,
       CurrentLevel, GetWindow, SetPointer, ClearPointer, INLINE,
       MyProcess, OldWindow;
EXPORT QUALIFIED Normal, Busy;

CONST
    POINTERSIZE = (16+2)*2*2; (* never change this! *)

VAR
  ZZ: ADDRESS;
  StartLevel: INTEGER;

(* $E- *)
PROCEDURE ZZData(); (* I'm busy or tired! *)
BEGIN
INLINE(
	00000H,00000H,
	03E00H,03E00H,
	07FC0H,07FC0H,
	043E0H,07FE0H,
	0F7E0H,0FFE0H,
	0EE10H,0FFF0H,
	0C3B0H,0FFF0H,
	07F70H,07FF0H,
	07E10H,07FF0H,
	03FE0H,03FE0H,
	01FC0H,01FC0H,
	00020H,00020H,
	007E0H,007E0H,
	007C0H,007C0H,
	00330H,00330H,
	00070H,00070H,
	00030H,00030H,
	00000H,00000H
)
END ZZData;

PROCEDURE Normal;
BEGIN
  ClearPointer(GetWindow());
END Normal;

PROCEDURE Busy;
BEGIN
  SetPointer(GetWindow(),ZZ,16,16,-7,-7);
END Busy;

PROCEDURE Exit;
BEGIN
  IF CurrentLevel()<=StartLevel THEN
    ClearPointer(GetWindow());
    IF ZZ#NIL THEN Deallocate(ZZ); ZZ:=NIL END;
    MyProcess^.windowPtr:=OldWindow;
  END
END Exit;

BEGIN (* Mod Pointer *)
  ZZ:=NIL;
  TermProcedure(Exit);
  AllocMem(ZZ,POINTERSIZE,TRUE);
  Assert(ZZ#NIL,ADR('no chipmem for Busy Pointer'));
  CopyMem(ADR(ZZData),ZZ,POINTERSIZE);
END Pointer;
(*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*)



PROCEDURE Beep;
BEGIN
  Sound(4,3,50);
  Sound(5,3,50);
END Beep;

PROCEDURE ErrBeep;
BEGIN
  Sound(4,2,50);
END ErrBeep;

(* Shei Arts Requester geht nur auf WBScreen!! *)
PROCEDURE Requester(header,body,pos,neg:ADDRESS):BOOLEAN;

  PROCEDURE DummyText; (* $E- *)
  BEGIN INLINE( 0001H, 0100H, 0,0, 0,0, 0,0, 0,0)
  END DummyText;

  PROCEDURE InitIText(VAR i:IntuiText; left,top:INTEGER; adr:ADDRESS);
  BEGIN
    CopyMem(ADR(DummyText),ADR(i),SIZE(i));
    WITH i DO
      leftEdge:=left; topEdge:=top; iText:=adr
    END;
  END InitIText;

VAR
  BodyText1,BodyText2, NegText, PosText: IntuiText;
  PosPtr: IntuiTextPtr;
  Height: INTEGER;
BEGIN
  InitIText(BodyText1,12,5,header);
  Height:=54;
  IF body#NIL THEN
    InitIText(BodyText2,12,16,body);
    BodyText1.nextText:=ADR(BodyText2);
    Height:=65;
  END;
  InitIText(NegText,6,3,neg);
  IF pos=NIL THEN
    PosPtr:=NIL
  ELSE
    InitIText(PosText,6,3,pos);
    PosPtr:=ADR(PosText);
  END;
  RETURN AutoRequest(GetWindow(),ADR(BodyText1),PosPtr,ADR(NegText),
  		IDCMPFlagSet{},IDCMPFlagSet{},320,Height)
END Requester;

PROCEDURE GetPath(VAR f,d:ARRAY OF CHAR);
VAR pos,i:INTEGER;
BEGIN
  Copy(d,f);
  pos:=LastPos(f,-1,'/');
  IF pos<0 THEN
    pos:=LastPos(f,-1,':');
  END;
  IF pos>=0 THEN
    IF d[pos]=':' THEN d[pos+1]:=0C ELSE d[pos]:=0C END;
    INC(pos);
    FOR i:=pos TO Length(f) DO
      f[i-pos]:=f[i]
    END;
    f[i]:=0C;
  ELSE
    d[0]:=0C
  END;
END GetPath;

PROCEDURE FileReq(VAR FName: ARRAY OF CHAR; save:BOOLEAN):BOOLEAN;
VAR
  FR:FileRequester;
  File, Dir: ARRAY[0..79] OF CHAR;
BEGIN
  Copy(File,FName);
  GetPath(File,Dir);
  WITH FR DO
    IF save THEN
      hail      := ADR('Speichern');
      funcFlags:=FileReqFlagSet{};
    ELSE
      hail      := ADR('Laden');
      funcFlags:=FileReqFlagSet{doColor};
    END;
    ddef      := ADR(File);
    ddir      := ADR(Dir);
    wind      := GetWindow();;
    reserved1 := 0;
    function  := NIL;
    reserved2 := 0;
  END;
  IF FileRequest(ADR(FR))#NIL THEN
    IF (Length(Dir)>0) AND (Dir[Length(Dir)-1]#':') THEN
      Concat(Dir,'/');
    END;
    Concat(Dir,File);
    Copy(FName,Dir);
    RETURN TRUE
  ELSE
    RETURN FALSE;
  END;
END FileReq;

PROCEDURE Load;
VAR res: FileIOResult;
    Body: ARRAY[0..39] OF CHAR;
BEGIN
  ClearWindow;
  LOOP
    IF NOT GotArg AND (NumArgs()>0) THEN
      GetArg(1,Name,NameLen);
      GotArg:=TRUE;
    ELSE
      IF NOT FileReq(Name,FALSE) THEN
        Terminate(CurrentLevel());
      END;
    END;
    Pointer.Busy;
    res:=GetFile(Name,CAST(ADDRESS,Start),MomLength,BUFFERADD+16);
    Pointer.Normal;
    CASE res OF
    | noError: 	MaxLength:=MomLength+BUFFERADD;
      	      	Top:=0;
      		ActPos:=0;
      		Offset:=0-Start;
      		Changed:=FALSE;
      		Pointer.Normal;
      		EXIT;
    | notFound: Body:='File nicht gefunden!';
    | readError,
      seekError:Body:='Lesefehler!';
    | noMem:    Body:='Nicht genug Speicher frei!';
    | ELSE	Body:=UNKNOWNERR;
    END;
    IF Requester(ADR('Fehler beim Laden:'),ADR(Body),
    	         ADR('Programmende'),ADR('Anderer Name')) THEN
      Terminate(CurrentLevel())
    END;
  END; (* loop *)
END Load;

PROCEDURE Save(ask:BOOLEAN);
VAR res: FileIOResult;
    Body: ARRAY[0..39] OF CHAR;
    Temp: BOOLEAN;
BEGIN
 IF ask THEN
   IF NOT FileReq(Name,TRUE) THEN RETURN END;
   Temp:=Backup;
 ELSE
   Temp:=FALSE;
 END;
 REPEAT
  Pointer.Busy;
  GotoXY(0,0);
  IF Temp THEN
    WriteS('Speichere mit Backup: '); WriteL(Name);
  ELSE
    WriteS('Speichere ohne Backup: '); WriteL(Name);
  END;
  ClearEOL;
  res:=PutFile(Name,Start,MomLength,Temp,TRUE);
  Pointer.Normal;
  CASE res OF
  | writeError: Body:='Schreibfehler!';
  | saveError:  Body:='Kann File nicht anlegen!';
  | renameError:Body:='Kann altes File nicht umbenennen!';
  | noError: 	Changed:=FALSE;
		FreeFile(CAST(ADDRESS,Start));
  | ELSE 	Body:=UNKNOWNERR;
  END;
  IF res#noError THEN
    IF Requester(ADR('Fehler beim Speichern:'),ADR(Body),
    	         ADR('Vergi es!'),ADR('Anderer Name')) THEN
      res:=noError;
    ELSE
      IF NOT FileReq(Name,TRUE) THEN
        res:=noError
      END;
    END;
  END;
 UNTIL res=noError;
END Save;

PROCEDURE AskSave;
BEGIN
  IF Changed THEN
    ErrBeep;
    IF Requester(ADR('File verndert!!'),ADR('Abspeichern?'),
      		 ADR('Ja'),ADR('Nein')) THEN
      Save(FALSE);
    END;
  END;
END AskSave;

PROCEDURE ShowArr(ScheinVon:LONGINT; Lines:INTEGER);
VAR s: ARRAY[0..79] OF CHAR; i:INTEGER;
BEGIN
  CurOff;
  GotoXY(0,TopOff);
  FOR i:=1 TO Lines DO
    Dump(s,ScheinVon-Offset);
    WriteL(s);
    INC(ScheinVon,16);
  END;
END ShowArr;

PROCEDURE Edit():BOOLEAN;
VAR c:CHAR; FirstByte, SecByte: UByte; x,y:INTEGER;
    OldTop,i:LONGINT; Insert, StatChanged: BOOLEAN;


  PROCEDURE CalcCursor();
  VAR RelPos:LONGINT;
  BEGIN
    IF ActPos<0 THEN
      ActPos:=0
    ELSIF ActPos>MaxPos THEN
      ActPos:=MaxPos
    END;
    WHILE MaxPos-Top<(LINES-1)*16 DO
      DEC(Top,16); OldTop:=-1
    END;
    IF Top<0 THEN Top:=0; OldTop:=-1 END;
    WHILE ActPos<Top DO
      DEC(Top,16); OldTop:=-1
    END;
    WHILE ActPos-Top>=LINES*16 DO
      INC(Top,16); OldTop:=-1
    END;
    RelPos:=ActPos-Top; y:=RelPos/16; x:=RelPos REM 16;
  END CalcCursor;

  PROCEDURE Cursor;
  BEGIN
    IF Asc THEN
      GotoXY(AscOff+x,y+TopOff);
    ELSE
      IF    BLength=1 THEN GotoXY(LeftOff+x*3,y+TopOff);
      ELSIF BLength=2 THEN GotoXY(LeftOff+(x REM 2)*2+x/2*5,y+TopOff);
      ELSE GotoXY(LeftOff+(x REM 4)*2+x/4*9,y+TopOff);
      END;
    END;
    CurOn;
  END Cursor;

  PROCEDURE Ins(b:CHAR);
  VAR z,q:CharPtr; i:LONGINT;
  BEGIN
    IF MomLength<MaxLength THEN
      z:=CAST(CharPtr,Start+MomLength);
      q:=z; DEC(q);
      FOR i:=1 TO MomLength-ActPos DO
        z^:=q^;
        DEC(z); DEC(q); (* hier sollte INLINE!!! *)
      END;
      z^:=b;
      INC(MomLength);
      OldTop:=-1;
    ELSE
      ErrBeep;
      IF Requester(ADR('Puffer berlauf!'),ADR('Speichern und neu laden!'),
      		   NIL,ADR('OK')) THEN
      END;
      StatChanged:=TRUE;
    END;
  END Ins;

  PROCEDURE Del;
  BEGIN
    IF MomLength>0 THEN
      IF ActPos<MomLength THEN
        CopyMem(Start+ActPos+1,Start+ActPos,MomLength-ActPos);
        DEC(MomLength);
        IF MomLength=0 THEN Insert:=TRUE END;
        OldTop:=-1;
        IF NOT Changed THEN
          Changed:=TRUE;
          StatChanged:=TRUE;
        END;
      ELSE
        ErrBeep
      END;
    ELSE
      ErrBeep;
    END;
  END Del;

  PROCEDURE SetByte(b:CHAR);
  VAR p: CharPtr;
  BEGIN
    IF Insert THEN
      Ins(b);
    ELSE
      p:=CAST(CharPtr,Start+ActPos);
      p^:=b;
    END;
    INC(ActPos);
    IF NOT Insert AND (ActPos>MaxPos) THEN ErrBeep END;
    OldTop:=-1;
    IF NOT Changed THEN
      Changed:=TRUE;
      StatChanged:=TRUE;
    END;
  END SetByte;

  PROCEDURE GetSearchVal;
  VAR str: ARRAY[0..3] OF CHAR;
      i, si,Len:INTEGER;
      c:CHAR; b, nib: [0..255];
      ok:BOOLEAN;
  BEGIN
    StatChanged:=TRUE;
    REPEAT
      ok:=TRUE;
      GotoXY(0,1); WriteS('Suchstring ');
      IF Asc THEN WriteS('(ASCII) ? ') ELSE WriteS('(HEX) ? ') END;
      ReadLn(SearchString,c);
      SearchLen:=Length(SearchString);
      IF SearchLen=0 THEN RETURN END;
      IF Asc THEN
        Copy(SearchCode,SearchString);
      ELSE
        CapString(SearchString);
        si:=0;
        SearchLen:=0;
        LOOP
          WHILE (SearchString[si]#0C) AND (SearchString[si]<=' ') DO INC(si) END;
          IF SearchString[si]=0C THEN EXIT END; (* ende *)
          i:=0;
          WHILE (i<2) AND (SearchString[si]>' ') DO
            c:=SearchString[si];
            IF ((c<'0') OR (c>'9')) AND
                ((c<'A') OR (c>'F')) THEN
              ok:=FALSE;
              EXIT;
            END;
            str[i]:=c;
            INC(i); INC(si);
          END;
          str[i]:=0C;
          i:=0; b:=0;
          WHILE str[i]#0C DO
            nib:=ORD(str[i])-30H;
            IF nib>9 THEN DEC(nib,7) END;
            b:=b*16+nib;
            INC(i);
          END;
          SearchCode[SearchLen]:=CHAR(b);
          INC(SearchLen);
        END; (* LOOP *)
        IF NOT ok THEN ErrBeep END;
      END; (* if asc *)
    UNTIL ok;
  END GetSearchVal;

  PROCEDURE Search(New:BOOLEAN);
  VAR End:LONGINT;
      i:INTEGER;
      p,s,p2,s2:CharPtr;
      res:BOOLEAN;
  BEGIN
    IF New THEN GetSearchVal END;
    IF SearchLen=0 THEN RETURN END;
    p:=CAST(CharPtr,Start+ActPos);
    End:=Start+MaxPos-SearchLen+1;
    s:=ADR(SearchCode);
    Pointer.Busy;
    IF CaseEgal AND Asc THEN
      CapString(SearchCode);
      LOOP
        WHILE (CAP(p^)#s^) AND (CAST(LONGINT,p)<End) DO INC(p) END;
        IF CAST(LONGINT,p)>=End THEN res:=FALSE; EXIT END;
        p2:=p; s2:=s; i:=1;
        REPEAT
          INC(p2); INC(s2); INC(i);
        UNTIL (CAP(p2^)#s2^) OR (i>SearchLen);
        IF i>SearchLen THEN (* gefunden! *)
          ActPos:=CAST(LONGINT,p2)-Start;
          res:=TRUE;
          EXIT;
        END;
        INC(p);
      END;
    ELSE
      LOOP
        WHILE (p^#s^) AND (CAST(LONGINT,p)<End) DO INC(p) END;
        IF CAST(LONGINT,p)>=End THEN res:=FALSE; EXIT END;
        p2:=p; s2:=s; i:=1;
        REPEAT
          INC(p2); INC(s2); INC(i);
        UNTIL (p2^#s2^) OR (i>SearchLen);
        IF i>SearchLen THEN (* gefunden! *)
          ActPos:=CAST(LONGINT,p2)-Start;
          res:=TRUE;
          EXIT;
        END;
        INC(p);
      END;
    END;
    IF res THEN
      Beep;
      CalcCursor;
      IF y=MAXLINE THEN INC(Top,16*LINES/2) END; (* etwa mittig *)
    ELSE
      ErrBeep;
    END;
    Pointer.Normal;
  END Search;

BEGIN (* Edit *)
  ActPos:=0;
  OldTop:=-1;
  Asc:=FALSE;
  Changed:=FALSE;
  IF MomLength=0 THEN
    Insert:=TRUE
  ELSE
    Insert:=FALSE;
  END;
  ClearWindow;
  StatChanged:=TRUE;
  LOOP
    IF Insert THEN MaxPos:=MomLength ELSE MaxPos:=MomLength-1 END;
    CalcCursor;
    IF OldTop#Top THEN
      OldTop:=Top;
      i:=(MaxPos-Top)/16+1;
      IF i<LINES THEN
        ShowArr(Top,i);
        ClearEOL;
      ELSE
        ShowArr(Top,LINES);
      END;
    END;
    CurOff;
    IF StatChanged THEN
      GotoXY(0,0);
      WriteS('File: '); WriteS(Name);
      Colour(2,0,plain);
      GotoXY(LeftOff,2);
      IF BLength = 1 THEN
        WriteS('0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F   0123456789ABCDEF');
      ELSIF BLength=2 THEN
        WriteS('0 1  2 3  4 5  6 7  8 9  A B  C D  E F   0123456789ABCDEF');
      ELSE
        WriteS('0 1 2 3  4 5 6 7  8 9 A B  C D E F   0123456789ABCDEF');
      END;
      GotoXY(0,LINES+TopOff);
      WriteL('F1:Asc/Hex   F2:Einfgen   F3:Backup   F4:Gross/Klein   F5:Bytezahl    F6:Suchen');
      WriteS('F7:Weitersuchen   F8:Laden   F9:Speichern als   F10:Speichern u. Ende   Esc:Ende');
      GotoXY(0,1);
      IF Asc     THEN WriteS('Asc ') ELSE WriteS('Hex ') END;
      IF Insert  THEN WriteS('   Einfgen    ') ELSE WriteS(' berschreiben ') END;
      IF Backup  THEN WriteS('   Backup    ') ELSE WriteS(' Kein Backup ') END;
      IF CaseEgal THEN WriteS(' Gross ') ELSE WriteS(' Klein ') END;
      IF Changed THEN
        Colour(3,1,plain);
        WriteS('  ! Gendert ! ');
      ELSE
        WriteS(' Nicht gendert')
      END;
      StatChanged:=FALSE;
    END;
    Colour(2,0,plain);
    GotoXY(56,1);
    Format('Pos/Lnge:%6ld/%-6ld',ADR(ActPos));
    NormColours;
    Cursor;
    c:=ReadC();
    CASE CAP(c) OF
    | cUp:     		DEC(ActPos,16);
    | cDown:   		INC(ActPos,16);
    | cLeft:   		DEC(ActPos);
    | cRight:  		INC(ActPos);
    | scUp:    		ActPos:=0;
    | scDown:  		ActPos:=MaxPos;
    | scLeft:  		ActPos:=(ActPos)/16*16;
    | scRight: 		ActPos:=(ActPos)/16*16+15;
    | acUp:    		DEC(ActPos,16*LINES); DEC(Top,16*LINES);
    | acDown:  		INC(ActPos,16*LINES); INC(Top,16*LINES);
    | esc:     		AskSave; RETURN TRUE;
    | kF1:		Asc:=NOT Asc;
    			StatChanged:=TRUE;
    | CHAR(ORD(kF1)+1): Insert:=NOT Insert; StatChanged:=TRUE;
    | CHAR(ORD(kF1)+2): Backup:=NOT Backup; StatChanged:=TRUE;
    | CHAR(ORD(kF1)+3): CaseEgal:=NOT CaseEgal; StatChanged:=TRUE;
    | CHAR(ORD(kF1)+4): BLength:=BLength*2; IF BLength>4 THEN BLength:=1 END;
    			IF BLength=1 THEN AscOff:=LeftOff+16*3+1
    			ELSIF BLength=2 THEN AscOff:=LeftOff+8*5+1
    			ELSE AscOff:=LeftOff+4*9+1;
    			END;
    			GotoXY(0,TopOff-1); ClearEOS;
			OldTop:=-1; StatChanged:=TRUE;
    | CHAR(ORD(kF1)+5): Search(TRUE);
    | CHAR(ORD(kF1)+6): Search(FALSE);
    | CHAR(ORD(kF1)+7): AskSave; RETURN FALSE;
    | CHAR(ORD(kF1)+8): Save(TRUE); RETURN FALSE;
    | CHAR(ORD(kF1)+9): IF Changed THEN Save(FALSE) END; RETURN TRUE;
    | kDel:    		IF Insert THEN Del ELSE ErrBeep END;
    | '0'..'9','A'..'F':
    		IF Asc THEN
    		  SetByte(c);
    		  WriteC(c);
    		ELSE
    		  WriteC(CAP(c)); WriteC('?'); WriteC(CHAR(8));
		  FirstByte:=ORD(CAP(c))-30H;
		  IF FirstByte>9 THEN DEC(FirstByte,7) END;
		  LOOP
		    c:=CAP(ReadC());
		    CASE c OF
		    | '0'..'9','A'..'F': WriteC(c);
		  		     SecByte:=ORD(c)-30H;
		                     IF SecByte>9 THEN DEC(SecByte,7) END;
		                     FirstByte:=FirstByte*16+SecByte;
		                     SetByte(CAST(CHAR,FirstByte));
		                     EXIT;
		    | ELSE ErrBeep;
		    END;
		  END; (* loop *)
		END;
     | ELSE
        IF Asc AND Printable(c) THEN
          SetByte(c);
          WriteC(c)
        ELSE
          ErrBeep
        END;
     END;
  END; (* loop *)
END Edit;

BEGIN
  Name:='';
  MyProcess:=CAST(ProcessPtr,FindTask(NIL));
  OldWindow:=MyProcess^.windowPtr; (* Requester auf BdScreen! *)
  MyProcess^.windowPtr:=GetWindow(); (* TermProc in Module Pointer!! *)
  CurMax(LINES,MAXLINE);
  IF MAXLINE=30 THEN (* PAL *)
    LINES:=24
  ELSE (* NTSC *)
    LINES:=16
  END;
  MAXLINE:=LINES-1;
  Header:='HexEdit V 2.0      23-Sep-1989 Bernd Preusing';
  BLength:=1;
  AscOff:=LeftOff+16*3+1;
  Title(Header);
  GotArg:=FALSE;
  Backup:=TRUE;
  CaseEgal:=FALSE;
  SearchString:=''; SearchLen:=0;
  REPEAT
    Load;
  UNTIL Edit();
END HexEdit.mod
