(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	
    Fehler	:	nicht bekannt    
*)

IMPLEMENTATION MODULE extremstellen;

FROM SYSTEM 		IMPORT	ADR;
FROM LongRealInOut	IMPORT	WriteReal,ReadReal;
FROM InOut 		IMPORT	Write,WriteString,WriteLn,WriteCard,OpenOutput,
				CloseOutput;
FROM startupproc 	IMPORT	CLS,crlf,cursorr,center,solve,m,n,fn,eps,string,
                       		nullbuffer,dateiabfrage,fragedatei,wptr;
FROM intervall 		IMPORT	kleinintervall;
FROM lparser 		IMPORT	lparse;    
FROM Strings 		IMPORT	Length;    
FROM menu 		IMPORT	wartemenu;
FROM Intuition		IMPORT	WindowToFront;


PROCEDURE extremstellen;

CONST
  MAXFOUND = 20;

VAR
  x,dx,xmin,xmax 	: LONGREAL;
  success, found 	: BOOLEAN;
  art,cfound	 	: CARDINAL;
  
BEGIN
  nullbuffer[2]:= "0.2";
  kleinintervall(nullbuffer,ADR("EXTREMSTELLEN - Intervall"));
  xmin:= lparse(nullbuffer[1],0.0);
  dx:=   lparse(nullbuffer[2],0.0);
  xmax:= lparse(nullbuffer[3],0.0);
  art := CARDINAL(lparse(nullbuffer[4],0.0));
  found := FALSE;
  cfound:= 0;
  WindowToFront(wptr);
  Write(CLS); 
  IF dateiabfrage THEN
    fragedatei();
  END;
  center("EXTREMSTELLENBESTIMMUNG"); WriteLn;
  center("-----------------------"); crlf(2);
  center("von"); crlf(2);
  cursorr( 20+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string); crlf(3);
  cursorr(23); WriteString("Xmin: "); WriteReal(xmin,m,n); cursorr(5);
  WriteString("Xmax: "); WriteReal(xmax,m,n); crlf(3);
  x:= solve(xmin,xmax,dx,1,art,success);
  IF success THEN
    REPEAT
      cursorr(26);
      IF fn(x,2) < -eps THEN
        WriteString("H ( ");
      ELSIF fn(x,2) > eps THEN WriteString("T ( ");
      ELSIF (fn(x,3)>eps) OR (fn(x,3)>-eps) THEN WriteString("S ( ");
      ELSE success := FALSE;
      END;						   (* IF 2	*)
      IF success THEN
        WriteReal(x,m,n); WriteString(" , "); WriteReal(fn(x,0),m,n);
        WriteString(" )"); WriteLn;
        found := TRUE;
        INC(cfound);
      END;					    	   (* IF 3	*)
      xmin := x + dx;
      x:= solve(xmin,xmax,dx,1,art,success);
    UNTIL NOT success OR (x>xmax) OR (cfound > MAXFOUND);  (* REPEAT 1	*)
  END;							   (* IF 1	*)
  IF found = FALSE THEN 
    cursorr(22);
    WriteString("Keine Extremstellen im Intervall gefunden"); WriteLn;
  END;
  WriteLn;
  CloseOutput;
  crlf(2); cursorr(22);
  WriteString("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;
END extremstellen;

END extremstellen.    
