(*

    Programm	:	JWELib.mod
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	-
    Fehler	:	nicht bekannt

*)


(* $R- $V- $F- *)
IMPLEMENTATION MODULE jwelib;

FROM    SYSTEM          IMPORT  ADR,ADDRESS,LONGSET,BYTE,REG,INLINE,FFP;
FROM    Graphics        IMPORT  RastPortPtr,BitMapPtr,GetRGB4,
               			ViewModes,ViewModeSet;
FROM    Exec            IMPORT  OpenLibrary,CloseLibrary,LibraryPtr,
                    		MsgPort,OpenDevice,CloseDevice,DoIO,
                                Message,MsgPortPtr;
FROM    ExecSupport     IMPORT  CreatePort,DeletePort;
FROM    Printer         IMPORT  IODRPReq,Special,SpecialSet,dumpRPort,
                                density3,densityMask;
FROM    Arts            IMPORT  Assert,Error,BreakPoint;
FROM    Intuition       IMPORT  ScreenPtr;
FROM    Strings         IMPORT  Occurs,first,last,Length;
FROM    MathTrans       IMPORT  Sqrt,Pow,Acos,Asin,Atan,Cos,Exp,Log,
                    		Log10,Sin,Tan;
FROM    FFPConversions  IMPORT  StrToReal;
FROM    DOS         	IMPORT  Execute,FileHandlePtr,Open,Close,oldFile;


PROCEDURE DumpScreen(rpptr:RastPortPtr;sp:ScreenPtr);  (*sp fuer View.color*)

  VAR
    ppptr           :   MsgPortPtr;
    request         :   IODRPReq;


BEGIN
    
  ppptr:= CreatePort(ADR("printer.port"),0);
  Assert(ppptr#NIL,ADR("Printer.port nicht gefunden"));
  OpenDevice(ADR("printer.device"),0,ADR(request),LONGSET{});
  WITH request DO
    message.replyPort   := ppptr;
    command     := dumpRPort;
    rastPort        := rpptr;
    colorMap        := sp^.viewPort.colorMap;
    modes       := ViewModeSet{hires,lace};
    srcX        := 0;
    srcY        := 0;
    srcWidth        := sp^.width;
    srcHeight       := sp^.height;
    destCols        := 0;
    destRows        := 0;
    special     := density3;
  END;
  DoIO(ADR(request));
  CloseDevice(ADR(request));
  DeletePort(ppptr);
    
 END DumpScreen;
 
 
(*
 
 PROCEDURE RPortToILBM
   (sp:ScreenPtr;rpptr:RastPortPtr;name:ARRAY OF CHAR;depth:LONGCARD);
 
   CONST
     form = "FORM";
     ilbm = "ILBM";
     bmhd = "BMHD";
     cmap = "CMAP";
     body = "BODY";
     
   VAR
     out            : File;
     i,farbn,farbe,dat      : LONGCARD;
     rot,gruen,blau,int     : INTEGER;
     byte           : BYTE;
     bmptr          : BitMapPtr;
     puffer         : ARRAY[0..5] OF ADDRESS;
     written,n          : LONGINT;
     
  
  PROCEDURE write(adr: ADDRESS;len: LONGINT);
  
  BEGIN
    
    WriteBytes(out,adr,len,written);
    
  END write;
  
  
     
BEGIN
 
  farbn:= 1;
  Lookup(out,name,1000,TRUE);
  Assert(out.res=done,ADR("Konnte IFF-Datei nicht ffnen"));
  bmptr:= rpptr^.bitMap;
  FOR i:= 0 TO depth-1 DO
    puffer[i]:= bmptr^.planes[i];
    INC(farbn,farbn);
  END;
  write(ADR(form),4);
  dat:= 48+(farbn*3)+(LONGCARD(sp^.width)/8*LONGCARD(sp^.height)*depth);
  write(ADR(dat),4);
  write(ADR(ilbm),4);
  write(ADR(bmhd),4);
  dat:= 20;
  write(ADR(dat),4);
  write(ADR(sp^.width),2);
  write(ADR(sp^.height),2);
  dat:= 0;
  write(ADR(dat),4);
  byte:= ToByte(depth);
  write(ADR(byte),1);
  write(ADR(dat),1);
  write(ADR(dat),4);
  byte:= 10;
  write(ADR(byte),1);
  byte:= 11;
  write(ADR(byte),1);
  write(ADR(sp^.width),2);
  write(ADR(sp^.height),2);
  write(ADR(cmap),4);
  farbn:= farbn*3;
  write(ADR(farbn),4);
  farbn:= farbn/3;
  FOR i:= 0 TO farbn-1 DO
    farbe:= GetRGB4(sp^.viewPort.colorMap,LONGINT(i));
    rot:= farbe/256;
    rot:= rot*16;
    farbe:= farbe-LONGCARD(rot)*16;
    gruen:= farbe/16;
    gruen:= gruen*16;
    farbe:= farbe-LONGCARD(gruen);
    blau:=  farbe*16;
    write(ADR(rot)+1,1);
    write(ADR(gruen)+1,1);
    write(ADR(blau)+1,1);
  END;
  write(ADR(body),4);
  dat:= LONGCARD(sp^.width)/8*LONGCARD(sp^.height)*depth;
  write(ADR(dat),4);
  FOR n:= 0 TO LONGCARD(sp^.height)-1 DO
    FOR i:= 0 TO depth-1 DO
      write(puffer[i]+(LONGINT(sp^.width)/8*n),LONGINT(sp^.width)/8);
    END;
  END;
  Close(out);
  
END RPortToILBM;
*)
    


  (* $E-    *)
  PROCEDURE ByteToInt(A0{8} : ADDRESS):INTEGER;
  
  BEGIN
  
    INLINE(004112,018560,020085,000000,000000);
    RETURN(REG(0));
    
  END ByteToInt;
  
  
  
  (* $E-    *)
  PROCEDURE ByteToCard(A0{8} : ADDRESS):CARDINAL;
  
  BEGIN
  
    INLINE(004112,018560,020085,000000,000000);
    RETURN(REG(0));
    
  END ByteToCard;
  
  (* $E-    *)
  PROCEDURE ByteToLongInt(A0{8} : ADDRESS):LONGINT;
  
  BEGIN
  
    INLINE(004112,018560,018624,020085,000000);
    RETURN(REG(0));
    
  END ByteToLongInt;
  
  
  
  (* $E-    *)
  PROCEDURE ByteToLongCard(A0{8} : ADDRESS):LONGCARD;
  
  BEGIN
  
    INLINE(004112,018560,018624,020085,000000);
    RETURN(REG(0));
    
  END ByteToLongCard;
  
  
  
  PROCEDURE ToByte(in:ARRAY OF BYTE):BYTE;
  
  BEGIN
  
    RETURN(in[HIGH(in)]);
    
  END ToByte;
  
  
  PROCEDURE Prim(n: LONGCARD):BOOLEAN;    
  
    VAR
      jn   : BOOLEAN;
      lauf, step    : LONGCARD;

  BEGIN    
    
    jn := TRUE;
    lauf := 2;
    step := 2;
    IF n>40 THEN
      WHILE (lauf*lauf<=n) AND jn DO
        IF n MOD lauf = 0 THEN
          jn := FALSE
        ELSIF lauf<5 THEN
          INC(lauf,lauf-1); 
        ELSE
          INC(lauf,step); 
          step := 6 - step;
        END;
      END;
    ELSE
      IF (n#1) AND (n#2) AND (n#3) AND (n#5) AND (n#7) AND (n#11) AND (n#17) 
         AND (n#19) AND (n#23) AND (n#29) AND (n#31) AND (n#37) AND (n#13) THEN
        jn:= FALSE;
      END;
    END;
    RETURN jn;
  
  END Prim;
  

PROCEDURE parse(argument: ARRAY OF CHAR;X:FFP):FFP;

  CONST
    CLS     = CHR(12);
    NULL    = "";
    TOKSIZE = 20;

  VAR
    now         : CARDINAL;
    arglen,lauf     : INTEGER;
    exprs       : ARRAY [0..90]  OF CHAR;
    ans,Xres        : FFP;  



PROCEDURE Round(n : FFP):FFP;

BEGIN
  
  IF n<0.0 THEN
    RETURN(FFP(TRUNC(n-0.5)));
  ELSE
    RETURN(FFP(TRUNC(n+0.5)));
  END;

END Round;



PROCEDURE Fak(n : FFP):FFP;

VAR
  x,i,k : CARDINAL;

BEGIN
  x:= TRUNC(ABS(n));  
  IF x>20 THEN 
    BreakPoint(ADR("! Fak(x) -> Fak(20) !"));
    x:= 20;
  END;
  k:= 1;
  FOR i:= x TO 2 BY -1 DO
    k:= k*x;
  END;
  RETURN FFP(k);
END Fak;




PROCEDURE fastnull(zahl:FFP):BOOLEAN;

BEGIN
  
  RETURN (ABS(zahl)<0.000001);

END fastnull;






PROCEDURE binary(a,b:FFP; tok: ARRAY OF CHAR):FFP;
  
  VAR
    c       : FFP;
    index   : INTEGER;

BEGIN
  
  CASE tok[0] OF
    | "+": RETURN (a+b)
    | "-": RETURN (a-b)
    | "*": RETURN (a*b)
    | "/": IF NOT fastnull(b) THEN
             RETURN (a/b);
           ELSIF ((a>0.0) AND (b>0.0)) OR ((a<0.0) AND (b<0.0)) THEN
             RETURN MAXFFP;
           ELSE
             RETURN -MAXFFP;
           END;
    | "^": c:= a;
           FOR index:= 1 TO INTEGER(ABS(b))-1 DO
             a:= a*c;
           END;
           IF b<0.00001 THEN 
             IF NOT fastnull(a) THEN
               a:= 1.0/a;
             ELSE                   (* IF 2     *)
               a:= MAXFFP;
             END;                   (* IF 2     *)
           END;                     (* IF 1     *)
           IF ABS(b)<0.000001 THEN
             a:= 1.0;
           END;
           RETURN a;        
    | "&": RETURN (Pow(a,b)) |
  ELSE
    BreakPoint(ADR("!   Operator nicht gefunden   !"));
    RETURN 0.0;
  END;                          (* CASE 1   *)
END binary;



PROCEDURE stripleer;

BEGIN
  
  WHILE (exprs[now]=" ") DO
    INC(now);
  END;
  
END stripleer;



PROCEDURE getfn(VAR tok: ARRAY OF CHAR);

  VAR
    toklauf : CARDINAL;

BEGIN
  FOR toklauf:= 0 TO TOKSIZE DO
    tok[toklauf]:=" ";
  END;
  toklauf:=0;
  stripleer;
  WHILE ( (exprs[now]>="A") AND (exprs[now]<="Z") ) DO
     tok[toklauf]:=exprs[now];
     INC(toklauf);
     INC(now);
  END;

END getfn;



PROCEDURE getnumb(VAR tok: ARRAY OF CHAR);

  VAR
    toklauf: CARDINAL;
BEGIN
  
  FOR toklauf:= 0 TO TOKSIZE DO
    tok[toklauf]:=" ";
  END;
  stripleer;
  toklauf:=0;
  WHILE 
  (  ( (exprs[now]>="0") AND (exprs[now]<="9") ) OR (exprs[now]=".") ) DO
    tok[toklauf]:= exprs[now];
    INC(toklauf);
    INC(now);
  END;

END getnumb;      



PROCEDURE gettoken(VAR tok: ARRAY OF CHAR);

  VAR
    c: CHAR;

BEGIN
  
  stripleer;
  c:=exprs[now];
  IF (
      (c="+") OR (c="-") OR (c="*") OR (c="/") OR (c="^") OR (c=")") OR 
      (c="&")
     ) THEN
    tok[0]:= exprs[now];
    INC(now);
  ELSE
    tok[0]:= NULL;
  END;
  
END gettoken;
  
  
  
PROCEDURE parse0():FFP; FORWARD;



PROCEDURE parse5():FFP;

  VAR
    tok,zahlstr     : ARRAY[0..TOKSIZE] OF CHAR;
    a           : FFP;
    err         : BOOLEAN;
    toklen,index    : CARDINAL;
  
  
  PROCEDURE fneval():FFP;
  
  BEGIN
    
    IF tok[0]="X" THEN
      RETURN Xres;
    ELSIF (Occurs(tok,first,"PI",FALSE)#last) THEN
      RETURN 3.14159265;  
    ELSIF (Occurs(tok,first,"SQRT",FALSE)#last) THEN
      RETURN (Sqrt(parse5()));
    ELSIF (Occurs(tok,first,"EXP",FALSE)#last) THEN
      RETURN (Exp(parse5()));
    ELSIF (Occurs(tok,first,"LN",FALSE)#last) THEN
      RETURN (Log(parse5()));
    ELSIF (Occurs(tok,first,"ARCCOS",FALSE)#last) THEN
      RETURN (Acos(parse5()));
    ELSIF (Occurs(tok,first,"ARCSIN",FALSE)#last) THEN
      RETURN (Asin(parse5()));
    ELSIF (Occurs(tok,first,"ARCTAN",FALSE)#last) THEN
      RETURN (Atan(parse5()));
    ELSIF (Occurs(tok,first,"ARCCOT",FALSE)#last) THEN
      RETURN (Atan(1.0/parse5()));
    ELSIF (Occurs(tok,first,"SIN",FALSE)#last) THEN
      RETURN (Sin(parse5()));  
    ELSIF (Occurs(tok,first,"COS",FALSE)#last) THEN
      RETURN (Cos(parse5()));
    ELSIF (Occurs(tok,first,"LOG",FALSE)#last) THEN
      RETURN (Log10(parse5()));
    ELSIF (Occurs(tok,first,"TAN",FALSE)#last) THEN
      RETURN (Tan(parse5()));
    ELSIF (Occurs(tok,first,"COT",FALSE)#last) THEN
      RETURN (1.0/Tan(parse5()));
    ELSIF (Occurs(tok,first,"FAK",FALSE)#last) THEN
      RETURN (Fak(parse5()));
    ELSIF (Occurs(tok,first,"ABS",FALSE)#last) THEN
      RETURN (ABS(parse5()));
    ELSIF (Occurs(tok,first,"TRUNC",FALSE)#last) THEN
      RETURN (FFP(TRUNC(parse5())));
    ELSIF (Occurs(tok,first,"ROUND",FALSE)#last) THEN
      RETURN (Round(parse5()));
    ELSIF (Occurs(tok,first,"EE",FALSE)#last) THEN
      RETURN 2.7182818284;
    ELSE
      BreakPoint(ADR("! Funktion nicht implementiert !"));
      RETURN 0.0;
    END;
  
  END fneval;



BEGIN                           (* parse5 Main  *)
  getfn(tok);
  IF tok[0]#" " THEN
    RETURN (fneval());
  END;
  getnumb(tok);
  IF tok[0]#" " THEN
    StrToReal(tok,a,err);
    IF err THEN
      BreakPoint(ADR("!  Fehler bei StrToReal  !"));
      RETURN 0.0;
    ELSE                        (* IF 2     *)
      RETURN(a)
    END;                        (* IF 2     *)
  END;                          (* IF 1     *)
  IF (exprs[now]="(") THEN
    INC(now);
    a:= parse0();
    IF (exprs[now]=")") THEN
      INC(now);
    ELSE                        (* IF 4     *)
      Error(ADR("!   Falscher Klammerausdruck   !"),ADR("Nicht behebbar"));
    END;                        (* IF 4     *)
    RETURN a;
  END;                          (* IF 3     *)
  BreakPoint(ADR("!   Ausdruck nicht erkannt   !"));
  RETURN 0.0;

END parse5;



PROCEDURE parse4():FFP;

  VAR
    tok     : ARRAY [0..TOKSIZE] OF CHAR;

BEGIN
  
  gettoken(tok);
  IF (tok[0]="-") THEN
    RETURN (-(parse4()));
  ELSIF (tok[0]="+") THEN
    RETURN(parse4());
  ELSIF (tok[0]=NULL) THEN
    RETURN (parse5());
  END;
  DEC(now);
  RETURN(parse5());

END parse4;



PROCEDURE parse3():FFP;

  VAR
    tok     : ARRAY [0..TOKSIZE] OF CHAR;
    a       : FFP;

BEGIN
  
  a:= parse4();
  WHILE (exprs[now]#NULL) DO
    gettoken(tok);
    IF (  (tok[0]="^") OR (tok[0]="&")  ) THEN
      a:= binary(a,parse4(),tok);
    ELSE
      DEC(now);
    END;
    RETURN a;
  END;
  RETURN a;

END parse3;



PROCEDURE parse2():FFP;

  VAR
    tok     : ARRAY [0..TOKSIZE] OF CHAR;
    a       : FFP;

BEGIN
  
  a:= parse3();
  WHILE (exprs[now]#NULL) DO
    gettoken(tok);
    IF ((tok[0]="*") OR (tok[0]="/")) THEN
      a:= binary(a,parse3(),tok);
    ELSE                        (* IF 1     *)
      DEC(now);
      RETURN a;
    END;                        (* IF 1     *)
  END;                          (* WHILE 1  *)
  RETURN a;

END parse2;



PROCEDURE parse0():FFP;

  VAR
    tok     : ARRAY [0..TOKSIZE] OF CHAR;
    a       : FFP;

BEGIN 
  
  a:= parse2();
  WHILE (exprs[now]#NULL) DO
    gettoken(tok);
    IF ((tok[0]="+") OR (tok[0]="-")) THEN
      a:= binary(a,parse2(),tok);
    ELSE                        (* IF 1     *)
      DEC(now);
      RETURN a;
    END;                        (* IF 1     *)
  END;                          (* WHILE 1  *)
  RETURN a;
  
END parse0;




BEGIN
  Xres:=X;
  arglen:= Length(argument);
  FOR lauf:= 1 TO arglen DO
    exprs[lauf]:= CAP(argument[lauf-1]);
  END;
  exprs[0]:= NULL;
  exprs[arglen+1]:=NULL;
  now:=1;
  ans:= parse0();
  IF exprs[1]=NULL THEN
    Error(ADR("! String nicht zu parsen !"),ADR("Nicht behebbar"));
  END; 
  RETURN ans;

END parse;


PROCEDURE fastnull(zahl:FFP):BOOLEAN;

BEGIN
  
  RETURN (ABS(zahl)<0.000001);

END fastnull;  


PROCEDURE WBExecute(Order:ADDRESS):LONGINT;
CONST
  NoHandle = 1122;
VAR
  Handle: FileHandlePtr;
  Error : LONGINT;
BEGIN
  Handle:= Open(ADR("NIL:"),oldFile);
  IF Handle # NIL THEN
    Error:= Execute(Order,Handle,Handle);
    Close(Handle);
    RETURN Error;
  END;
  RETURN NoHandle;
END WBExecute;

PROCEDURE fastnullL(zahl:LONGREAL):BOOLEAN;

BEGIN
  
  RETURN (ABS(zahl)<0.000000001);

END fastnullL;

END jwelib.  
