(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	
    Fehler	:	nicht bekannt
*)

IMPLEMENTATION MODULE nullstellen;

FROM SYSTEM 		IMPORT 	ADR;
FROM LongRealInOut	IMPORT 	WriteReal,ReadReal;
FROM InOut 		IMPORT 	Write,WriteString,WriteLn,WriteCard,OpenOutput,
				CloseOutput;
FROM startupproc 	IMPORT 	CLS,crlf,cursorr,solve,m,n,nullbuffer,string,
				dateiabfrage,center,fragedatei,wptr;
FROM intervall 		IMPORT 	kleinintervall;
FROM lparser 		IMPORT 	lparse;    
FROM Strings 		IMPORT 	Length;
FROM menu 		IMPORT 	wartemenu;
FROM Intuition		IMPORT	WindowToFront;


PROCEDURE nullstellen;
  
  CONST
    MAXFOUND = 20;
    
  VAR
    x,dx,xmin,xmax 	: LONGREAL;
    success        	: BOOLEAN;
    zaehler,art 	: CARDINAL;

BEGIN
  nullbuffer[2]:= "0.2";
  kleinintervall(nullbuffer,ADR("NULLSTELLEN - Intervall"));
  xmin:= lparse(nullbuffer[1],0.0);
  dx:=   lparse(nullbuffer[2],0.0);
  xmax:= lparse(nullbuffer[3],0.0);
  art:=  CARDINAL(lparse(nullbuffer[4],0.0));
  WindowToFront(wptr);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;  
  center("N U L L S T E L L E N"); WriteLn;
  center("---------------------"); crlf(2);
  center("von"); crlf(2);
  cursorr( 20+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string); crlf(3);  
  cursorr(23); WriteString("Xmin: "); WriteReal(xmin,m,n); cursorr(5);
  WriteString("Xmax: "); WriteReal(xmax,m,n); crlf(3);
  zaehler:= 0;
  success:= FALSE;
  x:= solve(xmin,xmax,dx,0,art,success);
  IF success THEN
    REPEAT
      INC(zaehler);
      cursorr(26);
      WriteCard(zaehler,3);
      WriteString(".    N ( "); WriteReal(x,m,n);WriteString("  , 0 )");WriteLn;
      xmin:= x + dx;
      x:= solve(xmin,xmax,dx,0,art,success);
    UNTIL ( NOT success OR (x>xmax) OR (zaehler>MAXFOUND) );
  ELSE							(* IF 1		*)
    center("Keine Nullstelle gefunden"); WriteLn;
  END;							(* IF 1		*)
  WriteLn;
  CloseOutput;
  crlf(3);
  center("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;
END nullstellen;


END nullstellen.
