(*
    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	NewMathLib fr UPN von Philippe Gressly, Update von JWE
    Fehler	:	nicht bekannt
*)

IMPLEMENTATION MODULE plotter;

FROM InOut 		IMPORT 	Write,WriteCard,ReadCard,WriteString,WriteLn;
FROM LongRealInOut	IMPORT 	WriteReal;
FROM SYSTEM 		IMPORT 	ADR,ADDRESS;
FROM Arts 		IMPORT 	Assert,BreakPoint;
FROM Intuition 		IMPORT 	ScreenPtr,CloseScreen,WBenchToFront,
				ScreenToFront,IntuiMessage,IDCMPFlags,
                                IDCMPFlagSet,ModifyIDCMP,ActivateWindow;
FROM Graphics 		IMPORT 	ViewPortPtr,RastPortPtr,SetAPen,ViewPort,Move,
				RastPort,jam1,WritePixel,Draw,SetRGB4,Text,
                                DrawModes,DrawModeSet,SetDrMd,TextLength;
FROM Exec 		IMPORT 	GetMsg,ReplyMsg,WaitPort,UByte;
FROM Str 		IMPORT 	Length,Copy,Concat;
FROM Dos		IMPORT	Delay;
FROM LongRealConversions 	IMPORT 	RealToStr;
FROM kurvescreen 	IMPORT 	SetUpScreen,MakeWindow;
FROM startupproc 	IMPORT 	crlf,cursorr,CLS,fn,m,n,sp,wp,cleanup,neu,intf,
				grenze,gadgetid,string,STRING,festgrenzestr;
FROM lparser 		IMPORT 	lparse;
FROM intervall 		IMPORT 	grossintervall,fktstring;
FROM menu 		IMPORT 	plotmenu,ablmenu;
FROM NewMathLib		IMPORT  ArEr,ArErType;

  CONST
    err				=   0.001;
    strich          		=   4.0;
    screenxmaxint   		= 639;
    screenxmax      		= 639.0;
    screenymaxint   		= 511;
    screenymax      		= 511.0;
    linksint        		=  50;
    links   	  		=  50.0;
    rechtsint     		=  20;
    rechts        		=  20.0;
    untenint	 		=  70;
    unten			=  70.0;
    oben		  	=  30.0;
    obenint         		=  30;
  
  VAR
    hRegister[0BFEC01H]			: UByte;
    lastKey				: UByte;
    rp 					: RastPortPtr;
    vp 					: ViewPortPtr;
    abl,dummy,taste,modus		: CARDINAL;
    xmin,xmax,ymin,ymax,dx,dy,x,d,s 	: LONGREAL;
    erfolg				: BOOLEAN;
    msg					: POINTER TO IntuiMessage;
    mousex,mousey,ax,ay			: INTEGER;
    xkoord,ykoord			: LONGREAL;	
    kstring				: ARRAY [0..70] OF CHAR;
    class				: IDCMPFlagSet;
    first,error				: BOOLEAN;


PROCEDURE screentoworld(x,y : INTEGER; VAR realx,realy : LONGREAL);
  
  BEGIN
    realx:= LONGREAL((x-linksint))*(xmax-xmin)/(screenxmax-links-rechts) + xmin;
    realy:=LONGREAL((screenymaxint-y-untenint))*(ymax-ymin)/(screenymax-unten-oben)
           +ymin;
  END screentoworld;
  

  	
PROCEDURE kreuz(kx,ky : INTEGER);

BEGIN
  IF (    (kx>=linksint) AND (kx<=screenxmaxint-rechtsint) AND 
          (ky>=obenint)  AND (ky<=screenymaxint-untenint)        ) THEN
    SetDrMd(rp,DrawModeSet{complement});
    Move(rp,linksint,ky); 
    Draw(rp,screenxmaxint-rechtsint,ky);
    Move(rp,kx,obenint); 
    Draw(rp,kx,screenymaxint-untenint);
    SetDrMd(rp,DrawModeSet{dm0});
  END;
END kreuz;



PROCEDURE koordinatenmit();

BEGIN
  first:= TRUE;
  ax:= 1; ay:= 1;
  ScreenToFront(sp);
  ActivateWindow(wp);
  kreuz(ax,ay);
  LOOP
    ModifyIDCMP(wp,IDCMPFlagSet{closeWindow,mouseMove,mouseButtons,intuiTicks});
    WaitPort(wp^.userPort);
    lastKey:= hRegister;
    ModifyIDCMP(wp,IDCMPFlagSet{mouseMove,mouseButtons,closeWindow});
    msg:= GetMsg(wp^.userPort);
    class:= msg^.class;
    ReplyMsg(msg);
    IF (closeWindow IN class) THEN
      EXIT;
    ELSIF (lastKey=119) OR (lastKey=121) THEN
      kreuz(ax,ay);
      EXIT;
    ELSIF (mouseMove IN class) THEN
      ModifyIDCMP(wp,IDCMPFlagSet{});
      mousex:= msg^.mouseX; mousey:= msg^.mouseY;
      kreuz(ax,ay);
      kreuz(mousex,mousey);
      ax:= mousex; ay:= mousey;
      screentoworld(mousex,mousey,xkoord,ykoord);
      Move(rp,100,495);
      kstring:= "X-Koordinate : ";
      Text(rp,ADR(kstring[0]),Length(kstring));
      RealToStr(xkoord,kstring,m,n,FALSE,erfolg);
      Text(rp,ADR(kstring[0]),Length(kstring));
      Move(rp,350,495);
      kstring:= "Y-Koordinate : ";
      Text(rp,ADR(kstring[0]),Length(kstring));
      RealToStr(ykoord,kstring,m,n,FALSE,erfolg);
      Text(rp,ADR(kstring[0]),Length(kstring));
    ELSIF (mouseButtons IN class) THEN
      ModifyIDCMP(wp,IDCMPFlagSet{});
      IF first THEN
        mousex:= msg^.mouseX; mousey:= msg^.mouseY;
        ax:= mousex + 1; ay:= mousey + 1;
        screentoworld(mousex,mousey,xkoord,ykoord);
        RealToStr(xkoord,grenze[3],m,n,FALSE,erfolg);
        RealToStr(ykoord,grenze[1],m,n,FALSE,erfolg);
        kreuz(ax,ay);
        first:= FALSE;
        Delay(10);
      ELSE						(* IF 2		*)
        mousex:= msg^.mouseX; mousey:= msg^.mouseY;      
        screentoworld(mousex,mousey,xkoord,ykoord);
        RealToStr(xkoord,grenze[4],m,n,FALSE,erfolg);
        RealToStr(ykoord,grenze[2],m,n,FALSE,erfolg);
	neu:= TRUE;
      END; 						(* IF 2		*) 
    END; 						(* IF 1		*)
    IF neu THEN 
      IF lparse(grenze[1],0.0)<lparse(grenze[2],0.0) THEN
        grenze[10]:= grenze[1];
        grenze[1]:=  grenze[2];
        grenze[2]:=  grenze[10];
      END;
      IF lparse(grenze[4],0.0)<lparse(grenze[3],0.0) THEN
        grenze[10]:= grenze[4];
        grenze[4]:=  grenze[3];
        grenze[3]:=  grenze[10];
      END;
      EXIT;
    END;     
  END;     						(* LOOP 	*)
  kstring:= "                                                                 ";
  Move(rp,50,495);
  Text(rp,ADR(kstring[0]),Length(kstring));
  erfolg:= WBenchToFront();
END koordinatenmit;

  
PROCEDURE plotter;
  
  PROCEDURE worldtoscreen(x,y: LONGREAL; VAR xs,ys: INTEGER); 
  
  BEGIN
    xs:= INTEGER(
         TRUNC((x-xmin)*(screenxmax-links-rechts)/(xmax-xmin)+links+0.5));  
    ys:= screenymaxint-
         INTEGER(
         TRUNC((y-ymin)*(screenymax-unten-oben)/(ymax-ymin)+unten+0.5)); 
  END worldtoscreen;


  PROCEDURE drawpoint(x,y: LONGREAL); (* Im Funktionskoordinatensystem *)

    VAR
      xp,yp 	:  INTEGER;
      dummy 	:  LONGINT;
  
  BEGIN
    worldtoscreen(x,y,xp,yp);
    dummy:= WritePixel(rp,xp,yp);
  END drawpoint;


  PROCEDURE drawline(x1,y1,x2,y2 :  LONGREAL); (* Im Funktionskoordinatensystem *)

    VAR
      xp1,yp1,xp2,yp2 	:  INTEGER;
  
  BEGIN
    worldtoscreen(x1,y1,xp1,yp1);
    worldtoscreen(x2,y2,xp2,yp2);
    Move(rp,xp1,yp1);
    Draw(rp,xp2,yp2);
  END drawline;


  PROCEDURE draw2(x1,y1,x2,y2 : INTEGER);  (* Im umgekehrten Rechnersystem *)

  BEGIN
    Move(rp,x1,screenymaxint-y1);
    Draw(rp,x2,screenymaxint-y2);
  END draw2;

  PROCEDURE SetYText(y:LONGREAL;yoff:INTEGER;textadr:ADDRESS;textlen:INTEGER);
  VAR
    xs,ys : INTEGER;
  BEGIN
    worldtoscreen(0.0,y,xs,ys);
    Move(rp,0,ys+yoff);
    Text(rp,textadr,textlen);
  END SetYText;
  
  PROCEDURE SetXText(x:LONGREAL;textadr:ADDRESS;textlen:INTEGER);
  VAR
    xs,ys,xoff : INTEGER;
  BEGIN
    worldtoscreen(x,0.0,xs,ys);
    xoff:= TextLength(rp,textadr,textlen) DIV 2;
    Move(rp,xs-xoff,25);
    Text(rp,textadr,textlen);
  END SetXText;
  
  PROCEDURE EvalStr(koord:LONGREAL;VAR str: ARRAY OF CHAR;VAR err:BOOLEAN);
  VAR
    helpstr	: ARRAY [0..30] OF CHAR;
    i,j	   	: CARDINAL;
  BEGIN
    RealToStr(koord,helpstr,6,2,FALSE,err);
    j:= 0;
    FOR i:= 0 TO Length(helpstr) DO
      IF helpstr[i] # ' ' THEN
        str[j]:= helpstr[i];
        INC(j);
      END;
    END;
  END EvalStr;
    

  PROCEDURE koordinatenkreuz;
    VAR
      x,y,dist 		:  LONGREAL;
      str      		:  ARRAY [0..30] OF CHAR;
      err      		:  BOOLEAN;
      xs,ys		:  INTEGER;
  BEGIN
    SetAPen(rp,1);
    dist:= strich*(xmax-xmin)/(screenxmax-links-rechts); 
    y:= dy;
    WHILE y<=ymax DO
      drawline(xmin-dist,y,xmin+dist,y);
      drawline(xmax-dist,y,xmax+dist,y);
      EvalStr(y,str,err);
      IF NOT err THEN
        SetYText(y,4,ADR(str),Length(str));
      END;
      y:= y + dy; 
    END;
    y:= 0.0;
    WHILE y>=ymin DO
      drawline(xmin-dist,y,xmin+dist,y);
      drawline(xmax-dist,y,xmax+dist,y);
      EvalStr(y,str,err);
      IF NOT err THEN
        SetYText(y,4,ADR(str),Length(str));
      END;
      y:= y -  dy; 
    END;
    dist:= strich*(ymax-ymin)/(screenymax-oben-unten); 
    x:= dx;
    WHILE x<=xmax DO
      drawline(x,ymin-dist,x,ymin+dist);
      drawline(x,ymax-dist,x,ymax+dist);
      EvalStr(x,str,err);
      IF NOT err THEN
        SetXText(x,ADR(str),Length(str));
      END;
      x:= x + dx; 
    END;
    x:= 0.0;
    WHILE x>=xmin DO
      drawline(x,ymin-dist,x,ymin+dist);
      drawline(x,ymax-dist,x,ymax+dist);
      EvalStr(x,str,err);
      IF NOT err THEN
        SetXText(x,ADR(str),Length(str));
      END;
      x:= x -  dx; 
    END;
    drawline(xmin,0.0,xmax,0.0);
    drawline(0.0,ymin,0.0,ymax);
    draw2(linksint,untenint,linksint,screenymaxint-obenint);
    draw2(screenxmaxint-rechtsint,untenint,screenxmaxint-rechtsint,
          screenymaxint-obenint);
    draw2(linksint,untenint,screenxmaxint-rechtsint,untenint);
    draw2(linksint,screenymaxint-obenint,screenxmaxint-rechtsint,
          screenymaxint-obenint);
    Move(rp,10,screenymaxint-untenint+15);
    str:= "Xmin : ";
    Text(rp,ADR(str[0]),Length(str));
    RealToStr(xmin,str,m,n,FALSE,err);
    Text(rp,ADR(str[0]),Length(str));
    str:= "                Dx : ";
    Text(rp,ADR(str[0]),Length(str));
    RealToStr(dx,str,m,n,FALSE,err);
    Text(rp,ADR(str[0]),Length(str));
    str:= "                 Xmax : ";
    Text(rp,ADR(str[0]),Length(str));
    RealToStr(xmax,str,m,n,FALSE,err);
    Text(rp,ADR(str[0]),Length(str));
    Move(rp,10,screenymaxint-untenint+30); 
    str:= "Ymin : ";
    Text(rp,ADR(str[0]),Length(str));
    RealToStr(ymin,str,m,n,FALSE,err);
    Text(rp,ADR(str[0]),Length(str));
    str:= "                Dy : ";
    Text(rp,ADR(str[0]),Length(str));
    RealToStr(dy,str,m,n,FALSE,err);
    Text(rp,ADR(str[0]),Length(str));
    str:= "                 Ymax : ";
    Text(rp,ADR(str[0]),Length(str));
    RealToStr(ymax,str,m,n,FALSE,err);
    Text(rp,ADR(str[0]),Length(str));
END koordinatenkreuz;


PROCEDURE zeichnen;

  VAR
   altd,hy1,hy2		: LONGREAL;
   ohnestepper		: CARDINAL;

  BEGIN  
    ScreenToFront(sp);
    ohnestepper:= 0;
    x:= xmin;
    d:= (xmax-xmin)/s;
    altd:= d;
    WHILE (x+d)<=xmax DO
      hy1:= fn(x,abl);
      hy2:= fn(x+d,abl);
      IF (hy1>=ymin) AND (hy1<=ymax) AND (hy2>=ymin) AND (hy2<=ymax) AND
         (ArEr=ArNoEr) THEN
        IF   (ohnestepper>2) AND (d+d<=altd) THEN
          d:=d+d;
          ohnestepper:= 0;
          x:= x - d;
        ELSE						(* IF 2		*)
          drawline(x,hy1,x+d,hy2);
          INC(ohnestepper);
        END;						(* IF 2		*)
      ELSE						(* IF 1		*)
        IF (d>=2.0*(xmax-xmin)/(screenxmax-links-rechts)) THEN
          d:= d/2.0;
          ohnestepper:= 0;
          x:= x-d;
        END;						(* IF 3		*)
      END;						(* IF 1		*)
      x:= x + d;
    END;						(* WHILE 1	*)
  END zeichnen;


  PROCEDURE schnellzeichnen;
  
  VAR
    hy1,hy2 : LONGREAL;
  
  BEGIN  
    ScreenToFront(sp);
    x:= xmin;
    d:= (xmax-xmin)/s;
    WHILE (x+d)<=xmax DO
      hy1:= fn(x,abl);
      hy2:= fn(x+d,abl);
      IF (hy1>=ymin) AND (hy1<=ymax) AND (hy2>=ymin) AND (hy2<=ymax) AND
         (ArEr=ArNoEr) THEN
          drawline(x,hy1,x+d,hy2);
      END;
      x:= x + d;
    END;
  END schnellzeichnen;
  
  
  PROCEDURE intfzeichnen;
  
    VAR
      sum,sumplusd,festgrenze,fehler	: LONGREAL;
      zuviele				: BOOLEAN;
      
  BEGIN  
    fktstring(festgrenzestr);
    ScreenToFront(sp);
    festgrenze:= lparse(festgrenzestr,0.0);
    fehler:= err;
    IF festgrenze=xmin THEN
      sum:= 0.0;
    ELSE
      sum:= intf(festgrenze,xmin,fehler,zuviele);
    END;
    sumplusd:= 0.0;
    d:= (xmax-xmin)/s;
    x:= xmin;
    fehler:= err;
    sumplusd:= sum + intf(x,x+d,fehler,zuviele);
    IF NOT(zuviele) AND (sum>=ymin) AND (sum<=ymax) AND (sumplusd>=ymin) AND 
       (sumplusd<=ymax) THEN
      drawline(x,sum,x+d,sumplusd);
    END;
    sum:= sumplusd;
    x:= x + d;
    WHILE (x+d)<=xmax DO
      fehler:= err;
      sumplusd:= sum + intf(x,x+d,fehler,zuviele);
      IF (sum>=ymin) AND (sum<=ymax) AND 
         (sumplusd>=ymin) AND (sumplusd<=ymax) THEN
        drawline(x,sum,x+d,sumplusd);
      END;
      sum:= sumplusd;
      x:= x + d;
    END;
  END intfzeichnen;
  
  
BEGIN							(* plotter Main	*)
  REPEAT
    Write(CLS);
    IF neu THEN
      grossintervall(grenze);
      xmin := lparse(grenze[3],0.0);            
      xmax := lparse(grenze[4],0.0);
      ymin := lparse(grenze[2],0.0);
      ymax := lparse(grenze[1],0.0);
      dx   := lparse(grenze[5],0.0);
      dy   := lparse(grenze[6],0.0);
      abl  := CARDINAL(lparse(grenze[7],0.0));
      s    := lparse(grenze[8],0.0);
      modus:= CARDINAL(lparse(grenze[9],0.0));
      crlf(3);
      sp:= SetUpScreen();
      Assert(sp#NIL,ADR("Screen konnte nicht geffnet werden"));
      wp:= MakeWindow(sp,gadgetid);
      Assert(wp#NIL,ADR("Window konnte nicht geffnet werden"));
      vp:= ADR(sp^.viewPort);
      rp:= wp^.rPort;
      SetRGB4(vp,0,15,15,15);
      SetRGB4(vp,1,0,0,0);
      SetAPen(rp,1);
      koordinatenkreuz;
      neu:= FALSE;
      erfolg:= WBenchToFront();
      IF abl=4 THEN
        intfzeichnen;
      ELSIF modus=0  THEN
        schnellzeichnen;
      ELSIF modus=1 THEN				(* IF 2		*)
        zeichnen;
      END;						(* IF 2		*)
      erfolg := WBenchToFront();
      taste:= 4;
    ELSE						(* IF 1		*)
      koordinatenmit();
      IF neu THEN 
        taste:= 1;
      ELSE						(* IF 3		*)
        plotmenu(taste);
      END;						(* IF 3		*)
    END;						(* IF 1		*)
    CASE taste OF
      |  1: CloseScreen(sp); neu:= TRUE;
      |  2: ablmenu(abl);
            IF abl=4 THEN
              intfzeichnen;
	    ELSIF modus=0  THEN
              schnellzeichnen; 
            ELSIF modus=1 THEN
              zeichnen;
            END;
            erfolg:= WBenchToFront();
      |  3: ;
      |  4: ;
    END;						(* CASE 1	*)
  UNTIL taste = 3;					(* REPEAT 1	*)
END plotter;


PROCEDURE koordinaten();
VAR
  helpstr : STRING;

BEGIN
  ax:= 1; ay:= 1;
  ScreenToFront(sp);
  ActivateWindow(wp);
  kreuz(ax,ay);
  LOOP
    ModifyIDCMP(wp,IDCMPFlagSet{mouseMove,mouseButtons,closeWindow,intuiTicks});
    WaitPort(wp^.userPort);
    lastKey:= hRegister;
    ModifyIDCMP(wp,IDCMPFlagSet{mouseMove,mouseButtons,closeWindow});
    msg:= GetMsg(wp^.userPort);
    class:= msg^.class;
    ReplyMsg(msg);
    IF (closeWindow IN class) THEN
      EXIT;
    ELSIF (lastKey=119) OR (lastKey=121) THEN
      kreuz(ax,ay);
      EXIT;
    ELSIF (mouseButtons IN class) THEN
      Copy(helpstr,"f(x)=");
      Concat(helpstr,string);
      ModifyIDCMP(wp,IDCMPFlagSet{});
      mousex:= msg^.mouseX; mousey:= msg^.mouseY; 
      Move(rp,mousex+5,mousey-5);
      Text(rp,ADR(helpstr),Length(helpstr));   
    ELSIF
      (mouseMove IN class) THEN
      ModifyIDCMP(wp,IDCMPFlagSet{});
      mousex:= msg^.mouseX; mousey:= msg^.mouseY;
      kreuz(ax,ay);
      kreuz(mousex,mousey);
      ax:= mousex; ay:= mousey;
      screentoworld(mousex,mousey,xkoord,ykoord);
      Move(rp,100,495);
      kstring:= "X-Koordinate : ";
      Text(rp,ADR(kstring[0]),Length(kstring));
      RealToStr(xkoord,kstring,m,n,FALSE,erfolg);
      Text(rp,ADR(kstring[0]),Length(kstring));
      Move(rp,350,495);
      kstring:= "Y-Koordinate : ";
      Text(rp,ADR(kstring[0]),Length(kstring));
      RealToStr(ykoord,kstring,m,n,FALSE,erfolg);
      Text(rp,ADR(kstring[0]),Length(kstring));
    END; 						(* IF 1		*)
  END;     						(* LOOP 1	*)
  kstring:= "                                                               ";
  Move(rp,50,495);
  Text(rp,ADR(kstring[0]),Length(kstring));
  erfolg:= WBenchToFront();
END koordinaten;

END plotter.
