(*

    Programm	:	Kurve
    Autor	:	Jrg Wesemann
    Adresse	:	Auf der Heide 10 , 2807 Achim - Baden
    Telefon	:	04202 / 70658
    Version	:	3.20 (deutsch)
    Datum	:	28.09.1989
    Copyright	:	Public Domain, bei eigenen nderungen bitte Nachricht !
    Compiler	:	M2-Amiga Modula-2, Version 3.2d, 01.11.88
    Importiert	:	-
    Fehler	:	nicht bekannt    
*)

IMPLEMENTATION MODULE wertetabelle;

FROM SYSTEM 		IMPORT	ADR;
FROM LongRealInOut	IMPORT	WriteReal, ReadReal;
FROM InOut 		IMPORT	Write,WriteString,WriteLn,WriteCard,OpenOutput,
				CloseOutput;
FROM startupproc 	IMPORT	CLS,crlf,cursorr,m,n,fn,nullbuffer,center,intf,
				string,dateiabfrage,festgrenzestr,fragedatei,
				wptr,mstr;
FROM intervall		IMPORT	kleinintervall,fktstring;
FROM lparser 		IMPORT	lparse,MAXLONGREAL;
FROM Strings 		IMPORT	Length;
FROM menu		IMPORT	wartemenu;
FROM Intuition		IMPORT  WindowToFront;


PROCEDURE wertetabelle;

VAR
  x,dx,xmin,xmax,erg	: LONGREAL;
  bool		    	: BOOLEAN;

BEGIN
  nullbuffer[2]:= "1.0";
  kleinintervall(nullbuffer,ADR("WERTETABELLE - Intervall"));
  xmin:= lparse(nullbuffer[1],0.0);
  dx:=   lparse(nullbuffer[2],0.0);
  xmax:= lparse(nullbuffer[3],0.0);
  WindowToFront(wptr);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;
  center("TABELLIERUNG DER FUNKTION"); WriteLn; 
  center("-------------------------"); WriteLn;
  cursorr( 18+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string); crlf(2);cursorr(3);
  WriteString(
  " |      x    |       y     |       y'    |        y''  |       y'''  |");
  WriteLn; cursorr(3);
  WriteString(
  " |-----------|-------------|-------------|-------------|-------------|");
  WriteLn;
  x:= xmin;  
  REPEAT
    bool:= TRUE;
    cursorr(3);
    WriteString(" |");
    WriteReal(x,m,n); WriteString("   |  ");
    erg:= fn(x,0);
    IF ABS(erg)#MAXLONGREAL THEN
      WriteReal(erg,m,n);
    ELSE
      WriteString(mstr);
      bool:= FALSE;
    END;
    WriteString("   |  ");
    erg:= fn(x,1);
    IF (ABS(erg)#MAXLONGREAL) AND bool THEN
      WriteReal(erg,m,n);
    ELSE
      WriteString(mstr);
      bool:= FALSE;
    END;
    WriteString("   |  ");
    erg:= fn(x,2);
    IF (ABS(erg)#MAXLONGREAL) AND bool THEN
      WriteReal(erg,m,n);
    ELSE
      WriteString(mstr);
      bool:= FALSE;
    END;
    WriteString("   |  "); 
    erg:= fn(x,3);
    IF (ABS(erg)#MAXLONGREAL) AND bool THEN
      WriteReal(erg,m,n);
    ELSE
      WriteString(mstr);
    END;
    WriteString("   |  "); WriteLn;
    x:= x + dx;
  UNTIL x>xmax;
  cursorr(3);
  WriteString(
  " |-----------|-------------|-------------|-------------|-------------|");
  WriteLn;
  CloseOutput;
  crlf(2); cursorr(22);
  WriteString("Bitte 'RETURN' drcken fr MENU ");
  wartemenu;
END wertetabelle;

    
PROCEDURE wertetabelleif;

CONST
  err = 0.001;

VAR
  x,dx,xmin,xmax,festgrenze,sum,fehler	: LONGREAL;
  zuviele				: BOOLEAN;
	
BEGIN
  fktstring(festgrenzestr);
  nullbuffer[2]:= "1.0";
  kleinintervall(nullbuffer,ADR("Integralfunktion - Intervall"));
  xmin:= lparse(nullbuffer[1],0.0);
  dx:=   lparse(nullbuffer[2],0.0);
  xmax:= lparse(nullbuffer[3],0.0);
  festgrenze:= lparse(festgrenzestr,0.0);
  Write(CLS);
  IF dateiabfrage THEN
    fragedatei();
  END;
  center("TABELLIERUNG DER INTEGRALFUNKTION"); WriteLn; 
  center("---------------------------------"); WriteLn;
  cursorr( 18+(31-Length(string)) DIV 2 );
  WriteString("f(x) = ");
  WriteString(string);
  WriteLn;
  cursorr(22); WriteString("Feste untere Grenze A = ");
  WriteReal(festgrenze,m,n);
  crlf(2);cursorr(20);        
  WriteString("|       z      |     INT(a,z,f() dx)   |"); WriteLn;
  cursorr(20);
  WriteString("|--------------|-----------------------|"); WriteLn;
  x:= xmin;
  fehler:= err;
  IF festgrenze=xmin THEN
    sum:= 0.0;
  ELSE
    sum:= intf(festgrenze,xmin,fehler,zuviele);
  END;
  REPEAT
    cursorr(20);
    WriteString("|   ");
    WriteReal(x,m,n);
    WriteString("   |      ");
    WriteReal(sum,m,n);
    WriteString("         |");
    WriteLn;
    fehler:= err;
    sum:= sum + intf(x,x+dx,fehler,zuviele);
    x:= x + dx;
  UNTIL x>xmax;
  cursorr(20); 
  WriteString("|--------------|-----------------------|");
  CloseOutput;
  crlf(2); cursorr(22);
  WriteString("Bitte 'RETURN' drcken fr MENU");
  wartemenu;
END wertetabelleif;
    
  
END wertetabelle.

