(*---------------------------------------------------------------------------
    :Program.    SlideText.mod
    :Author.     Urs Pntener
    :Address.    Kilchbergstr. 139, CH-8038 Zrich
    :History.    V1.0, 10-Okt-89
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga v3.2d
    :Imports.    LoadBody.asm [fbs]
    :Imports.    IFFSupport   [fbs]
    :Imports.    AmigaTreasures [A+L]
    :Contents.   Prg. zum gleichzeitigen zeigen von Bildern und Texten.
    :Remark.     I dont like Oberon  !!!
    :Remark.       --- Warum ??? Du kennst meinen Compiler nicht! [fbs]
---------------------------------------------------------------------------*)
MODULE  SlideText;

IMPORT SYSTEM;
IMPORT FileSystem;
IMPORT Intuition;
IMPORT Strings;
IMPORT ScreenLib;
IMPORT WindowLib;
IMPORT WinIOLib;
IMPORT WinIOControl;
IMPORT WindowInOut;
IMPORT WinGraphics;
FROM   FileSystem  IMPORT Response;
FROM   IFFLoad     IMPORT ReadILBM, ReadILBMFlags, ReadILBMFlagSet,
                          IFFInfoTypePtr, IFFInfoType, IFFInfo;
FROM   Graphics    IMPORT WaitTOF, LoadRGB4, SetRGB4, ViewModes;

VAR   ScrPtr0,ScrPtr1,ScrPtr2,ScrPtr3     : Intuition.ScreenPtr;
      Win0,Win1,Win2,Win3                 : Intuition.WindowPtr;
      Extras,m,n                          : CARDINAL;
      PictureName,TextName,Picture        : ARRAY[0..99] OF CHAR;
      TextFile,PictureFile                : FileSystem.File;
      Break1,Break2,Fault                 : BOOLEAN;
      PictureIndex                        : INTEGER;
      Info0,Info3                         : IFFInfoType;

PROCEDURE DimOff(Screen: Intuition.ScreenPtr; Info: IFFInfoTypePtr);
(* by fbs *)

BEGIN
  WITH Screen^ DO
    IF NOT(ham IN viewPort.modes) THEN
      WITH Info^.CMAP DO
        FOR m:=15 TO 0 BY -1 DO
          FOR n:=0 TO colorCnt-1 DO
            SetRGB4(SYSTEM.ADR(viewPort),n,SYSTEM.SHIFT(red  [n]*m,-4),
                                    SYSTEM.SHIFT(green[n]*m,-4),
                                    SYSTEM.SHIFT(blue [n]*m,-4));
          END;
          WaitTOF;
        END;
      END;
    END;
  END;
END DimOff;

PROCEDURE DimOn(Screen: Intuition.ScreenPtr; Info: IFFInfoTypePtr);
(* by fbs *)

VAR
  front: BOOLEAN;

BEGIN
  front := FALSE;
  WITH Screen^ DO
    IF NOT(ham IN viewPort.modes) THEN
      WITH Info^.CMAP DO
        FOR m:=1 TO 16 DO
          FOR n:=0 TO colorCnt-1 DO
            SetRGB4(SYSTEM.ADR(viewPort),n,SYSTEM.SHIFT(red  [n]*m,-4),
                                    SYSTEM.SHIFT(green[n]*m,-4),
                                    SYSTEM.SHIFT(blue [n]*m,-4));
          END;
          IF NOT(front) THEN
            Intuition.ScreenToFront(Screen);
            front := TRUE;
          END;
          WaitTOF;
        END;
      END;
    ELSE
      Intuition.ScreenToFront(Screen);
    END;
  END;
END DimOn;

PROCEDURE NewPictureName;
(* den neuen Pfad und Name des nchsten bildes einlesen *)

VAR      Text                                : CHAR;
         Index,i                             : INTEGER;

BEGIN
  Index := 0;
  FOR i := 0 TO 99 DO Picture[i] := 0C END;
  LOOP
    FileSystem.SetPos(PictureFile,PictureIndex);
    FileSystem.ReadChar(PictureFile,Text);
    IF (Text = 0C) OR (Text = 12C) THEN
      IF (Text = 0C) THEN PictureIndex := 0
      ELSE INC(PictureIndex)
      END;
      Index := 0;
      IF (Picture[0] # 0C) AND (Picture[0] # 12C) THEN EXIT END
    ELSE
      Picture[Index] := Text;
      INC(Index);
      INC(PictureIndex)
    END;
  END;
END NewPictureName;

PROCEDURE Textnameeinlesen;
(* Den Pfad und Namen der Textdatei einlesen *)

VAR      Char        : CHAR;
         Index,i     : INTEGER;

BEGIN
  WinIOControl.WGotoXY(32,18);
  WinIOControl.WTextColors(1,0);
  WindowInOut.WWriteString(TextName);
  Index := Strings.Length(TextName);
  LOOP
    Char := WinIOLib.InspChar(Win2,WinIOLib.wait);
    WinIOControl.WTextColors(1,0);
    IF Char = 33C THEN
      Break1 := TRUE;
      EXIT;
    ELSIF (Char > 40C) AND (Char # 177C) THEN
      TextName[Index] := Char;
      WindowInOut.WWriteChar(Char);
      INC(Index);
    ELSIF (Char = 10C) AND (Index > 0) THEN
      TextName[Index] := 0C;
      WindowInOut.WWriteChar(" ");
      WinIOControl.WCursorLeft(2);
      DEC(Index);
    ELSIF Char = 15C THEN
      FOR i := Index+1 TO 30 DO
        TextName[i] := 0C
      END;
      FileSystem.Lookup(TextFile,TextName,1024,FALSE);
      IF (TextFile.res = notFound ) THEN
        WinIOControl.WGotoXY(41,27);
        WinIOControl.WTextColors(1,2);
        WinIOControl.WBoldText;
        WindowInOut.WWriteString("Textdatei nicht gefunden ! ");
        WindowInOut.WWriteLn;
        WinIOControl.WPlainText;
        WinIOControl.WGotoXY(32+Index,18);
        Index := Strings.Length(TextName);
      ELSE
        WinIOControl.WGotoXY(41,27);
        WinIOControl.WTextColors(1,2);
        WindowInOut.WWriteString("                           ");
        EXIT;
      END;
    END;
  END;
END Textnameeinlesen;

PROCEDURE Picturenameeinlesen;
(* Den Namen und Pfad der PictureScriptDatei einlesen *)

VAR      Char        : CHAR;
         Index,i     : INTEGER;

BEGIN
  WinIOControl.WGotoXY(32,21);
  WinIOControl.WTextColors(1,0);
  WindowInOut.WWriteString(PictureName);
  Index := Strings.Length(PictureName);
  LOOP
    Char := WinIOLib.InspChar(Win2,WinIOLib.wait);
    WinIOControl.WTextColors(1,0);
    IF Char = 33C THEN
      Break2 := TRUE;
      EXIT;
    ELSIF (Char > 40C) AND (Char # 177C) THEN
      PictureName[Index] := Char;
      WindowInOut.WWriteChar(Char);
      INC(Index);
    ELSIF (Char = 10C) AND (Index > 0) THEN
      PictureName[Index] := 0C;
      WindowInOut.WWriteChar(" ");
      WinIOControl.WCursorLeft(2);
      DEC(Index);
    ELSIF Char = 15C THEN
      FOR i := Index+1 TO 30 DO
        PictureName[i] := 0C
      END;
      FileSystem.Lookup(PictureFile,PictureName,1024,FALSE);
      IF (PictureFile.res = notFound ) THEN
        WinIOControl.WGotoXY(41,27);
        WinIOControl.WTextColors(1,2);
        WinIOControl.WBoldText;
        WindowInOut.WWriteString("Bilddatei nicht gefunden ! ");
        WindowInOut.WWriteLn;
        WinIOControl.WPlainText;
        Index := Strings.Length(PictureName);
        WinIOControl.WGotoXY(32+Index,21);
      ELSE
        WinIOControl.WGotoXY(41,27);
        WinIOControl.WTextColors(1,2);
        WindowInOut.WWriteString("                           ");
        EXIT;
      END;
    END;
  END;
END Picturenameeinlesen;

PROCEDURE PicFehler;
(* Ein PictureScriptBildName ist kein IFF-Bild *)

BEGIN
 ScrPtr2 := ScreenLib.SimpleScr("SlideText v1.0   1989 by Urs Pntener ",
                                 0,0,ScreenLib.Hi,2,FALSE,FALSE,FALSE);
 Extras  := WindowLib.noSize + WindowLib.noMove +  WindowLib.noBack +
            WindowLib.noBorder + WindowLib.noClose;
 Win2 :=WindowLib.SimpleWin(ScrPtr2,"",0,12,640,226,Extras);
 WindowInOut.InitForIO(Win2);
 WindowInOut.SetIOWin(Win2);
 WinIOLib.ReportChar(Win2,TRUE);
 WinGraphics.Rectangle(Win2,5,14,630,110,3,FALSE);
 WinIOControl.WGotoXY(3,4);
 WinIOControl.WTextColors(1,0);
 WindowInOut.WWriteString("Fehler beim Einlesen des Bildes !");
 WinIOControl.WGotoXY(3,6);
 WindowInOut.WWriteString("Der eingelesene Bildname : ");
 WinIOControl.WGotoXY(3,7);
 WindowInOut.WWriteString(Picture);
 WinIOControl.WGotoXY(3,8);
 WindowInOut.WWriteString(" ist kein IFF-Bild !");
 WinIOControl.WGotoXY(3,9);
 WindowInOut.WWriteString("Bitte Ueberprfen Sie die Bilddatei und den Pfad.");
 WinGraphics.Rectangle(Win2,5,126,630,24,3,FALSE);
 WinIOControl.WGotoXY(3,18);
 WinIOControl.WTextColors(2,4);
 WindowInOut.WWriteString("Name und Pfad der Textdatei: ");
 WinIOControl.WGotoXY(32,18);
 WinIOControl.WTextColors(1,0);
 WindowInOut.WWriteString(TextName);
 WinGraphics.Rectangle(Win2,5,152,630,22,3,FALSE);
 WinIOControl.WTextColors(2,4);
 WinIOControl.WGotoXY(3,21);
 WindowInOut.WWriteString("Name und Pfad der Bilddatei: ");
 WinGraphics.Rectangle(Win2,5,178,296,18,3,TRUE);
 WinIOControl.WGotoXY(32,21);
 WinIOControl.WTextColors(1,0);
 WindowInOut.WWriteString(PictureName);
 WinIOControl.WGotoXY(3,24);
 WinIOControl.WTextColors(2,3);
 WindowInOut.WWriteString("Esc bricht Programm ab");
 WinIOControl.WCursorInvisible;
 REPEAT
 UNTIL WinIOLib.InspChar(Win2,WinIOLib.wait) = CHR(27);
 WindowInOut.FinishIO(Win2);
 WindowLib.ClearWin(Win2);
 WindowLib.CloseWin(Win2);
 ScreenLib.ClearScr(ScrPtr2);
 ScreenLib.CloseScr(ScrPtr2);
END PicFehler;

PROCEDURE Ask;
(* Bildschirm zur Abfrage des BildDateinNamens und TextDateiNamens *)

BEGIN
 ScrPtr2 := ScreenLib.SimpleScr("SlideText v1.0   1989 by Urs Pntener ",
                                 0,0,ScreenLib.Hi,2,FALSE,FALSE,FALSE);
 Extras  := WindowLib.noSize + WindowLib.noMove +  WindowLib.noBack +
            WindowLib.noBorder + WindowLib.noClose;
 Win2 :=WindowLib.SimpleWin(ScrPtr2,"",0,12,640,226,Extras);
 WindowInOut.InitForIO(Win2);
 WindowInOut.SetIOWin(Win2);
 WinIOLib.ReportChar(Win2,TRUE);
 WinIOLib.ReportMButtons(Win2,TRUE,TRUE);
 WinGraphics.Rectangle(Win2,5,14,630,110,3,FALSE);
 WinIOControl.WGotoXY(3,4);
 WinIOControl.WTextColors(2,4);
 WindowInOut.WWriteString("SlideText V1.0 by Urs Pntener");
 WinIOControl.WGotoXY(3,6);
 WinIOControl.WTextColors(1,0);
 WindowInOut.WWriteString("Eine DiaShow, bei der gleichzeitig ein Text eingeblendet wird.");
 WinIOControl.WGotoXY(3,8);
 WindowInOut.WWriteString("Dieses Programm ist frei kopierbar, darf aber nicht fr kommerzielle");
 WinIOControl.WGotoXY(3,9);
 WindowInOut.WWriteString("Zwecke genutzt werden.");
 WinIOControl.WGotoXY(3,11);
 WindowInOut.WWriteString("Wichtig : Der Mauszeiger muss sich fr die untengenannten Befehle");
 WinIOControl.WGotoXY(3,12);
 WindowInOut.WWriteString("          whrend der DiaShow im Textbereich befinden.");
 WinGraphics.Rectangle(Win2,5,126,630,24,3,FALSE);
 WinIOControl.WGotoXY(3,18);
 WinIOControl.WTextColors(2,4);
 WindowInOut.WWriteString("Name und Pfad der Textdatei: ");
 WinGraphics.Rectangle(Win2,5,152,630,22,3,FALSE);
 WinIOControl.WGotoXY(3,21);
 WindowInOut.WWriteString("Name und Pfad der Bilddatei: ");
 WinGraphics.Rectangle(Win2,5,178,296,18,3,TRUE);
 WinIOControl.WGotoXY(3,24);
 WinIOControl.WTextColors(2,3);
 WindowInOut.WWriteString("Linke  Maustaste : nchstes Bild");
 WinGraphics.Rectangle(Win2,5,202,296,18,3,TRUE);
 WinIOControl.WGotoXY(3,27);
 WinIOControl.WTextColors(2,3);
 WindowInOut.WWriteString("Rechte Maustaste : nchster Text");
 WinGraphics.Rectangle(Win2,307,178,327,18,3,TRUE);
 WinIOControl.WGotoXY(41,24);
 WinIOControl.WTextColors(2,3);
 WindowInOut.WWriteString("Esc bricht Programm ab");
 WinGraphics.Rectangle(Win2,307,202,327,18,2,TRUE);
 PictureName := "DF0:SlideText1.0/PictureScript.txt";
 TextName    := "DF0:SlideText1.0/SlideText.dok";
 Textnameeinlesen;
 IF Break1 # TRUE THEN Picturenameeinlesen END;
 WindowInOut.FinishIO(Win2);
 WindowLib.ClearWin(Win2);
 WindowLib.CloseWin(Win2);
 ScreenLib.ClearScr(ScrPtr2);
 ScreenLib.CloseScr(ScrPtr2);
END Ask;

PROCEDURE Textausgabe;
(* Den nchtsten Textabschnitt (6 Linien) einlesen und ausgeben *)

VAR   Index1,Index2                       : INTEGER;
      Text                                : CHAR;

BEGIN
  Index1 := 0;
  Index2 := 0;
  WinIOControl.WCls;
  FileSystem.SetPos(TextFile,Index1);
  FileSystem.ReadChar(TextFile,Text);
  WHILE (NOT(TextFile.eof)) AND (Index2 # 6) DO
    IF Text = 12C THEN INC(Index2) END;
    IF Index2 # 6 THEN WindowInOut.WWriteChar(Text) END;
    INC(Index1);
    FileSystem.SetPos(TextFile,Index1);
    FileSystem.ReadChar(TextFile,Text);
  END;
  IF TextFile.eof THEN
    Index1 := 0;Index2 := 0;
    FileSystem.SetPos(TextFile,Index1);
    FileSystem.ReadChar(TextFile,Text);
  END;
  IF Index2 = 6   THEN Index2 := 0 END;
  REPEAT
    IF WinIOLib.InspMButtons(Win1,WinIOLib.wait) = 1 THEN
      NewPictureName;
      IF ReadILBM(Picture,ReadILBMFlagSet{visible},ScrPtr3,Win3) THEN
        Info3 := IFFInfo;
        DimOff(ScrPtr0,SYSTEM.ADR(Info0));
        DimOn (ScrPtr3,SYSTEM.ADR(Info3));
        ScreenLib.CloseScr(ScrPtr0);
        ScrPtr0 := ScrPtr3;
        Win0    := Win3;
        Info0   := Info3;
      ELSE
        PicFehler;
     END;
      ScreenLib.PlaceScr(ScrPtr1,0,201,TRUE);
    ELSIF WinIOLib.InspMButtons(Win1,WinIOLib.old) = 2 THEN
      WinIOControl.WCls;
      WHILE (NOT(TextFile.eof)) AND (Index2 # 6) DO
        IF Text = 12C THEN INC(Index2) END;
        IF Index2 # 6 THEN WindowInOut.WWriteChar(Text) END;
        INC(Index1);
        FileSystem.SetPos(TextFile,Index1);
        FileSystem.ReadChar(TextFile,Text);
      END;
      IF TextFile.eof THEN
        Index1 := 0; Index2 := 0;
        FileSystem.SetPos(TextFile,Index1);
        FileSystem.ReadChar(TextFile,Text);
      END;
      IF Index2 = 6   THEN Index2 := 0 END;
    END;
  UNTIL WinIOLib.InspChar(Win1,WinIOLib.old) = CHR(27);
END Textausgabe;

BEGIN
  PictureIndex := 0;
  Break1 := FALSE;
  Break2 := FALSE;
  Fault  := FALSE;
  Ask;
  IF Break1 = TRUE THEN
    FileSystem.Close(TextFile);
  ELSIF Break2 = TRUE THEN
    FileSystem.Close(TextFile);
    FileSystem.Close(PictureFile);
  ELSE
    NewPictureName;
    IF ReadILBM(Picture,ReadILBMFlagSet{visible},ScrPtr0,Win0) THEN
      Info0 := IFFInfo;
      DimOn (ScrPtr0,SYSTEM.ADR(Info0));
    ELSE
      Fault := TRUE;
      PicFehler;
      FileSystem.Close(PictureFile);
    END;
    IF Fault = FALSE THEN
      ScrPtr1 := ScreenLib.SimpleScr("",0,201,ScreenLib.Hi,2,FALSE,FALSE,FALSE);
      Extras  := WindowLib.noClose + WindowLib.noSize + WindowLib.noMove +
                 WindowLib.noBack  + WindowLib.noBorder;
      Win1 :=WindowLib.SimpleWin(ScrPtr1,"",0,0,640,55,Extras);
      WinIOLib.ReportMButtons(Win1,TRUE,TRUE);
      WinIOLib.ReportChar(Win1,TRUE);
      WindowInOut.InitForIO(Win1);
      WindowInOut.SetIOWin(Win1);
      WinIOControl.WCursorInvisible;
      Textausgabe;
      WindowInOut.FinishIO(Win1);
      WindowLib.ClearWin(Win1);
      WindowLib.CloseWin(Win1);
      ScreenLib.ClearScr(ScrPtr1);
      ScreenLib.CloseScr(ScrPtr1);
      ScreenLib.CloseScr(ScrPtr0);
      FileSystem.Close(PictureFile);
      FileSystem.Close(TextFile);
    END;
  END;
 (* Ich weiss, dass war eine sprliche Dokumentation. Aber wenn man alle
    Textoperationen weglsst bleibt nicht mehr viel PRG brig ! *)
END  SlideText.

