(* -------------------------------------------------------------------------
  :Program.       TestDisky
  :Contents.      Program to test FieRequest
  :Author.        Kai Bolay
  :Address.       Hoffmannstrae 168, 7250 Leonberg 1
  :Phone.         07152/22135
  :Copyright.     PD
  :Language.      Modula-2
  :Translator.    M2Amiga 3.2d
  :Imports.       FileRequest, IntuiStruct1.3 [bne]
  :History.       V1.0 18-May-89
------------------------------------------------------------------------- *)

MODULE TestDisky;

FROM SYSTEM      IMPORT ADR;
FROM FileRequest IMPORT DiskyInfo, DiskyFlags, DiskyFlagSet, DiskyResult,
                        Disky;
FROM Terminal    IMPORT WriteString, WriteLn;

VAR DI : DiskyInfo;

BEGIN
   WITH DI DO
      title        := ADR ("FileRequest-Demo");
      dir          := "SYS:";
      file         := "Demo-File";
      flags        := DiskyFlagSet {};
   END; (* WITH *)
   IF (Disky (DI) # DiskyOK) THEN
      WriteString ("Cancel / Error");
   ELSE
      WriteString (DI.path);
   END; (* IF *)
   WriteLn;
END TestDisky.


