(*---------------------------------------------------------------------------
    :Program.     DisObject.mod
    :Contents.	  Disassembliere ein M2Amiga Object File
    :Author.      Bernd Preusing
    :Address.	  Gerhardstr. 16  D-2200 Elmshorn
    :Phone.	  04121/22486
    :Copyright.	  Public Domain
    :Language.	  Modula-2
    :Translator.  M2Amiga V3.27d
    :Support.	  ()
    :History.	  1.1 Oktober 88
    :History.	  1.2 September 89 (mehr Speed, nun auch CASE korrekt)
    :Imports.	  DisAss, SymTabA (Bernd Preusing)
    :Remark.      Das htte ich viel frher machen sollen!!
    :Bugs.	  Die Option -m ist noch nicht korrekt brauchbar und sollte
    :Bugs.	  nicht benutzt werden!
    :Usage.	  DisObject [>textfile] objectfile [-om]
---------------------------------------------------------------------------*)
MODULE DisObject;

FROM SYSTEM	IMPORT	CAST,ADDRESS,ADR,INLINE,BITSET, LONGSET, SHIFT;

FROM Arts	IMPORT	ModType, ModuleId, ModuleInfo, ModuleInfoPtr,
			Terminate, CurrentLevel, BreakPoint;
FROM InOut	IMPORT	WriteString, WriteLn, WriteHex, Write, WriteInt,
			ReadString, ReadLongCard;
IMPORT Str;
FROM FileSystem	IMPORT	File, Response, Lookup, Close, Length, ReadBytes;
FROM Storage	IMPORT	ALLOCATE, DEALLOCATE;
FROM DisAss	IMPORT	Line, Disass;
FROM SymTabA	IMPORT	SymName, AdRec, AdRecPtr, SearchAd, InsertAd, FirstAd,
			NextAd, GenSyms;
FROM Arguments	IMPORT	NumArgs, GetArg;

TYPE
  CARDPOINTER = POINTER TO CARDINAL;
  CasePtr = POINTER TO RECORD
  			CASE :INTEGER OF
  			| 0: carr: ARRAY[-2..1000] OF CARDINAL;
  			| 1: barr: ARRAY[-2..1000] OF BITSET;
  			| 2: iarr: ARRAY[-2..1000] OF INTEGER;
  			END;
  		       END;
  LPtr = POINTER TO LONGINT;
  SymPtr = POINTER TO SymName;
  ModuleIdPtr = POINTER TO ARRAY[1..100] OF ModuleId;
  Module = RECORD
    id1: LONGINT;
    mid: ModuleId;
    codeSize,
    varSize,
    constSize,
    jumps,
    modules: LONGINT;
  END;
  (* dann consts, jumps, moduleIds, Prog *)
  (* fertig= consts, jumps, dataPtr, modulePtrs, Prog *)
  ModulePtr = POINTER TO Module;

CONST nullName='';
	TAB = 11C;

VAR
 ObjAnzeigen,M2ocCode, alert,TempAlert: BOOLEAN;
 procName: SymName;
 Buff: Line;
 FBuffPtr:ADDRESS; BuffLen:LONGINT;
 adRec, actRec: AdRecPtr;
 mp:ModulePtr;
 Adr,OldAdr,nexta: ADDRESS; lPtr:LPtr;
 i,j,Pos:CARDINAL;
 cmd,fname:ARRAY[0..63] OF CHAR;
 CaseArr: ARRAY[0..99] OF ADDRESS;

PROCEDURE WrS(s:ARRAY OF CHAR);
BEGIN
 WriteString(s); WriteLn
END WrS;

PROCEDURE WrTab(s:ARRAY OF CHAR);
BEGIN
 Write(TAB);
 WriteString(s)
END WrTab;

PROCEDURE WrTabL(s:ARRAY OF CHAR);
BEGIN
 Write(TAB);
 WriteString(s);
 WriteLn
END WrTabL;

PROCEDURE WrL(l:LONGINT);
BEGIN
 WrTab('DC.L'); Write(TAB); WriteInt(l,1); WriteLn
END WrL;

PROCEDURE WrI(l:LONGINT);
BEGIN
 WrTab('DC.W'); Write(TAB); WriteInt(l,1); WriteLn
END WrI;

PROCEDURE JName(nr:INTEGER);
BEGIN
  procName:='Proc000';
  INC(procName[6],nr MOD 10);
  INC(procName[5],(nr DIV 10) MOD 10);
  INC(procName[4],(nr DIV 100) MOD 10);
END JName;

PROCEDURE GetFile(s:ARRAY OF CHAR):BOOLEAN;
VAR f:File; actual:LONGINT;
BEGIN
 Lookup(f,s,0,FALSE);
 IF f.res#done THEN RETURN FALSE END;
 Length(f,BuffLen);
 ALLOCATE(FBuffPtr,BuffLen); (* bricht ab *)
 ReadBytes(f,FBuffPtr,BuffLen,actual);
 IF actual<BuffLen THEN Close(f); RETURN FALSE END;
 Close(f);
 RETURN TRUE
END GetFile;

PROCEDURE OpenFile();
VAR dummy, i:INTEGER; opt: ARRAY[0..10] OF CHAR;
BEGIN
 IF NumArgs()>0 THEN
   GetArg(1,fname,dummy);
   IF NOT GetFile(fname) THEN
     WriteString('Fehler: obj-File nicht zu laden.');
     WriteLn;
     Terminate(CurrentLevel())
   END;
 ELSE
   WrS('usage: DisObject [>textfile] objfile [-om]');
   Terminate(CurrentLevel());
 END;
 IF NumArgs()>1 THEN
   GetArg(2,opt,dummy);
   IF opt[0]='-' THEN
     FOR i:=1 TO dummy-1 DO
       IF CAP(opt[i])='O' THEN ObjAnzeigen:=TRUE;
       ELSIF CAP(opt[i])='M' THEN M2ocCode:=TRUE
       END;
     END;
   END;
 END;
END OpenFile;

PROCEDURE ShowObj():BOOLEAN;
 VAR a,e:ADDRESS; i,offset:LONGINT; NewName, CaseName: SymName;
     wp: CasePtr; ci, CaseBase, CaseNr, CaseMax:INTEGER; ActCase:INTEGER;
     CaseFlag: BOOLEAN; CaseRec:AdRecPtr; CaseAd:LONGINT;


 PROCEDURE Sym(ad:LONGINT);
 BEGIN
   IF SearchAd(ad)=NIL THEN
    InsertAd(nullName,ad);
   END;
 END Sym;

 PROCEDURE NamSym(s:SymName;ad:LONGINT);
 VAR a: AdRecPtr;
 BEGIN
    a:= SearchAd(ad);
    IF a=NIL THEN
      InsertAd(s,ad);
    ELSE
      a^.str:=s
    END;
 END NamSym;

 PROCEDURE ModSym(s:ARRAY OF CHAR;ad:LONGINT);
 VAR i:CARDINAL;
 BEGIN
   i:=0;
   WHILE (s[i]#0C) AND (i<5) DO
    NewName[i]:=s[i];
    IF NewName[i]='.' THEN NewName[i]:='_' END;
    INC(i)
   END;
   NewName[i]:='B'; INC(i); NewName[i]:='s'; INC(i);
   WHILE i<7 DO NewName[i]:='_'; INC(i) END; NewName[7]:=0C;
   NamSym(NewName,ad);
 END ModSym;

 PROCEDURE Mids(m:ADDRESS;cnt:INTEGER; write:BOOLEAN);
 VAR mid:ModuleIdPtr; j:INTEGER;
 BEGIN
   mid:=CAST(ModuleIdPtr,m);
   FOR j:=1 TO cnt DO
    WITH mid^[j] DO
     IF write THEN
       WrTab('DC.W '); WriteInt(type,1);
       WrTab('; ');
       CASE type OF
         0: WrS('none');    |
         1: WrS('mod');     |
         2: WrS('library'); |
         3: WrS('noImp');   |
       ELSE
         WrS(' unbekannt!!')
       END;
       IF name[0]#0C THEN
         WrTab("DC.B '"); WriteString(name); WrS("'");
       END;
       WrTab('DS.B '); WriteInt(32-Str.Length(name),1);
       WrS(',0');
       IF type=2 THEN
         WrI(keys[0]); WrL(keys[2])
       ELSE
         WrTab('DC.W $'); WriteHex(keys[0],4);
         WriteString(',$'); WriteHex(keys[1],4);
         WriteString(',$'); WriteHex(keys[2],4); WriteLn
       END;
     END; (* if write *)
     IF (cnt>1) AND (type>0) THEN
        ModSym(name,mp^.constSize+mp^.jumps*6+j*4);
	IF write OR M2ocCode THEN
	  WriteString(NewName);
	  IF M2ocCode THEN
	    WriteString('		EQU	*-');
	  ELSE
            WriteString(' EQUR Prog-');
          END;
	  WriteInt((cnt-j+1)*4,1); WriteLn;
        END;
     END;
    END;
    IF write THEN WriteLn END;
   END
 END Mids;

 PROCEDURE Replace(VAR d,s:ARRAY OF CHAR);
 VAR i,j:INTEGER;
 BEGIN
  i:=7;
  WHILE (d[i]#'L') AND (i<HIGH(d)) DO INC(i) END;
  IF d[i]='L' THEN
    FOR j:=0 TO 6 DO d[j+i]:=s[j] END;
  END;
 END Replace;

 PROCEDURE GenCase(wp:CasePtr; max,base:INTEGER);
 VAR s: SymName; val,i,j,pos:INTEGER; AdrBase:LONGINT;
 BEGIN
   AdrBase:=CAST(LONGINT,wp)+offset+4; (* wg. -2..1000 *)
   s:='CsTab00';
   s[5]:=CHAR(CaseNr/10+30H);
   s[6]:=CHAR(CaseNr REM 10+30H);
   NamSym(s,AdrBase);
   s:='Cxx1234';
   s[1]:=CHAR(CaseNr/10+30H);
   s[2]:=CHAR(CaseNr REM 10+30H);
   WITH wp^ DO
     FOR i:=0 TO max DO
       val:=base+i;
       IF val<0 THEN
         val:=-val;
         s[3]:='M';
         pos:=4;
       ELSE
         pos:=3;
       END;
       FOR j:=6 TO pos BY -1 DO
	 s[j]:=CHAR(val REM 10+30H);
	 val:=val/10
       END;
       IF val>0 THEN s[3]:='?' END;
       NamSym(s,AdrBase+iarr[i]);
     END;
     Str.CopyPos(s,'DFLT',3);
     NamSym(s,AdrBase+iarr[-1]);
   END;
   INC(CaseNr);
 END GenCase;

 PROCEDURE DumpA(VAR a:ADDRESS; b:ADDRESS);
 TYPE sPtr=POINTER TO ARRAY[0..200] OF CHAR;
 VAR s:sPtr; i:LONGINT; olda,mom:ADDRESS; tempName:SymName;
 BEGIN
 adRec:=FirstAd();
 nexta:=adRec^.ad; mom:=0;
 IF a=b THEN RETURN END;
 olda:=a;
 REPEAT
  IF mom>=nexta THEN
    IF mom=nexta THEN
       tempName:=adRec^.str;
       IF M2ocCode THEN
         (*tempName[0]:='L';*)
         WriteString(tempName); WrS(':');
       ELSE
         tempName[0]:='K';
         WriteString(tempName); WrS(':');
         WriteString(adRec^.str); WriteString('	EQUR	');
         WriteString(tempName); Write('+');
         WriteInt(mp^.modules*SIZE(ModuleId)-(mp^.modules+1)*4,1); WriteLn
       END;
    END;
    adRec:=NextAd(); nexta:=adRec^.ad;
  END;
  s:=CAST(sPtr,a);
  IF s^[0]#0C THEN
    WriteString(' DC.B "'); WriteString(s^); WriteString('",0');
    i:=Str.Length(s^)+1;
    IF ODD(i) THEN WriteString(',0'); INC(i) END;
  ELSE
    WriteString(' DC.B 0,0  ; LeerString');
    i:=2
  END;
  WriteLn;
  INC(a,i); INC(mom,i);
 UNTIL a>=b
 END DumpA;

 PROCEDURE DumpJ(VAR a:ADDRESS; b:ADDRESS);
 VAR i:LONGINT; olda,mom:ADDRESS; tempName:SymName;
 BEGIN
 nexta:=adRec^.ad; mom:=mp^.constSize; i:=1;
 IF a=b THEN RETURN END;
 olda:=a;
 REPEAT
  IF mom>=nexta THEN
    IF (mom=nexta) AND (NOT M2ocCode) THEN
       tempName:=adRec^.str;
       tempName[0]:='K';
       WriteString(tempName); WrS(':');
       WriteString(adRec^.str); WrTab('EQUR');
       WrTab(tempName); Write('+');
       WriteInt(mp^.modules*SIZE(ModuleId)-(mp^.modules+1)*4,1); WriteLn
    END;
    adRec:=NextAd(); nexta:=adRec^.ad;
  END;
  lPtr:=CAST(LPtr,a+2);
  JName(mp^.jumps-i);
  INC(i);
  a:=Disass(ADR(Buff),a,offset);
  IF ObjAnzeigen THEN
    WrS(Buff.s)
  ELSE
    IF M2ocCode THEN
      WriteString('		XDEF	'); WriteString(procName);
    ELSE
      WriteString('	DC.W	$4EF9,0,');
      WriteString(procName); Write('-');
      WriteInt(SIZE(Module)+mp^.modules*SIZE(ModuleId)-(mp^.modules+1)*4,1);
    END;
    WriteLn;
   END;
   INC(mom,6);
  UNTIL a>=b
 END DumpJ;

BEGIN (* ShowObj *)
  CaseNr:=0;
  mp:=CAST(ModulePtr,FBuffPtr);
  IF mp^.id1#1 THEN RETURN FALSE END;
  WrS('; M2Amiga Object-File Disassembler V 2.0   Bernd Preusing 1989');
  WriteString('; Disassembly of '); WrS(fname);
  WriteLn;
  IF M2ocCode AND (mp^.jumps=1) THEN
    M2ocCode:=FALSE;
    WrS('; Option -m nicht bei Hauptmodulen!');
  END;
  IF M2ocCode THEN
    M2ocCode:=FALSE;
    Mids(ADR(mp^.mid),1,FALSE);
    M2ocCode:=TRUE;
  ELSE
    WrTabL('CODE');
    WrTabL('DC.L 1  ; Kennung: .obj-File');
    Mids(ADR(mp^.mid),1,TRUE);
  END;
  a:=FBuffPtr+SIZE(Module)+mp^.constSize;
  FOR i:=1 TO mp^.jumps DO
    lPtr:=CAST(LPtr,a+2);
    JName(mp^.jumps-i);
    NamSym(procName,lPtr^);
    INC(a,6);
  END;
  IF NOT M2ocCode THEN
    WrS('; CodeSize');
    WrTab('DC.L'); WrTabL('ENDE-Prog');
    WrS('; VarSize');
    WrL(mp^.varSize);
    WrS('; ConstSize');
    WrTab('DC.L'); WrTabL('Jumps-Consts');
    WrS('; Jumps');
    WrL(mp^.jumps);
    WrS('; Modules');
    WrL(mp^.modules);
    WriteLn;
  END;
  NamSym('dataPtr',mp^.constSize+mp^.jumps*6);
  a:=FBuffPtr+SIZE(Module)+mp^.constSize+mp^.jumps*6;
  IF M2ocCode THEN
    M2ocCode:=FALSE;
    Mids(a,mp^.modules,FALSE); (* nur symbole generieren *)
    M2ocCode:=TRUE;
  ELSE
    Mids(a,mp^.modules,FALSE); (* nur symbole generieren *)
  END;
  alert:=FALSE;
(* Pass 1 == *)
  a:=FBuffPtr+SIZE(Module)+mp^.modules*SIZE(ModuleId)+mp^.constSize+
     mp^.jumps*6;
  e:=FBuffPtr+BuffLen;
  offset:=mp^.constSize+mp^.jumps*6+(mp^.modules+1)*4-a;
  WHILE a<e DO
    a:=Disass(ADR(Buff),a,offset);
    IF (0 IN Buff.flags) OR (1 IN Buff.flags) THEN
       Sym(Buff.adr+offset)
    END;
    IF 2 IN Buff.flags THEN
      TempAlert:=TRUE;
      wp:=CAST(CasePtr,LONGINT(a)-4);
      WITH wp^ DO
        IF ((carr[-2]=4E75H) OR (iarr[-2]=-24)) AND (carr[-1]>=0F000H) THEN (* kann case sein *)
	  ci:=0;
	  WHILE carr[ci]>=0F000H DO INC(ci) END;
	  CaseMax:=ci-1;
	  IF barr[ci]-BITSET{0..5,9..11}=CAST(BITSET,41C0H) THEN (* lea *)
	    (* a ist auf jumplabel nach 1. dc.w *)
	    (* danach subq ode subi.w oder nichts,
	       danach cmpi.w
	    *)
	    INC(ci,2);
	    IF barr[ci]-BITSET{0..7,9..11}=CAST(BITSET,5100H) THEN (* subq*)
	      CaseBase:=carr[ci]/512 REM 8;
	      IF CaseBase=0 THEN CaseBase:=8 END;
	      INC(ci);
	    ELSIF barr[ci]-BITSET{0..5}=CAST(BITSET,0440H) THEN (* subi.w *)
	      CaseBase:=iarr[ci+1];
	      INC(ci,2);
	    ELSE
	      CaseBase:=0;
	    END;
	    IF (barr[ci]-BITSET{0..5}=CAST(BITSET,0C40H)) (* cmpi.w *)
	    	AND (carr[ci+2]=6302H) (* bls.s *+2 *)
	    	AND (iarr[ci+1]=CaseMax) THEN (* absolutely a CASE *)
	      CaseArr[CaseNr]:=a;
	      GenCase(wp,CaseMax,CaseBase);
	      INC(a,CaseMax*2+2);
	      TempAlert:=FALSE;
	    END;
	  END; (* if lea *)
	END; (* if rts *)
      END; (* with *)
      alert:=alert OR TempAlert;
    END; (* dc.w *)
  END; (* while *)
(* == *)
IF alert THEN
  WriteLn;
  WrS('!!!!! Achtung: DC.W im Code, vermutlich INLINE o.. !!!!');
  WriteLn;
END;
(* Pass 2 == *)
  GenSyms();
  IF M2ocCode AND (mp^.jumps>1) THEN
    WrS('; Module:');
    Mids(FBuffPtr+SIZE(Module)+mp^.constSize+mp^.jumps*6,mp^.modules,FALSE);
    WriteLn;
    WrS('; Variablen:');
    WriteString('dataPtr		EQU	*-'); WriteInt((mp^.modules+1)*4,1);
    WriteLn; WriteLn;
    WrS('; Prozeduren:');
    a:=FBuffPtr+SIZE(Module)+mp^.constSize;
    offset:=mp^.constSize-a;
    DumpJ(a,a+mp^.jumps*6);
    WriteLn;

    WrS('Consts:');
    a:=FBuffPtr+SIZE(Module);
    DumpA(a,a+mp^.constSize);
    WriteLn;

  ELSE
    WrS('Consts:');
    a:=FBuffPtr+SIZE(Module);
    DumpA(a,a+mp^.constSize);
    WriteLn;

    WrS('Jumps:');
    offset:=mp^.constSize-a;
    DumpJ(a,a+mp^.jumps*6);
    WriteLn;

    WrS('ModuleIds:');
    Mids(a,mp^.modules,TRUE);
    WriteLn;

    WriteString('dataPtr EQUR Prog-'); WriteInt((mp^.modules+1)*4,1);
    WriteLn; WriteLn;
    WrS('Prog:');
  END;
  a:=FBuffPtr+SIZE(Module)+mp^.modules*SIZE(ModuleId)+mp^.constSize+
     mp^.jumps*6;
  e:=FBuffPtr+BuffLen;
  offset:=mp^.constSize+mp^.jumps*6+(mp^.modules+1)*4-a;
  WHILE nexta<a DO adRec:=NextAd();
    IF adRec#NIL THEN nexta:=adRec^.ad-offset ELSE nexta:=7FFFFFFFH END;
  END;

  ActCase:=0;
  CaseFlag:=FALSE;
  WHILE a<e DO
    IF a>=nexta THEN
       IF a=nexta THEN WriteString(adRec^.str); WrS(':'); END;
       adRec:=NextAd();
       IF adRec#NIL THEN nexta:=adRec^.ad-offset ELSE nexta:=7FFFFFFFH END;
    END;
    a:=Disass(ADR(Buff),a,offset);
    IF 2 IN Buff.flags THEN
      IF (CaseArr[ActCase]=a) THEN
        CaseFlag:=TRUE;
        Str.Copy(CaseName,adRec^.str);
        CaseAd:=a+offset;
        INC(ActCase);
      END;
      IF CaseFlag THEN
        wp:=CAST(CasePtr,CAST(LONGINT,a)-4);
        CaseRec:=SearchAd(CaseAd+wp^.iarr[-1]);
        IF CaseRec#NIL THEN
          Buff.s2:='DC.W	';
          Str.Concat(Buff.s2,CaseRec^.str);
          Str.Concat(Buff.s2,'-');
          Str.Concat(Buff.s2,CaseName);
        END;
      END;
    ELSE
      CaseFlag:=FALSE;
    END;
    IF (0 IN Buff.flags) OR (1 IN Buff.flags) THEN
       actRec:=SearchAd(Buff.adr+offset);
       IF actRec#NIL THEN
         Replace(Buff.s2,actRec^.str)
       END;
    END;
    IF ObjAnzeigen THEN
      WrS(Buff.s)
    ELSE
      WrTabL(Buff.s2);
    END;
  END;
(* == *)
  IF NOT M2ocCode THEN
    WrS('ENDE:');
  END;
  WrTabL('END');
  RETURN TRUE
END ShowObj;


BEGIN
 ObjAnzeigen:=FALSE; M2ocCode:=FALSE; alert:=FALSE;
 REPEAT
  OpenFile();
 UNTIL ShowObj()=TRUE;
END DisObject.mod
