(******************************************************************************
*                                                                             *
*    Programmname:  TimerSupport                                              *
*                                                                             *
*    Stand:         21.11.89                            Uhrzeit:  21:01:18    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.1         () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE TimerSupport;

FROM SYSTEM        IMPORT ADR;
FROM Dos           IMPORT Date,DateStamp;
FROM Str           IMPORT Concat,Copy;
FROM StringSupport IMPORT StringStr;

PROCEDURE GetDate(VAR day,month,year : LONGINT);
VAR SysTime     : Date;
    n,alldays   : LONGINT;
BEGIN
  (* Datum wird nach dem Algorithmus des Juljanischen Kalenders bestimmt! *)
  
  DateStamp(ADR(SysTime));
  alldays:= SysTime.days;
       n := alldays+28431;
    year := (4 * n-1) DIV 1461;
     day := (4 * n + 3 - 1461 * year) DIV 4;
    month:= (5 * day - 3) DIV 153;
      day:= (5 * day + 2 - 153 * month) DIV 5;
    IF (month >= 10) THEN
       month := month - 9;
        year := year + 1;
    ELSE
       month := month + 3;
    END;
END GetDate;

PROCEDURE GetTime(VAR hour,min,sec,hsec : LONGINT);
VAR SysTime : Date;
BEGIN
  DateStamp(ADR(SysTime));
  
  hour := SysTime.minute DIV 60;
  min  := SysTime.minute - (hour * 60);
  sec  := SysTime.tick DIV 50;
  hsec := SysTime.tick - (sec * 50);
END GetTime;

PROCEDURE MakeString(VAR string : ARRAY OF CHAR; trennChar : CHAR;
                                          num1,num2,num3 : LONGINT);
VAR zahl : ARRAY [0..2] OF CHAR;
    trenn: ARRAY [0..1] OF CHAR;
  PROCEDURE ZeroStringStr(num : LONGINT);
  BEGIN
    IF (num < 10) THEN
        zahl[0]:=CHR(48); zahl[1]:=CHR(48+num); zahl[2]:=00C;
    ELSE
       StringStr(zahl,num,2);
    END;        
  END ZeroStringStr;
BEGIN
  trenn[0]:=trennChar; trenn[1]:=00C;
  ZeroStringStr(num1); Copy(string,zahl);   Concat(string,trenn);
  ZeroStringStr(num2); Concat(string,zahl); Concat(string,trenn);
  ZeroStringStr(num3); Concat(string,zahl);
END MakeString;                     

PROCEDURE MakeDateString(VAR dateString : ARRAY OF CHAR);
VAR day,month,year : LONGINT;
BEGIN
  GetDate(day,month,year);
  MakeString(dateString,".",day,month,year);
END MakeDateString;

PROCEDURE MakeTimeString(VAR timeString : ARRAY OF CHAR);
VAR hour,min,sec,hsec : LONGINT;
BEGIN
  GetTime(hour,min,sec,hsec);
  MakeString(timeString,":",hour,min,sec);
END MakeTimeString;

BEGIN
END TimerSupport.

