(* $R- $V- $S- $N- SF- *)
IMPLEMENTATION MODULE DirSorter;

FROM SYSTEM        IMPORT ADR,ADDRESS;
FROM Dos           IMPORT accessRead,Examine,ExNext,FileInfoBlock,
                          FileInfoBlockPtr,FileLockPtr,Lock,UnLock;
FROM Str           IMPORT CapString,Copy,Length;
FROM Storage       IMPORT ALLOCATE,Available,DEALLOCATE;
FROM StringSupport IMPORT ChangeStr,LLT,Occurs;

VAR  Verzeichnis   : FileLockPtr;
     
PROCEDURE AllocEintrag(VAR eintragPtr: DirPtr): BOOLEAN;
BEGIN
  IF Available(SIZE(DirName)) THEN
     ALLOCATE(eintragPtr,SIZE(DirName));
     WITH eintragPtr^ DO
       fileName := ("");
       typ  := undefiniert;
     END;
     RETURN TRUE;
  END;     
  RETURN FALSE;
END AllocEintrag;

PROCEDURE DeallocEintrag(VAR eintragPtr : DirPtr);
BEGIN
  DEALLOCATE(eintragPtr,SIZE(DirName)); eintragPtr:=NIL;
END DeallocEintrag;
  
PROCEDURE DeallocEintragList;
VAR i : CARDINAL;
BEGIN
  i:=0;
  WHILE (DirFeld[i] # NIL) DO
    DeallocEintrag(DirFeld[i]); INC(i);
  END;
END DeallocEintragList;                                           

PROCEDURE ReadDirectory(lock : FileLockPtr; infos : BOOLEAN): BOOLEAN;
VAR good,alloc  : BOOLEAN;
    fileInfoPtr : FileInfoBlockPtr;
  PROCEDURE CheckforInfo(ptr : FileInfoBlockPtr): BOOLEAN;
  VAR from : INTEGER;
  BEGIN
    from:=Length(ptr^.fileName); from:=from-5;  IF from < 0 THEN from:=0 END;
    IF (Occurs(ptr^.fileName,from,".info",FALSE) = -1) THEN
       RETURN TRUE;
    END;
    RETURN FALSE;
  END CheckforInfo;  
BEGIN
  DirEntries:=0;
  IF Available(SIZE(FileInfoBlock)) THEN
     ALLOCATE(fileInfoPtr,SIZE(FileInfoBlock));
     IF Examine(lock,fileInfoPtr) THEN
        REPEAT
          IF infos THEN alloc:=TRUE ELSE
             alloc:=CheckforInfo(fileInfoPtr);
          END;   
          IF alloc THEN    
             IF AllocEintrag(DirFeld[DirEntries]) THEN
                WITH fileInfoPtr^ DO
                  IF (fileInfoPtr^.dirEntryType < 0) THEN
                     DirFeld[DirEntries]^.typ := datei;
                  ELSIF (fileInfoPtr^.dirEntryType > 0) THEN
                     DirFeld[DirEntries]^.typ := verzeichnis;
                  END;
                  Copy(DirFeld[DirEntries]^.fileName,fileName);
                END;
             END;    
             INC(DirEntries);
          END;  
        UNTIL (ExNext(lock,fileInfoPtr) = FALSE) OR (DirEntries > maxMax);
        good := TRUE;
        DEC(DirEntries);
     ELSE
       good := FALSE;
     END;
     DEALLOCATE(fileInfoPtr,SIZE(FileInfoBlock));
     RETURN good;
  END;  
  RETURN FALSE;
END ReadDirectory;

PROCEDURE QSort(beginning : CARDINAL);
VAR i,j  : CARDINAL;
  PROCEDURE FirstHigher(unten,oben : ARRAY OF CHAR): BOOLEAN;
  VAR i : CARDINAL;
  BEGIN
    CapString(unten); CapString(oben);
    IF LLT(unten,oben) THEN
       RETURN TRUE;
    END;  
    RETURN FALSE;
  END FirstHigher;
  PROCEDURE Sort(unten,oben : CARDINAL);
  VAR i,j : CARDINAL;
      x,w : DirPtr;
  BEGIN
    i := unten; j := oben;
    x := DirFeld[(unten + oben) DIV 2];
    REPEAT
      WHILE FirstHigher(x^.fileName,DirFeld[i]^.fileName) DO INC(i) END;
      WHILE FirstHigher(DirFeld[j]^.fileName,x^.fileName) DO DEC(j) END;
      IF (i <= j) THEN
        w := DirFeld[i];
        DirFeld[i] := DirFeld[j];
        DirFeld[j] := w;
        INC(i);
        DEC(j);
      END;
    UNTIL (i > j);
    IF (unten < j) THEN Sort(unten,j) END;
    IF (i < oben)  THEN Sort(i,oben) END;
  END Sort;
BEGIN
  Sort(beginning,DirEntries);
END QSort;

PROCEDURE StoreVerzeichnis(fileName : ADDRESS);
BEGIN
  Verzeichnis:=Lock(fileName,accessRead);
  IF (Verzeichnis # NIL) THEN
    IF ReadDirectory(Verzeichnis,FALSE) THEN
       QSort(1);
    END;
  END;
  UnLock(Verzeichnis); Verzeichnis:=NIL;
END StoreVerzeichnis;

PROCEDURE CleanDir;
BEGIN
  IF (Verzeichnis # NIL) THEN
     UnLock(Verzeichnis);
  END;
  DeallocEintragList;
END CleanDir;

BEGIN
END DirSorter.

