(******************************************************************************
*                                                                             *
*    Programmname:  DirectorySupport                                          *
*                                                                             *
*    Stand:         05.11.89                            Uhrzeit:  20:17:08    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.1         () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE DirectorySupport;

FROM Arts             IMPORT Assert;
FROM SYSTEM           IMPORT ADDRESS,ADR,CAST,INLINE;
FROM Dos              IMPORT accessRead,Examine,ExNext,FileInfoBlock,
                             FileInfoBlockPtr,FileLockPtr,IoErr,Lock,UnLock;
FROM Intuition        IMPORT ActivateGadget,ActivationFlags,ActivationFlagSet,
                             AddGadget,boolGadget,Border,BorderPtr,DisplayBeep,
                             Gadget,GadgetFlags,GadgetFlagSet,GadgetPtr,
                             IDCMPFlags,IDCMPFlagSet,Image,IntuiMessagePtr,
                             propGadget,PropInfo,PropInfoFlags,PropInfoFlagSet,
                             RefreshGList,ReportMouse,selectUp,strGadget,
                             StringInfo,WindowPtr;
FROM Exec             IMPORT AllocMem,CopyMemQuick,FreeMem,MemReqs,MemReqSet;
FROM Graphics         IMPORT Draw,DrawModes,DrawModeSet,jam1,jam2,Move,
                             RastPortPtr,RectFill,SetAPen,SetBPen,SetDrMd,Text;
FROM Str              IMPORT CapString,Concat,Copy,FirstPos,LastPos,Length;
FROM Storage          IMPORT ALLOCATE,Available,DEALLOCATE;
FROM StringSupport    IMPORT ChangeStr,LeftStr,LLT,Occurs,ProduceStr;
FROM IntuitionSupport IMPORT SetBorder,SetBorderKoord,SetGadget,SetImage,
                             SetInfo,SetPropInfo;

CONST maxMax      = 250;
      displayRows = 11;
      cursorLeft  = 4FH;
      cursorRight = 4EH;
      
TYPE  FileTypen = (undefiniert,verzeichnis,datei,parent);
      DirPtr    = POINTER TO DirName; 
      DirName   = RECORD
                    fileName : ARRAY [0..30] OF CHAR;
                    typ      : FileTypen;
                  END;
      
      DisplayControl = RECORD
                         newPage,
                         selected : BOOLEAN;
                         number,
                         line     : CARDINAL;
                        END;     
      
VAR  DirFeld       : ARRAY [0..maxMax] OF DirPtr;
     buffer        : ARRAY [0..80] OF CHAR;
     xykoord       : ARRAY [0..1],[0..9] OF INTEGER;
     gadget        : ARRAY [0..3] OF Gadget;
     image         : ARRAY [0..2] OF Image;
     DirEntries,
     maxFiles,i,
     dirBlockx1,
     dirBlockx2,
     dirBlocky1,
     dirBlocky2,
     element       : CARDINAL;
     imageMemPtr   : ARRAY [0..1] OF ADDRESS;
     windowptr     : WindowPtr;
     gadgetptr     : GadgetPtr;
     class         : IDCMPFlagSet;
     IntuiMsg      : IntuiMessagePtr;
     strInfo       : StringInfo;
     border        : ARRAY [0..1] OF Border;
     Invers        : DisplayControl;
     extension     : BOOLEAN;
     DOSDosPtr     : DirectoryPtr;
     PathStruct    : PathStructure;
     
PROCEDURE AllocEintrag(VAR eintragPtr: DirPtr): BOOLEAN;
BEGIN
  IF Available(SIZE(DirName)) THEN
     ALLOCATE(eintragPtr,SIZE(DirName));
     WITH eintragPtr^ DO
       fileName := ("");
       typ  := undefiniert;
     END;
     RETURN TRUE;
  END;     
  RETURN FALSE;
END AllocEintrag;

PROCEDURE DeallocEintrag(VAR eintragPtr : DirPtr);
BEGIN
  DEALLOCATE(eintragPtr,SIZE(DirName)); eintragPtr:=NIL;
END DeallocEintrag;
  
PROCEDURE DeallocEintragList;
VAR i : CARDINAL;
BEGIN
  FOR i:=DirEntries TO 0 BY -1 DO
    DeallocEintrag(DirFeld[i]);
  END;
END DeallocEintragList;                                           

PROCEDURE ReadDirectory(lock : FileLockPtr; infos : BOOLEAN): BOOLEAN;
VAR good,alloc  : BOOLEAN;
    fileInfoPtr : FileInfoBlockPtr;
    
  PROCEDURE CheckforInfo(ptr : FileInfoBlockPtr): BOOLEAN;
  VAR len : INTEGER;
  BEGIN
    len:=Length(ptr^.fileName)-5; IF (len < 0) THEN len:= 0 END;
    IF (Occurs(ptr^.fileName,len,".info",FALSE) = -1) THEN
       RETURN TRUE;
    END;
    RETURN FALSE;
  END CheckforInfo;  
BEGIN
  DirEntries:=0;
  IF Available(SIZE(FileInfoBlock)) THEN
     ALLOCATE(fileInfoPtr,SIZE(FileInfoBlock));
     IF Examine(lock,fileInfoPtr) THEN
        REPEAT
          alloc:=CheckforInfo(fileInfoPtr);
          IF alloc THEN    
             IF AllocEintrag(DirFeld[DirEntries]) THEN
                WITH fileInfoPtr^ DO
                  IF (fileInfoPtr^.dirEntryType < 0) THEN
                     DirFeld[DirEntries]^.typ := datei;
                  ELSIF (fileInfoPtr^.dirEntryType > 0) THEN
                     DirFeld[DirEntries]^.typ := verzeichnis;
                  END;
                  Copy(DirFeld[DirEntries]^.fileName,fileName);
                END;
             END;    
             INC(DirEntries);
          END;  
        UNTIL (ExNext(lock,fileInfoPtr) = FALSE) OR (DirEntries > maxMax);
        good := TRUE;
        DEC(DirEntries);
     ELSE
       good := FALSE;
     END;
     DEALLOCATE(fileInfoPtr,SIZE(FileInfoBlock));
     RETURN good;
  END;  
  RETURN FALSE;
END ReadDirectory;

PROCEDURE QSort(beginning : CARDINAL);
VAR i,j,count : CARDINAL;
    merk      : FileTypen;
  PROCEDURE FirstHigher(unten,oben : ARRAY OF CHAR): BOOLEAN;
  VAR i : CARDINAL;
  BEGIN
    CapString(unten); CapString(oben);
    IF LLT(unten,oben) THEN
       RETURN TRUE;
    END;  
    RETURN FALSE;
  END FirstHigher;
  PROCEDURE Sort(unten,oben : CARDINAL);
  VAR i,j : CARDINAL;
      x,w : DirPtr;
  BEGIN
    i := unten; j := oben;
    x := DirFeld[(unten + oben) DIV 2];
    REPEAT
      WHILE FirstHigher(x^.fileName,DirFeld[i]^.fileName) DO INC(i) END;
      WHILE FirstHigher(DirFeld[j]^.fileName,x^.fileName) DO DEC(j) END;
      IF (i <= j) THEN
        w := DirFeld[i];
        DirFeld[i] := DirFeld[j];
        DirFeld[j] := w;
        INC(i);
        DEC(j);
      END;
    UNTIL (i > j);
    IF (unten < j) THEN Sort(unten,j) END;
    IF (i < oben)  THEN Sort(i,oben) END;
  END Sort;
BEGIN
  count:=beginning;
  FOR i:=beginning TO DirEntries DO
    WITH DirFeld[i]^ DO
      IF (typ = verzeichnis) THEN
         ChangeStr(DirFeld[count]^.fileName,fileName);
         merk:=DirFeld[count]^.typ; DirFeld[count]^.typ:=typ; typ:=merk;
         INC(count);
      END;   
    END;
  END;
  IF (count > beginning) THEN
     Sort(beginning,count-1);
  END;   
  IF (DirEntries-count > 1) THEN     
     Sort(count,DirEntries);
  END;
END QSort;

PROCEDURE Block(rport : RastPortPtr; col,x1,y1,x2,y2 : INTEGER);
BEGIN
  SetAPen(rport,col); SetDrMd(rport,jam2);
  RectFill(rport,x1,y1,x2,y2);
END Block;

PROCEDURE Frame(rport : RastPortPtr; col,x1,y1,x2,y2,width : INTEGER);
VAR i,j : INTEGER;
BEGIN
  SetAPen(rport,col); SetDrMd(rport,jam2);
  FOR i:=0 TO width-1 DO
    j:=i*2;
    Move(rport,x1+j,y1+i);     Draw(rport,x1+j,y2-i);
    Move(rport,x1+1+j,y1+i);   Draw(rport,x1+1+j,y2-i);
    Draw(rport,x2-j,y2-i);     Draw(rport,x2-j,y1+i);
    Move(rport,x2-1-j,y2-1-i); Draw(rport,x2-1-j,y1+i);
    Draw(rport,x1+j,y1+i);
  END;   
END Frame;

PROCEDURE Print(text : ARRAY OF CHAR; rport : RastPortPtr;
                                  fPen,bPen : INTEGER;
                                  drawM     : DrawModeSet;
                                  xpos,ypos : INTEGER);
VAR space : ARRAY [0..24] OF CHAR;
    i     : INTEGER;
BEGIN
  SetAPen(rport,fPen); SetBPen(rport,bPen); SetDrMd(rport,drawM);
  Move(rport,xpos,ypos); i:=Length(text);
  IF (i > 24) THEN LeftStr(text,text,24) END;
  Text(rport,ADR(text),Length(text));
    Move(rport,xpos+(i * 8),ypos);
    ProduceStr(space," ",24 - i); 
  Text(rport,ADR(space),Length(space));
END Print;

PROCEDURE ListDir(first : CARDINAL);
VAR  i : CARDINAL;
BEGIN
  IF (first > DirEntries-displayRows) THEN
     first:=first-displayRows+(DirEntries-first);
  END;
    
    element:=first; Invers.newPage:=TRUE;
    IF (element = 0) THEN INC(element) END;
    
  FOR i:=1 TO displayRows DO
    IF (DirFeld[first+i] # NIL) THEN        
       IF (DirFeld[first+i]^.typ = verzeichnis) THEN
          Print(DirFeld[first+i]^.fileName,windowptr^.rPort,3,0,jam2,
             dirBlockx1+7,dirBlocky1 + (i * 8)+1); 
       ELSE
          Print(DirFeld[first+i]^.fileName,windowptr^.rPort,1,0,jam2,
             dirBlockx1+7,dirBlocky1 + (i * 8)+1);
       END;
    ELSE
      Print("",windowptr^.rPort,1,0,jam2,dirBlockx1+7,dirBlocky1 + (i * 8)+1);
    END;         
  END;
END ListDir;

PROCEDURE ModifyListDir;
BEGIN
  IF (DOSDosPtr^.info.vertPot = 0) THEN
     DOSDosPtr^.listFile:=0;
  ELSE   
    DOSDosPtr^.listFile:= DOSDosPtr^.info.vertPot DIV (0FFFFH DIV DirEntries);
    IF (DOSDosPtr^.listFile > DirEntries-displayRows) THEN
       DOSDosPtr^.listFile:=DirEntries-displayRows;
    END;
  END;
  ListDir(DOSDosPtr^.listFile);
END ModifyListDir;

PROCEDURE Up;
VAR list : INTEGER;
BEGIN
  list:=DOSDosPtr^.listFile-displayRows+1;
  IF (list < 0) THEN 
     list:=0; DOSDosPtr^.info.vertPot:=0; 
  ELSE
     DOSDosPtr^.info.vertPot:= (0FFFFH DIV DirEntries) * (CAST(CARDINAL,list));
     Invers.line:=displayRows; Invers.number:=list+displayRows-1;
  END;
    RefreshGList(ADR(gadget[0]),windowptr,NIL,1);
    DOSDosPtr^.listFile:=list;
  ListDir(DOSDosPtr^.listFile);
END Up;

PROCEDURE Down;
BEGIN
  DOSDosPtr^.listFile:=DOSDosPtr^.listFile+displayRows-1;
  IF (DOSDosPtr^.listFile > DirEntries-displayRows) THEN 
     DOSDosPtr^.listFile:=DirEntries-displayRows;
     DOSDosPtr^.info.vertPot:=0FFFFH;
  ELSE
     DOSDosPtr^.info.vertPot:= (0FFFFH DIV DirEntries) * 
                                       (DOSDosPtr^.listFile+displayRows);
  END;   
  RefreshGList(ADR(gadget[0]),windowptr,NIL,1);
  ListDir(DOSDosPtr^.listFile);
END Down;

PROCEDURE NewDir(startzero : BOOLEAN);
VAR fileLock  : FileLockPtr;
    len       : LONGINT;
    bool      : BOOLEAN;
BEGIN
 len:=Length(DOSDosPtr^.Pfad);
 IF ((DOSDosPtr^.Pfad[len-1] # CHR(47)) AND
                               (DOSDosPtr^.Pfad[len-1] # CHR(58))) THEN
    DOSDosPtr^.Pfad[len]:=CHR(47); DOSDosPtr^.Pfad[len+1]:=00C;
    RefreshGList(ADR(gadget[1]),windowptr,NIL,1);
 END;   
 DeallocEintragList;
 fileLock:=Lock(ADR(DOSDosPtr^.Pfad),accessRead);
 IF (fileLock # NIL) THEN
  IF ReadDirectory(fileLock,extension) THEN
     len:=Length(DOSDosPtr^.Pfad);
     IF (len > FirstPos(DOSDosPtr^.Pfad,0,":")+1) THEN
        IF Available(SIZE(DirName)) THEN
           INC(DirEntries);
           ALLOCATE(DirFeld[DirEntries],SIZE(DirName));
           WITH DirFeld[DirEntries]^ DO
             ChangeStr(fileName,DirFeld[1]^.fileName); typ:=DirFeld[1]^.typ;
             DirFeld[1]^.fileName:=("PARENT\"); DirFeld[1]^.typ:=parent;
           END;
           QSort(2);
        END;
     ELSE      
       QSort(1);
     END;  
     DOSDosPtr^.info.vertBody := 0FFFFH;
     IF (DirEntries > displayRows) THEN
         DOSDosPtr^.info.vertBody:= (0FFFFH DIV DirEntries) * displayRows;
     END;
        
     RefreshGList(ADR(gadget[0]),windowptr,NIL,2);
     
     Copy(DOSDosPtr^.Device,DirFeld[0]^.fileName);
     DOSDosPtr^.Auswahl:=("");
     
     IF startzero THEN
        DOSDosPtr^.info.vertPot:=0;
        DOSDosPtr^.listFile:=0;
     ELSE
        IF (DOSDosPtr^.info.vertPot = 0) THEN
            DOSDosPtr^.listFile:=0;
        ELSE   
           DOSDosPtr^.listFile:= DOSDosPtr^.info.vertPot DIV 
                                                 (0FFFFH DIV DirEntries);
           IF (DOSDosPtr^.listFile > DirEntries-displayRows) THEN
               DOSDosPtr^.listFile:=DirEntries-displayRows;
           END;
          IF (DOSDosPtr^.listFile > DirEntries) THEN DOSDosPtr^.listFile:=0 END;
     END;
   
     END;
     ListDir(DOSDosPtr^.listFile);
     
  END;
 ELSE
   DisplayBeep(NIL);
   DOSDosPtr^.IOErr:=IoErr();
   Block(windowptr^.rPort,0,dirBlockx1+5,dirBlocky1+3,
         dirBlockx2-5,dirBlocky2-3);
   bool:=ActivateGadget(ADR(gadget[1]),windowptr,NIL);
 END;      
 UnLock(fileLock);
END NewDir;

PROCEDURE InitDiskDir(propId,strId,downId,upId,xPos,yPos : INTEGER;
                                      Infos  : BOOLEAN;
                                      window : WindowPtr): DirectoryPtr;
                                      
VAR gadgpos,i : INTEGER;
     bptr     : BorderPtr;
     (* $E- *)
     PROCEDURE BildUp;
     BEGIN
       INLINE(0FFFFH,0C003H,0C183H,0C243H,0C423H,
              0C243H,0C243H,0C243H,0C003H,0FFFFH);
     END BildUp;
     (* $E- *)
     PROCEDURE BildDown;
     BEGIN
       INLINE(0FFFFH,0C003H,0C243H,0C243H,0C243H,
              0C423H,0C243H,0C183H,0C003H,0FFFFH);
     END BildDown;
     
     PROCEDURE AllocImageChip(imageadr : ADDRESS; size : LONGINT): ADDRESS;
     VAR adr : ADDRESS;
     BEGIN
       adr:=AllocMem(size,MemReqSet{chip});
       Assert(adr # NIL,ADR("Out of Chipram"));
         CopyMemQuick(imageadr,adr,size);
       RETURN adr;  
     END AllocImageChip;
BEGIN
  DOSDosPtr:=ADR(PathStruct);
  dirBlockx1:= xPos;     dirBlocky1:= yPos;
  dirBlockx2:= xPos+204; dirBlocky2:= yPos+(displayRows * 8)+5;
  windowptr:=window;
  Frame(windowptr^.rPort,3,dirBlockx1,dirBlocky1,dirBlockx2,dirBlocky2,2);
  
  DOSDosPtr^.Pfad:=(":");
  imageMemPtr[0]:=AllocImageChip(ADR(BildUp),20);
  imageMemPtr[1]:=AllocImageChip(ADR(BildDown),20);
  SetPropInfo(DOSDosPtr^.info,PropInfoFlagSet{autoKnob,freeVert,knobHit},
              0,0,0,0);
  SetInfo(strInfo,ADR(DOSDosPtr^.Pfad),ADR(buffer),0,80,0);
  SetGadget(gadget[0],dirBlockx2+6,dirBlocky1+11,16,72,GadgetFlagSet{},
            ActivationFlagSet{gadgImmediate,relVerify},propGadget,ADR(image[0]),
            NIL,ADR(DOSDosPtr^.info),propId);
  SetGadget(gadget[1],dirBlockx1+1,dirBlocky2+5,dirBlockx2-dirBlockx1+20,8,
           GadgetFlagSet{},ActivationFlagSet{gadgImmediate,relVerify,
           toggleSelect},strGadget,ADR(border[0]),NIL,ADR(strInfo),strId);
  SetGadget(gadget[2],dirBlockx2+8,dirBlocky1+1,12,8,GadgetFlagSet{gadgImage},
            ActivationFlagSet{gadgImmediate,relVerify},boolGadget,
            ADR(image[1]),NIL,NIL,upId);
  SetGadget(gadget[3],dirBlockx2+8,dirBlocky1+85,12,8,GadgetFlagSet{gadgImage},
            ActivationFlagSet{gadgImmediate,relVerify},boolGadget,
            ADR(image[2]),NIL,NIL,downId);
  
  DOSDosPtr^.info.vertPot:=0FFFFH; DOSDosPtr^.info.vertBody:=0FFFFH;
  SetImage(image[1],-2,-1,16,10,1,imageMemPtr[0],1,0);
  SetImage(image[2],-2,-1,16,10,1,imageMemPtr[1],1,0);
  SetBorderKoord(xykoord[0],gadget[1]);
  SetBorderKoord(xykoord[1],gadget[2]);
  bptr:=SetBorder(border[0],-1,-1,1,0,5,jam1,ADR(xykoord[0]));
  bptr:=SetBorder(border[1],-1,-1,1,0,5,jam1,ADR(xykoord[1]));
  
  FOR i:=0 TO 3 DO
      gadgpos:=AddGadget(windowptr,ADR(gadget[i]),-1);
  END;    
  ReportMouse(windowptr,TRUE);
  RefreshGList(ADR(gadget[0]),windowptr,NIL,2);
  element:=1; DOSDosPtr^.listFile:=0;
  RETURN DOSDosPtr;
END InitDiskDir; 

PROCEDURE CheckMouse(): CARDINAL;
VAR zeile   : CARDINAL;
    PROCEDURE BearbeiteIntuipar(VAR element : CARDINAL): BOOLEAN;
    VAR mouseX,
        mouseY  : CARDINAL;
    BEGIN
    mouseX:=DOSDosPtr^.intuipar.mousex; 
    mouseY:=DOSDosPtr^.intuipar.mousey;
    
    CASE DOSDosPtr^.intuipar.key OF 
      return     :  IF Invers.number > 0 THEN
                       Invers.selected:=TRUE;
                       RETURN TRUE;
                    END;   
    | cursorDown :  IF (element+1 <= DOSDosPtr^.listFile+displayRows) THEN 
                       INC(element);
                    ELSE
                       IF (DOSDosPtr^.listFile+displayRows+1 < DirEntries) THEN
                          Down; INC(element);
                       END;
                    END;
                    RETURN TRUE;
    | cursorUp   :  IF (element-1 > DOSDosPtr^.listFile) AND (element > 0) THEN 
                       DEC(element); 
                    ELSE 
                       IF (DOSDosPtr^.listFile > 0) THEN
                          Up; element:=element+displayRows;
                       END;   
                    END;
                    RETURN TRUE;
    | cursorLeft :  DOSDosPtr^.listFile:=0;
                    DOSDosPtr^.info.vertPot:=0;
                    RefreshGList(ADR(gadget[0]),windowptr,NIL,1);
                    ListDir(DOSDosPtr^.listFile);
    | cursorRight:  IF (DirEntries > displayRows) THEN
                       DOSDosPtr^.listFile:=DirEntries-displayRows;
                       DOSDosPtr^.info.vertPot:=0FFFFH;
                    END;   
                    RefreshGList(ADR(gadget[0]),windowptr,NIL,1);
                    ListDir(DOSDosPtr^.listFile);           
    | selectUp   :
    
      IF ((mouseY > dirBlocky1+2) AND (mouseY < dirBlocky2-3)) THEN
         IF ((mouseX > dirBlockx1) AND (mouseX < dirBlockx2)) THEN
             zeile:=((mouseY - (dirBlocky1+3)) DIV 8) + 1;
             element:=zeile+DOSDosPtr^.listFile;
             Invers.selected:=TRUE;
             RETURN TRUE;
         END;
      END;
    ELSE  
    END;  
    RETURN FALSE;
    END BearbeiteIntuipar;

BEGIN
  zeile:=1;
IF BearbeiteIntuipar(element) THEN
   IF (element > DirEntries) AND (element > displayRows) THEN
      element:=element-displayRows;
   END;
   zeile:=element-DOSDosPtr^.listFile;
   IF zeile > displayRows THEN zeile:=displayRows; DEC(element); END;
     
  WITH Invers DO
    IF newPage THEN
       newPage:=FALSE;
    ELSE   
       IF (DirFeld[number]^.typ = verzeichnis) THEN
           Print(DirFeld[number]^.fileName,windowptr^.rPort,3,0,jam2,
               dirBlockx1+7,dirBlocky1 + (line * 8)+1);
       ELSE
           Print(DirFeld[number]^.fileName,windowptr^.rPort,1,0,jam2,
               dirBlockx1+7,dirBlocky1 + (line * 8)+1);
       END;
    END;
    
    IF (DirFeld[element]^.typ = verzeichnis) THEN
       Print(DirFeld[element]^.fileName,windowptr^.rPort,3,2,jam2,
             dirBlockx1+7,dirBlocky1 + (zeile * 8)+1);
    ELSE
       Print(DirFeld[element]^.fileName,windowptr^.rPort,0,1,jam2,
            dirBlockx1+7,dirBlocky1 + (zeile * 8)+1);
    END;
    number:=element; line:=zeile;    
  
    IF selected THEN
       RETURN element;
    END;
  END;     
END;    
 RETURN (0);         
END CheckMouse;

PROCEDURE ExamineKlick():BOOLEAN;
VAR  position  : INTEGER;
BEGIN
  DOSDosPtr^.selected:=FALSE; DOSDosPtr^.newProjekt:=FALSE;
  position:=CheckMouse();
  IF (position # 0) THEN
     Invers.selected:=FALSE; 
     IF (DirFeld[position]^.typ = verzeichnis) THEN
        IF (Occurs(DirFeld[position]^.fileName,0,".Projekt",FALSE) # -1) THEN
           Copy(DOSDosPtr^.Projekt,DirFeld[position]^.fileName);
           DOSDosPtr^.newProjekt:=TRUE; DOSDosPtr^.selected:=TRUE;
           RETURN FALSE;
        ELSE
          Concat(DOSDosPtr^.Pfad,DirFeld[position]^.fileName);
          Concat(DOSDosPtr^.Pfad,"/");
          RefreshGList(ADR(gadget[1]),windowptr,NIL,1);
        END;  
        RETURN TRUE; 
     ELSIF (DirFeld[position]^.typ = parent) THEN
        IF (DOSDosPtr^.Pfad[Length(DOSDosPtr^.Pfad)-1] = "/") THEN
           LeftStr(DOSDosPtr^.Pfad,DOSDosPtr^.Pfad,Length(DOSDosPtr^.Pfad)-1);
        END;   
        position:=LastPos(DOSDosPtr^.Pfad,Length(DOSDosPtr^.Pfad),"/");   
        IF (position # -1) THEN
           LeftStr(DOSDosPtr^.Pfad,DOSDosPtr^.Pfad,position+1);
           RETURN TRUE;
        ELSE
           position:=LastPos(DOSDosPtr^.Pfad,Length(DOSDosPtr^.Pfad),":");
           IF (position # -1) THEN
              LeftStr(DOSDosPtr^.Pfad,DOSDosPtr^.Pfad,position+1);
           ELSE
              Copy(DOSDosPtr^.Pfad,buffer); DisplayBeep(NIL);
           END;       
           RETURN TRUE;
        END;
     ELSIF (DirFeld[position]^.typ = datei) THEN
           Copy(DOSDosPtr^.Auswahl,DirFeld[position]^.fileName);
           DOSDosPtr^.selected:=TRUE;
     END;
  END;
  RETURN FALSE;   
END ExamineKlick;

PROCEDURE MasterControl(): BOOLEAN;
BEGIN
  ReportMouse(windowptr,FALSE);
  IF ExamineKlick() THEN
     NewDir(TRUE);  DOSDosPtr^.Auswahl:=("");
     RETURN DOSDosPtr^.selected;
  END;
  ReportMouse(windowptr,TRUE);
  RETURN DOSDosPtr^.selected;
END MasterControl;

PROCEDURE RefreshDir;
BEGIN
  Frame(windowptr^.rPort,1,dirBlockx1,dirBlocky1,dirBlockx2,dirBlocky2,2);
  ModifyListDir;
END RefreshDir;

PROCEDURE FreeAll;
BEGIN
  DeallocEintragList;
  IF (imageMemPtr[0] # NIL) THEN FreeMem(imageMemPtr[0],20) END;
  IF (imageMemPtr[1] # NIL) THEN FreeMem(imageMemPtr[1],20) END;
END FreeAll;

BEGIN
END DirectorySupport.

