(**********************************************************************

    :Program.    m2Maker
    :Contents.   Compileroberflche fr M2Amiga
    :Author.     Thomas Stolze
    :Copyright.  ShareWare
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.2
    :Imports.    StringSupport
    :Imports.    DirectorySupport
    :Imports.    IntuitionSupport
    :History.    V1.0 Thomas Stolze
    :History.    V1.1 Thomas Stolze 05-Nov-89

**********************************************************************)

(******************************************************************************
*                                                                             *
*    Programmname:  m2Maker                                                   *
*                                                                             *
*    Stand:         05.11.89                            Uhrzeit:  20:23:15    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.1         () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE m2Maker;

IMPORT Intuition;
IMPORT Exec;

FROM Arts             IMPORT Assert,wbStarted;
FROM SYSTEM           IMPORT ADDRESS,ADR,INLINE;
FROM Intuition        IMPORT ActivationFlags,ActivationFlagSet,AddGadget,
                             boolGadget,Border,BorderPtr,ClearMenuStrip,
                             CloseWindow,GadgetFlags,GadgetFlagSet,IDCMPFlags,
                             IDCMPFlagSet,Image,IntuiMessagePtr,IntuiText,
                             IntuiTextPtr,IntuitionBasePtr,Menu,MenuItemFlags,
                             MenuItemFlagSet,MoveWindow,NewWindow,OpenWindow,
                             RefreshGadgets,ScreenFlags,ScreenFlagSet,
                             SetMenuStrip,SizeWindow,strGadget,StringInfo,
                             WindowFlags,WindowFlagSet,WindowPtr;
FROM Graphics         IMPORT AllocRaster,BitMap,BltClear,DrawModeSet,FreeRaster,
                             InitBitMap,jam1,jam2,Move,RastPortPtr,SetAPen,
                             SetBPen,SetDrMd,Text;
FROM Exec             IMPORT AllocMem,CopyMem,CopyMemQuick,FindPort,FreeMem,
                             MemReqs,MemReqSet,Message,MsgPortPtr,PutMsg;
FROM ExecSupport      IMPORT CreatePort,DeletePort;
FROM Dos              IMPORT Output;
FROM InputEvent       IMPORT InputEvent,Qualifiers,QualifierSet;
FROM Str              IMPORT Length;
FROM StringSupport    IMPORT LEQ;
FROM IntuitionSupport IMPORT SetBorder,SetBorderKoord,SetGadget,SetImage,
                             SetInfo,SetIText,SetMenu,SetMenuItem,SetWindow;
FROM DirectorySupport IMPORT Block,Frame,FreeAll,InitDiskDir;

CONST  gadgetFlaggen = GadgetFlagSet{};
       actions       = ActivationFlagSet{gadgImmediate,relVerify};
       ImageBytes    = 40;


TYPE CardPtr    = POINTER TO CARDINAL;

     inputMessagePtr = POINTER TO inputMessage;
     inputMessage    = RECORD
                         nachricht : Message;
                         event     : InputEvent;
                       END;

VAR  InfoFeldListe  : ARRAY [comInfo..timerInfo] OF StringInfo;
     GadgetRahmen   : ARRAY [com..quest] OF Border;
     BorderKoord    : ARRAY [0..11],[0..9] OF INTEGER;
     IntuiFeldTexte : ARRAY [comText..deleteText] OF IntuiText;
     MenuTexte      : ARRAY [0..15] OF IntuiText;
     RequesterTexte : ARRAY [0..9] OF IntuiText;
     menustrip      : ARRAY [0..3] OF Menu;
     sysImage       : Image;
     sysImagePtr    : CardPtr;
     map            : BitMap;
     MyWindow       : NewWindow;
     erfolg,
     bigWindow      : BOOLEAN;


PROCEDURE SizeCLIWindow;
VAR base     : IntuitionBasePtr;
    x,y,w,h  : INTEGER;
    windptr  : WindowPtr;
    title    : ARRAY [0..40] OF CHAR;

    PROCEDURE GetTitle(VAR name : ARRAY OF CHAR): BOOLEAN;
    BEGIN
      IF windptr = NIL THEN RETURN FALSE END;
      CopyMem(windptr^.title,ADR(name),39);
      RETURN TRUE;
    END GetTitle;
BEGIN
  Assert(wbStarted = FALSE,ADR('Vom CLI mit "Run m2Maker" starten !'));

  base:=ADR(Intuition);
  windptr:=base^.firstScreen^.firstWindow;
  LOOP
    IF GetTitle(title) THEN
       IF (LEQ("AmigaShell",title) OR LEQ("New CLI",title))
                                   OR LEQ("AShell",title) THEN
          EXIT;
       END;
       windptr:=windptr^.nextWindow;
    ELSE
       EXIT;
    END;
  END;

  x:=windptr^.leftEdge; y:=windptr^.topEdge;
  w:=windptr^.width;    h:=windptr^.height;
  MoveWindow(windptr,-1 * x,(-1 * y) + 12);
  SizeWindow(windptr,538 - w,244 - h);
END SizeCLIWindow;

PROCEDURE InitITexte;
VAR ptr : IntuiTextPtr;
BEGIN
  ptr:=SetIText(IntuiFeldTexte[editorText],ADR('Editor')   ,1,0,1,2,jam1);
  ptr:=SetIText(IntuiFeldTexte[comText]   ,ADR('Compiler') ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[linkText]  ,ADR('Linker')   ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[runText]   ,ADR('Run')      ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[newText]   ,ADR('New')      ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[makeText]  ,ADR('Make')     ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[dirText]   ,ADR('Directory'),1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[opText]    ,ADR('Options')  ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[loadText]  ,ADR('Load Opt') ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[saveText]  ,ADR('Save Opt') ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[deleteText],ADR('Delete')   ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[copyText]  ,ADR('Save')     ,1,0,4,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[clearText] ,ADR('Clear')    ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[printText] ,ADR('Print')    ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[okText]    ,ADR('  OK  ')   ,2,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[projText]  ,ADR('Projekt')  ,1,0,1,2,jam2);
  ptr:=SetIText(IntuiFeldTexte[modText]   ,ADR('Mod')      ,1,0,1,2,jam2);
END InitITexte;

PROCEDURE InitInfo;
BEGIN
  SetInfo(InfoFeldListe[editInfo],ADR(BufferString[3]),ADR(BufferString[4]),
          0,79,0);
  SetInfo(InfoFeldListe[fileInfo],ADR(BufferString[1]),ADR(BufferString[2]),
          0,79,0);
  SetInfo(InfoFeldListe[pathInfo],ADR(BufferString[5]),ADR(BufferString[6]),
          0,79,0);
  SetInfo(InfoFeldListe[nameInfo],ADR(BufferString[7]),ADR(BufferString[8]),
          0,79,0);
END InitInfo;

PROCEDURE InitGadgets;
BEGIN
  SetGadget(GadgetFeldListe[editorGadget],11,15,49,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[edit]),ADR(IntuiFeldTexte[editorText]),NIL,0);
  SetGadget(GadgetFeldListe[compilerGadget],68,15,66,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[com]),ADR(IntuiFeldTexte[comText]),NIL,1);
  SetGadget(GadgetFeldListe[linkerGadget],142,15,49,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[edit]),ADR(IntuiFeldTexte[linkText]),NIL,2);
  SetGadget(GadgetFeldListe[runGadget],199,15,26,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[run]),ADR(IntuiFeldTexte[runText]),NIL,3);
  SetGadget(GadgetFeldListe[makeGadget],233,15,34,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[make]),ADR(IntuiFeldTexte[makeText]),NIL,4);
  SetGadget(GadgetFeldListe[dirGadget],327,57,74,10,gadgetFlaggen,
             actions,boolGadget,
             ADR(GadgetRahmen[neun]),ADR(IntuiFeldTexte[dirText]),NIL,5);
  SetGadget(GadgetFeldListe[opGadget],341,15,58,10,gadgetFlaggen,
             actions,boolGadget,
             ADR(GadgetRahmen[sieben]),ADR(IntuiFeldTexte[opText]),NIL,23);
  SetGadget(GadgetFeldListe[loadGadget],10,57,66,10,gadgetFlaggen,
             actions,boolGadget,ADR(GadgetRahmen[com]),
             ADR(IntuiFeldTexte[loadText]),NIL,6);
  SetGadget(GadgetFeldListe[saveGadget],83,57,66,10,gadgetFlaggen,
             actions,boolGadget,ADR(GadgetRahmen[com]),
             ADR(IntuiFeldTexte[saveText]),NIL,7);
  SetGadget(GadgetFeldListe[copyGadget],357,44,42,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[clear]),ADR(IntuiFeldTexte[copyText]),NIL,8);
  SetGadget(GadgetFeldListe[fileTextGadget],161,31,191,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[editor]),
             NIL,ADR(InfoFeldListe[fileInfo]),9);
  SetGadget(GadgetFeldListe[editTextGadget],161,45,191,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[redfile]),
             NIL,ADR(InfoFeldListe[editInfo]),10);
  SetGadget(GadgetFeldListe[clearGadget],156,57,42,10,gadgetFlaggen,
             actions,boolGadget,ADR(GadgetRahmen[clear]),
             ADR(IntuiFeldTexte[clearText]),NIL,13);
  SetGadget(GadgetFeldListe[printGadget],357,30,42,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[clear]),ADR(IntuiFeldTexte[printText]),NIL,14);
  SetGadget(GadgetFeldListe[pathTextGadget],124,77,265,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[file]),
             NIL,ADR(InfoFeldListe[pathInfo]),15);
  SetGadget(GadgetFeldListe[projectGadget],275,15,58,10,gadgetFlaggen,
             actions+ActivationFlagSet{toggleSelect},boolGadget,
             ADR(GadgetRahmen[sieben]),ADR(IntuiFeldTexte[projText]),NIL,17);
  SetGadget(GadgetFeldListe[nameGadget],124,92,265,8,gadgetFlaggen,actions,
             strGadget,ADR(GadgetRahmen[file]),
             NIL,ADR(InfoFeldListe[nameInfo]),18);
  SetGadget(GadgetFeldListe[SysGadget],-73,0,22,8,gadgetFlaggen+
             GadgetFlagSet{gRelRight,gadgImage},actions+
             ActivationFlagSet{topBorder},boolGadget,ADR(sysImage),NIL,NIL,24);
  SetGadget(GadgetFeldListe[deleteGadget],271,57,50,10,gadgetFlaggen,
             actions,boolGadget,ADR(GadgetRahmen[edit]),
             ADR(IntuiFeldTexte[deleteText]),NIL,25);
  SetGadget(GadgetFeldListe[NewGadget],238,57,26,10,gadgetFlaggen,
             actions,boolGadget,ADR(GadgetRahmen[run]),
             ADR(IntuiFeldTexte[newText]),NIL,26);
  SetGadget(GadgetFeldListe[modGadget],205,57,26,10,gadgetFlaggen,
             actions,boolGadget,ADR(GadgetRahmen[run]),
             ADR(IntuiFeldTexte[modText]),NIL,27);

END InitGadgets;

PROCEDURE InitBorderKoor;
BEGIN
  SetBorderKoord(BorderKoord[0],GadgetFeldListe[runGadget]);       (*  3 *)
  SetBorderKoord(BorderKoord[1],GadgetFeldListe[makeGadget]);      (*  4 *)
  SetBorderKoord(BorderKoord[2],GadgetFeldListe[clearGadget]);     (*  5 *)
  SetBorderKoord(BorderKoord[3],GadgetFeldListe[editorGadget]);    (*  6 *)
  SetBorderKoord(BorderKoord[4],GadgetFeldListe[compilerGadget]);  (*  8 *)
  SetBorderKoord(BorderKoord[6],GadgetFeldListe[pathTextGadget]);  (* 30 *)
  SetBorderKoord(BorderKoord[8],GadgetFeldListe[projectGadget]);   (*  7 *)
  SetBorderKoord(BorderKoord[9],GadgetFeldListe[editTextGadget]);  (* 22 *)
  SetBorderKoord(BorderKoord[10],GadgetFeldListe[dirGadget]);      (*  9 *)
     BorderKoord[7,0]:=6;    BorderKoord[7,1]:=3;
     BorderKoord[7,2]:=316;  BorderKoord[7,3]:=3;
     BorderKoord[7,4]:=316;  BorderKoord[7,5]:=68;
     BorderKoord[7,6]:=6;    BorderKoord[7,7]:=68;
     BorderKoord[7,8]:=6;    BorderKoord[7,9]:=3;
     BorderKoord[11]:=BorderKoord[7];
     BorderKoord[11,5]:=80; BorderKoord[11,7]:=80;
END InitBorderKoor;

PROCEDURE InitBorder;
VAR ptr : BorderPtr;
BEGIN
  ptr:=SetBorder(GadgetRahmen[edit] ,-1,-1,1,0,5,jam2,ADR(BorderKoord[3]));
  ptr:=SetBorder(GadgetRahmen[com ] ,-1,-1,1,0,5,jam2,ADR(BorderKoord[4]));
  ptr:=SetBorder(GadgetRahmen[run ] ,-1,-1,1,0,5,jam2,ADR(BorderKoord[0]));
  ptr:=SetBorder(GadgetRahmen[make] ,-1,-1,1,0,5,jam2,ADR(BorderKoord[1]));
  ptr:=SetBorder(GadgetRahmen[file] ,-1,-1,1,0,5,jam2,ADR(BorderKoord[6]));
  ptr:=SetBorder(GadgetRahmen[redfile],-1,-1,3,0,5,jam2,ADR(BorderKoord[9]));
  ptr:=SetBorder(GadgetRahmen[clear],-1,-1,1,0,5,jam2,ADR(BorderKoord[2]));
  ptr:=SetBorder(GadgetRahmen[ok]   ,-1,-1,2,0,5,jam2,ADR(BorderKoord[3]));
  ptr:=SetBorder(GadgetRahmen[quest],-1,-1,2,0,5,jam2,ADR(BorderKoord[7]));
  ptr:=SetBorder(GadgetRahmen[sieben],-1,-1,1,0,5,jam2,ADR(BorderKoord[8]));
  ptr:=SetBorder(GadgetRahmen[editor],-1,-1,1,0,5,jam2,ADR(BorderKoord[9]));
  ptr:=SetBorder(GadgetRahmen[neun]  ,-1,-1,1,0,5,jam2,ADR(BorderKoord[10]));
  ptr:=SetBorder(GadgetRahmen[opt]   ,-1,-1,2,0,5,jam2,ADR(BorderKoord[11]));
END InitBorder;

PROCEDURE InitMenus;
VAR ptr : IntuiTextPtr;
BEGIN
  ptr:=SetIText(MenuTexte[0],ADR('Info')             ,0,1,17,2,jam2);
  ptr:=SetIText(MenuTexte[1],ADR('AutoSave')         ,0,1,17,2,jam2);
  ptr:=SetIText(MenuTexte[2],ADR('Copy Projekt')     ,0,1,17,2,jam2);
  ptr:=SetIText(MenuTexte[3],ADR('New CLI       ^C') ,0,1,17,2,jam2);
  ptr:=SetIText(MenuTexte[4],ADR('Quit          ^Q') ,0,1,17,2,jam2);
  ptr:=SetIText(MenuTexte[5],ADR('Editor    F1') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[6],ADR('Compiler  F2') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[7],ADR('Linker    F3') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[8],ADR('Run       F4') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[9],ADR('Make      F5') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[10],ADR('Optionen     F7') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[11],ADR('Load    OPT') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[12],ADR('Save    OPT') ,0,1,10,2,jam2);
  ptr:=SetIText(MenuTexte[13],ADR('Umbenennen')  ,0,1,17,2,jam2);
  ptr:=SetIText(MenuTexte[14],ADR('Lschen')     ,0,1,17,2,jam2);
  ptr:=SetIText(MenuTexte[15],ADR('SYS Compiler'),0,1,10,2,jam2);

           menustripPtr:=SetMenu(menustrip[0], 28,0,100,0,ADR(" Projekt"));
  menustrip[0].nextMenu:=SetMenu(menustrip[1],136,0,100,0,ADR(" m2Maker"));
  menustrip[1].nextMenu:=SetMenu(menustrip[2],240,0,100,0,ADR(" Optionen"));
  menustrip[2].nextMenu:=SetMenu(menustrip[3],340,0,100,0,ADR("    DOS"));

  menustripPtr^.firstItem:=SetMenuItem(MenuItemFeld[0],3,0,151,11,
               MenuItemFlagSet{commSeq,highComp,itemText,itemEnabled},
               ADR(MenuTexte[0]),NIL,"I");
  MenuItemFeld[0].nextItem:=SetMenuItem(MenuItemFeld[1],3,12,151,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled,commSeq,
               menuToggle,checkIt},
               ADR(MenuTexte[1]),NIL,"B");
  MenuItemFeld[1].nextItem:=SetMenuItem(MenuItemFeld[2],3,24,151,11,
               MenuItemFlagSet{highComp,itemText,commSeq},
               ADR(MenuTexte[2]),NIL,"C");
  MenuItemFeld[2].nextItem:=SetMenuItem(MenuItemFeld[3],3,36,151,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[3]),NIL,00C);
  MenuItemFeld[3].nextItem:=SetMenuItem(MenuItemFeld[4],3,48,151,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[4]),NIL,00C);

   menustrip[1].firstItem:=SetMenuItem(MenuItemFeld[5],3,0,118,11,
                MenuItemFlagSet{highComp,itemEnabled,itemText},
                ADR(MenuTexte[5]),NIL,00C);
  MenuItemFeld[5].nextItem:=SetMenuItem(MenuItemFeld[6],3,12,118,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[6]),NIL,00C);
  MenuItemFeld[6].nextItem:=SetMenuItem(MenuItemFeld[7],3,24,118,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[7]),NIL,00C);
  MenuItemFeld[7].nextItem:=SetMenuItem(MenuItemFeld[8],3,36,118,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[8]),NIL,00C);
  MenuItemFeld[8].nextItem:=SetMenuItem(MenuItemFeld[9],3,48,118,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[9]),NIL,00C);
  MenuItemFeld[9].nextItem:=SetMenuItem(MenuItemFeld[15],3,60,118,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[15]),NIL,00C);

  menustrip[2].firstItem:=SetMenuItem(MenuItemFeld[10],3,0,144,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled},
               ADR(MenuTexte[10]),NIL,00C);
  MenuItemFeld[10].nextItem:=SetMenuItem(MenuItemFeld[11],3,12,144,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled,commSeq},
               ADR(MenuTexte[11]),NIL,"L");
  MenuItemFeld[11].nextItem:=SetMenuItem(MenuItemFeld[12],3,24,144,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled,commSeq},
               ADR(MenuTexte[12]),NIL,"S");

  menustrip[3].firstItem:=SetMenuItem(MenuItemFeld[13],3,0,138,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled,commSeq},
               ADR(MenuTexte[13]),NIL,"R");
  MenuItemFeld[13].nextItem:=SetMenuItem(MenuItemFeld[14],3,12,138,11,
               MenuItemFlagSet{highComp,itemText,itemEnabled,commSeq},
               ADR(MenuTexte[14]),NIL,"D");
END InitMenus;

PROCEDURE PrintTexte;
  PROCEDURE Print(text : ARRAY OF CHAR; rport : RastPortPtr;
                                    fPen,bPen : INTEGER;
                                    drawM     : DrawModeSet;
                                    xpos,ypos : INTEGER);
BEGIN
  SetAPen(rport,fPen); SetBPen(rport,bPen); SetDrMd(rport,drawM);
  Move(rport,xpos,ypos);
  Text(rport,ADR(text),Length(text));
END Print;

BEGIN
  Block(window^.rPort,2,12,71,400,105);
  Frame(window^.rPort,1,69,109,401,119,1);
  Frame(window^.rPort,3,11,70,401,106,2);
  Print("Filename:",window^.rPort,1,0,jam2,11,37);
  Print("Editor Filename:",window^.rPort,1,0,jam2,11,51);
  Print("Status:",window^.rPort,3,0,jam2,11,117);
  Print("Backup-Pfad:",window^.rPort,1,2,jam2,21,83);
  Print("Projekt:",window^.rPort,1,2,jam2,21,99);
END PrintTexte;

PROCEDURE Cleanupm2Maker;
VAR news       : inputMessage;
    ptr,
    replyport  : MsgPortPtr;
    in         : IntuiMessagePtr;
    wind       : WindowPtr;
BEGIN
  wind:=window; window:=NIL;
  WHILE (MemoryTask # NIL) DO END;

  IF (wind # NIL) THEN
     ClearMenuStrip(wind);
     CloseWindow(wind); wind:=NIL;
     FreeRaster(map.planes[0],fensterBreite,((fensterHoehe DIV 8)+1)*8);
     FreeRaster(map.planes[1],fensterBreite,((fensterHoehe DIV 8)+1)*8);
     FreeMem(sysImagePtr,ImageBytes);
  END;
  FreeAll;

  ptr:=FindPort(ADR("FastLister_Port"));
  IF (ptr # NIL) THEN
     replyport:=CreatePort(NIL,0);
        news.event.code:=45H;
        news.event.qualifier:=QualifierSet{lShift,control};
        news.nachricht.node.type:=Exec.message;
        news.nachricht.length:=SIZE(InputEvent);
        news.nachricht.replyPort:=replyport;

        PutMsg(ptr,ADR(news));

     DeletePort(replyport);
     WHILE (FindPort(ADR("FastLister_Port")) # NIL) DO END;
  END;
END Cleanupm2Maker;

PROCEDURE Window(): WindowPtr;
VAR i,pos : INTEGER;
    pl    : ADDRESS;
    (* $E- *)
    PROCEDURE ImageDaten;
    BEGIN
      INLINE(03FFFH,0FFFFH,
             00000H,00FFFH,0000FH,0CFFFH,
             0000FH,0CFFFH,0000FH,0CFFFH,
             0000FH,0CFFFH,03FFFH,0CFFFH,
             03FFFH,0CFFFH,00000H,00FFFH,
             03FFFH,0FFFFH);
    END ImageDaten;

    PROCEDURE AllocImageChip(imageadr : ADDRESS; size : LONGINT): ADDRESS;
    VAR adr : ADDRESS;
    BEGIN
      adr:=AllocMem(size,MemReqSet{chip});
      Assert(adr # NIL,ADR("Nicht genug Chip-RAM"));
        CopyMemQuick(imageadr,adr,size);
      RETURN adr;
    END AllocImageChip;
BEGIN

  InitBitMap(map,2,fensterBreite,((fensterHoehe DIV 8)+1)*8);
  FOR i:=0 TO 1 DO
      pl:=AllocRaster(fensterBreite,((fensterHoehe DIV 8)+1)*8);
          Assert(pl # NIL,ADR('Nicht genug Chip-RAM !!!'));
      map.planes[i]:=pl;
      BltClear(pl,(fensterBreite) DIV 8 * (((fensterHoehe DIV 8)+1)*8),1);
  END;
  sysImagePtr:=AllocImageChip(ADR(ImageDaten),ImageBytes);
  SetImage(sysImage,0,0,20,10,1,sysImagePtr,1,0);

  InitITexte; InitInfo;
  InitGadgets; InitMenus;
  InitBorderKoor; InitBorder;

  SetWindow(MyWindow,0,0,fensterBreite,fensterHoehe,0,1,
            IDCMPFlagSet{closeWindow,gadgetUp,mouseButtons,rawKey,menuPick},
            WindowFlagSet{windowDrag,windowDepth,windowClose,activate,menuState,
                          superBitMap,noCareRefresh,windowActive,reportMouse},
            NIL,NIL,NIL,160,50,640,111,ScreenFlagSet{wbenchScreen});
            MyWindow.bitMap:=ADR(map);

  window:=OpenWindow(MyWindow);
    Assert(window # NIL,ADR("Fenster nicht geffnet"));
  erfolg:=SetMenuStrip(window,menustripPtr);
    Assert(erfolg # FALSE,ADR("Menu konnte nicht initialisiert werden"));

  PrintTexte;
  FOR i:=1 TO 20 DO
    pos:=AddGadget(window,ADR(GadgetFeldListe[VAL(GadgetNamen,i)]),-1);
  END;
    pos:=AddGadget(window,ADR(GadgetFeldListe[SysGadget]),0);
  RefreshGadgets(window^.firstGadget,window,NIL);

  BackupFlag:=FALSE;
  DirPtr:=InitDiskDir(21,22,35,36,407,13,FALSE,window);
  outputChannel:=Output();
  RETURN window;
END Window;

BEGIN
  MemoryTask:=NIL;
END m2Maker.

