(******************************************************************************
*                                                                             *
*    Programmname:  m2MakerRoutines                                           *
*                                                                             *
*    Stand:         05.11.89                            Uhrzeit:  20:31:06    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.1         () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE m2MakerRoutines;

FROM SYSTEM           IMPORT ADR;
FROM Intuition        IMPORT ActivateGadget,ActivationFlags,ActivationFlagSet,
                             ClearMenuStrip,GadgetFlags,GadgetPtr,IDCMPFlags,
                             IDCMPFlagSet,MenuItemFlags,ModifyIDCMP,MoveWindow,
                             RefreshGList,SetMenuStrip,SizeWindow,WindowToFront,
                             AddGadget,RemoveGadget,GadgetFlagSet;
FROM Graphics         IMPORT DrawModes,DrawModeSet,jam1,jam2,Move,RastPortPtr,
                             RectFill,SetAPen,SetBPen,SetDrMd,Text;
FROM Dos              IMPORT accessRead,CurrentDir,Delay,Execute,FileLockPtr,
                             IoErr,Lock,UnLock,SetComment;
FROM m2Maker          IMPORT BackupFlag,BufferString,DirPtr,fensterBreite,
                             fensterHoehe,GadgetFeldListe,GadgetNamen,
                             MenuItemFeld,menustripPtr,OptionenString,
                             outputChannel,projectFlag,SystemString,window,win;
FROM Str              IMPORT Concat,Copy,FirstPos,LastPos,Length;
FROM FileSystem       IMPORT Close,File,Lookup,ReadChar,Response,WriteBytes,
                             WriteChar;
FROM StringSupport    IMPORT DeleteStr,LeftStr,Occurs,ProduceStr,StringStr,
                             ValStr,LGT;
FROM TimerSupport     IMPORT MakeDateString,MakeTimeString;
FROM DirectorySupport IMPORT Frame,NewDir;

CONST lineFeed = 12C;
      actions  = ActivationFlagSet{gadgImmediate,relVerify};

VAR DummyStr  : ARRAY [0..140] OF CHAR;
    altlock   : FileLockPtr;
    bigWindow,
    erfolg    : BOOLEAN;
    
PROCEDURE Block(rport : RastPortPtr; col,x1,y1,x2,y2 : INTEGER);
BEGIN
  SetAPen(rport,col); SetDrMd(rport,jam2);
  RectFill(rport,x1,y1,x2,y2);
END Block;

PROCEDURE Print(text : ARRAY OF CHAR; rport : RastPortPtr;
                                  fPen,bPen : INTEGER;
                                  drawM     : DrawModeSet;
                                  xpos,ypos : INTEGER);
BEGIN
  SetAPen(rport,fPen); SetBPen(rport,bPen); SetDrMd(rport,drawM);
  Move(rport,xpos,ypos);
  Text(rport,ADR(text),Length(text));
END Print;
  
PROCEDURE PrintStatus(text : ARRAY OF CHAR);
VAR space : ARRAY [0..40] OF CHAR;
BEGIN
  ProduceStr(space," ",40);
  Print(space,window^.rPort,1,0,jam2,74,117);
  Print(text,window^.rPort,1,0,jam1,74,117);
END PrintStatus;

PROCEDURE PrintDosErr(nr : LONGINT);
VAR  print : ARRAY [0..10] OF CHAR;
     errstr: ARRAY [0..20] OF CHAR; 
BEGIN
  IF (nr > 0) AND (nr < 1000) THEN 
     errstr:=("DOS Error: "); StringStr(print,nr,5);
     Concat(errstr,print);    PrintStatus(errstr);
  END;
  PrintStatus("OK");   
END PrintDosErr;
       
PROCEDURE Executeing(VAR str : ARRAY OF CHAR): INTEGER;
VAR  erg : INTEGER;
BEGIN
  erg:=Execute(ADR(str),NIL,outputChannel);
  IF erg > 0 THEN
     PrintDosErr(IoErr());
  END;
  RETURN erg;
END Executeing;

PROCEDURE Invers(gadgptr : GadgetPtr);
VAR erg : INTEGER;
BEGIN
  erg:=RemoveGadget(window,gadgptr);
  WITH gadgptr^ DO
    IF (selected IN flags) THEN
      Block(window^.rPort,0,leftEdge,topEdge,leftEdge+width-1,topEdge+height-1);
       EXCL(flags,selected);
    END;
  END; 
  erg:=AddGadget(window,gadgptr,erg);
  RefreshGList(gadgptr,window,NIL,1);
END Invers;

PROCEDURE Convert(gadgptr : GadgetPtr);
VAR erg : INTEGER;
BEGIN
  erg:=RemoveGadget(window,gadgptr);
  WITH gadgptr^ DO
    IF NOT (selected IN flags) THEN
      Block(window^.rPort,0,leftEdge,topEdge,leftEdge+width-1,topEdge+height-1);
       INCL(flags,selected);
    END;
  END;
  erg:=AddGadget(window,gadgptr,erg);
  RefreshGList(gadgptr,window,NIL,1);
END Convert;
    
PROCEDURE Prueffile(str : ARRAY OF CHAR; anzeige : BOOLEAN): BOOLEAN;
VAR ioerr  : LONGINT;
    lock   : FileLockPtr;
BEGIN
  lock:=Lock(ADR(str),accessRead);
  IF lock = NIL THEN
     IF anzeige THEN
        PrintDosErr(IoErr());
     END;   
     UnLock(lock);
     RETURN FALSE;
  END;
  UnLock(lock);
  RETURN TRUE
END Prueffile;

PROCEDURE EditorTextGadget;
VAR pos : INTEGER;
BEGIN
   pos:=LastPos(BufferString[3],Length(BufferString[3]),".");
     LeftStr(BufferString[1],BufferString[3],pos);
     Copy(BufferString[9],DirPtr^.Pfad);
   RefreshGList(ADR(GadgetFeldListe[fileTextGadget]),window,NIL,2);
END EditorTextGadget;
   
PROCEDURE Editor;
BEGIN
  PrintStatus('Editor aktiviert');
  Copy(DummyStr,SystemString[4]); Concat(DummyStr,SystemString[0]); 
  Concat(DummyStr," "); Concat(DummyStr,OptionenString[0]);
  Concat(DummyStr," ");      
  Concat(DummyStr,BufferString[9]);  
  Concat(DummyStr,BufferString[3]);
    PrintDosErr(Executeing(DummyStr));
  Invers(ADR(GadgetFeldListe[editorGadget]));
END Editor;

PROCEDURE Compiler(): BOOLEAN;
VAR str  : ARRAY [0..79] OF CHAR;

  PROCEDURE SetCompilerComment;
  VAR infoString : ARRAY [0..40] OF CHAR;
      string     : ARRAY [0..20] OF CHAR;
      dummy      : ARRAY [0..79] OF CHAR;
      bool       : BOOLEAN;
      pos        : INTEGER;
  BEGIN
    MakeDateString(string); Copy(infoString,string); Concat(infoString," ");
    MakeTimeString(string); Concat(infoString,string);
       Copy(DummyStr,BufferString[7]); Concat(DummyStr,"/obj/");
       pos:=LastPos(BufferString[3],Length(BufferString[3]),".");
       Copy(dummy,BufferString[3]);
       IF (pos # -1) THEN
           LeftStr(dummy,BufferString[3],pos);
            Concat(dummy,".obj");
            Concat(DummyStr,dummy); 
           bool:=SetComment(ADR(DummyStr),ADR(infoString));
       END;
  END SetCompilerComment;
BEGIN
  PrintStatus('Compiler aktiviert'); str:=("");
  Copy(DummyStr,SystemString[4]); Concat(DummyStr,SystemString[1]); 
  Concat(DummyStr," "); Concat(DummyStr,OptionenString[2]);
  Concat(DummyStr," ");
    IF projectFlag THEN
       Copy(str,BufferString[7]); Concat(str,"/txt/");
    ELSE
       Concat(str,BufferString[9]);   
    END; 
  Concat(str,BufferString[3]); Concat(DummyStr,str);
    PrintDosErr(Executeing(DummyStr));
  IF projectFlag THEN SetCompilerComment END;
  
  Invers(ADR(GadgetFeldListe[compilerGadget]));
  Concat(str,"E");
    IF Prueffile(str,FALSE) THEN
       Convert(ADR(GadgetFeldListe[editorGadget]));
       Editor;
       RETURN FALSE;
    END;
  RETURN TRUE; 
END Compiler;

PROCEDURE CompileProject;
VAR Dateiname : ARRAY [0..80] OF CHAR;
    input     : File;
    bool      : BOOLEAN;
  PROCEDURE LeseZeile(VAR name : ARRAY OF CHAR);
  VAR  pos : INTEGER;
     anzahl: LONGINT;
       str : ARRAY [0..80] OF CHAR;
       ch  : CHAR;
  BEGIN
    pos:=0; ch:=00C;
    REPEAT
      ReadChar(input,ch);
       str[pos]:=ch; INC(pos);
    UNTIL (ch = lineFeed) OR (input.eof);
       str[pos-1]:=00C;
    Copy(name,str);
  END LeseZeile;
BEGIN
  PrintStatus("Compiliere Projekt"); bool:=TRUE;
  Copy(DummyStr,DirPtr^.Pfad); Concat(DummyStr,BufferString[3]);
  IF Occurs(BufferString[3],0,".mke",TRUE) # -1 THEN
     Lookup(input,DummyStr,512,FALSE);
       WHILE ((input.res = done) AND ((NOT input.eof) AND bool)) DO
             LeseZeile(Dateiname);
             IF LGT("                                  ",Dateiname) THEN
                Copy(BufferString[3],Dateiname);
                EditorTextGadget;
                Convert(ADR(GadgetFeldListe[compilerGadget]));
                bool:=Compiler();
             END;
       END;
     Close(input); 
  ELSE
    PrintStatus("Datei ungltig !!!");
  END;   
END CompileProject;

PROCEDURE Linker;
VAR bool : BOOLEAN;
BEGIN
  PrintStatus('Linker aktiviert');
  Copy(DummyStr,SystemString[4]); Concat(DummyStr,SystemString[2]); 
  Concat(DummyStr," "); Concat(DummyStr,OptionenString[4]);
  Concat(DummyStr," ");
    IF projectFlag THEN
       Concat(DummyStr,BufferString[7]);
       Concat(DummyStr,"/obj/");
    ELSE
       Concat(DummyStr,BufferString[9]);   
    END;
   Concat(DummyStr,BufferString[1]);
   Concat(DummyStr,".obj");
     PrintDosErr(Executeing(DummyStr));
   Invers(ADR(GadgetFeldListe[linkerGadget]));
END Linker;

PROCEDURE Run;
VAR bool : BOOLEAN;
BEGIN
  PrintStatus('Programm gestartet');
  IF projectFlag THEN
     Copy(DummyStr,BufferString[7]); Concat(DummyStr,"/");
     IF (FirstPos(OptionenString[6],0,"b") = -1) THEN
        Concat(DummyStr,"bin/");
     END;   
  ELSE
     Copy(DummyStr,BufferString[9]);
  END;
  Concat(DummyStr,BufferString[1]);
    PrintDosErr(Executeing(DummyStr));
  Invers(ADR(GadgetFeldListe[runGadget]));
END Run;

PROCEDURE Backup;
VAR true : INTEGER;
    str,  
    check,
    pruef: ARRAY [0..79] OF CHAR;
BEGIN
  PrintStatus('Backup-Kopie wird gespeichert'); str:=("");
  DummyStr:="sys:c/copy ";
  IF projectFlag THEN
     Copy(str,BufferString[7]);
     Concat(str,"/txt/");
  ELSE
      Concat(str,BufferString[9]);
  END;      
  Concat(str,BufferString[3]);
  Concat(DummyStr,str);    
  Concat(DummyStr," TO ");
  IF projectFlag THEN
     Copy(str,BufferString[7]); 
     true:=FirstPos(str,0,":"); DeleteStr(str,0,true+1);
     
     Copy(pruef,SystemString[4]); Concat(pruef,SystemString[3]);
     Concat(pruef," "); Concat(pruef,OptionenString[6]); 
     Concat(pruef," ");
     Concat(pruef,BufferString[5]); Concat(pruef,str);
     Copy(check,BufferString[5]);   Concat(check,str);
     IF NOT Prueffile(check,FALSE) THEN
        PrintDosErr(Executeing(pruef));
     END;
     
     Concat(str,"/txt/");
     Concat(DummyStr,BufferString[5]);
  ELSE
     Copy(str,BufferString[5]);   
  END;    
  Concat(DummyStr,str);
    PrintDosErr(Executeing(DummyStr));
  Invers(ADR(GadgetFeldListe[copyGadget]));
END Backup;

PROCEDURE Make;
VAR  str    : ARRAY [0..80] OF CHAR;
     erfolg : BOOLEAN;
BEGIN
  Convert(ADR(GadgetFeldListe[compilerGadget]));
  erfolg:=Compiler();
    IF erfolg THEN
         Convert(ADR(GadgetFeldListe[linkerGadget]));
       Linker;
       IF BackupFlag=TRUE THEN
          Convert(ADR(GadgetFeldListe[copyGadget]));
          Backup;
       END;
       Convert(ADR(GadgetFeldListe[runGadget]));
       Run;
    END;
  Invers(ADR(GadgetFeldListe[makeGadget]));
END Make;

PROCEDURE SaveOpts;
VAR     anzahl : LONGINT;
             i : INTEGER;
        output : File; 
        dummy  : ARRAY [0..10] OF CHAR;
  PROCEDURE SchreibeZeile(str : ARRAY OF CHAR);
  VAR pos : INTEGER;
  BEGIN
      pos:=Length(str);
         WriteBytes(output,ADR(str),pos,anzahl);
         WriteChar (output,lineFeed);
  END SchreibeZeile;
  PROCEDURE SichereParameter(path : ARRAY OF CHAR);
  BEGIN
    i:=0;
    Lookup(output,path,512,TRUE);
    IF (output.res = done) THEN
       FOR i:=0 TO 6 BY 2 DO
         SchreibeZeile(OptionenString[i]);
         SchreibeZeile(BufferString[i+1]);
       END;
       SchreibeZeile(BufferString[9]);
       SchreibeZeile(DirPtr^.Pfad);
       SchreibeZeile(BufferString[11]);
         StringStr(dummy,DirPtr^.info.vertPot,9);
       SchreibeZeile(dummy);
       FOR i:=0 TO 4 DO
         SchreibeZeile(SystemString[i]);
       END;
    END;
    Close(output);
    PrintDosErr(IoErr());
  END SichereParameter;
BEGIN
  PrintStatus('Optionen Speichern');
    Copy(DummyStr,SystemString[4]); Concat(DummyStr,"m2Maker.par");
    SichereParameter(DummyStr);
    Copy(DummyStr,BufferString[7]);
      Concat(DummyStr,"/m2Maker.par");
    SichereParameter(DummyStr);
END SaveOpts;
  
PROCEDURE LoadOpts;
VAR input : File;
    i     : INTEGER;
    dummy : ARRAY [0..10] OF CHAR; 
  PROCEDURE LeseZeile(VAR zeile : ARRAY OF CHAR);
  VAR  pos : INTEGER;
     anzahl: LONGINT;
       str : ARRAY [0..80] OF CHAR;
       ch  : CHAR;
  BEGIN
    pos:=0; ch:=00C;
    REPEAT
      ReadChar(input,ch);
       str[pos]:=ch; INC(pos);
    UNTIL (ch = lineFeed) OR (input.eof);
       str[pos-1]:=00C;
    Copy(zeile,str);
  END LeseZeile;
BEGIN
  Copy(DummyStr,SystemString[4]); Concat(DummyStr,"m2Maker.par");
  PrintStatus('Optionen Laden');
  Lookup(input,DummyStr,512,FALSE);
  IF (input.res = done) THEN
     DirPtr^.listFile:=0;
     FOR i:=0 TO 6 BY 2 DO
       LeseZeile(OptionenString[i]);
       LeseZeile(BufferString[i+1]);
     END;
     LeseZeile(BufferString[9]);
     LeseZeile(DirPtr^.Pfad);
     LeseZeile(BufferString[11]);
     LeseZeile(dummy);
     DirPtr^.info.vertPot:=ValStr(dummy);
     FOR i:=0 TO 4 DO
         LeseZeile(SystemString[i]);
     END;
  END;
  Close(input);
  PrintDosErr(IoErr());  
  RefreshGList(ADR(GadgetFeldListe[fileTextGadget]),window,NIL,7);
END LoadOpts;
   
PROCEDURE Saver;
BEGIN
  IF BackupFlag=FALSE THEN
     BackupFlag:=TRUE;
  ELSE
     BackupFlag:=FALSE;
  END;
END Saver;
          
PROCEDURE ProjektSpeichern;
VAR save    : BOOLEAN;
    nr      : LONGINT;
    str     : ARRAY [0..79] OF CHAR;
    lock    : FileLockPtr;
BEGIN
  IF (Length(BufferString[7]) # 0) THEN
     Copy(DummyStr,"sys:c/Copy ");
     Concat(DummyStr,BufferString[7]); 
     Concat(DummyStr," TO ");
     Copy(str,BufferString[7]); nr:=FirstPos(str,0,":");
     DeleteStr(str,0,nr+1); Concat(DummyStr,BufferString[5]);
     Concat(DummyStr,str); Concat(DummyStr," ALL QUIET");
      
     Convert(ADR(GadgetFeldListe[copyGadget])); 
       PrintDosErr(Executeing(DummyStr));
       
     Copy(DummyStr,BufferString[5]); Concat(DummyStr,str); 
     Concat(DummyStr,".info");
     IF NOT Prueffile(DummyStr,FALSE) THEN
        Copy(str,BufferString[7]); Concat(str,".info");
        IF Prueffile(str,FALSE) THEN
           Copy(DummyStr,"sys:c/Copy ");
           Concat(DummyStr,str); Concat(DummyStr," TO ");
           Concat(DummyStr,BufferString[5]);
           nr:=Executeing(DummyStr);
        END;   
     END;
     Invers(ADR(GadgetFeldListe[copyGadget]));
  END;        
END ProjektSpeichern;

PROCEDURE StartProject():BOOLEAN;
VAR erg  : INTEGER;
    lock : FileLockPtr;
BEGIN
  Copy(DummyStr,SystemString[4]); Concat(DummyStr,SystemString[3]); 
  Concat(DummyStr," ");   
  Concat(DummyStr,OptionenString[6]); Concat(DummyStr," ");
  
  IF (Length(BufferString[7]) # 0) THEN
        IF (NOT Prueffile(BufferString[7],TRUE)) THEN
           Concat(DummyStr,BufferString[7]);
           erg:=Executeing(DummyStr);
        END;
        Copy(DummyStr,BufferString[7]);
        Concat(DummyStr,"/m2Maker.par");
        IF (Prueffile(DummyStr,TRUE)) THEN
           Copy(DummyStr,"sys:c/Copy "); 
           Concat(DummyStr,BufferString[7]);
           Concat(DummyStr,"/m2Maker.par TO "); 
           Concat(DummyStr,SystemString[4]);
           erg:=Executeing(DummyStr);
           LoadOpts; NewDir(FALSE);
        ELSE
           Copy(DirPtr^.Pfad,BufferString[7]); Concat(DirPtr^.Pfad,"/");
           DirPtr^.info.vertPot:=0;
           NewDir(TRUE);
        END;  
        PrintStatus('Projekt initialisiert');
         lock:=Lock(ADR(BufferString[7]),accessRead);
         altlock:=CurrentDir(lock);
     RETURN TRUE;
  ELSE   
     PrintStatus('Kein Projekt definiert !!!');
  END;
  RETURN FALSE;
END StartProject;

PROCEDURE Project;
VAR wahr : BOOLEAN;
    lock : FileLockPtr;
BEGIN
  IF (projectFlag = FALSE) THEN
     PrintStatus("Projektverzeichnis erstellt");
     IF StartProject() THEN
        projectFlag:=TRUE;
        ClearMenuStrip(window);
          INCL(MenuItemFeld[2].flags,itemEnabled);
        wahr:=SetMenuStrip(window,menustripPtr);
     ELSE
        Invers(ADR(GadgetFeldListe[projectGadget]))
     END; 
  ELSE
     projectFlag:=FALSE;
      ClearMenuStrip(window);
        EXCL(MenuItemFeld[2].flags,itemEnabled);
      wahr:=SetMenuStrip(window,menustripPtr);
      PrintStatus('Projekt beendet');
      lock:=CurrentDir(altlock); UnLock(lock);
  END;   
END Project;
          
PROCEDURE SelectedFile;
VAR pos : INTEGER;
BEGIN
  IF DirPtr^.newProjekt THEN
     IF projectFlag THEN
        Project;
          Copy(BufferString[7],DirPtr^.Device); Concat(BufferString[7],":");
          Concat(BufferString[7],DirPtr^.Projekt);
          RefreshGList(ADR(GadgetFeldListe[nameGadget]),window,NIL,1);
        Project;
        PrintStatus("Wechsel des Projekts !!!");
     ELSE
        Concat(DirPtr^.Pfad,DirPtr^.Projekt);
        NewDir(TRUE);
     END;   
  ELSE 
     Copy(BufferString[9],DirPtr^.Pfad);
     Copy(BufferString[3],DirPtr^.Auswahl);
     pos:=LastPos(BufferString[3],Length(BufferString[3]),".");
     IF (pos # -1) THEN
       LeftStr(BufferString[1],DirPtr^.Auswahl,pos);
     ELSE
       Copy(BufferString[1],DirPtr^.Auswahl);
     END;      
     RefreshGList(ADR(GadgetFeldListe[fileTextGadget]),window,NIL,2);
  END;  
END SelectedFile;  

PROCEDURE NewCli;
VAR str : ARRAY [0..15] OF CHAR;
BEGIN
  str:=("sys:c/NewShell"); PrintDosErr(Executeing(str));
END NewCli;

PROCEDURE SmallWindow;
VAR gadgptr : GadgetPtr;
    erfolg  : BOOLEAN;
BEGIN
  IF (NOT bigWindow) THEN
     bigWindow:=TRUE;
     MoveWindow(window,-1 * window^.leftEdge,-1 * window^.topEdge);
     SizeWindow(window,-365,29-fensterHoehe); Delay(5);
     ModifyIDCMP(window,IDCMPFlagSet{closeWindow,gadgetUp,rawKey,menuPick});
     WindowToFront(window); Delay(5);
  ELSE
     bigWindow:=FALSE;
     MoveWindow(window,-1 * window^.leftEdge,-1 * window^.topEdge);
     SizeWindow(window,365,fensterHoehe-29); Delay(5);
     ModifyIDCMP(window,IDCMPFlagSet{closeWindow,gadgetUp,rawKey,
                                     mouseButtons,menuPick});
     Frame(window^.rPort,1,0,0,fensterBreite-1,fensterHoehe-1,1);
     IF projectFlag THEN Convert(ADR(GadgetFeldListe[projectGadget])) END;
     WindowToFront(win); Delay(5);
  END; 
END SmallWindow;

PROCEDURE ExecuteBatch;
VAR  name : ARRAY [0..50] OF CHAR;
BEGIN
  Copy(DummyStr,SystemString[4]); Concat(DummyStr,"m2Maker.exec");
  IF Prueffile(DummyStr,FALSE) THEN
     name:=("sys:c/Execute "); Concat(name,DummyStr);
     PrintStatus("FastLister installiert /  Batchdatei");
     PrintDosErr(Executeing(name));
  END;
  Copy(name,SystemString[4]); Concat(name,"FastLister ");
  IF Prueffile(DummyStr,FALSE) THEN
     DummyStr:=("run "); Concat(DummyStr,name); 
     Concat(DummyStr,BufferString[11]);
     PrintDosErr(Executeing(DummyStr));
  END;   
END ExecuteBatch;

PROCEDURE NewFile;
VAR bool : BOOLEAN;
BEGIN
  BufferString[3]:=(""); BufferString[1]:=("");
    Copy(BufferString[9],DirPtr^.Pfad);
    RefreshGList(ADR(GadgetFeldListe[fileTextGadget]),window,NIL,2);
  bool:=ActivateGadget(ADR(GadgetFeldListe[editTextGadget]),window,NIL);
END NewFile;

PROCEDURE ProjektPfad;
BEGIN
  IF (BufferString[7,Length(BufferString[7])-1] = CHAR(47)) THEN
     BufferString[7,Length(BufferString[7])-1]:=00C;
  END;
  IF (Occurs(BufferString[7],0,".Projekt",FALSE) = -1 ) THEN
     Concat(BufferString[7],".Projekt");
  END;   
  RefreshGList(ADR(GadgetFeldListe[nameGadget]),window,NIL,1);        
END ProjektPfad;

PROCEDURE BackupPfad;
VAR len : INTEGER;
BEGIN
  len:=Length(BufferString[5]);
  IF ((BufferString[5,len-1] # CHR(47)) AND
                              (BufferString[5,len-1] # CHR(58))) THEN
     BufferString[5,len]:=CHR(47);
     BufferString[5,len+1]:=00C;
  END;
  RefreshGList(ADR(GadgetFeldListe[pathTextGadget]),window,NIL,1);  
END BackupPfad;

PROCEDURE Clear;
BEGIN
  IF projectFlag THEN 
     Invers(ADR(GadgetFeldListe[projectGadget]));
     Project;
  END;
   
  OptionenString[4]:=("-qx");        BufferString[3]:=("");
  OptionenString[2]:=("-dfnqrsv");   BufferString[1]:=("");
  BufferString[5]:=("df1:");         OptionenString[6]:=("-br");
  BufferString[7]:=("");             OptionenString[0]:=("-b");
  BufferString[9]:=("");
  SystemString[0]:=("m2emacs"); SystemString[1]:=("m2c");
  SystemString[2]:=("m2l");     SystemString[3]:=("m2project");
  SystemString[4]:=("m2:");
  RefreshGList(ADR(GadgetFeldListe[fileTextGadget]),window,NIL,8);
  NewDir(TRUE);
END Clear;

PROCEDURE StartDefMaker;
BEGIN
  PrintStatus("Aktiviere DefMaker !");
    Copy(DummyStr,"run "); Concat(DummyStr,SystemString[4]);
    Concat(DummyStr,"ModuleTool ");
    Concat(DummyStr,BufferString[9]); Concat(DummyStr,BufferString[3]);
  PrintDosErr(Executeing(DummyStr));
END StartDefMaker;

BEGIN
END m2MakerRoutines.

