(******************************************************************************
*                                                                             *
*    Programmname:  RequesterWindow                                           *
*                                                                             *
*    Stand:         05.11.89                            Uhrzeit:  20:33:16    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.1         () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(*(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)*)
IMPLEMENTATION MODULE RequesterWindow;

FROM Arts             IMPORT Assert;
FROM SYSTEM           IMPORT ADDRESS,ADR,CAST,LONGSET,WORD,SHIFT;
FROM Intuition        IMPORT ActivationFlags,ActivationFlagSet,AddGadget,
                             AddGList,boolGadget,Border,BorderPtr,CloseWindow,
                             Gadget,GadgetFlags,GadgetFlagSet,GadgetPtr,
                             IDCMPFlags,IDCMPFlagSet,IntuiMessagePtr,IntuiText,
                             IntuiTextPtr,NewWindow,OpenWindow,PrintIText,
                             RefreshGadgets,ScreenFlags,ScreenFlagSet,strGadget,
                             StringInfo,WindowFlags,WindowFlagSet,WindowPtr;
FROM Exec             IMPORT AllocMem,AvailMem,CloseDevice,DoIO,FreeMem,GetMsg,
                             MemReqs,MemReqSet,MsgPortPtr,OpenDevice,ReplyMsg,
                             Task,TaskPtr,WaitPort,FindTask;
FROM ExecSupport      IMPORT CreateExtIO,CreatePort,CreateTask,DeleteExtIO,
                             DeletePort;
FROM Graphics         IMPORT DrawModeSet,jam1,jam2,Move,RastPortPtr,SetAPen,
                             SetBPen,SetDrMd,Text;
FROM Timer            IMPORT addRequest,IOTimer,IOTimerPtr,timerName,vBlank;
FROM TimerSupport     IMPORT MakeDateString,MakeTimeString;
FROM Str              IMPORT Concat,Copy,Length;
FROM StringSupport    IMPORT StringStr,ValStr;
FROM FileSystem       IMPORT Close,File,Lookup,ReadChar,Response,WriteChar;
FROM Dos              IMPORT CreateProc,DeleteFile,ProcessPtr,Rename;
FROM m2Maker          IMPORT BufferString,GadgetFeldListe,GadgetNamen,
                             MemoryTask,OptionenString,Rahmen,SystemString,
                             window,win;
FROM m2MakerRoutines  IMPORT Block,Invers,PrintStatus;
FROM DirectorySupport IMPORT NewDir;
FROM IntuitionSupport IMPORT SetBorder,SetBorderKoord,SetGadget,SetInfo,
                             SetIText,SetWindow;

CONST version = " m2Maker V1.37 ";

PROCEDURE ShowRequest(titleptr : ADDRESS;
                      x,y,w,h  : INTEGER;
                      textptr  : IntuiTextPtr;
                      gadgptr  : GadgetPtr;
                      cancel   : BOOLEAN): BOOLEAN;

CONST action = ActivationFlagSet{gadgImmediate,relVerify};                  
VAR wind       : NewWindow;
    windowptr  : WindowPtr;
    Auswahl    : GadgetPtr;
    ptr        : IntuiTextPtr;
    msg        : IntuiMessagePtr;
    response   : BOOLEAN;
    code       : CARDINAL;
    class      : IDCMPFlagSet;
    pos        : INTEGER;
    bordptr    : BorderPtr;
    Text       : ARRAY [0..1] OF IntuiText;
    Gadgets    : ARRAY [0..1] OF Gadget;
    Rahmen     : Border;
    BorderKoord: ARRAY [0..9] OF INTEGER;
  
BEGIN
  ptr:=SetIText(Text[0],ADR("  OK  "),2,1,1,2,jam2);
  ptr:=SetIText(Text[1],ADR("CANCEL"),2,1,1,2,jam2);
  
  SetWindow(wind,x,y,w,h,0,1,IDCMPFlagSet{gadgetUp,closeWindow},
            WindowFlagSet{windowDepth,activate,windowActive,windowClose,
                          windowRefresh},
            titleptr,NIL,NIL,-1,-1,20,40,ScreenFlagSet{wbenchScreen});
  SetGadget(Gadgets[0],20,-18,50,10,GadgetFlagSet{gRelBottom},
            action,boolGadget,ADR(Rahmen),ADR(Text[0]),NIL,0);
  SetGadget(Gadgets[1],w-70,-18,50,10,GadgetFlagSet{gRelBottom},
            action,boolGadget,ADR(Rahmen),ADR(Text[1]),NIL,1);
  bordptr:=SetBorder(Rahmen,-1,-1,2,0,5,jam1,ADR(BorderKoord));
  SetBorderKoord(BorderKoord,Gadgets[0]);
        
  windowptr:=OpenWindow(wind);
    Assert(windowptr # NIL,ADR("Requester nicht geffnet"));
  Block(windowptr^.rPort,1,4,11,w-5,h-3);
  PrintIText(windowptr^.rPort,textptr,0,0);

  IF cancel THEN
     pos:=AddGadget(windowptr,ADR(Gadgets[1]),-1);
  ELSE
     Gadgets[0].leftEdge:=w-70;   
  END;
  pos:=AddGadget(windowptr,ADR(Gadgets[0]),-1); 
  IF (gadgptr # NIL) THEN pos:=AddGList(windowptr,gadgptr,-1,11,NIL) END;  
  RefreshGadgets(windowptr^.firstGadget,windowptr,NIL);  
             
  LOOP
    response:=FALSE;
    WaitPort(windowptr^.userPort);
      msg:=GetMsg(windowptr^.userPort);
      class:=msg^.class;
      Auswahl:=msg^.iAddress;
    ReplyMsg(msg);
    
    IF (closeWindow IN class) THEN
        response:=FALSE; EXIT;
    ELSIF (gadgetUp IN class) THEN
       CASE Auswahl^.gadgetID OF
         0 : response:=TRUE;  EXIT;
       | 1 : response:=FALSE; EXIT;
       ELSE
       END;
    END;           
  END;
  
  CloseWindow(windowptr); windowptr:=NIL;
  RETURN response;
END ShowRequest;

PROCEDURE PrinterRequest(): BOOLEAN;
VAR texte : ARRAY [0..1] OF IntuiText;
    ptr   : IntuiTextPtr;
BEGIN
  ptr:=SetIText(texte[0],ADR('Drucker vorbereiten:'),2,1,16,20,jam1);
  texte[0].nextText:=SetIText(texte[1],
                     ADR('Papier justieren & ON-Line whlen.'),0,1,16,36,jam1);
  RETURN ShowRequest(ADR("Drucker Nachricht"),160,20,320,70,ptr,NIL,TRUE);
END PrinterRequest;

PROCEDURE DeleteDatei;
VAR DummyStr : ARRAY [0..140] OF CHAR;
    erfolg   : BOOLEAN;
    frage    : IntuiText;
BEGIN
  erfolg:=ShowRequest(ADR("Datei lschen:"),160,20,320,70,
        SetIText(frage,ADR("Sind Sie sicher ?"),3,1,66,25,jam2),NIL,TRUE);
  
  IF erfolg THEN      
     Copy(DummyStr,BufferString[9]); Concat(DummyStr,BufferString[3]);
     
     erfolg:=DeleteFile(ADR(DummyStr));
       Concat(DummyStr,".Info");
     erfolg:=DeleteFile(ADR(DummyStr));
     NewDir(FALSE);
  END;   
END DeleteDatei;

PROCEDURE RenameDatei;
VAR erfolg   : BOOLEAN;
    gadg     : Gadget;
    text     : IntuiText;
    textptr  : IntuiTextPtr;  
    rahmen   : Border;
    bordptr  : BorderPtr;
    bordkoor : ARRAY [0..9] OF INTEGER;
    info     : StringInfo;
    String   : ARRAY [0..1],[0..30] OF CHAR;
    DummyStr : ARRAY [0..1],[0..110] OF CHAR;
BEGIN
  bordptr:=SetBorder(rahmen,-1,-1,2,0,5,jam2,ADR(bordkoor));           
  SetInfo(info,ADR(String[0]),ADR(String[1]),0,31,0);
  SetGadget(gadg,40,35,242,8,GadgetFlagSet{},
             ActivationFlagSet{relVerify,gadgImmediate,toggleSelect},
             strGadget,bordptr,NIL,ADR(info),2);
  SetBorderKoord(bordkoor,gadg);
  Copy(String[0],BufferString[3]);     Copy(DummyStr[0],BufferString[9]);
  Copy(DummyStr[1],BufferString[9]); Concat(DummyStr[0],BufferString[3]);
  
  textptr:=SetIText(text,ADR("Geben Sie den neuen Namen ein:"),2,1,40,22,jam2);
  IF ShowRequest(ADR("Datei umbenennen:"),160,20,320,70,textptr,ADR(gadg),
                                                                   TRUE) THEN
     Concat(DummyStr[1],String[0]);
     erfolg:=Rename(ADR(DummyStr[0]),ADR(DummyStr[1]));
       Concat(DummyStr[0],".info");
       Concat(DummyStr[1],".info");
     erfolg:=Rename(ADR(DummyStr[0]),ADR(DummyStr[1]));
     NewDir(FALSE); 
  END;       
END RenameDatei;

PROCEDURE Printer;
VAR texte       : ARRAY [0..4] OF IntuiText;
    Gadgs       : ARRAY [0..1] OF Gadget;
    Infos       : ARRAY [0..1] OF StringInfo;
    BorderKoord : ARRAY [0..9] OF INTEGER;
    ZahlenString: ARRAY [0..3],[0..10] OF CHAR;
    GadgetRahmen: Border;
    bptr        : BorderPtr;
    ptr         : IntuiTextPtr;
    proc        : ProcessPtr;
    DummyStr    : ARRAY [0..140] OF CHAR; 
    
CONST actions       = ActivationFlagSet{relVerify,gadgImmediate,toggleSelect,
                                        longint};
      gadgetFlaggen = GadgetFlagSet{};
      eol = 12C;
      
  PROCEDURE Drucken;
  VAR in,out : File;
      char   : CHAR;
      prt    : ARRAY [0..4] OF CHAR;
      von,bis,
      zeile  : INTEGER;
  BEGIN
     von:=ValStr(ZahlenString[0]); bis:=ValStr(ZahlenString[2]);
     IF (von < 1) THEN von:=1 END; bis:=ABS(bis); zeile:=0;
     
     prt:=("prt:"); 
     Lookup(in,DummyStr,10240,FALSE);
     IF (in.res = done) THEN
        Lookup(out,prt,10240,TRUE);
        IF (out.res = done) THEN
           WHILE NOT in.eof DO
             ReadChar(in,char); IF (char = eol) THEN INC(zeile) END;
             IF (zeile >= von-1) AND (zeile <= bis-1) THEN
                 WriteChar(out,char); 
             END;
           END;     
        END;
        Close(out);
     END;
     Close(in);        
  END Drucken;
    
PROCEDURE CreateFunctionProc(name      : ADDRESS;
                             pri       : LONGINT;
                             function  : ADDRESS;
                             stacksize : INTEGER): ProcessPtr;

TYPE HelpSegPtr = POINTER TO HelpSeg;
     HelpSeg    = RECORD
                    Len,
                    Next  : LONGINT;
                    OCode : WORD;
                    FAddr : ADDRESS;
                  END;
VAR taskptr : TaskPtr;
    portPtr : MsgPortPtr;
    procPtr : ProcessPtr;
    Segment : LONGINT;
    HSeg    : HelpSegPtr;
    adr     : ADDRESS;
BEGIN

  adr:=AllocMem(SIZE(HelpSeg),MemReqSet{public});
  IF (adr # NIL) THEN
     HSeg:=CAST(HelpSegPtr,adr);
     WITH HSeg^ DO
       Len:=SIZE(HelpSeg);
       Next:=NIL;
       OCode:=04EF9H;
       FAddr:=ADR(function);
     END;
     Segment:=SHIFT(HSeg^.Next,-2);
     portPtr:=CreateProc(name,pri,Segment,stacksize);
     IF (portPtr # NIL) THEN
        procPtr:=CAST(ProcessPtr,(CAST(LONGINT,portPtr)
                                - CAST(LONGINT,SIZE(Task))));
        WHILE (FindTask(name) = NIL) DO END;
     END;
  ELSE
     RETURN NIL;
  END;
  FreeMem(adr,SIZE(HelpSeg));  
  RETURN procPtr;
END CreateFunctionProc;

BEGIN
  PrintStatus("Ausdruck des Listings");
  ptr:=SetIText(texte[0],ADR('Drucker vorbereiten:'),2,1,16,20,jam1);
  texte[0].nextText:=SetIText(texte[1],
                     ADR("Papier justieren & ON-Line whlen."),0,1,16,32,jam1);
  texte[1].nextText:=SetIText(texte[2],
                ADR("Bitte die gewnschten Zeilen eingeben"),2,1,16,46,jam1);
  texte[2].nextText:=SetIText(texte[3],ADR("von:"),2,1,16,60,jam1);
  texte[3].nextText:=SetIText(texte[4],ADR("bis:"),2,1,160,60,jam1);

  SetGadget(Gadgs[0],58,60,72,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen),NIL,ADR(Infos[0]),2);
  SetGadget(Gadgs[1],200,60,72,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen),NIL,ADR(Infos[1]),3);
  
  ZahlenString[0]:=("1"); ZahlenString[2]:=("5000");           
  SetInfo(Infos[0],ADR(ZahlenString[0]),ADR(ZahlenString[1]),0,10,0);
  SetInfo(Infos[1],ADR(ZahlenString[2]),ADR(ZahlenString[3]),0,10,0);
  SetBorderKoord(BorderKoord,Gadgs[0]);
  bptr:=SetBorder(GadgetRahmen,-1,-1,2,0,5,jam1,ADR(BorderKoord)); 
  Gadgs[0].nextGadget:=ADR(Gadgs[1]);
  
  IF ShowRequest(ADR("Drucker Nachricht:"),160,20,320,98,
                                        ptr,ADR(Gadgs[0]),TRUE) THEN
     Copy(DummyStr,BufferString[9]); Concat(DummyStr,BufferString[3]);
     (*proc:=CreateFunctionProc(ADR("m2Maker_Print"),0,
                              ADR(Drucken),8024);*)
     Drucken;
  END;
  Invers(ADR(GadgetFeldListe[printGadget]));
END Printer;

PROCEDURE OptionenRequester;
CONST actions       = ActivationFlagSet{relVerify,gadgImmediate,toggleSelect};
      gadgetFlaggen = GadgetFlagSet{};
      
VAR dummys      : ARRAY [0..5],[0..80] OF CHAR;
    Texte       : ARRAY [0..10] OF IntuiText;
    Gadgs       : ARRAY [0..10] OF Gadget;
    Infos       : ARRAY [0..10] OF StringInfo;
    BorderKoord : ARRAY [0..1],[0..9] OF INTEGER;
    GadgetRahmen: ARRAY [0..1] OF Border;
    ptr         : IntuiTextPtr;
    bptr        : BorderPtr;
    bool        : BOOLEAN;
BEGIN
                ptr:=SetIText(Texte[0],ADR('  Editor '),0,0,225,17,jam1);
  Texte[0].nextText:=SetIText(Texte[1],ADR(' Compiler'),0,0,225,29,jam1);
  Texte[1].nextText:=SetIText(Texte[2],ADR('  Linker '),0,0,225,41,jam1);
  Texte[2].nextText:=SetIText(Texte[3],ADR(' Projekt '),2,0,225,53,jam1);  
  Texte[3].nextText:=SetIText(Texte[4],ADR('{-d -bi}')   ,0,0,400,17,jam1);  
  Texte[4].nextText:=SetIText(Texte[5],ADR('{-dfinqrsv}'),0,0,400,29,jam1);  
  Texte[5].nextText:=SetIText(Texte[6],ADR('{-iqx}')     ,0,0,400,41,jam1);  
  Texte[6].nextText:=SetIText(Texte[7],ADR('{-iborst}')  ,0,0,400,53,jam1);
  Texte[7].nextText:=SetIText(Texte[8],ADR('FastLister Verzeichnis:'),
                                            2,0,25,65,jam1);
  Texte[8].nextText:=SetIText(Texte[9],ADR('Systemverzeichnis:'),
                                            2,0,225,65,jam1);
  
  SetGadget(Gadgs[0],310,17,80,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[0]),NIL,ADR(Infos[0]),2);
  SetGadget(Gadgs[1],310,29,80,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[0]),NIL,ADR(Infos[1]),3);
  SetGadget(Gadgs[2],310,41,80,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[0]),NIL,ADR(Infos[2]),4);
  SetGadget(Gadgs[3],310,53,80,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[0]),NIL,ADR(Infos[3]),5);
  SetGadget(Gadgs[4],25,77,184,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[1]),NIL,ADR(Infos[4]),6);
  SetGadget(Gadgs[5],25,17,184,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[1]),NIL,ADR(Infos[5]),7);
  SetGadget(Gadgs[6],25,29,184,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[1]),NIL,ADR(Infos[6]),8);
  SetGadget(Gadgs[7],25,41,184,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[1]),NIL,ADR(Infos[7]),9);
  SetGadget(Gadgs[8],25,53,184,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[1]),NIL,ADR(Infos[8]),10);
  SetGadget(Gadgs[9],225,77,80,8,gadgetFlaggen,
             actions,strGadget,ADR(GadgetRahmen[0]),NIL,ADR(Infos[9]),11);

  Gadgs[0].nextGadget:=ADR(Gadgs[1]);
  Gadgs[1].nextGadget:=ADR(Gadgs[2]);
  Gadgs[2].nextGadget:=ADR(Gadgs[3]);
  Gadgs[3].nextGadget:=ADR(Gadgs[4]);
  Gadgs[4].nextGadget:=ADR(Gadgs[5]);
  Gadgs[5].nextGadget:=ADR(Gadgs[6]);
  Gadgs[6].nextGadget:=ADR(Gadgs[7]);
  Gadgs[7].nextGadget:=ADR(Gadgs[8]);
  Gadgs[8].nextGadget:=ADR(Gadgs[9]);
  
  SetInfo(Infos[0],ADR(OptionenString[0]),ADR(OptionenString[1]),0,11,0);
  SetInfo(Infos[1],ADR(OptionenString[2]),ADR(OptionenString[3]),0,11,0);
  SetInfo(Infos[2],ADR(OptionenString[4]),ADR(OptionenString[5]),0,11,0);
  SetInfo(Infos[3],ADR(OptionenString[6]),ADR(OptionenString[7]),0,11,0);
  SetInfo(Infos[4],ADR(BufferString[11]),ADR(BufferString[10]),  0,79,0);
  SetInfo(Infos[5],ADR(SystemString[0]),ADR(dummys[0]),0,79,0);
  SetInfo(Infos[6],ADR(SystemString[1]),ADR(dummys[1]),0,79,0);
  SetInfo(Infos[7],ADR(SystemString[2]),ADR(dummys[2]),0,79,0);
  SetInfo(Infos[8],ADR(SystemString[3]),ADR(dummys[3]),0,79,0);
  SetInfo(Infos[9],ADR(SystemString[4]),ADR(dummys[4]),0,79,0);
 
  SetBorderKoord(BorderKoord[0],Gadgs[0]);
  SetBorderKoord(BorderKoord[1],Gadgs[4]);
  bptr:=SetBorder(GadgetRahmen[0],-1,-1,3,0,5,jam1,ADR(BorderKoord[0]));  
  bptr:=SetBorder(GadgetRahmen[1],-1,-1,2,1,5,jam2,ADR(BorderKoord[1]));
  
  bool:=ShowRequest(ADR("m2Maker Optionen:"),60,20,500,95,ptr,
                    ADR(Gadgs[0]),FALSE);
END OptionenRequester;

PROCEDURE InfoRequester;
VAR  ptr  : IntuiTextPtr;
     Texte: ARRAY [0..7] OF IntuiText;
     bool : BOOLEAN; 
BEGIN
   ptr:=SetIText(Texte[0],ADR("Der"),2,0,25,20,jam1);
   Texte[0].nextText:=SetIText(Texte[1],
              ADR(version),0,0,57,20,jam1); 
   Texte[1].nextText:=SetIText(Texte[2],
              ADR('ist "Shareware".'),2,0,185,20,jam1); 
   Texte[2].nextText:=SetIText(Texte[3],
    ADR('Wem dieses Programm zusagt, berweise mir bitte'),2,0,25,32,jam1); 
   Texte[3].nextText:=SetIText(Texte[4],
    ADR('DM 20 ,- (oder mehr ...) auf mein Konto:'),2,0,25,44,jam1); 
   Texte[4].nextText:=SetIText(Texte[5],
    ADR(' Ko.Nr.: 14561514'),0,0,190,56,jam1); 
   Texte[5].nextText:=SetIText(Texte[6],
    ADR('Stadtsparkasse Hannover  BLZ 250 501 80'),0,0,25,66,jam1);
   Texte[6].nextText:=SetIText(Texte[7],
    ADR('Copyright by Thomas Stolze    Nov. 1989'),2,0,50,78,jam1);
     
  
  bool:=ShowRequest(ADR("m2Maker Info:"),80,20,480,102,ptr,NIL,FALSE);  
END InfoRequester;

PROCEDURE WriteHeadLine;
VAR msgTimerPort : MsgPortPtr;
    adrIOTimer   : IOTimerPtr; 
    wind         : NewWindow;
    
  PROCEDURE WriteMemory;
    PROCEDURE freeMemory(memory : MemReqSet): INTEGER;
    VAR bytes : LONGINT;
    BEGIN
      bytes:=AvailMem(memory);
      RETURN bytes DIV 1024;
    END freeMemory;
    
    PROCEDURE Print(text : ARRAY OF CHAR; rport : RastPortPtr;
                                      fPen,bPen : INTEGER;
                                      drawM     : DrawModeSet;
                                      xpos,ypos : INTEGER);
    BEGIN
      SetAPen(rport,fPen); SetBPen(rport,bPen); SetDrMd(rport,drawM);
      Move(rport,xpos,ypos);
      Text(rport,ADR(text),Length(text));
    END Print;
 
  VAR print : ARRAY [0..10] OF CHAR;
      Title : ARRAY [0..40] OF CHAR;
      mem   : INTEGER;
  BEGIN
    MakeDateString(print); Title:=("  ");       Concat(Title,print);
    MakeTimeString(print); Concat(Title,"   "); Concat(Title,print); 
    mem:=freeMemory(MemReqSet{fast});
      Concat(Title,'    F:'); StringStr(print,mem,4);
      Concat(Title,print);
    mem:=freeMemory(MemReqSet{chip});
      Concat(Title,'K C:'); StringStr(print,mem,4);
      Concat(Title,print); Concat(Title,'K  ');
    Print(version,win^.rPort,3,1,jam2,0, 7);
    Print(Title  ,win^.rPort,2,1,jam2,118,7); 
  END WriteMemory;
                
BEGIN
    SetWindow(wind,30,0,500,10,0,1,IDCMPFlagSet{},
            WindowFlagSet{windowDepth,windowDrag,noCareRefresh},
            NIL,NIL,NIL,0,0,0,0,ScreenFlagSet{wbenchScreen});
  win:=OpenWindow(wind);
  
  IF (win # NIL) THEN
     msgTimerPort:=CreatePort(NIL,0);
     adrIOTimer:=CreateExtIO(msgTimerPort,SIZE(IOTimer));
     OpenDevice(ADR(timerName),vBlank,adrIOTimer,LONGSET{});
  
     LOOP 
       adrIOTimer^.node.command:=addRequest;
       adrIOTimer^.time.secs:=1;
       adrIOTimer^.time.micro:=0;
  
      DoIO(adrIOTimer);
        IF (window = NIL) THEN
           EXIT;
        ELSE 
           WriteMemory;
        END;
     END;
  
    CloseDevice(adrIOTimer);
    DeleteExtIO(adrIOTimer);
    DeletePort(msgTimerPort);
    CloseWindow(win);
    MemoryTask:=NIL;
  END;  
END WriteHeadLine;

PROCEDURE InstallTimerTask(): TaskPtr;
VAR task : TaskPtr;
BEGIN
 task:=CreateTask(ADR("m2Maker_TimerTask"),0,ADR(WriteHeadLine),2024);
 RETURN task;
END InstallTimerTask;

BEGIN
END RequesterWindow.

