(*---------------------------------------------------------------------------
   :Program.    Process.mod
   :Contants.   Export a Procedure who starts Procedures as Processes
   :Remark.     Ported from C to Modula-2
   :History.    C-Edition by Arno Glzer
   :History.    V1.0, after spending a lot of time by meditation
   :History.    V2.1, Markus Peuckert, November 89
   :Author.     Markus Peuckert
   :Address.    Schtzenstr. 50, D-3550 Marburg, West-Germany,
   :Copyright.  PD
   :Language.   Modula-2
   :Translator. M2Amiga V3.2d
---------------------------------------------------------------------------*)

IMPLEMENTATION MODULE Process;

FROM Arts       IMPORT  Assert;
FROM SYSTEM     IMPORT  ADDRESS, ADR, SHIFT;
FROM Dos        IMPORT  Process, ProcessPtr, CreateProc;
FROM Exec       IMPORT  Byte, MsgPortPtr, TaskPtr, Task, FindTask;
FROM Heap       IMPORT  AllocMem, Deallocate;


PROCEDURE CreateFuncProcess (Name : ARRAY OF CHAR; pri, stack : LONGINT;
                                func : ADDRESS) : ADDRESS;

TYPE    HelpSeg         = RECORD
                                Len, Next       : LONGINT;
                                OCode           : INTEGER;
                                FAddr           : ADDRESS
                          END;

VAR     Prior           : Byte;
        Segment         : LONGINT;
        Proc            : ProcessPtr;
        TaskP           : TaskPtr;
        HSeg            : POINTER TO HelpSeg;
        Port            : MsgPortPtr;

BEGIN
 TaskP := NIL;  Port := NIL;
 Prior := TaskP^.node.pri;
 IF ((pri - Prior) < 0) THEN pri:=Prior END;
 AllocMem (HSeg, SIZE(HelpSeg), FALSE);
 Assert (HSeg#NIL, ADR("Kein Speicher fr Segment"));
 HSeg^.Len := SIZE (HelpSeg);
 HSeg^.Next := 0;
 HSeg^.OCode := 04EF9H;
 HSeg^.FAddr := func;
 Segment := LONGINT (SHIFT (ADR(HSeg^.Next), -2));
 Port := CreateProc (ADR(Name), pri, Segment, stack);
(* Ab hier luft der neue Proze *)
 IF Port#NIL THEN
  Proc := ProcessPtr (LONGCARD (Port) - LONGCARD (SIZE (Task)));
  WHILE (FindTask (ADR(Name))=NIL) DO END
 END;
 Deallocate (HSeg);
 Assert (Proc#NIL, ADR("Kein neuer Proze gestartet !"));
 RETURN Proc
END CreateFuncProcess;


BEGIN

END Process.
