(* Written by Urs Pntener *)
(* on Amiga 2000 with M2-Amiga *)
(* 14.2.89 *)
             
MODULE Wordsearch ;

FROM   FileSystem IMPORT Response ;
IMPORT FileSystem ;
IMPORT InOut      ;
IMPORT Strings    ;

TYPE  Name                                   = ARRAY [0..100] OF CHAR ;
     
VAR   File                                         : FileSystem.File ;
      Char                                         : CHAR ;
      InputFileName,Word                           : Name ;
      Field                                        : ARRAY [0..10] OF Name ;
      Index,Line,WordIndex,i,Left,Right,Middle,N   : INTEGER ;
      Mark                                         : BOOLEAN ;
     
CONST Space              = 40C ;
      EOL                = 12C ;

PROCEDURE InitTabel ;
(* The KeyWords *)

  BEGIN
    N := 11 ;
    Field[00] := "2#BY" ;
    Field[01] := "3#AND" ;
    Field[02] := "3#DIV" ;
    Field[03] := "4#CASE" ;
    Field[04] := "4#CHAR" ;
    Field[05] := "5#ARRAY" ;
    Field[06] := "5#BEGIN" ;
    Field[07] := "5#CONST" ;
    Field[08] := "6#BITSET" ;
    Field[09] := "7#BOOLEAN " ;
    Field[10] := "8#CARDINAL" ;
  END InitTabel ;

PROCEDURE Wordlength ;
(* Prepare a Word for compare *)

  VAR  help1 : CARDINAL ;
       help2 : CHAR ;
       help3 : ARRAY [0..1] OF CHAR ;

  BEGIN (* Wordlength *)
  
       (* A big RABBIT out of my hat !!!!!! *)
       help1 := (ORD(WordIndex)+48) ;
       (* Have you seen him ? *)

       help2 := CHR(help1) ;
       help3[0] := help2 ;
       
       (* I need a sign to fill the Array *)
       help3[1] := "#" ;
                 
       Strings.Delete(Word,WordIndex+1,2) ;
       Strings.Insert(Word,0,help3) ;
       INC(WordIndex,2) ;
  END Wordlength ;
          
PROCEDURE FetchChar;
(* Get the Chars from Input-Text-File *)

  BEGIN
    FileSystem.SetPos(File,Index) ;
    FileSystem.ReadChar(File,Char) ;
    INC(Index) ;
  END FetchChar ; 
  
PROCEDURE Compare;
(* Compare a Word from Text with the KeyWords from Field *)
(* With Bin. Search *)

  BEGIN
    Left := 0 ;
    Right := N ;
    WHILE Left < Right DO
      Middle := (Left+Right) DIV 2;
      i := 0;
      WHILE (Field[Middle,i] = Word[i]) AND (Word[i] <> 0C) DO 
        INC(i) ;
      END (* WHILE *) ;
      IF Field[Middle,i] < Word[i] THEN 
        Left := Middle+1 ;
      ELSE 
        Right := Middle ; 
      END (* IF *) ;
    END (* WHILE *) ;
    IF Right < N THEN
      i := 0 ;
      WHILE (Field[Right,i] = Word[i]) AND (Word[i] <> 0C) DO 
        INC(i) ;
        IF (Word[i] = 0C) THEN
          Strings.Delete(Word,0,2) ;
          InOut.WriteString(" Line,KeyWord : ") ;
          InOut.WriteInt(Line,4) ;
          InOut.WriteString(" ,  ") ;
          InOut.WriteString(Word) ;
          InOut.WriteLn ;
        END (* IF *) ;
      END (* WHILE *) ;
    END (* IF *) ;
    
  END Compare ;
        
BEGIN (* Wordsearch *)      
  
  (* Getting some Infos from the User *)
  WHILE (Strings.Length(InputFileName) = 0) DO 
      InOut.WriteString ("InputFileName: ") ;
      InOut.ReadString(InputFileName) ;
  END (* WHILE *) ;
  
  (* Open the Input-Text-File *)
  FileSystem.Lookup(File,InputFileName,0,FALSE) ;
    IF (File.res  = notFound) THEN
      InOut.WriteString("File not found  !") ;
      HALT ;
    END (* IF *) ;
  
  (* Preparation *)
  Index     := 0 ;
  Line      := 1 ;
  FOR i := 0 TO 100 DO
    Word[i] := Space ;
  END (* FOR *) ;  
  WordIndex := 0 ;
  InitTabel ;
  Mark := FALSE ;
  
  
  (* Main LOOP *)

  FetchChar ;

  WHILE ( NOT(File.eof)) DO
  
    IF (Char=Space) OR (Char=EOL) THEN
      IF (Char=EOL) THEN
        INC(Line) ;
      END (* IF *) ;
      IF Mark = TRUE THEN
         Wordlength ;
         Word[WordIndex] := 0C ;
         Compare ;
        FOR i := 0 TO 100 DO
          Word[i] := Space ;
        END (* FOR *) ;
        WordIndex := 0 ;
        Mark := FALSE ;
      END (* IF *) ;  
    ELSE
      Word[WordIndex] := Char ;
      INC(WordIndex) ;     
      Mark := TRUE ;
    END (* IF *) ;  
    
    FetchChar ;
    
  END (* WHILE *) ;  
  
  InOut.WriteString(" End of Search. ") ;  
  
  (* Closing the Files *)
  FileSystem.Close(File) ;

END Wordsearch .
