(**********************************************************************

    :Program.  	 EQGadgets.mod
    :Imports.    IntuiStruct V1.3 [bne], IDCMP V 1.1 [bne]
    :Imports.    Version V1.0 [gs]
    :Author.   	 Gary Struhlik
    :shortcut. 	 [gs]
    :Version.  	 1.0
    :Date.     	 09.10.89
    :Copyright.  Public Domain
    :Language. 	 Modula-II
    :Translator. M2Amiga AMSoft V3.2d
    :Contents.	 Enthlt die  grafische  Benutzerschnittstelle  fr das
    :Contents.   Programm 'Ersatzquelle'
  
**********************************************************************)

IMPLEMENTATION MODULE EQGadgets;

FROM Intuition IMPORT NewWindow,  IDCMPFlags, WindowFlags,  ScreenFlags,
		      IDCMPFlagSet, WindowFlagSet, WindowPtr, ScreenFlagSet, 
                      OpenWindow, CloseWindow, IntuiMessagePtr, Gadget,
                      GadgetPtr, boolGadget, AddGadget, RefreshGadgets,
                      ActivationFlags, ActivationFlagSet, GadgetFlags,
                      GadgetFlagSet, Image, SetWindowTitles,DrawImage;
FROM SYSTEM IMPORT ADR,ADDRESS,LONGSET;
FROM IntuiStruct IMPORT StructWindow, StructGadget, StructImage,
                        ImageEnd, Long, AllocProc,DeallocProc,FreeImage;
FROM Graphics IMPORT DrawModes, DrawModeSet, SetRast;
FROM Exec IMPORT MsgPortPtr;
FROM IDCMP IMPORT GetIntuiMessage;
FROM InputEvent IMPORT QualifierSet;
FROM InOut IMPORT WriteLn, WriteString;
FROM Heap IMPORT AllocMem, Deallocate;
FROM Version IMPORT ImgPtr, Imgwidth, Imgheight, Imgdepth;

VAR
	GadgetID : INTEGER;
	NewGadget : ARRAY [0..31] OF Gadget;
	msgadr : GadgetPtr; 
	nw : NewWindow;
	window : WindowPtr;
	Class : IDCMPFlags;
	Code : CARDINAL;
	x,y : INTEGER;
	Qualf : QualifierSet;
	ItemAdr : ADDRESS;
	ImageDaten : ARRAY [0..31] OF Image;
	i : CARDINAL;
        SelectGadget : ARRAY[0..1] OF Gadget;
        SelectImage  : ARRAY[0..1] OF Image;
        Autor : Image;

PROCEDURE MaleGadgets;
BEGIN
	StructWindow(nw, 0, 217, 639, 39, 0, 1, 
	             IDCMPFlagSet{gadgetUp},
	             WindowFlagSet{windowDepth, activate,windowDrag},
	             NIL, NIL, 
	             ScreenFlagSet{wbenchScreen} );

	window:=OpenWindow(nw);
	IF window=NIL THEN HALT END;

	SetRast(window^.rPort,1); (* Hintergrund des Befehlfensters wei *)
	SetWindowTitles(window,ADR("   Befehle   "),NIL);
	                          (* Window Titel schreiben *)
	RefreshGadgets(window^.firstGadget,window,NIL);
		
	WITH Autor DO
	  leftEdge:=0; topEdge:=0; width:=Imgwidth; height:=Imgheight;
	  depth:=Imgdepth; imageData:=ImgPtr; planePick:=2;
	  planeOnOff:=1 ; nextImage:=NIL
	END;  
	
	DrawImage(window^.rPort, ADR(Autor),515,10); (* Grafik mit Versions- *)
	                                             (* nummer zeichnen      *)
	StructImage( ImageDaten[0], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000100000000000000100000000L);
	Long(00011111100000000000000111111000L);
	Long(00000000100000000000000100000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000011110000011110000000000L);
	Long(00000000010001000010001000000000L);
	Long(00000000010001000010001000000000L);
	Long(00000000011110000011110000000000L);
	Long(00000000010001000010001000000000L);
	Long(00000000010000100010000100000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[0], 2, 10, 32, 14, GadgetFlagSet{gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	              ADR(ImageDaten[0]) , NIL , LONGSET{}, 0,NIL );
	GadgetID:=AddGadget(window, ADR(NewGadget[0]), -1);
	
	StructImage( ImageDaten[1], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000100000000000000100000000L);
	Long(00011111100000000000000111111000L);
	Long(00000000100000000000000100000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000011110000011110000000000L);
	Long(00000000010001000010001000000000L);
	Long(00000000010001000010001000000000L);
	Long(00000000011110000011110000000000L);
	Long(00000000010001000010000000000000L);
	Long(00000000010000100010000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[1], 2, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[1]), NIL ,LONGSET{}, 1,ADR(NewGadget[0]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[1]), -1);

	StructImage( ImageDaten[2], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000100000000000000100000000L);
	Long(00011111100000000000000111111000L);
	Long(00000000100000000000000100000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000010000100011110000000000L);
	Long(00000000001001000010001000000000L);
	Long(00000000000110000010001000000000L);
	Long(00000000000110000011110000000000L);
	Long(00000000001001000010001000000000L);
	Long(00000000010000100010000100000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[2], 34, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	            ADR(ImageDaten[2]), NIL , LONGSET{}, 2,ADR(NewGadget[1]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[2]), -1);

	StructImage( ImageDaten[3], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000100000000000000100000000L);
	Long(00011111100000000000000111111000L);
	Long(00000000100000000000000100000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000010000100011110000000000L);
	Long(00000000001001000010001000000000L);
	Long(00000000000110000010001000000000L);
	Long(00000000000110000011110000000000L);
	Long(00000000001001000010000000000000L);
	Long(00000000010000100010000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[3], 34, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	            ADR(ImageDaten[3]), NIL , LONGSET{}, 3,ADR(NewGadget[2]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[3]), -1);

	StructImage( ImageDaten[4], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000111111111111111100000000L);
	Long(00011111111111111111111111111000L);
	Long(00000000111111111111111100000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000010000000011110000000000L);
	Long(00000000010000000010001000000000L);
	Long(00000000010000000010001000000000L);
	Long(00000000010000000011110000000000L);
	Long(00000000010000000010001000000000L);
	Long(00000000011111100010000100000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[4], 66, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[4]) , NIL , LONGSET{}, 4,ADR(NewGadget[3]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[4]), -1);
	
	StructImage( ImageDaten[5], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000111111111111111100000000L);
	Long(00011111111111111111111111111000L);
	Long(00000000111111111111111100000000L);
	Long(00000000111111111111111100000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000010000000011110000000000L);
	Long(00000000010000000010001000000000L);
	Long(00000000010000000010001000000000L);
	Long(00000000010000000011110000000000L);
	Long(00000000010000000010000000000000L);
	Long(00000000011111100010000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[5], 66, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[5]), NIL ,LONGSET{}, 5,ADR(NewGadget[4]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[5]), -1);
	
	StructImage( ImageDaten[6], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00111111111111001111111111110000L);
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00000001111000000011110000000000L);
	Long(00000010000100000010001000000000L);
	Long(00000010000000000010001000000000L);
	Long(00000010000000000011110000000000L);
	Long(00000010000100000010001000000000L);
	Long(00000001111000000010000100000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[6], 98, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[6]) , NIL , LONGSET{}, 6,ADR(NewGadget[5]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[6]), -1);
	
	StructImage( ImageDaten[7], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00111111111111001111111111110000L);
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00000000000011001100000000000000L);
	Long(00000001111000000011110000000000L);
	Long(00000010000100000010001000000000L);
	Long(00000010000000000010001000000000L);
	Long(00000010000000000011110000000000L);
	Long(00000010000100000010000000000000L);
	Long(00000001111000000010000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[7], 98, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[7]), NIL ,LONGSET{}, 7,ADR(NewGadget[6]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[7]), -1);

	StructImage( ImageDaten[8], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000011111111000000000000L);
	Long(00000000011100000000111000000000L);
	Long(00000001100000000000000110000000L);
	Long(00000010000000001110011101000000L);
	Long(00000100010000101001010000100000L);
	Long(00000100010000101110011100010000L);
	Long(00001000010000101001010000010000L);
	Long(11111000010000101001011100011111L);
	Long(00000100010000100000000000010000L);
	Long(00000100001111001000100000100000L);
	Long(00000010000000001000100001000000L);
	Long(00000001100000001000100110000000L);
	Long(00000000011100000000111000000000L);
	Long(00000000000011111111000000000000L);
	ImageEnd;
	StructGadget( NewGadget[8],130, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[8]), NIL ,LONGSET{}, 8,ADR(NewGadget[7]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[8]), -1);

	StructImage( ImageDaten[9], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000011000011000000000000L);
	Long(00000000011100000000111000000000L);
	Long(00000001100000000000000110000000L);
	Long(00000010000000001110011101000000L);
	Long(00000100011111001001010000100000L);
	Long(00000100000100001110011100010000L);
	Long(00001000000100001001010000010000L);
	Long(11111000000100001001011100011111L);
	Long(00000100000100000000000000010000L);
	Long(00000100011111001000100000100000L);
	Long(00000010000000001000100001000000L);
	Long(00000001100000001000100110000000L);
	Long(00000000011100000000111000000000L);
	Long(00000000000011000011000000000000L);        
	ImageEnd;
	StructGadget( NewGadget[9],130, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[9]), NIL ,LONGSET{}, 9,ADR(NewGadget[8]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[9]), -1);
	
	StructImage( ImageDaten[10], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000011111111000000000000L);
	Long(00000000011100000000111000000000L);
	Long(00000001100000000000000110000000L);
	Long(00000010000000000101101101000000L);
	Long(00000100010000100101010100100000L);
	Long(00000100010000100101000100010000L);
	Long(00001000010000100101000100010000L);
	Long(11111000010000100000011000011111L);
	Long(00000100010000100001100000010000L);
	Long(00000100001111000110000000100000L);
	Long(00000010000000001111111001000000L);
	Long(00000001100000000000000110000000L);
	Long(00000000011100000000111000000000L);
	Long(00000000000011111111000000000000L);
	ImageEnd;
	StructGadget( NewGadget[10],162, 10, 32, 14, GadgetFlagSet{ gadgImage,
	                  gadgHImage, gadgHBox },
	              ActivationFlagSet{ relVerify,gadgImmediate},
	               boolGadget,
	           ADR(ImageDaten[10]), NIL ,LONGSET{}, 10,ADR(NewGadget[9]) );
            
	GadgetID:=AddGadget(window, ADR(NewGadget[10]), -1);

	StructImage( ImageDaten[11], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000011000011000000000000L);
	Long(00000000011100000000111000000000L);
	Long(00000001100000000000000110000000L);
	Long(00000010000000000101101101000000L);
	Long(00000100011111000101010100100000L);
	Long(00000100000100000101000100010000L);
	Long(00001000000100000101000100010000L);
	Long(11111000000100000000011000011111L);
	Long(00000100000100000001100000010000L);
	Long(00000100011111000110000000100000L);
	Long(00000010000000001111111001000000L);
	Long(00000001100000000000000110000000L);
	Long(00000000011100000000111000000000L);
	Long(00000000000011000011000000000000L);	
	ImageEnd;
	StructGadget( NewGadget[11],162, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[11]), NIL ,LONGSET{},11,ADR(NewGadget[10]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[11]), -1);

	StructImage( ImageDaten[12], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00001111111111100111111111110000L);
	Long(01111000000000111100000000011110L);
	Long(00001111111111100111111111110000L);
	Long(00000000000000000000000000000000L);
	Long(00000001000000000011110000000000L);
	Long(00000010100000000010001000000000L);
	Long(00000100010000000011110000000000L);
	Long(00000111110000000010001000000000L);
	Long(00000100010000000010001000000000L);
	Long(00000100010000000011110000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[12],194, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[12]), NIL ,LONGSET{},12,ADR(NewGadget[11]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[12]), -1);

	StructImage( ImageDaten[13], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000010000L);
	Long(00000001111111111100000000101000L);
	Long(00001111000000000111100001000100L);
	Long(00001001111111111100100001111100L);
	Long(00001000000000000000100001000100L);
	Long(01111000000000000000111101000100L);
	Long(00001000000000000000100000000000L);
	Long(00001001111111111100100001111000L);
	Long(00001111000000000111100001000100L);
	Long(00000001111111111100000001111000L);
	Long(00000000000000000000000001000100L);
	Long(00000000000000000000000001111000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[13],194, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[13]), NIL ,LONGSET{},13,ADR(NewGadget[12]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[13]), -1);

	StructImage( ImageDaten[14], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000010000010000011110000000000L);
	Long(00000010000010000100001000000000L);
	Long(00000010000010000100001000000000L);
	Long(00000010000010000100001000000000L);
	Long(00000010000010000100001000000000L);
	Long(00000010000010000100001000000000L);
	Long(00000010000010000100001000000000L);
	Long(00000001111100000011110000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[14],226, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[14]), NIL ,LONGSET{},14,ADR(NewGadget[13]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[14]), -1);

	StructImage( ImageDaten[15], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000001111100000100010000000000L);
	Long(00000000010000000100100000000000L);
	Long(00000000010000000101000000000000L);
	Long(00000000010000000110000000000000L);
	Long(00000000010000000101000000000000L);
	Long(00000000010000000100100000000000L);
	Long(00000000010000000100100000000000L);
	Long(00000001111100000100010000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[15],226, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[15]), NIL ,LONGSET{},15,ADR(NewGadget[14]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[15]), -1);

	StructImage( ImageDaten[16], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000011111111000011111000000000L);
	Long(00000000000010000000100000000000L);
	Long(00000000000100000000100000000000L);
	Long(00000000001000000000100000000000L);
	Long(00000000010000000000100000000000L);
	Long(00000000100000000000100000000000L);
	Long(00000001000000000000100000000000L);
	Long(00000011111111000011111000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[16],258, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[16]), NIL ,LONGSET{},16,ADR(NewGadget[15]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[16]), -1);

	StructImage( ImageDaten[17], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000001000000000000001111110000L);
	Long(00000010100000000000001000001000L);
	Long(00000100010000000000001000001000L);
	Long(00001000001000001000001000001000L);
	Long(00001000001000000110001111110000L);
	Long(00001111111001111111001000001000L);
	Long(00001000001000000110001000001000L);
	Long(00001000001000001000001000001000L);
	Long(00001000001000000000001111110000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[17],258, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[17]), NIL ,LONGSET{},17,ADR(NewGadget[16]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[17]), -1);

	StructImage( ImageDaten[18], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000001000000000000000111110000L);
	Long(00000010100000000000001000001000L);
	Long(00000100010000000000001000000000L);
	Long(00001000001000001000001000000000L);
	Long(00001000001000000110001000000000L);
	Long(00001111111001111111001000000000L);
	Long(00001000001000000110001000000000L);
	Long(00001000001000001000001000001000L);
	Long(00001000001000000000000111110000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[18],290, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[18]), NIL ,LONGSET{},18,ADR(NewGadget[17]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[18]), -1);

	StructImage( ImageDaten[19], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00001111110000000000000011111000L);
	Long(00001000001000000000000100000100L);
	Long(00001000001000010010000100000000L);
	Long(00001000001001100001100100000000L);
	Long(00001111110011111111110100000000L);
	Long(00001000001001100001100100000000L);
	Long(00001000001000010010000100000000L);
	Long(00001000001000000000000100000100L);
	Long(00001111110000000000000011111000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[19],290, 24, 32, 14, GadgetFlagSet{ gadgImage,
	             gadgHImage,gadgHBox },
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[19]), NIL ,LONGSET{},19,ADR(NewGadget[18]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[19]), -1);

	StructImage( ImageDaten[20], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
        Long(00000000000000000000000000000000L);
	Long(00000000000111000000000000000000L);
	Long(00000000111000000000000000000000L);
	Long(00000111000000000000000000000000L);
	Long(00001111111111111111111111110000L);
	Long(00000111000000000000000000000000L);
	Long(00000000111000000000000000000000L);
        Long(00000000000111000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[20],322, 10, 32, 14, GadgetFlagSet{ gadgImage,
	             gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[20]), NIL ,LONGSET{},20,ADR(NewGadget[19]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[20]), -1);

	StructImage( ImageDaten[21], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
        Long(00000000000000000000000000000000L);
	Long(00000000000000000001110000000000L);
	Long(00000000000000000000001110000000L);
	Long(00000000000000000000000001110000L);
	Long(00000111111111111111111111111000L);
	Long(00000000000000000000000001110000L);
	Long(00000000000000000000001110000000L);
        Long(00000000000000000001110000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[21],322, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[21]), NIL ,LONGSET{},21,ADR(NewGadget[20]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[21]), -1);

	StructImage( ImageDaten[22], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000010000000000000000L);
        Long(00000000000000111000000000000000L);
	Long(00000000000000010000000000000000L);
	Long(00000000000000111110000000000000L);
	Long(00000000000001010001000000000000L);
	Long(00000000000010010000100000000100L);
	Long(00111111111111111111111111111110L);
	Long(00000000000000010000100000000100L);
        Long(00000000000000010001000000000000L);
	Long(00000000000000010010000000000000L);
	Long(00000000000000011100000000000000L);
	Long(00000000000000010000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[22],354, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[22]), NIL ,LONGSET{},22,ADR(NewGadget[21]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[22]), -1);

	StructImage( ImageDaten[23], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00010000000000001000010010010000L);
        Long(00111000000000001000010011010000L);
	Long(00010000011000001000010010110000L);
	Long(00010001100100001111010010010000L);
	Long(00011110000010000000000000000000L);
	Long(00010000000001111111111111111000L);
	Long(00010000000000000000000000000000L);
	Long(00010000000000000000000000001000L);
        Long(00011111111111111111111111111100L);
	Long(00000000000000000000000000001000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[23],354, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[23]), NIL ,LONGSET{},23,ADR(NewGadget[22]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[23]), -1);

	StructImage( ImageDaten[24], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00010000000000001000001100011100L);
        Long(00111000000000001000010010100000L);
	Long(00010000011000001000010010100100L);
	Long(00010001100100001111001100011100L);
	Long(00011110000010000000000000000000L);
	Long(00010000000001111111111111111000L);
	Long(00010000000000000000000000000000L);
	Long(00010000000000000000000000001000L);
        Long(00011111111111111111111111111100L);
	Long(00000000000000000000000000001000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[24],386, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[24]), NIL ,LONGSET{},24,ADR(NewGadget[23]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[24]), -1);

	StructImage( ImageDaten[25], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00001000010010000100100000100000L);
	Long(00001100010010000100110001100000L);
	Long(00001010010010000100101010100000L);
	Long(00001010010010000100100100100000L);
	Long(00001001010010000100100000100000L);
	Long(00001001010010000100100000100000L);
	Long(00001000110010000100100000100000L);
	Long(00001000010001111000100000100000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[25],386, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[25]), NIL ,LONGSET{},25,ADR(NewGadget[24]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[25]), -1);

	StructImage( ImageDaten[26], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000011111110011111110000000000L);
	Long(00000010000000010000000000000000L);
	Long(00000010000000010000000000000000L);
	Long(00000011111110011111110000000000L);
	Long(00000010000000010000000000000000L);
	Long(00000010000000010000000000000000L);
	Long(00000010000000010000000000000000L);
	Long(00000011111110011111110000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[26],418, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox },
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	           ADR(ImageDaten[26]), NIL ,LONGSET{},26,ADR(NewGadget[25]) );
	GadgetID:=AddGadget(window, ADR(NewGadget[26]), -1);

	StructImage( SelectImage[1], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
        Long(00000000000000000111111111111000L);
	Long(00000000000000001000000000010000L);
	Long(00000000000000010000000000100000L);
	Long(00000000000000100000000001000000L);
	Long(00000000111111111111111111111100L);
	Long(00000001000011111111111110001100L);
	Long(00000010000111111111111100010100L);
        Long(00000100000000000000000001001000L);
	Long(00001111111111111111111110010000L);
	Long(00001000000000000000000010100000L);
	Long(00001111111111111111111111000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructImage( ImageDaten[27], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00001111111111111111111111111000L);
        Long(00001000000000000000000000001000L);
	Long(00001000111111111111111110001000L);
	Long(00001001000000000000000001001000L);
	Long(00001001000000000000000001001000L);
	Long(00001001000000000000000001001000L);
	Long(00001001000000000000000001001000L);
	Long(00001000111111111111111110001000L);
        Long(00001000000000000000000000001000L);
	Long(00001111111111111111111111111000L);
	Long(00001000000100000000010010101000L);
	Long(00001111111111111111111111111000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;	
	StructGadget( NewGadget[27],418, 24, 32, 14, GadgetFlagSet{ gadgImage
	               (* ,gadgDisabled *),gadgHImage },
	              ActivationFlagSet{ relVerify,gadgImmediate,toggleSelect},
	               boolGadget,
	           ADR(ImageDaten[27]), NIL ,LONGSET{},27,ADR(NewGadget[26]) );
	NewGadget[27].selectRender:=ADR(SelectImage[1]);           
	GadgetID:=AddGadget(window, ADR(NewGadget[27]), -1);

	StructImage( ImageDaten[28], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000111111000011111000010000000L);
	Long(00000100000100100000100010000000L);
	Long(00000100000100100000100010000000L);
	Long(00000100000100100000100010000000L);
	Long(00000111111000100000100010000000L);
	Long(00000100000000100000100010000000L);
	Long(00000100000000100000100010000000L);
	Long(00000100000000100000100010000000L);
	Long(00000100000000100000100010000000L);
	Long(00000100000000011111000011111100L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructImage( SelectImage[0], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000111111000111111000011111000L);
	Long(00000100000100100000000100000100L);
	Long(00000100000100100000000100000000L);
	Long(00000100000100100000000100000000L);
	Long(00000111111000111111000100000000L);
	Long(00000100010000100000000100000000L);
	Long(00000100001000100000000100000000L);
	Long(00000100001000100000000100000000L);
	Long(00000100001000100000000100000100L);
	Long(00000100001000111111000011111000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[28],450, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage},
	              ActivationFlagSet{ relVerify,gadgImmediate,toggleSelect },
	               boolGadget,
	             ADR(ImageDaten[28]),NIL ,LONGSET{},28,ADR(NewGadget[27]));
	NewGadget[28].selectRender:=ADR(SelectImage[0]);             
	GadgetID:=AddGadget(window, ADR(NewGadget[28]), -1);
	
	StructImage( ImageDaten[29], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000001000001000111111000000000L);
	Long(00000001100001001000000100000000L);
	Long(00000001010001001000000000000000L);
	Long(00000001010001000100000000000000L);
	Long(00000001001001000011110000000000L);
	Long(00000001001001000000001000000000L);
	Long(00000001000101000000000100000000L);
	Long(00000001000011001000000100000000L);
	Long(00000001000001000111111000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[29],450, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[29]),NIL,LONGSET{},29,ADR(NewGadget[28]));
	GadgetID:=AddGadget(window, ADR(NewGadget[29]), -1);

	StructImage( ImageDaten[30], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
        Long(00001111100011110010001001110000L);
	Long(00001000010010000011001001001000L);
	Long(00001000010010000011001001000100L);
	Long(00001111100011110010101001000100L);
	Long(00001000000010000010101001000100L);
	Long(00001000000010000010011001001000L);
	Long(00001000000011110010001001110000L);
        Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[30],482, 10, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[30]),NIL,LONGSET{},30,ADR(NewGadget[29]));
	GadgetID:=AddGadget(window, ADR(NewGadget[30]), -1);

	StructImage( ImageDaten[31], 0,0, 32, 14, 1, {1}, {0}, NIL );
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
        Long(00000010000001000010010000000100L);
	Long(00000100100001100010010000000100L);
	Long(00001000010001010010010000000100L);
	Long(00010000001001010010010001000100L);
	Long(00010000001001001010010010100100L);
	Long(00011111111001001010010100010100L);
	Long(00010000001001000110010100010100L);
        Long(00010000001001000110011000001100L);
	Long(00010000001001000010010000000100L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	Long(00000000000000000000000000000000L);
	ImageEnd;
	StructGadget( NewGadget[31],482, 24, 32, 14, GadgetFlagSet{ gadgImage,
	              gadgHImage,gadgHBox},
	              ActivationFlagSet{ relVerify,gadgImmediate },
	               boolGadget,
	             ADR(ImageDaten[31]),NIL,LONGSET{},31,ADR(NewGadget[30]));
	GadgetID:=AddGadget(window, ADR(NewGadget[31]), -1);

	RefreshGadgets(ADR(NewGadget[0]), window, NIL);
END MaleGadgets;

PROCEDURE GadgetAbfrage( VAR Anw : Auswahl; 
                         VAR Druckflag,Ausgabeflag : BOOLEAN );	
BEGIN      	
        GetIntuiMessage( window^.userPort, Class, Code, Qualf, ItemAdr, 
	                  x,y) ;
	 IF (Class=gadgetUp) THEN
	 
	        msgadr:=ItemAdr;
	        CASE msgadr^.gadgetID OF
	          0: Anw:=RR | (* RR ohmscher Widerstand in Reihe *)
	          1: Anw:=RP | (* RP ohmscher Widerstand parallel *)
	          2: Anw:=XR | (* XR Blindwiderstand in Reihe *)
	          3: Anw:=XP | (* XP Blindwiderstand parallel *)
	          4: Anw:=LR | (* LR Induktivitt in Reihe *)
	          5: Anw:=LP | (* LP Induktivitt parallel *)
	          6: Anw:=CR | (* CR Kapazitt in Reihe *)
	          7: Anw:=CP | (* CP Kapazitt parallel *)
	          8: Anw:=U1  | (* U1 Spannungsquelle Betrag oder Realteil *)
	          9: Anw:=I1  | (* I1 Stromquelle Betrag oder Realteil *)
	          10: Anw:=U2 |(* U2 Spannungsquelle Winkel oder Imaginrteil *)
	          11: Anw:=I2 |(* I2 Stromquelle Winkel oder Imaginrteil *)
	          12: Anw:=RS | (* RS A und B in Reihe schalten *)
	          13: Anw:=PS | (* PS A und B parallel schalten *)
	          14: Anw:=U0 | (* U0 den Spannungswert der Ersatzquelle *)
	                        (* ausgeben                              *)
	          15: Anw:=IK | (* IK den Stromwert der Ersatzquelle ausgeben *)
	          16: Anw:=ZI | (* ZI den Widerstandswert der Ersatzquelle    *)
	                        (* ausgeben                                   *)
	          17: Anw:=AnB | (* AnB Speicher A in B sichern *)
	          18: Anw:=AnC | (* AnC Speicher A in C sichern *)
	          19: Anw:=BvC | (* Speicher B und C vertauschen *)
	          20: Anw:=RCK | (* RCK eine Anweisung zurck *)
	          21: Anw:=VOR | (* VOR eine Anweisung vor *)
	          22: Anw:=OK | (* OK Ortskurve *)
	          23: Anw:=BODELIN | (* BODELIN Bodediagramm linear *)
	          24: Anw:=BODELOG | (* BODELOG Bodediagramm logarithmisch *)
	          25: Anw:=NUM | (* NUM numerisch rechnen *)
	          26: Anw:=EE | (* Ende der Bauteilliste *)
	          27: IF Druckflag THEN (* DR Druckerausgabe ein/aus *) 
	                 Druckflag:=FALSE 
	              ELSE Druckflag:=TRUE END; Anw:=DR |
	          28: IF Ausgabeflag THEN (* RECPOL Normal- oder Polarform *)
	                 Ausgabeflag:=FALSE
	              ELSE
	                 Ausgabeflag:=TRUE 
	              END; Anw:=RECPOL |   
	          29: Anw:=NS (* NS neue Schaltung eingeben *) |
	          30: Anw:=PEND (* PEND Programm beenden *) |
	          31: Anw:=ANWAZ  (* ANWAZ alle Anweisungen anzeigen *)
	        END 
	 END ;
END GadgetAbfrage;      

PROCEDURE EntferneGadgets;
BEGIN
	FOR i:=0 TO 31 DO
	  IF ImageDaten[i].imageData<>NIL THEN 
	    FreeImage(ImageDaten[i])
	  END
	END;
	IF SelectImage[0].imageData<>NIL THEN
	   FreeImage(SelectImage[0])
	END;
	IF SelectImage[1].imageData<>NIL THEN
	   FreeImage(SelectImage[1])
	END;	   
	Deallocate(ImgPtr);
	IF window<>NIL THEN CloseWindow(window) END
END EntferneGadgets;

BEGIN
	AllocProc:=AllocMem;
	DeallocProc:=Deallocate
END EQGadgets.
