(*********************************************************************
 *
 *  :Program.    Datenblatt.mod
 *  :Project.    Nahverkehrssystem
 *  :Author.     Ingo Goldak
 *  :Address.    Hohenzollerndamm 8
 *  :Address.    1000 Berlin 31
 *  :Copyright.  PD
 *  :Language.   Modula-II
 *  :Translator. M2Amiga V3.3d
 *  :Imports.    PrinterSupport [AMOK]
 *  :Imports.    Werkzeuge, Hilfsmittel, WindowInOut [Ingo Goldak]
 *  :Contents.   PROCEDUREn fr Menu 'Datenblatt'
 *  :History. V1.0 [Ingo Goldak] 30.03.90
 *
 *********************************************************************)

IMPLEMENTATION MODULE Datenblatt;

FROM SYSTEM IMPORT
     ADR,ADDRESS;
FROM Arts IMPORT
     Assert;
FROM Intuition IMPORT
     WindowPtr,SetWindowTitles;
FROM Graphics IMPORT
     SetRast,SetAPen,SetBPen,Draw,Move;
FROM Dos IMPORT
     FileHandlePtr,Open,Close,Read,Write,Seek,beginning,oldFile;
FROM Strings IMPORT
     Compare,Copy,Insert,Length,Occurs,last;
FROM Conversions IMPORT
     StrToVal,ValToStr;
FROM ASCII IMPORT
     eol;
FROM WindowInOut IMPORT
     input,
     GetChar,WriteWindowString,ReadWindowString,WriteWindowCard,ReadWindowCard;
FROM PrinterSupport IMPORT
     OpenPrinter,ClosePrinter,PrintLine,PrintString,PrintChar,PrintCommand;
FROM Werkzeuge IMPORT
     MAXX,MAXY,
     Names,List,Speichern,Title,
     String,DATENSATZ,FLAGSET,FLAGS,TEXT,DATUM,LISTELEMENT;
FROM Hilfsmittel IMPORT
     SetMessage,ClearMessage,InsertName,SucheDatensatz,LeseDatensatz,
     DisplayBoolean,ReadDatum,CheckDatum;


PROCEDURE SchreibeDatensatz (Window : WindowPtr;
                             Position : CARDINAL;
                             Dir : ARRAY OF CHAR;
                             VAR Daten : DATENSATZ);

VAR File : ARRAY [0..255] OF CHAR;
    Datei : FileHandlePtr;
    Ziel : LONGCARD;
    Fehler,Dummy : LONGINT;

BEGIN
   Copy(File,Dir,0,Length(Dir));
   Insert(File,last,"Bahnhfe");
   Datei:=Open(ADR(File),oldFile);
   Assert(Datei#NIL,ADR("Kann Bahnhof nicht speichern"));
   Ziel:=2+(LONGCARD(SIZE(Daten))*LONGCARD(Position-1));
   Dummy:=Seek(Datei,Ziel,beginning);
   Fehler:=Write(Datei,ADR(Daten),SIZE(Daten));
   IF Fehler<=0
   THEN
      SetMessage(Window," Fehler beim Schreiben ! ");
   END (* IF *);
   Close(Datei);
END SchreibeDatensatz;


PROCEDURE SchreibeNamen (Window : WindowPtr;
                         Dir : ARRAY OF CHAR);

VAR File : String;
    Datei : FileHandlePtr;
    Fehler : INTEGER;

BEGIN
   Copy(File,Dir,0,Length(Dir));
   Insert(File,last,"Bahnhfe");
   Datei:=Open(ADR(File),oldFile);
   Assert(Datei#NIL,ADR("Kann Bahnhofsliste nicht speichern"));
   Fehler:=Write(Datei,ADR(Names),SIZE(Names));
   IF Fehler<=0
   THEN
      SetMessage(Window," Zahl konnte nicht geschrieben werden ! ");
   END (* IF *);
   Close(Datei);
END SchreibeNamen;


PROCEDURE DeleteName (Position : CARDINAL);

VAR Zaehler : CARDINAL;
    Hilf : LISTELEMENT;

BEGIN
   IF Position<Names
   THEN
      FOR Zaehler:=Position TO Names-1 DO
         Hilf:=List[Zaehler+1];
         List[Zaehler]:=Hilf;
      END (* FOR *);
   END (* IF *);
   DEC(Names);
END DeleteName;


PROCEDURE InitDummyDatensatz (Name : TEXT;
                              VAR Daten : DATENSATZ);

BEGIN
   WITH Daten DO
      NamenOben:="";XPosOben:=0;YPosOben:=0;
      Namen:=Name;XPosHier:=0;YPosHier:=0;
      NamenUnten:="";XPosUnten:=0;YPosUnten:=0;
      OpenDate:="";CloseDate:="";
      NeueLinie:=0;AlteLinie:="";
      AusgVorne:=FALSE;AusgMitte:=FALSE;AusgHinten:=FALSE;
      Bahnsteigart:="";BauForm:="";Veraendert:="";
      Umsteigen:=FALSE;Tiefe:=0.0;
      KurzZeichen:="";Profil:="";Bahnform:="";
      KehrVorne:=FALSE;KehrHinten:=FALSE;
   END (* WITH *);
END InitDummyDatensatz;


PROCEDURE DisplayDatensatz (Window : WindowPtr;
                            Daten : DATENSATZ);

VAR RastPort : ADDRESS;
    Position,Laenge : CARDINAL;

BEGIN
   RastPort:=Window^.rPort;
   WITH Daten DO
      SetAPen(RastPort,4);
      SetBPen(RastPort,8);
      Laenge:=Length(Namen);
      Position:=(79-Laenge) DIV 2;
      WriteWindowString(Window,0,Position-1," ");
      WriteWindowString(Window,0,Position,Namen);
      WriteWindowString(Window,0,Position+Laenge," ");
      SetAPen(RastPort,8);
      Move(RastPort,(Position-1)*8,0);
      Draw(RastPort,((Position+1+Laenge)*8)-1,0);
      Move(RastPort,(Position-1)*8,9);
      Draw(RastPort,((Position+1+Laenge)*8)-1,9);

      SetBPen(RastPort,0);
      SetAPen(RastPort,10);
      WriteWindowString(Window,2,0,"Positionen des Bahnhofes: X:");
      WriteWindowString(Window,2,40,"Y:");
      WriteWindowString(Window,2,60,"Kurzzeichen:");
      WriteWindowString(Window,3,0,"Oben:  X:");
      WriteWindowString(Window,3,14,"Y:");
      WriteWindowString(Window,3,21,"Name:");
      WriteWindowString(Window,4,0,"Unten: X:");
      WriteWindowString(Window,4,14,"Y:");
      WriteWindowString(Window,4,21,"Name:");
      WriteWindowCard(Window,2,29,XPosHier,3);
      WriteWindowCard(Window,2,43,YPosHier,3);
      WriteWindowString(Window,2,73,KurzZeichen);
      WriteWindowCard(Window,3,10,XPosOben,3);
      WriteWindowCard(Window,3,17,YPosOben,3);
      WriteWindowString(Window,3,27,NamenOben);
      WriteWindowCard(Window,4,10,XPosUnten,3);
      WriteWindowCard(Window,4,17,YPosUnten,3);
      WriteWindowString(Window,4,27,NamenUnten);

      SetAPen(RastPort,9);
      WriteWindowString(Window,6,0,"Ausgnge (J/N): Vorne:");
      WriteWindowString(Window,6,40,"Mitte:");
      WriteWindowString(Window,6,60,"Hinten:");
      DisplayBoolean(Window,6,23,9,AusgVorne);
      DisplayBoolean(Window,6,47,9,AusgMitte);
      DisplayBoolean(Window,6,68,9,AusgHinten);

      SetAPen(RastPort,7);
      WriteWindowString(Window,8,0,"Umsteigebahnhof (J/N):");
      DisplayBoolean(Window,8,23,7,Umsteigen);

      SetAPen(RastPort,8);
      WriteWindowString(Window,8,32,"Kehranlagen (J/N): Vorne:");
      WriteWindowString(Window,8,67,"Hinten:");
      DisplayBoolean(Window,8,58,8,KehrVorne);
      DisplayBoolean(Window,8,75,8,KehrHinten);

      SetAPen(RastPort,2);
      WriteWindowString(Window,10,0,"Erffnungsdatum:");
      WriteWindowString(Window,10,40,"Schliedatum:");
      WriteWindowString(Window,10,17,OpenDate);
      WriteWindowString(Window,10,54,CloseDate);

      SetAPen(RastPort,3);
      WriteWindowString(Window,12,0,"Linienbezeichnungen: Alt:");
      WriteWindowString(Window,12,40,"Neu:");
      WriteWindowString(Window,12,26,AlteLinie);
      WriteWindowCard(Window,12,45,NeueLinie,2);

      SetAPen(RastPort,5);
      WriteWindowString(Window,12,50,"Tiefenlage:");



      SetAPen(RastPort,15);
      WriteWindowString(Window,14,0,"Bahnart      (Straen-/U-/S-/M-Bahn)  :");
      WriteWindowString(Window,14,40,Bahnform);
      WriteWindowString(Window,14,40+Length(Bahnform),"-Bahn");

      SetAPen(RastPort,6);
      WriteWindowString(Window,15,0,
                 "Bahnsteig (Innen-/Mittel-/Auen-/Sonder-Bahnsteig):");
      WriteWindowString(Window,15,52,Bahnsteigart);
      WriteWindowString(Window,15,52+Length(Bahnsteigart),"bahnsteig");

      SetAPen(RastPort,15);
      WriteWindowString(Window,16,0,"Profilbreite (Gro/Klein/Gummi/Magnet):");
      WriteWindowString(Window,16,40,Profil);
      WriteWindowString(Window,16,40+Length(Profil),"profil");

      SetAPen(RastPort,12);
      WriteWindowString(Window,18,0,"Erscheinungsbild (U/T/E/D/H):");
      WriteWindowString(Window,18,30,BauForm);
      WriteWindowString(Window,18,30+Length(BauForm),"strecke");

      SetAPen(RastPort,7);
      WriteWindowString(Window,20,0,"Umbau (alt/restauriert/modernisiert):");
      WriteWindowString(Window,20,38,Veraendert);
   END (* WITH *);
END DisplayDatensatz;


PROCEDURE ReadName (Window : WindowPtr;
                    Line,Column,Farbe : CARDINAL;
                    VAR Variable : TEXT;
                    VAR Zeiger : BOOLEAN;
                    VAR Record : CARDINAL);

VAR RastPort : ADDRESS;
    Fehler,Vorzeichen : BOOLEAN;
    LongInt : LONGINT;
    Anfang : CHAR;
    Laenge : INTEGER;

BEGIN
   RastPort:=Window^.rPort;
   REPEAT
      Fehler:=FALSE;
      Zeiger:=FALSE;
      SetAPen(RastPort,Farbe);
      SetBPen(RastPort,0);
      ReadWindowString(Window,Line,Column,Variable);
      ClearMessage(Window);
      Laenge:=Length(Variable);
      Vorzeichen:=FALSE;
      StrToVal(Variable,LongInt,Vorzeichen,10,Fehler);
      Record:=LongInt;
      IF Fehler
      THEN
         Anfang:=Variable[0];
         IF ((Anfang<"A") OR (Anfang>"Z"))
         THEN
            IF ((Anfang#"") AND (Anfang#"") AND (Anfang#""))
            THEN
               SetMessage(Window," Unzulssiger Bahnhofsname ! ");
            ELSE
               Fehler:=FALSE;
            END (* IF *);
         ELSE
            Fehler:=FALSE;
         END (* IF *);
      ELSIF Record>Names
      THEN
         Fehler:=TRUE;
         SetMessage(Window," Falsche Record-Nummer ! ");
      ELSE
         Zeiger:=TRUE;
      END (* IF *);
   UNTIL NOT Fehler;
END ReadName;


PROCEDURE ReadDataSet (Window : WindowPtr;
                       Dir : ARRAY OF CHAR;
                       VAR Datensatz : DATENSATZ;
                       VAR Flags : FLAGSET);

VAR Titel : String;
    Name : TEXT;
    Record,Pos : CARDINAL;
    Position : INTEGER;
    Zeiger,Gefunden : BOOLEAN;
    RastPort : ADDRESS;

BEGIN
   RastPort:=Window^.rPort;
   SetRast(RastPort,0);
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Veraendert);
   IF Names=0
   THEN
      SetMessage(Window," Es gibt noch keine Bahnhfe ! ");
   END (* IF *);
   SetAPen(RastPort,10);
   SetBPen(RastPort,0);
   WriteWindowString(Window,1,1,"Bahnhofsname/Record-Nr. : ");
   REPEAT
      ReadName(Window,1,27,10,Name,Zeiger,Record);
      ClearMessage(Window);
      IF NOT input
      THEN
         SetMessage(Window," Eingabe erwartet ! ");
      END (* IF *);
   UNTIL input;
   SetRast(RastPort,0);
   Gefunden:=FALSE;
   IF NOT Zeiger
   THEN
      SucheDatensatz(Name,Record,Pos,Gefunden);
   END (* IF *);
   IF (Zeiger OR Gefunden)
   THEN
      LeseDatensatz(Window,Record,Dir,Datensatz);
   ELSE
      InitDummyDatensatz(Name,Datensatz);
      SetMessage(Window," Der Bahnhof existiert noch nicht ! ");
   END (* IF *);
   DisplayDatensatz(Window,Datensatz);
   INCL(Flags,Namen);
END ReadDataSet;


PROCEDURE WriteDataSet (Window : WindowPtr;
                        Dir : ARRAY OF CHAR;
                        Datensatz : DATENSATZ;
                        VAR Flags : FLAGSET);

VAR Record,Position : CARDINAL;
    Gefunden : BOOLEAN;

BEGIN
   SucheDatensatz(Datensatz.Namen,Record,Position,Gefunden);
   SchreibeDatensatz(Window,Record,Dir,Datensatz);
   IF NOT Gefunden
   THEN
      InsertName(Datensatz.Namen,Position,Record);
      SchreibeNamen(Window,Dir);
      INCL(Flags,Liste);
      Speichern:=TRUE;
   END (* IF *);
   EXCL(Flags,Namen);
   EXCL(Flags,Veraendert);
   EXCL(Flags,Sortiert);
   SetRast(Window^.rPort,0);
END WriteDataSet;


PROCEDURE ChangeDataSet (Window : WindowPtr;
                         Dir : ARRAY OF CHAR;
                         VAR Datensatz : DATENSATZ;
                         VAR Flags : FLAGSET);

VAR RastPort : ADDRESS;
    AlterDatensatz,Hilfsdatensatz : DATENSATZ;
    Gueltig,Zeiger,Fehler,Gefunden : BOOLEAN;
    Record,Position : CARDINAL;
    Zeichen : CHAR;
    Vergleich : ARRAY [1..4] OF BOOLEAN;


   PROCEDURE ReadCardinal (Window : WindowPtr;
                           Max,Line,Column,Farbe : CARDINAL;
                           VAR Variable : CARDINAL);

   BEGIN
      REPEAT
         SetAPen(RastPort,Farbe);
         SetBPen(RastPort,0);
         ReadWindowCard(Window,Line,Column,Variable);
         ClearMessage(Window);
         IF Variable>Max
         THEN
            SetMessage(Window," Der Wert ist zu gro ! ");
         END (* IF *);
      UNTIL Variable<=Max;
   END ReadCardinal;


   PROCEDURE ReadBoolean (Window : WindowPtr;
                          Line,Column,Farbe : CARDINAL;
                          VAR Variable : BOOLEAN);

   VAR Zeichen : CHAR;

   BEGIN
      SetAPen(RastPort,Farbe);
      SetBPen(RastPort,0);
      WriteWindowString(Window,Line,Column,"?   ");
      REPEAT
         Zeichen:=GetChar(Window);
      UNTIL ((Zeichen='j') OR (Zeichen='J')
         OR (Zeichen='n') OR (Zeichen='N') OR (Zeichen=CHAR(13)));
      IF Zeichen=CHAR(13)
      THEN
         input:=FALSE;
      ELSE
         input:=TRUE;
         IF ((Zeichen='j') OR (Zeichen='J'))
         THEN
            Variable:=TRUE;
         ELSE
            Variable:=FALSE;
         END (* IF *);
      END (* IF *);
   END ReadBoolean;


BEGIN (* ChangeDataSet *)
   RastPort:=Window^.rPort;
   AlterDatensatz:=Datensatz;
   WITH Datensatz DO
      ReadCardinal(Window,MAXX,2,29,10,XPosHier);
      IF NOT input
      THEN
         XPosHier:=AlterDatensatz.XPosHier;
      END (* IF *);
      WriteWindowCard(Window,2,29,XPosHier,3);
      ReadCardinal(Window,MAXY,2,43,10,YPosHier);
      IF NOT input
      THEN
         YPosHier:=AlterDatensatz.YPosHier;
      END (* IF *);
      WriteWindowCard(Window,2,43,YPosHier,3);
      SetAPen(RastPort,10);
      SetBPen(RastPort,0);
      ReadWindowString(Window,2,73,KurzZeichen);
      IF NOT input
      THEN
         KurzZeichen:=AlterDatensatz.KurzZeichen;
         WriteWindowString(Window,2,73,KurzZeichen);
      END (* IF *);
      ReadCardinal(Window,MAXX,3,10,10,XPosOben);
      IF NOT input
      THEN
         XPosOben:=AlterDatensatz.XPosOben;
      END (* IF *);
      WriteWindowCard(Window,3,10,XPosOben,3);
      ReadCardinal(Window,MAXY,3,17,10,YPosOben);
      IF NOT input
      THEN
         YPosOben:=AlterDatensatz.YPosOben;
      END (* IF *);
      WriteWindowCard(Window,3,17,YPosOben,3);
      REPEAT
         Fehler:=FALSE;
         ReadName(Window,3,27,10,NamenOben,Zeiger,Record);
         ClearMessage(Window);
         IF input
         THEN
            Gefunden:=FALSE;
            IF NOT Zeiger
            THEN
               SucheDatensatz(NamenOben,Record,Position,Gefunden);
            END (* IF *);
            IF (Zeiger OR Gefunden)
            THEN
               LeseDatensatz(Window,Record,Dir,Hilfsdatensatz);
               NamenOben:=Hilfsdatensatz.Namen;
               XPosOben:=Hilfsdatensatz.XPosHier;
               YPosOben:=Hilfsdatensatz.YPosHier;
               WriteWindowString(Window,3,27,NamenOben);
               WriteWindowCard(Window,3,10,XPosOben,3);
               WriteWindowCard(Window,3,17,YPosOben,3);
            ELSE
               SetMessage(Window," Dieser Bahnhof existiert nicht ! ");
               Fehler:=TRUE;
            END (* IF *);
         ELSE
            NamenOben:=AlterDatensatz.NamenOben;
            WriteWindowString(Window,3,27,NamenOben);
         END (* IF *);
      UNTIL NOT Fehler;
      ReadCardinal(Window,MAXX,4,10,10,XPosUnten);
      IF NOT input
      THEN
         XPosUnten:=AlterDatensatz.XPosUnten;
      END (* IF *);
      WriteWindowCard(Window,4,10,XPosUnten,3);
      ReadCardinal(Window,MAXY,4,17,10,YPosUnten);
      IF NOT input
      THEN
         YPosUnten:=AlterDatensatz.YPosUnten;
      END (* IF *);
      WriteWindowCard(Window,4,17,YPosUnten,3);
      REPEAT
         Fehler:=FALSE;
         ReadName(Window,4,27,10,NamenUnten,Zeiger,Record);
         ClearMessage(Window);
         IF input
         THEN
            Gefunden:=FALSE;
            IF NOT Zeiger
            THEN
               SucheDatensatz(NamenUnten,Record,Position,Gefunden);
            END (* IF *);
            IF (Zeiger OR Gefunden)
            THEN
               LeseDatensatz(Window,Record,Dir,Hilfsdatensatz);
               NamenUnten:=Hilfsdatensatz.Namen;
               XPosUnten:=Hilfsdatensatz.XPosHier;
               YPosUnten:=Hilfsdatensatz.YPosHier;
               WriteWindowString(Window,4,27,NamenUnten);
               WriteWindowCard(Window,4,10,XPosUnten,3);
               WriteWindowCard(Window,4,17,YPosUnten,3);
            ELSE
               SetMessage(Window," Dieser Bahnhof existiert nicht ! ");
               Fehler:=TRUE;
            END (* IF *);
         ELSE
            NamenUnten:=AlterDatensatz.NamenUnten;
            WriteWindowString(Window,4,27,NamenUnten);
         END (* IF *);
      UNTIL NOT Fehler;
      ReadBoolean(Window,6,23,9,AusgVorne);
      IF NOT input
      THEN
         AusgVorne:=AlterDatensatz.AusgVorne;
      END (* IF *);
      DisplayBoolean(Window,6,23,9,AusgVorne);
      ReadBoolean(Window,6,47,9,AusgMitte);
      IF NOT input
      THEN
         AusgMitte:=AlterDatensatz.AusgMitte;
      END (* IF *);
      DisplayBoolean(Window,6,47,9,AusgMitte);
      ReadBoolean(Window,6,68,9,AusgHinten);
      IF NOT input
      THEN
         AusgHinten:=AlterDatensatz.AusgHinten;
      END (* IF *);
      DisplayBoolean(Window,6,68,9,AusgHinten);
      ReadBoolean(Window,8,23,7,Umsteigen);
      IF NOT input
      THEN
         Umsteigen:=AlterDatensatz.Umsteigen;
      END (* IF *);
      DisplayBoolean(Window,8,23,7,Umsteigen);
      ReadBoolean(Window,8,58,8,KehrVorne);
      IF NOT input
      THEN
         KehrVorne:=AlterDatensatz.KehrVorne;
      END (* IF *);
      DisplayBoolean(Window,8,58,8,KehrVorne);
      ReadBoolean(Window,8,75,8,KehrHinten);
      IF NOT input
      THEN
         KehrHinten:=AlterDatensatz.KehrHinten;
      END (* IF *);
      DisplayBoolean(Window,8,75,8,KehrHinten);
      REPEAT
         Gueltig:=TRUE;
         ReadDatum(Window,10,17,2,OpenDate);
         ClearMessage(Window);
         IF NOT input
         THEN
            OpenDate:=AlterDatensatz.OpenDate;
            IF Length(OpenDate)=0
            THEN
               SetMessage(Window," Eingabe erwartet ! ");
               Gueltig:=FALSE;
            END (* IF *);
            WriteWindowString(Window,10,17,OpenDate);
         END (* IF *);
      UNTIL Gueltig;
      REPEAT
         Gueltig:=TRUE;
         ReadDatum(Window,10,54,2,CloseDate);
         ClearMessage(Window);
         IF NOT input
         THEN
            CloseDate:=AlterDatensatz.CloseDate;
            IF Length(CloseDate)=0
            THEN
               SetMessage(Window," Eingabe erwartet ! ");
               Gueltig:=FALSE;
            END (* IF *);
            WriteWindowString(Window,10,54,CloseDate);
         END (* IF *);
      UNTIL Gueltig;
      SetAPen(RastPort,3);
      SetBPen(RastPort,0);
      ReadWindowString(Window,12,26,AlteLinie);
      IF NOT input
      THEN
         AlteLinie:=AlterDatensatz.AlteLinie;
         WriteWindowString(Window,12,26,AlteLinie);
      END (* IF *);
      ReadCardinal(Window,15,12,45,3,NeueLinie);
      IF NOT input
      THEN
         NeueLinie:=AlterDatensatz.NeueLinie;
      END (* IF *);
      WriteWindowCard(Window,12,45,NeueLinie,2);


      REPEAT
         Fehler:=FALSE;
         SetAPen(RastPort,15);
         SetBPen(RastPort,0);
         ReadWindowString(Window,14,40,Bahnform);
         ClearMessage(Window);
         IF input
         THEN
            Vergleich[1]:=(Compare(Bahnform,0,7,"Straen",TRUE)=0);
            Vergleich[2]:=(Compare(Bahnform,0,1,"U",TRUE)=0);
            Vergleich[3]:=(Compare(Bahnform,0,1,"S",TRUE)=0);
            Vergleich[4]:=(Compare(Bahnform,0,1,"M",TRUE)=0);
            IF (NOT Vergleich[1] AND NOT Vergleich[2]
            AND NOT Vergleich[3] AND NOT Vergleich[4])
            THEN
               SetMessage(Window," Falsche Eingabe ! ");
               Fehler:=TRUE;
            END (* IF *);
         ELSE
            Bahnform:=AlterDatensatz.Bahnform;
         END (* IF *);
         IF Length(Bahnform)=0
         THEN
            SetMessage(Window," Eingabe erwartet ! ");
            Fehler:=TRUE;
         END (* IF *);
      UNTIL NOT Fehler;
      SetAPen(RastPort,15);
      SetBPen(RastPort,0);
      WriteWindowString(Window,14,40,Bahnform);
      WriteWindowString(Window,14,40+Length(Bahnform),"-Bahn        ");
      REPEAT
         Fehler:=FALSE;
         SetAPen(RastPort,6);
         SetBPen(RastPort,0);
         ReadWindowString(Window,15,52,Bahnsteigart);
         ClearMessage(Window);
         IF input
         THEN
            Vergleich[1]:=(Compare(Bahnsteigart,0,5,"Innen",TRUE)=0);
            Vergleich[2]:=(Compare(Bahnsteigart,0,5,"Auen",TRUE)=0);
            Vergleich[3]:=(Compare(Bahnsteigart,0,6,"Mittel",TRUE)=0);
            Vergleich[4]:=(Compare(Bahnsteigart,0,6,"Sonder",TRUE)=0);
            IF (NOT Vergleich[1] AND NOT Vergleich[2]
            AND NOT Vergleich[3] AND NOT Vergleich[4])
            THEN
               SetMessage(Window," Falsche Eingabe ! ");
               Fehler:=TRUE;
            END (* IF *);
         ELSE
            Bahnsteigart:=AlterDatensatz.Bahnsteigart;
         END (* IF *);
         IF Length(Bahnsteigart)=0
         THEN
            SetMessage(Window," Eingabe erwartet ! ");
            Fehler:=TRUE;
         END (* IF *);
      UNTIL NOT Fehler;
      SetAPen(RastPort,6);
      SetBPen(RastPort,0);
      WriteWindowString(Window,15,52,Bahnsteigart);
      WriteWindowString(Window,15,52+Length(Bahnsteigart),"bahnsteig  ");
      REPEAT
         Fehler:=FALSE;
         SetAPen(RastPort,15);
         SetBPen(RastPort,0);
         ReadWindowString(Window,16,40,Profil);
         ClearMessage(Window);
         IF input
         THEN
            Vergleich[1]:=(Compare(Profil,0,4,"Gro",TRUE)=0);
            Vergleich[2]:=(Compare(Profil,0,5,"Klein",TRUE)=0);
            Vergleich[3]:=(Compare(Profil,0,5,"Gummi",TRUE)=0);
            Vergleich[4]:=(Compare(Profil,0,6,"Magnet",TRUE)=0);
            IF (NOT Vergleich[1] AND NOT Vergleich[2]
            AND NOT Vergleich[3] AND NOT Vergleich[4])
            THEN
               SetMessage(Window," Falsche Eingabe ! ");
               Fehler:=TRUE;
            END (* IF *);
         ELSE
            Profil:=AlterDatensatz.Profil;
         END (* IF *);
         IF Length(Profil)=0
         THEN
            SetMessage(Window," Eingabe erwartet ! ");
            Fehler:=TRUE;
         END (* IF *);
      UNTIL NOT Fehler;
      SetAPen(RastPort,15);
      SetBPen(RastPort,0);
      WriteWindowString(Window,16,40,Profil);
      WriteWindowString(Window,16,40+Length(Profil),"profil   ");
      REPEAT
         Fehler:=FALSE;
         SetAPen(RastPort,12);
         SetBPen(RastPort,0);
         WriteWindowString(Window,18,38+Length(BauForm),"? ");
         REPEAT
            Zeichen:=GetChar(Window);
         UNTIL ((Zeichen='U') OR (Zeichen='u')
             OR (Zeichen='T') OR (Zeichen='t')
             OR (Zeichen='E') OR (Zeichen='e')
             OR (Zeichen='D') OR (Zeichen='d')
             OR (Zeichen='H') OR (Zeichen='h')
             OR (Zeichen=CHAR(13)));
         ClearMessage(Window);
         CASE Zeichen OF
            'U','u','T','t' : BauForm:="Tunnel";
          | 'E','e'         : BauForm:="Einschnitt";
          | 'D','d'         : BauForm:="Damm";
          | 'H','h'         : BauForm:="Hochbahn";
          | CHAR(13)        : BauForm:=AlterDatensatz.BauForm;
         END (* CASE *);
         IF Length(BauForm)=0
         THEN
            SetMessage(Window," Eingabe erwartet ! ");
            Fehler:=TRUE;
         END (* IF *);
      UNTIL NOT Fehler;
      SetAPen(RastPort,12);
      SetBPen(RastPort,0);
      WriteWindowString(Window,18,30,BauForm);
      WriteWindowString(Window,18,30+Length(BauForm),"strecke        ");
      REPEAT
         Fehler:=FALSE;
         SetAPen(RastPort,7);
         SetBPen(RastPort,0);
         ReadWindowString(Window,20,38,Veraendert);
         ClearMessage(Window);
         IF input
         THEN
            Vergleich[1]:=(Compare(Veraendert,0,3,"alt",TRUE)=0);
            Vergleich[2]:=(Compare(Veraendert,0,11,"restauriert",TRUE)=0);
            Vergleich[3]:=(Compare(Veraendert,0,12,"modernisiert",TRUE)=0);
            IF (NOT Vergleich[1] AND NOT Vergleich[2] AND NOT Vergleich[3])
            THEN
               SetMessage(Window," Falsche Eingabe ! ");
               Fehler:=TRUE;
            END (* IF *);
         ELSE
            Veraendert:=AlterDatensatz.Veraendert;
         END (* IF *);
         IF Length(Veraendert)=0
         THEN
            SetMessage(Window," Eingabe erwartet ! ");
            Fehler:=TRUE;
         END (* IF *);
      UNTIL NOT Fehler;
      SetAPen(RastPort,7);
      SetBPen(RastPort,0);
      WriteWindowString(Window,20,38,Veraendert);
      WriteWindowString(Window,20,38+Length(Veraendert),"           ");
   END (* WITH *);
   INCL(Flags,Veraendert);
END ChangeDataSet;


PROCEDURE PrintDataSet (Datensatz : DATENSATZ);

VAR Druckstring : ARRAY [0..77] OF CHAR;
    Hilfsstring : ARRAY [0..4] OF CHAR;
    Fehler : BOOLEAN;

   PROCEDURE ClearString (VAR String : ARRAY OF CHAR);

   VAR Zaehler : CARDINAL;

   BEGIN
      FOR Zaehler:=0 TO HIGH(String) DO
         String[Zaehler]:=' ';
      END (* FOR *);
   END ClearString;


BEGIN
   OpenPrinter;
   WITH Datensatz DO
      PrintCommand(18,0,0,0,0);
      PrintCommand(6,0,0,0,0);
      PrintCommand(15,0,0,0,0);
      PrintCommand(8,0,0,0,0);
      PrintCommand(25,0,0,0,0);
      ClearString(Druckstring);
      Druckstring:="";
      Insert(Druckstring,(76-Length(Namen))/2,Namen);
      PrintString(Druckstring);
      PrintChar(eol);
      PrintCommand(7,0,0,0,0);
      PrintCommand(9,0,0,0,0);
      PrintChar(eol);
      Druckstring:="Position des Bahnhofes X:";
      ValToStr(XPosHier,FALSE,Hilfsstring,10,4,' ',Fehler);
      Insert(Druckstring,last,Hilfsstring);
      Insert(Druckstring,40,"Y:");
      ValToStr(YPosHier,FALSE,Hilfsstring,10,4,' ',Fehler);
      Insert(Druckstring,last,Hilfsstring);
      Insert(Druckstring,last,"            Kurzzeichen: ");
      Insert(Druckstring,last,KurzZeichen);
      PrintLine(Druckstring);
      Druckstring:="Oben  X:";
      ValToStr(XPosOben,FALSE,Hilfsstring,10,4,' ',Fehler);
      Insert(Druckstring,last,Hilfsstring);
      Insert(Druckstring,last," Y:");
      ValToStr(YPosOben,FALSE,Hilfsstring,10,4,' ',Fehler);
      Insert(Druckstring,last,Hilfsstring);
      Insert(Druckstring,last," Name: ");
      Insert(Druckstring,last,NamenOben);
      PrintLine(Druckstring);
      Druckstring:="Unten X:";
      ValToStr(XPosUnten,FALSE,Hilfsstring,10,4,' ',Fehler);
      Insert(Druckstring,last,Hilfsstring);
      Insert(Druckstring,last," Y:");
      ValToStr(YPosUnten,FALSE,Hilfsstring,10,4,' ',Fehler);
      Insert(Druckstring,last,Hilfsstring);
      Insert(Druckstring,last," Name: ");
      Insert(Druckstring,last,NamenUnten);
      PrintLine(Druckstring);
      PrintChar(eol);
      Druckstring:="Ausgnge: vorne: ";
      IF AusgVorne
      THEN
         Insert(Druckstring,last,"JA  ");
      ELSE
         Insert(Druckstring,last,"NEIN");
      END (* IF *);
      Insert(Druckstring,40,"mitte: ");
      IF AusgMitte
      THEN
         Insert(Druckstring,last,"JA  ");
      ELSE
         Insert(Druckstring,last,"NEIN");
      END (* IF *);
      Insert(Druckstring,last,"       hinten: ");
      IF AusgHinten
      THEN
         Insert(Druckstring,last,"JA");
      ELSE
         Insert(Druckstring,last,"NEIN");
      END (* IF *);
      PrintLine(Druckstring);
      Druckstring:="Umsteigebahnhof: ";
      IF Umsteigen
      THEN
         Insert(Druckstring,last,"JA  ");
      ELSE
         Insert(Druckstring,last,"NEIN");
      END (* IF *);
      Insert(Druckstring,last,"       Kehranlagen vorne: ");
      IF KehrVorne
      THEN
         Insert(Druckstring,last,"JA  ");
      ELSE
         Insert(Druckstring,last,"NEIN");
      END (* IF *);
      Insert(Druckstring,last,"       hinten: ");
      IF KehrHinten
      THEN
         Insert(Druckstring,last,"JA");
      ELSE
         Insert(Druckstring,last,"NEIN");
      END (* IF *);
      PrintLine(Druckstring);
      PrintChar(eol);
      Druckstring:="Erffnungsdatum: ";
      Insert(Druckstring,last,OpenDate);
      Insert(Druckstring,40,"Schliedatum: ");
      Insert(Druckstring,last,CloseDate);
      PrintLine(Druckstring);
      PrintChar(eol);
      Druckstring:="Linienbezeichnungen: Alt: ";
      Insert(Druckstring,last,AlteLinie);
      Insert(Druckstring,40,"Neu:");
      ValToStr(NeueLinie,FALSE,Hilfsstring,10,4,' ',Fehler);
      Insert(Druckstring,last,Hilfsstring);
      PrintLine(Druckstring);
      (*
      ValToStr();
      PrintLine(Druckstring);
      *)
   END (* WITH *);
   ClosePrinter;
END PrintDataSet;


PROCEDURE DeleteDataSet (Window : WindowPtr;
                         Dir : ARRAY OF CHAR;
                         Datensatz : DATENSATZ;
                         VAR Flags : FLAGSET);

VAR Record,Position,Dummy : CARDINAL;
    Hilfsdatensatz : DATENSATZ;
    Gefunden : BOOLEAN;

BEGIN
   SucheDatensatz(Datensatz.Namen,Record,Position,Gefunden);
   IF Gefunden
   THEN
      IF Record#Names
      THEN
         LeseDatensatz(Window,Names,Dir,Hilfsdatensatz);
         SchreibeDatensatz(Window,Record,Dir,Hilfsdatensatz);
         DeleteName(Position);
         SchreibeNamen(Window,Dir);
         SucheDatensatz(Hilfsdatensatz.Namen,Dummy,Position,Gefunden);
         List[Position].Namen:=Hilfsdatensatz.Namen;
         List[Position].Nummer:=Record;
      ELSE
         DeleteName(Position);
         SchreibeNamen(Window,Dir);
      END (* IF *);
      EXCL(Flags,Namen);
      EXCL(Flags,Veraendert);
      EXCL(Flags,Sortiert);
      INCL(Flags,Liste);
      Speichern:=TRUE;
      SetRast(Window^.rPort,0);
   ELSE
      SetMessage(Window," Der Bahnhof existiert nicht ! ");
   END (* IF *);
END DeleteDataSet;


PROCEDURE RenameDataSet (Window : WindowPtr;
                         Dir : ARRAY OF CHAR;
                         Datensatz : DATENSATZ;
                         VAR Flags : FLAGSET);

VAR Position,Record : CARDINAL;
    Gefunden,Gueltig,Zeiger : BOOLEAN;
    Hilfsdatensatz : DATENSATZ;
    Name : TEXT;
    RastPort : ADDRESS;

BEGIN
   RastPort:=Window^.rPort;
   SetAPen(RastPort,10);
   SetBPen(RastPort,0);
   WriteWindowString(Window,22,0,"Neuer Bahnhofsname:");
   REPEAT
      ReadName(Window,22,20,10,Name,Zeiger,Record);
      ClearMessage(Window);
      Gueltig:=TRUE;
      IF (Zeiger OR (Length(Name)=0))
      THEN
         Gueltig:=FALSE;
         SetMessage(Window," Hier mu der Bahnhofsname angegeben werden ! ");
      END (* IF *);
   UNTIL Gueltig;
   SucheDatensatz(Name,Record,Position,Gefunden);
   IF Gefunden
   THEN
      SetMessage(Window," Der neue Bahnhof existiert bereits ! ");
      SetBPen(RastPort,0);
      WriteWindowString(Window,22,0,
      "                                                                    ");
   ELSE
      Hilfsdatensatz:=Datensatz;
      Hilfsdatensatz.Namen:=Name;
      SchreibeDatensatz(Window,Record,Dir,Hilfsdatensatz);
      InsertName(Hilfsdatensatz.Namen,Position,Record);
      SchreibeNamen(Window,Dir);
      DeleteDataSet(Window,Dir,Datensatz,Flags);
      EXCL(Flags,Namen);
      EXCL(Flags,Veraendert);
      EXCL(Flags,Sortiert);
      INCL(Flags,Liste);
      Speichern:=TRUE;
      SetRast(RastPort,0);
   END (* IF *);
END RenameDataSet;


PROCEDURE CopyDataSet (Window : WindowPtr;
                       Dir : ARRAY OF CHAR;
                       Datensatz : DATENSATZ;
                       VAR Flags : FLAGSET);

VAR Position,Record : CARDINAL;
    Gefunden,Gueltig,Zeiger : BOOLEAN;
    Hilfsdatensatz : DATENSATZ;
    Name : TEXT;
    RastPort : ADDRESS;

BEGIN
   RastPort:=Window^.rPort;
   SetAPen(RastPort,10);
   SetBPen(RastPort,0);
   WriteWindowString(Window,22,0,"Neuer Bahnhofsname:");
   REPEAT
      ReadName(Window,22,20,10,Name,Zeiger,Record);
      ClearMessage(Window);
      Gueltig:=TRUE;
      IF (Zeiger OR (Length(Name)=0))
      THEN
         Gueltig:=FALSE;
         SetMessage(Window," Hier mu der Bahnhofsname angegeben werden ! ");
      END (* IF *);
   UNTIL Gueltig;
   SucheDatensatz(Name,Record,Position,Gefunden);
   IF Gefunden
   THEN
      SetMessage(Window," Der neue Bahnhof existiert bereits ! ");
      SetBPen(RastPort,0);
      WriteWindowString(Window,22,0,
      "                                                                    ");
   ELSE
      Hilfsdatensatz:=Datensatz;
      Hilfsdatensatz.Namen:=Name;
      SchreibeDatensatz(Window,Record,Dir,Hilfsdatensatz);
      InsertName(Hilfsdatensatz.Namen,Position,Record);
      SchreibeNamen(Window,Dir);
      EXCL(Flags,Namen);
      EXCL(Flags,Veraendert);
      EXCL(Flags,Sortiert);
      INCL(Flags,Liste);
      Speichern:=TRUE;
      SetRast(RastPort,0);
   END (* IF *);
END CopyDataSet;


END Datenblatt.
