(*********************************************************************
 *
 *  :Program.    Datenblatt.mod
 *  :Project.    Nahverkehrssystem
 *  :Author.     Ingo Goldak
 *  :Address.    Hohenzollerndamm 8
 *  :Address.    1000 Berlin 31
 *  :Copyright.  PD
 *  :Language.   Modula-II
 *  :Translator. M2Amiga V3.3d
 *  :Imports.    IntuiStruct, FileRequest, IFFSupport, MemSystem, IDCMP,
 *  :Imports.    SuperLists [AMOK]
 *  :Imports.    WindowInOut, Werkzeuge [Ingo Goldak]
 *  :Contents.   PROCEDUREn fr Menu 'Diskette'
 *  :History. V1.0 [Ingo Goldak] 30.03.90
 *
 *********************************************************************)

IMPLEMENTATION MODULE Diskette;

FROM SYSTEM IMPORT
     ADDRESS,ADR,LONGSET;
FROM Arts IMPORT
     Assert;
FROM Intuition IMPORT
     Border,IntuiText,boolGadget,propGadget,Gadget,GadgetPtr,GadgetFlags,
     GadgetFlagSet,ActivationFlags,ActivationFlagSet,RefreshGadgets,
     PropInfo,PropInfoFlags,PropInfoFlagSet,Image,IntuiMessagePtr,
     WindowPtr,NewWindow,OpenWindow,CloseWindow,WindowFlagSet,WindowFlags,
     IDCMPFlagSet,IDCMPFlags,ModifyIDCMP,SetWindowTitles,ScreenPtr,CloseScreen,
     ScreenFlagSet,ScreenFlags,SetPointer,ClearPointer;
FROM Graphics IMPORT
     SetRast,Move,Draw,SetAPen,SetBPen,SetRGB4,jam1;
FROM InputEvent IMPORT
     QualifierSet;
FROM Dos IMPORT
     FileLockPtr,FileHandlePtr,CreateDir,CurrentDir,
     Open,Close,Read,Write,Lock,UnLock,sharedLock,oldFile,newFile;
FROM Conversions IMPORT
     ValToStr;
FROM Strings IMPORT
     Length,Copy,Insert,Occurs,last;
FROM WindowInOut IMPORT
     WriteWindowString,WriteWindowInt,WriteWindowCard;
FROM IFFSupport IMPORT
     WriteILBM,LoadILBM;
FROM IntuiStruct IMPORT
     StructWindow,StructGadget,StructText,StructProp,StructBorder,Rectangle,
     BorderEnd;
FROM FileRequest IMPORT
     InitList,InitStdGadgets,InitListGadgets,InitLoadGadgets,
     GetPath,RequestFile,RequestPath,StdHandler,CreateStdEntry,CreateDirEntry;
FROM MemSystem IMPORT
     Allocate,AllocMem,Deallocate;
FROM IDCMP IMPORT
     GetIntuiMessage,EmptyIDCMP;
FROM Werkzeuge IMPORT
     Names,List,Farben,Title,Speichern,
     String,TEXT,LISTE,DATUM,FLAGSET,FLAGS,LISTELEMENT;
FROM Initializations IMPORT
     MousePtr;
FROM Hilfsmittel IMPORT
     SetMessage,ClearMessage;
IMPORT IntuiStruct;
IMPORT SuperLists;
IMPORT FileRequest;
IMPORT Graphics;


PROCEDURE SaveNames (Window : WindowPtr;
                     Dir : ARRAY OF CHAR;
                     Exists : BOOLEAN);

VAR Datei : FileHandlePtr;
    File : String;
    Laenge,Fehler,zaehler : INTEGER;

BEGIN
   IF (Length(Dir)#0) AND Speichern
   THEN
      Copy(File,Dir,0,Length(Dir));
      Insert(File,last,"Bahnhofsnamen");
      IF Exists
      THEN
         Datei:=Open(ADR(File),oldFile);
      ELSE
         Datei:=Open(ADR(File),newFile);
      END (* IF *);
      Assert(Datei#NIL,ADR("Kann Bahnhfe nicht speichern"));
      Fehler:=Write(Datei,ADR(Names),SIZE(Names));
      IF NOT (Fehler>0)
      THEN
         SetMessage(Window," Zahl konnte nicht geschrieben werden ! ");
         WriteWindowInt(Window,22,1,Fehler,5);
      END (* IF *);
      IF Names#0
      THEN
         FOR zaehler:=1 TO Names DO
            Fehler:=Write(Datei,ADR(List[zaehler]),SIZE(LISTELEMENT));
            IF NOT (Fehler>0)
            THEN
               SetMessage(Window,
                          " Datensatz konnte nicht geschrieben werden ! ");
               WriteWindowInt(Window,22,1,Fehler,5);
            END (* IF *);
         END (* FOR *);
      END (* IF *);
      Close(Datei);
   END (* IF *);
END SaveNames;


PROCEDURE CheckColors (Window : WindowPtr;
                       VAR Flags : FLAGSET);

VAR RastPort : ADDRESS;
    Titel : String;
    Position : INTEGER;
    index,zaehler : CARDINAL;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Namen);
   RastPort:=Window^.rPort;
   SetRast(RastPort,0);
   FOR index:=0 TO 15 DO
      SetAPen(RastPort,index);
      FOR zaehler:=index TO index+10 DO
         Move(RastPort,0,(index*14)+zaehler);
         Draw(RastPort,639,(index*14)+zaehler);
      END; (* FOR zaehler *)
   END; (* FOR index *)
END CheckColors;


PROCEDURE ChooseTown (Screen : ScreenPtr;
                      Window : WindowPtr;
                      Mouse,Wait : MousePtr;
                      VAR Dir : ARRAY OF CHAR;
                      VAR Flags : FLAGSET);

CONST Old = TRUE;
      New = FALSE;

VAR Zaehler : CARDINAL;
    Vorhanden,Dummy : BOOLEAN;
    reqWindow : NewWindow;
    ReqWindow : WindowPtr;
    OldDir,NewDir : FileLockPtr;
    Datei : FileHandlePtr;
    Directory,FileName,OldTitle,File : String;
    Gadgets : GadgetPtr;
    Fehler,start : INTEGER;
    Ok : Gadget;
    OkFrame : Border;
    OkText : IntuiText;
    Linie : ARRAY [0..15] OF Gadget;
    Feld : ARRAY [0..15],[0..4] OF Border;

   PROCEDURE LoadNames (Dir : ARRAY OF CHAR);

   VAR Datei : FileHandlePtr;
       File : String;
       Laenge,Fehler,zaehler : INTEGER;

   BEGIN
      Copy(File,Dir,0,Length(Dir));
      Insert(File,last,"Bahnhofsnamen");
      Datei:=Open(ADR(File),oldFile);
      Assert(Datei#NIL,ADR("Kann Bahnhfe nicht laden"));
      Fehler:=Read(Datei,ADR(Names),SIZE(Names));
      IF NOT (Fehler>0)
      THEN
         SetMessage(Window," Zahl konnte nicht gelesen werden ! ");
         WriteWindowInt(Window,22,1,Fehler,5);
      END (* IF *);
      IF Names#0
      THEN
         FOR zaehler:=1 TO Names DO
            Fehler:=Read(Datei,ADR(List[zaehler]),SIZE(LISTELEMENT));
            IF NOT (Fehler>0)
            THEN
               SetMessage(Window," Datensatz konnte nicht gelesen werden ! ");
               WriteWindowInt(Window,22,1,Fehler,5);
            END (* IF *);
         END (* FOR *);
      END (* IF *);
      Close(Datei);
   END LoadNames;


   PROCEDURE DisplayColors (Window : WindowPtr);

   VAR RastPort : ADDRESS;
       index : CARDINAL;

   BEGIN
      RastPort:=Window^.rPort;
      SetRast(RastPort,0);
      SetAPen(RastPort,0);
      SetBPen(RastPort,10);
      WriteWindowString(Window,1,28," Einstellen der Farben ");
      SetAPen(RastPort,10);
      Move(RastPort,224,10);
      Draw(RastPort,407,10);
      Move(RastPort,224,19);
      Draw(RastPort,407,19);
      SetAPen(RastPort,10);
      SetBPen(RastPort,0);
      WriteWindowString(Window,3,1,"Hintergrund");
      StructBorder(Feld[0,0],0,0,0,jam1,4,NIL);
      Rectangle(500,10);
      BorderEnd;
      StructBorder(Feld[0,1],1,1,0,jam1,4,ADR(Feld[0,0]));
      Rectangle(498,8);
      BorderEnd;
      StructBorder(Feld[0,2],2,2,0,jam1,4,ADR(Feld[0,1]));
      Rectangle(496,6);
      BorderEnd;
      StructBorder(Feld[0,3],3,3,0,jam1,4,ADR(Feld[0,2]));
      Rectangle(494,4);
      BorderEnd;
      StructBorder(Feld[0,4],4,4,0,jam1,4,ADR(Feld[0,3]));
      Rectangle(492,2);
      BorderEnd;
      StructGadget(Linie[0],100,30,500,10,GadgetFlagSet{},
                   ActivationFlagSet{relVerify},boolGadget,
                   ADR(Feld[0,4]),NIL,LONGSET{},0,NIL);
      FOR index:=1 TO 15 DO
         StructBorder(Feld[index,0],0,0,index,jam1,4,NIL);
         Rectangle(500,10);
         BorderEnd;
         StructBorder(Feld[index,1],1,1,index,jam1,4,ADR(Feld[index,0]));
         Rectangle(498,8);
         BorderEnd;
         StructBorder(Feld[index,2],2,2,index,jam1,4,ADR(Feld[index,1]));
         Rectangle(496,6);
         BorderEnd;
         StructBorder(Feld[index,3],3,3,index,jam1,4,ADR(Feld[index,2]));
         Rectangle(494,4);
         BorderEnd;
         StructBorder(Feld[index,4],4,4,index,jam1,4,ADR(Feld[index,3]));
         Rectangle(492,2);
         BorderEnd;
         StructGadget(Linie[index],100,(index+3)*10,500,10,GadgetFlagSet{},
                      ActivationFlagSet{relVerify},boolGadget,
                      ADR(Feld[index,4]),NIL,LONGSET{},index,
                      ADR(Linie[index-1]));
         WriteWindowString(Window,index+3,1,"Linie");
         WriteWindowCard(Window,index+3,7,index,2);
      END (* FOR *);
      StructText(OkText,10,0,jam1,42,1,ADR("Ok"),NIL);
      StructBorder(OkFrame,0,0,10,jam1,4,NIL);
      Rectangle(100,10);
      BorderEnd;
      StructGadget(Ok,110,200,100,10,GadgetFlagSet{},
                   ActivationFlagSet{relVerify},boolGadget,ADR(OkFrame),
                   ADR(OkText),LONGSET{},16,ADR(Linie[15]));
      Window^.firstGadget:=ADR(Ok);
      RefreshGadgets(Window^.firstGadget,Window,NIL);
   END DisplayColors;


   PROCEDURE ChangeColors (Farbe : CARDINAL);

   VAR Rot,Gruen,Blau : Gadget;
       RProp,GProp,BProp : PropInfo;
       RText,GText,BText : IntuiText;
       RInfo,GInfo,BInfo : Image;
       Flag : PropInfoFlagSet;
       R,G,B,Code,ID : CARDINAL;
       Class : IDCMPFlags;
       Qualifier : QualifierSet;
       x,y : INTEGER;
       Item,ViewPort : ADDRESS;
       ItemPtr : GadgetPtr;
       Fehler : BOOLEAN;
       cWindow : NewWindow;
       CWindow : WindowPtr;
       Ueberschrift,Hilfe : ARRAY [0..50] OF CHAR;

   BEGIN
      ViewPort:=ADR(Screen^.viewPort);
      R:=Farben[Farbe,1];G:=Farben[Farbe,2];B:=Farben[Farbe,3];
      StructText(RText,15-Farbe,15-Farbe,jam1,-12,0,ADR("R "),NIL);
      StructText(GText,15-Farbe,15-Farbe,jam1,-12,0,ADR("G "),NIL);
      StructText(BText,15-Farbe,15-Farbe,jam1,-12,0,ADR("B "),NIL);
      Flag:=PropInfoFlagSet{freeHoriz,autoKnob};
      StructProp(RProp,Flag,R*4096,0,4096,0);
      StructProp(GProp,Flag,G*4096,0,4096,0);
      StructProp(BProp,Flag,B*4096,0,4096,0);
      StructGadget(Rot,20,40,200,10,GadgetFlagSet{},
                   ActivationFlagSet{gadgImmediate,relVerify},propGadget,
                   ADR(RInfo),ADR(RText),LONGSET{},1,NIL);
      Rot.specialInfo:=ADR(RProp);
      StructGadget(Gruen,20,60,200,10,GadgetFlagSet{},
                   ActivationFlagSet{gadgImmediate,relVerify},propGadget,
                   ADR(GInfo),ADR(GText),LONGSET{},2,ADR(Rot));
      Gruen.specialInfo:=ADR(GProp);
      StructGadget(Blau,20,80,200,10,GadgetFlagSet{},
                   ActivationFlagSet{gadgImmediate,relVerify},propGadget,
                   ADR(BInfo),ADR(BText),LONGSET{},3,ADR(Gruen));
      Blau.specialInfo:=ADR(BProp);
      Ueberschrift:=" Farbe#";
      ValToStr(Farbe,FALSE,Hilfe,10,2," ",Fehler);
      Insert(Ueberschrift,last,Hilfe);
      StructWindow(cWindow,0,150,250,100,Farbe,15-Farbe,
                   IDCMPFlagSet{closeWindow,gadgetUp,gadgetDown},
                   WindowFlagSet{activate,windowClose,windowDrag},
                   ADR(Ueberschrift),Screen,ScreenFlagSet{wbenchScreen});
      cWindow.firstGadget:=ADR(Blau);
      CWindow:=OpenWindow(cWindow);
      Assert(CWindow#NIL,ADR("Kann Farb-Window nicht ffnen"));
      SetPointer(CWindow,Mouse,16,16,-4,-1);
      LOOP
         GetIntuiMessage(CWindow^.userPort,Class,Code,Qualifier,Item,x,y);
         IF (Class=gadgetUp) OR (Class=gadgetDown)
         THEN
            ItemPtr:=Item;
            ID:=ItemPtr^.gadgetID;
            CASE ID OF
               1 : R:=RProp.horizPot/4096;
                   G:=GProp.horizPot/4096;
                   B:=BProp.horizPot/4096;
                   SetRGB4(ViewPort,Farbe,R,G,B);
             | 2 : R:=RProp.horizPot/4096;
                   G:=GProp.horizPot/4096;
                   B:=BProp.horizPot/4096;
                   SetRGB4(ViewPort,Farbe,R,G,B);
             | 3 : R:=RProp.horizPot/4096;
                   G:=GProp.horizPot/4096;
                   B:=BProp.horizPot/4096;
                   SetRGB4(ViewPort,Farbe,R,G,B);
            END (* CASE *);
         ELSE
            Farben[Farbe,1]:=R;Farben[Farbe,2]:=G;Farben[Farbe,3]:=B;
            ClearPointer(CWindow);
            CloseWindow(CWindow);
            EXIT;
         END (* IF *);
      END (* LOOP *);
   END ChangeColors;


   PROCEDURE SetColors (Screen : ScreenPtr;
                        Window : WindowPtr): BOOLEAN;

   VAR Class : IDCMPFlags;
       Code,ID : CARDINAL;
       OldIDCMP : IDCMPFlagSet;
       Qualifier : QualifierSet;
       Item : ADDRESS;
       ItemPtr : GadgetPtr;
       Message : IntuiMessagePtr;
       x,y : INTEGER;
       Changed : BOOLEAN;

   BEGIN
      Changed:=FALSE;
      DisplayColors(Window);
      OldIDCMP:=Window^.idcmpFlags;
      ModifyIDCMP(Window,IDCMPFlagSet{gadgetUp,gadgetDown});
      LOOP
         GetIntuiMessage(Window^.userPort,Class,Code,Qualifier,Item,x,y);
         IF Class=gadgetUp
         THEN
            ItemPtr:=Item;
            ID:=ItemPtr^.gadgetID;
            IF (ID>=0) AND (ID<=15)
            THEN
               Changed:=TRUE;
               ChangeColors(ID);
               EmptyIDCMP(Window^.userPort);
            ELSIF ID=16
            THEN
               EXIT;
            END (* IF *);
         END (* IF *);
      END (* LOOP *);
      ModifyIDCMP(Window,OldIDCMP);
      Window^.firstGadget:=NIL;
      SetRast(Window^.rPort,0);
      RETURN Changed;
   END SetColors;


   PROCEDURE SaveColors (Directory : ARRAY OF CHAR;
                         Exists : BOOLEAN);

   VAR File : String;
       Datei : FileHandlePtr;
       Fehler : INTEGER;

   BEGIN
      Copy(File,Directory,0,Length(Directory));
      Insert(File,last,".colors");
      IF Exists
      THEN
         Datei:=Open(ADR(File),oldFile);
      ELSE
         Datei:=Open(ADR(File),newFile);
      END (* IF *);
      Assert(Datei#NIL,ADR("Kann Farben nicht speichern"));
      Fehler:=Write(Datei,ADR(Farben),SIZE(Farben));
      IF NOT (Fehler>0)
      THEN
         SetMessage(Window," Datei konnte nicht geschrieben werden ! ");
         WriteWindowInt(Window,22,1,Fehler,5);
      END (* IF *);
      Close(Datei);
   END SaveColors;


   PROCEDURE LoadColors (Screen : ScreenPtr;
                         Window : WindowPtr;
                         Dir : ARRAY OF CHAR):BOOLEAN;

   VAR Datei : FileHandlePtr;
       File : String;
       Laenge,Test : INTEGER;
       color : CARDINAL;

   BEGIN
      Copy(File,Dir,0,Length(Dir));
      Insert(File,last,".colors");
      Datei:=Open(ADR(File),oldFile);
      Assert(Datei#NIL,ADR("Kann Farben nicht laden"));
      Laenge:=SIZE(Farben);
      Test:=Read(Datei,ADR(Farben),Laenge);
      IF Test#Laenge
      THEN
         SetMessage(Window," Fehler beim Lesen der Farben ! ");
         WriteWindowInt(Window,22,1,Test,5);
         WriteWindowInt(Window,22,10,Laenge,5);
      END (* IF *);
      Close(Datei);
      FOR color:=0 TO 15 DO
         SetRGB4(ADR(Screen^.viewPort),color,
                 Farben[color,1],Farben[color,2],Farben[color,3]);
      END (* FOR *);
      RETURN NOT SetColors(Screen,Window);
   END LoadColors;


   PROCEDURE SaveList (Dir : ARRAY OF CHAR);

   VAR File : String;
       Datei : FileHandlePtr;
       Fehler : INTEGER;

   BEGIN
      Copy(File,Dir,0,Length(Dir));
      Insert(File,last,"Bahnhfe");
      Datei:=Open(ADR(File),newFile);
      Assert(Datei#NIL,ADR("Kann Bahnhofsliste nicht speichern"));
      Fehler:=Write(Datei,ADR(Names),SIZE(Names));
      IF Fehler<=0
      THEN
         SetMessage(Window," Zahl konnte nicht geschrieben werden ! ");
         WriteWindowInt(Window,22,1,Fehler,5);
      END (* IF *);
      Close(Datei);
   END SaveList;


BEGIN (* ChooseTown *)
   EXCL(Flags,Datum);
   EXCL(Flags,Namen);
   EXCL(Flags,Sortiert);
   SetRast(Window^.rPort,0);
   SetPointer(Window,Wait,16,16,-4,-1);
   SaveNames(Window,Dir,Old);
   Copy(OldTitle,Title,0,Length(Title));
   Title:="Nahverkehrssystem";
   SetWindowTitles(Window,NIL,ADR(Title));
   OldDir:=NIL;
   NewDir:=NIL;
   Copy(Directory,Dir,0,Length(Dir));
   Gadgets:=InitStdGadgets(ADR("Ok     "),FALSE);
   StructWindow(reqWindow,239,0,401,91,0,10,IDCMPFlagSet{gadgetUp},
                WindowFlagSet{windowDrag,activate},ADR("Pfadname auswhlen"),
                Screen,ScreenFlagSet{wbenchScreen});
   reqWindow.firstGadget:=Gadgets;
   ReqWindow:=OpenWindow(reqWindow);
   Assert(ReqWindow#NIL,ADR("Kann Window nicht ffnen"));
   SetPointer(ReqWindow,Mouse,16,16,-4,-1);
   InitList(ReqWindow^.rPort,FALSE);
   IF RequestPath(Directory,FileName,Vorhanden,ReqWindow,NIL,
                  CreateDirEntry,StdHandler)
   THEN (* Ok *)
      INCL(Flags,Stadt);
      EXCL(Flags,Veraendert);
      ClearPointer(ReqWindow);
      CloseWindow(ReqWindow);
      IF NOT Vorhanden
      THEN (* Dir erzeugen *)
         NewDir:=Lock(ADR(Directory),sharedLock);
         Insert(Directory,last,FileName);
         Insert(Directory,last,"/");
         Insert(Title,last," von ");
         Insert(Title,last,FileName);
         SetWindowTitles(Window,NIL,ADR(Title));
         OldDir:=CreateDir(ADR(FileName));
         UnLock(OldDir);
         UnLock(NewDir);
         Dummy:=SetColors(Screen,Window);
         SaveColors(Directory,New);
         Speichern:=TRUE;
         SaveNames(Window,Directory,New);
         Speichern:=FALSE;
         SaveList(Directory);
      ELSE (* Dir vorhanden *)
         start:=Length(Directory)-2;
         REPEAT
            DEC(start);
         UNTIL (Directory[start]=':') OR (Directory[start]='/') OR (start=0);
         IF start=0
         THEN (* Diskette *)
            Copy(FileName,Directory,0,Length(Directory)-1);
         ELSE (* Directory *)
            Copy(FileName,Directory,start+1,Length(Directory)-start-2);
         END (* IF *);
         Insert(Title,last," von ");
         Insert(Title,last,FileName);
         SetWindowTitles(Window,NIL,ADR(Title));
         Copy(File,Directory,0,Length(Directory));
         Insert(File,last,".colors");
         SetPointer(Window,Mouse,16,16,-4,-1);
         OldDir:=Lock(ADR(File),sharedLock);
         IF OldDir#NIL
         THEN
            UnLock(OldDir);
            IF NOT LoadColors(Screen,Window,Directory)
            THEN
               SaveColors(Directory,Old);
            END (* IF *);
         ELSE (* Es gibt keine Farben *)
            UnLock(OldDir);
            Dummy:=SetColors(Screen,Window);
            SaveColors(Directory,New);
         END (* IF *);
         SetPointer(Window,Wait,16,16,-4,-1);
         Copy(File,Directory,0,Length(Directory));
         Insert(File,last,"Bahnhofsnamen");
         OldDir:=Lock(ADR(File),sharedLock);
         IF OldDir#NIL
         THEN
            UnLock(OldDir);
            LoadNames(Directory);
         ELSE (* Es gibt keine Namen - leere Datei speichern *)
            UnLock(OldDir);
            Speichern:=TRUE;
            SaveNames(Window,Directory,New);
            Speichern:=FALSE;
         END (* IF *);
         Copy(File,Directory,0,Length(Directory));
         Insert(File,last,"Bahnhfe");
         OldDir:=Lock(ADR(File),sharedLock);
         IF OldDir=NIL
         THEN (* Es gibt keine Liste - leere Datei speichern *)
            UnLock(OldDir);
            SaveList(Directory);
         END (* IF *);
      END (* IF *);
      Copy(Dir,Directory,0,Length(Directory));
   ELSE (* Cancel *)
      Copy(Title,OldTitle,0,Length(OldTitle));
      SetWindowTitles(Window,NIL,ADR(Title));
      ClearPointer(ReqWindow);
      CloseWindow(ReqWindow);
   END;
   SetPointer(Window,Mouse,16,16,-4,-1);
   SetRast(Window^.rPort,0);
END ChooseTown;


PROCEDURE WriteIFF (Screen : ScreenPtr;
                    Window : WindowPtr;
                    Dir : ARRAY OF CHAR;
                    Date : DATUM;
                    VAR Flags : FLAGSET);

VAR Directory,Titel : String;
    Fehler : BOOLEAN;
    Position : INTEGER;
    Rechteck : Graphics.Rectangle;

BEGIN
   ClearMessage(Window);
   EXCL(Flags,Datum);
   EXCL(Flags,Namen);
   Copy(Directory,Dir,0,Length(Dir));
   Insert(Directory,last,Date);
   WITH Rechteck DO
      minX:=0;
      minY:=0;
      maxX:=639;
      maxY:=255;
   END (* WITH *);
   Fehler:=NOT WriteILBM(Directory,Window^.rPort,ADR(Screen^.viewPort),
                         ADR(Rechteck),TRUE);
   IF Fehler
   THEN
      SetMessage(Window," Fehler beim Speichern des Bildes ");
   END (* IF *);
   (* Hier mssen die Bilddaten gespeichert werden ! *)
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   SetRast(Window^.rPort,0);
END WriteIFF;


PROCEDURE ReadIFF (Screen : ScreenPtr;
                   Window : WindowPtr;
                   Mouse,Wait : MousePtr;
                   Dir : ARRAY OF CHAR;
                   VAR Flags : FLAGSET);

VAR reqWindow : NewWindow;
    ReqWindow : WindowPtr;
    Directory : String;
    FileName : TEXT;
    Vorhanden,Fehler : BOOLEAN;
    Gadgets : GadgetPtr;


BEGIN (* ReadIFF *)
   EXCL(Flags,Datum);
   EXCL(Flags,Namen);
   SetRast(Window^.rPort,0);
   Copy(Directory,Dir,0,Length(Dir));
   Gadgets:=InitListGadgets(NIL,FALSE);
   Gadgets:=InitLoadGadgets(Gadgets,FALSE);
   StructWindow(reqWindow,239,0,401,91,0,10,IDCMPFlagSet{gadgetUp},
                WindowFlagSet{windowDrag,activate},
                ADR("Filename (Datum) auswhlen"),
                Screen,ScreenFlagSet{wbenchScreen});
   reqWindow.firstGadget:=Gadgets;
   ReqWindow:=OpenWindow(reqWindow);
   Assert(ReqWindow#NIL,ADR("Kann Window nicht ffnen"));
   SetPointer(ReqWindow,Mouse,16,16,-4,-1);
   InitList(ReqWindow^.rPort,FALSE);
   IF RequestFile(Directory,FileName,Vorhanden,ReqWindow,NIL,
                  CreateStdEntry,StdHandler)
   THEN
      ClearPointer(ReqWindow);
      CloseWindow(ReqWindow);
      IF Vorhanden
      THEN
         SetPointer(Window,Wait,16,16,-4,-1);
         Insert(Directory,last,FileName);
         Fehler:=NOT LoadILBM(Directory,Screen,NIL);
         IF Fehler
         THEN
            SetMessage(Window," Fehler beim Laden des Bildes ");
         END (* IF *);
         SetPointer(Window,Mouse,16,16,-4,-1);
         (* Hier mssen die Bilddaten geladen werden ! *)
      END (* IF *);
   ELSE
      ClearPointer(ReqWindow);
      CloseWindow(ReqWindow);
   END;

END ReadIFF;


PROCEDURE EndAll (Screen : ScreenPtr;
                  Window : WindowPtr;
                  Mouse : MousePtr;
                  Dir : ARRAY OF CHAR;
                  Flags : FLAGSET);

BEGIN
   SaveNames(Window,Dir,TRUE);
   ClearPointer(Window);
   Deallocate(Mouse);
   CloseWindow(Window);
   CloseScreen(Screen);
END EndAll;


BEGIN (* Modul *)
   IntuiStruct.AllocProc:=AllocMem;
   IntuiStruct.DeallocProc:=Deallocate;
   SuperLists.AllocProc:=Allocate;
   SuperLists.DeallocProc:=Deallocate;
   FileRequest.AllocProc:=Allocate;
   FileRequest.DeallocProc:=Deallocate;
END Diskette.
