(*********************************************************************
 *
 *  :Program.    Hilfsmittel.mod
 *  :Project.    Nahverkehrssystem
 *  :Author.     Ingo Goldak
 *  :Address.    Hohenzollerndamm 8
 *  :Address.    1000 Berlin 31
 *  :Copyright.  PD
 *  :Language.   Modula-II
 *  :Translator. M2Amiga V3.3d
 *  :Imports.    IDCMP, IntuiStruct [AMOK]
 *  :Imports.    WindowInOut, Werkzeuge, Initializations [Ingo Goldak]
 *  :Contents.   PROCEDUREn fr mehrere Module
 *  :History. V1.0 [Ingo Goldak] 30.03.90
 *
 *********************************************************************)

IMPLEMENTATION MODULE Hilfsmittel;

FROM SYSTEM IMPORT
     ADR,ADDRESS;
FROM Arts IMPORT
     Assert;
FROM Intuition IMPORT
     ScreenPtr,WindowPtr,IDCMPFlags,IDCMPFlagSet,WindowFlags,WindowFlagSet,
     NewWindow,OpenWindow,CloseWindow,SetPointer,ClearPointer,ModifyIDCMP,
     ScreenFlags,ScreenFlagSet;
FROM Graphics IMPORT
     SetAPen,SetBPen;
FROM Dos IMPORT
     FileHandlePtr,Open,Close,Read,Seek,Write,oldFile,beginning,end;
FROM InputEvent IMPORT
     QualifierSet;
FROM Strings IMPORT
     Copy,Compare,Insert,Length,last;
FROM Conversions IMPORT
     StrToVal,ValToStr;
FROM WindowInOut IMPORT
     WriteWindowString,ReadWindowString,input;
FROM IDCMP IMPORT
     GetIntuiMessage,EmptyIDCMP;
FROM IntuiStruct IMPORT
     StructWindow;
FROM Werkzeuge IMPORT
     Names,List,MAXY,
     String,DATUM,DATUMSLISTE,TEXT,DATENSATZ,DISPLAYLIST,LISTELEMENT;
FROM Initializations IMPORT
     MousePtr;


PROCEDURE ClearMessage (Window : WindowPtr);

BEGIN
   SetBPen(Window^.rPort,0);
   WriteWindowString(Window,23,0,
   "                                                      ");
END ClearMessage;


PROCEDURE SetMessage (Window : WindowPtr;
                      Text : ARRAY OF CHAR);

BEGIN
   ClearMessage(Window);
   SetAPen(Window^.rPort,4);
   SetBPen(Window^.rPort,2);
   WriteWindowString(Window,23,0,Text);
END SetMessage;


PROCEDURE InsertName (Name : TEXT;
                      Position : CARDINAL;
                      Record : CARDINAL);

VAR Zaehler : CARDINAL;
    Hilf : LISTELEMENT;

BEGIN
   IF Position<=Names
   THEN
      FOR Zaehler:=Names TO Position BY -1 DO
         Hilf:=List[Zaehler];
         List[Zaehler+1]:=Hilf;
      END (* FOR *);
   END (* IF *);
   List[Position].Namen:=Name;
   List[Position].Nummer:=Record;
   INC(Names);
END InsertName;


PROCEDURE SucheDatensatz (Name : TEXT;
                          VAR Record : CARDINAL;
                          VAR Position : CARDINAL;
                          VAR Gefunden : BOOLEAN);

VAR Test : INTEGER;
    Pos : CARDINAL;

   PROCEDURE Suche (Anfang,Ende : CARDINAL;
                    Name : TEXT;
                    VAR Pos : CARDINAL);

   VAR Mitte : CARDINAL;
       Vergleich : INTEGER;

   BEGIN
      CASE (Ende-Anfang) OF
         0 : Pos:=Ende;
       | 1 : IF Anfang=1
             THEN
                Vergleich:=Compare(List[2].Namen,0,Length(Name),Name,TRUE);
                IF Vergleich=0
                THEN
                   IF Length(List[2].Namen)=Length(Name)
                   THEN
                      Pos:=2;
                   ELSE
                      Pos:=1;
                   END (* IF *);
                ELSIF Vergleich>0
                THEN
                   Pos:=2;
                ELSE
                   Pos:=1;
                END (* IF *);
             ELSE
                Pos:=Ende;
             END (* IF *);
      ELSE
         Mitte:=(Ende+Anfang)/2;
         Vergleich:=Compare(List[Mitte].Namen,0,Length(Name),Name,TRUE);
         IF Vergleich=0
         THEN
            IF Length(List[Mitte].Namen)=Length(Name)
            THEN
               Pos:=Mitte;
            ELSE
               Suche(Anfang,Mitte,Name,Pos);
            END (* IF *);
         ELSIF Vergleich>0
         THEN
            Suche(Mitte,Ende,Name,Pos);
         ELSE
            Suche(Anfang,Mitte,Name,Pos);
         END (* IF *);
      END (* CASE *);
   END Suche;

BEGIN (* SucheDatensatz *)
   IF Names>0
   THEN
      Suche(1,Names,Name,Pos);
      Test:=Compare(List[Pos].Namen,0,Length(Name),Name,TRUE);
      IF Test=0
      THEN
         IF Length(List[Pos].Namen)=Length(Name)
         THEN
            Gefunden:=TRUE;
            Record:=List[Pos].Nummer;
            Position:=Pos;
         ELSE
            Gefunden:=FALSE;
            Record:=Names+1;
            Position:=Pos;
         END (* IF *);
      ELSIF Test>0
      THEN
         Gefunden:=FALSE;
         Record:=Names+1;
         Position:=Pos+1;
      ELSE
         Gefunden:=FALSE;
         Record:=Names+1;
         Position:=Pos;
      END (* IF *);
   ELSE
      Gefunden:=FALSE;
      Record:=1;
      Position:=1;
   END (* IF *);
END SucheDatensatz;


PROCEDURE LeseDatensatz (Window : WindowPtr;
                         Position : CARDINAL;
                         Dir : ARRAY OF CHAR;
                         VAR Daten : DATENSATZ);

VAR File : ARRAY [0..255] OF CHAR;
    Datei : FileHandlePtr;
    Ziel : LONGCARD;
    Fehler,Dummy : LONGINT;

BEGIN
    Copy(File,Dir,0,Length(Dir));
    Insert(File,last,"Bahnhfe");
    Datei:=Open(ADR(File),oldFile);
    Ziel:=2+(LONGCARD(SIZE(Daten))*LONGCARD(Position-1));
    Dummy:=Seek(Datei,Ziel,beginning);
    Fehler:=Read(Datei,ADR(Daten),SIZE(Daten));
    IF Fehler<=0
    THEN
       SetMessage(Window," Fehler beim Lesen ! ");
    END (* IF *);
    Close(Datei);
END LeseDatensatz;


PROCEDURE DisplayBoolean (Window : WindowPtr;
                          Line,Column,Farbe : CARDINAL;
                          Datum : BOOLEAN);

BEGIN
   SetAPen(Window^.rPort,Farbe);
   SetBPen(Window^.rPort,0);
   IF Datum
   THEN
      WriteWindowString(Window,Line,Column,"Ja");
   ELSE
      WriteWindowString(Window,Line,Column,"Nein");
   END (* IF *);
END DisplayBoolean;


PROCEDURE SucheDatum (Datum : LONGCARD;
                      Liste : DATUMSLISTE;
                      Laenge : CARDINAL;
                      VAR Record : CARDINAL;
                      VAR Position : CARDINAL;
                      VAR Gefunden : BOOLEAN);

VAR Test : INTEGER;
    Pos : CARDINAL;

   PROCEDURE Suche (Anfang,Ende : CARDINAL;
                    Datum : LONGCARD;
                    VAR Pos : CARDINAL);

   VAR Mitte : CARDINAL;
       Vergleich : INTEGER;

   BEGIN
      CASE (Ende-Anfang) OF
         0 : Pos:=Ende;
       | 1 : IF Anfang=1
             THEN
                IF Liste[2].Datum1=Datum
                THEN
                   Pos:=2;
                ELSIF Liste[2].Datum1<Datum
                THEN
                   Pos:=2;
                ELSE
                   Pos:=1;
                END (* IF *);
             ELSE
                Pos:=Ende;
             END (* IF *);
      ELSE
         Mitte:=(Ende+Anfang)/2;
         IF Liste[Mitte].Datum1=Datum
         THEN
            Pos:=Mitte;
         ELSIF Liste[Mitte].Datum1<Datum
         THEN
            Suche(Mitte,Ende,Datum,Pos);
         ELSE
            Suche(Anfang,Mitte,Datum,Pos);
         END (* IF *);
      END (* CASE *);
   END Suche;

BEGIN (* SucheDatum *)
   IF Laenge>0
   THEN
      Suche(1,Laenge,Datum,Pos);
      IF Liste[Pos].Datum1=Datum
      THEN
         Gefunden:=TRUE;
         Record:=List[Pos].Nummer;
         Position:=Pos;
      ELSIF Liste[Pos].Datum1<Datum
      THEN
         Gefunden:=FALSE;
         Record:=Names+1;
         Position:=Pos+1;
      ELSE
         Gefunden:=FALSE;
         Record:=Names+1;
         Position:=Pos;
      END (* IF *);
   ELSE
      Gefunden:=FALSE;
      Record:=1;
      Position:=1;
   END (* IF *);
END SucheDatum;


PROCEDURE ReadDatum (Window : WindowPtr;
                     Line,Column,Farbe : CARDINAL;
                     VAR Variable : DATUM);


VAR RastPort : ADDRESS;
    Fehler : BOOLEAN;

BEGIN
   RastPort:=Window^.rPort;
   REPEAT
      SetAPen(RastPort,Farbe);
      SetBPen(RastPort,0);
      ReadWindowString(Window,Line,Column,Variable);
      ClearMessage(Window);
      IF input
      THEN
         Fehler:=CheckDatum(Window,Variable);
         IF Fehler
         THEN
            SetMessage(Window,' Das Eingabemuster ist: "tt. Monat 19jj" ! ');
         END (* IF *);
      ELSE
         Fehler:=FALSE;
      END (* IF *);
   UNTIL NOT Fehler;
END ReadDatum;


PROCEDURE CheckDatum (Window : WindowPtr;
                      Datum : DATUM):BOOLEAN;


VAR Fehler,Vorzeichen : BOOLEAN;
    Monat : ARRAY [1..12] OF BOOLEAN;
    TeilDatum : ARRAY [0..4] OF CHAR;
    Laenge,Ergebnis : INTEGER;
    LongInt : LONGINT;
    Tag,Jahr : CARDINAL;


BEGIN
   Laenge:=Length(Datum);
   IF ((Laenge<12) OR (Laenge>18))
   THEN
      RETURN TRUE;
   END (* IF *);
   Ergebnis:=Compare(Datum,2,2,". ",TRUE);
   IF ((Ergebnis#0) OR (Datum[Laenge-5]#' '))
   THEN
      RETURN TRUE;
   END (* IF *);
   Copy(TeilDatum,Datum,0,2);
   StrToVal(TeilDatum,LongInt,Vorzeichen,10,Fehler);
   Tag:=LongInt;
   IF Fehler
   THEN
      RETURN TRUE;
   END (* IF *);
   IF ((Tag=0) OR (Tag>31))
   THEN
      RETURN TRUE;
   END (* IF *);
   Copy(TeilDatum,Datum,Laenge-4,4);
   StrToVal(TeilDatum,LongInt,Vorzeichen,10,Fehler);
   Jahr:=LongInt;
   IF Fehler
   THEN
      RETURN TRUE;
   END (* IF *);
   IF ((Jahr<1900) OR (Jahr>2100))
   THEN
      RETURN TRUE;
   END (* IF *);
   Monat[1]:=(Compare(Datum,4,Laenge-9,"Januar",TRUE)=0);
   Monat[2]:=(Compare(Datum,4,Laenge-9,"Februar",TRUE)=0);
   Monat[3]:=(Compare(Datum,4,Laenge-9,"Mrz",TRUE)=0);
   Monat[4]:=(Compare(Datum,4,Laenge-9,"April",TRUE)=0);
   Monat[5]:=(Compare(Datum,4,Laenge-9,"Mai",TRUE)=0);
   Monat[6]:=(Compare(Datum,4,Laenge-9,"Juni",TRUE)=0);
   Monat[7]:=(Compare(Datum,4,Laenge-9,"Juli",TRUE)=0);
   Monat[8]:=(Compare(Datum,4,Laenge-9,"August",TRUE)=0);
   Monat[9]:=(Compare(Datum,4,Laenge-9,"September",TRUE)=0);
   Monat[10]:=(Compare(Datum,4,Laenge-9,"Oktober",TRUE)=0);
   Monat[11]:=(Compare(Datum,4,Laenge-9,"November",TRUE)=0);
   Monat[12]:=(Compare(Datum,4,Laenge-9,"Dezember",TRUE)=0);
   IF (NOT Monat[1] AND NOT Monat[2] AND NOT Monat[3] AND NOT Monat[4]
   AND NOT Monat[5] AND NOT Monat[6] AND NOT Monat[7] AND NOT Monat[8]
   AND NOT Monat[9] AND NOT Monat[10] AND NOT Monat[11] AND NOT Monat[12])
   THEN
      RETURN TRUE;
   END (* IF *);
   RETURN FALSE;
END CheckDatum;


PROCEDURE ConvertDatum (Datum : DATUM):LONGCARD;

VAR Tag,Monat,Jahr : DATUM;
    Zahl : LONGCARD;
    Wert : LONGINT;
    Fehler,Vorzeichen : BOOLEAN;
    Laenge : INTEGER;

BEGIN
    Vorzeichen:=FALSE;
    Laenge:=Length(Datum);
    Copy(Tag,Datum,0,2);
    Copy(Monat,Datum,4,Laenge-9);
    Copy(Jahr,Datum,Laenge-4,4);
    StrToVal(Tag,Wert,Vorzeichen,10,Fehler);
    IF Compare(Monat,0,6,"Januar",TRUE)=0
    THEN
       Zahl:=Wert+100;
    ELSIF Compare(Monat,0,7,"Februar",TRUE)=0
    THEN
       Zahl:=Wert+200;
    ELSIF Compare(Monat,0,4,"Mrz",TRUE)=0
    THEN
       Zahl:=Wert+300;
    ELSIF Compare(Monat,0,5,"April",TRUE)=0
    THEN
       Zahl:=Wert+400;
    ELSIF Compare(Monat,0,3,"Mai",TRUE)=0
    THEN
       Zahl:=Wert+500;
    ELSIF Compare(Monat,0,4,"Juni",TRUE)=0
    THEN
       Zahl:=Wert+600;
    ELSIF Compare(Monat,0,4,"Juli",TRUE)=0
    THEN
       Zahl:=Wert+700;
    ELSIF Compare(Monat,0,6,"August",TRUE)=0
    THEN
       Zahl:=Wert+800;
    ELSIF Compare(Monat,0,9,"September",TRUE)=0
    THEN
       Zahl:=Wert+900;
    ELSIF Compare(Monat,0,7,"Oktober",TRUE)=0
    THEN
       Zahl:=Wert+1000;
    ELSIF Compare(Monat,0,8,"November",TRUE)=0
    THEN
       Zahl:=Wert+1100;
    ELSIF Compare(Monat,0,8,"Dezember",TRUE)=0
    THEN
       Zahl:=Wert+1200;
    END (* IF *);
    StrToVal(Jahr,Wert,Vorzeichen,10,Fehler);
    Zahl:=Zahl+LONGCARD(10000*Wert);
    RETURN Zahl;
END ConvertDatum;


PROCEDURE ConvertZahl (Zahl : LONGCARD;
                       VAR Datum : DATUM);

VAR Wert : DATUM;
    Tag,Monat,Jahr : CARDINAL;
    Fehler : BOOLEAN;

BEGIN
   Tag:=Zahl MOD 100;
   Zahl:=Zahl DIV 100;
   Monat:=Zahl MOD 100;
   Jahr:=Zahl DIV 100;
   ValToStr(Tag,FALSE,Datum,10,2,'0',Fehler);
   CASE Monat OF
      1 : Insert(Datum,last,". Januar ");
    | 2 : Insert(Datum,last,". Februar ");
    | 3 : Insert(Datum,last,". Mrz ");
    | 4 : Insert(Datum,last,". April ");
    | 5 : Insert(Datum,last,". Mai ");
    | 6 : Insert(Datum,last,". Juni ");
    | 7 : Insert(Datum,last,". Juli ");
    | 8 : Insert(Datum,last,". August ");
    | 9 : Insert(Datum,last,". September ");
    | 10 : Insert(Datum,last,". Oktober ");
    | 11 : Insert(Datum,last,". November ");
    | 12 : Insert(Datum,last,". Dezember ");
   END (* CASE *);
   ValToStr(Jahr,FALSE,Wert,10,4,'0',Fehler);
   Insert(Datum,last,Wert);
END ConvertZahl;


PROCEDURE RequestNet (Window : WindowPtr;
                      Screen : ScreenPtr;
                      Mouse : MousePtr;
                      Dir : ARRAY OF CHAR;
                      Display : DISPLAYLIST;
                      Entries : CARDINAL);

VAR Info : WindowPtr;
    info : NewWindow;
    Druckstring : String;
    Datensatz : DATENSATZ;
    Code,Position,Zeilen : CARDINAL;
    Qualifier : QualifierSet;
    Item : ADDRESS;
    X,Y : INTEGER;
    Class : IDCMPFlags;
    MyIDCMPFlags : IDCMPFlagSet;

    PROCEDURE SuchePunkt (Display : DISPLAYLIST;
                          Entries : CARDINAL;
                          XMouse,YMouse : CARDINAL;
                          VAR Position : CARDINAL): BOOLEAN;

    VAR Gefunden : BOOLEAN;
        Zeiger : CARDINAL;

    BEGIN
       Gefunden:=FALSE;
       Zeiger:=1;
       WHILE (Zeiger<=Entries) AND NOT Gefunden DO
          IF (Display[2,Zeiger]=XMouse) AND (Display[3,Zeiger]=YMouse)
          THEN
             Gefunden:=TRUE;
             Position:=Display[1,Zeiger];
          END (* IF *);
          INC(Zeiger);
       END (* WHILE *);
       RETURN Gefunden;
    END SuchePunkt;


BEGIN (* RequestNet *)
   MyIDCMPFlags:=Window^.idcmpFlags;
   ModifyIDCMP(Window,IDCMPFlagSet{mouseButtons});
   LOOP
      GetIntuiMessage(Window^.userPort,Class,Code,Qualifier,Item,X,Y);
      IF (Class=mouseButtons)
      THEN
         IF (Y>=0) AND (Y<MAXY)
         THEN
            IF SuchePunkt(Display,Entries,X,Y,Position)
            THEN
               LeseDatensatz(Window,Position,Dir,Datensatz);
               StructWindow(info,280,176,360,80,0,10,IDCMPFlagSet{closeWindow},
                            WindowFlagSet{windowClose,windowDrag,activate},
                            ADR(Datensatz.Namen),Screen,
                            ScreenFlagSet{wbenchScreen});
               Info:=OpenWindow(info);
               Assert(Info#NIL,ADR("Kann Window nicht ffnen !"));
               SetPointer(Info,Mouse,16,16,-4,-1);
               WITH Datensatz DO
                  SetAPen(Info^.rPort,NeueLinie);
                  SetBPen(Info^.rPort,0);
                  IF AusgHinten
                  THEN
                     Druckstring:="hinten";
                     IF AusgMitte
                     THEN
                        Insert(Druckstring,0,"mitte, ");
                     END (* IF *);
                     IF AusgVorne
                     THEN
                        Insert(Druckstring,0,"vorne, ");
                     END (* IF *);
                  ELSIF AusgMitte
                  THEN
                     Druckstring:="mitte";
                     IF AusgVorne
                     THEN
                        Insert(Druckstring,0,"vorne, ");
                     END (* IF *);
                  ELSIF AusgVorne
                  THEN
                     Druckstring:="vorne";
                  END (* IF *);
                  Insert(Druckstring,0,"Ausgang: ");
                  WriteWindowString(Info,1,1,Druckstring);
                  IF KehrVorne OR KehrHinten
                  THEN
                     IF KehrHinten
                     THEN
                        Druckstring:="hinten";
                        IF KehrVorne
                        THEN
                           Insert(Druckstring,0,"vorne, ");
                        END (* IF *);
                     ELSE
                        Druckstring:="vorne";
                     END (* IF *);
                     Insert(Druckstring,0,"Kehranlage: ");
                     WriteWindowString(Info,2,1,Druckstring);
                     Zeilen:=3;
                  ELSE
                     Zeilen:=2;
                  END (* IF *);
                  Druckstring:="";
                  Insert(Druckstring,0,OpenDate);
                  Insert(Druckstring,last," - ");
                  Insert(Druckstring,last,CloseDate);
                  WriteWindowString(Info,Zeilen,1,Druckstring);
                  Druckstring:="";
                  Insert(Druckstring,0,Bahnsteigart);
                  Insert(Druckstring,last,"bahnsteig");
                  IF Umsteigen
                  THEN
                     Insert(Druckstring,last,", Umsteigebahnhof");
                  END (* IF *);
                  WriteWindowString(Info,Zeilen+1,1,Druckstring);
                  Druckstring:="Linie ";
                  Insert(Druckstring,last,AlteLinie);
                  Insert(Druckstring,last,", ");
                  Insert(Druckstring,last,Profil);
                  Insert(Druckstring,last,"profil,  Kurzzeichen: ");
                  Insert(Druckstring,last,KurzZeichen);
                  WriteWindowString(Info,Zeilen+2,1,Druckstring);
                  Druckstring:="";
                  Insert(Druckstring,0,BauForm);
                  Insert(Druckstring,last,"strecke, Tiefenlage: ");
                  WriteWindowString(Info,Zeilen+3,1,Druckstring);
                  Druckstring:="";
                  Insert(Druckstring,0,Bahnform);
                  Insert(Druckstring,last,"-Bahn, der Bahnhof ist ");
                  Insert(Druckstring,last,Veraendert);
                  WriteWindowString(Info,Zeilen+4,1,Druckstring);
               END (* WITH *);
               LOOP
                  GetIntuiMessage(Info^.userPort,Class,Code,Qualifier,Item,X,Y);
                  IF (Class=closeWindow)
                  THEN
                     EXIT;
                  END (* IF *);
               END (* LOOP *);
               ClearPointer(Info);
               CloseWindow(Info);
               EmptyIDCMP(Window^.userPort);
            END (* IF *);
         ELSE
            EXIT;
         END (* IF *);
      END (* IF *);
   END (* LOOP *);
   ModifyIDCMP(Window,MyIDCMPFlags);
   SetMessage(Window," Information beendet ");
END RequestNet;


END Hilfsmittel.
