(*********************************************************************
 *
 *  :Program.    Initializations.mod
 *  :Project.    Nahverkehrssystem
 *  :Author.     Ingo Goldak
 *  :Address.    Hohenzollerndamm 8
 *  :Address.    1000 Berlin 31
 *  :Copyright.  PD
 *  :Language.   Modula-II
 *  :Translator. M2Amiga V3.3d
 *  :Imports.    MemSystem, IntuiStruct [AMOK]
 *  :Imports.    Werkzeuge [Ingo Goldak]
 *  :Contents.   PROCEDUREn zur Initialisierung
 *  :History. V1.0 [Ingo Goldak] 30.03.90
 *
 *********************************************************************)

IMPLEMENTATION MODULE Initializations;

FROM SYSTEM IMPORT
     ADR,ADDRESS,LONGSET;
FROM Intuition IMPORT
     NewScreen,OpenScreen,ScreenFlagSet,ScreenFlags,
     MenuItem,Menu,MenuItemFlags,MenuItemFlagSet,menuEnabled,IntuiText,
     NewWindow,OpenWindow,WindowFlags,WindowFlagSet,IDCMPFlags,IDCMPFlagSet,
     MenuPtr,MenuItemPtr,IntuiTextPtr,ScreenPtr,WindowPtr;
FROM Graphics IMPORT
     jam1,ViewModes,ViewModeSet,SetRGB4;
FROM MemSystem IMPORT
     AllocMem,Deallocate;
FROM IntuiStruct IMPORT
     StructScreen,StructWindow,LinkMenu,Item,AllocProc,DeallocProc;
FROM Werkzeuge IMPORT
     Farben,Title;


PROCEDURE InitMouse (VAR Mouse : MousePtr);

BEGIN
   AllocMem(Mouse,SIZE(MOUSEDATA),TRUE);
   Mouse^[0]:=0;        Mouse^[1]:=0;
   Mouse^[2]:=255;      Mouse^[3]:=255;
   Mouse^[4]:=4350;     Mouse^[5]:=254;
   Mouse^[6]:=14534;    Mouse^[7]:=10494;
   Mouse^[8]:=14534;    Mouse^[9]:=14590;
   Mouse^[10]:=14534;   Mouse^[11]:=14590;
   Mouse^[12]:=14534;   Mouse^[13]:=14590;
   Mouse^[14]:=14590;   Mouse^[15]:=14590;
   Mouse^[16]:=65535;   Mouse^[17]:=65535;
   Mouse^[18]:=65535;   Mouse^[19]:=65535;
   Mouse^[20]:=65535;   Mouse^[21]:=65535;
   Mouse^[22]:=65535;   Mouse^[23]:=65535;
   Mouse^[24]:=65535;   Mouse^[25]:=65535;
   Mouse^[26]:=65535;   Mouse^[27]:=65535;
   Mouse^[28]:=15420;   Mouse^[29]:=15420;
   Mouse^[30]:=15420;   Mouse^[31]:=15420;
   Mouse^[32]:=6168;    Mouse^[33]:=6168;
   Mouse^[34]:=0;       Mouse^[35]:=0;
END InitMouse;


PROCEDURE InitWait (VAR Mouse : MousePtr);

BEGIN
   AllocMem(Mouse,SIZE(MOUSEDATA),TRUE);
   Mouse^[0]:=0;    Mouse^[1]:=0;
   Mouse^[2]:=0;    Mouse^[3]:=0;
   Mouse^[4]:=0;    Mouse^[5]:=0;
   Mouse^[6]:=0;    Mouse^[7]:=0;
   Mouse^[8]:=0;    Mouse^[9]:=0;
   Mouse^[10]:=0;   Mouse^[11]:=0;
   Mouse^[12]:=0;   Mouse^[13]:=0;
   Mouse^[14]:=0;   Mouse^[15]:=0;
   Mouse^[16]:=0;   Mouse^[17]:=0;
   Mouse^[18]:=0;   Mouse^[19]:=0;
   Mouse^[20]:=0;   Mouse^[21]:=0;
   Mouse^[22]:=0;   Mouse^[23]:=0;
   Mouse^[24]:=0;   Mouse^[25]:=0;
   Mouse^[26]:=0;   Mouse^[27]:=0;
   Mouse^[28]:=0;   Mouse^[29]:=0;
   Mouse^[30]:=0;   Mouse^[31]:=0;
   Mouse^[32]:=0;   Mouse^[33]:=0;
   Mouse^[34]:=0;   Mouse^[35]:=0;
(*   Mouse^[0]:=0;        Mouse^[1]:=0;
   Mouse^[2]:=0;        Mouse^[3]:=0;
   Mouse^[4]:=0;        Mouse^[5]:=0;
   Mouse^[6]:=9362;     Mouse^[7]:=9362;
   Mouse^[8]:=9362;     Mouse^[9]:=9362;
   Mouse^[10]:=65535;   Mouse^[11]:=0;
   Mouse^[12]:=9362;    Mouse^[13]:=9362;
   Mouse^[14]:=9362;    Mouse^[15]:=9362;
   Mouse^[16]:=9362;    Mouse^[17]:=9362;
   Mouse^[18]:=9362;    Mouse^[19]:=9362;
   Mouse^[20]:=9362;    Mouse^[21]:=9362;
   Mouse^[22]:=9362;    Mouse^[23]:=9362;
   Mouse^[24]:=65535;   Mouse^[25]:=0;
   Mouse^[26]:=9362;    Mouse^[27]:=9362;
   Mouse^[28]:=9362;    Mouse^[29]:=9362;
   Mouse^[30]:=0;       Mouse^[31]:=0;
   Mouse^[32]:=0;       Mouse^[33]:=0;
   Mouse^[34]:=0;       Mouse^[35]:=0; *)
END InitWait;


PROCEDURE InitColors (Screen : ScreenPtr);

VAR ViewPort : ADDRESS;
    color : CARDINAL;

BEGIN
   Farben[0,1]:=15;Farben[0,2]:=15;Farben[0,3]:=15;
   Farben[1,1]:=8;Farben[1,2]:=10;Farben[1,3]:=0;
   Farben[2,1]:=13;Farben[2,2]:=0;Farben[2,3]:=0;
   Farben[3,1]:=0;Farben[3,2]:=5;Farben[3,3]:=0;
   Farben[4,1]:=13;Farben[4,2]:=12;Farben[4,3]:=0;
   Farben[5,1]:=9;Farben[5,2]:=6;Farben[5,3]:=5;
   Farben[6,1]:=9;Farben[6,2]:=0;Farben[6,3]:=8;
   Farben[7,1]:=3;Farben[7,2]:=10;Farben[7,3]:=12;
   Farben[8,1]:=6;Farben[8,2]:=0;Farben[8,3]:=8;
   Farben[9,1]:=15;Farben[9,2]:=6;Farben[9,3]:=0;
   Farben[10,1]:=0;Farben[10,2]:=0;Farben[10,3]:=0;
   Farben[11,1]:=15;Farben[11,2]:=3;Farben[11,3]:=5;
   Farben[12,1]:=5;Farben[12,2]:=8;Farben[12,3]:=0;
   Farben[13,1]:=5;Farben[13,2]:=6;Farben[13,3]:=12;
   Farben[14,1]:=11;Farben[14,2]:=9;Farben[14,3]:=6;
   Farben[15,1]:=12;Farben[15,2]:=0;Farben[15,3]:=14;
   ViewPort:=ADR(Screen^.viewPort);
   FOR color:=0 TO 15 DO
      SetRGB4(ViewPort,color,Farben[color,1],Farben[color,2],Farben[color,3]);
   END (* FOR *);
END InitColors;


PROCEDURE InitScreen (VAR Screen : ScreenPtr);

VAR screen : NewScreen;

BEGIN
   Title:="Nahverkehrssystem - keine Stadt gewhlt";
   StructScreen(screen,4,10,0,ViewModeSet{hires},ScreenFlagSet{wbenchScreen},
                ADR(Title));
   Screen:=OpenScreen(screen);
END InitScreen;


PROCEDURE InitWindow (VAR Window : WindowPtr;
                      Screen : ScreenPtr);

VAR window : NewWindow;

BEGIN
   StructWindow(window,0,10,640,246,4,10,IDCMPFlagSet{},
                WindowFlagSet{borderless,activate,reportMouse},
                NIL,Screen,ScreenFlagSet{wbenchScreen});
   Window:=OpenWindow(window);
END InitWindow;


PROCEDURE InitMenu (VAR Menue : MenuPtr);

BEGIN (* InitMenu *)
   Item(ADR(" Schirm lschen "),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Ende           "),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bild Laden     "),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bild Speichern "),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Stadt auswhlen"),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Farbprobe      "),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   IF NOT LinkMenu(Menue,ADR("Diskette "),481,72,TRUE)
   THEN
      Menue:=NIL
   END;
   Item(ADR(" Schirm lschen   "),152,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Schliedaten D   "),152,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Schliedaten B   "),152,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Erffnungsdaten D"),152,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Erffnungsdaten B"),152,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bahnhofsnamen D  "),152,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bahnhofsnamen B  "),152,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   IF NOT LinkMenu(Menue,ADR("Listen "),380,56,TRUE)
   THEN
      Menue:=NIL
   END;
   Item(ADR(" Schirm lschen"),128,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Drucker       "),128,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bildschirm    "),128,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   IF NOT LinkMenu(Menue,ADR("Zeichnen "),263,72,TRUE)
   THEN
      Menue:=NIL
   END;
   Item(ADR(" Schirm lschen "),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Erffnungsdaten"),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bahnhofsnamen  "),136,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   IF NOT LinkMenu(Menue,ADR("Sortieren "),138,80,TRUE)
   THEN
      Menue:=NIL
   END;
   Item(ADR(" Schirm lschen    "),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bahnhof kopieren  "),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bahnhof umbenennen"),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Bahnhof lschen   "),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Drucken           "),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" ndern/Eingabe    "),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Speichern         "),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   Item(ADR(" Laden             "),160,
        MenuItemFlagSet{itemText,itemEnabled,highComp},LONGSET{},CHAR(0));
   IF NOT LinkMenu(Menue,ADR("Datenblatt "),10,88,TRUE)
   THEN
      Menue:=NIL
   END;
END InitMenu;


PROCEDURE SetMenu (Menue : MenuPtr;
                   x,y : CARDINAL;
                   on : BOOLEAN);

VAR suchx,suchy : CARDINAL;
    Menu : MenuPtr;
    Item : MenuItemPtr;
    fehler : BOOLEAN;

BEGIN
   fehler:=FALSE;
   suchx:=1;
   suchy:=0;
   Menu:=Menue;
   IF x#0
   THEN
      WHILE suchx#x DO
         IF Menu^.nextMenu#NIL
         THEN
            Menu:=Menu^.nextMenu;
            suchx:=suchx+1
         ELSE
            suchx:=x;
            fehler:=TRUE
         END; (* IF *)
      END; (* WHILE *)
      IF NOT fehler
      THEN
         IF y#0
         THEN
            suchy:=1;
            Item:=Menu^.firstItem;
            WHILE suchy#y DO
               IF Item^.nextItem#NIL
               THEN
                  Item:=Item^.nextItem;
                  suchy:=suchy+1
               ELSE
                  suchy:=y;
                  fehler:=TRUE
               END; (* IF *)
            END; (* WHILE *)
            IF NOT fehler
            THEN
               IF on
               THEN Item^.flags:=MenuItemFlagSet{itemText,itemEnabled,highComp};
               ELSE Item^.flags:=MenuItemFlagSet{itemText,highComp}
               END; (* IF *)
            END (* IF *)
         ELSE
            IF on
            THEN
               Item:=Menu^.firstItem;
               WHILE Item#NIL DO
                  Item^.flags:=MenuItemFlagSet{itemText,itemEnabled,highComp};
                  Item:=Item^.nextItem;
               END (* WHILE *)
            ELSE
               Item:=Menu^.firstItem;
               WHILE Item#NIL DO
                  Item^.flags:=MenuItemFlagSet{itemText,highComp};
                  Item:=Item^.nextItem;
               END; (* WHILE *)
            END; (* IF *)
         END; (* IF *)
      END (* IF *)
   END; (* IF *)
END SetMenu;


BEGIN
   AllocProc:=AllocMem;
   DeallocProc:=Deallocate;
END Initializations.
