(*********************************************************************
 *
 *  :Program.    Listen.mod
 *  :Project.    Nahverkehrssystem
 *  :Author.     Ingo Goldak
 *  :Address.    Hohenzollerndamm 8
 *  :Address.    1000 Berlin 31
 *  :Copyright.  PD
 *  :Language.   Modula-II
 *  :Translator. M2Amiga V3.3d
 *  :Imports.    PrinterSupport [AMOK]
 *  :Imports.    WindowInOut, Werkzeuge, Hilfsmittel [Ingo Goldak]
 *  :Contents.   PROCEDUREn fr Menu 'Listen'
 *  :History. V1.0 [Ingo Goldak] 30.03.90
 *
 *********************************************************************)

IMPLEMENTATION MODULE Listen;

FROM SYSTEM IMPORT
     ADR,ADDRESS;
FROM Intuition IMPORT
     WindowPtr,SetWindowTitles;
FROM Graphics IMPORT
     SetRast,Draw,Move,SetAPen,SetBPen;
FROM ASCII IMPORT
     eol;
FROM Strings IMPORT
     Insert,Occurs,Length,Copy,last;
FROM Conversions IMPORT
     ValToStr;
FROM WindowInOut IMPORT
     WriteWindowString,WriteWindowCard,GetChar;
FROM PrinterSupport IMPORT
     OpenPrinter,ClosePrinter,PrintLine,PrintCommand,PrintChar;
FROM Werkzeuge IMPORT
     Names,List,Title,
     String,FLAGS,FLAGSET,LISTE,LISTELEMENT,DATUMSLISTE,DATUMSELEMENT,
     DATUM,DATENSATZ;
FROM Hilfsmittel IMPORT
     LeseDatensatz,SetMessage,ClearMessage,ConvertZahl;


PROCEDURE Druckabfrage (Window : WindowPtr):BOOLEAN;

VAR Zeichen : CHAR;

BEGIN
   SetAPen(Window^.rPort,10);
   SetBPen(Window^.rPort,0);
   WriteWindowString(Window,5,0,"Papier einlegen (p) oder Abbrechen (a) ?");
   REPEAT
       Zeichen:=GetChar(Window);
   UNTIL (Zeichen='p') OR (Zeichen='P') OR (Zeichen='a') OR (Zeichen='A');
   IF (Zeichen='p') OR (Zeichen='P')
   THEN
      RETURN TRUE;
   ELSE
      RETURN FALSE;
   END (* IF *);
END Druckabfrage;


PROCEDURE GetMove (Window : WindowPtr):CHAR;

VAR Char : CHAR;
    Gelesen : BOOLEAN;

BEGIN
   REPEAT
      Gelesen:=FALSE;
      Char:=GetChar(Window);
      IF ((Char='+')
       OR (Char='-')
       OR (Char='*')
       OR (Char='_')
       OR (Char=']')
       OR (Char='/')
       OR (Char='=')
       OR (Char='0')
       OR (Char=CHAR(13)))
      THEN Gelesen:=TRUE
      END (* IF *)
   UNTIL Gelesen;
   RETURN Char
END GetMove;


PROCEDURE MoveStart (Char : CHAR;
                     VAR Start : CARDINAL;
                     VAR Ende : BOOLEAN);

BEGIN
   Ende:=FALSE;
   CASE Char OF
      '+' : IF Start+15 <= Names
            THEN
               Start:=Start+15
            ELSE
               IF Names>15
               THEN Start:=Names-15
               ELSE Start:=1
               END (* IF *)
            END (* IF *)
    | '-' : IF Start>15
            THEN Start:=Start-15
            ELSE Start:=1
            END (* IF *)
    | '*' : IF Start+100 <= Names
            THEN
               Start:=Start+100
            ELSE
               IF Names>15
               THEN Start:=Names-15
               ELSE Start:=1
               END (* IF *)
            END (* IF *)
    | '_' : IF Start>100
            THEN Start:=Start-100
            ELSE Start:=1
            END (* IF *)
    | ']' : IF Names>15
            THEN Start:=Names-15
            ELSE Start:=1
            END (* IF *)
    | '/' : Start:=1
    | '=','0',CHAR(13) : Ende:=TRUE
   ELSE
   END (* CASE *)
END MoveStart;


PROCEDURE WriteF1 (Window : WindowPtr;
                   Zeile : CARDINAL;
                   Nummer : CARDINAL;
                   Element : LISTELEMENT);

BEGIN
   WriteWindowCard(Window,Zeile,1,Nummer,5);
   WriteWindowCard(Window,Zeile,6,Element.Nummer,5);
   WriteWindowString(Window,Zeile,13,
"                                                                             ");
   WriteWindowString(Window,Zeile,13,Element.Namen);
END WriteF1;


PROCEDURE WriteF2 (Window : WindowPtr;
                   Zeile : CARDINAL;
                   Nummer : CARDINAL;
                   Element : DATUMSELEMENT);

VAR Datum : DATUM;

BEGIN
   WriteWindowCard(Window,Zeile,1,Nummer,5);
   WriteWindowCard(Window,Zeile,6,List[Element.Nummer].Nummer,5);
   WriteWindowString(Window,Zeile,13,
"                                                                             ");
   ConvertZahl(Element.Datum1,Datum);
   WriteWindowString(Window,Zeile,13,Datum);
   WriteWindowString(Window,Zeile,32,List[Element.Nummer].Namen);
END WriteF2;


PROCEDURE WriteF3 (Window : WindowPtr;
                   Zeile : CARDINAL;
                   Nummer : CARDINAL;
                   Element : DATUMSELEMENT);

VAR Datum : DATUM;

BEGIN
   WriteWindowCard(Window,Zeile,1,Nummer,5);
   WriteWindowCard(Window,Zeile,6,List[Element.Nummer].Nummer,5);
   WriteWindowString(Window,Zeile,13,
"                                                                             ");
   ConvertZahl(Element.Datum2,Datum);
   WriteWindowString(Window,Zeile,13,Datum);
   WriteWindowString(Window,Zeile,32,List[Element.Nummer].Namen);
END WriteF3;


PROCEDURE WriteF4 (Window : WindowPtr;
                   Dir : ARRAY OF CHAR;
                   Nummer : CARDINAL;
                   Element : LISTELEMENT);

VAR Datensatz : DATENSATZ;
    Druckstring : ARRAY [0..85] OF CHAR;
    Hilfsstring : ARRAY [0..4] OF CHAR;
    Fehler : BOOLEAN;

BEGIN
   LeseDatensatz(Window,Element.Nummer,Dir,Datensatz);
   Druckstring:="";
   ValToStr(Nummer,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ValToStr(Element.Nummer,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   Insert(Druckstring,9,Element.Namen);
   ValToStr(Datensatz.XPosHier,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,60,Hilfsstring);
   ValToStr(Datensatz.YPosHier,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ValToStr(Datensatz.XPosOben,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ValToStr(Datensatz.YPosOben,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ValToStr(Datensatz.XPosUnten,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ValToStr(Datensatz.YPosUnten,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   PrintLine(Druckstring);
END WriteF4;


PROCEDURE WriteF5 (Nummer : CARDINAL;
                   Element : DATUMSELEMENT);

VAR Druckstring,Hilfsstring : String;
    Fehler : BOOLEAN;
    Datum : DATUM;

BEGIN
   Druckstring:="";
   ValToStr(Nummer,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ValToStr(List[Element.Nummer].Nummer,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ConvertZahl(Element.Datum1,Datum);
   Insert(Druckstring,10,Datum);
   Insert(Druckstring,30,List[Element.Nummer].Namen);
   PrintLine(Druckstring);
END WriteF5;


PROCEDURE WriteF6 (Nummer : CARDINAL;
                   Element : DATUMSELEMENT);

VAR Druckstring,Hilfsstring : String;
    Fehler : BOOLEAN;
    Datum : DATUM;

BEGIN
   Druckstring:="";
   ValToStr(Nummer,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ValToStr(List[Element.Nummer].Nummer,FALSE,Hilfsstring,10,4,' ',Fehler);
   Insert(Druckstring,last,Hilfsstring);
   ConvertZahl(Element.Datum2,Datum);
   Insert(Druckstring,10,Datum);
   Insert(Druckstring,30,List[Element.Nummer].Namen);
   PrintLine(Druckstring);
END WriteF6;


PROCEDURE BListNames (Window : WindowPtr;
                      VAR Flags : FLAGSET);

VAR RastPort : ADDRESS;
    Ende,Gelesen : BOOLEAN;
    Start,Zaehler,Zeile : CARDINAL;
    Char : CHAR;
    Titel : String;
    Position : INTEGER;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Namen);
   RastPort:=Window^.rPort;
   SetRast(RastPort,0);
   IF Names#0
   THEN
      SetAPen(RastPort,0);SetBPen(RastPort,10);
      WriteWindowString(Window,0,20,"        Liste der Bahnhofsnamen:        ");
      SetAPen(RastPort,10);
      Move(RastPort,160,0);Draw(RastPort,479,0);
      Move(RastPort,160,9);Draw(RastPort,479,9);
      SetAPen(RastPort,0);SetBPen(RastPort,10);
      WriteWindowString(Window,2,1," Blttern mit den +/-/= Tasten ! ");
      WriteWindowString(Window,3,1," normal:             15 Zeilen   ");
      WriteWindowString(Window,4,1," mit Shift:         100 Zeilen   ");
      WriteWindowString(Window,5,1," mit Alt:  Anfang/Ende der Liste ");
      SetAPen(RastPort,10);
      Move(RastPort,8,20);Draw(RastPort,271,20);
      Move(RastPort,8,29);Draw(RastPort,271,29);
      Move(RastPort,8,30);Draw(RastPort,271,30);
      Move(RastPort,8,39);Draw(RastPort,271,39);
      Move(RastPort,8,40);Draw(RastPort,271,40);
      Move(RastPort,8,49);Draw(RastPort,271,49);
      Move(RastPort,8,50);Draw(RastPort,271,50);
      Move(RastPort,8,59);Draw(RastPort,271,59);
      Start:=1;SetAPen(RastPort,10);SetBPen(RastPort,0);
      REPEAT
         Zeile:=0;
         FOR Zaehler:=Start TO Start+15 DO
            Zeile:=Zeile+1;
            IF Zaehler<= Names
            THEN
               WriteF1(Window,6+Zeile,Zaehler,List[Zaehler]);
            ELSE
               WriteWindowString(Window,6+Zeile,1,
"                                                                             ");
            END (* IF *);
         END (* FOR *);
         Char:=GetMove(Window);
         MoveStart(Char,Start,Ende);
      UNTIL Ende;
      SetRast(RastPort,0);
   ELSE
      SetMessage(Window," Es gibt noch keine Bahnhfe ! ");
   END (* IF *);
END BListNames;


PROCEDURE DListNames (Window : WindowPtr;
                      Dir : ARRAY OF CHAR;
                      VAR Flags : FLAGSET);

VAR Titel : String;
    Position : INTEGER;
    Zaehler : CARDINAL;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Namen);
   SetRast(Window^.rPort,0);
   IF Druckabfrage(Window)
   THEN
      SetMessage(Window," Ausdruck luft ! ");
      OpenPrinter;
      PrintCommand(16,0,0,0,0);
      PrintCommand(17,0,0,0,0);
      PrintCommand(26,0,0,0,0);
      PrintLine("Liste der Bahnhofsnamen");
      PrintChar(eol);
      PrintCommand(8,0,0,0,0);
      PrintLine("Nr. Nr.  Name                                           ");
      PrintCommand(9,0,0,0,0);
      PrintChar(eol);
      FOR Zaehler:=1 TO Names DO
         WriteF4(Window,Dir,Zaehler,List[Zaehler]);
      END (* FOR *);
      ClosePrinter;
      ClearMessage(Window);
   END (* IF *);
   SetRast(Window^.rPort,0);
END DListNames;


PROCEDURE BListOpen (Window : WindowPtr;
                     Opens : DATUMSLISTE;
                     VAR Flags : FLAGSET);

VAR RastPort : ADDRESS;
    Ende,Gelesen : BOOLEAN;
    Start,Zaehler,Zeile : CARDINAL;
    Char : CHAR;
    Titel : String;
    Position : INTEGER;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Namen);
   RastPort:=Window^.rPort;
   SetRast(RastPort,0);
   IF Names#0
   THEN
      SetAPen(RastPort,0);SetBPen(RastPort,10);
      WriteWindowString(Window,0,20,"       Liste der Erffnungsdaten:       ");
      SetAPen(RastPort,10);
      Move(RastPort,160,0);Draw(RastPort,479,0);
      Move(RastPort,160,9);Draw(RastPort,479,9);
      SetAPen(RastPort,0);SetBPen(RastPort,10);
      WriteWindowString(Window,2,1," Blttern mit den +/-/= Tasten ! ");
      WriteWindowString(Window,3,1," normal:             15 Zeilen   ");
      WriteWindowString(Window,4,1," mit Shift:         100 Zeilen   ");
      WriteWindowString(Window,5,1," mit Alt:  Anfang/Ende der Liste ");
      SetAPen(RastPort,10);
      Move(RastPort,8,20);Draw(RastPort,271,20);
      Move(RastPort,8,29);Draw(RastPort,271,29);
      Move(RastPort,8,30);Draw(RastPort,271,30);
      Move(RastPort,8,39);Draw(RastPort,271,39);
      Move(RastPort,8,40);Draw(RastPort,271,40);
      Move(RastPort,8,49);Draw(RastPort,271,49);
      Move(RastPort,8,50);Draw(RastPort,271,50);
      Move(RastPort,8,59);Draw(RastPort,271,59);
      Start:=1;SetAPen(RastPort,10);SetBPen(RastPort,0);
      REPEAT
         Zeile:=0;
         FOR Zaehler:=Start TO Start+15 DO
            Zeile:=Zeile+1;
            IF Zaehler<= Names
            THEN
               WriteF2(Window,6+Zeile,Zaehler,Opens[Zaehler]);
            ELSE
               WriteWindowString(Window,6+Zeile,1,
"                                                                             ");
            END (* IF *);
         END (* FOR *);
         Char:=GetMove(Window);
         MoveStart(Char,Start,Ende);
      UNTIL Ende;
      SetRast(RastPort,0);
   ELSE
      SetMessage(Window," Es gibt noch keine Bahnhfe ! ");
   END (* IF *);
END BListOpen;


PROCEDURE DListOpen (Window : WindowPtr;
                     Opens : DATUMSLISTE;
                     VAR Flags : FLAGSET);

VAR Titel : String;
    Position : INTEGER;
    Zaehler : CARDINAL;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Namen);
   SetRast(Window^.rPort,0);
   IF Druckabfrage(Window)
   THEN
      SetMessage(Window," Ausdruck luft ! ");
      OpenPrinter;
      PrintCommand(16,0,0,0,0);
      PrintCommand(17,0,0,0,0);
      PrintCommand(26,0,0,0,0);
      PrintLine("Liste der Erffnungsdaten");
      PrintChar(eol);
      PrintCommand(8,0,0,0,0);
      PrintLine("Nr. Nr.   Datum               Name                    ");
      PrintCommand(9,0,0,0,0);
      PrintChar(eol);
      FOR Zaehler:=1 TO Names DO
         WriteF5(Zaehler,Opens[Zaehler]);
      END (* FOR *);
      ClosePrinter;
      ClearMessage(Window);
   END (* IF *);
   SetRast(Window^.rPort,0);
END DListOpen;


PROCEDURE BListClose (Window : WindowPtr;
                      Closes : DATUMSLISTE;
                      VAR Flags : FLAGSET);

VAR RastPort : ADDRESS;
    Ende,Gelesen : BOOLEAN;
    Start,Zaehler,Zeile : CARDINAL;
    Char : CHAR;
    Titel : String;
    Position : INTEGER;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Namen);
   RastPort:=Window^.rPort;
   SetRast(RastPort,0);
   IF Names#0
   THEN
      SetAPen(RastPort,0);SetBPen(RastPort,10);
      WriteWindowString(Window,0,20,"         Liste der Schliedaten:        ");
      SetAPen(RastPort,10);
      Move(RastPort,160,0);Draw(RastPort,479,0);
      Move(RastPort,160,9);Draw(RastPort,479,9);
      SetAPen(RastPort,0);SetBPen(RastPort,10);
      WriteWindowString(Window,2,1," Blttern mit den +/-/= Tasten ! ");
      WriteWindowString(Window,3,1," normal:             15 Zeilen   ");
      WriteWindowString(Window,4,1," mit Shift:         100 Zeilen   ");
      WriteWindowString(Window,5,1," mit Alt:  Anfang/Ende der Liste ");
      SetAPen(RastPort,10);
      Move(RastPort,8,20);Draw(RastPort,271,20);
      Move(RastPort,8,29);Draw(RastPort,271,29);
      Move(RastPort,8,30);Draw(RastPort,271,30);
      Move(RastPort,8,39);Draw(RastPort,271,39);
      Move(RastPort,8,40);Draw(RastPort,271,40);
      Move(RastPort,8,49);Draw(RastPort,271,49);
      Move(RastPort,8,50);Draw(RastPort,271,50);
      Move(RastPort,8,59);Draw(RastPort,271,59);
      Start:=1;SetAPen(RastPort,10);SetBPen(RastPort,0);
      REPEAT
         Zeile:=0;
         FOR Zaehler:=Start TO Start+15 DO
            Zeile:=Zeile+1;
            IF Zaehler<= Names
            THEN
               WriteF3(Window,6+Zeile,Zaehler,Closes[Zaehler]);
            ELSE
               WriteWindowString(Window,6+Zeile,1,
"                                                                             ");
            END (* IF *);
         END (* FOR *);
         Char:=GetMove(Window);
         MoveStart(Char,Start,Ende);
      UNTIL Ende;
      SetRast(RastPort,0);
   ELSE
      SetMessage(Window," Es gibt noch keine Bahnhfe ! ");
   END (* IF *);
END BListClose;


PROCEDURE DListClose (Window : WindowPtr;
                      Closes : DATUMSLISTE;
                      VAR Flags : FLAGSET);

VAR Titel : String;
    Position : INTEGER;
    Zaehler : CARDINAL;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   EXCL(Flags,Namen);
   SetRast(Window^.rPort,0);
   IF Druckabfrage(Window)
   THEN
      SetMessage(Window," Ausdruck luft ! ");
      OpenPrinter;
      PrintCommand(16,0,0,0,0);
      PrintCommand(17,0,0,0,0);
      PrintCommand(26,0,0,0,0);
      PrintLine("Liste der Schliedaten");
      PrintChar(eol);
      PrintCommand(8,0,0,0,0);
      PrintLine("Nr. Nr.   Datum               Name                    ");
      PrintCommand(9,0,0,0,0);
      PrintChar(eol);
      FOR Zaehler:=1 TO Names DO
         WriteF6(Zaehler,Closes[Zaehler]);
      END (* FOR *);
      ClosePrinter;
      ClearMessage(Window);
   END (* IF *);
   SetRast(Window^.rPort,0);
END DListClose;


END Listen.
