(*********************************************************************
 *
 *  :Program.    Sortieren.mod
 *  :Project.    Nahverkehrssystem
 *  :Author.     Ingo Goldak
 *  :Address.    Hohenzollerndamm 8
 *  :Address.    1000 Berlin 31
 *  :Copyright.  PD
 *  :Language.   Modula-II
 *  :Translator. M2Amiga V3.3d
 *  :Imports.    Werkzeuge, Hilfsmittel [Ingo Goldak]
 *  :Contents.   PROCEDUREn fr Menu 'Sortieren'
 *  :History. V1.0 [Ingo Goldak] 30.03.90
 *
 *********************************************************************)

IMPLEMENTATION MODULE Sortieren;

FROM SYSTEM IMPORT
     ADR;
FROM Arts IMPORT
     Assert;
FROM Intuition IMPORT
     WindowPtr,SetWindowTitles;
FROM Graphics IMPORT
     SetRast;
FROM Dos IMPORT
     FileHandlePtr,Open,Close,Read,oldFile;
FROM Strings IMPORT
     Copy,Insert,Length,Occurs,last;
FROM Werkzeuge IMPORT
     Names,List,Title,Speichern,
     String,LISTE,DATUM,DATUMSLISTE,FLAGSET,FLAGS,DATENSATZ;
FROM Hilfsmittel IMPORT
     SetMessage,SucheDatensatz,InsertName,LeseDatensatz,SucheDatum,ConvertDatum;


PROCEDURE InsertDate (Datum1,Datum2 : LONGCARD;
                      VAR Liste : DATUMSLISTE;
                      VAR Laenge : CARDINAL;
                      Position : CARDINAL;
                      Record : CARDINAL);

VAR Zaehler : CARDINAL;

BEGIN
   IF Position<=Laenge
   THEN
      FOR Zaehler:=Laenge TO Position BY -1 DO
         Liste[Zaehler+1]:=Liste[Zaehler];
      END (* FOR *);
   END (* IF *);
   Liste[Position].Datum1:=Datum1;
   Liste[Position].Datum2:=Datum2;
   Liste[Position].Nummer:=Record;
   INC(Laenge);
END InsertDate;


PROCEDURE SortNames (Window : WindowPtr;
                     Dir : ARRAY OF CHAR;
                     VAR Flags : FLAGSET);

VAR Titel,File : String;
    Datei : FileHandlePtr;
    Position,Fehler : INTEGER;
    Gefunden : BOOLEAN;
    Datensatz : DATENSATZ;
    Record,Anzahl,Pos,Dummy : CARDINAL;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   SetMessage(Window," Bitte warten ! ");
   Copy(File,Dir,0,Length(Dir));
   Insert(File,last,"Bahnhfe");
   Datei:=Open(ADR(File),oldFile);
   Assert(Datei#NIL,ADR("Kann Bahnhofsliste nicht lesen"));
   Fehler:=Read(Datei,ADR(Names),SIZE(Names));
   IF Fehler<=0
   THEN
      SetMessage(Window," Zahl konnte nicht gelesen werden ! ");
   END (* IF *);
   Close(Datei);
   Anzahl:=Names;
   Names:=0;
   FOR Record:=1 TO Anzahl DO
      LeseDatensatz(Window,Record,Dir,Datensatz);
      SucheDatensatz(Datensatz.Namen,Dummy,Pos,Gefunden);
      InsertName(Datensatz.Namen,Pos,Record);
   END (* FOR *);
   EXCL(Flags,Namen);
   INCL(Flags,Liste);
   Speichern:=TRUE;
   SetMessage(Window," Sortieren beendet ! ");
END SortNames;


PROCEDURE SortOpen (Window : WindowPtr;
                    Dir : ARRAY OF CHAR;
                    VAR Opens : DATUMSLISTE;
                    VAR Flags : FLAGSET);

VAR Titel : String;
    Anzahl,Record,Dummy,Pos,ListPos : CARDINAL;
    Datensatz : DATENSATZ;
    Datum1,Datum2 : LONGCARD;
    Position : INTEGER;
    Gefunden : BOOLEAN;

BEGIN
   EXCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
      SetWindowTitles(Window,NIL,ADR(Title));
   END (* IF *);
   SetMessage(Window," Bitte warten ! ");
   Anzahl:=0;
   FOR Record:=1 TO Names DO
      LeseDatensatz(Window,Record,Dir,Datensatz);
      Datum1:=ConvertDatum(Datensatz.OpenDate);
      Datum2:=ConvertDatum(Datensatz.CloseDate);
      SucheDatensatz(Datensatz.Namen,Dummy,ListPos,Gefunden);
      SucheDatum(Datum1,Opens,Anzahl,Dummy,Pos,Gefunden);
      InsertDate(Datum1,Datum2,Opens,Anzahl,Pos,ListPos);
   END (* FOR *);
   EXCL(Flags,Namen);
   INCL(Flags,Sortiert);
   SetMessage(Window," Sortieren beendet ! ");
END SortOpen;


END Sortieren.
