(*********************************************************************
 *
 *  :Program.    Zeichnen.mod
 *  :Project.    Nahverkehrssystem
 *  :Author.     Ingo Goldak
 *  :Address.    Hohenzollerndamm 8
 *  :Address.    1000 Berlin 31
 *  :Copyright.  PD
 *  :Language.   Modula-II
 *  :Translator. M2Amiga V3.3d
 *  :Imports.    PrinterSupport [AMOK]
 *  :Imports.    WindowInOut, Werkzeuge, Initializations,
 *  :Imports.    Hilfsmittel [Ingo Goldak]
 *  :Contents.   PRECEDUREn fr Menu 'Zeichnen'
 *  :History. V1.0 [Ingo Goldak] 30.03.90
 *
 *********************************************************************)

IMPLEMENTATION MODULE Zeichnen;

FROM SYSTEM IMPORT
     ADDRESS,ADR;
FROM Intuition IMPORT
     ScreenPtr,WindowPtr,SetWindowTitles,SetPointer;
FROM Graphics IMPORT
     SetRast,SetAPen,SetBPen,Draw,Move,RectFill,ViewModes,ViewModeSet;
FROM Printer IMPORT
     SpecialSet;
FROM Strings IMPORT
     Insert,Length,Copy,Occurs,last;
FROM WindowInOut IMPORT
     WriteWindowString,WriteWindowCard;
FROM PrinterSupport IMPORT
     OpenPrinter,ClosePrinter,DumpRPort;
FROM Werkzeuge IMPORT
     Names,List,Title,
     String,DATUM,DATUMSLISTE,DATENSATZ,FLAGSET,FLAGS,DISPLAYLIST;
FROM Initializations IMPORT
     MousePtr;
FROM Hilfsmittel IMPORT
     SetMessage,ClearMessage,ReadDatum,LeseDatensatz,ConvertDatum,RequestNet;


PROCEDURE DrawNet (Window : WindowPtr;
                   Opens : DATUMSLISTE;
                   Datum : LONGCARD;
                   Dir : ARRAY OF CHAR;
                   VAR Display : DISPLAYLIST;
                   VAR Entries : CARDINAL);

VAR RastPort : ADDRESS;
    Datensatz : DATENSATZ;
    Zeiger,Record,Position,Errorcount : CARDINAL;
    Ergebnis,Vergleich : INTEGER;

BEGIN
   RastPort:=Window^.rPort;
   SetRast(RastPort,0);
   Entries:=0;
   Errorcount:=0;
   Zeiger:=1;
   LOOP
      IF Zeiger<=Names
      THEN
         IF Opens[Zeiger].Datum1<=Datum
         THEN
            IF Opens[Zeiger].Datum2>=Datum
            THEN
               Position:=Opens[Zeiger].Nummer;
               Record:=List[Position].Nummer;
               IF Record>0
               THEN
                  LeseDatensatz(Window,Record,Dir,Datensatz);
                  WITH Datensatz DO
                     SetAPen(RastPort,NeueLinie);
                     RectFill(RastPort,XPosHier-1,YPosHier-1,
                              XPosHier+1,YPosHier+1);
                     Move(RastPort,XPosOben,YPosOben);
                     Draw(RastPort,XPosHier,YPosHier);
                     Draw(RastPort,XPosUnten,YPosUnten);
                     INC(Entries);
                     Display[1,Entries]:=Record;
                     Display[2,Entries]:=XPosHier;
                     Display[3,Entries]:=YPosHier;
                  END (* WITH *);
               ELSE
                  Record:=List[Position].Nummer;
                  IF Record>0
                  THEN
                     LeseDatensatz(Window,Record,Dir,Datensatz);
                     WITH Datensatz DO
                        SetAPen(RastPort,NeueLinie);
                        RectFill(RastPort,XPosHier-1,YPosHier-1,
                                 XPosHier+1,YPosHier+1);
                        Move(RastPort,XPosOben,YPosOben);
                        Draw(RastPort,XPosHier,YPosHier);
                        Draw(RastPort,XPosUnten,YPosUnten);
                        INC(Entries);
                        Display[1,Entries]:=Record;
                        Display[2,Entries]:=XPosHier;
                        Display[3,Entries]:=YPosHier;
                     END (* WITH *);
                  ELSE
                     SetAPen(RastPort,4);
                     WriteWindowCard(Window,20,Errorcount*4,Position,4);
                     SetMessage(Window," Lesefehler ! ");
                     INC(Errorcount);
                  END (* IF Record2 *);
               END (* IF Record1 *);
            END (* IF Open2 *);
            INC(Zeiger);
         ELSE
            EXIT;
         END (* IF Open1 *);
      ELSE
         EXIT;
      END (* IF Names *);
   END (* LOOP *);
END DrawNet;


PROCEDURE ScreenDump (Screen : ScreenPtr;
                      Window : WindowPtr);

BEGIN
   ClearMessage(Window);
   OpenPrinter;
   DumpRPort(ADR(Screen^.rastPort),Screen^.viewPort.colorMap,ViewModeSet{hires},
             0,0,Screen^.width,Screen^.height,0,0,SpecialSet{});
   ClosePrinter;
   SetMessage(Window," Ausdruck beendet ! ");
END ScreenDump;


PROCEDURE WriteScreen (Window : WindowPtr;
                       Screen : ScreenPtr;
                       Mouse,Wait : MousePtr;
                       Dir : ARRAY OF CHAR;
                       Opens : DATUMSLISTE;
                       VAR Date : DATUM;
                       VAR Flags : FLAGSET);

VAR Titel : String;
    Position : INTEGER;
    RastPort : ADDRESS;
    Display : DISPLAYLIST;
    Entries : CARDINAL;
    Datum1 : LONGCARD;

BEGIN
   SetPointer(Window,Wait,16,16,-4,-1);
   RastPort:=Window^.rPort;
   EXCL(Flags,Namen);
   INCL(Flags,Datum);
   Copy(Titel,Title,0,Length(Title));
   Position:=Occurs(Title,0," am ",TRUE);
   IF Position#last
   THEN
      Copy(Title,Titel,0,Position);
   END (* IF *);
   SetRast(RastPort,0);
   SetAPen(RastPort,10);
   SetBPen(RastPort,0);
   WriteWindowString(Window,2,1,"Stichtag:");
   ReadDatum(Window,2,11,10,Date);
   Insert(Title,last," am ");
   Insert(Title,last,Date);
   Datum1:=ConvertDatum(Date);
   SetWindowTitles(Window,NIL,ADR(Title));
   DrawNet(Window,Opens,Datum1,Dir,Display,Entries);
   SetPointer(Window,Mouse,16,16,-4,-1);
   RequestNet(Window,Screen,Mouse,Dir,Display,Entries);
END WriteScreen;


PROCEDURE WritePrinter (Window : WindowPtr;
                        Screen : ScreenPtr;
                        Mouse,Wait : MousePtr;
                        Dir : ARRAY OF CHAR;
                        Opens : DATUMSLISTE;
                        VAR Date : DATUM;
                        VAR Flags : FLAGSET);

BEGIN
    WriteScreen(Window,Screen,Mouse,Wait,Dir,Opens,Date,Flags);
    ScreenDump(Screen,Window);
END WritePrinter;


END Zeichnen.
