(***************************************************************************
  :Program.       MidiSupport.mod
  :Author.        Jrgen Zimmermann
  :Address.       Ringstrae 6, 6719 Altleiningen, West-Germany
  :Phone.         06356/1456
  :ShortCut.      [JnZ]
  :Support.       -
  :Version.       1.0
  :Date.          22. Febuary 1990
  :Copyright.     PD
  :Language.      MODULA-II
  :Translator.    M2Amiga 3.3d
  :Contents.      Eine Modulimplementation der "Midi-Marcos" (C!) fr
  :Contents.      Modula-2 User
  :Remark.        Ich wrde mich sehr ber Kontakt mit anderen M2Amiga-Usern
  :Remark.        und MIDI-Freaks freuen.
  :Usage.         Siehe Anleitung fr die Midi-Library (anbei!)
****************************************************************************)

IMPLEMENTATION MODULE MidiSupport;
(* $S- $R- $V- $F- *)


FROM Exec IMPORT UByte;

PROCEDURE MidiHiByte(data: CARDINAL): UByte;
   (* pack high bytes of a word into midi format (7/14 bit math) *)

   BEGIN
      RETURN (UByte(data DIV 128));
   END MidiHiByte;


PROCEDURE MidiLoByte(data: CARDINAL): UByte;
   (* pack low bytes of a word into midi format (7/14 bit math) *)

   BEGIN
      RETURN (UByte(data MOD 128));
   END MidiLoByte;


PROCEDURE MidiWord(hi, lo: UByte): CARDINAL;
   (* unpack 2 midi bytes into a word (7/14 bit math) *)

   BEGIN
      RETURN (CARDINAL(CARDINAL(hi)*128+CARDINAL(lo)));
   END MidiWord;


PROCEDURE SplitMidiID(id: LONGCARD;
                      VAR id0,id1,id2: UByte);
   (* unpack a 3 byte sys/ex id into single bytes for argument
      lists and RIMatch initializers *)

   BEGIN
      id0:=(UByte(id DIV 65536));
      id1:=(UByte((id DIV 256) MOD 256));
      id2:=(UByte(id MOD 256));
   END SplitMidiID;


PROCEDURE MakeMidiID(id0,id1,id2: UByte): LONGCARD;
    (* make a 3 byte sys/ex id from three single bytes *)

   BEGIN
      RETURN ((LONGCARD(id0)*65536)
              + (LONGCARD(id1)*256)
              + LONGCARD(id2));
   END MakeMidiID;
END MidiSupport.
