(***************************************************************************
  :Program.       rsx.mod
  :Author.        Jrgen Zimmermann
  :Address.       Ringstrae 6, 6719 Altleiningen, West-Germany
  :Phone.         06356/1456
  :ShortCut.      [JnZ]
  :Support.       -
  :Version.       1.0
  :Date.          24. Febuary 1990
  :Copyright.     PD
  :Language.      MODULA-II
  :Translator.    M2Amiga 3.3d
  :Contents.      Demoprogramm zur "midi.library": Empfngt Midi-Daten
  :Contents.      (SysEx) und zeigt die jeweilige Lnge an. Keine Speicher-
  :Contents.      funktion, sorry! Ich arbeite zur Zeit gerade an einem
  :Contents.      Universal-Dump-Manager, es dauert aber noch seine Zeit,
  :Contents.      ich wollte aber die Midi- und M2Amiga-Freaks nicht warten
  :Contents.      lassen, deshalb FAST NUR die Implementation des Library!
  :Remark.        Ich wrde mich sehr ber Kontakt mit anderen M2Amiga-Usern
  :Remark.        und MIDI-Freaks freuen.
  :Usage.         nur starten!
****************************************************************************)

MODULE rsx;


FROM SYSTEM IMPORT ADR;

FROM Arts IMPORT TermProcedure, RemoveTermProc, Assert;

FROM InOut IMPORT WriteLn, WriteString, WriteCard, WriteInt;

FROM Midi IMPORT MidiPacket, MidiPacketPtr,MDest, MDestPtr, MRoute, MRoutePtr,
                 MRouteInfo, MRouteInfoPtr, CreateMDest,
                 MRouteDest, GetMidiPacket, FreeMidiPacket, MMFFlags,
                 MMFFlagSet, DeleteMRoute, DeleteMDest;

IMPORT Midi;


VAR dest     : MDestPtr;
    routeinfo: MRouteInfo;
    route    : MRoutePtr;
    packet   : MidiPacketPtr;


PROCEDURE CleanUp;

   BEGIN
      IF (packet # NIL)
         THEN
            FreeMidiPacket(packet);
            packet:=NIL;
      END; (* IF *)
      IF (route # NIL)
         THEN
            DeleteMRoute(route);
            route:=NIL;
      END; (* IF *)
      IF (dest # NIL)
         THEN
            DeleteMDest(dest);
            dest:=NIL;
      END; (* IF *)
   END CleanUp;

BEGIN
   TermProcedure(CleanUp);

   routeinfo.MsgFlags:=MMFFlagSet{SysEx};

   WriteString("Receive Sys/Ex");
   WriteLn;
   dest:=NIL;
   dest:=CreateMDest(NIL,NIL);
   Assert(dest # NIL, ADR("Can't create Dest"));

   route:=NIL;
   route:=MRouteDest(ADR("MidiIn"),dest,ADR(routeinfo));

   LOOP
      packet:=GetMidiPacket(dest);
      IF (packet # NIL)
         THEN
            WriteString("Packet received! Length: ");
            WriteCard(packet^.Length, 10);
            WriteLn;
            FreeMidiPacket(packet);
      END; (* IF *)
   END; (* LOOP *)
END rsx.
