(* =============================================================================

:Program.       TitleClock (Tock)
:Contents.      Zeigt freien Speicher und die Uhrzeit,
:Contents.      Weckt Euch auch von den Amiga oder anderen [na,na..] Trumen auf
:Author.        Thorsten Kocher
:Address.       Geislinger Str.36, D - 7250 Leonberg
:Phone.         Ich will keine Drohanrufe
:Copyright.     Public Domain, oder Shareware fr Genossen (?)
:Language.      Modula2
:Translator.    M2Amiga Ver 3.3d
:History.       Ver. 2.0 am 1-Mar-1990 Thorsten, Happy BirthDay Onkel Siegfried
:History.       Ver. 2.1 am 9-Mar-1990 Thorsten, Bugs fixed.
:History.       v3.0 Ich war's nicht 26-Mar-90 gebeamt, alles anders!
:History.       Ver. 3.1 am 27-Mar-90 Thorsten, Fliegen gefangen
:History.       Ver. 3.2 am 20-Apr-90 Thorsten, optimiert
:History.       Ver. 3.2.1 am 21-Apr-90 [bne] (O: -> S:)
:Support.       Sehr erweiterte Version von UClock [Holger Bolay]
:Support.       Der, der's nicht war hat auch geholfen
:Imports.       Beep von Fridtjof Siebert [fbs]
:Imports.       HotKey von Bernd Preusing
:Imports.       TaskSupport, Screen, Gadgets, von dem Amiga Guru [bne]!!!
:Bugs.          Zu Lang (fertiges Programm), Zu Dumm (der Quelltext!)
:Bugs.          Zerstrt alles, was ihm in den Weg kommt!
:Remark.        Gre an Kai, Chicken, GARY, .... (den denke ich mir nur),
:Remark.        an meine Eltern, da ich das Programm schreiben konnte,
:Remark.        an den Rest der Welt, besonderst an die die dieses Programm
:Remark.        als Shareware betrachen (genug geschwallt). Es gibt im
:Remark.        Programm auch noch genug zu lachen.

============================================================================= *)

(* $S- *)
MODULE Tock;

(* FOLD: IMPORT *)
FROM SYSTEM       IMPORT ADR, ADDRESS, CAST;
FROM Arts         IMPORT TermProcedure, Terminate, CurrentLevel, DetectCtrlC;
FROM Exec         IMPORT SetFunction, Permit, Forbid, UByte, Byte, GetMsg,
                         MemReqSet, MemReqs, TaskPtr, ReplyMsg, AvailMem,
                         WaitPort, Message, MessagePtr, PutMsg, FindPort,
                         MsgPortPtr, AllocMem;
FROM Intuition    IMPORT ScreenPtr, NewWindow, WindowPtr, SetWindowTitles,
                         OpenWorkBench, DisplayBeep, IntuitionBasePtr,
                         IDCMPFlagSet, WindowFlagSet, WindowFlags, IDCMPFlags,
                         ScreenFlagSet, ScreenFlags,
                         Gadget, IntuiText, GadgetPtr, GadgetFlags, menuDown,
                         RefreshWindowFrame, GadgetFlagSet, boolGadget, Border,
                         IntuiMessagePtr, ActivationFlagSet, ActivationFlags;
FROM Graphics     IMPORT Text, Move, SetAPen, SetBPen, SetDrMd, DrawModes,
                         DrawModeSet, jam2, RastPort;
FROM Dos          IMPORT Date, DateStamp, Delay, Open, Close, Write, Read,
                         FileHandlePtr, newFile, oldFile;
FROM Beep         IMPORT Beep;
FROM TaskSupport  IMPORT CreateTask, DeleteTask;
FROM Gadgets      IMPORT InitGadget, InitText;
FROM Screen       IMPORT InitWindow, OpenWindow, CloseWindow;
FROM HotKey       IMPORT InstallKey, RAMIGA, F1;
IMPORT Intuition;
(* ENDFD *)

(* FOLD: CONST *)
CONST FileName = "S:Tock.opt";
      PortName = "Tock, Tock, Tock...";
      chr0 = ORD ("0");
(* ENDFD *)
(* FOLD: TYPE *)
TYPE String    = ARRAY [0..255] OF CHAR;
     StringPtr = POINTER TO String;
     SWT       = PROCEDURE (WindowPtr {8}, StringPtr {9}, StringPtr {10});
(* ENDFD *)
(* FOLD: VAR *)
VAR Hour, Minute, Second   : LONGINT;
    AlarmHour, AlarmMin    : LONGINT;
    Days                   : LONGINT;
    WBScreenPtr            : ScreenPtr;
    TitleStr               : ARRAY [1..128] OF CHAR;
    HBeep, Alarm           : BOOLEAN;
    AllWindows, Set        : BOOLEAN;
    AlarmRing, BEEEP       : BOOLEAN;
    OldSWTitles            : SWT;
    ClockTaskPtr           : TaskPtr;
    MyIntuiBase            : IntuitionBasePtr;
    GuardWB                : WindowPtr;
(* ENDFD *)
(* FOLD: ReadDefaults *)
PROCEDURE ReadDefaults;

VAR file       : FileHandlePtr;
    LoadedDays : LONGINT;

   (* FOLD: ReadLongInt *)
   PROCEDURE ReadLongInt () : LONGINT;

   VAR ret : LONGINT;

   BEGIN
      IF Read (file, ADR (ret), 4) # 4 THEN HALT END; RETURN ret;
   END ReadLongInt;
   (* ENDFD *)
   (* FOLD: ReadBool *)
   PROCEDURE ReadBool () : BOOLEAN;

   BEGIN
      RETURN (ReadLongInt() # 0);
   END ReadBool;
   (* ENDFD *)

BEGIN
   file := Open (ADR (FileName), oldFile);
   IF file # NIL THEN
      HBeep := ReadBool();
      AllWindows := ReadBool();
      Alarm := ReadBool();
      IF Alarm THEN
         LoadedDays := ReadLongInt();
         IF  LoadedDays < Days THEN
            Alarm := FALSE;
         ELSE
            AlarmHour := ReadLongInt();
            AlarmMin := ReadLongInt();
            IF (AlarmHour*60 + AlarmMin < Hour*60 + Minute) AND
               (Days = LoadedDays) THEN
               Alarm := FALSE;
               AlarmMin := 0;
               AlarmHour := 0;
            END; (* IF *)
         END; (* IF *)
      END; (* IF *);
      Close (file);
   ELSE
      DisplayBeep (NIL);
      Beep (FALSE);
   END; (* IF *)
END ReadDefaults;
(* ENDFD *)
(* FOLD: WriteDefaults *)
PROCEDURE WriteDefaults (all : BOOLEAN);

VAR file           : FileHandlePtr;
    OldHBeep,
    OldAllWindows,
    OldAlarm       : BOOLEAN;
    OldAlarmHour,
    OldAlarmMin    : LONGINT;

   (* FOLD: WriteLongInt *)
   PROCEDURE WriteLongInt (LI : LONGINT);

   BEGIN
      IF Write (file, ADR (LI), 4) # 4 THEN HALT; END;
   END WriteLongInt;
   (* ENDFD *)
   (* FOLD: WriteBool *)
   PROCEDURE WriteBool (Bool : BOOLEAN);

   BEGIN
      IF Bool THEN WriteLongInt (-1); ELSE WriteLongInt (0); END;
   END WriteBool;
   (* ENDFD *)

BEGIN
   IF NOT (all) THEN
      OldHBeep := HBeep; OldAllWindows := AllWindows; OldAlarm := Alarm;
      OldAlarmHour := AlarmHour; OldAlarmMin := AlarmMin;
      ReadDefaults;
      Alarm := OldAlarm; AlarmHour := OldAlarmHour; AlarmMin := OldAlarmMin;
   END; (* IF *)
   file := Open (ADR (FileName), newFile);
   IF file # NIL THEN
      WriteBool (HBeep);
      WriteBool (AllWindows);
      WriteBool (Alarm);
      IF Alarm THEN
         IF (AlarmHour*60 + AlarmMin < Hour*60 + Minute) THEN
            WriteLongInt (Days+1);
         ELSE
            WriteLongInt (Days);
         END; (* IF *)
         WriteLongInt (AlarmHour);
         WriteLongInt (AlarmMin);
      END; (* IF *)
      Close (file);
   ELSE
      DisplayBeep (NIL);
      Beep (FALSE);
   END; (* IF *)
   IF NOT (all) THEN
      HBeep := OldHBeep; AllWindows := OldAllWindows;
   END; (* IF *)
END WriteDefaults;
(* ENDFD *)
(* FOLD: WBString *)
PROCEDURE WBString (t : StringPtr) : BOOLEAN;

BEGIN
   RETURN ((t^[0] = "W") AND (t^[1] = "o") AND (t^[2] = "r") AND
           (t^[3] = "k") AND (t^[4] = "b") AND (t^[5] = "e") AND
           (t^[6] = "n") AND (t^[7] = "c") AND (t^[8] = "h"));
END WBString;
(* ENDFD *)
(* FOLD: WBWindow *)
PROCEDURE WBWindow (WinPtr : WindowPtr): BOOLEAN;

BEGIN
   RETURN ((wbenchWindow IN WinPtr^.flags) OR AllWindows);
END WBWindow;
(* ENDFD *)
(* FOLD: RestoreTitles *)
PROCEDURE RestoreTitles;

VAR WinPtr : WindowPtr;

BEGIN
   Forbid;
   WinPtr := WBScreenPtr^.firstWindow;
   REPEAT
      IF WBString (WinPtr^.screenTitle) THEN
         SetWindowTitles (WinPtr, -1, WBScreenPtr^.defaultTitle);
      END; (* IF *)
      WinPtr := WinPtr^.nextWindow;
   UNTIL WinPtr = NIL;
   Permit;
END RestoreTitles;
(* ENDFD *)
(* FOLD: NewSWTitles *)
(* $T- *)
PROCEDURE NewSWTitles (window {8}       : WindowPtr;
                       windowTitle {9}  : StringPtr;
                       screenTitle {10} : StringPtr);

BEGIN
   IF WBString (screenTitle) AND WBWindow (window) THEN
      Set := TRUE;
   ELSE
      OldSWTitles (window, windowTitle, screenTitle);
   END; (* IF *)
END NewSWTitles;
(* ENDFD *)
(* FOLD: UnPatchIntui *)
PROCEDURE UnPatchintui;

BEGIN
   OldSWTitles := SetFunction (ADDRESS (MyIntuiBase), -276,
                               CAST (ADDRESS, OldSWTitles));
   RestoreTitles;
END UnPatchintui;
(* ENDFD *)
(* FOLD: PatchIntui *)
PROCEDURE PatchIntui;

BEGIN
   Forbid;
   TermProcedure (UnPatchintui);
   OldSWTitles := SetFunction (ADDRESS (MyIntuiBase), -276,
                               ADR (NewSWTitles));
   Permit;
END PatchIntui;
(* ENDFD *)
(* FOLD: MakeTitle *)
PROCEDURE MakeTitle (dummy : ADDRESS);

VAR chipMem, fastMem : LONGINT;
    WinPtr           : WindowPtr;

   (* FOLD: ValStrPos *)
   PROCEDURE ValStrPos (Pos: CARDINAL; Val: CARDINAL; Len: CARDINAL;
                        Chr : CHAR);

   VAR counter : CARDINAL;

      (* FOLD: Pot *)
      PROCEDURE Pot (exp : CARDINAL) : CARDINAL;

      BEGIN
         IF exp = 0 THEN RETURN 1 ELSE RETURN 10 * Pot (exp-1) END;
      END Pot;
      (* ENDFD *)

   BEGIN
      IF (WBScreenPtr^.width > 703) THEN
         IF Pos > 64    THEN INC (Pos, 8);
         ELSIF Pos > 53 THEN INC (Pos, 3);
         ELSE                INC (Pos); END;
      END; (* IF *)
      WHILE (Val MOD Pot (Len - 1) = Val) AND (Len # 1) DO
         TitleStr[Pos] := Chr; INC (Pos); DEC (Len);
      END; (* WHILE *)
      FOR counter := (Len-1) TO 0 BY -1 DO
         TitleStr[Pos] := CHAR (Val DIV Pot (counter) + chr0);
         Val := Val MOD Pot (counter);
         INC (Pos);
      END; (* FOR *)
   END ValStrPos;
   (* ENDFD *)
   (* FOLD: GetDate *)
   PROCEDURE GetDate;

   VAR Tage     : [0..1460];
       Mon      : ARRAY [0..2] OF CHAR;
       Jahre    : CARDINAL;
       HereDays : LONGINT;
       Time     : Date;

   BEGIN
      DateStamp (ADR (Time));
      WITH Time DO
         Hour   := minute DIV 60;
         Minute := minute MOD 60;
         Second := tick DIV 50;
      END; (* WITH *)
      IF Time.days = Days THEN RETURN END;
      Days := Time.days;
      HereDays := Time.days;
      DEC (HereDays, 730);
      IF (HereDays > 0) AND (WBScreenPtr^.width > 703) THEN
         TitleStr := ("Workbench release 1.3.     Chip:     Fast:         Date:  -   -    Time:  :  :  ");
      ELSIF (HereDays < 0) AND (WBScreenPtr^.width > 703) THEN
         TitleStr := ("Workbench release 1.3.     Chip:     Fast:         Date: -unset-   Time:  :  :  ");
         RETURN;
      ELSIF (HereDays > 0) THEN
         TitleStr := ("Workbench release 1.3.    Chip:     Fast:       Date:  -   -      :  :  ");
      ELSE
         TitleStr := ("Workbench release 1.3.    Chip:     Fast:       Date: -unset-     :  :  ");
         RETURN;
      END; (* IF *)
      Mon := 0C;
      Jahre := (HereDays DIV 1461) * 4 + 80;
      Tage  := HereDays MOD 1461;
      CASE Tage OF
      |          0 : DEC (Jahre); Tage := 365;
      |  367.. 731 : INC (Jahre); DEC (Tage, 366);
      |  732..1096 : INC (Jahre, 2); DEC (Tage, 731);
      | 1097..1460 : INC (Jahre, 3); DEC (Tage, 1096);
      ELSE
      END; (* CASE *)
      IF Jahre > 100 THEN Jahre := Jahre - 100; END;
      INC (Tage);
      IF    Tage <= 31              THEN Mon := "Jan";
      ELSIF Tage <= 59              THEN Mon := "Feb"; DEC (Tage, 31);
      ELSIF HereDays MOD 1461 = 60  THEN Mon := "Feb"; DEC (Tage, 31);
      ELSIF HereDays MOD 1461 < 367 THEN DEC (Tage); END;
      IF Mon[0] = 0C THEN
         CASE Tage OF
         |  60.. 90 : Mon := "Mar"; DEC (Tage,  59);
         |  91..120 : Mon := "Apr"; DEC (Tage,  90);
         | 121..151 : Mon := "May"; DEC (Tage, 120);
         | 152..181 : Mon := "Jun"; DEC (Tage, 151);
         | 182..212 : Mon := "Jul"; DEC (Tage, 181);
         | 213..243 : Mon := "Aug"; DEC (Tage, 212);
         | 244..273 : Mon := "Sep"; DEC (Tage, 243);
         | 274..304 : Mon := "Oct"; DEC (Tage, 273);
         | 305..334 : Mon := "Nov"; DEC (Tage, 304);
         | 335..365 : Mon := "Dec"; DEC (Tage, 334);
         END; (* CASE *)
      END; (* IF *)
      IF WBScreenPtr^.width < 704 THEN
         TitleStr[57] := Mon[0]; TitleStr[58] := Mon[1]; TitleStr[59] := Mon[2];
      ELSE
         TitleStr[60] := Mon[0]; TitleStr[61] := Mon[1]; TitleStr[62] := Mon[2];
      END; (* IF *)
      ValStrPos (54, Tage,  2, " "); ValStrPos (61, Jahre, 2, "0");
   END GetDate;
   (* ENDFD *)
   (* FOLD: WriteRP *)
   PROCEDURE WriteRP;

   VAR myrp    : RastPort;
       WinPtr  : WindowPtr;
       doit    : BOOLEAN;

      PROCEDURE Length (str : ARRAY OF CHAR):INTEGER;

      VAR len : INTEGER;

      BEGIN
         len := 0;
         WHILE (len <= HIGH (str)) AND (str[len] # 0C) DO
            INC (len);
         END; (* WHILE *)
         RETURN len;
      END Length;

   BEGIN
      Forbid;
      doit := TRUE;
      WinPtr := WBScreenPtr^.firstWindow;
      REPEAT
         IF WBWindow (WinPtr) AND (WBString (WinPtr^.screenTitle) OR
            (wbenchWindow IN WinPtr^.flags) AND Set) THEN
            WinPtr^.screenTitle := ADR (TitleStr);
         END; (* IF *)
         IF (menuState IN WinPtr^.flags) THEN
            doit := FALSE;
         END; (* IF *)
         WinPtr := WinPtr^.nextWindow;
      UNTIL WinPtr = NIL;
      IF doit AND
        (WBString (MyIntuiBase^.activeWindow^.screenTitle) OR
         Set AND (wbenchWindow IN MyIntuiBase^.activeWindow^.flags)) AND
         WBWindow (MyIntuiBase^.activeWindow) OR
         (MyIntuiBase^.activeScreen # WBScreenPtr) THEN
         WITH WBScreenPtr^.barLayer^ DO
            myrp := rp^;
            SetDrMd (rp, DrawModeSet {dm0});
            SetAPen (rp, 0);
            SetBPen (rp, 1);
            Move (rp, 5, 7);
            Text (rp, ADR (TitleStr), Length (TitleStr));
            rp^ := myrp;
         END; (* WITH *)
      END; (* IF *)
      Set := FALSE;
      Permit;
   END WriteRP;
   (* ENDFD *)

BEGIN
   LOOP
      chipMem := AvailMem (MemReqSet {chip}) DIV 1024;
      fastMem := AvailMem (MemReqSet {fast}) DIV 1024;
      GetDate;
      ValStrPos (32, CARDINAL (chipMem), 3, " ");
      ValStrPos (42, CARDINAL (fastMem), 4, " ");
      ValStrPos (65, CARDINAL (Hour),    2, " ");
      ValStrPos (68, CARDINAL (Minute),  2, "0");
      ValStrPos (71, CARDINAL (Second),  2, "0");
      IF WBScreenPtr^.width > 703 THEN
         TitleStr[81] := 0C;
      ELSE
         TitleStr[73] := 0C;
      END; (* IF *)
      WriteRP;
      IF HBeep AND (Second = 0) AND (Minute = 0) THEN
         Beep (FALSE);
         Delay (50);
      END; (* IF *)
      IF Alarm AND
         ((AlarmHour = Hour) AND (AlarmMin = Minute)) OR AlarmRing THEN
         AlarmRing := TRUE;
         DisplayBeep (NIL);
         Beep (BEEEP);
         BEEEP := NOT (BEEEP);
         Delay (5);
      END; (* IF *)
      Delay (20);
   END; (* LOOP *)
END MakeTitle;
(* ENDFD *)
(* FOLD: Config *)
PROCEDURE Config;

TYPE Pairs = ARRAY [1..10] OF ARRAY [0..1] OF INTEGER;

CONST width  = 200;
      height =  90;
      OKID     = 0;
      QuitID   = 1;
      HBeepID  = 2;
      AlarmID  = 3;
      AllWinID = 4;
      SaveID   = 5;

VAR NewConfigWin             : NewWindow;
    ConfigWin                : WindowPtr;
    Bord                     : Border;
    BoolPairs                : Pairs;
    OK, QuitGad, AllWin      : Gadget;
    Save, HBeepGad, AlarmGad : Gadget;
    OKtxt, Quittxt           : IntuiText;
    HBeeptxt, Savetxt        : IntuiText;
    AllWintxt, Alarmtxt      : IntuiText;
    Gad                      : GadgetPtr;
    counter                  : INTEGER;
    str                      : String;
    Mess                     : IntuiMessagePtr;
    code                     : CARDINAL;
    class                    : IDCMPFlagSet;
    Leave                    : BOOLEAN;

   (* FOLD: WriteAlarm *)
   PROCEDURE WriteAlarm (On : BOOLEAN);

   VAR Str : ARRAY [0..3] OF CHAR;

   BEGIN
      IF On THEN
         Move (ConfigWin^.rPort, 8, 60);
         Text (ConfigWin^.rPort, ADR ("Alarm - Time :  "), 16);
         Str [0] := CHAR (chr0 + (AlarmHour DIV 10));
         Str [1] := CHAR (chr0 + (AlarmHour MOD 10));
         Text (ConfigWin^.rPort, ADR (Str), 2);
         Text (ConfigWin^.rPort, ADR (" : "), 3);
         Str [0] := CHAR (chr0 + (AlarmMin DIV 10));
         Str [1] := CHAR (chr0 + (AlarmMin MOD 10));
         Text (ConfigWin^.rPort, ADR (Str), 2);
      ELSE
         Move (ConfigWin^.rPort, 8, 60);
         Text (ConfigWin^.rPort, ADR ("                       "), 23);
      END; (* IF *)
   END WriteAlarm;
   (* ENDFD *)

BEGIN
   IF Alarm AND AlarmRing THEN
      Alarm := FALSE; AlarmRing := FALSE;
      RETURN;
   END; (* IF *)
   Leave := FALSE;
   BoolPairs[01, 0] := 0;       BoolPairs[01, 1] := 0;
   BoolPairs[02, 0] := 62;      BoolPairs[02, 1] := 0;
   BoolPairs[03, 0] := 62;      BoolPairs[03, 1] := 11;
   BoolPairs[04, 0] := 63;      BoolPairs[04, 1] := 11;
   BoolPairs[05, 0] := 63;      BoolPairs[05, 1] := 0;
   BoolPairs[06, 0] := 63;      BoolPairs[06, 1] := 11;
   BoolPairs[07, 0] := 1;       BoolPairs[07, 1] := 11;
   BoolPairs[08, 0] := 1;       BoolPairs[08, 1] := 0;
   BoolPairs[09, 0] := 0;       BoolPairs[09, 1] := 0;
   BoolPairs[10, 0] := 0;       BoolPairs[10, 1] := 11;
   WITH Bord DO
      leftEdge   := -2;
      topEdge    := -1;
      frontPen   := 1;
      backPen    := 0;
      drawMode   := jam2;
      nextBorder := NIL;
      xy         := ADR (BoolPairs);
      count      := 10;
   END; (* WITH *)
   InitText (HBeeptxt, 1, 0, 6, 1, ADR ("H-BEEP"), NIL);
   InitGadget (HBeepGad, 20, 20, 60, 10, GadgetFlagSet {},
               ActivationFlagSet {relVerify, toggleSelect}, boolGadget,
               ADR (Bord), ADR (HBeeptxt), HBeepID, NIL);
   IF HBeep THEN INCL (HBeepGad.flags, selected); END;
   InitText   (AllWintxt, 1, 0, 6, 1, ADR ("AllWin"), NIL);
   InitGadget (AllWin, 120, 20, 60, 10, GadgetFlagSet {},
               ActivationFlagSet {relVerify, toggleSelect}, boolGadget,
               ADR (Bord), ADR (AllWintxt), AllWinID, ADR (HBeepGad));
   IF AllWindows THEN INCL (AllWin.flags, selected); END;
   InitText   (OKtxt, 1, 0, 18, 1, ADR ("OK!"), NIL);
   InitGadget (OK, 20, 70, 60, 10, GadgetFlagSet {},
               ActivationFlagSet {relVerify}, boolGadget, ADR (Bord),
               ADR (OKtxt), OKID, ADR (AllWin));
   InitText   (Quittxt, 1, 0, 10, 1, ADR ("QUIT!"), NIL);
   InitGadget (QuitGad, 120, 70, 60, 10, GadgetFlagSet {},
               ActivationFlagSet {relVerify}, boolGadget, ADR (Bord),
               ADR (Quittxt), QuitID, ADR(OK));
   InitText   (Savetxt, 1, 0, 10, 1, ADR ("Save!"), NIL);
   InitGadget (Save, 120, 40, 60, 10, GadgetFlagSet {},
               ActivationFlagSet {relVerify}, boolGadget, ADR (Bord),
               ADR (Savetxt), SaveID, ADR(QuitGad));
   InitText   (Alarmtxt, 1, 0, 10, 1, ADR ("Alarm"), NIL);
   InitGadget (AlarmGad, 20, 40, 60, 10, GadgetFlagSet {},
               ActivationFlagSet {relVerify, toggleSelect}, boolGadget,
               ADR (Bord), ADR (Alarmtxt), AlarmID, ADR (Save));
   IF Alarm THEN INCL (AlarmGad.flags, selected); END;
   InitWindow (NewConfigWin, ((WBScreenPtr^.width - width) / 2),
               ((WBScreenPtr^.height - height) / 2), width, height, 0, 1,
               IDCMPFlagSet {gadgetUp, vanillaKey},
               WindowFlagSet {windowDrag, windowDepth, activate, rmbTrap},
               ADR ("Tock v3.2"), NIL, ScreenFlagSet {wbenchScreen});
   NewConfigWin.firstGadget := ADR (AlarmGad);
   ConfigWin := OpenWindow (NewConfigWin);
   IF ConfigWin = NIL THEN DisplayBeep (NIL); RETURN; END;
   SetWindowTitles (ConfigWin, -1, ADR ("TitleClock  1990 by Thorsten Kocher -7250 Leonberg- thanks to Kai Bolay"));
   WriteAlarm (Alarm);
   counter := 1;
   LOOP
      WaitPort (ConfigWin^.userPort);
      REPEAT
         Mess := GetMsg (ConfigWin^.userPort);
         IF Mess # NIL THEN
            Gad := Mess^.iAddress;
            code := Mess^.code;
            class := Mess^.class;
            ReplyMsg (Mess);
            IF (gadgetUp IN class) THEN
               CASE Gad^.gadgetID OF
               | OKID :
                  EXIT;
               | HBeepID : HBeep := (selected IN HBeepGad.flags);
               | SaveID :
                  HBeep := (selected IN HBeepGad.flags);
                  AllWindows := (selected IN AllWin.flags);
                  WriteDefaults (TRUE);
               | QuitID :
                  Leave := TRUE;
                  EXIT;
               | AllWinID :
                  AllWindows := (selected IN AllWin.flags);
                  RestoreTitles;
               | AlarmID :
                  WriteAlarm (selected IN AlarmGad.flags);
                  counter := 1;
               END; (* CASE *)
            END; (* IF *)
            IF (vanillaKey IN class) AND (selected IN AlarmGad.flags) THEN
               IF code = 8 THEN
                  AlarmHour := 0; AlarmMin := 0; counter := 1;
                  WriteAlarm (TRUE);
                  code := 99;
               ELSIF (code < chr0) THEN
                  code := 99;
               END; (* IF *)
               code := code - chr0;
               CASE counter OF
               | 1 : IF 3 > code THEN
                        AlarmHour := code * 10; INC (counter);
                     ELSE
                        DisplayBeep (NIL);
                     END; (* IF *)
               | 2 : IF (10 > code) AND ((code < 4) OR (AlarmHour < 20)) THEN
                        INC (AlarmHour, code); INC (counter);
                     ELSE
                        DisplayBeep (NIL);
                     END; (* IF *)
               | 3 : IF 6 > code THEN
                        AlarmMin := code * 10; INC (counter);
                     ELSE
                        DisplayBeep (NIL);
                     END; (* IF *)
               | 4 : IF 10 > code THEN
                        INC (AlarmMin, code); INC (counter);
                     ELSE
                        DisplayBeep (NIL);
                     END; (* IF *)
               | 5 : DisplayBeep (NIL);
               END; (* CASE *)
               WriteAlarm (TRUE);
            END; (* IF *)
         END; (* IF *)
      UNTIL Mess = NIL;
   END; (* LOOP *)
   Alarm := (selected IN AlarmGad.flags);
   HBeep := (selected IN HBeepGad.flags);
   AllWindows := (selected IN AllWin.flags);
   RestoreTitles;
   SetWindowTitles (ConfigWin, NIL, NIL);
   CloseWindow (ConfigWin);
   ConfigWin := NIL;
   WriteDefaults (FALSE);
   IF Leave THEN Terminate (CurrentLevel ()) END;
END Config;
(* ENDFD *)
(* FOLD: TimeSet *)
PROCEDURE TimeSet;

VAR Time : Date;
    NewWin : NewWindow;

BEGIN
   InitWindow (NewWin, 0, 0, 1, 1, 0, 1, IDCMPFlagSet {},
               WindowFlagSet {backDrop, rmbTrap}, NIL, NIL,
               ScreenFlagSet {wbenchScreen});
   GuardWB := OpenWindow (NewWin);
   IF GuardWB = NIL THEN DisplayBeep (NIL); HALT; END;
   DateStamp (ADR (Time));
   WITH Time DO
      Hour   := minute DIV 60;
      Minute := minute MOD 60;
      Second := tick DIV 50;
      Days   := Time.days;
   END; (* WITH *)
END TimeSet;
(* ENDFD *)

BEGIN
   DetectCtrlC (FALSE);
   MyIntuiBase := ADR (Intuition);
   WBScreenPtr := OpenWorkBench();
   IF WBScreenPtr = NIL THEN HALT END;
   TimeSet; (* Zeit stellen fr ReadDefaults *)
   ReadDefaults;
   Days       := - 1;
   AlarmRing  := FALSE;
   Set        := FALSE;
   PatchIntui;
   ClockTaskPtr := CreateTask (MakeTitle, NIL,
                               ADR ("Tock's Proc"), 4048, 20);
   InstallKey ((F1+8), RAMIGA, Config, ADR (PortName));
END Tock. Erlsender Schlu!
