(**********************************************************************

    :Program.    Cursor.mod
    :Contents.   Prozeduren zur Cursorsteuerung im CLI oder Terminal
    :Author.     Markus Uhlendahl
    :Address.    Vorm Burgtor 16, D-4408 Dlmen
    :Phone.      02594/81540
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3d

**********************************************************************)
IMPLEMENTATION MODULE Cursor;


FROM SYSTEM IMPORT ADR;

FROM Dos    IMPORT FileHandlePtr,Output,Input,Write,Read,Delay;


VAR anzahl    : LONGINT;
    message   : ARRAY[1..9] OF CHAR;
    hilf      : ARRAY[1..5] OF CHAR;
    laenge,i  : INTEGER;


PROCEDURE transform (    n      : INTEGER;
                     VAR text   : ARRAY OF CHAR) : INTEGER;

  VAR laenge,i,index,teiler : INTEGER;
      immer                 : BOOLEAN;

  BEGIN
    laenge:=1;
    teiler:=10000;
    immer:=FALSE;
    text[0]:=CHR(48);
    IF n=0 THEN
        INC (laenge);
    END;
    FOR i:=1 TO 5 DO
      IF ((n DIV teiler)#0) OR immer THEN
        text[laenge-1]:=CHR((n DIV teiler)+48);
        INC (laenge);
        n:=n MOD teiler;
        immer:=TRUE;
      END;
      teiler:=teiler DIV 10;
    END;
    DEC (laenge);
    RETURN (laenge);
  END transform;


PROCEDURE ClrScr;

  VAR message   : CHAR;

  BEGIN
    message:=CHR(12);
    anzahl:=Write (Output(),ADR(message),1);
  END ClrScr;



PROCEDURE Gotoxy (x,y : INTEGER);

  VAR index : INTEGER;

  BEGIN
    IF (x>0) AND (x<80) AND (y>0) AND (y<47) THEN
      laenge:=transform (y,hilf);
      FOR i:=1 TO laenge DO
        message[1+i]:=hilf[i];
      END;
      index:=2+laenge;
      message[index]:=CHR(59);
      laenge:=transform (x,hilf);
      FOR i:=1 TO laenge DO
        message[index+i]:=hilf[i];
      END;
      INC (index,laenge);
      message[index+1]:=CHR(72);
      INC (index);
      anzahl:=Write (Output(),ADR(message),index);
    END;
  END Gotoxy;


PROCEDURE SetStyle (style      : styletype;
                    front,back : INTEGER);


  BEGIN
    INC (front,30);
    INC (back,40);
    message[2]:=style;
    message[3]:=";";
    message[4]:=CHR((front DIV 10)+48);
    message[5]:=CHR((front MOD 10)+48);
    message[6]:=";";
    message[7]:=CHR((back DIV 10)+48);
    message[8]:=CHR((back MOD 10)+48);
    message[9]:="m";
    anzahl:=Write (Output (),ADR(message),9);
  END SetStyle;


PROCEDURE InsertSpaces (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(64);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END InsertSpaces;


PROCEDURE CursorUp (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(65);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END CursorUp;


PROCEDURE CursorDown (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(66);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END CursorDown;


PROCEDURE CursorRight (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(67);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END CursorRight;


PROCEDURE CursorLeft (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(68);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END CursorLeft;


PROCEDURE DeleteEndOfWindow;

  BEGIN
    message[2]:=CHR(74);
    anzahl:=Write (Output(),ADR(message),2);
  END DeleteEndOfWindow;


PROCEDURE DeleteEndOfLine;

  BEGIN
    message[2]:=CHR(75);
    anzahl:=Write (Output(),ADR(message),2);
  END DeleteEndOfLine;


PROCEDURE InsertLine;

  BEGIN
    message[2]:=CHR(76);
    anzahl:=Write (Output(),ADR(message),2);
  END InsertLine;


PROCEDURE DeleteLine;

  BEGIN
    message[2]:=CHR(78);
    anzahl:=Write (Output(),ADR(message),2);
  END DeleteLine;


PROCEDURE DeleteChars (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(80);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END DeleteChars;


PROCEDURE PushUp (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(83);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END PushUp;


PROCEDURE PushDown (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(84);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END PushDown;


PROCEDURE MaxWidth (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(117);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END MaxWidth;


PROCEDURE MaxHeight (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(116);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END MaxHeight;


PROCEDURE LeftEdge (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(120);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END LeftEdge;


PROCEDURE TopEdge (n : INTEGER);

  BEGIN
    laenge:=transform (n,hilf);
    FOR i:=1 TO laenge DO
      message[1+i]:=hilf[i];
    END;
    message[2+laenge]:=CHR(121);
    anzahl:=Write (Output(),ADR(message),laenge+2);
  END TopEdge;


PROCEDURE HideCursor;

  BEGIN
    message[2]:=CHR(48);
    message[3]:=CHR(32);
    message[4]:=CHR(112);
    anzahl:=Write (Output(),ADR(message),4);
  END HideCursor;


PROCEDURE ShowCursor;

  BEGIN
    message[2]:=CHR(32);
    message[3]:=CHR(112);
    anzahl:=Write (Output(),ADR(message),3);
  END ShowCursor;


BEGIN
  message[1]:=CHR(155);
END Cursor.
