(**********************************************************************

    :Program.    TPFile.mod
    :Contents.   Turbo Pascal Fileprozeduren
    :Author.     Markus Uhlendahl
    :Address.    Vorm Burgtor 16, D-4408 Dlmen
    :Phone.      02594/81540
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3d

**********************************************************************)
IMPLEMENTATION MODULE TPFile;


FROM SYSTEM IMPORT ADR;

FROM Dos    IMPORT Read,Write;

IMPORT FileSystem;


VAR FileName : FileString;
    fehler   : LONGINT;


PROCEDURE Assign (f : Datei;s : FileString);

  VAR i : INTEGER;

  BEGIN
    i:=0;
    WHILE s[i]#0C DO
      FileName[i]:=s[i];
      INC (i);
    END;
    FileName[i]:=0C;
  END Assign;


PROCEDURE Close (f : Datei);

  BEGIN
    FileSystem.Close (f);
  END Close;


PROCEDURE ReadF (f : Datei;VAR c : CHAR);

  BEGIN
    fehler:=Read (f.file,ADR(c),1);
  END ReadF;


PROCEDURE ReadFInt (f : Datei;VAR i : INTEGER);

  BEGIN
    fehler:=Read (f.file,ADR(i),2);
  END ReadFInt;


PROCEDURE ReadFString (f : Datei;VAR s : ARRAY OF CHAR);

  VAR i : INTEGER;

  BEGIN
    i:=-1;
    REPEAT
      INC (i);
      fehler:=Read (f.file,ADR(s)+i,1);
    UNTIL (s[i]=0C) OR (i=HIGH(s));
  END ReadFString;


PROCEDURE ReadFReal (f : Datei;VAR r : REAL);

  BEGIN
    fehler:=Read (f.file,ADR(r),4);
  END ReadFReal;


PROCEDURE Reset (VAR f : Datei);

  BEGIN
    FileSystem.Lookup (f,FileName,1024,FALSE);
  END Reset;


PROCEDURE Rewrite (VAR f : Datei);

  BEGIN
    FileSystem.Lookup (f,FileName,1024,TRUE);
  END Rewrite;


PROCEDURE WriteF (f : Datei;c : CHAR);

  BEGIN
    fehler:=Write (f.file,ADR(c),1);
  END WriteF;


PROCEDURE WriteFInt (f : Datei;i : INTEGER);

  BEGIN
    fehler:=Write (f.file,ADR(i),2);
  END WriteFInt;


PROCEDURE WriteFString (f : Datei;s : ARRAY OF CHAR);

  BEGIN
    fehler:=Write (f.file,ADR(s),HIGH(s)+2);
  END WriteFString;


PROCEDURE WriteFReal (f : Datei;r : REAL);

  BEGIN
    fehler:=Write (f.file,ADR(r),4);
  END WriteFReal;


END TPFile.
