(**********************************************************************

    :Program.    TPSystem.mod
    :Contents.   Turbo Pascal Systemprozeduren
    :Author.     Markus Uhlendahl
    :Address.    Vorm Burgtor 16, D-4408 Dlmen
    :Phone.      02594/81540
    :Copyright.  Public Domain
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3d

**********************************************************************)
IMPLEMENTATION MODULE TPSystem;


FROM SYSTEM IMPORT ADDRESS,SHIFT,BITSET;

FROM Heap   IMPORT Available,Allocate,Deallocate;

IMPORT Dos;

IMPORT RandomNumber;


VAR PA[0BFE000H] : BITSET;


PROCEDURE Delay (i : INTEGER);

  BEGIN
    Dos.Delay (i DIV 20);
  END Delay;


PROCEDURE Dispose (p : ADDRESS);

  BEGIN
    Deallocate (p);
  END Dispose;


PROCEDURE Hi (i : INTEGER) : INTEGER;

  BEGIN
    RETURN (i DIV 256);
  END Hi;


PROCEDURE keypressed () : BOOLEAN;

  BEGIN
    RETURN (NOT (6 IN PA));
  END keypressed;


PROCEDURE Lo (i : INTEGER) : INTEGER;

  BEGIN
    RETURN (i MOD 256);
  END Lo;


PROCEDURE MemAvail () : INTEGER;

  BEGIN
    RETURN (Available(TRUE) DIV 16);
  END MemAvail;


PROCEDURE New (VAR p : ADDRESS);

  BEGIN
    Allocate (p,SIZE(p^));
  END New;


PROCEDURE Random () : REAL;

  BEGIN
    RETURN (RandomNumber.Random());
  END Random;


PROCEDURE Swap (i : INTEGER) : INTEGER;

  VAR a,b : INTEGER;

  BEGIN
    a:=Lo (i);
    b:=Hi (i);
    RETURN (a*256+b);
  END Swap;


PROCEDURE UpCase (c : CHAR) : CHAR;

  BEGIN
    RETURN (CAP(c));
  END UpCase;


END TPSystem.
