(* ------------------------------------------------------------------------
  :Program.       DosHelpDemo
  :Author.        Kai Bolay [kai]
  :Address.       Hoffmannstrae 168
  :Address.       7250 Leonberg 1
  :Phone.         07152/22135
  :History.       v1.0 [kai] 28-Jun-90 created
  :Copyright.     PD
  :Language.      Oberon
  :Translator.    OBERON v1.08
------------------------------------------------------------------------ *)
MODULE DosHelpDemo;

IMPORT dh  : DosHelp,
       d   : Dos,
       io,
       sys : SYSTEM;


VAR Path, Dir, File : ARRAY 200 OF CHAR;
    what : ARRAY 2 OF CHAR;
    Exists : BOOLEAN;
    L : d.FileLockPtr;

BEGIN
   io.WriteString ("SplitPath-Test\n");
   LOOP
      io.WriteString ("Enter Path: "); io.ReadString (Path);
      IF Path[0] = 0X THEN EXIT END;
      dh.SplitPath (Path, Dir, File);
      io.WriteString ("Dir  : "); io.WriteString (Dir); io.WriteLn;
      io.WriteString ("File : "); io.WriteString (File); io.WriteLn;
   END; (* LOOP *)
   io.WriteLn;

   io.WriteString ("MergePath-Test\n");
   LOOP
      io.WriteString ("Enter Dir  : "); io.ReadString (Dir);
      io.WriteString ("Enter File : "); io.ReadString (File);
      IF (Dir[0] = 0X) AND (File[0] = 0X) THEN EXIT END;
      dh.MergePath (Dir, File, Path);
      io.WriteString ("Path : "); io.WriteString (Path); io.WriteLn;
   END; (* LOOP *)
   io.WriteLn;

   io.WriteString ("GetPathFromLock-Test:\n");
   (*** Was hier gemacht wird, ist einfacher mit GetFullPath, wo soll ich
        in diesem Demo auch einen FileLock ohne Path herbekommen? ***)
   LOOP
      io.WriteString ("Enter Path: "); io.ReadString (Path);
      IF Path[0] = 0X THEN EXIT END;
      L := d.Lock (sys.ADR (Path), d.accessRead);
      IF L = NIL THEN
         io.WriteString ("Kein Lock() heute!\n");
      ELSE
         dh.GetPathFromLock (Path, L);
         io.WriteString ("Path : "); io.WriteString (Path); io.WriteLn;
         d.UnLock (L);
      END; (* IF *)
   END; (* LOOP *)
   io.WriteLn;

   io.WriteString ("GetFullPath-Test:\n");
   LOOP
      io.WriteString ("Enter Path: "); io.ReadString (Path);
      IF Path[0] = 0X THEN EXIT END;
      IF dh.GetFullPath (Path) THEN
         io.WriteString ("Path : "); io.WriteString (Path); io.WriteLn;
      ELSE
         io.WriteString ("N! Diesen Pfad gibt's nich'!!\n");
      END; (* IF *)
   END; (* LOOP *)
   io.WriteLn;

   io.WriteString ("Exists Test:\n");
   LOOP
      io.WriteString ("Enter Path: "); io.ReadString (Path);
      IF Path[0] = 0X THEN EXIT END;
      io.WriteString ("Test what (D)ir (F)ile (E)xists ? ");
      io.ReadString (what); what[0] := CAP (what[0]);
      CASE what[0] OF
      | "E" : Exists := dh.Exists (Path);
      | "F" : Exists := dh.FileExists (Path);
      | "D" : Exists := dh.DirExists (Path);
      ELSE
         EXIT
      END; (* CASE *)
      IF Exists THEN io.WriteString ("+ existiert\n");
                ELSE io.WriteString ("- nix da!!!\n"); END;
   END; (* LOOP *)
   io.WriteLn;

   io.WriteString ("Ade!\n");
END DosHelpDemo.
