(*--------------------------------------------------------------------------
 :Program.    LigaManager.mod
 :Author.     Marcus Stratmann
 :Address.    Bttcherstrae 13, D-4250 Bottrop-Kirchhellen
 :Phone.      02045/5191
 :Copyright.  Public Domain
 :Language.   MODULA-II
 :Translator. M2Amiga v3.3d
 :Imports.    typdefs, IntuiOps, TabellenOps, DatenInOut, ErgebnisInOut,
 :Imports.    Spieltag, Statistik
 :History.    V1.0,  26-Sep-89
 :History.    V1.1,  16-May-90
 :Contents.   Management of (Soccer-) Leagues. Displays tables, results and
 :Contents.   statistics, controls currently running matches.
--------------------------------------------------------------------------*)

MODULE LigaManager;  (* $S- $R- $V- $F- *)

FROM Arguments     IMPORT NumArgs, GetArg;
FROM DatenInOut    IMPORT InitDaten, SicherheitsTest, NeueSaison, Laden,
                          Speichern;
FROM ErgebnisInOut IMPORT ErgebnisEingabe, ErgebnisAusgabe;
FROM IntuiOps      IMPORT MenueAuswahl, MyRequest, MacheTitelzeile;
FROM Spieltag      IMPORT SpieltagDurchfuehren;
FROM Statistik     IMPORT ZeigeStatistik;
FROM SYSTEM        IMPORT ADR;
FROM TabellenOps   IMPORT ZeigeTabellen;
FROM typdefs       IMPORT DatenGesichert, ArbeitsFile;

VAR
  len, Auswahl: INTEGER;

BEGIN
  InitDaten;
  MacheTitelzeile;
  IF NumArgs() > 0 THEN
    GetArg(1, ArbeitsFile, len);
    Laden(FALSE);
  END;
  REPEAT
    Auswahl := MenueAuswahl();
    CASE Auswahl OF
    | 1: Laden(TRUE);
    | 2: Speichern;
    | 3: ErgebnisEingabe;
    | 4: ErgebnisAusgabe;
    | 5: ZeigeTabellen;
    | 6: SpieltagDurchfuehren;
    | 7: ZeigeStatistik;
    | 8: NeueSaison;
    | 0: IF MyRequest(ADR("Wirklich?"),
                      "Wollen Sie das Programm wirklich verlassen?", " Ja ",
                       "Nein", FALSE, TRUE) THEN
           SicherheitsTest(ADR("Programm beenden"));
         ELSE
           Auswahl := -1;
         END;
    END;
  UNTIL Auswahl = 0;
END LigaManager.
