(*---------------------------------------------------------------------------
    :Program.    TexDump
    :Author.     Steffen Khler
    :Address.    Apenrader Str. 30 D-2870 Delmenhorst
    :History     v1.0 Steffen Khler 31-May-90 creation
    :Copyright.  FreeWare
    :Language.   Modula-II
    :Translator. M2Amiga 3.3d
    :Contents.   Erzeugt Hexdumps von Dateien mit Formatierung speziell
    :Contents.   fr Dateien von Textverarbeitungsprogrammen
---------------------------------------------------------------------------*)
MODULE TexDump;

FROM FileSystem  IMPORT Lookup,File,ReadChar,WriteChar,Close,Response;
FROM Arguments   IMPORT NumArgs,GetArg;
FROM Strings     IMPORT Length,Insert,Delete;
FROM Terminal    IMPORT WriteString,WriteLn;
FROM Conversions IMPORT StrToVal;

VAR
   Input,
   Output               : File;
   InputName,
   OutputName           : ARRAY [1..200] OF CHAR;
   Buffer               : CARDINAL;
   ArgZahl,
   Dummy                : INTEGER;
   a,
   LHex,
   HHex                 : CHAR;
   Zeile                : ARRAY [1..80],[1..3] OF CHAR;
   Counter,
   Laenge,
   HByte,
   LByte                : INTEGER;
   LineEnd              : LONGINT;
   Error,
   Signed               : BOOLEAN;


PROCEDURE WriteStringOut(VAR Output:File; String:ARRAY OF CHAR);

VAR Counter: INTEGER;

BEGIN
   FOR Counter:=0 TO Length(String)-1 DO
      WriteChar(Output,String[Counter]);
   END;
END WriteStringOut;


PROCEDURE Ausgabe;

BEGIN
   FOR  Counter:=1 TO Laenge DO
      WriteChar(Output,Zeile[Counter,1]);
   END;
   WriteChar(Output,CHR(10));
   FOR  Counter:=1 TO Laenge DO
      WriteChar(Output,Zeile[Counter,2]);
   END;
   WriteChar(Output,CHR(10));
   FOR  Counter:=1 TO Laenge DO
      WriteChar(Output,Zeile[Counter,3]);
   END;
   WriteChar(Output,CHR(10));
   WriteChar(Output,CHR(10));
END Ausgabe;


BEGIN
   IF NumArgs()<>0 THEN
      ArgZahl:=1;
      LineEnd:=10;
      Buffer:=20000;
      WHILE ArgZahl<=NumArgs() DO
         GetArg(ArgZahl,InputName,Dummy);
         IF InputName[1]#'-' THEN
            OutputName:=InputName;
            Insert(OutputName,Length(OutputName),".Texdump");
            Lookup(Input,InputName,Buffer,FALSE);
            Lookup(Output,OutputName,Buffer,TRUE);
            IF Input.res=done THEN
               IF Output.res = done THEN
                  Laenge:=1;
                  WriteString('Wandle ');
                  WriteString(InputName);
                  WriteString(' nach ');
                  WriteString(OutputName);
                  WriteLn;
                  WriteStringOut(Output,'                                    TexDump 1.0');
                  WriteChar(Output,CHR(10));
                  WriteStringOut(Output,'               Steffen Khler  -  Apenrader Str. 30  -  2870 Delmenhorst');
                  WriteChar(Output,CHR(10));
                  WriteChar(Output,CHR(10));
                  WriteStringOut(Output,'TexDump of: ');
                  WriteStringOut(Output,InputName);
                  WriteChar(Output,CHR(10));
                  WriteChar(Output,CHR(10));
                  WHILE NOT (Input.eof) DO
                     ReadChar(Input,a);
                     LByte:=ORD(a) MOD 16;
                     HByte:=(ORD(a)-LByte) DIV 16;
                     IF LByte<10 THEN
                        LHex:=CHR(LByte+48);
                     ELSE
                        LHex:=CHR(LByte+55);
                     END;
                     IF HByte<10 THEN
                        HHex:=CHR(HByte+48);
                     ELSE
                        HHex:=CHR(HByte+55);
                     END;
                     Zeile[Laenge,1]:=HHex;
                     Zeile[Laenge,2]:=LHex;
                     IF ((ORD(a)>31) AND (ORD(a)<127)) THEN
                        Zeile[Laenge,3]:=a;
                     ELSE
                        Zeile[Laenge,3]:='.';
                     END;
                     IF (Laenge>74) OR (a=CHR(LineEnd)) THEN
                        Ausgabe;
                        Laenge:=0;
                     END;
                     INC(Laenge);
                  END;
                  DEC(Laenge);
                  Ausgabe;
                  Close(Output);
                  INC(ArgZahl);
               ELSE
                  WriteString('Fehler beim ffnen der Ausgabedatei');
                  WriteLn;
               END;
               Close(Input);
            ELSE
               WriteString('Fehler beim ffnen der Eingabedatei');
               WriteLn;
            END;
         ELSE
            Delete(InputName,0,1);
            StrToVal(InputName,LineEnd,Signed,10,Error);
            IF (Error OR (LineEnd<0) OR (LineEnd>255)) THEN
               LineEnd:=10;
               WriteString('Zeilenende- Parameter auerhalb des erlaubten Breichs (0-255)');
               WriteLn;
               WriteString('Es wird der Default-Wert CHR(10) verwendet.');
               WriteLn;
               ArgZahl:=NumArgs()+1;
            ELSE
               INC(ArgZahl);
            END;
         END;
      END;
      WriteString('Fertig.');
      WriteLn;
   ELSE
      WriteString('        TexDump 1.0 - erzeugt Hexdumps speziell fr Dateien');
      WriteLn;
      WriteString('                  von Text- Verarbeitungsprogrammen');
      WriteLn;
      WriteString('    Der Hexdump wird zeilenorientiert in die Ausgabedatei geschrieben');
      WriteLn;
      WriteLn;
      WriteString(' Aufruf: TexDump <-ASCIIwert> Datei1 <Datei2> <Datei3> <-ASCIIwert> usw.');
      WriteLn;
      WriteString('   oder von der WB durch SHIFT+Klick auf die einzelnen Dateien und');
      WriteLn;
      WriteString('                 Doppelklick auf das Programm- Icon');
      WriteLn;
      WriteString('-ASCIIwert (z.B. -13) stellt das akt. gewnschte Zeilenende- Zeichen dar');
      WriteLn;
      WriteString('                        (Default- Wert 10)');
      WriteLn;
   END;
END TexDump.
