IMPLEMENTATION MODULE DosSupport;
(*---------------------------------------------------------------------------
   :Program.    DosSupport
   :Version.    1.5 --- Jan-88
   :Contants.   Supporting Dos-Routines
   :Author.     Markus Peuckert
   :Address.    Schtzenstr. 50, D-3550 Marburg, West-Germany,
   :Copyright.  ShareWare
   :Language.   Modula-2
   :Translator. M2Amiga V3.3d
---------------------------------------------------------------------------*)

FROM SYSTEM	IMPORT 	ADR;
FROM Dos    	IMPORT 	Open, Close, CurrentDir, Lock, UnLock, Write,
		       	FileLockPtr, sharedLock, newFile;
FROM ASCII	IMPORT	csi;
FROM Str	IMPORT	Length;
FROM Conversions IMPORT	ValToStr;


VAR L : FileLockPtr;


PROCEDURE OpenCon (win : WinNam) : ID;
BEGIN
 RETURN Open (ADR(win), newFile);
END OpenCon;

PROCEDURE CloseCon (k : ID);
BEGIN
 IF k # NIL THEN
  L := CurrentDir (L);
  Close (k)
 END
END CloseCon;

PROCEDURE CD (Dir : ARRAY OF CHAR) : BOOLEAN;
VAR l : FileLockPtr;
BEGIN
 l := Lock (ADR(Dir), sharedLock);
 IF l # NIL THEN
  l := CurrentDir (l);
  UnLock (l);
  RETURN TRUE
 END;
 RETURN FALSE
END CD;

PROCEDURE WriteS (k : ID; str : ARRAY OF CHAR);
VAR ok, len : INTEGER;
BEGIN
	IF k # NIL THEN
		len := Length (str);
		ok := Write (k, ADR (str), len)
	END
END WriteS;

PROCEDURE WriteC (k : ID; ch : CHAR);
VAR ok : INTEGER;
BEGIN
	IF k # NIL THEN
		ok := Write (k, ADR (ch), SIZE (ch))
	END
END WriteC;

PROCEDURE WriteLn (k : ID);
VAR lf : CHAR;
    ok : INTEGER;
BEGIN
	lf := 12C;
	IF k # NIL THEN
		ok := Write (k, ADR (lf), SIZE (CHAR))
	END
END WriteLn;

PROCEDURE SetPenColor (k : ID; PenColour : CARDINAL);
VAR String : ARRAY [0..1] OF CHAR;
    err    : BOOLEAN;
BEGIN
	WriteC (k, csi);
	IF (PenColour = 0) THEN
		WriteC (k, ";");	WriteS (k, "31");
	ELSIF (PenColour >= 30) AND (PenColour <= 37) THEN
		ValToStr (PenColour, FALSE, String, 10, 1, "0", err);
		WriteC (k, ";");	WriteS (k, String)
	END;
	WriteC (k, "m")
END SetPenColor;


BEGIN

 L := Lock (0, sharedLock);

END DosSupport.Mod
