IMPLEMENTATION MODULE MPGad;
(*---------------------------------------------------------------------------
   :Program.    MPGad.Mod
   :Version.    3.3
   :History.	Mar-90
   :Author.     Markus Peuckert
   :Address.    Schtzenstr. 50, D-3550 Marburg, West-Germany,
   :Copyright.  ShareWare
   :Language.   Modula-2
   :Translator. M2Amiga V3.3d
---------------------------------------------------------------------------*)

FROM SYSTEM	IMPORT	ADR, INLINE;
FROM Intuition 	IMPORT	boolGadget, strGadget, Gadget, Border, StringInfo,
			IntuiText, ActivationFlags, ActivationFlagSet;
FROM Graphics	IMPORT	Move, Draw, Text, SetAPen, RastPortPtr;
FROM IntuiSup	IMPORT 	InitIText, InitBorder, CreateGadget, InitStringInfo;


VAR   CommBord, DebugBord, ParamBord				: Border;

      SaveGad, CompilGad, LinkerGad, LoaderGad, EditGad		: Gadget;

      CompText, LinkText, DebugText, RunText, ExText, EdText,
      LoadText, SaveText, PopText, MakeText,
      CompilText, LinkerText,LoaderText, PrgText, EditText	: IntuiText;

      CompilInfo, LinkerInfo, LoaderInfo, PrgInfo, EditInfo	: StringInfo;

      CompilUnbuf, LinkerUnbuf,
      LoaderUnbuf, PrgUnbuf, EditUnbuf				: BufStrTyp;


PROCEDURE xyCommand;	(* $E- *)
BEGIN
 INLINE (0,0, 60,0, 60,11, 0,11, 0,0)
END xyCommand;

PROCEDURE xyDebug; 	(* $E- *)
BEGIN
 INLINE (0,0, 85,0, 85,11, 0,11, 0,0)
END xyDebug;

PROCEDURE xyParam;	(* $E- *)
BEGIN
 INLINE (0,0, 385,0, 385,10, 0,10, 0,0)
END xyParam;

PROCEDURE MakeGadgets;
BEGIN
 InitBorder (CommBord,  ADR(xyCommand), NIL);
 InitBorder (DebugBord, ADR(xyDebug),   NIL);
 InitBorder (ParamBord, ADR(xyParam),   NIL);

 InitIText (CompText,  1,1,  ADR("Compile"));
 InitIText (LinkText,  13,1, ADR("Link"));
 InitIText (DebugText, 2,1,  ADR("Load/Debug"));
 InitIText (RunText,   18,1, ADR("Run"));
 InitIText (ExText,    1,1,  ADR("Execute"));
 InitIText (EdText,    15,1, ADR("Edit"));
 InitIText (PopText,   18,1, ADR("Pop"));
 InitIText (MakeText,  18,1, ADR("ALT"));
 InitIText (LoadText,  15,1, ADR("Load"));
 InitIText (SaveText,  15,1, ADR("Save"));

 InitStringInfo (CompilInfo, CompilBuf, CompilUnbuf);
 InitStringInfo (LinkerInfo, LinkerBuf, LinkerUnbuf);
 InitStringInfo (LoaderInfo, LoaderBuf, LoaderUnbuf);
 InitStringInfo (PrgInfo, PrgBuf, PrgUnbuf);
 InitStringInfo (EditInfo, EditBuf, EditUnbuf);

 CreateGadget (EditGad, 98,70, 385,10, editgad, strGadget, NIL,
 		ADR(EditInfo), ADR(ParamBord), NIL,
 		ActivationFlagSet{gadgImmediate,relVerify,toggleSelect});
 CreateGadget (PrgGad, 98,54, 385,10, prggad, strGadget, ADR(EditGad),
 		ADR(PrgInfo), ADR(ParamBord), NIL,
 		ActivationFlagSet{gadgImmediate,relVerify,toggleSelect});
 CreateGadget (LoaderGad, 98,38, 385,10, loadergad, strGadget, ADR(PrgGad),
 		ADR(LoaderInfo), ADR(ParamBord), NIL,
 		ActivationFlagSet{gadgImmediate,relVerify,toggleSelect});
 CreateGadget (LinkerGad, 98,22, 385,10, linkergad, strGadget, ADR(LoaderGad),
 		ADR(LinkerInfo), ADR(ParamBord), NIL,
 		ActivationFlagSet{gadgImmediate,relVerify,toggleSelect});
 CreateGadget (CompilGad, 98,6, 385,10, compilgad, strGadget, ADR(LinkerGad),
 		ADR(CompilInfo), ADR(ParamBord), NIL,
 		ActivationFlagSet{gadgImmediate,relVerify,toggleSelect});

 CreateGadget (SaveGad, 337,90, 60,11, savegad, boolGadget, ADR(CompilGad), NIL,
 		ADR(CommBord), ADR(SaveText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (LoadGad, 107,90, 60,11, loadgad, boolGadget, ADR(SaveGad), NIL,
 		ADR(CommBord), ADR(LoadText),
 		ActivationFlagSet{gadgImmediate,relVerify});
CreateGadget (MakeGad, 10,90, 60,11, makegad, boolGadget, ADR(LoadGad), NIL,
 		ADR(CommBord), ADR(MakeText),
 		ActivationFlagSet{gadgImmediate,relVerify,toggleSelect});

 CreateGadget (PopGad, 425,5, 60,11, popgad, boolGadget, NIL, NIL,
 		ADR(CommBord), ADR(PopText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (EdGad, 360,5, 60,11, edgad, boolGadget, ADR(PopGad), NIL,
 		ADR(CommBord), ADR(EdText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (ExGad, 295,5, 60,11, exgad, boolGadget, ADR(EdGad), NIL,
 		ADR(CommBord), ADR(ExText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (RunGad, 230,5, 60,11, rungad, boolGadget, ADR(ExGad), NIL,
 		ADR(CommBord), ADR(RunText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (DebugGad, 140,5, 85,11, debuggad, boolGadget, ADR(RunGad), NIL,
 		ADR(DebugBord), ADR(DebugText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (LinkGad, 75,5, 60,11, linkgad, boolGadget, ADR(DebugGad), NIL,
 		ADR(CommBord), ADR(LinkText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (CompGad, 10,5, 60,11, compgad, boolGadget, ADR(LinkGad), NIL,
 		ADR(CommBord), ADR(CompText),
 		ActivationFlagSet{gadgImmediate,relVerify});
END MakeGadgets;

PROCEDURE InitBuffers;
BEGIN
 CompilBuf:=""; LinkerBuf:=""; LoaderBuf:=""; PrgBuf:="";
 EditBuf:="";
 CompilUnbuf:=""; LinkerUnbuf:=""; LoaderUnbuf:="";
 PrgUnbuf:=""; EditUnbuf:="";
END InitBuffers;

PROCEDURE DrawText (rPort : RastPortPtr);
BEGIN
 SetAPen (rPort, 3);
 Move (rPort, 10, 12); Text (rPort, ADR("Compiler :"), 10);
 Move (rPort, 10, 28); Text (rPort, ADR("Linker   :"), 10);
 Move (rPort, 10, 44); Text (rPort, ADR("Loader   :"), 10);
 Move (rPort, 10, 60); Text (rPort, ADR("Program  :"), 10);
 Move (rPort, 10, 76); Text (rPort, ADR("Editor   :"), 10);
 Move (rPort, 5, 85); Draw (rPort, 487, 85);
 Move (rPort, 200,97); Text (rPort, ADR("Compi.config"), 12);
END DrawText;


BEGIN

 InitBuffers;
 MakeGadgets;

END MPGad.Mod
