MODULE Flanz;
(*---------------------------------------------------------------------------
   :Program.    Flanz
   :Version.    1.0
   :History.	Dez-89
   :Author.     Markus Peuckert
   :Address.    Schtzenstr. 50, D-3550 Marburg, West-Germany,
   :Copyright.  PD
   :Language.   Modula-2
   :Translator. M2Amiga V3.3d
---------------------------------------------------------------------------*)

FROM SYSTEM    	IMPORT 	ADR, ADDRESS, INLINE, FFP;
FROM Arts      	IMPORT 	TermProcedure, CurrentLevel;
FROM Terminal	IMPORT 	waitCloseGadget;
FROM GfxMacros	IMPORT	DrawCircle;
FROM Graphics  	IMPORT  RastPortPtr, ViewPortPtr, ViewModes, ViewModeSet,
			LoadRGB4, Move, Draw, Text, SetAPen, SetBPen, SetRast,
			SetDrMd, jam1, jam2;
FROM Intuition 	IMPORT 	IDCMPFlags, IDCMPFlagSet, ScreenFlags, ScreenFlagSet,
			WindowFlags, WindowFlagSet, WindowPtr, CloseWindow,
			ScreenPtr, CloseScreen, customScreen, IntuiMessagePtr,
			WindowToFront, WindowToBack, GadgetPtr, RefreshGadgets;
FROM Exec	IMPORT 	WaitPort, ReplyMsg, GetMsg;
FROM Dos	IMPORT	Delay;
FROM MathTrans	IMPORT	Pow, Sin, Cos;
FROM RandomNumber IMPORT RND;
FROM FFPConversions IMPORT StrToReal;
FROM Strings	IMPORT	Length;
FROM FileSystem IMPORT	File, Lookup, Close, ReadChar, done;
FROM IntuiSup	IMPORT	CreateWindow, CreateScreen, IDCMPOn, IDCMPOff;
FROM FlGad	IMPORT	chrom1gad, itergad, noxgad, astgad, skalgad, wachsgad,
			zeichgad, endegad, IterInfo, NoxInfo, AstInfo,
			Chrom1Gad, Chrom1Buf, IterBuf, NoxBuf, AstBuf, SkalBuf,
			DrawText;


CONST 	WIDTH 		= 640;		HEIGHT 		= 512;
	WIDTH2		= 150;	 	HEIGHT2		= 145;
 	MIDDLE		= WIDTH DIV 2;
 	DEPTH  		= 2;
 	COL		= 4;
 	MaxAS		= 40000;	MaxGen		= 50;

TYPE	KettenTyp	= ARRAY [0..MaxAS-1] OF CHAR;
	Chromosom	= ARRAY [0..MaxGen-1] OF CHAR;

VAR	scr		: ScreenPtr;
	win, win2	: WindowPtr;
 	rp, rp2		: RastPortPtr;
 	vp		: ViewPortPtr;
 	Level		: INTEGER;

	KettA, KettB	: KettenTyp;
	Chrom		: Chromosom;

	AnzIter, Skal	: INTEGER;
	AngIt		: INTEGER;
	SkalFak		: FFP;
	MaxMut, AnzMut	: INTEGER;
	AnzS, Anz0, Anz1,
	Anz2, Anz3	: INTEGER;


PROCEDURE DegToRad (Winkel : INTEGER) : FFP;
BEGIN
	RETURN FFP(Winkel) * 0.01745329252
END DegToRad;

PROCEDURE Win2Ko (VAR x, y : INTEGER; rad, wink : INTEGER);
VAR
BEGIN
 x := INTEGER (FFP(rad) * Cos (DegToRad(wink)));
 y := INTEGER (FFP(rad) * Sin (DegToRad(wink)))
END Win2Ko;

PROCEDURE DrawMsg (Message : ARRAY OF CHAR; fg, bg : INTEGER);
BEGIN
 SetDrMd (rp2, jam2);
 SetAPen (rp2, fg); SetBPen (rp2, bg);
 Move (rp2, 70, 127);
 Text (rp2, ADR(Message), Length (Message));
 SetDrMd (rp2, jam1)
END DrawMsg;

PROCEDURE BlattKleben (f, x, y, r : INTEGER);
BEGIN
 SetAPen (rp, f);	DrawCircle (rp, MIDDLE-x, HEIGHT-y, r);
END BlattKleben;

PROCEDURE Zeichnen (xa, ya, x, y, f : INTEGER);
BEGIN
 SetAPen (rp, f);
 Move (rp, MIDDLE-xa, HEIGHT-ya);	Draw (rp, MIDDLE-x, HEIGHT-y);
END Zeichnen;

PROCEDURE GrasWachsen (i : LONGINT; xa, ya, x, y, Ang, f : INTEGER;
			re : BOOLEAN; VAR NxtAst : LONGINT);
BEGIN
 IF (KettA [i] = "*") THEN BlattKleben (3, x, y, 1) END;
 IF (KettA [i] <> "*") THEN
  IF (KettA [i] = "0") OR (KettA [i] = "1") THEN
   xa:=x;		ya:=y;
   Win2Ko (x, y, Skal, Ang);
   INC (x, xa);		INC (y, ya);	INC (NxtAst);
   Zeichnen (xa, ya, x, y, f);
   GrasWachsen (i+1, xa, ya, x, y, Ang, f, re, NxtAst)
  ELSIF (KettA [i] = "[") THEN
   INC (NxtAst);
   IF re THEN  	INC (Ang, AngIt)   ELSE		DEC (Ang, AngIt)   END;
   GrasWachsen (i+1, xa, ya, x, y, Ang, f, NOT re, NxtAst);
   IF re THEN  	DEC (Ang, AngIt)   ELSE   	INC (Ang, AngIt)   END;
   GrasWachsen (NxtAst, xa, ya, x, y, Ang, f, NOT re, NxtAst)
  ELSIF (KettA [i] = "]") THEN
   BlattKleben (3, x, y, 1);
   INC (NxtAst)
  END
 END
END GrasWachsen;

PROCEDURE LassWachsen;
VAR i, NxtAst		: LONGINT;
    xa, ya, x, y,
    Ang, f		: INTEGER;
    re			: BOOLEAN;
BEGIN
 SetRast (rp, 0);
 re := FALSE;
 i:=0; xa:=0; ya:=0; x:=0; y:=0; NxtAst :=0; Ang:=90; f:=2;
 IF (KettA[i] <> "*") THEN
 	GrasWachsen (i, xa, ya, x, y, Ang, f, re, NxtAst)
 END
END LassWachsen;

PROCEDURE Ersetze (i : LONGINT; VAR j : LONGINT; Chrom : Chromosom);
VAR k, a, b, c : INTEGER;
BEGIN
   a:=AnzS+Anz0;	b:=AnzS+Anz0+Anz1;	c:=AnzS+Anz0+Anz1+Anz2;
   CASE KettA [i] OF
 	"0" :	FOR k:=0 TO Anz0-1 DO
 			KettB [j+k]   := Chrom [k+AnzS]
		END;	INC (j, k)			|
   	"1" :	FOR k:=0 TO Anz1-1 DO
			KettB [j+k]   := Chrom [k+a]
		END;	INC (j, k)			|
   	"[" :	FOR k:=0 TO Anz2-1 DO
   			KettB [j+k]   := Chrom [k+b]
   		END;	INC (j, k)			|
   	"]" :	FOR k:=0 TO Anz3-1 DO
   			KettB [j+k]   := Chrom [k+c]
   		END;	INC (j, k)			|
   ELSE	END
END Ersetze;

PROCEDURE StartCodon (AnzGen : INTEGER) : INTEGER;
BEGIN
	RETURN RND (AnzGen)
END StartCodon;

PROCEDURE Mutare () : CHAR;
VAR Base : INTEGER;
BEGIN
	Base := RND (4);
	CASE Base OF
	 	0 : RETURN "0" |
	 	1 : RETURN "1" |
	 	2 : RETURN "[" |
	 	3 : RETURN "]" |
	END
END Mutare;

PROCEDURE Evol (Chrom : Chromosom);
VAR g, Start, k	: INTEGER;
    i, j	: LONGINT;
BEGIN
 FOR g:=0 TO AnzS-1 DO
 	KettA [g] := Chrom [g]
 END;
 KettA [AnzS] := "*";
 FOR g:=0 TO AnzIter-1 DO
  i:=0;		j:=0;
  WHILE (KettA [i] <> "*") DO
  	Ersetze (i, j, Chrom);
  	INC (i)
  END;
  KettB [j] := "*";
  KettA := KettB;
  IF (g=AnzIter-2) THEN
 	IF (AnzMut>0) THEN
  		FOR k:=0 TO AnzMut-1 DO
  			Start := StartCodon (j);
  			KettA [Start] := Mutare ()
  END 	END	END
 END
END Evol;

PROCEDURE GetChrom (fname : ARRAY OF CHAR; VAR Chrom : Chromosom);
VAR	fdat		: File;
	i, j		: INTEGER;
	ch		: CHAR;
BEGIN
 Lookup (fdat, fname, 512, FALSE);
 IF (fdat.res # done) THEN
 	DrawMsg ("Datei ...", 0, 3);
 	Delay (100);
	DrawMsg ("         ", 0, 0);
	Chrom [0] := 0C;
 	RETURN
 END;
 i:=0;
 FOR j:=0 TO 4 DO
	LOOP
 		ReadChar (fdat, ch);
 		CASE  ch  OF
 			"0" :	Chrom [i] := ch;   INC (i)	|
 			"1" :	Chrom [i] := ch;   INC (i)	|
 			"[" :	Chrom [i] := ch;   INC (i)	|
 			"]" :	Chrom [i] := ch;   INC (i)	|
 			";" :	CASE j OF
 			 	  0 :	AnzS := i			       |
 			 	  1 : 	Anz0 := i -  AnzS		       |
 		 		  2 : 	Anz1 := i - (AnzS + Anz0)	       |
		 		  3 : 	Anz2 := i - (AnzS + Anz0 + Anz1)       |
		 		  4 : 	Anz3 := i - (AnzS + Anz0 + Anz1 + Anz2)|
		 		END				|
 		ELSE	END;
 		IF (ch = ";") OR fdat.eof THEN EXIT END
 	END
 END;
 Close (fdat)
END GetChrom;

PROCEDURE Manage;
VAR 	class		: IDCMPFlagSet;
	adr		: GadgetPtr;
	Msg		: IntuiMessagePtr;
	err, toggle	: BOOLEAN;
BEGIN
  Msg:=NIL;	toggle:=FALSE;
  LOOP
	WaitPort (win2^.userPort);
	Msg:=GetMsg (win2^.userPort);
   	WHILE Msg # NIL DO
   		class := Msg^.class;	adr := Msg^.iAddress;
    		ReplyMsg (Msg);
    		IF (menuPick IN class) THEN
    			IF toggle THEN WindowToFront (win2)
    			ELSE WindowToBack (win2) END;
    			toggle := NOT toggle
    		END;
    		IF (gadgetUp IN class) THEN
    		 CASE adr^.gadgetID OF
    		  endegad   : EXIT					|
		  wachsgad  : IF (Chrom[0]=0C) THEN
		  		DrawMsg ("Chromosom", 0, 3);
		  		Delay (100);
		  		DrawMsg ("         ", 0, 0);
		  	      ELSE  IDCMPOff (win2);
		  	      	DrawMsg ("Berechne ", 3, 0);
		  	      	Evol (Chrom);
		  	      	DrawMsg (" Zeichne ", 3, 0);
		  	      	LassWachsen;
		  	      	DrawMsg ("  Fertig ", 2, 0);
		  	      	IDCMPOn (win2,IDCMPFlagSet{gadgetUp,menuPick})
		  	      END					|
		  zeichgad  : IF (Chrom[0]=0C) THEN
		  		DrawMsg ("Chromosom", 0, 3);
		  		Delay (100);
		  		DrawMsg ("         ", 0, 0);
		  	      ELSE IDCMPOff (win2);
		  	      	DrawMsg (" Zeichne ", 3, 0);
		  	      	LassWachsen;
		  	      	DrawMsg ("  Fertig ", 2, 0);
		  	        IDCMPOn (win2,IDCMPFlagSet{gadgetUp,menuPick})
		  	      END					|
		  itergad   : IF (IterInfo.longInt > 0) THEN
		  	      	AnzIter:=IterInfo.longInt;
		   Skal := HEIGHT DIV INTEGER(Pow (2.0, FFP(AnzIter)+SkalFak))
		   END							|
		  noxgad    : IF (NoxInfo.longInt>0) THEN
			      	MaxMut:=NoxInfo.longInt;
			      	AnzMut := 1 + RND (MaxMut)
 			      ELSE AnzMut:=0 END			|
		  astgad    : IF (AstInfo.longInt <=0) THEN
		 	      	AngIt:=20 ELSE AngIt:=AstInfo.longInt
		 	      END					|
		  skalgad   : StrToReal (SkalBuf, SkalFak, err);
	    	   Skal := HEIGHT DIV INTEGER(Pow (2.0, FFP(AnzIter)+SkalFak)) |
	    	  chrom1gad : GetChrom (Chrom1Buf, Chrom)		|
	    	ELSE END END;
    		Msg:=GetMsg (win2^.userPort)
  	END
  END
END Manage;

PROCEDURE VarInit;
VAR err : BOOLEAN;
BEGIN
 IterBuf := "4";		IterInfo.longInt := 4;
 NoxBuf  := "0";		NoxInfo.longInt  := 0;
 AstBuf  := "25";		AstInfo.longInt  := 25;
 SkalBuf := "2.0";
 RefreshGadgets (ADR(Chrom1Gad), win2, NIL);
 AnzIter := IterInfo.longInt;
 MaxMut  := NoxInfo.longInt;	IF (MaxMut>0) THEN AnzMut := 1 + RND (MaxMut)
 				ELSE AnzMut := 0 END;
 AngIt   := AstInfo.longInt;
 StrToReal (SkalBuf, SkalFak, err);
 Skal    := HEIGHT DIV INTEGER(Pow (2.0, FFP(AnzIter)+SkalFak));
 AnzS 	 := 0;
 Anz0 	 := 0; Anz1	 := 0;
 Anz2	 := 0; Anz3	 := 0
END VarInit;

PROCEDURE Colors;	(* $E- *)
BEGIN
 INLINE (0000H, 0050H, 0090H, 0E00H)
END Colors;

PROCEDURE Growup;
BEGIN
 win:=NIL; 	scr := NIL;	win2:=NIL;
 rp :=NIL;	vp  := NIL;
 scr := CreateScreen (WIDTH, HEIGHT, DEPTH, ViewModeSet{hires, lace}, NIL, NIL);
 vp := ADR (scr^.viewPort);
 LoadRGB4 (vp, ADR(Colors), COL);
 win := CreateWindow (0,0,WIDTH, HEIGHT, IDCMPFlagSet{},
 			WindowFlagSet{windowDepth, gimmeZeroZero, rmbTrap}, NIL,
 			scr,
ADR("    Flanz  -  Gewchshaus       ---       1990 by M.Peuckert"),
 			customScreen);
 win2 := CreateWindow (WIDTH-WIDTH2,0,WIDTH2,HEIGHT2,
 	 		IDCMPFlagSet{gadgetUp,menuPick},
 	  		WindowFlagSet{windowDrag,gimmeZeroZero}, ADR(Chrom1Gad),
 	 		scr, ADR(" Flanz - Grtner  "), customScreen);
 rp := win^.rPort;
 rp2:= win2^.rPort;
 DrawText (rp2)
END Growup;

PROCEDURE Cleanup;
BEGIN
 IF Level >= CurrentLevel () THEN
  IF win#NIL  THEN CloseWindow (win);  win :=NIL END;
  IF win2#NIL THEN CloseWindow (win2); win2:=NIL END;
  IF scr#NIL  THEN CloseScreen (scr);  scr :=NIL END
 END
END Cleanup;


BEGIN
 Level:=CurrentLevel();	TermProcedure (Cleanup);	waitCloseGadget:=FALSE;

 Growup;

 VarInit;

 Manage

END Flanz.
