IMPLEMENTATION MODULE FlGad;
(*---------------------------------------------------------------------------
   :Program.    FlGad.Mod
   :Version.    1.0
   :History.	Dez-89
   :Author.     Markus Peuckert
   :Address.    Schtzenstr. 50, D-3550 Marburg, West-Germany,
   :Copyright.  PD
   :Language.   Modula-2
   :Translator. M2Amiga V3.3d
---------------------------------------------------------------------------*)

FROM SYSTEM	IMPORT	ADR, INLINE;
FROM Intuition 	IMPORT	boolGadget, strGadget, Gadget, Border, StringInfo,
			IntuiText, ActivationFlags, ActivationFlagSet;
FROM Graphics	IMPORT	Move, Draw, Text, SetAPen, RastPortPtr;
FROM IntuiSup	IMPORT 	InitIText, InitBorder, CreateGadget, InitStringInfo;


VAR   ChromBord, ParamBord, CommBord				: Border;

      IterGad,  NoxGad,   AstGad,  SkalGad,
      WachsGad, ZeichGad, EndeGad				: Gadget;

      WachsText, ZeichText, EndeText				: IntuiText;

      Chrom1Info, SkalInfo					: StringInfo;

      Chrom1Unbuf						: BufStrTyp;
      IterUnbuf,   NoxUnbuf,    AstUnbuf,    SkalUnbuf		: BufIntTyp;


PROCEDURE xyParam;	(* $E- *)
BEGIN
 INLINE (0,0, 41,0, 41,10, 0,10, 0,0)
END xyParam;

PROCEDURE xyComm;	(* $E- *)
BEGIN
 INLINE (0,0, 61,0, 61,10, 0,10, 0,0)
END xyComm;

PROCEDURE xyChrom;	(* $E- *)
BEGIN
 INLINE (0,0, 131,0, 131,10, 0,10, 0,0)
END xyChrom;

PROCEDURE MakeGadgets;
BEGIN
 InitBorder (CommBord,  ADR(xyComm),   NIL);
 InitBorder (ParamBord, ADR(xyParam),   NIL);
 InitBorder (ChromBord, ADR(xyChrom),   NIL);

 InitIText (EndeText,   15,1, ADR("Ende"));
 InitIText (WachsText,  10,1, ADR("Wachs"));
 InitIText (ZeichText,  10,1, ADR("Zeich"));

 InitStringInfo (Chrom1Info, Chrom1Buf, Chrom1Unbuf);
 InitStringInfo (IterInfo,   IterBuf,   IterUnbuf);
 InitStringInfo (NoxInfo,    NoxBuf,    NoxUnbuf);
 InitStringInfo (AstInfo,    AstBuf,    AstUnbuf);
 InitStringInfo (SkalInfo,   SkalBuf,   SkalUnbuf);

 CreateGadget (EndeGad, 5,120, 60,11, endegad, boolGadget, NIL, NIL,
 		ADR(CommBord), ADR(EndeText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (ZeichGad, 75,105, 60,11, zeichgad, boolGadget, ADR(EndeGad),NIL,
 		ADR(CommBord), ADR(ZeichText),
 		ActivationFlagSet{gadgImmediate,relVerify});
 CreateGadget (WachsGad, 5,105, 60,11, wachsgad, boolGadget, ADR(ZeichGad), NIL,
 		ADR(CommBord), ADR(WachsText),
 		ActivationFlagSet{gadgImmediate,relVerify});

 CreateGadget (SkalGad, 95,85, 40,10, skalgad, strGadget, ADR(WachsGad),
 		ADR(SkalInfo), ADR(ParamBord), NIL,
 	ActivationFlagSet{stringCenter,gadgImmediate,relVerify,toggleSelect});
 CreateGadget (AstGad, 95,70, 40,10, astgad, strGadget, ADR(SkalGad),
 		ADR(AstInfo), ADR(ParamBord), NIL,
 	ActivationFlagSet{stringCenter,gadgImmediate,relVerify,
 			toggleSelect,longint});
 CreateGadget (NoxGad, 95,55, 40,10, noxgad, strGadget, ADR(AstGad),
 		ADR(NoxInfo), ADR(ParamBord), NIL,
 	ActivationFlagSet{stringCenter,gadgImmediate,relVerify,
 			toggleSelect,longint});
 CreateGadget (IterGad, 95,40, 40,10, itergad, strGadget, ADR(NoxGad),
 		ADR(IterInfo), ADR(ParamBord), NIL,
 	ActivationFlagSet{stringCenter,gadgImmediate,relVerify,
 			toggleSelect,longint});

 CreateGadget (Chrom1Gad, 5,20, 130,10, chrom1gad, strGadget, ADR(IterGad),
 		ADR(Chrom1Info), ADR(ChromBord), NIL,
 	ActivationFlagSet{stringCenter,gadgImmediate,relVerify,toggleSelect});
END MakeGadgets;

PROCEDURE InitBuffers;
BEGIN
 Chrom1Buf:=""; Chrom1Unbuf:="";
 IterBuf:="0";   NoxBuf:="0";   AstBuf:="0";   SkalBuf:="0";
 IterUnbuf:="0"; NoxUnbuf:="0"; AstUnbuf:="0"; SkalUnbuf:="0";
END InitBuffers;

PROCEDURE DrawText (rPort : RastPortPtr);
BEGIN
 SetAPen (rPort,  1);
 Move (rPort, 5, 13);  Text (rPort, ADR("   Chromosom"), 12);
 Move (rPort, 2, 35); Draw (rPort, 138, 35);
 Move (rPort, 5, 47); Text (rPort, ADR("Generation  "), 11);
 Move (rPort, 5, 62); Text (rPort, ADR("NoxenDosis "), 11);
 Move (rPort, 5, 77); Text (rPort, ADR("Ast-Winkel "), 11);
 Move (rPort, 5, 92); Text (rPort, ADR("Skalierung "), 11);
 Move (rPort, 2, 98); Draw (rPort, 138, 98);
END DrawText;


BEGIN

 InitBuffers;
 MakeGadgets

END FlGad.Mod
