IMPLEMENTATION MODULE IntuiSup;
(*---------------------------------------------------------------------------
   :Program.    IntuiSup.Mod
   :Version.    1.8
   :History.	Dez-89
   :Author.     Markus Peuckert
   :Address.    Schtzenstr. 50, D-3550 Marburg, West-Germany,
   :Copyright.  PD
   :Language.   Modula-2
   :Translator. M2Amiga V3.3d
---------------------------------------------------------------------------*)

FROM SYSTEM 	IMPORT	ADR, ADDRESS;
FROM Arts	IMPORT	Assert;
FROM Intuition	IMPORT	Gadget, GadgetFlags, GadgetFlagSet, Border, StringInfo,
			boolGadget, strGadget, ActivationFlags, ModifyIDCMP,
			ActivationFlagSet, IDCMPFlags, IDCMPFlagSet,
			WindowFlags, WindowFlagSet, WindowPtr, NewWindow,
			OpenWindow, ScreenPtr, ScreenFlags, ScreenFlagSet,
			IntuiText, customScreen, OpenScreen, NewScreen,
			OpenIntuition, IntuitionBasePtr;
FROM Graphics	IMPORT	ViewModes, ViewModeSet, jam1;


VAR	IntuiBasePtr		: IntuitionBasePtr;


PROCEDURE InitBorder (VAR Bord : Border; xyData, next : ADDRESS);
BEGIN
 WITH Bord DO
  leftEdge:=-1; topEdge:=-1; frontPen:=1; backPen:=0; drawMode:=jam1;
  count:=5; xy:=xyData; nextBorder:=next
 END
END InitBorder;

PROCEDURE InitStringInfo (VAR Info : StringInfo;
			  VAR buf, unbuf : ARRAY OF CHAR);
BEGIN
 WITH Info DO
  buffer:=ADR(buf);	undoBuffer:=ADR(unbuf);	bufferPos:=0;
  maxChars:=HIGH(buf);	dispPos:=0
 END
END InitStringInfo;

PROCEDURE InitIText (VAR IText : IntuiText; x,y : INTEGER; text : ADDRESS);
BEGIN
 WITH IText DO
  frontPen:=1; backPen:=0; drawMode:=jam1; leftEdge:=x; topEdge:=y;
  nextText:=NIL; iText:=text
 END
END InitIText;

PROCEDURE CreateGadget (VAR Gad : Gadget; x,y,w,h,ID : INTEGER; Type:CARDINAL;
			 next, Info, Bord, Text : ADDRESS;
			 Activ : ActivationFlagSet);
BEGIN
 WITH Gad DO
  nextGadget:=next;	leftEdge:=x; 	topEdge:=y;	width:=w;
  height:=h;		flags:=GadgetFlagSet{}; 	gadgetType:=Type;
  gadgetRender:=Bord;	selectRender:=NIL;		gadgetText:=Text;
  specialInfo:=Info;	gadgetID:=ID;   userData:=NIL;	activation:=Activ
 END;
END CreateGadget;

PROCEDURE CreateScreen (w,h,d : INTEGER; vm : ViewModeSet; t,gad : ADDRESS)
								 : ScreenPtr;
VAR ns  : NewScreen;
    scr : ScreenPtr;
BEGIN
 WITH ns DO
  leftEdge:=0; topEdge:=0; width:=w; height:=h; depth:=d; detailPen:=0;
  blockPen:=1; viewModes:=vm; type:=customScreen;font:=NIL; defaultTitle:=t;
  gadgets:=gad; customBitMap:=NIL
 END;
 scr := OpenScreen (ns);
 Assert (scr#NIL, ADR("Kein Schirm"));
 RETURN scr
END CreateScreen;

PROCEDURE CreateWindow(x,y,w,h : INTEGER; if: IDCMPFlagSet; wf: WindowFlagSet;
                       gad,scr,tit : ADDRESS; typ : ScreenFlagSet) : WindowPtr;
VAR
 nw  : NewWindow;
 win : WindowPtr;
BEGIN
 WITH nw DO
  leftEdge:=x; topEdge:=y; width:=w; height:=h; detailPen:=0; blockPen:=1;
  idcmpFlags:=if; flags:=wf; firstGadget:=gad; checkMark:=NIL; title:=tit;
  screen:=scr; bitMap:=NIL; minWidth:=160; minHeight:=14; maxWidth:=w;
  maxHeight:=h; type:=typ
 END;
 win := OpenWindow(nw);
 Assert (win#NIL, ADR("Kein Fenster"));
 RETURN win
END CreateWindow;

PROCEDURE IDCMPOn (window : WindowPtr; flags : IDCMPFlagSet);
BEGIN
 ModifyIDCMP (window, flags)
END IDCMPOn;

PROCEDURE IDCMPOff (window : WindowPtr);
BEGIN
 ModifyIDCMP (window, IDCMPFlagSet{})
END IDCMPOff;

PROCEDURE ActivWindow () : WindowPtr;
BEGIN
 RETURN IntuiBasePtr^.activeWindow
END ActivWindow;


BEGIN

 IntuiBasePtr := OpenIntuition();

END IntuiSup.Mod
