(******************************************************************************
*                                                                             *
*    Programmname:  IntuitionSupport                                          *
*                                                                             *
*    Stand:         29.12.89                            Uhrzeit:  18:07:00    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.12        () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE IntuitionSupport;

FROM Exec      IMPORT Byte,UByte;
FROM Graphics  IMPORT BitMapPtr,DrawModeSet,ViewModeSet;
FROM Intuition IMPORT ActivationFlagSet,Border,BorderPtr,Gadget,GadgetFlagSet,
                      GadgetPtr,IDCMPFlagSet,Image,IntuiText,IntuiTextPtr,Menu,
                      menuEnabled,MenuItem,MenuItemFlagSet,MenuItemPtr,MenuPtr,
                      NewScreen,NewWindow,PropInfo,PropInfoFlagSet,Requester,
                      RequesterFlagSet,RequesterPtr,ScreenFlagSet,ScreenPtr,
                      StringInfo,WindowFlagSet,WindowPtr;
FROM SYSTEM    IMPORT ADDRESS,ADR,LONGSET;

PROCEDURE SetIText(VAR it   : IntuiText;
                   text     : LONGINT;
                   fp,bp,
                   le,te    : INTEGER;
                   Mode     : DrawModeSet): IntuiTextPtr;
BEGIN
  WITH it DO
    frontPen:=fp; backPen:=bp;
    drawMode:=Mode;
    leftEdge:=le; topEdge:=te;
    iTextFont:=NIL;
    iText:=text;
    nextText:=NIL;
  END;
  RETURN ADR(it);
END SetIText;

PROCEDURE SetInfo(VAR info : StringInfo;
                  buf,unbuf: ADDRESS;
                  bp,mc,dp : INTEGER);
BEGIN
  WITH info DO
    buffer:=buf; undoBuffer:=unbuf;
    bufferPos:=bp; maxChars:=mc; dispPos:=dp;
  END;
END SetInfo;

PROCEDURE SetBorder(VAR border : Border;
                    le,te,fp,bp,
                    c          : INTEGER;
                    mode       : DrawModeSet;
                    xykoor     : ADDRESS): BorderPtr;
BEGIN
  WITH border DO
    leftEdge:=le; topEdge:=te;
    frontPen:=fp; backPen:=bp;
    drawMode:=mode;
    count:=c; xy:=xykoor;
    nextBorder:=NIL;
  END;
  RETURN ADR(border);
END SetBorder;

PROCEDURE SetBorderKoord(VAR int : ARRAY OF INTEGER; gadg : Gadget);
BEGIN
  int[0]:=0;              int[1]:=0;
  int[2]:=gadg.width+1;   int[3]:=0;
  int[4]:=gadg.width+1;   int[5]:=gadg.height+1;
  int[6]:=0;              int[7]:=gadg.height+1;
  int[8]:=0;              int[9]:=0;
END SetBorderKoord;

PROCEDURE SetGadget(VAR gadg       : Gadget;
                         le,te,w,h : INTEGER;
                         GadgFlags : GadgetFlagSet;
                         ActFlags  : ActivationFlagSet;
                         GadType   : CARDINAL;
                         GadgRend  : ADDRESS;
                         textptr   : ADDRESS;
                         specinfo  : ADDRESS;
                         id        : CARDINAL);
BEGIN
  WITH gadg DO
    nextGadget:=NIL; leftEdge:=le; topEdge:=te;
    width:=w; height:=h; flags:=GadgFlags; activation:=ActFlags;
    gadgetType:=GadType; gadgetRender:=GadgRend;
    selectRender:=NIL; gadgetText:=textptr;
    specialInfo:=specinfo; gadgetID:=id;
    userData:=NIL;
  END;
END SetGadget;

PROCEDURE SetPropInfo(VAR info       : PropInfo;
                          flaggen    : PropInfoFlagSet;
                          hPot,vPot,
                          hBody,vBody: INTEGER);
BEGIN
  WITH info DO
    flags:=flaggen;
    horizPot:=hPot; vertPot:=vPot;
    horizBody:=hBody; vertBody:=vBody;
  END;
END SetPropInfo;

PROCEDURE SetImage(VAR image      : Image;
                       le,te,w,h,
                       tiefe      : INTEGER;
                       imageDaten : ADDRESS;
                       Planepick,
                       PlaneOnOff : UByte);
BEGIN
  WITH image DO
    leftEdge:=le; topEdge:=te; width:=w; height:=h; depth:=tiefe;
    imageData:=imageDaten; planePick:=Planepick; planeOnOff:=PlaneOnOff;
  END;
END SetImage;

PROCEDURE SetMenu(VAR menu      : Menu;
                      le,te,w,h : INTEGER;
                      text      : ADDRESS): MenuPtr;
BEGIN
  WITH menu DO
    nextMenu:=NIL; leftEdge:=le; topEdge:=te; width:=w; height:=h;
    flags:={menuEnabled}; menuName:=text; firstItem:=NIL;
  END;
  RETURN ADR(menu);
END SetMenu;

PROCEDURE SetMenuItem(VAR item      : MenuItem;
                          le,te,w,h : INTEGER;
                          flaggen   : MenuItemFlagSet;
                          itemF,
                          selectF   : ADDRESS;
                          comm      : CHAR): MenuItemPtr;
BEGIN
  WITH item DO
    leftEdge:=le; topEdge:=te;
    width:=w; height:=h; flags:=flaggen;
    mutualExclude:=LONGSET{}; itemFill:=itemF;
    selectFill:=selectF; command:=comm;
    subItem:=NIL; nextItem:=NIL;
  END;
  RETURN ADR(item);
END SetMenuItem;

PROCEDURE SetRequester(VAR request   : Requester;
                           le,te,w,h : INTEGER;
                           reqGadg   : GadgetPtr;
                           reqBord   : BorderPtr;
                           reqTex    : IntuiTextPtr;
                           fl        : RequesterFlagSet;
                           backf     : INTEGER;
                           rWind     : WindowPtr): RequesterPtr;
BEGIN
  WITH request DO
    leftEdge:=le; topEdge:=te; width:=w; height:=h;
    relLeft:=0; relTop:=0; reqGadget:=reqGadg;
    reqBorder:=reqBord; reqText:=reqTex;
    flags:=fl;  backFill:=backf; reqLayer:=NIL;
    rWindow:=rWind; imageBMap:=NIL;
  END;
  RETURN ADR(request);
END SetRequester;

PROCEDURE SetWindow(VAR wind      : NewWindow;
                        le,te,w,h : INTEGER;
                        dPen,bPen : Byte;
                        idcmp     : IDCMPFlagSet;
                        flaggen   : WindowFlagSet;
                        titletext : ADDRESS;
                        fGadget   : GadgetPtr;
                        screenptr : ScreenPtr;
                        minW,minH,
                        maxW,maxH : INTEGER;
                        typ       : ScreenFlagSet);
BEGIN
  WITH wind DO
    leftEdge:=le; topEdge:=te; width:=w; height:=h;
    detailPen:=dPen; blockPen:=bPen;
    idcmpFlags:=idcmp; flags:=flaggen;
    firstGadget:=fGadget; checkMark:=NIL; title:=titletext;
    screen:=screenptr; bitMap:=NIL;
    minWidth:=minW; minHeight:=minH; maxWidth:=maxW; maxHeight:=maxH;
    type:=typ;
  END;
END SetWindow;

PROCEDURE SetScreen(VAR setscreen   : NewScreen;
                        le,te,w,h,d : INTEGER;
                        dPen,bPen   : Byte;
                        viewM       : ViewModeSet;
                        typ         : ScreenFlagSet;
                        defaultTit  : ADDRESS;
                        gadg        : GadgetPtr;
                        customBitM  : BitMapPtr);
BEGIN
  WITH setscreen DO
    leftEdge:=le; topEdge:=te; width:=w; height:=h; depth:=d;
    detailPen:=dPen; blockPen:=bPen; viewModes:=viewM;
    type:=typ; font:=NIL; defaultTitle:=defaultTit;
    gadgets:=gadg; customBitMap:=customBitM;
  END;
END SetScreen;

BEGIN
END IntuitionSupport.

