(**********************************************************************

    :Program.    m2Maker
    :Contents.   Compileroberflche fr M2Amiga
    :Author.     Thomas Stolze
    :Copyright.  ShareWare
    :Language.   Modula-2
    :Translator. M2Amiga AMSoft V3.3
    :Imports.    StringSupport
    :Imports.    DirectorySupport
    :Imports.    IntuitionSupport
    :History.    V1.0 Thomas Stolze
    :History.    V1.42 Thomas Stolze 01-JAN-90

**********************************************************************)

(******************************************************************************
*                                                                             *
*    Programmname:  m2MakerMain                                               *
*                                                                             *
*    Stand:         29.12.89                            Uhrzeit:  14:06:18    *
*                                                                             *
*    Bearbeitet mit dem MODULETool V1.12        () by  Thomas Stolze 1989    *
*                                                                             *
******************************************************************************)

(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
MODULE m2MakerMain;

FROM Arts             IMPORT Terminate,TermProcedure;
FROM DirectorySupport IMPORT Down,GetDevList,MasterControl,ModifyListDir,
                             NewDir,Up;
FROM Dos              IMPORT Delay;
FROM Exec             IMPORT GetMsg,ReplyMsg,WaitPort;
FROM InputEvent       IMPORT Qualifiers,QualifierSet;
FROM InputHandler     IMPORT CleanupHandler,Wache;
FROM Intuition        IMPORT GadgetPtr,IDCMPFlags,IDCMPFlagSet,IntuiMessagePtr,
                             MenuItemFlags,MenuItemFlagSet,WBenchToFront;
FROM RequesterWindow  IMPORT DeleteDatei,InfoRequester,InstallTimerTask,
                             MakerOptionen,OptionenRequester,Printer,
                             RenameDatei,LoadProjekt,DeleteProjekt;
FROM SYSTEM           IMPORT ADR,SHIFT;
FROM Str              IMPORT Concat,Copy;
FROM m2Maker          IMPORT BufferString,Cleanupm2Maker,DirPtr,F1,F10,F2,F3,F4,
                             F5,F6,F7,F8,F9,GadgetFeldListe,GadgetNamen,
                             MemoryTask,MenuItemFeld,projectFlag,SizeCLIWindow,
                             Window,window;
FROM m2MakerRoutines  IMPORT Backup,BackupPfad,Clear,CompileProject,Compiler,
                             Convert,Editor,EditorTextGadget,EditSysCompiler,
                             ExecuteBatch,Executeing,FastLister,
                             Invers,Linker,LoadOpts,Make,NewCli,NewFile,
                             PrintDosErr,PrintStatus,Project,ProjektPfad,
                             ProjektSpeichern,Prueffile,Resident,Run,SaveOpts,
                             Saver,SelectedFile,SmallWindow,StartDefMaker;

CONST cursorUp   = 4CH;
      cursorDown = 4DH;
      return     = 44H;
      space      = 40H;
      P          = 19H;

TYPE  IntuiParameterPtr = POINTER TO IntuiParameter;
      IntuiParameter    = RECORD
                            mousex,
                            mousey,
                            key    : INTEGER;
                          END;

VAR  dummy          : ARRAY [0..108] OF CHAR;
     class          : IDCMPFlagSet;
     qualifier      : QualifierSet;
     code,menu,item,
     subitem        : CARDINAL;
     msg            : IntuiMessagePtr;
     gadgAuswahl    : GadgetPtr;
     erfolg,
     bigWindow      : BOOLEAN;

PROCEDURE Cleanup;
BEGIN
  IF (checked IN MenuItemFeld[22].flags) THEN
     EXCL(MenuItemFeld[22].flags,checked);
       Resident;
  END;
  CleanupHandler;
  Cleanupm2Maker;
END Cleanup;

BEGIN
  TermProcedure(Cleanup); SizeCLIWindow;
  window:=Window(); Delay(25);
  MemoryTask:=InstallTimerTask();
  Clear;
  LoadOpts;

  Copy(dummy,BufferString[9]); Concat(dummy,BufferString[3]);
  IF Prueffile(dummy,FALSE) THEN
     Copy(BufferString[9],DirPtr^.Pfad);
     Copy(BufferString[3],DirPtr^.Auswahl);
     NewDir(FALSE);
  END;

  ExecuteBatch;
  Convert(ADR(GadgetFeldListe[projectGadget])); Project;

    LOOP
      WaitPort(window^.userPort);
        msg:=GetMsg(window^.userPort);
        class:=msg^.class;
        code:=msg^.code;
        DirPtr^.intuipar.key:=msg^.code;
        DirPtr^.intuipar.mousex:=msg^.mouseX;
        DirPtr^.intuipar.mousey:=msg^.mouseY;
        DirPtr^.intuipar.secs:=msg^.seconds;
        DirPtr^.intuipar.micros:=msg^.micros;
        qualifier:=msg^.qualifier;
        gadgAuswahl:=msg^.iAddress;
      ReplyMsg(msg);
        IF (closeWindow IN class) THEN
           EXIT;
        ELSIF (gadgetUp IN class) THEN
           CASE gadgAuswahl^.gadgetID OF
                0    :  Editor(FALSE);
           |    1    :  erfolg:=Compiler();
           |    2    :  Linker;
           |    3    :  Run;
           |    4    :  Make;
           |    5    :  NewDir(FALSE);
           |    6    :  LoadOpts;
           |    7    :  SaveOpts;
           |    8    :  Backup;
           |    10   :  EditorTextGadget;
           |    13   :  Clear;
           |    14   :  Printer;
           |    15   :  BackupPfad;
           |    17   :  Project;
           |    18   :  ProjektPfad;
           |    21   :  ModifyListDir;
           |    22   :  IF projectFlag THEN
                           Invers(ADR(GadgetFeldListe[projectGadget]));
                           Project
                        END; NewDir(TRUE);
           |    23   :  OptionenRequester;
           |    24   :  SmallWindow;
           |    25   :  DeleteDatei;
           |    26   :  NewFile;
           |    27   :  StartDefMaker;
           |    28   :  GetDevList;
           |    35   :  Down;
           |    36   :  Up;
           ELSE
           END;
        ELSIF (menuPick IN class) THEN
           menu:=(code MOD 32); item:=(code DIV 32) MOD 32;
           subitem:=SHIFT(code,-11);
           CASE menu OF
            0:
              CASE item OF
                0 : InfoRequester;
              | 1 : Saver;
              | 2 :
                    CASE subitem OF
                      0 : ProjektSpeichern(FALSE);
                    | 1 : ProjektSpeichern(TRUE);
                    ELSE
                    END;

              | 3 : FastLister;
              | 4 : NewCli;
              | 5 : EXIT;
              END;
          |  1:
              CASE item OF
                0 : Convert(ADR(GadgetFeldListe[editorGadget]));  Editor(FALSE);
              | 1 : Convert(ADR(GadgetFeldListe[compilerGadget]));
                    erfolg:=Compiler();
              | 2 : Convert(ADR(GadgetFeldListe[linkerGadget]));  Linker;
              | 3 : Convert(ADR(GadgetFeldListe[runGadget]));     Run;
              | 4 : Convert(ADR(GadgetFeldListe[makeGadget]));    Make;
              | 5 :
                    CASE subitem OF
                      0 : EditSysCompiler;
                    | 1 : CompileProject("",TRUE);
                    | 2 : CompileProject(BufferString[3],FALSE);
                    ELSE
                    END;
              ELSE
              END;
          |  2:
              CASE item OF
                0 : OptionenRequester;
              | 1 : LoadOpts;
              | 2 : SaveOpts;
              | 3 : IF (checked IN MenuItemFeld[17].flags) THEN
                       MakerOptionen;
                    ELSE
                       PrintStatus("Erweiterte Make-Funktion abgeschaltet.");
                    END;
              | 4 : IF (checked IN MenuItemFeld[21].flags) THEN
                        CleanupHandler; Wache;
                    ELSE
                        CleanupHandler;
                    END;
              | 5 : Resident;
              ELSE
              END;
          |  3:
              CASE item OF
                0 : RenameDatei;
              | 1 : DeleteDatei;
              | 2 : NewDir(FALSE);
              | 3 : GetDevList;
              | 4 : LoadProjekt;
              | 5 : DeleteProjekt;
              ELSE
              END;
           ELSE
           END;
        ELSIF (mouseButtons IN class) OR (rawKey IN class) THEN
           IF MasterControl() THEN
              SelectedFile;
           ELSE
              IF (control IN qualifier) AND (lShift IN qualifier) THEN
                 IF ((code >= 208) AND (code <= 213)) OR (code = 192) THEN
                    code:=code-128;
                 END;
              END;

              CASE code OF
                F1 : Convert(ADR(GadgetFeldListe[editorGadget])); Editor(FALSE);
              | F2 : Convert(ADR(GadgetFeldListe[compilerGadget]));
                     erfolg:=Compiler();
              | F3 : Convert(ADR(GadgetFeldListe[linkerGadget]));  Linker;
              | F4 : Convert(ADR(GadgetFeldListe[runGadget]));     Run;
              | F5 : Convert(ADR(GadgetFeldListe[makeGadget]));    Make;
              | F6 : NewDir(FALSE);
              | F7 : OptionenRequester;
              | F8 : StartDefMaker;
              | F9 : Convert(ADR(GadgetFeldListe[copyGadget]));    Backup;
              | F10: Printer;
              | space: erfolg:=WBenchToFront();
              ELSE
              END;
           END;

           IF (control IN qualifier) THEN
               CASE code OF
                    33H : NewCli;
               |    10H : EXIT;
               |    22H : GetDevList;
               |    P   : IF projectFlag THEN
                             Invers(ADR(GadgetFeldListe[projectGadget]));
                          ELSE
                             Convert(ADR(GadgetFeldListe[projectGadget]));
                          END;
                          Project;
               ELSE
               END;
           END;
        END;
    END;
    Terminate(0);
END m2MakerMain.
