(*---------------------------------------------------------------------------
 :Program.      WBPrefs
 :Author.       Thomas Ansorge
 :Address.      Dinkelackerring 55, D-6730 Neustadt
 :Copyright.    FD
 :Language.     OBERON
 :Translator.   AMIGA OBERON Compiler
 :History.      V2.0 13-Jun-90: Erste Version                 Thomas Ansorge
 :History.      V2.1 20-Jun-90: Fehler entfernt, M2 -> Oberon Fridtjof Siebert
 :Contents.     Program to set Preferences
 :Usage.        WBPrefs <Prefsfile>
---------------------------------------------------------------------------*)

MODULE WBPrefs;

(*********************************************************************)
(*                                                                   *)
(*  1990 by Thomas Ansorge, Dinkelackerring 55, D-6730 Neustadt     *)
(*                                                                   *)
(* Version : 2.0 vom 13.06.1990                                      *)
(*                                                                   *)
(* Sprache : MODULA-2 (M2Amiga V3.3d)                                *)
(*                                                                   *)
(* Funktion: Dieses Programm ldt eine Datei, interpretiert die      *)
(*           Daten darin als Preferences und setzt diese. Der Name   *)
(*           der Datei mu beim Aufruf im CLI/Shell bergeben werden *)
(*           (bei Workbench-Start "erweiterte Selektion" mglich).   *)
(*                                                                   *)
(* Danke   : an Fridtjof, der mich auf einen Fehler in der Version   *)
(*           1.0 aufmerksam machte.                                  *)
(*                                                                   *)
(*********************************************************************)

IMPORT I:   Intuition,
       fs:  FileSystem,
       arg: Arguments,
            io,
       sys: SYSTEM;

(* ----------------------------------------------------------------- *)

VAR Prefs : I.Preferences;
    Anzahl: LONGINT; (* fr Dos.Read *)
    Datei : fs.File;

    (* fr Arguments *)
    Argument: ARRAY 80 OF CHAR;

(* ----------------------------------------------------------------- *)

BEGIN (* Modul WBPrefs *)

  IF arg.NumArgs() = 1 THEN
    arg.GetArg(1,Argument)
  ELSE
    Argument := "devs:system-configuration";
  END;

  IF Argument = "?" THEN

    io.WriteLn;
    arg.GetArg (0, Argument);
    io.WriteString (Argument);
    io.WriteString (": Fehler - Genau ein Dateiname erwartet!");
    io.WriteLn; io.WriteLn;

  ELSE

    (* Datei einlesen *)
    IF fs.Open(Datei, Argument, FALSE) THEN

      IF fs.Read(Datei,Prefs) THEN

        (* Bis jetzt habe ich keine Unstimmigkeiten feststellen knnen.   *)
        (* Ich nehme an, da "Preferences" das mit der DEVS:system-conf.  *)
        (* genauso macht!                                                 *)

        (* Prefs in den Speicher schreiben *)
        I.SetPrefs (sys.ADR (Prefs), sys.SIZE (Prefs), I.LTRUE);

        io.WriteString("ok!\n");

      END;

      IF fs.Close (Datei) THEN END; (* ergebnis kann ignoriert werden *)

    ELSE

      io.WriteString("*** Konnte Datei nicht ffnen!"); io.WriteLn;

    END;

  END (* If ArgNum *);

END WBPrefs (* Modul *).
