(*---------------------------------------------------------------------------
 :Program.      DetachFile.mod
 :Author.       Fridtjof Siebert
 :Address.      Nobileweg 67, D-7000 Stuttgart 40
 :Shortcut.     [fbs]
 :Copyright.    FD, see docs
 :Language.     OBERON
 :Translator.   Amiga Oberon Compiler V1.31
 :History.      V1.0, 15-Feb-91, [fbs]
 :Usage.        DetachFile <source> <destination>
---------------------------------------------------------------------------*)

MODULE DetachFile;

IMPORT fs:  FileSystem,
            io,
            Break,
       arg: Arguments;

VAR
  in,out: fs.File;
  src,dst: ARRAY 256 OF CHAR;
  typ: LONGINT;

  first,last: LONGINT;

CONST
  HUNKHEADER  = 03F3H;
  HUNKCODE    = 03E9H;
  HUNKDATA    = 03EAH;
  HUNKBSS     = 03EBH;
  HUNKEND     = 03F2H;
  HUNKOVERLAY = 03F5H;
  HUNKNAME    = 03E8H;
  HUNKSYMBOL  = 03F0H;
  HUNKDEBUG   = 03F1H;
  HUNKRELOC32 = 03ECH;


  Size1 = 57;
  Size2 = 63;
  Size3 = 87;

TYPE

  T1 = ARRAY 2 * Size1 OF INTEGER;
  T2 = ARRAY 2 * Size2 OF INTEGER;

CONST

  Data1 = T1(

    02C78U,00004U,                (* MOVEA.L     4,A6                 *)
    0286EU,00114U,                (* MOVEA.L     276(A6),A4           *)
    04AACU,000ACU,                (* TST.L       172(A4)              *)
    06606U,                       (* BNE         00000014H            *)
    04EF9U,00000U,00088U,         (* JMP         00000088H            *)
    023C0U,00000U,00114U,         (* MOVE.L      D0,00000114H         *)
    043F9U,00000U,00014U,         (* LEA         00000014H,A1         *)
    00240U,000FFU,                (* ANDI.W      #00FFH,D0            *)
    012D8U,                       (* MOVE.B      (A0)+,(A1)+          *)
    051C8U,0FFFCU,                (* DBF         D0,00000024H         *)
    043FAU,000AAU,                (* LEA         000000B6H(PC),A1     *)
    07021U,                       (* MOVEQ       #33,D0               *)
    04EAEU,0FDD8U,                (* JSR         -552(A6)             *)
    023C0U,00000U,00000U,         (* MOVE.L      D0,00000000H         *)
    043FAU,0FFC0U,                (* LEA         -4(PC),A1            *)
    023D1U,00000U,00008U,         (* MOVE.L      (A1),00000008H       *)
    023D1U,00000U,00158U,         (* MOVE.L      (A1),00000008H       *)
    04291U,                       (* CLR.L       (A1)                 *)
    02078U,00004U,                (* MOVEA.L     4,A0                 *)
    02068U,00114U,                (* MOVEA.L     276(A0),A0           *)
    02228U,00098U,                (* MOVE.L      152(A0),D1           *)
    02C79U,00000U,00000U,         (* MOVEA.L     00000000H,A6         *)
    04EAEU,0FFA0U,                (* JSR         -96(A6)              *)
    023C0U,00000U,00004U,         (* MOVE.L      D0,00000004H         *)
    06604U,                       (* BNE         0000006EH            *)
    07014U,                       (* MOVEQ       #20,D0               *)
    04E75U,                       (* RTS                              *)
    02C78U,00004U,                (* MOVEA.L     4,A6                 *)
    04EAEU,0FF7CU,                (* JSR         -132(A6)             *)
    0223CU,00000U,000EAU,         (* MOVE.L      #000000EAH,D1        *)
    04282U,                       (* CLR.L       D2                   *)
    0142CU,00009U,                (* MOVE.B      9(A4),D2             *)
    0263CU,00000U,00000U,         (* MOVE.L      #00000000H,D3        *)
    05943U,                       (* SUBQ.W      #4,D3                *)
    0E48BU,                       (* LSR.L       #2,D3                *)
    0282CU,00084U,                (* MOVE.L      132(A4),D4           *)
    02C79U,00000U,00000U,         (* MOVEA.L     00000000H,A6         *)
    04EAEU,0FF76U,                (* JSR         -138(A6)             *)
    00480U,00000U,0005CU,         (* SUBI.L      #0000005CH,D0        *)
    02040U,                       (* MOVEA.L     D0,A0                *)
    02179U,00000U,00004U,00098U,  (* MOVE.L      00000004H,152(A0)    *)
    043F9U,00000U,0011CU,         (* LEA         0000011CH,A1         *)
    02009U,                       (* MOVE.L      A1,D0                *)
    0E488U,                       (* LSR.L       #2,D0                *)
    02140U,000ACU,                (* MOVE.L      D0,172(A0)           *)
    05380U,                       (* SUBQ.L      #1,D0                *)
    02340U,00004U,                (* MOVE.L      D0,4(A1)             *)
    02340U,00010U,                (* MOVE.L      D0,16(A1)            *)
    02340U,00018U,                (* MOVE.L      D0,24(A1)            *)
    02340U,00024U,                (* MOVE.L      D0,36(A1)            *)
    02C78U,00004U,                (* MOVEA.L     4,A6                 *)
    04EAEU,0FF76U,                (* JSR         -138(A6)             *)
    07000U,                       (* MOVEQ       #0,D0                *)
    04E75U,                       (* RTS                              *)
    0646FU,0732EU,06C69U,         (* DC.B        "dos.library",0      *)
    06272U,06172U,07900U,         (*                                  *)
    04E71U);                      (* NOP                              *)

  Data2 = T2(

    02C79U,00000U,00000U,               (* MOVEA.L     00000000H,A6         *)
    0223CU,00000U,000F4U,               (* MOVE.L      #000000F4H,D1        *)
    0243CU,00000U,003EDU,               (* MOVE.L      #000003EDH,D2        *)
    04EAEU,0FFE2U,                      (* JSR         -30(A6)              *)
    023C0U,00000U,0000CU,               (* MOVE.L      D0,0000000CH         *)
    0677AU,                             (* BEQ         00000098H            *)
    0223CU,00000U,000F4U,               (* MOVE.L      #000000F4H,D1        *)
    0243CU,00000U,003EEU,               (* MOVE.L      #000003EEH,D2        *)
    04EAEU,0FFE2U,                      (* JSR         -30(A6)              *)
    023C0U,00000U,00010U,               (* MOVE.L      D0,00000010H         *)
    06762U,                             (* BEQ         00000098H            *)
    02878U,00004U,                      (* MOVEA.L     4,A4                 *)
    0286CU,00114U,                      (* MOVEA.L     276(A4),A4           *)
    02979U,00000U,0000CU,0009CU,        (* MOVE.L      0000000CH,156(A4)    *)
    02979U,00000U,00010U,000A0U,        (* MOVE.L      00000010H,160(A4)    *)
    043F9U,00000U,0011CU,               (* LEA         0000011CH,A1         *)
    02379U,00000U,00004U,00008U,        (* MOVE.L      000000HHHHH04,8(A1)      *)
    02379U,00000U,0000CU,0001CU,        (* MOVE.L      0000000CH,28(A1)     *)
    02379U,00000U,0000CU,00020U,        (* MOVE.L      0000000CH,32(A1)     *)
    02379U,00000U,00010U,00030U,        (* MOVE.L      00000010H,48(A1)     *)
    02379U,00000U,00010U,00038U,        (* MOVE.L      00000010H,56(A1)     *)
    02039U,00000U,00114U,               (* MOVE.L      00000114H,D0         *)
    041F9U,00000U,00014U,               (* LEA         00000014H,A0         *)
    04EB9U,00000U,00000U,               (* JSR         00000000H            *)
    023F9U,00000U,00124U,00000U,00004U, (* MOVE.L      00000124H,00000004H  *)
    02600U,                             (* MOVE.L      D0,D3                *)
    02239U,00000U,00004U,               (* MOVE.L      00000004H,D1         *)
    06744U,                             (* BEQ         000000E6H            *)
    02C79U,00000U,00000U,               (* MOVEA.L     00000000H,A6         *)
    04EAEU,0FFA6U,                      (* JSR         -90(A6)              *)
    02C78U,00004U,                      (* MOVEA.L     4,A6                 *)
    04EAEU,0FF7CU,                      (* JSR         -132(A6)             *)
    02C79U,00000U,00000U,               (* MOVEA.L     00000000H,A6         *)
    02239U,00000U,00008U,               (* MOVE.L      00000008H,D1         *)
    04EAEU,0FF64U,                      (* JSR         -156(A6)             *)
    02239U,00000U,0000CU,               (* MOVE.L      0000000CH,D1         *)
    06704U,                             (* BEQ         000000D0H            *)
    04EAEU,0FFDCU,                      (* JSR         -36(A6)              *)
    02239U,00000U,00010U,               (* MOVE.L      00000010H,D1         *)
    06704U,                             (* BEQ         000000DCH            *)
    04EAEU,0FFDCU,                      (* JSR         -36(A6)              *)
    0224EU,                             (* MOVEA.L     A6,A1                *)
    02C78U,00004U,                      (* MOVEA.L     4,A6                 *)
    04EAEU,0FE62U,                      (* JSR         -414(A6)             *)
    02003U,                             (* MOVE.L      D3,D0                *)
    04E75U,                             (* RTS                              *)

    04465U,07461U,06368U,06564U,
    00000U,                             (* DC.B        "Detached",0         *)
    04E49U,04C3AU,00000U,               (* DC.B        "NIL:",0             *)
    04E71U);


  PROCEDURE Quit(s: ARRAY OF CHAR);

  BEGIN
    io.WriteString("\nSorry, ich habe ein kleines Problem: \[1m"); io.WriteString(s);
    io.WriteString("!\[m\n");
    HALT(20);
  END Quit;


  PROCEDURE Usage;

  BEGIN
    io.WriteString("\n  \[1mUsage: \[33mDetachFile\[31m  <Source>  <Destination>\[m\n\n     1991 by Fridtjof Siebert\n\n    geschrieben mit dem Amiga Oberon Compiler\n\n");
    HALT(20);
  END Usage;

  PROCEDURE Get(): LONGINT;
  VAR l: LONGINT;
  BEGIN
    IF fs.Read(in,l) THEN
      RETURN l;
    ELSE
      Quit("Lesefehler");
    END;
  END Get;

  PROCEDURE GetOk(VAR l: LONGINT): BOOLEAN;
  BEGIN
    RETURN fs.Read(in,l);
  END GetOk;

  PROCEDURE Put(l: LONGINT);
  BEGIN
    IF NOT fs.Write(out,l) THEN
      Quit("Schreibfehler");
    END;
  END Put;

  PROCEDURE PutA(d: ARRAY OF BYTE);
  BEGIN
    IF NOT fs.Write(out,d) THEN
      Quit("Schreibfehler");
    END;
  END PutA;

  PROCEDURE Hunk(typ: LONGINT);
  VAR
    len,x: LONGINT;
  BEGIN
    CASE typ MOD 1000000H OF
    HUNKHEADER:
      Put(HUNKHEADER);
      LOOP
        len := Get();
        Put(len);
        IF len=0 THEN EXIT END;
        WHILE len>0 DO
          DEC(len);
          Put(Get());
        END
      END;
      len := Get();
      Put(len+3);
      first := Get();
      Put(0);
      last := Get();
      Put(last+3);
      len := last-first;
      Put(Size1);
      Put(Size2);
      Put(Size3);
      WHILE len>=0 DO
        Put(Get());
        DEC(len);
      END;
      Put(HUNKCODE);
      Put(Size1);
      PutA(Data1);
      Put(HUNKRELOC32);
      Put( 3); Put(first+1); Put(0010H); Put(0078H); Put(0084H);
      Put(10); Put(first+2); Put(0016H); Put(001CH); Put(0036H); Put(0040H);
                             Put(0046H); Put(005AH); Put(0064H); Put(0092H);
                             Put(00A4H); Put(00ACH);
      Put(0);
      Put(HUNKEND);
      Put(HUNKCODE);
      Put(Size2);
      PutA(Data2);
      Put(HUNKRELOC32);
      Put( 2); Put(first+1); Put(0008H); Put(0020H);
      Put(21); Put(first+2); Put(0002H); Put(0018H); Put(0030H); Put(0040H);
                             Put(0048H); Put(0050H); Put(0056H); Put(005EH);
                             Put(0066H); Put(006EH); Put(0076H); Put(007EH);
                             Put(0084H); Put(0090H); Put(0094H); Put(009CH);
                             Put(00A4H); Put(00B6H); Put(00BCH); Put(00C6H);
                             Put(00D2H);
      Put( 1); Put(first+3); Put(008AH);
      Put(0);
      Put(HUNKEND);
      Put(HUNKBSS);
      Put(Size3);
      Put(HUNKEND) |
    HUNKCODE,HUNKDATA,HUNKNAME,HUNKDEBUG:
      Put(typ);
      len := Get();
      Put(len);
      WHILE len>0 DO
        DEC(len);
        Put(Get());
      END |
    HUNKBSS:
      Put(typ);
      Put(Get()) |
    HUNKOVERLAY:
      Quit("Overlays sind nicht erlaubt") |
    HUNKSYMBOL:
      Put(typ);
      LOOP
        len := Get();
        Put(len);
        IF len=0 THEN EXIT END;
        REPEAT
          DEC(len);
          Put(Get());
        UNTIL len=0;
        Put(Get());
      END |
    HUNKRELOC32:
      Put(typ);
      LOOP
        len := Get();
        Put(len);
        IF len=0 THEN EXIT END;
        Put(Get()+3);
        REPEAT
          DEC(len);
          Put(Get());
        UNTIL len=0;
      END |
    HUNKEND:
      Put(typ) |
    ELSE
      Quit("Unbekannter Hunk-Typ");
    END;
  END Hunk;

BEGIN

  IF arg.NumArgs()#2 THEN Usage END;
  arg.GetArg(1,src);
  arg.GetArg(2,dst);
  IF NOT fs.Open(in,src,FALSE) THEN
    Quit("Konnte Source nicht ffnen");
  END;
  IF NOT fs.Open(out,dst,TRUE) THEN
    Quit("Konnte Destination nicht ffnen");
  END;
  WHILE GetOk(typ) DO
    Hunk(typ);
  END;
  IF fs.Close(in) THEN END;
  IF NOT fs.Close(out) THEN Quit("Schreibfehler") END;

CLOSE

  io.WriteString("\ntsch!\n");

END DetachFile.
