MODULE Sparks;
(*$ LargeVars:=FALSE LongAlign:=FALSE StackChk:=FALSE StackParms:=FALSE
    RangeChk:=FALSE OverflowChk:=FALSE NilChk:=FALSE Volatile:=FALSE
*)

FROM SYSTEM IMPORT ADR,ADDRESS,ASSEMBLE,SHORTSET,BITSET,CAST,SHIFT;
IMPORT Graphics,Intuition;
FROM Arts IMPORT Terminate;


CONST
  maxLines=128;
  erase=0;
  x=0;
  y=1;
  start = 0;
  end   = 1;
  DEPTH=5; COLS=32;

TYPE
  point = ARRAY [0..1] OF INTEGER; (* x,y *)
  line = ARRAY [0..1] OF point;    (* start,end *)

VAR
  i: INTEGER;
  ns: Intuition.NewScreen;
  screen: Intuition.ScreenPtr;
  Ciapra[0BFE001H]: SHORTSET;
  lines: ARRAY [0..maxLines-1] OF line;
  l: line;
  cl: INTEGER;
  color,coldir: INTEGER;
  deltas: line;
  mx,my: INTEGER;


PROCEDURE colors; (*$ EntryExitCode:=FALSE *)
BEGIN
  ASSEMBLE(DC.W
     $0000,$0F00,$0F30,$0F60,$0F90,$0FC0,$0FF0,$0CF0,
     $09F0,$06F0,$03F0,$00F0,$00F3,$00F6,$00F9,$00FC,
     $00FF,$00CF,$009F,$006F,$003F,$000F,$030F,$060F,
     $090F,$0C0F,$0F0F,$0F3F,$0F6F,$0F9F,$0FCF,$0FFF
  END);
END colors;



PROCEDURE AdjustX(VAR x,dx: INTEGER): BOOLEAN;
BEGIN
  INC(x,dx);
  IF (x<0) OR (x>=mx) THEN
    DEC(x,dx);
    RETURN TRUE
  ELSE
    RETURN FALSE
  END;
END AdjustX;


PROCEDURE AdjustY(VAR y,dy: INTEGER): BOOLEAN;
BEGIN
  INC(y,dy);
  IF (y<0) OR (y>=my) THEN
    DEC(y,dy);
    RETURN TRUE
  ELSE
    RETURN FALSE
  END;
END AdjustY;


PROCEDURE DrawLine(VAR l: line; color: INTEGER);
VAR rp: Graphics.RastPortPtr;
BEGIN
  rp := ADR(screen^.rastPort);
  Graphics.SetAPen(rp,color);
  Graphics.SetDrMd(rp,Graphics.jam1);
  Graphics.Move(rp,l[start,x],l[start,y]);
  Graphics.Draw(rp,l[end,  x],l[end,  y]);
END DrawLine;


(*$ EntryExitCode:=FALSE *)
PROCEDURE NewDelta(): INTEGER; (* 1..4, -4..-1 *)
CONST Range=4; (* mu 2er-Potenz sein! *)
VAR
  VHPosR[0DFF006H]: BITSET;
BEGIN
  ASSEMBLE(
	MOVE.W	VHPosR,D0
	MOVE.W	D0,D1
	ROR.W	#8,D1
	EOR.W	D1,D0
	ANDI.W	#2*Range-1,D0
	ADDQ.W	#1,D0
	CMPI.W	#Range,D0
	BLS.S	ok
	SUBI.W	#2*Range+1,D0
  ok:	RTS
  END);
END NewDelta;

VAR gfx:Graphics.GfxBasePtr;
BEGIN
  gfx:=ADR(Graphics);
  ns.width  := gfx^.normalDisplayColumns DIV 2;
  ns.height := -1;
  ns.depth  := DEPTH;
  ns.type   := Intuition.customScreen
		+Intuition.ScreenFlagSet{Intuition.screenQuiet};
  screen := Intuition.OpenScreen(ns);
  IF screen=NIL THEN Terminate END;
  Graphics.LoadRGB4(ADR(screen^.viewPort),ADR(colors),COLS);
  color:=1; coldir := 1;
  mx := screen^.width;
  my := screen^.height;
  l[start,x] := mx DIV 2;
  l[end  ,x] := l[start,x];
  l[start,y] := my DIV 2;
  l[end  ,y] := l[start,y];
  deltas[start,x] := 1000;
  deltas[end  ,x] := 1000;
  WHILE 6 IN Ciapra DO
    (* main loop *)
    DrawLine(lines[cl],erase);
    INC(color,coldir);
    IF (color=1) OR (color=COLS-1) THEN coldir := -coldir END;
    i := start;
    REPEAT
      IF AdjustX(l[i,x],deltas[i,x]) OR AdjustY(l[i,y],deltas[i,y]) THEN
        deltas[i,x] := NewDelta();
        deltas[i,y] := NewDelta();
      END;
      INC(i);
    UNTIL i>end;
    DrawLine(l,color);
    lines[cl] := l;
    cl := (cl+1) MOD maxLines;
  END
CLOSE
  IF screen#NIL THEN Intuition.CloseScreen(screen); screen:=NIL END
END Sparks.
