(*$ LargeVars:=FALSE Volatile:=FALSE StackParms:=FALSE
    NilChk:=FALSE RangeChk:=FALSE OverflowChk:=FALSE StackChk:=FALSE
*)
MODULE tilt;
(*
 * original source Leo L. Schwab
 * adapted to M2Amiga 16.9.87/ms
 * new adaption M2Amiga V4.0 25.8.90/bp
 *)
FROM SYSTEM IMPORT
 ADDRESS,ADR,SETREG,SHIFT,CAST,ASSEMBLE;
FROM Arts IMPORT
 Assert,Terminate,returnVal;
FROM Dos IMPORT
 Delay;
FROM Graphics IMPORT
 BitMapPtr,RastPortPtr,ViewModes,ViewModeSet,
 BltBitMap,ScrollRaster;
FROM Intuition IMPORT
 recoveryAlert,IDCMPFlagSet,NewWindow,NewScreen,ScreenFlags,ScreenFlagSet,
 ScreenPtr,WindowFlags,WindowFlagSet,WindowPtr,
 CloseScreen,CloseWindow,DisplayAlert,OpenScreen,OpenWindow,ScreenToBack,
 ScreenToFront;


PROCEDURE CreateScreen(x, y, w, h: INTEGER; v: ViewModeSet): ScreenPtr;
 VAR
  ns: NewScreen;
 BEGIN
  WITH ns DO
   leftEdge:=x; topEdge:=y; width:=w; height:=h; depth:=2;
   detailPen:=255; blockPen:=255;
   viewModes:=v;
   type:=ScreenFlagSet{};
   font:=NIL; defaultTitle:=NIL; gadgets:=NIL; customBitMap:=NIL
  END;
  RETURN OpenScreen(ns)
 END CreateScreen;


VAR (*$ LongAlign:=FALSE *)
 i: INTEGER;
 scr, wb: ScreenPtr;
 newWin:POINTER TO NewWindow;
 win: WindowPtr;
 rp: RastPortPtr;
 wbm,mbm: BitMapPtr;
 x, y, n: LONGINT;

(*$ EntryExitCode:=FALSE *)
PROCEDURE NewWin; (* NewWindow-Struktur in eine Prozedur verpackt *)
CONST if=CAST(LONGINT,IDCMPFlagSet{});
      wf=CAST(LONGINT,WindowFlagSet{windowDrag,windowDepth, activate});
      screenflags=CAST(INTEGER,ScreenFlagSet{wbenchScreen});
BEGIN
  ASSEMBLE(
	RELOCATION (* erlaube die absolute Benutzung von Title *)
	DC.W	150,130,100,20 (* left top width height *)
	DC.B	0,1 (* detailPen blockPen *)
	DC.L	if,wf,0,0 (* idcmp, flags, firstGadget, checkMark *)
	DC.L	Title (* title *)
	DC.L	0,0 (* screen, bitMap *)
	DC.W	0,0,0,0 (* min..max *)
	DC.W	screenflags
 Title:	DC.B	'Tilt!',0
 	EVEN
  END);
END NewWin;

CONST
  GuruMsg=
 "\o\x60\x0fSoftware Failure.   Press left mouse button to continue. \o\x01\o\xb0\x1cGuru Meditation #00019987.000JR000";
BEGIN
 newWin:=ADR(NewWin);
 win:=OpenWindow(newWin^);
 IF win=NIL THEN Terminate END;
 wb:=win^.wScreen;(* Workbench Screen  *)
 WITH wb^ DO
  scr:=CreateScreen(leftEdge, topEdge, width, height, viewPort.modes)
 END;
 IF scr=NIL THEN Terminate END;
 ScreenToBack(scr);
 rp:=ADR(scr^.rastPort);
 mbm:=rp^.bitMap;
 wbm:=win^.wScreen^.rastPort.bitMap;
 SETREG(0, BltBitMap(wbm, 0, 0, mbm, 0, 0,
                     scr^.width,scr^.height, 0C0H, 0FFH, NIL));
 y:=scr^.height-1;
 FOR i:=0 TO 39 DO x:=16*i; ScrollRaster(rp,0,i-20,x,0,x+15,y) END;
 x:=scr^.width-1;
 n:=scr^.height DIV 50;
 FOR i:=0 TO 49 DO y:=i*n; ScrollRaster(rp,25-i,0,0,y,x,y+n-1) END;
 ScreenToFront(scr);
 Delay(50);
 IF DisplayAlert(recoveryAlert, ADR(GuruMsg), 40) THEN END;

CLOSE
  IF scr#NIL THEN CloseScreen(scr); scr:=NIL END;
  IF win#NIL THEN CloseWindow(win); win:=NIL END
END tilt.mod
