(*----------------------------------------------------------------------
  :Program.    Io.mod
  :Contents.   Abspeichern und Laden einer Gadget-Struktur
  :Author.     Hubert Bildstein
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga V3.3d
  :History.    V1.0   5.12.1990
----------------------------------------------------------------------*)

IMPLEMENTATION MODULE Io;
(* Modul zur Ein/Ausgabe der Gadgetinformationen *)

FROM SYSTEM     IMPORT ADDRESS, ADR, BYTE;
FROM FileSystem IMPORT File, Response, Lookup, Close, ReadBytes, WriteBytes;
FROM Str        IMPORT Compare;

CONST BufferSize = 512;
      ID = "GEd00";    (* "00" fr evtl. sptere Dateiformate *)

VAR f      : File;
    actual : LONGINT;

(*--------------------------------------------------------------------------*)

PROCEDURE Load (    name   : ARRAY OF CHAR;
                VAR Feld   : ARRAY OF BYTE;
                VAR WFeld  : ARRAY OF BYTE;
                VAR length : LONGINT) : Response;
(* Einladen der Gadgetinformation in ein Feld *)

VAR ReadID : ARRAY [1..SIZE(ID)] OF CHAR;
    len    : LONGINT;

BEGIN

 (* ffnen *)
 Lookup (f,name,BufferSize,FALSE);

 IF (f.res # done) THEN Close(f); RETURN f.res END;

 (* Lesen *)
 ReadBytes (f,ADR(ReadID),SIZE(ID),actual);
 IF (Compare(ID,ReadID) # 0) THEN Close (f); RETURN notdone END;

 ReadBytes (f,ADR(len),SIZE(len),actual);          (* Lnge *)
 ReadBytes (f,ADR(WFeld),len,actual);              (* Window *)
 ReadBytes (f,ADR(length),SIZE(length),actual);    (* Lnge *)
 ReadBytes (f,ADR(Feld),length,actual);            (* Gadgets *)

 IF (f.res # done) THEN Close (f); RETURN f.res END;

 (* Schlieen *)
 Close (f);
 RETURN f.res;

END Load;

(*--------------------------------------------------------------------------*)

PROCEDURE Save (name   : ARRAY OF CHAR;
                adr1   : ADDRESS;
                len1   : LONGINT;
                adr2   : ADDRESS;
                len2   : LONGINT) : Response;
(* Speichern der Gadgetinformationen *)

BEGIN

 (* ffnen *)
 Lookup (f,name,BufferSize,TRUE);

 IF (f.res # done) THEN Close(f); RETURN f.res END;

 (* Schreiben *)
 WriteBytes (f,ADR(ID),SIZE(ID),actual);           (* Kennung *)
 WriteBytes (f,ADR(len1),SIZE(len1),actual);       (* Lnge *)
 WriteBytes (f,adr1,len1,actual);                  (* FensterInfo *)
 WriteBytes (f,ADR(len2),SIZE(len2),actual);       (* Lnge *)
 WriteBytes (f,adr2,len2,actual);                  (* Inhalt *)

 IF (f.res # done) THEN Close(f); RETURN f.res END;

 (* Schlieen *)
 Close (f);
 RETURN f.res;

END Save;

(*--------------------------------------------------------------------------*)

END Io.
