(*---------------------------------------------------------------------------
  :Program.    OnLine
  :Author.     Thomas Stolze
  :Address.    Goslarsche Str. 32, 3000 Hannover 21, Germany
  :Phone.      (0)511 / 75 10 77
  :Version.    V1.0
  :Date.       29-Sep-90
  :Copyright.  PD
  :Language.   Modula-2
  :Translator. M2Amiga V3.32d
  :Imports.    FileRequester
  :Contents.   Print Utility.
---------------------------------------------------------------------------*)
(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE Requester;

FROM Arts             IMPORT AllLevelTermProc,Assert;
FROM Exec             IMPORT GetMsg,ReplyMsg,WaitPort;
FROM Graphics         IMPORT jam1,jam2,SetRast;
FROM Intuition        IMPORT ActivateGadget,ActivationFlags,ActivationFlagSet,
                             AddGadget,AddGList,boolGadget,Border,BorderPtr,
                             CloseWindow,Gadget,GadgetFlags,GadgetFlagSet,
                             GadgetPtr,IDCMPFlags,IDCMPFlagSet,IntuiMessagePtr,
                             IntuiText,IntuiTextPtr,NewWindow,OpenWindow,
                             PrintIText,RefreshGadgets,ScreenFlags,
                             ScreenFlagSet,strGadget,StringInfo,WindowFlags,
                             WindowFlagSet,WindowPtr;
FROM IntuitionSupport IMPORT SetBorder,SetBorderKoord,SetGadget,SetInfo,
                             SetIText,SetWindow;
FROM Routines         IMPORT Frame,prtInfo;
FROM Str              IMPORT Copy,Length;
FROM SYSTEM           IMPORT ADDRESS,ADR;

VAR Gadgets     : ARRAY [0..5] OF Gadget;
    GadgetText  : ARRAY [0..5] OF IntuiText;
    BorderGadg  : ARRAY [0..3] OF Border;
    BorderCoord : ARRAY [0..3],[0..9] OF INTEGER;
    wind        : WindowPtr;

PROCEDURE ShowRequest(titleptr    : ADDRESS;
                      x,y,w,h,
                      border      : INTEGER;
                      textptr     : IntuiTextPtr;
                      gadgptr     : GadgetPtr;
                      cancel      : BOOLEAN): BOOLEAN;

CONST action = ActivationFlagSet{gadgImmediate,relVerify};

VAR wd         : NewWindow;
    Selection  : GadgetPtr;
    ptr        : IntuiTextPtr;
    msg        : IntuiMessagePtr;
    response   : BOOLEAN;
    code       : CARDINAL;
    class      : IDCMPFlagSet;
    pos        : INTEGER;
    bordptr    : BorderPtr;

BEGIN
  ptr:=SetIText(GadgetText[0],ADR("  OK"),2,1,1,2,jam2);
  ptr:=SetIText(GadgetText[1],ADR("CANCEL"),2,1,1,2,jam2);

  SetWindow(wd,x,y,w,h,1,1,IDCMPFlagSet{gadgetDown},
            WindowFlagSet{activate,windowActive,borderless,windowRefresh},
            NIL,NIL,NIL,-1,-1,20,40,ScreenFlagSet{wbenchScreen});

  SetGadget(Gadgets[0],20,-18,58,10,GadgetFlagSet{gRelBottom},
            action,boolGadget,ADR(BorderGadg[0]),ADR(GadgetText[0]),NIL,0);
  SetGadget(Gadgets[1],w-78,-18,58,10,GadgetFlagSet{gRelBottom},
            action,boolGadget,ADR(BorderGadg[0]),ADR(GadgetText[1]),NIL,1);
  bordptr:=SetBorder(BorderGadg[0],-1,-1,2,0,5,jam1,ADR(BorderCoord[0]));
  SetBorderKoord(BorderCoord[0],Gadgets[0]);

  wind:=OpenWindow(wd);
    Assert(wind # NIL,ADR("Couldn't open Requester"));

  SetRast(wind^.rPort,1); Frame(wind^.rPort,border,0,0,w-1,h-1,2);
  PrintIText(wind^.rPort,textptr,0,0);

  IF cancel THEN pos:=AddGadget(wind,ADR(Gadgets[1]),-1)
            ELSE Gadgets[0].leftEdge:=w-70 END;

  pos:=AddGadget(wind,ADR(Gadgets[0]),-1);
    IF (gadgptr # NIL) THEN pos:=AddGList(wind,gadgptr,-1,11,NIL) END;
  RefreshGadgets(wind^.firstGadget,wind,NIL);

  IF (gadgptr # NIL) THEN
      IF Gadgets[2].gadgetType = strGadget THEN
         response:=ActivateGadget(ADR(Gadgets[2]),wind,NIL);
      END;
  END;

    LOOP
      response:=FALSE;
      WaitPort(wind^.userPort);
        msg:=GetMsg(wind^.userPort);
        class:=msg^.class;
        Selection:=msg^.iAddress;
      ReplyMsg(msg);

      IF (gadgetDown IN class) THEN
         CASE Selection^.gadgetID OF
           0 : response:=TRUE;  EXIT;
         | 1 : response:=FALSE; EXIT;
         ELSE
         END;
      END;
    END;
    CloseWindow(wind); wind:=NIL;
    RETURN response;
END ShowRequest;

PROCEDURE OptionRequester(): BOOLEAN;
VAR IText   : ARRAY [0..2] OF IntuiText;
    ptr     : IntuiTextPtr;
    bordptr : BorderPtr;
    info    : ARRAY [0..2] OF StringInfo;
    String  : ARRAY [0..3],[0..25] OF CHAR;
    month   : ARRAY [0..1],[0..100] OF CHAR;
    bool    : BOOLEAN;
BEGIN
  ptr:=SetIText(IText[0],ADR("Date and Time Option:"),2,1,30,12,jam2);
  IText[0].nextText:=SetIText(IText[1],ADR("Date:"),2,1,30,27,jam2);
  IText[1].nextText:=SetIText(IText[2],ADR("Time:"),2,1,30,40,jam2);

  bordptr:=SetBorder(BorderGadg[1],-1,-1,3,0,5,jam2,ADR(BorderCoord[1]));
  bordptr:=SetBorder(BorderGadg[2],-1,-1,3,0,5,jam2,ADR(BorderCoord[2]));

  Copy(String[0],prtInfo.pI.dateFormat); Copy(String[2],prtInfo.pI.timeFormat);
  Copy(month[0],prtInfo.pI.monthName);
  SetInfo(info[0],ADR(String[0]),ADR(String[1]),Length(String[0]),24,0);
  SetInfo(info[1],ADR(String[2]),ADR(String[3]),Length(String[2]),24,0);
  SetInfo(info[2],ADR(month[0]),ADR(month[1]),Length(month[0]),99,0);

  SetGadget(Gadgets[2],80,27,112,8,GadgetFlagSet{},
            ActivationFlagSet{relVerify,gadgImmediate,toggleSelect},
            strGadget,ADR(BorderGadg[1]),NIL,ADR(info[0]),2);
  SetGadget(Gadgets[3],80,40,112,8,GadgetFlagSet{},
            ActivationFlagSet{relVerify,gadgImmediate,toggleSelect},
            strGadget,ADR(BorderGadg[1]),NIL,ADR(info[1]),3);
  SetGadget(Gadgets[4],30,53,240,8,GadgetFlagSet{},
            ActivationFlagSet{relVerify,gadgImmediate,toggleSelect},
            strGadget,bordptr,NIL,ADR(info[2]),4);

  SetBorderKoord(BorderCoord[1],Gadgets[2]);
  SetBorderKoord(BorderCoord[2],Gadgets[4]);
  Gadgets[2].nextGadget:=ADR(Gadgets[3]);
  Gadgets[3].nextGadget:=ADR(Gadgets[4]);

  bool:=ShowRequest(NIL,160,70,320,85,3,ptr,ADR(Gadgets[2]),TRUE);

  IF bool THEN
     Copy(prtInfo.pI.dateFormat,String[0]);
     Copy(prtInfo.pI.timeFormat,String[2]);
     Copy(prtInfo.pI.monthName,month[0]);
  END;
  RETURN bool;

END OptionRequester;

PROCEDURE Cleanup;
BEGIN
  IF (wind # NIL) THEN CloseWindow(wind) END;
END Cleanup;

BEGIN
  AllLevelTermProc(ADR(Cleanup));
END Requester.
