(*---------------------------------------------------------------------------
    :Program.    OnLine
    :Author.     Thomas Stolze,
    :Address.    Goslarsche Str. 32, 3000 Hannover 21, Germany
    :Version.    1.0
    :Date.       30-Sep-90
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga V3.32d
    :Contents.   Print Utility.
---------------------------------------------------------------------------*)
(* $R- *) (* $V- *) (* $S- *) (* $N- *) (* $F- *)
IMPLEMENTATION MODULE Routines;

IMPORT FileSystem;

FROM Arts       IMPORT BreakPoint;
FROM Arguments  IMPORT GetArg,NumArgs;
FROM Graphics   IMPORT Draw,DrawModeSet,jam2,Move,RastPortPtr,RectFill,SetAPen,
                       SetBPen,SetDrMd,Text;
FROM Intuition  IMPORT GadgetPtr,RefreshGList;
FROM Storage    IMPORT ALLOCATE,Available;
FROM Str        IMPORT Concat,Copy,FirstPos,Length;
FROM SYSTEM     IMPORT ADR;

(*FROM InOut IMPORT WriteString,WriteLn,WriteInt;*)

CONST parFileName = "S:OnLine.cfg";

PROCEDURE Print(text      : ARRAY OF CHAR;
                rport     : RastPortPtr;
                fPen,bPen : INTEGER;
                drawM     : DrawModeSet;
                xpos,ypos : INTEGER);

VAR print : ARRAY [0..80] OF CHAR;
BEGIN
  SetAPen(rport,fPen); SetBPen(rport,bPen); SetDrMd(rport,drawM); print:=("");
  Move(rport,xpos,ypos); Copy(print,text); print[Length(text)]:=00C;
  Text(rport,ADR(print),Length(print));
END Print;

PROCEDURE Frame(rport : RastPortPtr; col,x1,y1,x2,y2,width : INTEGER);
VAR i,j : INTEGER;
BEGIN
  SetAPen(rport,col); SetDrMd(rport,jam2);
  FOR i:=0 TO width-1 DO
    j:=i*2;
    Move(rport,x1+j,y1+i);     Draw(rport,x1+j,y2-i);
    Move(rport,x1+1+j,y1+i);   Draw(rport,x1+1+j,y2-i);
    Draw(rport,x2-j,y2-i);     Draw(rport,x2-j,y1+i);
    Move(rport,x2-1-j,y2-1-i); Draw(rport,x2-1-j,y1+i);
    Draw(rport,x1+j,y1+i);
  END;
END Frame;

PROCEDURE Block(rport : RastPortPtr; col,x1,y1,x2,y2 : INTEGER;
                mode  : DrawModeSet);
BEGIN
  SetAPen(rport,col); SetDrMd(rport,mode); RectFill(rport,x1,y1,x2,y2);
END Block;

PROCEDURE PrintPath(refreshPtr : GadgetPtr);
VAR i : INTEGER;
BEGIN
  Copy(prtInfo.pI.strPath,prtInfo.pI.dirName);
  IF Length(prtInfo.pI.strPath) > 0 THEN
     CASE prtInfo.pI.strPath[Length(prtInfo.pI.strPath)-1] OF
          ":": ELSE Concat(prtInfo.pI.strPath,"/")
     END;
  END;
  Concat(prtInfo.pI.strPath,prtInfo.pI.fileName);
  RefreshGList(refreshPtr,window,NIL,1);
END PrintPath;

PROCEDURE GetArguments;
VAR args,
    arglen,
    i,j      : INTEGER;
    argument : ARRAY [0..80] OF CHAR;
    set      : PrintModeSet;

    PROCEDURE GetFile;
    VAR pos,i : INTEGER;
    BEGIN
      pos:=FirstPos(argument,0,":");
      IF pos >= 0 THEN
        FOR i:=0 TO pos DO prtInfo.pI.dirName[i]:=argument[i] END;
        FOR i:=pos+1 TO arglen DO prtInfo.pI.fileName[i-pos-1]:=argument[i] END;
        prtInfo.pI.dirName[pos+1]:=00C; prtInfo.pI.fileName[i-pos]:=00C;
      ELSE
        Copy(prtInfo.pI.fileName,argument);
      END;
    END GetFile;

    PROCEDURE GetOptions;
    BEGIN
      REPEAT
        INC(j);
        CASE argument[j] OF
          "n": INCL(set,nlq);
        | "f": INCL(set,format);
        | "q": INCL(set,queue);
        | "d": INCL(set,date);
        | "t": INCL(set,time);
        | "p": INCL(set,page);
        ELSE
        END;
      UNTIL j >= arglen;
    END GetOptions;
BEGIN
  args:=NumArgs(); i:=1; set:=PrintModeSet{};
  IF args > 0 THEN
     REPEAT
       GetArg(i,argument,arglen); j:=0;
         WHILE argument[j] = " " DO INC(j) END;
         IF argument[j] = "-" THEN
            GetOptions; prtInfo.pI.printMode:=set;
         ELSE
            GetFile;
         END;
       INC(i);
     UNTIL i = args+1;
  END;
END GetArguments;

PROCEDURE LoadOpt;
VAR file   : FileSystem.File;
    actual : LONGINT;
BEGIN
  FileSystem.Lookup(file,parFileName,512,FALSE);
  IF (file.res = FileSystem.done) THEN
     FileSystem.ReadBytes(file,ADR(prtInfo.pI),tagLength,actual);
     FileSystem.Close(file);
  END;
END LoadOpt;

PROCEDURE SaveOpt;
VAR file   : FileSystem.File;
    actual : LONGINT;
BEGIN
  FileSystem.Lookup(file,parFileName,512,TRUE);
  IF (file.res = FileSystem.done) THEN
     FileSystem.WriteBytes(file,ADR(prtInfo.pI),tagLength,actual);
     FileSystem.Close(file);
  END;
END SaveOpt;

PROCEDURE QueuePrintOrder(prt : Queued);
VAR ptr : QueuedPtr;
BEGIN
  IF Available(SIZE(Queued)) THEN
     ALLOCATE(ptr,SIZE(Queued));
      ptr^:=prt;  ptr^.lastQueued:=actualQPtr; ptr^.nextQueued:=NIL;
      actualQPtr^.nextQueued:=ptr; actualQPtr:=ptr;
      INC(queuedFiles);
  ELSE
     BreakPoint(ADR("Out of Memory"));
  END;
END QueuePrintOrder;

BEGIN
  WITH prtInfo.pI DO
    dirName:=(""); printMode:=PrintModeSet{}; strPath:=("");
    dateFormat:=("%d.%t.%Y"); timeFormat:=("Zeit: %H:%M:%S");
  END;
  prtInfoPtr:=ADR(prtInfo); actualQPtr:=prtInfoPtr; queuedFiles:=0;
END Routines.
