(*---------------------------------------------------------------------------
    Programm     Sieb.mod
    Autor        Ralph Schr
                 Juchen 8
                 CH-2577 Siselen
    Version      1.2
    Copyright    Public Domain
    Datum        30.03.1991
    Sprache      Oberon
    Compiler     Amiga Oberon Compiler V1.17.1
    Zweck        Primzahlen ausgeben
    Aufruf       CLI : Sieb <von> <bis>
---------------------------------------------------------------------------*)
MODULE Sieb;

IMPORT io,
       mt: MathTrans,
       arg: Arguments,
       con: Conversions,
       I: Intuition,
       ob: OberonLib,
       d: Dos,
       ASCII,
       Break;

CONST bufLen = 80;

VAR  winptr      : I.WindowPtr;
     flags       : POINTER TO BOOLEAN;
     i,j,k       : LONGINT;
     wurzel,z,y  : LONGINT;
     startadr    : LONGINT;
     argu        : ARRAY 2 OF ARRAY 10 OF CHAR;
     e1,e2       : BOOLEAN;
     size        : LONGINT;
     zeile,max   : INTEGER;
     len         : INTEGER;
     von,bis,h   : LONGINT;
     teil,index  : LONGINT;
     start       : LONGINT;
     spez        : BOOLEAN;
     out         : d.FileHandlePtr;
     buffer      : ARRAY bufLen OF CHAR;
     bufIndex    : INTEGER;

(*-------------------------------------------------------------------------*)

PROCEDURE WriteBuffer;
VAR len : LONGINT;
BEGIN
  IF bufIndex > 0 THEN
    len := d.Write(out,buffer,bufIndex);
    bufIndex := 0;
  END;
END WriteBuffer;

(*-------------------------------------------------------------------------*)

PROCEDURE Write(ch: CHAR);
BEGIN
  IF ch # ASCII.nul THEN
    buffer[bufIndex] := ch;
    INC(bufIndex);
  END;
  IF (ch = ASCII.lf) OR (ch = ASCII.nul) OR (bufIndex = bufLen) THEN
    WriteBuffer;
  END;
END Write;

(*-------------------------------------------------------------------------*)

PROCEDURE WriteLn;
BEGIN
  Write(ASCII.lf);
END WriteLn;

(*-------------------------------------------------------------------------*)

PROCEDURE WriteInt(x,n: LONGINT);
VAR i : INTEGER;
    buf: ARRAY 10 OF LONGINT;
BEGIN
  i := 0;
  REPEAT
    buf[i] := x MOD 10;
    x := x DIV 10;
    INC(i);
  UNTIL x = 0;
  WHILE n > i DO
    Write(" ");
    DEC(n);
  END;
  REPEAT
    DEC(i);
    Write(CHR(buf[i]+ORD("0")))
  UNTIL i = 0;
END WriteInt;

(*-------------------------------------------------------------------------*)

PROCEDURE Help;
BEGIN
  io.WriteString("Aufruf :  Sieb <von> <bis>\n");
  io.WriteString("Alle Primzahlen <von> <bis> werden ausgegeben\n\n");
  HALT(0);
END Help;

(*-------------------------------------------------------------------------*)

BEGIN (* Sieb *)

  bufIndex := 0;
  out := d.Output();
  winptr := I.int^.activeWindow;

  IF arg.NumArgs() = 2 THEN
    arg.GetArg(1,argu[0]);
    arg.GetArg(2,argu[1]);
    len := io.Length(argu[1]);
    e1 := con.StringToInt(argu[0],von);
    e2 := con.StringToInt(argu[1],bis);
    IF (e1 = FALSE) OR (e2 = FALSE) THEN
      io.WriteString("Fehler beim Umwandeln\n\n"); HALT(20)
    END;
  ELSE
    Help;
  END;

  IF bis < von THEN h := bis; bis := von; von := h; END;

  spez := FALSE;
  IF von < 3 THEN von := 3; spez := TRUE; END;

  size := ((bis-von) DIV 2) + 1;
  ob.New(startadr,size);
  IF startadr = NIL THEN
    io.WriteString(" Zuwenig Speicher\n\n"); HALT(20);
  END;

  IF ODD(von) THEN DEC(von); END;

  start := von;
  IF NOT(ODD(von)) THEN INC(start); END;
  wurzel := ENTIER(mt.Sqrt(bis)) + 1;

  (* Alle Felder initialisieren *)
  j := 0;
  WHILE j <= size-1 DO
    flags  := startadr+j;
    flags^ := TRUE;
    INC(j);
  END;

  (* Berechnung der Primzahlen *)
  i := 3;
  WHILE i <= wurzel DO (* by 2 *)
    teil := (von DIV i) + 1; IF teil = 1 THEN teil := 2; END;
    index := teil * i;
    IF NOT(ODD(index)) THEN index := index + i; END;
    flags := startadr+((index - von) DIV 2);
    WHILE index <= bis DO
      flags  := startadr+((index - von) DIV 2);
      flags^ := FALSE;
      INC(index,i*2);
    END;
    INC(i,2);
  END;

  (* Ausgabe der Primzahlen *)
  zeile := 0;
  IF spez THEN
    INC(zeile); WriteInt(2,len+2);
  END;
  max := (winptr^.width DIV winptr^.iFont^.xSize - 3) DIV (len+2);

  i := start;
  WHILE i <= bis DO (* by 2 *)
    flags := startadr+((i-von) DIV 2);
    IF flags^ THEN
      INC(zeile); WriteInt(i,len+2);
      IF zeile = max THEN WriteLn; zeile := 0; END;
    END;
    INC(i,2);
  END;
  WriteLn;

CLOSE

  IF startadr # NIL THEN DISPOSE(startadr); END;

END Sieb.

