(*---------------------------------------------------------------------------
  :Program.    FileRequester
  :Author.     Thomas Stolze
  :Address.    Goslarsche Str. 32, 3000 Hannover 21, Germany
  :Phone.      (0)511 / 75 10 77
  :Version.    V1.2
  :Date.       16-Nov-90
  :Copyright.  PD
  :Language.   Modula-2
  :Translator. M2Amiga V4.0d
  :Contents.   FileRequester Utility.
  :LastChange. 01-Jun-91
---------------------------------------------------------------------------*)
(*$LargeVars:=FALSE*)
IMPLEMENTATION MODULE FileRequester;

IMPORT DosD;
IMPORT DosL;
IMPORT ExecD;
IMPORT IntuitionD;

FROM Arts             IMPORT Assert,BreakPoint;
FROM Conversions      IMPORT ValToStr;
FROM DateConversions  IMPORT DateInfo,DateToStr,FromDos,month3;
FROM DosD             IMPORT accessRead,DeviceListPtr,DosLibraryPtr,
                             FileInfoBlock,FileInfoBlockPtr,ProcessPtr,
                             FileLockPtr,ProtectionFlags,ProtectionFlagSet;
FROM DosL             IMPORT Delay,Examine,ExNext,Lock,UnLock;
FROM ExecL            IMPORT CopyMem,GetMsg,ReplyMsg,WaitPort,FindTask;
FROM GraphicsD        IMPORT DrawModeSet,jam2,RastPortPtr;
FROM GraphicsL        IMPORT Draw,Move,RectFill,
                             ScrollRaster,SetAPen,SetBPen,SetDrMd,Text,WaitTOF;
FROM Images           IMPORT ArrowDown,ArrowUp;
FROM IntuitionD       IMPORT ActivationFlags,ActivationFlagSet,
                             boolGadget,BorderPtr,cursorDown,
                             cursorLeft,cursorRight,cursorUp,customScreen,
                             GadgetFlags,GadgetFlagSet,GadgetPtr,IDCMPFlags,
                             IDCMPFlagSet,IntuiMessage,IntuiMessagePtr,
                             IntuiTextPtr,maxBody,maxPot,
                             NewWindow,propGadget,PropInfoFlagSet,
                             ScreenFlags,ScreenFlagSet,selectDown,strGadget,
                             WindowFlags,WindowFlagSet,WindowPtr;
FROM IntuitionL       IMPORT AddGList,CloseWindow,ModifyIDCMP,
                             NewModifyProp,OpenWindow,RefreshGList;
FROM IntuitionSupport IMPORT SetBorder,SetBorderKoord,SetGadget,SetImage,
                             SetInfo,SetIText,SetPropInfo,SetWindow;
FROM Storage          IMPORT ALLOCATE,Available,DEALLOCATE;
FROM String           IMPORT CapString,Compare,Concat,Copy,LastPos,Length,Occurs;
FROM SYSTEM           IMPORT ADDRESS,ADR,CAST;

(*FROM InOut IMPORT WriteString,WriteLn;*)

CONST return1     = 43H;
      return2     = 44H;
      o           = 18H;
      d           = 22H;
      p           = 19H;
      c           = 33H;

TYPE  ProtocollPtr = POINTER TO Protocoll;
      Protocoll    = RECORD
                       next : ProtocollPtr;
                       req  : FileRequestPtr;
                     END;

VAR Prot      : Protocoll;
    nextProt,
    TermPtr   : ProtocollPtr;
    bonus     : CARDINAL;

PROCEDURE Print(text      : ARRAY OF CHAR;
                rport     : RastPortPtr;
                fPen,bPen : INTEGER;
                drawM     : DrawModeSet;
                xpos,ypos : INTEGER);
BEGIN
  SetAPen(rport,fPen); SetBPen(rport,bPen); SetDrMd(rport,drawM);
  Move(rport,xpos,ypos); Text(rport,ADR(text),Length(text));
END Print;

PROCEDURE Frame(rport : RastPortPtr; col,x1,y1,x2,y2,width : INTEGER);
VAR i,j : INTEGER;
BEGIN
  SetAPen(rport,col); SetDrMd(rport,jam2);
  FOR i:=0 TO width-1 DO
    j:=i*2;
    Move(rport,x1+j,y1+i);     Draw(rport,x1+j,y2-i);
    Move(rport,x1+1+j,y1+i);   Draw(rport,x1+1+j,y2-i);
    Draw(rport,x2-j,y2-i);     Draw(rport,x2-j,y1+i);
    Move(rport,x2-1-j,y2-1-i); Draw(rport,x2-1-j,y1+i);
    Draw(rport,x1+j,y1+i);
  END;
END Frame;

PROCEDURE Block(rport : RastPortPtr; col,x1,y1,x2,y2 : INTEGER);
BEGIN
  SetAPen(rport,col); SetDrMd(rport,jam2); RectFill(rport,x1,y1,x2,y2);
END Block;

PROCEDURE MakeDrawings(fr : FileRequestPtr);
BEGIN
  WITH fr^.datas^ DO
    Frame(wind^.rPort,3,xpos+10,ypos+13,xpos+((fr^.displayColumns+1)*8)+23,
                        ypos+((fr^.displayRows+1)*8)+18,2);
    Print(("Dir:"),wind^.rPort,1,0,jam2,xpos+10,
                        ypos+((fr^.displayRows+1)*8)+30);
    Print(("File:"),wind^.rPort,1,0,jam2,xpos+10,
                        ypos+((fr^.displayRows+1)*8)+41);
    IF pattern IN fr^.FRFlags THEN
       Print(("Pattern:"),wind^.rPort,1,0,jam2,xpos+10,
                          ypos+((fr^.displayRows+1)*8)+52);
    END;
  END;
END MakeDrawings;

PROCEDURE InitIntuition(fr : FileRequestPtr);
VAR nw   : NewWindow;
    res  : LONGINT;
    pat  : INTEGER;
    taskPtr    : ExecD.TaskPtr;
    processPtr : ProcessPtr;

  PROCEDURE InitIText;
  VAR ptr : IntuiTextPtr;
  BEGIN
    ptr:=SetIText(fr^.datas^.TextArray[0],ADR("   OK  "),1,0,0,2,jam2);
    ptr:=SetIText(fr^.datas^.TextArray[1],ADR(" Drives"),1,0,0,2,jam2);
    ptr:=SetIText(fr^.datas^.TextArray[2],ADR(" Parent"),1,0,0,2,jam2);
    ptr:=SetIText(fr^.datas^.TextArray[3],ADR(" CANCEL"),1,0,0,2,jam2);
  END InitIText;

  PROCEDURE InitInfo;
  BEGIN
    WITH fr^.datas^ DO
      SetInfo(InfoArray[0],ADR(fr^.dirPath),ADR(dirArray[0]),0,254,0);
      SetInfo(InfoArray[1],ADR(fr^.file),ADR(fileArray[1]),0, 30,0);
      SetInfo(InfoArray[2],ADR(fr^.patternStr),ADR(fileArray[0]),0,30,0);
    END;
  END InitInfo;

  PROCEDURE InitGadgets;
    PROCEDURE CalcPos(): INTEGER;
    BEGIN
      RETURN (((fr^.displayColumns+8)*8) - (4*64)) DIV 5;
    END CalcPos;
  BEGIN
    WITH fr^.datas^ DO
      SetPropInfo(propInfo,PropInfoFlagSet{IntuitionD.autoKnob,
                  IntuitionD.freeVert,IntuitionD.knobHit},0,0,0,maxBody);
      SetImage(ImageArray[1],-2,-1,16,10,1,ADR(ArrowUp)  ,1,0);
      SetImage(ImageArray[2],-2,-1,16,10,1,ADR(ArrowDown),1,0);

      SetGadget(GadgetArray[0],xpos+((fr^.displayColumns+1)*8)+30,
                ypos+24,16,(fr^.displayRows-1)*8,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify},propGadget,
                ADR(ImageArray[0]),NIL,ADR(propInfo),firstGadgetID+extra);
      SetGadget(GadgetArray[1],xpos+((fr^.displayColumns+1)*8)+32,
                ypos+14,12,8,GadgetFlagSet{gadgImage},
                ActivationFlagSet{gadgImmediate,relVerify},boolGadget,
                ADR(ImageArray[1]),NIL,NIL,firstGadgetID+extra+1);
      SetGadget(GadgetArray[2],xpos+((fr^.displayColumns+1)*8)+32,
                ypos+((fr^.displayRows+1)*8)+10,12,8,GadgetFlagSet{gadgImage},
                ActivationFlagSet{gadgImmediate,relVerify},boolGadget,
                ADR(ImageArray[2]),NIL,NIL,firstGadgetID+extra+2);

      SetGadget(GadgetArray[3],xpos+63,ypos+((fr^.displayRows+1)*8)+23,
                ((fr^.displayColumns-1)*8),8,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify,toggleSelect},
                strGadget,ADR(GadgetBorder[1]),NIL,ADR(InfoArray[0]),
                firstGadgetID+extra+3);
      SetGadget(GadgetArray[4],xpos+63,ypos+((fr^.displayRows+1)*8)+34,
                (27*8),8,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify,toggleSelect},
                strGadget,ADR(GadgetBorder[1]),NIL,ADR(InfoArray[1]),
                firstGadgetID+extra+4);
      SetGadget(GadgetArray[5],xpos+CalcPos(),
                ypos+((fr^.displayRows+1)*8)+47+pat,64,10,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify},
                boolGadget,ADR(GadgetBorder[0]),ADR(TextArray[0]),NIL,
                firstGadgetID+extra+5);
      SetGadget(GadgetArray[6],xpos+CalcPos()*2+64,
                ypos+((fr^.displayRows+1)*8)+47+pat,64,
                10,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify},
                boolGadget,ADR(GadgetBorder[0]),ADR(TextArray[1]),NIL,
                firstGadgetID+extra+6);
      SetGadget(GadgetArray[7],xpos+CalcPos()*3+128,
                ypos+((fr^.displayRows+1)*8)+47+pat,64,10,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify},
                boolGadget,ADR(GadgetBorder[0]),ADR(TextArray[2]),NIL,
                firstGadgetID+extra+7);
      SetGadget(GadgetArray[8],xpos+CalcPos()*4+192,
                ypos+((fr^.displayRows+1)*8)+47+pat,64,10,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify},
                boolGadget,ADR(GadgetBorder[0]),ADR(TextArray[3]),NIL,
                firstGadgetID+extra+8);
      SetGadget(GadgetArray[9],xpos+87,ypos+((fr^.displayRows)*8)+42+pat,
                ((fr^.displayColumns-4)*8),8,GadgetFlagSet{},
                ActivationFlagSet{gadgImmediate,relVerify,toggleSelect},
                strGadget,ADR(GadgetBorder[2]),NIL,ADR(InfoArray[2]),
                firstGadgetID+extra+9);

    END;
  END InitGadgets;

  PROCEDURE InitBorderCoor;
  BEGIN
    WITH fr^.datas^ DO
      SetBorderKoord(BorderArray[0],GadgetArray[5]);
      SetBorderKoord(BorderArray[1],GadgetArray[3]);
      SetBorderKoord(BorderArray[2],GadgetArray[9]);
      GadgetArray[9].width:=24*8;
    END;
  END InitBorderCoor;

  PROCEDURE InitBorder;
  VAR ptr : BorderPtr;
  BEGIN
    WITH fr^.datas^ DO
      ptr:=SetBorder(GadgetBorder[0],-1,-1,1,0,5,jam2,ADR(BorderArray[0]));
      ptr:=SetBorder(GadgetBorder[1],-1,-1,1,0,5,jam2,ADR(BorderArray[1]));
      ptr:=SetBorder(GadgetBorder[2],-1,-1,1,0,5,jam2,ADR(BorderArray[2]));
    END;
  END InitBorder;

  PROCEDURE InitAll;
  VAR i : INTEGER;
  BEGIN
    WITH fr^.datas^ DO
      IF (noWindow IN fr^.FRFlags) THEN
         xpos:=fr^.x; ypos:=fr^.y;
      ELSE
         xpos:=0; ypos:=0;
      END;
      InitIText; InitGadgets; InitBorderCoor; InitBorder; InitInfo;

      FOR i:=1 TO numOfGadgets DO
          GadgetArray[i-1].nextGadget:=ADR(GadgetArray[i]);
      END;
    END;
  END InitAll;

BEGIN
  pat:=0; IF (pattern IN fr^.FRFlags) THEN pat:=11 END; InitAll;
  WITH fr^.datas^ DO
    Copy(dirArray[1],fr^.dirPath); Copy(fileArray[1],fr^.file);

    IF noWindow IN fr^.FRFlags THEN
       Assert(NIL # fr^.FRWindow,ADR("WindowPtr is NIL!"));
       fr^.datas^.wind:=fr^.FRWindow;
       ModifyIDCMP(wind,fr^.FRWindow^.idcmpFlags+
             IDCMPFlagSet{closeWindow,gadgetDown,gadgetUp,mouseButtons,rawKey});
    ELSE
       SetWindow(nw,fr^.x,fr^.y,((fr^.displayColumns+8)*8)-2,
            ((fr^.displayRows+1)*8)+62+pat,0,1,IDCMPFlagSet{},
            WindowFlagSet{windowDrag,windowDepth,windowClose,activate,
                          windowRefresh,windowActive,reportMouse},
            fr^.head,NIL,fr^.userScreen,
            10,60,288,142,ScreenFlagSet{wbenchScreen});
            IF fr^.userScreen # NIL THEN nw.type:=customScreen END;

       IF (giveNewWindow IN fr^.FRFlags) THEN
       res:=fr^.func(ADR(nw),CAST(CARDINAL,FileRequestFlagSet{giveNewWindow}));
       END;

       fr^.datas^.wind:=OpenWindow(nw); fr^.FRWindow:=fr^.datas^.wind;
         Assert(fr^.datas^.wind # NIL,ADR("Couldn't open window!"));

      taskPtr:=FindTask(NIL);
      IF taskPtr^.node.type = ExecD.process THEN
         processPtr:=CAST(ProcessPtr,taskPtr);
         processPtr^.windowPtr:=fr^.datas^.wind;
      END;
    END;

    IF pattern IN fr^.FRFlags THEN
       res:=AddGList(wind,ADR(GadgetArray[0]),-1,numOfGadgets+1,NIL);
       RefreshGList(ADR(GadgetArray[0]),wind,NIL,numOfGadgets+1);
    ELSE
       res:=AddGList(wind,ADR(GadgetArray[0]),-1,numOfGadgets,NIL);
       RefreshGList(ADR(GadgetArray[0]),wind,NIL,numOfGadgets);
    END;

    IF (sharedIDCMP IN fr^.FRFlags) THEN
       wind^.userPort:=fr^.userWindow^.userPort;
    END;
    ModifyIDCMP(fr^.datas^.wind,fr^.datas^.wind^.idcmpFlags+
          IDCMPFlagSet{closeWindow,gadgetDown,gadgetUp,mouseButtons,rawKey});
    MakeDrawings(fr);
  END;
END InitIntuition;

PROCEDURE OldValues(fr : FileRequestPtr);
BEGIN
  WITH fr^.datas^ DO
    Copy(fr^.file,fileArray[1]);
    IF (noWindow IN fr^.FRFlags) THEN
       RefreshGList(ADR(GadgetArray[4]),wind,NIL,1);
    ELSE
       Copy(fr^.dirPath,dirArray[1]);
    END;
  END;
END OldValues;

PROCEDURE AllocEntry(VAR entryPtr: DirNamePtr): BOOLEAN;
BEGIN
  IF Available(SIZE(DirName)) THEN
     ALLOCATE(entryPtr,SIZE(DirName));
     WITH entryPtr^ DO
       fileName := ("");
       type  := notdefined;
     END;
     RETURN TRUE;
  END;
  RETURN FALSE;
END AllocEntry;

PROCEDURE DeallocEntry(VAR entryPtr : DirNamePtr);
BEGIN
  DEALLOCATE(entryPtr,SIZE(DirName)); entryPtr:=NIL;
END DeallocEntry;

PROCEDURE DeallocEntryList(fr : FileRequestPtr);
VAR i : CARDINAL;
BEGIN
  WITH fr^.datas^ DO
   FOR i:=dirEntries TO 0 BY -1 DO DeallocEntry(DirArray[i]) END; dirEntries:=0;
  END;
END DeallocEntryList;

PROCEDURE Pattern(file,patternStr : ARRAY OF CHAR): BOOLEAN;
VAR i,j,k,len   : CARDINAL;
    exit,repeat : BOOLEAN;
BEGIN
  i:=0; j:=0; len:=Length(file);

  WHILE (j <= len) DO
    IF CAP(file[j]) # CAP(patternStr[i]) THEN
       CASE patternStr[i] OF
         "?" : INC(i); INC(j);
       | "#" : INC(i);
               IF CAP(patternStr[i]) = "?" THEN
                  INC(i); IF patternStr[i] = 00C THEN RETURN TRUE END;
                  LOOP
                    exit:=TRUE;
                    LOOP
                      FOR k:=j TO len DO
                        IF CAP(patternStr[i]) = CAP(file[k]) THEN
                           j:=k+1; EXIT;
                        ELSIF file[k] = 00C THEN
                           RETURN FALSE;
                        END;
                      END;
                      RETURN TRUE;
                    END;
                    FOR k:=j TO len DO
                      IF CAP(file[k]) = CAP(patternStr[i]) THEN exit:=FALSE END;
                    END;
                    IF exit THEN INC(i); EXIT END;
                  END;
               ELSE
                  WHILE CAP(patternStr[i]) = CAP(file[j]) DO INC(j) END; INC(i);
               END;
       ELSE
         RETURN FALSE;
       END;
    ELSE
       INC(i); INC(j);
    END;
  END;
  RETURN TRUE;
END Pattern;

PROCEDURE ReadDirectory(fr   : FileRequestPtr;
                       lock  : FileLockPtr;
                       infos : BOOLEAN): BOOLEAN;
VAR good,alloc  : BOOLEAN;
    fileInfoPtr : FileInfoBlockPtr;

  PROCEDURE CheckforInfo(ptr : FileInfoBlockPtr): BOOLEAN;
  VAR len : INTEGER;
  BEGIN
    IF infos THEN
       len:=Length(ptr^.fileName)-5; IF (len < 0) THEN len:= 0 END;
       IF (Occurs(ptr^.fileName,len,".info",FALSE) = -1) THEN
          RETURN TRUE;
       END;
       RETURN FALSE;
    END;
    RETURN TRUE;
  END CheckforInfo;

  PROCEDURE Alloc;
  BEGIN
    WITH fr^.datas^ DO
      IF AllocEntry(DirArray[dirEntries]) THEN
         WITH fileInfoPtr^ DO
           DirArray[dirEntries]^.date:=date;
           DirArray[dirEntries]^.protection:=protection;
           DirArray[dirEntries]^.fileLength:=size;
           IF (fileInfoPtr^.dirEntryType < 0) THEN
               DirArray[dirEntries]^.type := file;
           ELSIF (fileInfoPtr^.dirEntryType > 0) THEN
               DirArray[dirEntries]^.type := directory;
           END;
           Copy(DirArray[dirEntries]^.fileName,fileName);
           DirArray[dirEntries]^.selected:=FALSE;
         END;
      END;
      INC(dirEntries);
    END;
  END Alloc;

BEGIN
  WITH fr^.datas^ DO
    dirEntries:=0;
    IF Available(SIZE(FileInfoBlock)) THEN
       ALLOCATE(fileInfoPtr,SIZE(FileInfoBlock));
       IF Examine(lock,fileInfoPtr) THEN
          REPEAT
            IF CheckforInfo(fileInfoPtr) THEN
               IF (pattern IN fr^.FRFlags) THEN
                  IF fileInfoPtr^.dirEntryType < 0 THEN
                     IF Pattern(fileInfoPtr^.fileName,fr^.patternStr) THEN
                        Alloc;
                     END;
                  ELSE
                    Alloc;
                  END;
               ELSE
                  Alloc;
               END;
            END;
          UNTIL (ExNext(lock,fileInfoPtr) = FALSE) OR (dirEntries > maxMax);
          good := TRUE;
          IF dirEntries > 0 THEN DEC(dirEntries); END;
       ELSE
         good := FALSE;
       END;
       DEALLOCATE(fileInfoPtr,SIZE(FileInfoBlock));
       RETURN good;
    END;
    RETURN FALSE;
  END;
END ReadDirectory;

PROCEDURE QSort(fr : FileRequestPtr; begin : CARDINAL);
VAR i,j,count : CARDINAL;
    adr       : ADDRESS;
    typ       : FileTypes;

  PROCEDURE FirstHigher(low,high : ARRAY OF CHAR): BOOLEAN;
  VAR i : CARDINAL;
  BEGIN
    CapString(low); CapString(high);
    IF Compare(low,high) > 0 THEN
       RETURN TRUE;
    END;
    RETURN FALSE;
  END FirstHigher;

  PROCEDURE Sort(low,high : CARDINAL);
  VAR i,j : CARDINAL;
      x,w : DirNamePtr;
  BEGIN
   WITH fr^.datas^ DO
    i := low; j := high;
    x := DirArray[(low + high) DIV 2];
    REPEAT
      WHILE FirstHigher(x^.fileName,DirArray[i]^.fileName) DO INC(i) END;
      WHILE FirstHigher(DirArray[j]^.fileName,x^.fileName) DO DEC(j) END;
      IF (i <= j) THEN
        w := DirArray[i];
        DirArray[i] := DirArray[j];
        DirArray[j] := w;
        INC(i);
        DEC(j);
      END;
    UNTIL (i > j);
    IF (low < j)   THEN Sort(low,j) END;
    IF (i < high)  THEN Sort(i,high) END;
   END;
  END Sort;

BEGIN
  WITH fr^.datas^ DO
    count:=begin;
    IF (filesFirst IN fr^.FRFlags) THEN typ:=file ELSE typ:=directory END;
    FOR i:=begin TO dirEntries DO
      IF (DirArray[i]^.type = typ) OR (DirArray[i]^.type = device) THEN
         adr:=DirArray[count]; DirArray[count]:=DirArray[i]; DirArray[i]:=adr;
         INC(count);
      END;
    END;
    IF (count > begin) THEN Sort(begin,count-1) END;
    IF (count <= dirEntries) THEN
       IF (dirEntries-count > 0) THEN Sort(count,dirEntries) END;
    END;
  END;
END QSort;

PROCEDURE RemoveArtsMemo(fr : FileRequestPtr);
VAR ptr,memo : ProtocollPtr;
BEGIN
  ptr:=ADR(Prot);

   WHILE ptr # NIL DO
     IF (ptr^.next # NIL) AND (ptr^.next^.req = fr) THEN
        memo:=ptr^.next^.next;
           DEALLOCATE(ptr^.next,SIZE(Protocoll));
        ptr^.next:=memo;
     END;
     ptr:=ptr^.next;
   END;
END RemoveArtsMemo;

PROCEDURE CloseFileRequest(fileRequest : FileRequestPtr);
VAR msg : IntuiMessagePtr;
BEGIN
 IF fileRequest # NIL THEN
  IF fileRequest^.datas # NIL THEN
     WITH fileRequest^.datas^ DO
       DeallocEntryList(fileRequest);
       IF NOT (noWindow IN fileRequest^.FRFlags) THEN
          IF (wind # NIL) THEN
             REPEAT
              msg:=GetMsg(wind^.userPort); IF msg # NIL THEN ReplyMsg(msg); END;
             UNTIL msg = NIL;
             wind^.userPort:=NIL; ModifyIDCMP(wind,IDCMPFlagSet{});
             CloseWindow(wind); wind:=NIL; fileRequest^.FRWindow:=NIL;
          END;
       END;
       IF lockPtr # NIL THEN UnLock(lockPtr); lockPtr:=NIL; END;
       DEALLOCATE(fileRequest^.datas,SIZE(Request)); fileRequest^.datas:=NIL;
       RemoveArtsMemo(fileRequest);
     END;
  END;
 END;
END CloseFileRequest;

PROCEDURE PrintSingle(fr       : FileRequestPtr;
                      ptr      : DirNamePtr;
                      row      : INTEGER;
                      selected : BOOLEAN);
VAR i,len : INTEGER;
    print : ARRAY [0..81] OF CHAR;

    PROCEDURE DoPrint(c1,c2 : INTEGER);
    BEGIN
      WITH fr^.datas^ DO
        Print(print,wind^.rPort,c1,c2,jam2,17+xpos,21+row*8+1+ypos);
      END;
    END DoPrint;

    PROCEDURE ConcatLength;
    VAR err : BOOLEAN;
        str : ARRAY [0..9] OF CHAR;
    BEGIN
      IF (dosLength IN fr^.FRFlags) THEN
         IF ptr^.type = directory THEN
            Concat(print,"     Dir");
         ELSE
            IF ptr^.type = file THEN
               ValToStr(ptr^.fileLength,FALSE,str,10,8," ",err);
               Concat(print,str);
            END;
         END;
      END;
    END ConcatLength;

    PROCEDURE ConcatFlags;
    BEGIN
      IF (dosFlags IN fr^.FRFlags) THEN
         IF (ptr^.type = file) OR (ptr^.type = directory) THEN
            len:=Length(print); Concat(print," -------- ");
            IF NOT (delete    IN ptr^.protection) THEN print[len+8]:="d" END;
            IF NOT (execute   IN ptr^.protection) THEN print[len+7]:="e" END;
            IF NOT (writeProt IN ptr^.protection) THEN print[len+6]:="w" END;
            IF NOT (readProt  IN ptr^.protection) THEN print[len+5]:="r" END;
            IF (archive   IN ptr^.protection) THEN print[len+4]:="a" END;
            IF (script    IN ptr^.protection) THEN print[len+2]:="s" END;
            IF (pure      IN ptr^.protection) THEN print[len+3]:="p" END;
            IF (hidden    IN ptr^.protection) THEN print[len+1]:="h" END;
         END;
      END;
    END ConcatFlags;

    PROCEDURE ConcatDate;
    VAR dInfo : DateInfo;
        dstr  : ARRAY [0..20] OF CHAR;
    BEGIN
      IF dosDate IN fr^.FRFlags THEN
        IF (ptr^.type = file) OR (ptr^.type = directory) THEN
           FromDos(ptr^.date,dInfo);
           DateToStr(dInfo,"%d-%t-%y %H:%M:%S",month3,dstr); Concat(print,dstr);
        END;
      END;
    END ConcatDate;
BEGIN
  IF ptr # NIL THEN
     len:=Length(ptr^.fileName); Copy(print,ptr^.fileName);
     FOR i:=len TO 30 DO print[i]:=" " END; print[31]:=00C;
     ConcatLength; ConcatFlags; ConcatDate;

     len:=Length(print);
     IF len < fr^.displayColumns+1 THEN
        FOR i:=len TO fr^.displayColumns DO print[i]:=" " END;
     END;
     print[fr^.displayColumns+1]:=00C;

     IF (doColor IN fr^.FRFlags) THEN
        CASE ptr^.type OF
          file,volume: IF selected THEN DoPrint(1,2) ELSE DoPrint(2,1) END;
        ELSE
                       IF selected THEN DoPrint(0,3) ELSE DoPrint(3,2) END;
        END;
     ELSE
        CASE ptr^.type OF
          file,volume: IF selected THEN DoPrint(2,1) ELSE DoPrint(1,0) END;
        ELSE
                       IF selected THEN DoPrint(2,1) ELSE DoPrint(3,0) END;
        END;
     END;
  END;
END PrintSingle;

PROCEDURE PrintFiles(fr : FileRequestPtr; nr : CARDINAL);
VAR i : CARDINAL;
BEGIN
  WITH fr^.datas^ DO
    FOR i:=0 TO fr^.displayRows DO
      IF nr+i <= dirEntries THEN
         IF DirArray[nr+i]^.selected THEN
            PrintSingle(fr,DirArray[nr+i],i,TRUE);
         ELSE
            PrintSingle(fr,DirArray[nr+i],i,FALSE);
         END;
      END;
    END;
  END;
END PrintFiles;

PROCEDURE UnSelectFiles(fr : FileRequestPtr);
VAR i : CARDINAL;
BEGIN
  FOR i:=1 TO fr^.datas^.dirEntries DO
    fr^.datas^.DirArray[i]^.selected:=FALSE;
    PrintFiles(fr,fr^.datas^.listFile+1);
  END;
END UnSelectFiles;

PROCEDURE ModifyProp(fr : FileRequestPtr);
BEGIN
  WITH fr^.datas^ DO
    IF dirEntries > CARDINAL(fr^.displayRows+1) THEN
       listFile:=(LONGINT(propInfo.vertPot) *
                 (LONGINT(dirEntries-1)-LONGINT(fr^.displayRows))) DIV maxPot;
       PrintFiles(fr,listFile+1); lastSelected:=-1;
    END;
  END;
END ModifyProp;

PROCEDURE FindRow(fr : FileRequestPtr; last : INTEGER): INTEGER;
BEGIN
  WITH fr^.datas^ DO
    IF last >= INTEGER(listFile+1) THEN
       IF last <= INTEGER(listFile+1)+fr^.displayRows THEN
          RETURN last - INTEGER(listFile)-1;
       END;
    END;
    RETURN -1;
  END;
END FindRow;

PROCEDURE PrintFileName(fr : FileRequestPtr; element,pos : CARDINAL);
BEGIN
  WITH fr^.datas^ DO
    IF DirArray[element]^.selected THEN
       PrintSingle(fr,DirArray[element],pos,TRUE);
    ELSE
       PrintSingle(fr,DirArray[element],pos,FALSE);
    END;
  END;
END PrintFileName;

PROCEDURE Up(fr : FileRequestPtr);
BEGIN
  WITH fr^.datas^ DO
    IF (INTEGER(listFile)-1 >= 0) THEN
       DEC(listFile); propInfo.vertPot:=0;
       IF listFile+1 > 1 THEN
         propInfo.vertPot:=(maxPot DIV (dirEntries-CARDINAL(fr^.displayRows)-1))
                                    *  (listFile+1);
       END;
       WaitTOF();
       NewModifyProp(ADR(GadgetArray[0]),wind,NIL,propInfo.flags,0,
                     propInfo.vertPot,0,propInfo.vertBody,1);
       ScrollRaster(wind^.rPort,0,-8,xpos+17,ypos+16,
                    ((fr^.displayColumns+1)*8)+16+xpos,
                    ((fr^.displayRows+1)*8)+ypos+15);

       PrintFileName(fr,listFile+1,0);
    END;
  END;
END Up;

PROCEDURE Down(fr : FileRequestPtr);
BEGIN
  WITH fr^.datas^ DO
    IF INTEGER(listFile+1) <= INTEGER(dirEntries-1)-fr^.displayRows THEN
       INC(listFile); propInfo.vertPot:=maxPot;
       IF listFile+1 < dirEntries-CARDINAL(fr^.displayRows) THEN
         propInfo.vertPot:=(maxPot DIV (dirEntries-CARDINAL(fr^.displayRows-1)))
                                    *   (listFile+1);
       END;
       WaitTOF();
       NewModifyProp(ADR(GadgetArray[0]),wind,NIL,propInfo.flags,0,
                     propInfo.vertPot,0,propInfo.vertBody,1);
       ScrollRaster(wind^.rPort,0,8,xpos+17,ypos+16,
                   ((fr^.displayColumns+1)*8)+16+xpos,
                   ((fr^.displayRows+1)*8)+ypos+15);

       PrintFileName(fr,listFile+CARDINAL(fr^.displayRows+1),fr^.displayRows);
    END;
  END;
END Down;

PROCEDURE CorrectLastPrinted(fr : FileRequestPtr; last : INTEGER);
VAR row : INTEGER;
BEGIN
  WITH fr^.datas^ DO
    row:=FindRow(fr,last); IF (row >= 0) THEN PrintFileName(fr,last,row) END;
  END;
END CorrectLastPrinted;

PROCEDURE CursorUp(fr : FileRequestPtr);
VAR row : INTEGER;
BEGIN
  WITH fr^.datas^ DO
    CorrectLastPrinted(fr,lastSelected);
    IF lastSelected <= INTEGER(listFile+1) THEN
       IF (INTEGER(listFile)-1 >= 0) THEN
         Up(fr); DEC(lastSelected); PrintSingle(fr,DirArray[listFile+1],0,TRUE);
       END;
    ELSE
       IF lastSelected = -1 THEN
          IF listFile+1 <= dirEntries THEN
             lastSelected:=listFile+1;
             PrintSingle(fr,DirArray[listFile+1],0,TRUE);
          END;
       ELSE
         DEC(lastSelected); row:=FindRow(fr,lastSelected);
         IF (row >= 0) AND (lastSelected <= INTEGER(dirEntries)) THEN
            PrintSingle(fr,DirArray[lastSelected],row,TRUE);
         ELSE
            lastSelected:=INTEGER(listFile)+1;
         END;
       END;
    END;
  END;
END CursorUp;

PROCEDURE CursorDown(fr : FileRequestPtr);
VAR row : INTEGER;
BEGIN
  WITH fr^.datas^ DO
    CorrectLastPrinted(fr,lastSelected);
    IF lastSelected >= INTEGER(listFile+1)+fr^.displayRows THEN
       IF INTEGER(listFile+1) <= INTEGER(dirEntries-1)-fr^.displayRows THEN
          Down(fr); INC(lastSelected);
          PrintSingle(fr,DirArray[listFile+CARDINAL(fr^.displayRows+1)],
                         fr^.displayRows,TRUE);
       END;
    ELSE
       IF lastSelected = -1 THEN
          IF (listFile+1 <= dirEntries) THEN
             lastSelected:=listFile+1;
             PrintSingle(fr,DirArray[listFile+1],0,TRUE);
          END;
       ELSE
         INC(lastSelected); row:=FindRow(fr,lastSelected);
         IF (row >= 0) AND (lastSelected <= INTEGER(dirEntries)) THEN
            PrintSingle(fr,DirArray[lastSelected],row,TRUE);
         ELSE
            DEC(lastSelected);
         END;
       END;
    END;
  END;
END CursorDown;

PROCEDURE CursorLeft(fr : FileRequestPtr);
VAR row : INTEGER;
BEGIN
  WITH fr^.datas^ DO
    IF listFile # 0 THEN
       lastSelected:=1; listFile:=0; WaitTOF();
       NewModifyProp(ADR(GadgetArray[0]),wind,NIL,propInfo.flags,0,
                         0,0,propInfo.vertBody,1);
       PrintFiles(fr,listFile+1);
       PrintSingle(fr,DirArray[lastSelected],FindRow(fr,lastSelected),TRUE);
    END;
  END;
END CursorLeft;

PROCEDURE CursorRight(fr : FileRequestPtr);
VAR row : INTEGER;
BEGIN
  WITH fr^.datas^ DO
    IF INTEGER(dirEntries)-1-fr^.displayRows > 0 THEN
       listFile:=INTEGER(dirEntries)-1-fr^.displayRows;
       lastSelected:=dirEntries; WaitTOF();
       NewModifyProp(ADR(GadgetArray[0]),wind,NIL,propInfo.flags,0,
                         maxPot,0,propInfo.vertBody,1);
       PrintFiles(fr,listFile+1);
       PrintSingle(fr,DirArray[lastSelected],FindRow(fr,lastSelected),TRUE);
    END;
  END;
END CursorRight;

PROCEDURE GetAllDevices(fr : FileRequestPtr);
VAR dos     : DosLibraryPtr;
    dev     : DeviceListPtr;
    i       : CARDINAL;
    name    : ARRAY [0..31] OF CHAR;
    DevList : ARRAY [0..8],[0..6] OF CHAR;
    memo    : BOOLEAN;

    PROCEDURE Init;
    BEGIN
      DevList[0]:=("AUX");     DevList[1]:=("CON");
      DevList[2]:=("NEWCON");  DevList[3]:=("PAR");
      DevList[4]:=("PIPE");    DevList[5]:=("PRT");
      DevList[6]:=("RAW");     DevList[7]:=("SER");
      DevList[8]:=("SPEAK");
    END Init;
BEGIN
  WITH fr^.datas^ DO
    DeallocEntryList(fr);
    dirEntries:=1; dos:=ADR(DosL); dev:=dos^.root^.info^.devInfo; Init;

    WHILE (dev # NIL) DO
      CopyMem(ADDRESS(dev^.name)+1,ADR(name),30); name[30]:=00C;
      i:=0;
      REPEAT
        memo:=NOT (Compare(name,DevList[i]) = 0); INC(i);
      UNTIL ((i = 9) OR NOT memo);
      IF memo THEN
         IF Available(SIZE(DirName)) THEN
            ALLOCATE(DirArray[dirEntries],SIZE(DirName));
            WITH DirArray[dirEntries]^ DO
              Copy(fileName,name); Concat(fileName,":");
              IF dev^.type = DosD.device THEN type:=device ELSE type:=volume END;
            END;
            INC(dirEntries);
         END;
      END;
      dev:=dev^.next;
    END;

    DEC(dirEntries); listFile:=0; propInfo.vertBody:=maxBody;
    IF dirEntries > CARDINAL(fr^.displayRows+1) THEN
       propInfo.vertBody:=(maxBody DIV dirEntries) *
                                       (CARDINAL(fr^.displayRows)-1);
    END;
    NewModifyProp(ADR(GadgetArray[0]),wind,NIL,propInfo.flags,0,
                        0,0,propInfo.vertBody,1);
    QSort(fr,1); PrintFiles(fr,listFile+1); lastSelected:=-1;

  END;
END GetAllDevices;

PROCEDURE LoadDir(fileRequest : FileRequestPtr);
VAR bool : BOOLEAN;
BEGIN
  WITH fileRequest^.datas^ DO
    DeallocEntryList(fileRequest);
    lockPtr:=Lock(ADR(fileRequest^.dirPath),accessRead); lastSelected:=-1;
    IF lockPtr # NIL THEN
       listFile:=0;
        Block(wind^.rPort,0,16+xpos,15+ypos,
        ((fileRequest^.displayColumns+1)*8)+18+xpos,
        ((fileRequest^.displayRows+1)*8)+16+ypos);
       IF ReadDirectory(fileRequest,lockPtr,
                       (noInfos IN fileRequest^.FRFlags)) THEN
          propInfo.vertBody:=maxBody;
          IF dirEntries > CARDINAL(fileRequest^.displayRows+1) THEN
             propInfo.vertBody:=(maxBody DIV dirEntries) *
                                (CARDINAL(fileRequest^.displayRows - 1));
          END;
          NewModifyProp(ADR(GadgetArray[0]),wind,NIL,propInfo.flags,0,
                        0,0,propInfo.vertBody,1);
          QSort(fileRequest,1); PrintFiles(fileRequest,listFile+1);
          UnLock(lockPtr); lockPtr:=NIL;
          RefreshGList(ADR(GadgetArray[3]),wind,NIL,2);
       ELSE
         Block(wind^.rPort,0,16+xpos,15+ypos,
           ((fileRequest^.displayColumns+1)*8)+18+xpos,
           ((fileRequest^.displayRows+1)*8)+16+ypos);
         dirEntries:=0; listFile:=0;
         NewModifyProp(ADR(GadgetArray[0]),wind,NIL,propInfo.flags,0,
                       0,0,maxBody,1);
         RefreshGList(ADR(GadgetArray[3]),wind,NIL,2);
       END;
    ELSE
       GetAllDevices(fileRequest);
    END;
  END;
END LoadDir;

PROCEDURE CheckDoubleClick(fr : FileRequestPtr; position : CARDINAL): BOOLEAN;
BEGIN
  IF fr^.datas^.DirArray[position]^.selected THEN
     RETURN TRUE
  ELSE RETURN FALSE END;
END CheckDoubleClick;

PROCEDURE CurrentSelected(fr : FileRequestPtr): FileNamePtr;
BEGIN
  RETURN ADR(fr^.datas^.DirArray[fr^.datas^.lastSelected]^.fileName);
END CurrentSelected;

PROCEDURE DoSelected(fr : FileRequestPtr; row : CARDINAL; key : BOOLEAN);

  PROCEDURE FileSelect;
  VAR bool : LONGINT;
  BEGIN
   WITH fr^.datas^ DO
    IF lastSelected = INTEGER(row+listFile+1) THEN
       IF (multiSelect IN fr^.FRFlags) THEN
          IF DirArray[row+listFile+1]^.selected THEN
             DirArray[lastSelected]^.selected:=FALSE;
             CorrectLastPrinted(fr,lastSelected);
          ELSE
             DirArray[row+listFile+1]^.selected:=TRUE;
             PrintSingle(fr,DirArray[row+listFile+1],row,TRUE);
          END;
       ELSE
         Copy(fr^.file,DirArray[row+listFile+1]^.fileName);
         RefreshGList(ADR(GadgetArray[4]),wind,NIL,1);

         IF (giveFileSelected IN fr^.FRFlags) THEN
          bool:=fr^.func(0,CAST(CARDINAL,FileRequestFlagSet{giveFileSelected}));
         END;
       END;
    ELSE
       IF (multiSelect IN fr^.FRFlags) THEN
          IF DirArray[row+listFile+1]^.selected THEN
             IF lastSelected # -1 THEN
                CorrectLastPrinted(fr,lastSelected);
                DirArray[lastSelected]^.selected:=FALSE;
             END;
          ELSE
            DirArray[row+listFile+1]^.selected:=TRUE;
          END;
       ELSE
          CorrectLastPrinted(fr,lastSelected);
       END;
       PrintSingle(fr,DirArray[row+listFile+1],row,TRUE);
       lastSelected:=row+listFile+1;
    END;
   END;
  END FileSelect;

  PROCEDURE DirSelect;
  VAR bool : LONGINT;
  BEGIN
   WITH fr^.datas^ DO
    IF lastSelected = INTEGER(row+listFile+1) THEN
       IF Length(fr^.dirPath) > 0 THEN
          IF (fr^.dirPath[Length(fr^.dirPath)-1] # "/") AND
             (fr^.dirPath[Length(fr^.dirPath)-1] # ":") THEN
             Concat(fr^.dirPath,"/");
          END;
          Concat(fr^.dirPath,DirArray[row+listFile+1]^.fileName);
          RefreshGList(ADR(GadgetArray[3]),wind,NIL,1);
          LoadDir(fr);
          IF (giveDirSelected IN fr^.FRFlags) THEN
           bool:=fr^.func(0,CAST(CARDINAL,FileRequestFlagSet{giveDirSelected}));
          END;
       END;
    ELSE
       CorrectLastPrinted(fr,lastSelected);
       PrintSingle(fr,DirArray[row+listFile+1],row,TRUE);
       lastSelected:=INTEGER(row+listFile+1);
    END;
   END;
  END DirSelect;

  PROCEDURE DevAndVolSelect;
  BEGIN
   WITH fr^.datas^ DO
    IF lastSelected = INTEGER(row+listFile+1) THEN
       Copy(fr^.dirPath,DirArray[row+listFile+1]^.fileName);
       RefreshGList(ADR(GadgetArray[3]),wind,NIL,1);
       LoadDir(fr);
    ELSE
       CorrectLastPrinted(fr,lastSelected);
       PrintSingle(fr,DirArray[row+listFile+1],row,TRUE);
       lastSelected:=INTEGER(row+listFile+1);
    END;
   END;
  END DevAndVolSelect;

BEGIN
  WITH fr^.datas^ DO
    CASE DirArray[row+listFile+1]^.type OF
      file:          FileSelect;
    | directory:     DirSelect;
    | device,volume: DevAndVolSelect;
    ELSE
    END;
  END;
END DoSelected;

PROCEDURE Return(fr : FileRequestPtr);
VAR row : INTEGER;
BEGIN
  WITH fr^.datas^ DO
    row:=FindRow(fr,lastSelected);
    IF (row >= 0) THEN DoSelected(fr,CARDINAL(row),TRUE) END;
  END;
END Return;

PROCEDURE CheckMouse(fr : FileRequestPtr);
VAR row : CARDINAL;
BEGIN
 WITH fr^.datas^ DO
  IF (mouseX >= xpos+16) AND (mouseX <= xpos+((fr^.displayColumns+1)*8)+18) THEN
  IF (mouseY >= ypos+16) AND (mouseY <= ypos+((fr^.displayRows+1)*8)+15)    THEN
       row:=((mouseY-ypos-16) DIV 8);
       IF row+listFile+1 <= dirEntries THEN DoSelected(fr,row,FALSE) END;
  END;
  END;
 END;
END CheckMouse;

PROCEDURE Parent(fr : FileRequestPtr);
VAR len : INTEGER;
BEGIN
  WITH fr^.datas^ DO
   IF Length(fr^.dirPath) > 0 THEN
    len:=LastPos(fr^.dirPath,Length(fr^.dirPath)-2,"/");
    IF (len < 0) THEN
        len:=LastPos(fr^.dirPath,Length(fr^.dirPath)-1,":");
        IF len > 0 THEN
           IF len+1 # INTEGER(Length(fr^.dirPath)) THEN
              fr^.dirPath[len+1]:=00C;
              RefreshGList(ADR(GadgetArray[3]),wind,NIL,1);
              LoadDir(fr);
           END;
        END;
    ELSE
       fr^.dirPath[len]:=00C;
       RefreshGList(ADR(GadgetArray[3]),wind,NIL,1);
       LoadDir(fr);
    END;
   END;
  END;
END Parent;

PROCEDURE RefreshDisplay(fileRequest : FileRequestPtr);
BEGIN
  MakeDrawings(fileRequest);
  PrintFiles(fileRequest,fileRequest^.datas^.listFile+1);
END RefreshDisplay;

PROCEDURE DoAction(fr : FileRequestPtr);
VAR i   : CARDINAL;
    res : LONGINT;
BEGIN
  IF (multiSelect IN fr^.FRFlags) THEN
     IF fr^.datas^.dirEntries > 0 THEN
        i:=1;
        REPEAT
          IF fr^.datas^.DirArray[i]^.selected THEN
             res:=fr^.multiFunc(ADR(fr^.datas^.DirArray[i]^.fileName),0);
          END;
          INC(i);
        UNTIL (i > fr^.datas^.dirEntries) OR (res = -1);
        fr^.datas^.lastSelected:=-1;
     END;
  END;
END DoAction;

PROCEDURE CauseAction(fileRequest : FileRequestPtr;
                      msg         : IntuiMessagePtr;
                      VAR exit    : BOOLEAN): BOOLEAN;
VAR class      : IDCMPFlagSet;
    gadgSelect : GadgetPtr;
    win        : WindowPtr;
    code       : CARDINAL;
    intuiMsg   : IntuiMessage;
    pressed,
    delay      : BOOLEAN;

    PROCEDURE GetNextMsg(): BOOLEAN;
    VAR nextMsg : IntuiMessagePtr;
    BEGIN
      WITH fileRequest^.datas^ DO
        IF delay THEN Delay(5); delay:=FALSE; END;
        IF (listFile > 0) AND (INTEGER(listFile+1) <=
                       INTEGER(dirEntries-1)-fileRequest^.displayRows) THEN

           nextMsg:=GetMsg(wind^.userPort);
           IF nextMsg # NIL THEN
              intuiMsg:=nextMsg^; msg:=ADR(intuiMsg); ReplyMsg(nextMsg);
              delay:=TRUE; RETURN TRUE;
           END;
           RETURN FALSE;
        ELSE
           RETURN TRUE;
        END;
      END;
    END GetNextMsg;

    PROCEDURE Close;
    BEGIN
      IF NOT (noWindow IN fileRequest^.FRFlags) THEN
         CloseFileRequest(fileRequest);
      END;
    END Close;

BEGIN
IF fileRequest^.datas # NIL THEN
 WITH fileRequest^.datas^ DO
   exit:=FALSE; delay:=TRUE; pressed:=FALSE;
   LOOP
    IF msg # NIL THEN
       class:=msg^.class;
       code:=msg^.code;
       mouseX:=msg^.mouseX;
       mouseY:=msg^.mouseY;
       gadgSelect:=msg^.iAddress;
       win:=msg^.idcmpWindow;

      IF win = fileRequest^.datas^.wind THEN
         IF (closeWindow IN class) THEN
            exit:=FALSE; Close; RETURN TRUE;;
         ELSIF (rawKey IN class) THEN
           IF keyCodes IN fileRequest^.FRFlags THEN
              CASE code OF
                cursorUp:         CursorUp(fileRequest);
              | cursorDown:       CursorDown(fileRequest);
              | cursorLeft:       CursorLeft(fileRequest);
              | cursorRight:      CursorRight(fileRequest);
              | return1,return2:  Return(fileRequest);
              | o:                DoAction(fileRequest);exit:=TRUE;
              			  Close; RETURN TRUE;
              | d:                GetAllDevices(fileRequest);
              | p:                Parent(fileRequest);
              | c:                IF (multiSelect IN fileRequest^.FRFlags) THEN
				     UnSelectFiles(fileRequest);
           		          END;
           		          OldValues(fileRequest); exit:=FALSE;
                                  Close; RETURN TRUE;
              ELSE
              END;
           END;
         ELSIF (gadgetDown IN class) THEN
           CASE (gadgSelect^.gadgetID-INTEGER(extra)) OF
             firstGadgetID   : ModifyProp(fileRequest);
           | firstGadgetID+1 : Up(fileRequest);   pressed:=TRUE;
           | firstGadgetID+2 : Down(fileRequest); pressed:=TRUE;
           | firstGadgetID+5 : DoAction(fileRequest);
           		       IF (noWindow IN fileRequest^.FRFlags) THEN
                                  Return(fileRequest);
                               END;
                               exit:=TRUE; Close; RETURN TRUE;
           | firstGadgetID+6 : GetAllDevices(fileRequest);
           | firstGadgetID+7 : Parent(fileRequest);
           | firstGadgetID+8 : IF (multiSelect IN fileRequest^.FRFlags) THEN
				 UnSelectFiles(fileRequest);
           		       END;
           		       OldValues(fileRequest); exit:=FALSE;
                               Close; RETURN TRUE;
           ELSE
           END;
         ELSIF (gadgetUp IN class) THEN
           CASE gadgSelect^.gadgetID-INTEGER(extra) OF
             firstGadgetID   : ModifyProp(fileRequest);
           | firstGadgetID+3,
             firstGadgetID+9 : LoadDir(fileRequest);
           ELSE
           END;
         ELSIF (mouseButtons IN class) THEN
           CASE code OF
             selectDown: CheckMouse(fileRequest);
           ELSE
           END;
         END;
      END;
      IF (giveMsgPtr IN fileRequest^.FRFlags) THEN
         IF fileRequest^.func(msg,
                  CAST(CARDINAL,FileRequestFlagSet{giveMsgPtr})) = -1 THEN
            exit:=TRUE; msg:=NIL; Close; RETURN TRUE;
         END;
      END;
      IF (giveGadgetID IN fileRequest^.FRFlags) THEN
         IF gadgSelect # NIL THEN
            IF fileRequest^.func(gadgSelect^.gadgetID,
                  CAST(CARDINAL,FileRequestFlagSet{giveMsgPtr})) = -1 THEN
               exit:=TRUE; msg:=NIL; Close;
               RETURN TRUE;
            END;
         END;
      END;
      IF pressed THEN IF GetNextMsg() THEN EXIT END ELSE EXIT END;
    ELSE
      EXIT;
    END;
   END;
 END;
END;
RETURN FALSE;
END CauseAction;

PROCEDURE FileRequester(fileRequest : FileRequestPtr): BOOLEAN;
VAR intuiMsg : IntuiMessage;
    msg      : IntuiMessagePtr;
    exit     : BOOLEAN;
BEGIN
  IF fileRequest^.datas = NIL THEN
     IF Available(SIZE(Request)) THEN
        ALLOCATE(fileRequest^.datas,SIZE(Request));
        IF Available(SIZE(Protocoll)) THEN
           ALLOCATE(nextProt^.next,SIZE(Protocoll));
           nextProt^.req:=fileRequest; nextProt:=nextProt^.next;

           WITH fileRequest^.datas^ DO
             lastSelected:=-1; exit:=TRUE; nextProt^.next:=NIL;
             extra:=bonus; INC(bonus,numOfGadgets+1);
             WITH fileRequest^ DO
               IF displayRows < 2 THEN displayRows:=2 END;
               IF displayColumns < 28 THEN displayColumns:=28 END;
             END;

             InitIntuition(fileRequest);
             IF Length(fileRequest^.dirPath) = 0 THEN
                GetAllDevices(fileRequest);
             ELSE
                LoadDir(fileRequest);
             END;
             Assert(wind # NIL, ADR("FileRequester fatal Error !!"));
             IF NOT ((sharedIDCMP IN fileRequest^.FRFlags) OR
                        (noWindow IN fileRequest^.FRFlags)) THEN
                LOOP
                  WaitPort(wind^.userPort);
                  msg:=GetMsg(wind^.userPort);
                  IF msg # NIL THEN
                     intuiMsg:=msg^; ReplyMsg(msg);
                     IF CauseAction(fileRequest,ADR(intuiMsg),exit) THEN
                        EXIT
                     END;
                  END;
                END;
             END;
             RETURN exit;
           END;
        ELSE
           DEALLOCATE(fileRequest^.datas,SIZE(Request));
           fileRequest^.datas:=NIL;
        END;
     END;
  END;
  RETURN FALSE;
END FileRequester;

BEGIN
  nextProt:=ADR(Prot); bonus:=0;

CLOSE

 TermPtr:=ADR(Prot);
 REPEAT
   CloseFileRequest(TermPtr^.req); TermPtr:=TermPtr^.next
 UNTIL TermPtr = NIL;
END FileRequester.
