(*---------------------------------------------------------------------------
  :Program.    TestFileRequester
  :Author.     Thomas Stolze
  :Address.    Goslarsche Str. 32, 3000 Hannover 21, Germany
  :Phone.      (0)511 / 75 10 77
  :Version.    V1.2
  :Date.       16-Nov-90
  :Copyright.  PD
  :Language.   Modula-2
  :Translator. M2Amiga V4.0d
  :LastChange. 01-JUN-1991
  :Contents.   Demo.
---------------------------------------------------------------------------*)
(*$LargeVars:=FALSE *)
MODULE TestFileRequester;

FROM Arts             IMPORT Assert,BreakPoint,Requester;
FROM DosL             IMPORT Delay;
FROM ExecL            IMPORT GetMsg,ReplyMsg,WaitPort;
FROM FileRequester    IMPORT FileRequester,CauseAction,CloseFileRequest,
                             FileRequest,FileRequestFlags,FileRequestFlagSet,
                             FileRequestFunc,DoAction,FileNamePtr,
                             UnSelectFiles;
FROM GraphicsD        IMPORT DrawModes,DrawModeSet,jam2,ViewModes,ViewModeSet;
FROM IntuitionD       IMPORT ActivationFlags,ActivationFlagSet,boolGadget,
                             Border,BorderPtr,
                             customScreen,Gadget,
                             GadgetFlags,GadgetFlagSet,GadgetPtr,IDCMPFlags,
                             IDCMPFlagSet,IntuiMessage,IntuiMessagePtr,
                             IntuiText,IntuiTextPtr,Menu,MenuItem,MenuItemFlags,
                             MenuItemFlagSet,MenuPtr,NewScreen,NewWindow,
                             ScreenFlags,
                             ScreenFlagSet,ScreenPtr,selectDown,
                             strGadget,StringInfo,WindowFlags,WindowFlagSet,
                             WindowPtr;
FROM IntuitionL       IMPORT ClearMenuStrip,CloseScreen,
                             CloseWindow,DisplayBeep,
                             OpenScreen,OpenWindow,RefreshGadgets,
                             SetMenuStrip,SetWindowTitles;
FROM IntuiMacros      IMPORT ItemNum,MenuNum;
FROM IntuitionSupport IMPORT SetBorder,SetBorderKoord,SetGadget,SetInfo,
                             SetIText,SetMenu,SetMenuItem,SetWindow;
FROM String           IMPORT Copy;
FROM SYSTEM           IMPORT ADDRESS,ADR,CAST;

(*FROM InOut IMPORT WriteString,WriteLn;*)

VAR fileRequest : FileRequest;
    fRequest2   : FileRequest;
    bool        : BOOLEAN;
    window      : WindowPtr;
    screen      : ScreenPtr;

PROCEDURE Demo1(): BOOLEAN;
BEGIN
  WITH fileRequest DO
    head       := ADR("--- Demo 1 ---");
    x          := 100;
    y          := 50;
    displayRows:= 9;
    displayColumns := 28;
    file       := "";
    dirPath    := "";
    userWindow := NIL;
    userScreen := NIL;
    patternStr := "#?";
    FRFlags    := FileRequestFlagSet{noInfos,pattern,keyCodes,filesFirst};
    func       := NIL;
  END;
  RETURN FileRequester(ADR(fileRequest));
END Demo1;

PROCEDURE Demo2(): BOOLEAN;
BEGIN
  WITH fileRequest DO
    head       := ADR("--- Demo 2 ---");
    x          := 100;
    y          := 50;
    displayRows:= 12;
    displayColumns := 38;
    file       := "";
    dirPath    := "";
    userWindow := NIL;
    userScreen := NIL;
    patternStr := "#?";
    FRFlags    := FileRequestFlagSet{doColor,keyCodes,dosLength};
    func       := NIL;
  END;
  RETURN FileRequester(ADR(fileRequest));
END Demo2;

PROCEDURE Action(ptr : ADDRESS; mask : LONGCARD): LONGINT;
TYPE NW = POINTER TO NewWindow;
VAR  nw : NW;
BEGIN
  IF mask = CAST(CARDINAL,FileRequestFlagSet{giveNewWindow}) THEN
     nw:=ptr; nw^.width:=nw^.width+100;
  END;
  RETURN 0;
END Action;

PROCEDURE Demo3(): BOOLEAN;
VAR nw     : NewWindow;
    ns     : NewScreen;
    msg    : IntuiMessagePtr;
    intui  : IntuiMessage;
    exit   : BOOLEAN;
BEGIN
  WITH ns DO
    leftEdge:=0; topEdge:=0; width:=640; height:=-1;
    detailPen:=0; blockPen:=1; depth:=2;
    viewModes:=ViewModeSet{hires};
    type:=customScreen; font:=NIL;
    defaultTitle:=ADR("Demo --- 3 ---");
    gadgets:=NIL; customBitMap:=NIL;
  END;

  screen:=OpenScreen(ns);
    Assert(screen # NIL,ADR("Couldn't open Screen!"));

  SetWindow(nw,0,11,300,170,0,1,
            IDCMPFlagSet{closeWindow,gadgetDown,mouseButtons},
            WindowFlagSet{windowDrag,windowDepth,windowClose,activate,
                          windowRefresh,windowActive,menuState},
            ADR("Demo -- 3 --"),NIL,screen,
            10,60,440,110,customScreen);

  window:=OpenWindow(nw);
    Assert(window # NIL,ADR("Couldn't open window!"));

  WITH fileRequest DO
    head       := ADR("--- Demo 3 ---");
    x          := 250;
    y          := 11;
    displayRows:= 6;
    displayColumns:=27;
    file       := "";
    dirPath    := "";
    FRWindow   := NIL;
    userWindow := window;
    userScreen := screen;
    patternStr := "#?";
    FRFlags    := FileRequestFlagSet{keyCodes,pattern,noInfos,filesFirst,
                                     sharedIDCMP,giveNewWindow};
    func       := Action;
  END;
  Assert(FileRequester(ADR(fileRequest)),ADR("Error"));

  LOOP
    WaitPort(window^.userPort);
    msg:=GetMsg(window^.userPort); intui:=msg^; ReplyMsg(msg);

    IF intui.idcmpWindow = window THEN
       IF (closeWindow IN intui.class) THEN EXIT ELSE DisplayBeep(screen) END;
    END;

    IF CauseAction(ADR(fileRequest),ADR(intui),exit) THEN
       CloseFileRequest(ADR(fileRequest));
    END;

  END;
  CloseFileRequest(ADR(fileRequest));
  CloseWindow(window); window:=NIL; CloseScreen(screen); screen:=NIL;
  RETURN exit;
END Demo3;

PROCEDURE Action2(file : ADDRESS; card : LONGCARD): LONGINT;
BEGIN
  SetWindowTitles(window,file,NIL); Delay(10); RETURN 0;
END Action2;

PROCEDURE Demo4(): BOOLEAN;
VAR nw     : NewWindow;
    msg    : IntuiMessagePtr;
    gadget : Gadget;
    intui  : IntuiMessage;
    ptr    : BorderPtr;
    gPtr   : GadgetPtr;
    exit   : BOOLEAN;
    text   : IntuiText;
    border : Border;
    BorderArray : ARRAY [0..9] OF INTEGER;
    fRequest3   : FileRequest;
BEGIN

  SetGadget(gadget,270,175,80,10,GadgetFlagSet{},
            ActivationFlagSet{gadgImmediate,relVerify},
            boolGadget,ADR(border),
            SetIText(text,ADR("Requester"),1,0,6,2,jam2),NIL,0);

  SetBorderKoord(BorderArray,gadget);
  ptr:=SetBorder(border,-1,-1,1,0,5,jam2,ADR(BorderArray));

  SetWindow(nw,0,11,640,189,0,1,
            IDCMPFlagSet{closeWindow,gadgetDown},
            WindowFlagSet{windowDrag,windowDepth,windowClose,activate,
                          windowRefresh,windowActive,menuState},
            ADR("Demo -- 4 --"),ADR(gadget),NIL,
            10,60,440,110,ScreenFlagSet{wbenchScreen});

  window:=OpenWindow(nw);
    Assert(window # NIL,ADR("Couldn't open window!"));

  WITH fileRequest DO
    head       := NIL;
    x          := 20;
    y          := 11;
    displayRows:= 5;
    displayColumns:=29;
    file       := "";
    dirPath    := "";
    FRWindow   := window;
    userWindow := NIL;
    userScreen := NIL;
    patternStr := "#?";
    FRFlags    := FileRequestFlagSet{pattern,filesFirst,noInfos,noWindow};
    func       := NIL;
  END;
    Assert(FileRequester(ADR(fileRequest)),ADR("Error"));

  WITH fRequest2 DO
    head       := NIL;
    x          := 340;
    y          := 11;
    displayRows:= 9;
    displayColumns := 29;
    file       := "";
    dirPath    := "";
    FRWindow   := window;
    userWindow := NIL;
    userScreen := NIL;
    patternStr := "#?";
    FRFlags    := FileRequestFlagSet{noInfos,pattern,filesFirst,
                                     noWindow,multiSelect};
    multiFunc  := Action2;
    func       := NIL;
  END;
    Assert(FileRequester(ADR(fRequest2)),ADR("Error"));

  WITH fRequest3 DO
    head       := ADR(" --- Demo 4 ---");
    x          := 30;
    y          := 30;
    displayRows:= 15;
    displayColumns := 66;
    file       := "";
    dirPath    := "";
    FRWindow   := NIL;
    userWindow := NIL;
    userScreen := NIL;
    patternStr := "#?";
    FRFlags    := FileRequestFlagSet{noInfos,pattern,filesFirst,keyCodes,
                                     dosLength,dosFlags,dosDate,multiSelect};
    multiFunc  :=Action2;
    datas      := NIL;
  END;

  LOOP
    WaitPort(window^.userPort);
    msg:=GetMsg(window^.userPort);
      intui:=msg^; gPtr:=msg^.iAddress;
    ReplyMsg(msg);

    exit:=FALSE;
    IF (closeWindow IN intui.class) THEN
       EXIT
    ELSIF (gadgetDown IN intui.class) THEN
       CASE gPtr^.gadgetID OF
         0 : bool:=FileRequester(ADR(fRequest3));
       ELSE
       END;
    END;

    bool:=CauseAction(ADR(fileRequest),ADR(intui),exit);
    bool:=CauseAction(ADR(fRequest2),ADR(intui),exit);

  END;
  CloseFileRequest(ADR(fRequest2)); CloseFileRequest(ADR(fileRequest));
  CloseWindow(window); window:=NIL;
  RETURN exit;

 (* IF you choose 'noWindow' you MUST call "CloseFileRequest()" by yourself ! *)
 (* But all resources will be still freed correctly at end of session.        *)
END Demo4;

BEGIN

  bool:=Demo1();
  bool:=Demo2();
  bool:=Demo3();
  bool:=Demo4();

CLOSE
  IF window # NIL THEN CloseWindow(window); window:=NIL END;
  IF screen # NIL THEN CloseScreen(screen); screen:=NIL END;
END TestFileRequester.
