(**********************************************************************

    :Program.    VDisk.mod
    :Contents.   Procedures zum Speichern und Laden fr das Programm
    :Contents.   VTrainer
    :Author.     Dieter WILHELM
    :Address.    Albert-Schweitzer-Str.44, 8000 Mnchen 83
    :Phone.      089/671693
    :Copyright.  PD
    :Language.   Modula-2
    :Translator. M2Amiga A+L V4.0d
    :Imports.    Lists [bne] Amok#22,
    :Imports.    Request, VEingabe, VMenue
    :History.    V1.0 Dieter WILHELM 13.Jan.1991
    :History.    V1.1 Dieter WILHELM 29.Sept.1991

**********************************************************************)

IMPLEMENTATION MODULE VDisk ;


  FROM FileMessage IMPORT ResponseText, StrPtr;
  FROM FileSystem  IMPORT Close, File, Lookup, ReadBytes, Response,
                          WriteBytes;
  FROM GraphicsD   IMPORT jam1;
  FROM IntuitionD  IMPORT ActivationFlags, ActivationFlagSet, Border,
                          Gadget, GadgetFlags, GadgetFlagSet, GadgetPtr,
                          IDCMPFlags, IDCMPFlagSet, IntuiText, strGadget,
                          StringInfo, WindowPtr;
  FROM IntuitionL  IMPORT AutoRequest;
  FROM Lists       IMPORT AppendEntryC, EntriesInList, EntryPtr,
                          FirstEntry, ReadEntryC, Successor;
  FROM Request     IMPORT fString, Req;
  FROM String      IMPORT Delete, Insert, Length;
  FROM SYSTEM      IMPORT ADR, LONGSET;
  FROM VEingabe    IMPORT Modus, VKopf, Vokabel, Zeile;
  FROM VMenue      IMPORT attr;


  TYPE Kennung = ARRAY [0..7] OF CHAR ;


  VAR VKenn               : Kennung ;
      mod                 : Modus ;
      i, m, n,
      laenge              : CARDINAL ;
      Vok                 : Vokabel ;
      Datei               : File ;
      DName               : fString;
      DDir                : fString;
      Resultat            : Response ;
      ZGroesse, MGroesse  : LONGINT ;
      req                 : BOOLEAN ;
      resp, schade, lang,
      modus, look,
      dateiformat         : IntuiText ;
      lTitel, sTitel      : ARRAY [0..32] OF CHAR;
      null                : CARDINAL;


  PROCEDURE Fehler(Resultat: Response; aktuell, Laenge: LONGINT;
                   W: WindowPtr): BOOLEAN ;
    VAR Text : StrPtr ;
    BEGIN
      IF Resultat # done THEN
        ResponseText(Resultat, Text) ;
        resp.iText := Text ;
        req := AutoRequest(W, ADR(resp), NIL, ADR(schade),
                           IDCMPFlagSet{}, IDCMPFlagSet{}, 300, 65);
        RETURN TRUE ;
      END ;  (* IF *)
      IF aktuell # Laenge THEN
        req := AutoRequest(W, ADR(lang), NIL, ADR(schade),
                           IDCMPFlagSet{}, IDCMPFlagSet{}, 500, 65);
        RETURN TRUE ;
      END ;  (* IF *)
      RETURN FALSE ;
  END Fehler ;


  PROCEDURE KennungFalsch(Kenn: Kennung): BOOLEAN ;
    BEGIN
      FOR i := 0 TO 7 DO
        IF Kenn[i] # VKenn[i] THEN
          RETURN TRUE ;
        END ;  (* IF *)
      END ;  (* FOR *)
      RETURN FALSE ;
  END KennungFalsch ;


  PROCEDURE Lesen(VAR Kopf: VKopf; W: WindowPtr) ;
    VAR HKenn   : Kennung ;
        gelesen : LONGINT ;
        ok      : BOOLEAN ;
    BEGIN
      DName := Kopf.Name ; DDir := Kopf.Dir ;
      IF Req(W, DName, DDir, lTitel) THEN
        Kopf.Name := DName ; Kopf.Dir := DDir ;
        IF (Length(DDir) > 0) AND (DDir[Length(DDir) - 1] # ":") THEN
          Insert(DName, 0, "/") ;
        END ;  (* IF (Length *)
        Insert(DName, 0, DDir) ;
        Lookup(Datei, DName, 2048, FALSE) ;
        IF Datei.res # done THEN
          req := AutoRequest(W, ADR(look), NIL, ADR(schade),
                             IDCMPFlagSet{}, IDCMPFlagSet{}, 350, 65);
        ELSE
          ReadBytes(Datei, ADR(HKenn), 8, gelesen) ;
          IF Fehler(Datei.res, gelesen, 8, W) OR KennungFalsch(HKenn)
          THEN
            req := AutoRequest(W, ADR(dateiformat), NIL, ADR(schade),
                               IDCMPFlagSet{}, IDCMPFlagSet{}, 230, 65);
          ELSE
            ok := TRUE ; m := 0 ; Kopf.Anzahl := 0 ;
            WHILE (m < 4) AND ok DO
              ReadBytes(Datei, ADR(laenge), 2, gelesen) ;
              ok := NOT Fehler(Datei.res, gelesen, 2, W) ;
              n := 0 ;
              WHILE (n < laenge) AND ok DO
                ReadBytes(Datei, ADR(Vok.Wort), ZGroesse, gelesen) ;
                ok := NOT Fehler(Datei.res, gelesen, ZGroesse, W) ;
                i := 0 ;
                WHILE (i < 5) AND ok DO
                  ReadBytes(Datei, ADR(Vok.Uebersetzung[i]), ZGroesse,
                            gelesen) ;
                  ok := NOT Fehler(Datei.res, gelesen, ZGroesse, W) ;
                  INC(i);
                END ;  (* WHILE i *)
                FOR mod := v TO ue DO
                  IF ok THEN
                    ReadBytes(Datei, ADR(Vok.abgefragt[mod]), 2,gelesen);
                    ok := NOT Fehler(Datei.res, gelesen, 2, W) ;
                    IF ok THEN
                      ReadBytes(Datei, ADR(Vok.gewusst[mod]), 2,gelesen);
                      ok := NOT Fehler(Datei.res, gelesen, 2, W) ;
                    END ;  (* IF ok *)
                  END ;  (* IF ok *)
                END ;  (* FOR *)
                IF ok THEN
                  AppendEntryC(Kopf.Gruppe[m], Vok) ;
                  INC(Kopf.Anzahl);
                END ;  (* IF ok*)
                INC(Kopf.gefragtV, Vok.abgefragt[v]) ;
                INC(Kopf.gewusstV, Vok.gewusst[v]) ;
                INC(Kopf.gefragtU, Vok.abgefragt[ue]) ;
                INC(Kopf.gewusstU, Vok.gewusst[ue]) ;
                INC(n);
              END ;  (* WHILE n *)
              INC(m);
            END ;  (* WHILE m *)
            ReadBytes(Datei, ADR(Kopf.Mod), MGroesse, gelesen) ;
            IF Fehler(Datei.res, gelesen, MGroesse, W) THEN
              Kopf.Mod := v ;
              req := AutoRequest(W, ADR(modus), NIL, ADR(schade),
                                 IDCMPFlagSet{}, IDCMPFlagSet{}, 350,65);
            END ;  (* IF Fehler *)
          END ;  (* IF Fehler OR KennungFalsch *)
          Close(Datei) ;
        END ;  (* IF Datei.res *)
      END ;  (* IF FileRequest *)
  END Lesen ;


  PROCEDURE Schreiben(VAR Kopf: VKopf; neu: BOOLEAN; W: WindowPtr):
                      BOOLEAN;
    VAR dummy       : BOOLEAN ;
        geschrieben : LONGINT ;
        ok          : BOOLEAN ;
        Eintrag     : EntryPtr ;
    BEGIN
      ok := TRUE ;
      DName := Kopf.Name ; DDir := Kopf.Dir ;
      IF (Kopf.Anzahl > 0) AND neu THEN
        IF Req(W, DName, DDir, sTitel) THEN
          Kopf.Name := DName ; Kopf.Dir := DDir ;
        ELSE
          ok := FALSE ;
        END ;  (* IF FileRequest *)
      END ;  (* IF neu *)
      IF (Kopf.Anzahl > 0) AND ok THEN
        IF (Length(DDir) > 0) AND (DDir[Length(DDir) - 1] # ":") THEN
          Insert(DName, 0, "/") ;
        END ;  (* IF (Length *)
        Insert(DName, 0, DDir) ;
        Lookup(Datei, DName, 2048, TRUE) ;
        IF Datei.res # done THEN
          req := AutoRequest(W, ADR(look), NIL, ADR(schade),
                             IDCMPFlagSet{}, IDCMPFlagSet{}, 350, 65);
        ELSE
          WriteBytes(Datei, ADR(VKenn), 8, geschrieben) ;
          dummy := Fehler(Datei.res, 8, geschrieben, W) ;
          FOR m := 0 TO 3 DO
            ok := TRUE ;
            laenge := EntriesInList(Kopf.Gruppe[m]) ;
            WriteBytes(Datei, ADR(laenge), 2, geschrieben) ;
            dummy := Fehler(Datei.res, 2, geschrieben, W) ;
            Eintrag := FirstEntry(Kopf.Gruppe[m]) ; n := 0 ;
            WHILE (n < laenge) AND ok DO
              ReadEntryC(Kopf.Gruppe[m], Eintrag, Vok) ;
              WriteBytes(Datei, ADR(Vok.Wort), ZGroesse, geschrieben);
              dummy := Fehler(Datei.res, ZGroesse, geschrieben, W) ;
              FOR i := 0 TO 4 DO
                WriteBytes(Datei, ADR(Vok.Uebersetzung[i]), ZGroesse,
                           geschrieben) ;
                dummy := Fehler(Datei.res, ZGroesse, geschrieben, W) ;
              END ;  (* FOR i *)
              FOR mod := v TO ue DO
                WriteBytes(Datei, ADR(Vok.abgefragt[mod]), 2,
                           geschrieben);
                dummy := Fehler(Datei.res, 2, geschrieben, W) ;
                WriteBytes(Datei, ADR(Vok.gewusst[mod]), 2, geschrieben);
                dummy := Fehler(Datei.res, 2, geschrieben, W) ;
              END ;  (* FOR mod *)
              ok := Successor(Eintrag) ; INC(n);
            END ;  (* WHILE n *)
          END ;  (* FOR m *)
          WriteBytes(Datei, ADR(Kopf.Mod), MGroesse, geschrieben) ;
          dummy := Fehler(Datei.res, MGroesse, geschrieben, W) ;
          Close(Datei) ;
          RETURN TRUE ;
        END ;  (* IF Datei.res *)
      END ;  (* IF ok *)
      RETURN FALSE ;
  END Schreiben;


  PROCEDURE Ausgabe(VAR Kopf: VKopf; W: WindowPtr);
    VAR dummy       : BOOLEAN ;
        geschrieben : LONGINT ;
        ok          : BOOLEAN ;
        Eintrag     : EntryPtr ;
    BEGIN
      ok := TRUE ;
      DName := Kopf.Name ; DDir := Kopf.Dir ;
      IF (Kopf.Anzahl > 0) THEN
        IF Req(W, DName, DDir, sTitel) THEN
          Kopf.Name := DName ; Kopf.Dir := DDir ;
        ELSE
          ok := FALSE ;
        END ;  (* IF FileRequest *)
      END ;  (* IF neu *)
      IF (Kopf.Anzahl > 0) AND ok THEN
        IF (Length(DDir) > 0) AND (DDir[Length(DDir) - 1] # ":") THEN
          Insert(DName, 0, "/") ;
        END ;  (* IF (Length *)
        Insert(DName, 0, DDir) ;
        Lookup(Datei, DName, 2048, TRUE) ;
        IF Datei.res # done THEN
          req := AutoRequest(W, ADR(look), NIL, ADR(schade),
                             IDCMPFlagSet{}, IDCMPFlagSet{}, 350, 65);
        ELSE
          WriteBytes(Datei, ADR(VKenn), 8, geschrieben) ;
          dummy := Fehler(Datei.res, 8, geschrieben, W) ;
          FOR m := 0 TO 3 DO
            ok := TRUE ;
            laenge := EntriesInList(Kopf.Gruppe[m]) ;
            WriteBytes(Datei, ADR(laenge), 2, geschrieben) ;
            dummy := Fehler(Datei.res, 2, geschrieben, W) ;
            Eintrag := FirstEntry(Kopf.Gruppe[m]) ; n := 0 ;
            WHILE (n < laenge) AND ok DO
              ReadEntryC(Kopf.Gruppe[m], Eintrag, Vok) ;
              WriteBytes(Datei, ADR(Vok.Wort), ZGroesse, geschrieben);
              dummy := Fehler(Datei.res, ZGroesse, geschrieben, W) ;
              FOR i := 0 TO 4 DO
                WriteBytes(Datei, ADR(Vok.Uebersetzung[i]), ZGroesse,
                           geschrieben) ;
                dummy := Fehler(Datei.res, ZGroesse, geschrieben, W) ;
              END ;  (* FOR i *)
              FOR mod := v TO ue DO
                WriteBytes(Datei, ADR(null), 2, geschrieben) ;
                dummy := Fehler(Datei.res, 2, geschrieben, W) ;
                WriteBytes(Datei, ADR(null), 2, geschrieben) ;
                dummy := Fehler(Datei.res, 2, geschrieben, W) ;
              END ;  (* FOR mod *)
              ok := Successor(Eintrag) ; n := n + 1 ;
            END ;  (* WHILE n *)
          END ;  (* FOR m *)
          WriteBytes(Datei, ADR(Kopf.Mod), MGroesse, geschrieben) ;
          dummy := Fehler(Datei.res, MGroesse, geschrieben, W) ;
          Close(Datei) ;
        END ;  (* IF Datei.res *)
      END ;  (* IF ok *)
  END Ausgabe;


  BEGIN    (* VDisk *)
    VKenn := "VoDatNeu" ;
    ZGroesse := LONGINT(SIZE(Zeile)) ;
    MGroesse := LONGINT(SIZE(Modus)) ;
    WITH resp DO
      frontPen := 0 ; backPen := 1 ;
      leftEdge := 15 ; topEdge := 15 ; drawMode := jam1 ;
      iTextFont := ADR(attr);
      iText := ADR("Datei noch nicht gespeichert");
      nextText := NIL ;
    END ;  (* WITH *)
    WITH lang DO
      frontPen := 0 ; backPen := 1 ;
      leftEdge := 15 ; topEdge := 15 ; drawMode := jam1 ;
      iTextFont := ADR(attr);
      iText:= ADR("Anzahl der gelesenen/geschriebenen Bytes ist falsch");
      nextText := NIL ;
    END ;  (* WITH *)
    WITH modus DO
      frontPen := 0 ; backPen := 1 ;
      leftEdge := 15 ; topEdge := 15 ; drawMode := jam1 ;
      iTextFont := ADR(attr);
      iText := ADR("Modus konnte nicht gelesen werden");
      nextText := NIL ;
    END ;  (* WITH *)
    WITH look DO
      frontPen := 0 ; backPen := 1 ;
      leftEdge := 15 ; topEdge := 15 ; drawMode := jam1 ;
      iTextFont := ADR(attr);
      iText := ADR("Datei konnte nicht geffnet werden");
      nextText := NIL ;
    END ;  (* WITH *)
    WITH dateiformat DO
      frontPen := 0 ; backPen := 1 ;
      leftEdge := 15 ; topEdge := 15 ; drawMode := jam1 ;
      iTextFont := ADR(attr); iText := ADR("Falsches Dateiformat");
      nextText := NIL ;
    END ;  (* WITH *)
    WITH schade DO
      frontPen := 2 ; backPen := 3 ;
      leftEdge := 5 ; topEdge := 4 ; drawMode := jam1 ;
      iTextFont := ADR(attr); iText := ADR("Schade") ;
      nextText := NIL ;
    END ;  (* WITH *)
    lTitel := "Laden: Bitte Datei auswhlen";
    sTitel := "Speichern: Bitte Datei auswhlen";
    null := 0;

END VDisk.
