(**********************************************************************

    :Program.    VEdit.mod
    :Contents.   Procedure zum Editieren der Vokabeln fr das Programm
    :Contents.   VTrainer
    :Author.     Dieter WILHELM
    :Address.    Albert-Schweitzer-Str.44, 8000 Mnchen 83
    :Phone.      089/671693
    :Copyright.  PD
    :Language.   Modula-2
    :Translator. M2Amiga A+L V4.0d
    :Imports.    IntuiStruct1.3 [bne] Amok#3, Lists [bne] Amok#22,
    :Imports.    VEingabe
    :History.    V1.0 Dieter WILHELM 13.Jan.1991
    :History.    V1.1 Dieter WILHELM 29.Sept.1991

**********************************************************************)

IMPLEMENTATION MODULE VEdit ;


  FROM ExecL       IMPORT GetMsg, ReplyMsg, WaitPort;
  FROM GraphicsD   IMPORT jam1;
  FROM GraphicsL   IMPORT Move, RectFill, SetAPen, Text;
  FROM Heap        IMPORT AllocMem, Deallocate;
  FROM IntuiStruct IMPORT AllocProc, BorderEnd, DeallocProc, Rectangle,
                          StructBorder, StructGadget, StructString;
  FROM IntuitionD  IMPORT ActivationFlags, ActivationFlagSet, boolGadget,
                          Border, Gadget, GadgetFlags, GadgetFlagSet,
                          GadgetPtr, IDCMPFlags, IDCMPFlagSet,
                          IntuiMessagePtr, IntuiText, strGadget,
                          StringInfo, WindowPtr;
  FROM IntuitionL  IMPORT ActivateGadget, AddGList, DrawBorder,
                          ModifyIDCMP, OffGadget, OnGadget, RefreshGList,
                          RemoveGList;
  FROM Lists       IMPORT DeleteEntry, EntriesInList, EntryPtr,
                          LocateEntryAbs, ReadEntryC, ReplaceEntryC;
  FROM String      IMPORT Length;
  FROM SYSTEM      IMPORT ADR, LONGSET;
  FROM VEingabe    IMPORT Modus, VKopf, Vokabel, Zeile;


  TYPE Nr    = RECORD
                 G : CARDINAL ;
                 V : CARDINAL ;
               END ;  (* RECORD *)
       Daten = RECORD
                 Anzahl  : CARDINAL ;
                 Gesamt  : CARDINAL ;
                 Anz     : ARRAY [0..3] OF CARDINAL ;
                 Akt     : Nr ;
                 Ende    : BOOLEAN ;
               END ;  (* RECORD *)


  VAR i, max  : CARDINAL;
      Eintrag : EntryPtr;
      GadPos  : INTEGER;
      Vok     : Vokabel;
      Gad     : ARRAY [0..2] OF Gadget;
      VGad    : ARRAY [1..20] OF Gadget;
      GPtr    : GadgetPtr;
      GBorder : ARRAY [0..2] OF Border;
      SGad    : ARRAY [0..5] OF Gadget;
      Buffer  : ARRAY [0..5] OF Zeile;
      UBuffer : ARRAY [0..5] OF Zeile;
      SInfo   : ARRAY [0..5] OF StringInfo;
      SBorder : ARRAY [0..5] OF Border;
      Msg     : IntuiMessagePtr;
      class   : IDCMPFlagSet;
      code    : CARDINAL;
      Dat     : Daten;
      vorOk,
      rueckOk : BOOLEAN;


  PROCEDURE Seite(K: VKopf; W: WindowPtr) ;
    VAR max2 : CARDINAL ;
    BEGIN
      SetAPen(W^.rPort, 0) ; RectFill(W^.rPort, 1, 1, W^.width, 201);
      SetAPen(W^.rPort, 1) ;
      IF max > 10 THEN
        max2 := 10
      ELSE
        max2 := max ;
      END ;
      FOR i := 1 TO max2 DO
        WHILE (Dat.Anz[Dat.Akt.G] = 0) OR
        (Dat.Akt.V = Dat.Anz[Dat.Akt.G]) DO
          INC(Dat.Akt.G) ; Dat.Akt.V := 0 ;
        END ;  (* WHILE *)
        Eintrag := LocateEntryAbs(K.Gruppe[Dat.Akt.G], Dat.Akt.V);
        ReadEntryC(K.Gruppe[Dat.Akt.G], Eintrag, Vok) ;
        Move(W^.rPort, 50, 7 + i * 19) ;
        Text(W^.rPort, ADR(Vok.Wort), Length(Vok.Wort)) ;
        INC(Dat.Akt.V) ; INC(Dat.Gesamt) ;
      END ;  (* FOR *)
      FOR i := 11 TO max DO
        WHILE (Dat.Anz[Dat.Akt.G] = 0) OR
        (Dat.Akt.V = Dat.Anz[Dat.Akt.G]) DO
          INC(Dat.Akt.G) ; Dat.Akt.V := 0 ;
        END ;
        Eintrag := LocateEntryAbs(K.Gruppe[Dat.Akt.G], Dat.Akt.V);
        ReadEntryC(K.Gruppe[Dat.Akt.G], Eintrag, Vok) ;
        Move(W^.rPort, 395, 7 + (i - 10) * 19) ;
        Text(W^.rPort, ADR(Vok.Wort), Length(Vok.Wort)) ;
        INC(Dat.Akt.V) ; INC(Dat.Gesamt) ;
      END ;  (* FOR *)
      IF vorOk AND (Dat.Gesamt = Dat.Anzahl) THEN
        OffGadget(ADR(Gad[2]), W, NIL);
        vorOk := FALSE;
      ELSIF (NOT vorOk) AND (Dat.Anzahl - Dat.Gesamt > 0) THEN
        OnGadget(ADR(Gad[2]), W, NIL);
        vorOk := TRUE;
        SetAPen(W^.rPort, 0);
        RectFill(W^.rPort, 480, 212, 556, 223);
        SetAPen(W^.rPort, 3);
        Move(W^.rPort, 481, 220);
        Text(W^.rPort, ADR(" weiter"),  7);
      END;  (* IF vorOk *)
      IF rueckOk AND (Dat.Gesamt < 21) THEN
        OffGadget(ADR(Gad[1]), W, NIL);
        rueckOk := FALSE;
      ELSIF (NOT rueckOk) AND (Dat.Gesamt > 20) THEN
        OnGadget(ADR(Gad[1]), W, NIL);
        rueckOk := TRUE;
        SetAPen(W^.rPort, 0);
        RectFill(W^.rPort, 280, 212, 356, 223);
        SetAPen(W^.rPort, 3);
        Move(W^.rPort, 281, 220);
        Text(W^.rPort, ADR(" zurck"),  7);
      END;  (* IF rueckOk *)
  END Seite ;


  PROCEDURE Seite1(K: VKopf; W: WindowPtr) ;
    BEGIN
      WITH Dat DO
        Anzahl := K.Anzahl ; Gesamt := 0 ;
        Akt.G := 0 ; Akt.V := 0 ;
        Ende := FALSE ;
      END ;  (* WITH *)
      SetAPen(W^.rPort, 3);
      Move(W^.rPort, 81,  220) ; Text(W^.rPort, ADR(" Abbruch"), 8);
      Move(W^.rPort, 281, 220) ; Text(W^.rPort, ADR(" zurck"),  7);
      Move(W^.rPort, 481, 220) ; Text(W^.rPort, ADR(" weiter"),  7);
      Move(W^.rPort, 80,  235) ; Text(W^.rPort, ADR("   F1"),    5);
      Move(W^.rPort, 280, 235) ; Text(W^.rPort, ADR("   F5"),    5);
      Move(W^.rPort, 480, 235) ; Text(W^.rPort, ADR("   F10"),   6);
      IF Dat.Anzahl > 20 THEN
        max := 20 ;
      ELSIF Dat.Anzahl = 20 THEN
        Dat.Ende := TRUE; max := 20;
      ELSE
        max := Dat.Anzahl ; Dat.Ende := TRUE ;
        GadPos := RemoveGList(W, ADR(VGad[max+1]), 20 - max);
      END ;  (* IF Dat.Anzahl *)
      Seite(K, W) ;
  END Seite1 ;


  PROCEDURE Vor(K: VKopf; W: WindowPtr) ;
    BEGIN
      IF NOT Dat.Ende THEN
        IF (Dat.Anzahl - Dat.Gesamt) > 20 THEN
          max := 20;
        ELSIF (Dat.Anzahl - Dat.Gesamt) = 20 THEN
          Dat.Ende := TRUE;
        ELSE
          max := Dat.Anzahl - Dat.Gesamt ; Dat.Ende := TRUE ;
          GadPos := RemoveGList(W, ADR(VGad[max+1]), 20 - max);
        END ;  (* IF Dat.Anzahl *)
        Seite(K, W) ;
      END;  (* IF NOT *)
  END Vor ;


  PROCEDURE Zurueck(K: VKopf; W: WindowPtr) ;
    BEGIN
      IF Dat.Gesamt > 20 THEN
        Dat.Gesamt := Dat.Gesamt - (20 + max) ; Dat.Ende := FALSE ;
        IF max < 20 THEN
          GadPos := AddGList(W, ADR(VGad[max + 1]), -1, 20 - max, NIL);
        END ;  (* IF max *)
        FOR i := 1 TO 20 + max DO
          IF Dat.Akt.V > 0 THEN
            DEC(Dat.Akt.V) ;
          ELSE
            REPEAT
              DEC(Dat.Akt.G) ;
            UNTIL Dat.Anz[Dat.Akt.G] > 0 ;
            Dat.Akt.V := Dat.Anz[Dat.Akt.G] - 1 ;
          END ;  (* IF Dat.Akt.V *)
        END ;  (* FOR *)
        max := 20;
        Seite(K, W);
      END;  (* IF Dat.Gesamt > *)
  END Zurueck ;


  PROCEDURE Edit(VAR K: VKopf; W: WindowPtr; g, n: CARDINAL): BOOLEAN;
    VAR k          : CARDINAL ;
        geloescht,
        anders,
        aktiv      : BOOLEAN ;
    BEGIN
      IF NOT vorOk THEN
        OnGadget(ADR(Gad[2]), W, NIL);
      END;  (* IF NOT *)
      IF NOT rueckOk THEN
        OnGadget(ADR(Gad[1]), W, NIL);
      END;  (* IF NOT *)
      geloescht := FALSE ; anders := FALSE;
      SetAPen(W^.rPort, 0);
      RectFill(W^.rPort, 0, 15, W^.width, W^.height);
      SetAPen(W^.rPort, 3) ;
      Move(W^.rPort, 81,  220) ; Text(W^.rPort, ADR(" Abbruch"), 8);
      Move(W^.rPort, 281, 220) ; Text(W^.rPort, ADR(" lschen"), 8);
      Move(W^.rPort, 481, 220) ; Text(W^.rPort, ADR(" ndern"),  7);
      Move(W^.rPort, 80,  235) ; Text(W^.rPort, ADR("   F1"),    5);
      Move(W^.rPort, 280, 235) ; Text(W^.rPort, ADR("   F5"),    5);
      Move(W^.rPort, 480, 235) ; Text(W^.rPort, ADR("   F10"),   6);
      RefreshGList(ADR(Gad[0]), W, NIL, 3) ;
      Eintrag := LocateEntryAbs(K.Gruppe[g], n) ;
      ReadEntryC(K.Gruppe[g], Eintrag, Vok) ;
      GadPos := AddGList(W, ADR(SGad[0]), -1, 6, NIL) ;
      WITH Vok DO
        FOR i := 0 TO 23 DO
          Buffer[0,i] := Wort[i] ;
        END ;  (* FOR *)
        FOR i := 0 TO 4 DO
          FOR k := 0 TO 23 DO
            Buffer[i +1,k] := Uebersetzung[i,k] ;
          END ;  (* FOR k *)
        END ;  (* FOR i *)
      END ;  (* WITH *)
      RefreshGList(ADR(SGad[0]), W, NIL, 6) ;
      aktiv := ActivateGadget(ADR(SGad[0]), W, NIL);
      LOOP
        WaitPort(W^.userPort) ;
        Msg := GetMsg(W^.userPort) ;
        WHILE Msg # NIL DO
          class := Msg^.class ;
          GPtr  := Msg^.iAddress ;
          code  := Msg^.code ;
          ReplyMsg(Msg) ;
          IF rawKey IN class THEN
            IF code = 89 THEN
              WITH Vok DO
                FOR k := 0 TO 23 DO
                  Wort[k] := Buffer[0,k] ;
                END ;  (* FOR *)
                FOR i := 0 TO 4 DO
                  FOR k := 0 TO 23 DO
                    Uebersetzung[i,k] := Buffer[i +1,k] ;
                  END ;  (* FOR k *)
                END ;  (* FOR i *)
              END ;  (* WITH *)
              ReplaceEntryC(K.Gruppe[g], Eintrag, Vok) ;
              anders := TRUE ;
              EXIT ;                              (* Vokabel gendert *)
            ELSIF code = 84 THEN
              DeleteEntry(K.Gruppe[g], Eintrag) ;
              DEC(K.Anzahl) ; DEC(Dat.Anz[g]) ;
              DEC(K.gefragtV, Vok.abgefragt[v]) ;
              DEC(K.gewusstV, Vok.gewusst[v]) ;
              DEC(K.gefragtU, Vok.abgefragt[ue]) ;
              DEC(K.gewusstU, Vok.gewusst[ue]) ;
              geloescht := TRUE ;
              EXIT ;                              (* Vokabel gelscht *)
            ELSIF code = 80 THEN
              EXIT ;
            END ;  (* IF code *)
          END ;  (* IF rawKey *)
          IF gadgetUp IN class THEN
            CASE GPtr^.gadgetID OF
              50 : aktiv := ActivateGadget(ADR(SGad[1]), W, NIL)|
              51 : aktiv := ActivateGadget(ADR(SGad[2]), W, NIL)|
              52 : aktiv := ActivateGadget(ADR(SGad[3]), W, NIL)|
              53 : aktiv := ActivateGadget(ADR(SGad[4]), W, NIL)|
              54 : aktiv := ActivateGadget(ADR(SGad[5]), W, NIL)|
              21 : EXIT |
              22 : DeleteEntry(K.Gruppe[g], Eintrag) ;
                   DEC(K.Anzahl) ; DEC(Dat.Anz[g]) ;
                   DEC(K.gefragtV, Vok.abgefragt[v]) ;
                   DEC(K.gewusstV, Vok.gewusst[v]) ;
                   DEC(K.gefragtU, Vok.abgefragt[ue]) ;
                   DEC(K.gewusstU, Vok.gewusst[ue]) ;
                   geloescht := TRUE ;
                   EXIT |                         (* Vokabel gelscht *)
              23 : WITH Vok DO
                     FOR k := 0 TO 23 DO
                       Wort[k] := Buffer[0,k] ;
                     END ;  (* FOR *)
                     FOR i := 0 TO 4 DO
                       FOR k := 0 TO 23 DO
                         Uebersetzung[i,k] := Buffer[i +1,k] ;
                       END ;  (* FOR k *)
                     END ;  (* FOR i *)
                   END ;  (* WITH *)
                   ReplaceEntryC(K.Gruppe[g], Eintrag, Vok) ;
                   anders := TRUE ;
                   EXIT|                           (* Vokabel gendert *)
              ELSE;
            END ;  (* CASE *)
          END ;  (* IF *)
          Msg := GetMsg(W^.userPort) ;
        END ;  (* WHILE *)
      END ;  (* LOOP *)
      GadPos := RemoveGList(W, ADR(SGad[0]), 6) ;
      SetAPen(W^.rPort, 0) ; RectFill(W^.rPort, 10, 10, W^.width,
              W^.height);
      SetAPen(W^.rPort, 3) ;
      Move(W^.rPort, 81,  220) ; Text(W^.rPort, ADR(" Abbruch"), 8);
      Move(W^.rPort, 281, 220) ; Text(W^.rPort, ADR(" zurck"),  7);
      Move(W^.rPort, 481, 220) ; Text(W^.rPort, ADR(" weiter"),  7);
      Move(W^.rPort, 80,  235) ; Text(W^.rPort, ADR("   F1"),    5);
      Move(W^.rPort, 280, 235) ; Text(W^.rPort, ADR("   F5"),    5);
      Move(W^.rPort, 480, 235) ; Text(W^.rPort, ADR("   F10"),   6);
      IF geloescht THEN
        GadPos := AddGList(W, ADR(VGad[1]), -1, 20, NIL);
        vorOk := TRUE; rueckOk := TRUE;
        Seite1(K, W);
        RETURN TRUE ;
      ELSE
        Dat.Gesamt := Dat.Gesamt - max ;
        GadPos := AddGList(W, ADR(VGad[1]), -1, max, NIL) ;
        FOR i := 1 TO max DO
          IF Dat.Akt.V > 0 THEN
            DEC(Dat.Akt.V) ;
          ELSE
            REPEAT
              DEC(Dat.Akt.G) ;
            UNTIL Dat.Anz[Dat.Akt.G] > 0 ;
            Dat.Akt.V := Dat.Anz[Dat.Akt.G] - 1 ;
          END ;  (* IF Dat.Akt.V *)
        END ;  (* FOR *)
        IF NOT vorOk THEN
          OffGadget(ADR(Gad[2]), W, NIL);
        END;  (* IF NOT *)
        IF NOT rueckOk THEN
          OffGadget(ADR(Gad[1]), W, NIL);
        END;  (* IF NOT *)
        Seite(K, W) ;
      END ;  (* IF *)
      RETURN anders;
  END Edit ;


  PROCEDURE Num(VAR g, v: CARDINAL; minus: CARDINAL) ;
    BEGIN
      v := Dat.Akt.V ; g := Dat.Akt.G ;
      FOR i := 1 TO  (1 + minus) DO
        IF v > 0 THEN
          DEC(v) ;
        ELSE
          REPEAT
            DEC(g) ;
          UNTIL Dat.Anz[g] > 0 ;
          v := Dat.Anz[g] - 1 ;
        END ;  (* IF v *)
      END ;  (* FOR *)
  END Num ;


  PROCEDURE Ed(W: WindowPtr; VAR K: VKopf): BOOLEAN ;
    VAR ed   : BOOLEAN ;
        g, v : CARDINAL ;
    BEGIN
      ed := FALSE; vorOk := TRUE; rueckOk := TRUE;
      SetAPen(W^.rPort, 0) ; RectFill(W^.rPort, 0, 0, W^.width,
              W^.height);
      FOR i := 0 TO 3 DO
        Dat.Anz[i] := INTEGER(EntriesInList(K.Gruppe[i])) ;
      END ;  (* FOR *)
      INCL(W^.idcmpFlags, gadgetUp) ;
      INCL(W^.idcmpFlags, rawKey) ;
      ModifyIDCMP(W, W^.idcmpFlags) ;
      GadPos := AddGList(W, ADR(Gad[0]), -1, 23, NIL) ;
      RefreshGList(ADR(Gad[0]), W, NIL, 3);
      Seite1(K, W) ;
      LOOP
        WaitPort(W^.userPort) ;
        Msg := GetMsg(W^.userPort) ;
        WHILE Msg # NIL DO
          class := Msg^.class ;
          GPtr := Msg^.iAddress ;
          code := Msg^.code ;
          ReplyMsg(Msg) ;
          IF rawKey IN class THEN
            IF (code = 89) AND vorOk THEN
              Vor(K, W) ;
            ELSIF (code = 84) AND rueckOk THEN
              Zurueck(K, W) ;
            ELSIF code = 80 THEN
              IF NOT vorOk THEN
                OnGadget(ADR(Gad[2]), W, NIL);
                vorOk := TRUE;
              END;  (* IF NOT *)
              IF NOT rueckOk THEN
                OnGadget(ADR(Gad[1]), W, NIL);
              END;  (* IF NOT *)
              EXIT ;
            END ;  (* IF code *)
          END ;  (* IF rawKey *)
          IF gadgetUp IN class THEN
            CASE GPtr^.gadgetID OF
              1..20 : Num(g, v, max - CARDINAL(GPtr^.gadgetID)) ;
                      IF max < 20 THEN
                        GadPos := AddGList(W, ADR(VGad[max + 1]), -1,
                                           20 - max, NIL) ;
                      END ;  (* IF max *)
                      GadPos := RemoveGList(W, ADR(VGad[1]), 20) ;
                      IF Edit(K, W, g, v) THEN
                        ed := TRUE ;
                      END ;  (* IF Edit *)
                      RefreshGList(ADR(Gad[0]), W, NIL, 3) |
              21    : IF NOT vorOk THEN
                        OnGadget(ADR(Gad[2]), W, NIL);
                        vorOk := TRUE;
                      END;  (* IF NOT *)
                      IF NOT rueckOk THEN
                        OnGadget(ADR(Gad[1]), W, NIL);
                      END;  (* IF NOT *)
                      EXIT |
              22    : Zurueck(K, W) |
              23    : Vor(K, W)|
              ELSE;
            END ;  (* CASE *)
          END ;  (* IF *)
          Msg := GetMsg(W^.userPort) ;
        END ;  (* WHILE *)
      END ;  (* LOOP *)
      IF max < 20 THEN
        GadPos := AddGList(W, ADR(VGad[max + 1]), -1, 20 - max, NIL);
      END ;  (* IF *)
      GadPos := RemoveGList(W, ADR(Gad[0]), 23) ;
      EXCL(W^.idcmpFlags, gadgetUp) ;
      EXCL(W^.idcmpFlags, rawKey) ;
      ModifyIDCMP(W, W^.idcmpFlags) ;
      SetAPen(W^.rPort, 0) ;
      RectFill(W^.rPort, 10, 15, W^.width, W^.height) ;
      RETURN ed ;
  END Ed ;


  BEGIN
    AllocProc := AllocMem ; DeallocProc := Deallocate;
    FOR i := 0 TO 2 DO
      StructBorder(GBorder[i], -2, -2, 3, jam1, 4, NIL) ;
      Rectangle(80, 15) ;
      BorderEnd ;
      StructGadget(Gad[i], 80 + 200 * i, 212, 76, 11, GadgetFlagSet{},
                   ActivationFlagSet{gadgImmediate, relVerify},
                   boolGadget, ADR(GBorder[i]), NIL, LONGSET{}, 21 + i,
                   NIL);
    END ;  (* FOR *)
    Gad[0].nextGadget := ADR(Gad[1]) ;
    Gad[1].nextGadget := ADR(Gad[2]) ;
    FOR i := 1 TO 10 DO
      StructGadget(VGad[i], 47, i * 19, 200, 12, GadgetFlagSet{},
                   ActivationFlagSet{gadgImmediate, relVerify},
                   boolGadget, NIL, NIL, LONGSET{}, i, NIL);
    END ;  (* FOR *)
    FOR i := 1 TO 10 DO
      StructGadget(VGad[10 + i], 392, i * 19, 200, 12, GadgetFlagSet{},
                   ActivationFlagSet{gadgImmediate, relVerify},
                   boolGadget, NIL, NIL, LONGSET{}, 10 + i, NIL);
    END ;  (* FOR *)
    FOR i := 1 TO 19 DO
      VGad[i].nextGadget := ADR(VGad[i + 1]) ;
    END ;
    Gad[2].nextGadget := ADR(VGad[1]) ;
    StructString(SInfo[0], Buffer[0], UBuffer[0]) ;
    StructBorder(SBorder[0], -2, -2, 1, jam1, 4, NIL) ;
    Rectangle(205, 15) ;
    BorderEnd ;
    StructGadget(SGad[0], 105, 80, 200, 10, GadgetFlagSet{},
                 ActivationFlagSet{stringCenter, relVerify}, strGadget,
                 ADR(SBorder[0]), NIL, LONGSET{}, 50, ADR(SGad[1])) ;
    SGad[0].specialInfo := ADR(SInfo[0]) ;
    FOR i := 1 TO 5 DO
      StructString(SInfo[i], Buffer[i], UBuffer[i]) ;
      StructBorder(SBorder[i], -2, -2, 1, jam1, 4, NIL) ;
      Rectangle(205, 15) ;
      BorderEnd ;
      StructGadget(SGad[i], 337, 60 + 20 * i, 200, 10, GadgetFlagSet{},
                   ActivationFlagSet{stringCenter, relVerify}, strGadget,
                   ADR(SBorder[i]), NIL, LONGSET{}, 50 + i, NIL) ;
      SGad[i].specialInfo := ADR(SInfo[i]) ;
    END ;  (* FOR *)
    FOR i := 1 TO 4 DO
      SGad[i].nextGadget := ADR(SGad[i + 1]) ;
    END ;  (* FOR *)


END VEdit.
