(**********************************************************************

    :Program.    VMenu.mod
    :Contents.   Procedures zum ffen und Schlieen des Fensters (mit
    :Contents.   Mens) fr das Programm VTrainer
    :Author.     Dieter WILHELM
    :Address.    Albert-Schweitzer-Str.44, 8000 Mnchen 83
    :Phone.      089/671693
    :Copyright.  PD
    :Language.   Modula-2
    :Translator. M2Amiga A+L V4.0d
    :Imports.    IntuiStruct1.3 [bne] Amok#3
    :History.    V1.0 Dieter WILHELM 13.Jan.1991
    :History.    V1.1 Dieter WILHELM 29.Sept.1991

**********************************************************************)

IMPLEMENTATION MODULE VMenue ;


  FROM Arts        IMPORT Assert;
  FROM ASCII       IMPORT nul;
  FROM ExecL       IMPORT GetMsg, ReplyMsg, WaitPort;
  FROM GraphicsD   IMPORT FontFlags, FontFlagSet, FontStyleSet, jam1,
                          TextFontPtr, ViewModes, ViewModeSet;
  FROM GraphicsL   IMPORT CloseFont, OpenFont, SetFont;
  FROM Heap        IMPORT AllocMem, Deallocate;
  FROM IntuiStruct IMPORT AllocProc, DeallocProc, Item, LinkMenu,
                          StructScreen, StructWindow, SubItem;
  FROM IntuitionD  IMPORT customScreen, IDCMPFlags, IDCMPFlagSet,
                          IntuiText, MenuItemFlags, MenuItemFlagSet,
                          MenuPtr, NewScreen, NewWindow, ScreenFlags,
                          ScreenFlagSet, ScreenPtr, WindowFlags,
                          WindowFlagSet, WindowPtr;
  FROM IntuitionL  IMPORT AutoRequest, ClearMenuStrip, CloseScreen,
                          CloseWindow, OpenScreen, OpenWindow,
                          SetMenuStrip;
  FROM SYSTEM      IMPORT LONGSET, ADR;


  CONST screenTitel = "  VokabelTrainer V1.1 ";


  VAR  Scr    : NewScreen;
       SPtr   : ScreenPtr;
       Win    : NewWindow;
       WPtr   : WindowPtr;
       MPtr   : MenuPtr;
       fPtr   : TextFontPtr;
       menu,
       ende   : IntuiText;
       fehler : BOOLEAN;


  PROCEDURE Window(): WindowPtr ;
    BEGIN
      INCL(Scr.type, showTitle);
      SPtr := OpenScreen(Scr);
      Assert(SPtr # NIL, ADR("Screen konnte nicht geffnet werden"));
      Win.screen := SPtr;
      Win.height := SPtr^.height;
      Win.width := SPtr^.width;
      WPtr := OpenWindow(Win) ;
      Assert(WPtr # NIL, ADR("Window konnte nicht geffnet werden")) ;
      IF NOT SetMenuStrip(WPtr, MPtr) THEN
        fehler := AutoRequest(WPtr, ADR(menu), NIL, ADR(ende),
                              IDCMPFlagSet{}, IDCMPFlagSet{}, 350, 65);
        HALT ;
      END ;  (* IF *)
      SetFont(WPtr^.rPort, fPtr);
      RETURN WPtr ;
  END Window ;


  BEGIN
    AllocProc := AllocMem ; DeallocProc := Deallocate ;
    SPtr := NIL; WPtr := NIL ; MPtr := NIL; fPtr := NIL;
    StructScreen(Scr, 2, 2, 1, ViewModeSet{hires}, customScreen,
                 ADR(screenTitel));
    WITH attr DO
      name := ADR("topaz.font"); ySize := 8;
      style := FontStyleSet{}; flags := FontFlagSet{romFont};
    END;  (* WITH *)
    fPtr := OpenFont(ADR(attr));
    Assert(fPtr # NIL, ADR("Kein Topaz-8 vorhanden"));
    Scr.font := ADR(attr);
    StructWindow(Win, 0, 0, 640, 245, 2, 1, IDCMPFlagSet{menuPick},
                 WindowFlagSet{backDrop, borderless, activate}, NIL, NIL,
                 customScreen);
    Item(ADR(" datei Ausgeben"), 170, MenuItemFlagSet{highComp, itemText,
          commSeq, itemEnabled}, LONGSET{}, "A") ;
    Assert(LinkMenu(MPtr, ADR("Ausgabe"), 275, 120, TRUE),
         ADR("Men konnte nicht erstellt werden")) ;
    Item(ADR("sTatistik"), 120, MenuItemFlagSet{highComp, itemText,
         commSeq, itemEnabled}, LONGSET{}, "T") ;
    Item(ADR("eDitieren"), 120, MenuItemFlagSet{highComp, itemText,
         commSeq, itemEnabled}, LONGSET{}, "D") ;
    Item(ADR("anZeige"), 120, MenuItemFlagSet{highComp, itemText,
         commSeq, itemEnabled}, LONGSET{}, "Z") ;
    SubItem(ADR("   Neu"), 115, 115, MenuItemFlagSet{highComp, itemText,
            commSeq, itemEnabled}, LONGSET{}, "N") ;
    SubItem(ADR("Erweitern"), 115, 115, MenuItemFlagSet{highComp,
            itemText, commSeq, itemEnabled}, LONGSET{}, "E") ;
    Item(ADR("Eingabe  >>>"), 120, MenuItemFlagSet{highComp, itemText,
         itemEnabled}, LONGSET{}, nul) ;
    SubItem(ADR("bersetzung -> Vokabel"), 115, 220, MenuItemFlagSet{
            highComp, itemText, commSeq, itemEnabled}, LONGSET{}, "U");
    SubItem(ADR("Vokabel -> bersetzung"), 115, 220, MenuItemFlagSet{
            highComp, itemText, commSeq, itemEnabled}, LONGSET{}, "V");
    Item(ADR("Abfrage  >>>"), 120, MenuItemFlagSet{highComp, itemText,
             itemEnabled}, LONGSET{}, nul) ;
    Assert(LinkMenu(MPtr, ADR("  Datei"), 155, 110, TRUE),
           ADR("Men konnte nicht erstellt werden")) ;
    Item(ADR("ENDE"), 150, MenuItemFlagSet{highComp, itemText, commSeq,
         itemEnabled}, LONGSET{}, "Q") ;
    Item(ADR("Info"), 150, MenuItemFlagSet{highComp, itemText, commSeq,
         itemEnabled}, LONGSET{}, "I") ;
    Item(ADR("Hilfe"), 150, MenuItemFlagSet{highComp, itemText, commSeq,
         itemEnabled}, LONGSET{}, "H") ;
    Item(ADR("Speichern"), 150, MenuItemFlagSet{highComp, itemText,
         commSeq, itemEnabled}, LONGSET{}, "S") ;
    Item(ADR("sPeichern als"), 150, MenuItemFlagSet{highComp, itemText,
         commSeq, itemEnabled}, LONGSET{}, "P") ;
    Item(ADR("Laden"), 150, MenuItemFlagSet{highComp, itemText, commSeq,
         itemEnabled}, LONGSET{}, "L") ;
    Assert(LinkMenu(MPtr, ADR("Projekt"), 0, 140, TRUE),
           ADR("Men konnte nicht erstellt werden")) ;
    WITH menu DO
      frontPen := 0 ; backPen := 1 ;
      leftEdge := 15 ; topEdge := 15 ; drawMode := jam1 ;
      iTextFont := ADR(attr) ;
      iText := ADR("Men konnte nicht angebracht werden");
      nextText := NIL ;
    END ;  (* WITH *)
    WITH ende DO
      frontPen := 2 ; backPen := 3 ;
      leftEdge := 5 ; topEdge := 4 ; drawMode := jam1 ;
      iTextFont := ADR(attr) ; iText := ADR("ENDE") ;
      nextText := NIL ;
    END ;  (* WITH *)

  CLOSE
    IF MPtr # NIL THEN
      ClearMenuStrip(WPtr);
      MPtr := NIL;
    END ;  (* IF *)
    IF WPtr # NIL THEN
      CloseWindow(WPtr);
      WPtr := NIL;
    END ;  (* IF *)
    IF SPtr # NIL THEN
      CloseScreen(SPtr);
      SPtr := NIL;
    END;  (* IF *)
    IF fPtr # NIL THEN
      CloseFont(fPtr);
      fPtr := NIL;
    END;  (* IF *)

END VMenue.
