(**********************************************************************

    :Program.    VStat.mod
    :Contents.   Procedure, die die Statistik einer Vokabeldatei fr das
    :Contents.   Programm VTrainer anzeigt
    :Author.     Dieter WILHELM
    :Address.    Albert-Schweitzer-Str.44, 8000 Mnchen 83
    :Phone.      089/671693
    :Copyright.  PD
    :Language.   Modula-2
    :Translator. M2Amiga A+L V4.0d
    :Imports.    VEingabe
    :History.    V1.0 Dieter WILHELM 13.Jan.1991
    :History.    V1.1 Dieter WILHELM 29.Sept.1991

**********************************************************************)

IMPLEMENTATION MODULE VStat ;


  FROM Conversions IMPORT ValToStr;
  FROM GraphicsL   IMPORT Draw, Move, RectFill, SetAPen, Text;
  FROM IntuitionD  IMPORT WindowPtr;
  FROM String      IMPORT Length;
  FROM SYSTEM      IMPORT ADR;
  FROM VEingabe    IMPORT VKopf;


  VAR Zahl       : ARRAY [0..4] OF CHAR ;
      gefr, gew  : LONGCARD;
      Note       : CARDINAL;
      bruch      : REAL;
      lang       : INTEGER;
      fehler     : BOOLEAN ;


  PROCEDURE Stat(W: WindowPtr; K: VKopf) ;
    BEGIN
      gew := K.gewusstV + K.gewusstU ;
      gefr := K.gefragtV + K.gefragtU ;
      IF gefr # 0 THEN
        CASE ((100 * gew) / gefr) OF
            0..29 : Note := 6 |
           30..44 : Note := 5 |
           45..59 : Note := 4 |
           60..74 : Note := 3 |
           75..89 : Note := 2 |
          99..100 : Note := 1 |
        END ;  (* CASE *)
      END ;  (* IF *)
      SetAPen(W^.rPort, 0);
      RectFill(W^.rPort, 0, 15, W^.width, W^.height);
      SetAPen(W^.rPort, 1) ;
      Move(W^.rPort, 80, 25) ; Text(W^.rPort, ADR("NAME             :"),
           18);
      Move(W^.rPort, 80, 47) ; Text(W^.rPort, ADR("Note             :"),
           18);
      Move(W^.rPort, 80, 62) ; Text(W^.rPort, ADR("Zahl d. Vokabeln :"),
           18);
      Move(W^.rPort, 80, 77) ; Text(W^.rPort, ADR("abgefragt        :"),
           18);
      Move(W^.rPort, 80, 92) ; Text(W^.rPort, ADR("gewusst          :"),
           18);
      Move(W^.rPort, 119, 106) ;
      Draw(W^.rPort, 521, 106) ; Draw(W^.rPort, 521, 123) ;
      Draw(W^.rPort, 119, 123) ; Draw(W^.rPort, 119, 106) ;
      Move(W^.rPort, 150, 152) ;
      Text(W^.rPort, ADR("Vokabel --> bersetzung"), 23) ;
      Move(W^.rPort, 80, 167) ; Text(W^.rPort, ADR("abgefragt        :"),
           18);
      Move(W^.rPort, 80, 180) ; Text(W^.rPort, ADR("gewut           :"),
           18);
      Move(W^.rPort, 329, 165) ;
      Draw(W^.rPort, 481, 165) ; Draw(W^.rPort, 481, 177) ;
      Draw(W^.rPort, 329, 177) ; Draw(W^.rPort, 329, 165) ;
      Move(W^.rPort, 150, 198) ;
      Text(W^.rPort, ADR("bersetzung --> Vokabel"), 23) ;
      Move(W^.rPort, 80, 213) ; Text(W^.rPort, ADR("abgefragt        :"),
           18);
      Move(W^.rPort, 80, 226) ; Text(W^.rPort, ADR("gewut           :"),
           18);
      Move(W^.rPort, 329, 211) ;
      Draw(W^.rPort, 481, 211) ; Draw(W^.rPort, 481, 223) ;
      Draw(W^.rPort, 329, 223) ; Draw(W^.rPort, 329, 211) ;
      SetAPen(W^.rPort, 3) ;
      Move(W^.rPort, 245, 25) ; Text(W^.rPort, ADR(K.Name),
           Length(K.Name));
      IF gefr # 0 THEN
        ValToStr(LONGINT(Note), FALSE, Zahl, 10, 4, " ", fehler);
        Move(W^.rPort, 245, 47) ; Text(W^.rPort, ADR(Zahl), 4) ;
      END ;  (* IF *)
      ValToStr(LONGINT(K.Anzahl), FALSE, Zahl, 10, 4, " ", fehler);
      Move(W^.rPort, 245, 62) ; Text(W^.rPort, ADR(Zahl), 4) ;
      ValToStr(LONGINT(gefr), FALSE, Zahl, 10, 4, " ", fehler) ;
      Move(W^.rPort, 245, 77) ; Text(W^.rPort, ADR(Zahl), 4) ;
      ValToStr(LONGINT(gew), FALSE, Zahl, 10, 4, " ", fehler) ;
      Move(W^.rPort, 245, 92) ; Text(W^.rPort, ADR(Zahl), 4) ;
      ValToStr(LONGINT(K.gefragtV), FALSE, Zahl, 10, 4, " ", fehler);
      Move(W^.rPort, 245, 167) ; Text(W^.rPort, ADR(Zahl), 4) ;
      ValToStr(LONGINT(K.gewusstV), FALSE, Zahl, 10, 4, " ", fehler);
      Move(W^.rPort, 245, 180) ; Text(W^.rPort, ADR(Zahl), 4) ;
      ValToStr(LONGINT(K.gefragtU), FALSE, Zahl, 10, 4, " ", fehler);
      Move(W^.rPort, 245, 213) ; Text(W^.rPort, ADR(Zahl), 4) ;
      ValToStr(LONGINT(K.gewusstU), FALSE, Zahl, 10, 4, " ", fehler);
      Move(W^.rPort, 245, 226) ; Text(W^.rPort, ADR(Zahl), 4) ;
      IF gefr # 0 THEN
        bruch := REAL(gew) / REAL(gefr);
        lang := 120 + INTEGER(400.0 * bruch);
        RectFill(W^.rPort, 120, 107, lang, 122);
      END ;  (* IF *)
      IF K.gefragtV # 0 THEN
        bruch := REAL(K.gewusstV) / REAL(K.gefragtV);
        lang := 330 + INTEGER(150.0 * bruch);
        RectFill(W^.rPort, 330, 166, lang, 176);
      END ;  (* IF *)
      IF K.gefragtU # 0 THEN
        bruch := REAL(K.gewusstU) / REAL(K.gefragtU);
        lang := 330 + INTEGER(150.0 * bruch);
        RectFill(W^.rPort, 330, 212, lang, 222);
      END ;  (* IF *)
  END Stat ;


END VStat.
