(*------------------------------------------------------------------------------
     :Program.    VectorFont.mod
     :Contents.   untersttzt Ausgabe von skalierbarem Font
     :Author.     Matthias Scherrer
     :Address.    Baselstrasse 63, CH-4242 Laufen
     :Phone.      ++(0)61/893975
     :Copyright.  FreeWare,(c) by Matthias Scherrer
     :Language.   Oberon
     :Translator. Oberon V2.13d
     :Supports.   Procedure Length von Fridtjof Siebert
     :Supports.   Zeichensatz-Definitionen (in etwa) vom ascii.fnt von ????
     :History.    V1.0,10-Apr-92
     :Bugs.       not tested  (bis jetzt noch keine gefunden)
------------------------------------------------------------------------------*)
MODULE VectorFont;

IMPORT sys : SYSTEM,
       G   : Graphics;

CONST
     length = 1746;

TYPE 
     datArr  = ARRAY length OF SHORTINT;

CONST
     width*  = 13;
     height* = 21;

     (* Datas fuer die Zeichen, von ASCII 33 bis 127:               *)
     (* Syntax: 64, Anzahl Linien fuer Linienzug, x/y-Koordinaten,  *)
     (* Anzahl linien fuer Linienzug, Koordinaten, ....             *)
     (* p.s.: 1 Linie: 2 Koordinaten; 2 Linien: 3 Koordinaten etc...*)
     datas = datArr(
       64,1,6,3,6,0, 1,6,9,6,21,                             (* 33 '!' *)
       64,1,3,15,3,21, 1,9,21,9,15,                          (* 34 '"' *)      
       64,1,3,0,3,18, 1,9,18,9,0, 1,12,6,0,6, 1,0,12,12,12,  (* 35 '#' *)    
       64,8,0,3,9,3,12,6,12,9,9,12,3,12,0,15,3,18,12,18,     (* 36 'S' *)
          1,6,21,6,0,
       64,6,3,15,0,15,0,12,3,12,3,15,12,21,0,0,              (* 37 '%' *)
          4,9,6,12,6,12,9,9,9,9,6,
       64,11,12,6,9,0,3,0,0,3,0,6,9,15,9,18,6,21,3,21,0,18,  (* 38 '&' *)
          0,15,12,0, 
       64,1,6,21,6,15,                                       (* 39 ''' *)
       64,5,9,21,6,18,3,12,3,9,6,3,9,0,                      (* 40 '(' *)
       64,5,3,21,6,18,9,12,9,9,6,3,3,0,                      (* 41 ')' *)
       64,1,6,3,6,15, 1,0,9,12,9, 1,12,15,0,3, 1,0,15,12,3,  (* 42 '*' *)
       64,1,6,3,6,15, 1,0,9,12,9,                            (* 43 '+' *)
       64,5,7,3,4,3,4,6,7,6,7,3,4,0,                         (* 44 ',' *)
       64,1,0,9,12,9,                                        (* 45 '-' *)
       64,4,4,3,4,0,7,0,7,3,4,3,                             (* 46 '.' *)
       64,1,0,0,12,21,                                       (* 47 '/' *)
       64,8,12,3,12,18,9,21,3,21,0,18,0,3,3,0,9,0,12,3,      (* 48 '0' *)
          1,10,20,2,1,
       64,2,3,18,6,21,6,0, 1,3,0,9,0,                        (* 49 '1' *)
       64,7,0,18,3,21,9,21,12,18,12,12,0,3,0,0,12,0,         (* 50 '2' *)
       64,6,0,3,3,0,9,0,12,3,12,9,9,12,3,12,                 (* 51 '3' *)
          5,9,12,12,15,12,18,9,21,3,21,0,18,
       64,3,9,0,9,21,0,6,12,6,                               (* 52 '4' *)
       64,8,0,3,3,0,9,0,12,3,12,9,9,12,0,12,0,21,12,21,      (* 53 '5' *)
       64,11,0,9,3,12,9,12,12,9,12,3,9,0,3,0,0,3,0,18,3,21,  (* 54 '6' *)
          9,21,12,18,
       64,4,0,21,12,21,12,18,6,3,6,0,                        (* 55 '7' *)
       64,15,3,12,0,15,0,18,3,21,9,21,12,18,12,15,9,12,      (* 56 '8' *)
          3,12,0,9,0,3,3,0,9,0,12,3,12,9,9,12,
       64,11,0,3,3,0,9,0,12,3,12,18,9,21,3,21,0,18,0,12,3,9, (* 57 '9' *)
          9,9,12,12,
       64,4,7,12,4,12,4,15,7,15,7,12, 4,7,3,4,3,4,6,7,6,7,3, (* 58 ':' *)
       64,4,7,12,4,12,4,15,7,15,7,12, 5,7,3,4,3,4,6,7,6,     (* 59 ';' *)
          7,3,4,0,
       64,2,12,6,0,12,12,18,                                 (* 60 '<' *)
       64,1,0,15,12,15, 1,12,6,0,6,                          (* 61 '=' *)
       64,2,0,18,12,12,0,6,                                  (* 62 '>' *)
       64,7,0,18,3,21,9,21,12,18,12,15,9,12,6,12,6,6,        (* 63 '?' *)
          1,6,3,6,0,
       64,15,12,12,9,15,6,15,3,12,3,9,6,6,9,6,12,9,          (* 64 '@' *)
          12,15,9,18,3,18,0,15,0,6,3,3,9,3,12,6,
       64,5,0,0,0,18,3,21,9,21,12,18,12,0, 1,12,9,0,9,       (* 65 'A' *)
       64,10,0,12,9,12,12,9,12,3,9,0,0,0,0,21,9,21,12,18,    (* 66 'B' *)
          12,15,9,12,
       64,7,12,18,9,21,3,21,0,18,0,3,3,0,9,0,12,3,           (* 67 'C' *)
       64,6,0,0,9,0,12,3,12,18,9,21,0,21,0,0,                (* 68 'D' *)
       64,1,0,12,9,12, 3,12,21,0,21,0,0,12,0,                (* 69 'E' *)
       64,1,0,12,9,12, 2,12,21,0,21,0,0,                     (* 70 'F' *)
       64,8,11,18,8,21,2,21,-1,18,-1,3,2,0,8,0,11,3,11,9,    (* 71 'G' *)
          1,8,9,14,9,
       64,1,0,0,0,21, 1,0,12,12,12, 1,12,21,12,0,            (* 72 'H' *)
       64,1,3,0,9,0, 1,6,0,6,21, 1,3,21,9,21,                (* 73 'I' *)
       64,4,0,3,3,0,9,0,12,3,12,21,                          (* 74 'J' *)
       64,1,0,0,0,21, 1,12,21,0,9, 1,6,15,12,0,              (* 75 'K' *)
       64,2,0,21,0,0,12,0,                                   (* 76 'L' *)
       64,4,0,0,0,21,6,9,12,21,12,0,                         (* 77 'M' *)
       64,3,0,0,0,21,12,0,12,21,                             (* 78 'N' *)
       64,8,12,3,12,18,9,21,3,21,0,18,0,3,3,0,9,0,12,3,      (* 79 'O' *)
       64,6,0,0,0,21,9,21,12,18,12,15,9,12,0,12,             (* 80 'P' *)
       64,8,12,3,12,18,9,21,3,21,0,18,0,3,3,0,9,0,12,3,      (* 81 'Q' *)
          1,6,6,12,0,
       64,6,0,0,0,21,9,21,12,18,12,15,9,12,0,12, 1,6,12,12,0,(* 82 'R' *)
       64,11,0,3,3,0,9,0,12,3,12,9,9,12,3,12,0,15,           (* 83 'S' *)
          0,18,3,21,9,21,12,18,
       64,1,0,21,12,21, 1,6,21,6,0,                          (* 84 'T' *)
       64,5,0,21,0,3,3,0,9,0,12,3,12,21,                     (* 85 'U' *)
       64,2,0,21,6,0,12,21,                                  (* 86 'V' *)
       64,4,0,21,3,0,6,12,9,0,12,21,                         (* 87 'W' *)
       64,1,0,0,12,21, 1,0,21,12,0,                          (* 88 'X' *)
       64,2,0,21,6,9,12,21, 1,6,9,6,0,                       (* 89 'Y' *)
       64,3,0,21,12,21,0,0,12,0,                             (* 90 'Z' *)
       64,3,9,21,3,21,3,0,9,0,                               (* 91 '[' *)
       64,1,-1,21,13,-3,                                     (* 92 '\' *)
       64,3,3,21,9,21,9,0,3,0,                               (* 93 ']' *)
       64,3,6,16,5,14,3,11,1,9, 3,6,16,7,14,9,11,11,9,       (* 94 '^' *)
       64,1,-3,-3,17,-3,                                     (* 95 '_' *)
       64,6,3,21,2,20,1,18,1,16,2,15,3,16,2,17,              (* 96 '`' *)
       64,4,0,12,3,15,9,15,12,12,12,0,                       (* 97 'a' *)
          7,12,3,9,0,3,0,0,3,0,6,3,9,9,9,12,6,
       64,1,0,0,0,21, 7,0,12,3,15,9,15,12,12,12,3,9,0,       (* 98 'b' *)
          3,0,0,3,
       64,7,12,12,9,15,3,15,0,12,0,3,3,0,9,0,12,3,           (* 99 'c' *)
       64,7,12,3,9,0,3,0,0,3,0,12,3,15,9,15,12,12,           (*100 'd' *)
          1,12,21,12,0,
       64,9,0,9,12,9,12,12,9,15,3,15,0,12,0,3,3,0,9,0,12,3,  (*101 'e' *)
       64,4,3,0,3,18,6,21,9,21,12,18, 1,9,12,0,12,           (*102 'f' *)
       64,17,3,3,0,0,0,-3,3,-6,9,-6,12,-3,12,0,9,3,3,3,0,    (*103 'g' *)
          6,0,12,3,15,6,15,9,12,9,9,6,6,3,6,0,9, 1,6,15,9,18,
       64,1,0,0,0,21, 4,0,12,3,15,9,15,12,12,12,0,           (*104 'h' *)
       64,1,6,21,6,18, 1,6,12,6,0,                           (*105 'i' *)
       64,3,3,-3,6,-6,9,-3,9,15, 1,9,18,9,21,                (*106 'j' *)
       64,1,0,0,0,21, 1,0,9,12,15, 1,6,12,12,0,              (*107 'k' *)
       64,1,6,21,6,0,                                        (*108 'l' *)
       64,1,0,0,0,15, 3,0,12,3,15,6,12,6,0,                  (*109 'm' *)
          3,12,0,12,12,9,15,6,12,
       64,1,0,0,0,15, 4,0,12,3,15,9,15,12,12,12,0,           (*110 'n' *)
       64,8,3,0,0,3,0,12,3,15,9,15,12,12,12,3,9,0,3,0,       (*111 'o' *)
       64,1,0,-6,0,15, 7,0,12,3,15,9,15,12,12,12,3,          (*112 'p' *)
          9,0,3,0,0,3,
       64,7,12,3,9,0,3,0,0,3,0,12,3,15,9,15,12,12,           (*113 'q' *)
          1,12,15,12,-6,
       64,1,0,0,0,15, 3,0,12,3,15,9,15,12,12,                (*114 'r' *)
       64,10,0,3,3,0,9,0,12,3,12,6,9,9,3,9,0,12,3,15,        (*115 's' *)
          9,15,12,12,
       64,1,0,12,9,12, 4,3,21,3,3,6,0,9,0,12,3,              (*116 't' *)
       64,4,0,15,0,3,3,0,9,0,12,3, 1,12,0,12,15,             (*117 'u' *)
       64,2,0,15,6,0,12,15,                                  (*118 'v' *)
       64,4,0,15,3,0,6,9,9,0,12,15,                          (*119 'w' *)
       64,1,0,0,12,15, 1,0,15,12,0,                          (*120 'x' *)
       64,4,0,-3,3,-6,9,-6,12,-3,12,15,                      (*121 'y' *)
          4,0,15,0,3,3,0,9,0,12,3,
       64,3,0,15,12,15,0,0,12,0,                             (*122 'z' *)
       64,9,4,25,2,24,1,23,0,21,0,19,1,17,2,16,3,14,3,12,    (*123 '{' *)
          1,10,16,2,24,1,22,1,20,2,18,3,17,4,15,
          4,13,3,11,-1,9,3,7,4,5,4,3,3,1,2,0,1,-2,1,-4,2,-6,
          9,1,8,3,6,3,4,2,2,1,1,0,-1,0,-3,1,-5,2,-6,4,-7,
       64,1,2,25,2,-7,                                       (*124 '|' *)
       64,9,-1,25,1,24,2,23,3,21,3,19,2,17,1,16,0,14,        (*125 '}' *)
          0,12,2,10,16,1,24,2,22,2,20,1,18,0,17,-1,15,-1,
          13,0,11,4,9,0,7,-1,5,-1,3,0,1,1,0,2,-2,2,-4,1,-6,
          9,2,8,0,6,0,4,1,2,2,1,3,-1,3,-3,2,-5,1,-6,-1,-7,
       64,10,-6,6,-6,8,-5,11,-3,12,-1,12,1,11,5,8,7,7,9,7,   (*126 '~' *)
          11,8,12,10,10,-6,8,-5,10,-3,11,-1,11,1,10,5,7,7,6,
          9,6,11,7,12,10,12,12,
       64,2,0,9,12,9,12,3,                                   (*127 '' *)
       64);


VAR
  charDat* : ARRAY 95 OF INTEGER;
  i,t      : INTEGER;


PROCEDURE Length*(str: ARRAY OF CHAR): INTEGER; (* $EntryExitCode- *)
BEGIN
sys.INLINE(02C5FH,          (*      move.l  (sp)+,a6  *)
           0301FH,          (*      move.w  (sp)+,d0  *)
           0205FH,          (*      move.l  (sp)+,a0  *)
           05340H,          (*      subq    #1,d0     *)
           03200H,          (*      move.w  d0,d1     *)
           04A18H,          (* l:   tst.b   (a0)+     *)
           057C9H, 0FFFCH,  (*      dbeq    d1,l      *)
           09041H,          (*      sub.w   d1,d0     *)
           04ED6H);         (*      jmp     (a6)      *)
END Length;


PROCEDURE Write*(rp           :G.RastPortPtr; 
                 xp,yp        :INTEGER; 
                 ch           :CHAR; 
                 xScal,yScal  :REAL);
VAR 
   i,t,v,x,y : INTEGER;
BEGIN
  DEC(ch,33);
  i:=ORD(ch);
  IF (i<94) AND (i>=0) THEN 
    v:=0;
    REPEAT
      t:=datas[charDat[i]+v];  
      x:=datas[charDat[i]+v+1];
      y:=datas[charDat[i]+v+2]; INC(v,3);
      y:=height-y;
      G.Move(rp,xp+SHORT(ENTIER(xScal*x)),yp+SHORT(ENTIER(yScal*y)));
        REPEAT
        x:=datas[charDat[i]+v];  
        y:=datas[charDat[i]+v+1]; INC(v,2);
        y:=height-y;
        G.Draw(rp,xp+SHORT(ENTIER(xScal*x)),yp+SHORT(ENTIER(yScal*y)));
        DEC(t);
      UNTIL t=0;
    UNTIL datas[charDat[i]+v]=64;
  END
END Write;


PROCEDURE WriteString*(rp           :G.RastPortPtr; 
                       xp,yp        :INTEGER; 
                       str          :ARRAY OF CHAR; 
                       xScal,yScal  :REAL);
VAR
   i,x : INTEGER;
BEGIN
  i:=0; x:=SHORT(ENTIER((width+4)*xScal));
  REPEAT
   Write(rp,xp,yp,str[i],xScal,yScal);
   xp:=xp+x;
   INC(i);
  UNTIL i>=Length(str);
END WriteString;
 

BEGIN
  i:=0; t:=0;
  WHILE i#length DO
    IF datas[i]=64 THEN charDat[t]:=i+1; INC(t); END;
  INC(i);
  END;    
END VectorFont.
