MODULE DumpConfig;

IMPORT ums, umsConsts, MHArgs, io, Utility, SYSTEM, NoGuru;

VAR
  login		: LONGINT;
  cfg		: MHArgs.Config;
  name,pwd,file	: ARRAY 256 OF CHAR;

BEGIN
  cfg := MHArgs.OpenConfig( "NAME/A,PASSWORD/A,FILE", "", NIL);
  IF cfg = NIL THEN  HALT(20)  END;
  IF cfg.GetString( "NAME", name) & cfg.GetString( "PASSWORD", pwd)  THEN
    login := ums.Login( name, pwd);
    IF login = 0 THEN
      io.WriteString("login failure\n");
    ELSE
      IF ~cfg.GetString( "FILE", file) THEN
        file := "CON:////UMS-Configuration/CLOSE/WAIT";
      END;
      IF NOT ums.WriteUMSConfigTags( login,
               Utility.user + umsConsts.tagCfgDump,  SYSTEM.ADR(file),
               Utility.done)
      THEN
        io.WriteString("error with WriteUMSConfig()\n");
      END;
    END;
  END;

CLOSE
  IF login # 0 THEN  ums.Logout(login)  END;
END DumpConfig.

