#include <exec/types.h>
#include <proto/exec.h>
#include "nl.h"

/*------------------------------------------------------------------------*/
#define NODELISTDIR	"Nodelist:"

/*-------------------------------------------------------------------------*/
extern void printf(char *,...);
extern void puts(char *);
extern int atol(char *);
extern void exit(int);

void main(int, char **);

/*------------------------------------------------------------------------*/
struct Library *NodelistBase;
ULONG LastZone = -1;

/*-------------------------------------------------------------------------*/
BOOL call_me(Addr *addr, UWORD region, void *the_nodelist)
	{
	if(addr->Zone != LastZone 		&&
		addr->Net  == addr->Zone 	&&
		addr->Node == 0 				&&
		addr->Point== 0 )
		{
		NodeDesc *nd;

		LastZone = addr->Zone;

		// Find that node in nodelist //

		if(nd = NLIndexFind(the_nodelist, addr, 0))
			{
			printf("%ld:%ld/%ld.%ld %s in %s\n", addr->Zone, addr->Net,
					addr->Node, addr->Point, nd->System, nd->City);

			NLFreeNode(nd);
			}
		}		

	return TRUE;
	}

/*-------------------------------------------------------------------------*/
void main(int argc, char **argv)
	{
	NodeList the_nodelist;

	if (argc != 1)
		{
		printf("Usage: %s\n", argv[0]);
		exit(5);
		}

	if(!(NodelistBase = OpenLibrary(TRAPLIST_NAME, TRAPLIST_VER)))
		{
		printf("Can't open library\n");
		exit(5);
		}

	if((the_nodelist = NLOpen(NODELISTDIR, 0)))
		{
		NLEnumNode(the_nodelist, 0, NULL, call_me, the_nodelist);
		NLClose(the_nodelist);
		}
	else	
		puts("Nodelist won't open");

	CloseLibrary(NodelistBase);
	}

/*-------------------------------------------------------------------------*/
/* ID: 6.35@1745  Last Changed: 10 Feb 1991 11:48:06 by max */
