MODULE EnumNodes;

IMPORT
  tl: TrapList, e: Exec, y: SYSTEM, d: Dos, ol: OberonLib, NoGuru;

(*------------------------------------------------------------------------*)
CONST
  NodeListDir = "NODELIST:";

(*------------------------------------------------------------------------*)
VAR
  nodelist: tl.NodeListPtr;
  LastZone: INTEGER;

(*-------------------------------------------------------------------------*)
(* $Debug- $SaveRegs+ $DeallocPars- Really should use Hooks! *)
PROCEDURE CallMe (thelist: y.ADDRESS; region: LONGINT; addr: tl.AddrPtr): BOOLEAN;
VAR
  nd: tl.NodeDescPtr;
BEGIN
  (* $IF SmallData *) ol.SetA5; (* $END *)

  IF (addr.zone  # LastZone) AND
     (addr.net   = addr.zone) AND
     (addr.node  = 0) AND
     (addr.point = 0) THEN

    LastZone := addr.zone;

    (* Find that node in nodelist *)
    d.PrintF ("%ld:%ld/%ld.%ld ", addr.zone, addr.net, addr.node, addr.point);

    nd := tl.IndexFind (thelist, addr, LONGSET {});
    IF nd # NIL THEN
      d.PrintF ("%s in %s\n", nd.system, nd.city);
      tl.FreeNode (nd); nd := NIL;
    ELSE
      d.PrintF ("not found\n");
    END;
  END;

  (* check for Ctrl-C *)
  IF (d.ctrlC IN e.SetSignal (LONGSET {}, LONGSET {})) THEN
    d.PrintF (" *** Break\n");
    RETURN FALSE;
  ELSE
    RETURN TRUE;
  END;
END CallMe;
(* $Debug= *)
(*-------------------------------------------------------------------------*)

BEGIN
  LastZone := -1;

  nodelist := tl.Open (NodeListDir, LONGSET {});
  IF nodelist = NIL THEN
    d.PrintF ("Nodelist won't open\n");
    HALT (20);
  END;
  IF tl.EnumNode (nodelist, 0, NIL, CallMe, nodelist) = 0 THEN END;
CLOSE
  IF nodelist # NIL THEN tl.Close (nodelist); nodelist := NIL END;
END EnumNodes.
(*-------------------------------------------------------------------------*)
