

     Page 1          traplist.library's Documentation           Page 1

















                             traplist.library
                           Copyright  1990,1991
                 Martin J. Laubach and Maximilian Hantsch
                            All rights reserved






                     traplist.library's Documentation
                       Wednesday 01-Jan-92 00:59:48
                           Copyright  1990,1991
                 Martin J. Laubach and Maximilian Hantsch
                            All rights reserved








  1. Introduction     

       This is the first public release of the TrapDoor
     traplist.library.  It is a fully functional shared library to
     access a TrapList 'newstyle' nodelist, as can be generated by
     TrapList 1.35 and above.  

       Since trying to coordinate all the different efforts leading
     to a universal nodelist.library, we decided to name this library
     "traplist.library", so it won't collide with other libraries.  








     Introduction


     Page 2          traplist.library's Documentation           Page 2


  2. What     

       In this archive, you should find the following files: 

          nl.h .............. traplist.library include file.
          nl.fd ............. .fd file for traplist.library
          tl_lib.Man ........ What you are reading right now.
          traplist.doc ...... Autodocs to the routines in the library.
          traplist.library .. Guess what
          examples/*......... Example of how to access the nodelist, the
                              extra database, etc.



  3. Pecularities     

       Traplist.library basically features two more or less
     independent sets of functions.  

       First, there are the index functions; these are for looking up
     raw or 'cooked' data from a nodelist. A program called TrapList
     can be used to generate the index file.  

       Second, there is the extra database. As opposed to the
     nodelist index functions, which can only give you data that can
     be directly derived from the raw nodelist, the extra database
     may contain any information you may want to associate with a
     particular node. For example, TrapList uses the extra database
     to store the session passwords for FidoNet nodes.  

       Extra data is grouped in 'chunks'. An extra data chunk is
     tagged by a four character identifier. Currently defined
     identifiers are listed below. You may use anything you like as
     tag field for your private data -- we only ask you to register
     these tag fields with us, so we can keep a list of already used
     tags up to date, thus avoiding collisions.  

       For more details how to access the extra database and how to
     use the index lookup functions for obtaining data from the raw
     nodelist, please see the example code enclosed in this
     distribution archive and the traplist.doc AutoDocs file.  




  4. Currently used tag identifiers  

       PASS ....... Used by TrapList/TrapDoor for session passwords.
                    The data part is a null terminated string.  
       TCFG ....... A custom configuration command line for TrapDoor.
                    The data part is a null terminated string.  
       ACCT ....... TrapDoor accounting information. The data part is
                    a binary private data structure.  



     Currently used tag identifiers


     Page 3          traplist.library's Documentation           Page 3


  5. ARexx Interface    

       Traplist.library also features an ARexx interface, so it can
     be used as ARexx function library. To tell ARexx about the
     library, add the line "RXLIB traplist.library 0 -30 0" to your
     startup-sequence.  

       The function host currently supports only one function: 


          result = FindNode(address[,[what][,[nodelistpath]]]) 

            This will search for the specified node in the nodelist.  

            The result string consists of a boolean success flag,
          followed by the requested value if the success flag is
          one.  When the success flag is zero, then the rest of the
          result string consists of an error message.  

            The arguments are as follows: 

            addr -- node address 

            what -- what value to return (defaults to "Node").
                    Abbreviations are possible.  

                    All ........ Return ALL data, separated by
                                 commas, in the order
                                 N,O,S,T,L,P,B,C,R,H,F 
                    Node ....... Four dimensional node number 
                    Operator ... Sysop name 
                    System ..... System name 
                    Telephone .. Phone number 
                    Location ... City 
                    Password ... Password 
                    BaudRate ... BaudRate 
                    Cost ....... Cost 
                    Region ..... Region number 
                    HUB ........ Node number of HUB 
                    Flags ...... Nodelist flags 

            path -- path to nodelist directory (defaults to
                    "Nodelist:") 


       Many thanks to Jrgen Hermann for this idea and its first
     implementation.  









     ARexx Interface


     Page 4          traplist.library's Documentation           Page 4



  6. Distribution     

       Traplist.library is a copyrighted product that has been made
     available to you as Freeware. You do not have to pay anything in
     order to use traplist.library, you may copy it, give it to
     others, etc. The only thing you may not do is sell it.  

       You may include traplist.library in a commercial product
     provided you send us a free copy.  

       Note however that TrapList, the program to generate index
     files for traplist.library, is distributed as Shareware. If you
     intend to make continued use of TrapList, please see the
     corresponding manual 'TrapList.Man' for information about
     registration.  




  6.1. Support     

       If you have any suggestions, bug reports, new extra chunk tags
     to be registered etc., feel free to contact us at 


                           TrapDoor Development
                          c/o Maximilian Hantsch
                      Matzleinsdorfer Platz 3-4/3/10
                                A-1050 Wien
                             Austria / Europe


       Additionally, you can reach us at: 

          Martin Laubach                  Maximilian Hantsch
          Fido:   2:310/3.14              Fido:   2:310/6
          Uucp:   mjl@alison.at           Uucp:   max@madvie.at
                  mjl%alison@cbmvie.at            max%madvie@cbmvie.at
                  ..!uunet!mcsun!tuvie!cbmvie!alison!mjl
                  ..!cbmvax!cbmehq!cbmvie!alison!mjl


       Also, there is a FidoNet Echomail conference called TRAPDOOR,
     which should be available at major backbones. This conference is
     in English and intended for the users of TrapDoor and, of
     course, traplist.library as well. There, you can freely exchange
     your experience with these programs, discuss future enhancements
     you would like to see etc. Both authors will participate in the
     conference and try to assist you.  






     Distribution                                          Support


     Page 5          traplist.library's Documentation           Page 5



  6.2. No Warranty    

       THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED
     BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE
     COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS
     IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE
     RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH
     YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
     ALL NECESSARY SERVICING, REPAIR OR CORRECTION.  

       IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU
     FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
     CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
     THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
     BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
     PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
     PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED
     OF THE POSSIBILITY OF SUCH DAMAGES.  




  6.3. Disclaimer     

       No warranty, either express or implied, is made with respect
     to the fitness or merchantability of traplist.library.  

       Maximilian Hantsch and Martin Laubach (referred to as "the
     authors"), reserve the right to not develop any future versions
     of traplist.library.  

       The authors will try to make a good faith attempt at
     correcting any problems if any are discovered, but are in no way
     required, nor bound to correct them.  

       The authors neither assume or accept any responsibility for
     the use or misuse of this program. They also will not be held
     liable for damages or any compensation due to loss of profit or
     any other damages arising out of the use, or inability to use
     this program.  

       Neither Maximilian Hantsch nor Martin Laubach will be liable
     for any damage arising from the failure of this program to
     perform as described, or any destruction of other programs or
     data residing on a system attempting to run the program. While
     we know of no damaging errors, the user of this program uses it
     at his or her own risk.  




     Distribution                                       Disclaimer


     Page 6          traplist.library's Documentation           Page 6


  7. Road Map   



        1. Introduction    .....................................    1
        2. What    .............................................    2
        3. Pecularities    .....................................    2
        4. Currently used tag identifiers ......................    2
        5. ARexx Interface   ...................................    3
        6. Distribution    .....................................    4
           6.1. Support    .....................................    4
           6.2. No Warranty   ..................................    5
           6.3. Disclaimer    ..................................    5
        7. Road Map   ..........................................    6

















          "The only way to avoid mistakes is to gain experience.
           The only way to gain experience is to make a mistake."























     Road Map

