(****************************************************************************
:Program.       LevenshteinTest.mod
:Contents.      Testmodule for Levensthein
:Author.        Richard Gnther [gvm]
:Address.       HeilbronnerStr.267, 7410 Reutlingen
:Phone.         07121/66432
:Copyright.     Freeware
:Language.      Oberon
:Translator.    AmigaOberon v2.14d
:Imports.       Levenshtein [gvm]
:History.       V1.0 [gvm] 07-July-92  first implementation
:Bugs.          none known
****************************************************************************)

MODULE LevenshteinTest ;

IMPORT  Levenshtein,
        io ;

VAR quit                : BOOLEAN;
    string1,string2     : ARRAY 64 OF CHAR ;
    distanz             : INTEGER ;


BEGIN
  quit:=FALSE ;
  REPEAT
    io.WriteString("String1: ") ; io.ReadString(string1) ;
    io.WriteString("String2: ") ; io.ReadString(string2) ;
    IF (string1="") AND (string2="") THEN quit:=TRUE END ;
    distanz:=Levenshtein.LDistance(string1,string2) ;
    IF distanz=-1 THEN
      io.WriteString("Strings zu lang!\n") ;
    ELSE
      io.WriteString("- Errechnete Distanz:") ; io.WriteInt(distanz,5) ;
      io.WriteLn ;
    END ;
  UNTIL quit ;
END LevenshteinTest.
