MODULE IFF2BMP;

(*
  Program   IFF to BitMap Converter
  Author    Eduard Pech, The New Power Generation
  Compiler  Amiga Oberon 2.13d
  Version   0.99\alpha.00a (not yet functional)
  Date      14-Jun-92
  Version   0.99\alpha.00b (full functionality)
  Date      16-Jun-92
  Version   0.99\alpha.01a (minor changes in error handling)
  Date      16-Jun-92
  Version   0.99\alpha.02a (file name without path bug removed)
  Date      24-Jun-92
  Remark    Not commented, because I don't think it's necessary.
*)

IMPORT
  Arguments,Dos,Exec,IFFSupport,Graphics,Intuition,ReqTools,Strings,SYSTEM,Utility;

CONST
  ProgramName = "IFF2BMP";
  Version     = "0.99\\beta.00a, 15-Jul-92";

VAR
  I           : LONGINT;
  FileReq     : ReqTools.FileRequesterPtr;
  MyScreen    : Intuition.ScreenPtr;
  WindowDummy : Intuition.WindowPtr;
  Source,Dest : Exec.STRING;
  DestFile    : Dos.FileHandlePtr;

PROCEDURE WriteBitMap {"WriteBitMap"} (BitPlane{12}: Graphics.PLANEPTR; File{13}: Dos.FileHandlePtr; ImageWidth{6}: INTEGER; ImageHeight{7}: INTEGER): BOOLEAN;

PROCEDURE MakeFileName (VAR Path : Exec.STRING; VAR File : Exec.STRING);

  BEGIN
    Strings.Insert (File,0,"/");
    Strings.Insert (File,0,Path);
  END MakeFileName;

BEGIN
  FileReq := ReqTools.AllocRequestA (ReqTools.TypeFileReq,NIL);
  IF FileReq # NIL THEN
    IF Arguments.NumArgs () >= 1
    THEN Arguments.GetArg (1,Source)
    ELSE
      Source := "Test.pic";
      REPEAT UNTIL ReqTools.FileRequest (FileReq,Source,"IFF Quelldatei",Utility.end);
      Dest := Source;
      Strings.Append (Dest,".bmp");
      MakeFileName (FileReq.dir^,Source);
    END;
    IF Arguments.NumArgs () = 2
    THEN Arguments.GetArg (2,Dest)
    ELSE
      REPEAT UNTIL ReqTools.FileRequest (FileReq,Dest,"BitMap Zieldatei",Utility.end);
      MakeFileName (FileReq.dir^,Dest);
    END;
    ReqTools.FreeRequest (FileReq);
  ELSE
    ReqTools.vEZRequest ("Zu wenig Speicher!","Ach, Mensch!",NIL,NIL);
  END;
  I := SYSTEM.ADR(ProgramName); (* Spart vier Bytes! *)
  Dos.PrintF ("\[2m%s\[0m version %s.\nIFF nach BitMap Konvertierer.  14-Jun-1992 bei \[1mEduard Pech, NPG\[0m.\n\[4mGebrauch\[0m: %s <IFF Quelldatei> <BitMap Zieldatei>\n\n",I,SYSTEM.ADR(Version),I);
  Dos.PrintF ("Lese IFF Quelldatei.\n");
  IF IFFSupport.ReadILBM (Source,{IFFSupport.front,IFFSupport.visible,IFFSupport.usebmsize},MyScreen,WindowDummy)
  THEN
    IF IFFSupport.DoCycle (IFFSupport.IFFInfo,MyScreen) THEN END;
    Dos.PrintF ("Schreibe BitMap Zieldatei.\n");
    DestFile := Dos.Open (Dest,Dos.newFile);
    IF DestFile = NIL
    THEN
      Dos.PrintF ("Zieldatei:::Fehler beim Oeffnen.\n");
      HALT (20);
    END;
    I := Dos.FPrintf (DestFile,"#define y_width %ld\n#define y_height %ld\nstatic char y_bits[] = {\n  ",IFFSupport.IFFInfo.BMHD.width,IFFSupport.IFFInfo.BMHD.height);
    IF ~WriteBitMap (MyScreen.bitMap.planes[0],DestFile,IFFSupport.IFFInfo.BMHD.width,IFFSupport.IFFInfo.BMHD.height)
    THEN Dos.PrintF ("Zieldatei:::Fehler beim Schreiben.\n");
    ELSE I := Dos.FPrintf (DestFile,"};\n",NIL);
    END;
    IF ~Dos.Close (DestFile)
    THEN
      Dos.PrintF ("Zieldatei:::Fehler beim Schliessen.\n");
      HALT(20)
    END;
    IFFSupport.EndCycle (IFFSupport.IFFInfo);
    Intuition.OldCloseScreen (MyScreen);
  ELSE
    Dos.PrintF ("Quelldatei:::Fehler beim Lesen.\n");
    Intuition.DisplayBeep (NIL);
  END;
END IFF2BMP.

