MODULE Colors;

(*
 * Colors - simple command to open a (nice) palette requester
 *          on the default public screen (usually Workbench).
 *
 * Written by P.Frhlich, 10-Jun-1992. Public Domain.
 *
 * Last Edit: 05-Jul-92
 *)

IMPORT
  p := Palette, i := Intuition, u := Utility, SYSTEM;

CONST
  easy = i.EasyStruct(
                       SIZE(i.EasyStruct),
                       LONGSET{},
                       SYSTEM.ADR("Colors"),
                       SYSTEM.ADR("Can't open\npalette requester."),
                       SYSTEM.ADR("Retry|Cancel")
                     );

 version = "$VER: Colors 1.0 (5.7.92) by P.Frhlich";

VAR
  screen : i.ScreenPtr;

BEGIN
  SYSTEM.SETREG(0,SYSTEM.ADR(version));

  screen := i.LockPubScreen(NIL);
  IF (screen # NIL) THEN

    LOOP

      (*
       * We attempt to open the palette until we succeed or
       * the user stops us.
       *)

      IF p.Palette(screen,TRUE,0,0,"Color Palette") < 0 THEN
        IF i.EasyRequest(NIL,SYSTEM.ADR(easy),NIL,u.done) = 0 THEN
          EXIT;
        END;
      ELSE
        EXIT;
      END;

    END;

  END;

CLOSE

  IF (screen # NIL) THEN i.UnlockPubScreen(NIL,screen); END;

END Colors.
