(*********************************************************************)
(*
   :Program.    MyMathLib
   :Author.     Stefan Khle
   :Address.
   :Phone.
   :shortcut.
   :Version.    1.0
   :Date.       6.11.90
   :Copyright.  nix
   :Language.   Modula-II.
   :Translator. M2Amiga V4.107d
   :Imports.
   :UpDate.
   :Contents.
   :Remark.

**********************************************************************)

IMPLEMENTATION MODULE MyMathLib;

   FROM SYSTEM IMPORT FFP,LONGSET,CAST ;
   FROM InOut IMPORT WriteInt,WriteString,WriteLn ;
   FROM FFPConversions IMPORT RealToStr ;
   FROM RealInOut IMPORT WriteReal ;



   PROCEDURE RealToInt(x: REAL):INTEGER ;
     BEGIN
        RETURN (TRUNC(x)) ;
     END RealToInt ;


   PROCEDURE FFPToInt(x: FFP): INTEGER ;
     BEGIN
        RETURN (TRUNC(x)) ;
     END FFPToInt ;


   PROCEDURE IntToReal(x:INTEGER): REAL ;
     BEGIN
        IF x >= 0 THEN
           RETURN (FLOAT(CARDINAL(x))) ;
        ELSE
           RETURN(-FLOAT(CARDINAL(ABS(x)))) ;
        END (* IF *) ;
     END IntToReal ;


   PROCEDURE IntToFFP(x:INTEGER): FFP ;
     BEGIN
       RETURN FFP(x) ;
     END IntToFFP ;


   PROCEDURE FFPToStr(ffp:FFP ; VAR string: ARRAY OF CHAR) ;
     VAR err: BOOLEAN ;

     BEGIN

     IF ABS(ffp) < 1000.0 THEN
        RealToStr(ffp,string,6,3,FALSE,err) ;
     ELSE
        RealToStr(ffp,string,8,2,TRUE,err) ;
     END ;

     IF err THEN WriteString('ERROR') ; WriteLn ; END ;

     END FFPToStr;

END MyMathLib .
