(*******************************************************************************

:Program.       MotaLern.mod
:Contents.      Lernprogramm fr den Mota (MOrse-TAschenrechner, s. Dok-File)
:Author.        Bernd Eisele
:Copyright.     Freeware
:Language.      Modula-II, Assembler (PowerLED-Steuerung)
:Translator.    M2Amiga V4.0
:History.       V1.0 [Bernd Eisele] 27-Dec-92 First Release
:Bugs.          Beim zweiten Start streikt die Joystick-Abfrage. Wenn mich
                bitte jemand aufklren knnte, warum, wre ich sehr dankbar...
:Address.       Pestalozzistr. 24   7104 Obersulm 2   Germany
:Remark.        Read the InfoX !! Papermag des ICC fr DM 5.- (incl. Porto)
                bestellen bei InfoX-RedaX   Po Box 1455  3057 Neustadt 1

*******************************************************************************)

MODULE MotaLern;

FROM SYSTEM       IMPORT ADR, ASSEMBLE, LONGSET;
FROM Arts	  IMPORT Assert;
FROM DosL         IMPORT Delay;
FROM ExecL        IMPORT WaitPort, GetMsg, ReplyMsg,OpenDevice, CloseDevice,
                         DoIO, SendIO, Wait, FindPort;
FROM ExecD	  IMPORT IOStdReqPtr, MsgPortPtr, clear, quick;
FROM ExecSupport  IMPORT CreatePort, DeletePort, CreateExtIO, DeleteExtIO;
FROM GamePort	  IMPORT gamePortName, Keys, KeySet, setTrigger, GamePortTrigger,
		         askCType, setCType, readEvent, Controller;
FROM GraphicsD    IMPORT RastPortPtr;
FROM GraphicsL    IMPORT Move, Text, SetAPen, RectFill;
FROM Heap         IMPORT AllocMem, Deallocate;
FROM InputEvent	  IMPORT InputEvent, upPrefix, lButton;
FROM IntuitionD   IMPORT NewWindow, WindowPtr, WindowFlags, WindowFlagSet,
                         IDCMPFlags, IDCMPFlagSet, ScreenFlags, ScreenFlagSet,
                         IntuiMessage;
FROM IntuitionL   IMPORT OpenWindow, CloseWindow, CurrentTime;
FROM RandomNumber IMPORT RND, PutSeed;
FROM String       IMPORT Length;


TYPE Def = RECORD
             c  : CHAR;                 (* Zeichen *)
             m  : ARRAY[0..4]  OF CHAR; (* Morsecode *)
             MW : ARRAY[0..60] OF CHAR; (* Merkwort *)
           END;

VAR Zeichen 	: ARRAY[1..26] OF Def;
    chc,chu 	: CHAR;
    num,b   	: SHORTCARD;
    nw      	: NewWindow;
    wp      	: WindowPtr;
    rpp     	: RastPortPtr;
    cl      	: IDCMPFlagSet;
    IOReqPtr 	: IOStdReqPtr;
    PortPtr	: MsgPortPtr;
    cType	: Controller;
    GPTrig	: GamePortTrigger;
    co      	: CARDINAL;
    Fini,
    HumanHuman 	: BOOLEAN;



PROCEDURE LEDOff;
BEGIN
  ASSEMBLE(
    RELOCATION
    ORI.B #2, $bfe001
    END);
END LEDOff;

PROCEDURE LEDOn;
BEGIN
  ASSEMBLE(
    RELOCATION
    ANDI.B #$fc, $bfe001
 END);
END LEDOn;

PROCEDURE SetJoyController(c : Controller);
BEGIN
  WITH IOReqPtr^ DO
    command := setCType;
    length := 1;
    flags := quick;
    data := ADR(c);
  END;
  DoIO(IOReqPtr);
END SetJoyController;

PROCEDURE OutTextXY(rp : RastPortPtr; x,y : INTEGER; text : ARRAY OF CHAR);
BEGIN
  Move(rp,x,y);
  Text(rp, ADR(text), Length(text));
END OutTextXY;

PROCEDURE Defin;
VAR i,j : INTEGER;
    sec,mic : POINTER TO LONGINT;
BEGIN

  AllocMem(mic,4,FALSE);	(* Zufallszahlen bekommen einen	Anfangs-*)
  CurrentTime(sec,mic);		(* wert zugewiesen, damit es beim Start	*)
  PutSeed(ADR(mic));		(* des Programms nicht immer die 	*)
  Deallocate(mic);		(* gleichen sind			*)

  FOR i := 1 TO 26 DO		(* Zeichen[i] bekommt	 	*)
    Zeichen[i].c := CHR(i+96);	(* Buchstaben zugewiesen.	*)
    FOR j := 0 TO 4 DO
      Zeichen[i].m[j] := 0C;
    END;
  END;

  (* a *) Zeichen[ 1].m := "-";   Zeichen[ 1].MW := "Alaaarm";
  (* b *) Zeichen[ 2].m := "-"; Zeichen[ 2].MW := "Baaahndefizit";
  (* c *) Zeichen[ 3].m := "--"; Zeichen[ 3].MW := "Caaardinaaale";
  (* d *) Zeichen[ 4].m := "-";  Zeichen[ 4].MW := "Dooominik";
  (* e *) Zeichen[ 5].m := "";    Zeichen[ 5].MW := "Eck";
  (* f *) Zeichen[ 6].m := "-"; Zeichen[ 6].MW := "Fette Beeuute";
  (* g *) Zeichen[ 7].m := "--";  Zeichen[ 7].MW := "Geeeh doooch mit";
  (* h *) Zeichen[ 8].m := ""; Zeichen[ 8].MW := "Hektikertick";
  (* i *) Zeichen[ 9].m := "";   Zeichen[ 9].MW := "Igitt";
  (* j *) Zeichen[10].m := "---"; Zeichen[10].MW := "Jesaaajaaa spraaach";
  (* k *) Zeichen[11].m := "--";  Zeichen[11].MW := "Kaaaviaaar";
  (* l *) Zeichen[12].m := "-"; Zeichen[12].MW := "Ich liiiebe dich";
  (* m *) Zeichen[13].m := "--";   Zeichen[13].MW := "Maaarthaaa ";
  (* n *) Zeichen[14].m := "-";   Zeichen[14].MW := "Naauutik";
  (* o *) Zeichen[15].m := "---";  Zeichen[15].MW := "Oooomeeegaaa";
  (* p *) Zeichen[16].m := "--"; Zeichen[16].MW := "Peseeeteeenstck";
  (* q *) Zeichen[17].m := "---"; Zeichen[17].MW := "Queeer graaast die Kuuuh";
  (* r *) Zeichen[18].m := "-";  Zeichen[18].MW := "Renaaate";
  (* s *) Zeichen[19].m := "";  Zeichen[19].MW := "Sirikit";
  (* t *) Zeichen[20].m := "-";    Zeichen[20].MW := "Toood";
  (* u *) Zeichen[21].m := "-";  Zeichen[21].MW := "Utopiiie";
  (* v *) Zeichen[22].m := "-"; Zeichen[22].MW := "Vitamin Aaa";
  (* w *) Zeichen[23].m := "--";  Zeichen[23].MW := "Wie waaarm waaars";
  (* x *) Zeichen[24].m := "--"; Zeichen[24].MW := "Xaaanthippes Haaar";
  (* y *) Zeichen[25].m := "---"; Zeichen[25].MW := "Aaaaly Baaabaaa ";
  (* z *) Zeichen[26].m := "--"; Zeichen[26].MW := "Zaaahnaaarztkittel";

  WITH nw DO
    leftEdge := 0; topEdge := 0; width := 640; height := 256; detailPen := 0;
    blockPen := 1;idcmpFlags := IDCMPFlagSet{closeWindow, vanillaKey};
    flags := WindowFlagSet{windowClose, windowDrag, gimmeZeroZero, activate};
    firstGadget := NIL;
    title := ADR("Mota(tm) - Lernprogramm V1.0   by B.E. in 1992 A.D.");
    bitMap := NIL; type := ScreenFlagSet{wbenchScreen};
  END;

  wp := OpenWindow(nw);
  rpp := wp^.rPort;
END Defin;

PROCEDURE Clear; (* Fensterinhalt lschen *)
BEGIN
  SetAPen(rpp,0);
  RectFill(rpp,0,0,635,240);
  SetAPen(rpp,1);
END Clear;

PROCEDURE TwoHumans;
VAR imp 		: POINTER TO IntuiMessage;
    IE			: InputEvent;
    JoySig, KeySig,
    AllSigs, ResSig	: LONGSET;
BEGIN
  Clear;
  OutTextXY(rpp,100,100,"Umschalten Computer/Mensch - Modus mit <Taste>");

  JoySig := LONGSET{};
  ResSig := LONGSET{};
  KeySig := LONGSET{};
  AllSigs := LONGSET{};
  INCL(JoySig,PortPtr^.sigBit);
  INCL(KeySig,wp^.userPort^.sigBit);
  INCL(AllSigs,PortPtr^.sigBit);
  INCL(AllSigs,wp^.userPort^.sigBit);

  REPEAT
    ResSig := LONGSET{};
    WITH IOReqPtr^ DO
      command := readEvent;
      length := SIZE(InputEvent);
      data := ADR(IE);
    END;
    SendIO(IOReqPtr);
    ResSig := Wait(AllSigs);

    IF ResSig = JoySig THEN
      IF IE.code = lButton THEN
        LEDOn;
      ELSIF (IE.code = (lButton + upPrefix)) THEN
        LEDOff;
      END;
    END;
  UNTIL ResSig = KeySig;
  imp := GetMsg(wp^.userPort);
  IF imp # NIL THEN ReplyMsg(imp); END;
  Clear;
  OutTextXY(rpp,10,20,"Wie heit folgender Buchstabe :");
  Delay(30);
END TwoHumans;


PROCEDURE Msg(VAR c : CHAR);
VAR imp : POINTER TO IntuiMessage;
BEGIN
  Fini := FALSE;
  HumanHuman := FALSE;
  WaitPort(wp^.userPort);
  imp := GetMsg(wp^.userPort);
  cl := imp^.class;
  co := imp^.code;
  ReplyMsg(imp);
  IF closeWindow IN cl THEN Fini := TRUE; END;
  IF vanillaKey IN cl THEN
    c := CHR(co);
    IF (co=27) THEN HumanHuman := TRUE END;
  END;
END Msg;


BEGIN (* MotaLern *)

  Assert(FindPort(ADR("JoyPort")) = NIL,ADR("MotaLern luft schon"));

  LEDOff;
  Defin;
  Clear;
  PortPtr := CreatePort(ADR("JoyPort"),0);		(* Port is opened   *)
  Assert(PortPtr # NIL,ADR("Kein Port"));

  IOReqPtr := CreateExtIO(PortPtr,SIZE(IOReqPtr^));	(* IOReq is created *)
  Assert(IOReqPtr # NIL,ADR("Kein IOReqPtr"));

  OpenDevice(ADR(gamePortName),1,IOReqPtr,LONGSET{});	(* Device is opened *)
  Assert(IOReqPtr^.device # NIL,ADR("Kein Gameportdevice"));

  WITH IOReqPtr^ DO					(* Check, if Joy-   *)
    command := askCType;				(* stickport free   *)
    length := 1;
    data := ADR(cType);
  END;
  DoIO(IOReqPtr);

  IF cType = noController THEN

    SetJoyController(absJoystick);

    WITH GPTrig DO					(* Set trigger      *)
      keys := KeySet{upKeys, downKeys};			(* conditions       *)
      timeout := 0; xDelta := 0; yDelta := 0;
    END;

    WITH IOReqPtr^ DO
      command := setTrigger;
      length := SIZE(GPTrig);
      data := ADR(GPTrig);
    END;
    DoIO(IOReqPtr);

    WITH IOReqPtr^ DO					(* Clear Joystick-   *)
      command := clear;					(* port. Maybe there *)
      data := NIL;					(* is data left.     *)
      length := 0;
    END;
    DoIO(IOReqPtr);

    LOOP

      OutTextXY(rpp,10,50,"Wenn bereit, Taste drcken.");
      OutTextXY(rpp,10,60,"Umschalten Mensch/Mensch - Modus mit <Esc>.");
      Msg(chu);
      IF Fini THEN EXIT END;
      IF HumanHuman THEN TwoHumans END;
      Delay(30);

      Clear;
      OutTextXY(rpp,10,20,"Wie heit folgender Buchstabe :");
      Delay(30);

      num := SHORTCARD(RND(26) + 1);   (* Bestimme Buchstaben durch Zufall *)
      chc := Zeichen[num].c;

      REPEAT
        FOR b := 0 TO Length(Zeichen[num].m)-1 DO
          LEDOn;
          IF (Zeichen[num].m[b] = "") THEN
            Delay(10)
          ELSE					(*   Morsen der Zeichen	*)
            Delay(40);				(*			*)
          END;					(*   via Power-LED	*)
          LEDOff;				(*			*)
          Delay(20);				(* ( Fragezeichen vom	*)
        END;					(*   User, falls nicht	*)
        LEDOff;					(*   nicht aufgepat )	*)
        Msg(chu); IF Fini THEN EXIT END;
      UNTIL (chu # "?");

      IF (CAP(chu) = CAP(chc)) THEN
        OutTextXY(rpp,10,35,"Richtig.");
      ELSE OutTextXY(rpp,10,30,"Falsch.");
         OutTextXY(rpp,10,40,"Richtig wre gewesen : ");
         Text(rpp,ADR(chc), 1); Text(rpp,ADR(" ("),2);
         Text(rpp,ADR(Zeichen[num].m), Length(Zeichen[num].m));
         Text(rpp,ADR(")  Merkwort: "),13);
         Text(rpp, ADR(Zeichen[num].MW), Length(Zeichen[num].MW));
      END;


    END (* mainLOOP *);

    SetJoyController(noController);

  ELSE (* IF JoyController = noController *)
    Assert(4=5,ADR("Joystickport schon belegt."));
  END;

CLOSE
  IF IOReqPtr^.device # NIL THEN
    CloseDevice(IOReqPtr);
  END;
  IF IOReqPtr # NIL THEN DeleteExtIO(IOReqPtr); END;
  IF PortPtr # NIL THEN DeletePort(PortPtr); END;
  LEDOn;
  IF wp#NIL THEN CloseWindow(wp); END;

END MotaLern.


