/*$VER: demo.rexx 37.12 (13.2.93)
**
**	$Filename: test.c $
**  $Version: 37.12 $
**  $Date: 13.2.93 $
**  $Creation: 2.1.93 $
**
**  Demo ARexx script for rexxreqtools.library
**
**	(C) Copyright 1993 Rafael D'Halleweyn
*/

/* NOTE: A Comma at the end of a line is no argument seperator but contituation
 *       character for a statement that continues on the next line!!
 */

NL = '0a'x

call addlib("rexxreqtools.library", 0, -30, 0)

call rtezrequest( "RexxReqTools 1.0 Demo" || NL ||,
                  "~~~~~~~~~~~~~~~~~~~~~" || NL ||,
                  "'rexxreqtools.library' offers several" || NL ||,
                  "different types of requesters:", "Let's see them")



/* STRING REQUESTER */

call rtezrequest( "NUMBER 1:" || NL ||,
                  "String requester" || NL ||,
                  "function: rtgetstring()", "Show me")

buffer = rtgetstring("A bit of text", , "Enter anything:")
if buffer == "" then
  call rtezrequest("You entered nothing!", "I'm sorry")
else
  call rtezrequest( "You entered this string:" || NL ||,
                    "'" || buffer || "'.", "So I did")

call rtgetstring( , "These are two new features of ReqTools 2.0:" || NL ||,
                    "Text above the entry gadget and more than" || NL ||,
                    "one response gadget.", "Enter anything:",,
  " _Ok |New _2.0 feature!|_Cancel")
if rtresult == 2 then call rtezrequest( "Yep,  this is a new" || NL ||,
                                        "ReqTools 2.0 feature!", "Oh boy!")

call rtgetstring(buffer,  "New is also the ability to switch off" || NL ||,
                          "the backfill pattern. You can also center" || NL ||,
                          "the text above the entry gadget." || NL ||,
                          "These new features are also available" || NL ||,
                          "in the rtgetlong() requester.",,
  "Enter anything:"," _Ok |_Abort|_Cancel",,
  "rtgs_backfill=false rtgs_flags=gsreqf_centertext|gsreqf_highlighttext")
if rtresult == 2 then
  call rtezrequest( "What!! You pressed abort!?!" || NL ||,
                    "You must be joking :-)", "Ok,  continue")



/* NUMBER REQUESTER */

call rtezrequest( "NUMBER 2:" || NL ||,
                  "Number requester" || NL ||,
                  "function: rtgetlong()", "Show me")

long = rtgetlong(, , "Enter a number:", , "rtgl_min=0 rtgl_max=666")
if rtresult == 0 then
  call rtezrequest("You entered nothing!", "I'm sorry");
else
  do
    text =         "The number you entered was:" || NL
    text = text || long
    if long == 666 then text = text "(you devil!)"
    call rtezrequest(text, "So it was")
  end



/* MESSAGE REQUESTER */

call rtezrequest( "NUMBER 3:" || NL ||,
                  "Message requester,  the requester" || NL ||,
                  "you've been using all the time!" || NL ||,
                  "function: rtezrequest()", "Show me more")

call rtezrequest( "Simplest usage: some body text" || NL ||,
                  "and a single centered gadget.", "Got it")

do while rtezrequest( "You can also use two gadgets" || NL ||,
                      "to ask the user something." || NL ||,
                      "Do you understand?", "Of course|Not really") == 0
  call rtezrequest("You are not one of the brightest are you?", "Let me try again")
end

call rtezrequest("Great,  we'll continue then.", "Fine")

call rtezrequest( "You can also put up a requester" || NL ||,
                  "with three choices:" || NL ||,
                  "How do you like the demo so far ?", "_Great|_So so|_Rubbish")
if rtresult == 0 then
  call rtezrequest( "Too bad,  we really hoped" || NL ||,
                    "you would like it better.", "So what");
if rtresult == 1 then
  call rtezrequest("We're glad you like it so much.", "Fine")
if rtresult == 2 then
  call rtezrequest( "Maybe if you run the demo" || NL ||,
                    "again you'll REALLY like it!", "Perhaps")

call rtezrequest( "The number of responses is not limited to" || NL ||,
                  "three as you can see.  The gadgets are labeled" || NL ||,
                  "with the return code from rtezrequest()." || NL ||,
                  "Pressing Return will choose 4,  note that" || NL ||,
                  "4's button text is printed in boldface.",,
  "1|2|3|4|5|0", , "rtez_defaultresponse=4")

call rtezrequest("You picked '" || rtresult || "'.", "How true")

if rtezrequest( "It is also possible to pass extra IDCMP flags" || NL ||,
                "that will satisfy rtezrequest(). This requester" || NL ||,
                "has had 'idcmp_diskinserted' passed to it." || NL ||,
                "(Try inserting a disk).", "Continue", ,,
    "rt_idcmpflags=idcmp_diskinserted") == 0 then
  call rtezrequest("You used the 'Continue' gadget.", "I did")
else
  call rtezrequest("You inserted a disk.", "I did")

call rtezrequest( "Finally,  it is possible to specify the position of the" || NL ||,
                  "requester." || NL ||,
                  "E.g. at the top left of the screen,  like this." || NL ||,
                  "This works for all requesters,  not just rtezrequest()!",,
  "Amazing", , "rt_reqpos=reqpos_topleftscr")

call rtezrequest( "Alternatively,  you can center" || NL ||,
                  "the requester on the screen." || NL ||,
                  "Check out 'rexxreqtools.doc'" || NL ||,
                  "for all the possibilities.", "I'll do that", ,,
  "rt_reqpos=reqpos_centerscr")



/* FILE REQUESTER */

call rtezrequest( "NUMBER 4:" || NL ||,
                  "File requester" || NL ||,
                  "function: rtfilerequest()", "Demonstrate")

filename = rtfilerequest(, , "Pick a file")
if rtresult == 0 then
  call rtezrequest("You didn't pick a file.", "No")
else
  call rtezrequest("You picked the file:" || NL || filename, "Right")

call rtezrequest( "The file requester has the ability" || NL ||,
                  "to allow you to pick more than one" || NL ||,
                  "file (use Shift to extend-select)." || NL ||,
                  "Note the extra gadgets you get.", "Interesting")

filename = rtfilerequest(, , "Pick some files", , "rtfi_flags=freqf_multiselect")
if rtresult == 1 then
  call rtezrequest( "You selected" rtresult.count "files, " || NL ||,
                    "this is the first one:" || NL ||,
                    rtresult.1, "Aha")

call rtezrequest( "The file requester can be used" || NL ||,
                  "as a directory requester as well.", "Let's see that")

dirname = rtfilerequest(, , "Pick a directory", , "rtfi_flags=freqf_nofiles")
if rtresult == 0 then
  call rtezrequest("You didn't pick a directory.", "No")
else
  call rtezrequest("You picked the directory:" || NL || dirname, "Right")



/* FONT REQUESTER */

call rtezrequest( "NUMBER 5:" || NL ||,
                  "Font requester" || NL ||,
                  "function: rtfontrequest()", "Show")

call rtfontrequest("Pick a font", , "rtfo_flags=freqf_style")
if rtresult == 0 then
  call rtezrequest("You canceled." || NL || "Was there no font you liked ?", "Nope")
else
  call rtezrequest( "You picked the font:" || NL ||,
                    rtresult.name "size" rtresult.height, "Right")



/* PALETTE REQUESTER */

call rtezrequest( "NUMBER 6:" || NL ||,
                  "Palette requester" || NL ||,
                  "function: rtpaletterequest()", "Proceed")

color = rtpaletterequest(, "Change palette")
if rtresult == 0 then
  call rtezrequest("You canceled." || NL || "No nice colors to be picked ?", "Nah")
else
  call rtezrequest("You picked color number" color, "Sure did")



/* VOLUME REQUESTER */

call rtezrequest( "NUMBER 7:" || NL ||,
                  "Volume requester" || NL ||,
                  "function: rtfilerequest() with" || NL ||,
                  "          rtfi_volumerequest tag.", "Show me")

volumename = rtfilerequest(, , "Pick a volume", , "rtfi_volumerequest=0")
if rtresult == 0 then
  call rtezrequest("You didn't pick a volume.", "I did not")
else
  call rtezrequest("You picked the volume:" || NL || volumename, "Right")



call rtezrequest("That's it!" || NL || "Hope you enjoyed the demo", "Sure did")
