(*--------------------------------------------------------------------------
  :Program.    TRechner.mod
  :Contents.   Residenter Rechner mit Eingabe ber Stringgadget
  :Author.     Frank Lmker
  :Copyright.  FreeWare, siehe Dok-File
  :Language.   Modula-2
  :Translator. M2Amiga V4.1d
  :Imports.    IntuiSupport 1.1.4 [Christian Stiens]
  :Imports.    function [Frank Lmker], RenderInfo 1.1m [kai]
  :History.    V1.0, [Frank Lmker] 01-Mar-93
  :Bugs.       keine bekannt
--------------------------------------------------------------------------*)

MODULE TRechner;
(*$ DEFINE FFP:=TRUE DEFINE LONG:=FALSE *)

(*$ LargeVars:=FALSE StackParms:=FALSE RangeChk:=FALSE OverflowChk:=FALSE
    StackChk:=FALSE ReturnChk:=FALSE NilChk:=FALSE EntryClear:=FALSE
    CaseChk:=FALSE Volatile:=FALSE *)

FROM ExecL IMPORT OpenDevice,DoIO,CloseDevice,Signal,Wait,FindTask,FindPort;
FROM ExecD IMPORT MsgPortPtr,Interrupt,IOStdReqPtr,TaskPtr;
FROM ExecSupport IMPORT CreatePort,CreateStdIO,DeleteStdIO,DeletePort;
FROM Input IMPORT addHandler,remHandler,inputName;
FROM DosD IMPORT ctrlC,ctrlF;
FROM DosL IMPORT Delay;
FROM InputEvent IMPORT InputEventPtr,Qualifiers,Class;
FROM IntuitionL IMPORT CloseWindow,RefreshGadgets,ActivateGadget,
      DisplayBeep,ScreenToFront,ActivateWindow,intuitionBase,WindowToFront;
FROM IntuitionD IMPORT WindowPtr,ScreenPtr,WindowFlagSet,WindowFlags,
      IDCMPFlagSet,IDCMPFlags,ActivationFlagSet,ActivationFlags,
      GadgetFlagSet,GadgetPtr,IntuiMessage,StringInfoPtr;
FROM GraphicsL IMPORT Move,Text,SetAPen,OpenFont,SetFont,CloseFont;
FROM GraphicsD IMPORT RastPortPtr,TextFontPtr,FontFlags;
FROM IconL IMPORT FindToolType,GetDiskObject,FreeDiskObject;
FROM WorkbenchD IMPORT DiskObjectPtr;
FROM RenderInfo IMPORT GetRenderInfo,RenderInfoPtr,CleanUpRenderInfo;
FROM function IMPORT calcex,REAL,noFehler,Fehler,wrongSym,
      Klammerauf,Klammerzu;
FROM IntuiSupport IMPORT CreateWindowA,InitBorder,DefFont,CreateBoolGadget,
      CreateStrGadget,GetIMes,fontAttrPtr,xSize,autoBord3D,stdGadg,stdActv,
      UseTopaz,defaultFont;
FROM SYSTEM IMPORT ADR,ADDRESS,LONGSET,REG,SETREG;
FROM String IMPORT Delete;
FROM Arts IMPORT Assert,kickVersion,Terminate;
FROM Conversions IMPORT ValToStr,StrToVal;
FROM Arguments IMPORT GetArg;
FROM (*$ IF FFP *)     FFPConversions
     (*$ ELSIF LONG *) LongRealConversions
     (*$ ELSE *)       RealConversions    (*$ ENDIF *) IMPORT RealToStr;

CONST version="$VER: TRechner V1.0 (01-Mar-93) by Frank Lmker";
TYPE str35=ARRAY [0..35] OF CHAR;
     str65=ARRAY [0..65] OF CHAR;
     Pstr65=POINTER TO str65;
VAR ySize,oben,links:INTEGER;
    rp:RastPortPtr;
    mywin:WindowPtr;
    font:TextFontPtr;

PROCEDURE Print (x,y,len:INTEGER;text:ADDRESS);
BEGIN
  Move (rp,x,y*(ySize+1) DIV 2+oben);
  Text (rp,text,len);
END Print;

PROCEDURE PrintVal (x,y,base,len:INTEGER;zahl:LONGINT);
VAR s:str35;
    err:BOOLEAN;
BEGIN
  ValToStr (zahl,FALSE,s,base,len," ",err);
  Print (x,y,ABS(len),ADR(s));
END PrintVal;

PROCEDURE PrintReal (x,y,len,nach:INTEGER;zahl:REAL);
VAR s:str35;
    err:BOOLEAN;
BEGIN
  RealToStr (zahl,s,len,nach,FALSE,err);
  IF err THEN
    RealToStr (zahl,s,len,7,TRUE,err);
  END;
  Print (x,y,ABS(len),ADR(s));
END PrintReal;

PROCEDURE writeerg (wert:REAL;nach,err:SHORTINT);
VAR zahl:LONGINT;
BEGIN
  IF err=noFehler THEN
    PrintReal (links,5,-15,nach,wert);
  ELSE
    Print (links,5,15,ADR("  ----------   "));
  END;
  IF (ABS(wert)<2147480000.0) AND (err=noFehler) THEN
    zahl:=LONGINT(wert);
    PrintVal (links,3,2,-32,zahl);
    PrintVal (links,7,16,-12,zahl);
  ELSE
    Print (links,3,32,ADR("  ----------                    "));
    Print (links,7,12,ADR("  ----------"));
  END;
END writeerg;

PROCEDURE writeerr (err:SHORTINT);
VAR help:INTEGER;
BEGIN
  help:=links+3*xSize;
  CASE err OF
     noFehler  : Print (help,13,22,ADR("     ------------     "));
    |Fehler    : Print (help,13,22,ADR("     -- Fehler --     "));
    |wrongSym  : Print (help,13,22,ADR("  Falsches Symbol !   "));
    |Klammerauf: Print (help,13,22,ADR("Klammer auf erwartet !"));
    |Klammerzu : Print (help,13,22,ADR("Klammer zu erwartet ! "));
  END;
END writeerr;

PROCEDURE rechner(VAR x:REAL;VAR nach:SHORTINT;VAR funk:str65):BOOLEAN;
VAR funkgad,hidegad,quitgad:GadgetPtr;
    scr:ScreenPtr;

  PROCEDURE WinAuf():BOOLEAN;
  VAR ri:RenderInfoPtr;

    PROCEDURE testFont():BOOLEAN;
    BEGIN
      IF proportional IN fontAttrPtr^.flags THEN RETURN FALSE; END;
      links:=ri^.windowLeft+ri^.windowRight+39*xSize-1;     (* Breite *)
      oben:=ri^.windowTitle+INTEGER(fontAttrPtr^.ySize)+5+  (* Hoehe *)
            ri^.windowBottom+INTEGER(fontAttrPtr^.ySize+1)*7;
      IF (links>ri^.screenWidth) OR (oben>ri^.screenHeight) THEN
        RETURN FALSE;
      ELSE
        RETURN TRUE;
      END;
    END testFont;

  BEGIN
    mywin:=NIL; font:=NIL;
    scr:=intuitionBase^.activeScreen;
    ri:=GetRenderInfo (scr);
    DefFont (scr);
    IF NOT testFont() THEN
      DefFont (defaultFont);
      IF NOT testFont() THEN
        UseTopaz;
        IF NOT testFont() THEN
          DisplayBeep (scr);
          CleanUpRenderInfo (ri);
          RETURN FALSE;
        END;
      END;
    END;
    ySize:=fontAttrPtr^.ySize;
    InitBorder (ri^.highlight,ri^.shadow,TRUE);
    mywin:=CreateWindowA (ADR("TRechner V1.0,  Frank Lmker"),
                0,0,links,oben,scr,NIL,
                WindowFlagSet{activate,noCareRefresh,windowClose,windowDrag,
                windowDepth},IDCMPFlagSet{closeWindow,gadgetUp});
    oben:=ri^.windowTitle;
    links:=ri^.windowLeft+xSize;
    CleanUpRenderInfo (ri);
    rp:=mywin^.rPort;
    SetAPen (rp,1);
    font:=OpenFont (fontAttrPtr);
    IF font#NIL THEN SetFont (rp,font); END;
    funkgad:=CreateStrGadget (1,links,oben+ySize DIV 2,xSize*32,ySize,61,
                              autoBord3D,stdGadg,stdActv,funk,-1,mywin,font);
    hidegad:=CreateBoolGadget (2,links+31*xSize,10*(ySize+1) DIV 2+oben+6,
                xSize*6,ySize+1,ADR(" Hide "),autoBord3D,GadgetFlagSet{},
                ActivationFlagSet{relVerify},mywin);
    quitgad:=CreateBoolGadget (3,links+31*xSize,13*(ySize+1) DIV 2+oben+6,
                xSize*6,ySize+1,ADR(" Quit "),autoBord3D,GadgetFlagSet{},
                ActivationFlagSet{relVerify},mywin);
    INC (oben,ySize+4);
    Print (links, 3,4,ADR("Bin:"));
    Print (links, 5,4,ADR("Dez:"));
    Print (links, 7,4,ADR("Hex:"));
    Print (links,10,4,ADR("x  :"));
    Print (links,13,7,ADR("Fehler:"));
    RefreshGadgets (funkgad,mywin,NIL);
    INC (links,5*xSize);
    PrintReal (links,10,-15,nach,x);
    RETURN TRUE;
  END WinAuf;

VAR erg:REAL;
    err:SHORTINT;
    gadID:INTEGER;
    ch:CHAR;
    imes:IntuiMessage;
    stinfo:StringInfoPtr;
    set:LONGSET;
BEGIN
  gadID:=0;
  IF WinAuf() THEN
    REPEAT
      IF ActivateGadget (funkgad,mywin,NIL) THEN END;
      set:=Wait (LONGSET{mywin^.userPort^.sigBit}+LONGSET{ctrlC,ctrlF});
      IF ctrlC IN set THEN
        gadID:=3;
      ELSIF ctrlF IN set THEN
        IF intuitionBase^.firstScreen#scr THEN ScreenToFront (scr); END;
        IF intuitionBase^.activeWindow#mywin THEN
          WindowToFront (mywin);
          ActivateWindow (mywin);
        END;
        IF kickVersion<36 THEN Delay (10); END;
      ELSE
        GetIMes (mywin,imes,FALSE);
        IF gadgetUp IN imes.class THEN
          gadID:=GadgetPtr(imes.iAddress)^.gadgetID;
          IF gadID=1 THEN
            stinfo:=funkgad^.specialInfo;
            funk:=Pstr65(stinfo^.buffer)^;
            IF (funk[1]=":") AND (funk[2]="=") THEN
              ch:=CAP(funk[0]);
              Delete (funk,0,3);
              calcex (funk,x,erg,err); writeerr (err);
              IF err=noFehler THEN
                CASE ch OF
                   "N": IF (erg>=0.0) AND (erg<=10.9999) THEN
                          nach:=SHORTINT(erg);
                          PrintReal (links,10,-15,nach,x);
                        ELSE
                          err:=Fehler; writeerr (err);
                        END;
                  |"X": x:=erg;
                        PrintReal (links,10,-15,nach,x);
                  ELSE
                    err:=wrongSym; writeerr (err);
                END;  (* CASE ch *)
              END;  (* IF err=noFehler *)
            ELSE
              calcex (funk,x,erg,err);
              writeerg (erg,nach,err);
              writeerr (err);
            END;  (* IF (funk[1] *)
          END;  (* IF gadID *)
        END;  (* IF gadgetUp *)
      END;  (* IF ctrlF IN set *)
    UNTIL (gadID>1) OR (closeWindow IN imes.class);
    stinfo:=funkgad^.specialInfo;
    funk:=Pstr65(stinfo^.buffer)^;
    IF font#NIL THEN CloseFont (font); font:=NIL; END;
    IF mywin#NIL THEN CloseWindow (mywin); mywin:=NIL; END;
  END;  (* IF WinAuf *)
  RETURN gadID=3;
END rechner;

CONST PortName="TRechner.Port";
VAR ioPort: MsgPortPtr;
    intrpt: Interrupt;
    ioReq : IOStdReqPtr;
    mytask: TaskPtr;
    HandlerActive,InputOpen:BOOLEAN;
    key:CARDINAL;

(*$ SaveA4:=TRUE *)
PROCEDURE Handler (eventptr{8}:InputEventPtr;data{9}:ADDRESS): InputEventPtr;
BEGIN
  SETREG (12,data);
  IF eventptr^.class=rawkey THEN
    IF (control IN eventptr^.qualifier) AND
       (lAlt IN eventptr^.qualifier) AND (eventptr^.code=key) THEN
      Signal (mytask,LONGSET{ctrlF});
      eventptr:=eventptr^.nextEvent;
    END;
  END;
  RETURN eventptr;
END Handler;

PROCEDURE InstallHandler;
BEGIN
  ioPort:=CreatePort(ADR(PortName),0);
  Assert(ioPort # NIL,ADR("Kann MsgPort nicht einrichten"));
  ioReq:=CreateStdIO(ioPort);
  Assert(ioReq # NIL,ADR("Kann IOStdReq nicht einrichten"));
  OpenDevice(ADR(inputName),0,ioReq,LONGSET{});
  InputOpen:=TRUE;
  intrpt.data:=REG (12);
  intrpt.code:=ADR(Handler);
  intrpt.node.pri:=51;
  ioReq^.data:=ADR(intrpt);
  ioReq^.command:=addHandler;
  DoIO(ioReq);
  Assert(ioReq^.error = 0,ADR("I/O Fehler"));
  HandlerActive:=TRUE;
END InstallHandler;

VAR nach:SHORTINT;
    x:REAL;
    funk:str65;
    set:LONGSET;
    Name:ARRAY [1..110] OF CHAR;
    Icon:DiskObjectPtr;
    StrPtr:Pstr65;
    wert:LONGINT;
    signed,err,popup:BOOLEAN;
BEGIN
  StrPtr:=ADR(version);
  mywin:=NIL; font:=NIL; ioReq:=NIL; ioPort:=NIL;
  HandlerActive:=FALSE; InputOpen:=FALSE;
  nach:=3; x:=0.0; funk:="";
  key:=13H; popup:=FALSE; set:=LONGSET{};
  ioPort:=FindPort (ADR(PortName));
  IF ioPort#NIL THEN
    Signal (ioPort^.sigTask,LONGSET{ctrlF}); ioPort:=NIL;
    Terminate;
  END;
  GetArg (0,Name,oben);
  Icon:=GetDiskObject (ADR(Name));
  IF Icon#NIL THEN
    IF FindToolType (Icon^.toolTypes,ADR("POPUP"))#NIL THEN
      popup:=TRUE;
    END;
    StrPtr:=FindToolType (Icon^.toolTypes,ADR("POPKEY"));
    IF StrPtr # NIL THEN
       StrToVal (StrPtr^,wert,signed,10,err);
       IF NOT (signed OR err OR (wert>255)) THEN key:=wert; END;
    END;
    FreeDiskObject (Icon);
  END;
  mytask:=FindTask (NIL);
  InstallHandler;
  IF popup THEN
    IF rechner(x,nach,funk) THEN INCL (set,ctrlC); END;
  END;
  WHILE NOT (ctrlC IN set) DO
    set:=Wait (LONGSET{ctrlC,ctrlF});
    IF ctrlF IN set THEN
      IF rechner(x,nach,funk) THEN INCL (set,ctrlC); END;
    END;
  END;
CLOSE
  IF font#NIL THEN CloseFont (font); font:=NIL; END;
  IF mywin#NIL THEN CloseWindow (mywin); mywin:=NIL; END;
  IF HandlerActive THEN
    ioReq^.command:=remHandler;
    ioReq^.data:=ADR(intrpt);
    DoIO(ioReq);
    HandlerActive:=FALSE;
  END;
  IF InputOpen THEN CloseDevice (ioReq); InputOpen:=FALSE; END;
  IF ioReq#NIL THEN DeleteStdIO (ioReq); ioReq:=NIL; END;
  IF ioPort#NIL THEN DeletePort (ioPort); ioPort:=NIL; END;
END TRechner.
