MODULE DHanoi;

(* ---------------------------------------------------------- *)
(* Graphische Ausgabe                                         *)
(* ---------------------------------------------------------- *)
(* SetGraphMode  : Grafikmodus Einschalten und Initialisieren *)
(* EndGraphMode  : Grafikmodus Ausschalten und Cleanup        *)
(* ClearScreen   : Graphic-Output loeschen                    *)
(* FillRectangle : Ausgefuelltes Rechteck zeichnen            *)
(* FColor        : Setzt die Vordergrundfarbe                 *)
(* ---------------------------------------------------------- *)
(* (c) by Roger Meyer, 1992                                   *)
(* ---------------------------------------------------------- *)

IMPORT
  I : Intuition,
  G : Graphics;

VAR
  MyWin : I.WindowPtr;
  Win   : I.NewWindow;


PROCEDURE SetGraphMode*(w,h : INTEGER);

BEGIN
  Win.leftEdge   := 10;
  Win.topEdge    := 230-h;
  Win.width      := w;
  Win.height     := h;
  Win.flags      := LONGSET{I.windowDrag,
                            I.windowDepth,
                            I.gimmeZeroZero,
                            I.windowActive,
                            I.wbenchWindow}+I.otherRefresh;
  NEW(Win.title);
  Win.title^     := "Towers of Hanoi";
  Win.type       := {I.wbenchScreen};

  MyWin := I.OpenWindow(Win);

  G.SetAPen(MyWin.rPort,1);

END SetGraphMode;


PROCEDURE EndGraphMode*();

BEGIN
  I.CloseWindow(MyWin);

END EndGraphMode;


PROCEDURE ClearScreen*();

BEGIN
  G.SetAPen(MyWin.rPort,0);
  G.ClearScreen(MyWin.rPort);
  G.SetAPen(MyWin.rPort,1);

END ClearScreen;


PROCEDURE FillRectangle*(x1,y1,x2,y2 : INTEGER);

BEGIN
  G.RectFill(MyWin.rPort,x1,y1,x2,y2);

END FillRectangle;


END DHanoi.
