(*------------------------------------------------------------------------------
     :Program.    IntroCAD2TPIC.mod
     :Contents.   Wandelt das HPGL des IntroCADs in das TPIC Format
     :Author.     Matthias Scherrer
     :Address.    Baselstrasse 63, CH-4242 Laufen
     :Phone.      ++(0)61/7613975
     :Copyright.  PD
     :Language.   Oberon
     :Translator. Oberon V3.00d
     :History.    V1.0,06-Sep-92  Argumente werden ueber ReadString eingelesen
     :History.    V1.1,29-Dec-92  Argumente werden nun ueber GetArg eingelesen
------------------------------------------------------------------------------*)
MODULE IntroCAD2TPIC;

IMPORT
  str: Strings,
  d  : Dos,io,
  ol : OberonLib,
  sys: SYSTEM,
  a  : Arguments,
  f  : FileSystem;

CONST version = "$VER: IntroCAD2TPICV1.1(c)byMatthiasScherrer\n";
      number  = 500;

TYPE  string  = ARRAY 20 OF CHAR;
      lstring = ARRAY 1024 OF CHAR;

VAR retbo       : BOOLEAN;
    fileR,fileW : f.File;
    ch          : CHAR;
    cz,az,ai    : INTEGER;
    wFlag       : BOOLEAN;
    cmd         : ARRAY 2 OF CHAR;
    arg         : ARRAY number OF string;
    tpic        : lstring;
    inf,outf    : ARRAY 100 OF CHAR;
    

BEGIN
  inf:=version; a.GetArg(0,inf);
  IF a.NumArgs()<2 THEN 
     io.WriteString("Usage: "); io.WriteString(inf); 
     io.WriteString(" <Infile> <Outfile> \n"); 
     HALT(0) 
  END;
  a.GetArg(1,inf); 
  a.GetArg(2,outf);

  IF f.Open(fileR,inf,FALSE) THEN
    retbo:=f.Open(fileW,outf,TRUE);

    REPEAT
      cz:=0; az:=0; ai:=0; cmd:="";
      WHILE cz<number DO arg[cz]:=""; INC(cz); END; cz:=0;
      REPEAT
        retbo:=f.ReadChar(fileR,ch);
  
        IF (ORD(CAP(ch))>=65) AND (ORD(CAP(ch))<=90) THEN  (* Buchstabe *)
          cmd[cz]:=ch; INC(cz); ai:=0;
        END;

        IF (ORD(ch)=32) OR (ORD(ch)=44) THEN  (* Space oder Komma *) 
          INC(ai); az:=0; 
        END;    

        IF (ORD(ch)>=48) AND (ORD(ch)<=57) THEN  (* Zahl *)
          arg[ai,az]:=ch; INC(az); arg[ai,az]:=0X;
        END;
      UNTIL (ch=";") OR (fileR.status=f.eof);

      IF cmd="PU" THEN
        tpic:="\\path"; wFlag:=FALSE;
        str.Append(tpic,"("); str.Append(tpic,arg[1]);str.Append(tpic,",");
        str.Append(tpic,arg[2]);str.Append(tpic,")");
        arg[1]:=""; arg[2]:="";
      END;

      IF cmd="PD" THEN 
        az:=1; wFlag:=TRUE;
        WHILE arg[az]#"" DO 
          str.Append(tpic,"("); str.Append(tpic,arg[az]);str.Append(tpic,",");
          str.Append(tpic,arg[az+1]);str.Append(tpic,")");
          INC(az,2);
        END;
        IF az=1 THEN wFlag:=FALSE END;
      END;
  
      IF wFlag THEN retbo:=f.WriteString(fileW,tpic) END;
    UNTIL fileR.status=f.eof;

    IF fileR.handle#NIL THEN retbo:=f.Close(fileR) END;
    IF fileW.handle#NIL THEN retbo:=f.Close(fileW) END;

    io.WriteLn; io.WriteString("Done!"); io.WriteLn; io.WriteLn;
  ELSE
    io.WriteString("Can't open "); io.WriteString(inf); 
    io.WriteString("!"); io.WriteLn;
  END
END IntroCAD2TPIC.
