(*------------------------------------------------------------------------------
     :Program.    DoStat.mod
     :Contents.   Wertet x/y Daten aus
     :Author.     Matthias Scherrer
     :Address.    Baselstrasse 63, CH-4242 Laufen
     :Phone.      ++(0)61/7613975
     :Copyright.  PD
     :Language.   Oberon
     :Translator. Oberon V3.00d
     :Imports.    Statistik.mod, ReadDat.mod
     :History.    V1.0,01-Dec-92  fuer Oberon 2.14d
     :History.    V1.1,29-Dec-92  angepasst an Oberon V3.00d
------------------------------------------------------------------------------*)
MODULE DoStat;

IMPORT stat : Statistik, rd : ReadDat, arg : Arguments, io,
       lrio : LongRealInOut;

CONST
   Usage = "DoStat by Matthias Scherrer\n\nUsage: DoStat filename\n\n";

VAR   p        : INTEGER;
      filename : ARRAY 150 OF CHAR;
      d        : ARRAY 500,2 OF LONGREAL;
      s        : stat.stat;
      retbo    : BOOLEAN;

BEGIN
  filename:="$VER:Regression_V1.0";
  p:=arg.NumArgs();
  IF p=0 THEN io.WriteString(Usage); HALT(0) END;
  arg.GetArg (p,filename); 
  IF filename="?" THEN io.WriteString(Usage); HALT(0) END;

  s.n:=rd.ReadDatas(filename,d);
  IF s.n=-1 THEN io.WriteString("File not found!\n") ELSE
     stat.DoStat(s,d);
    
    io.WriteString("\n\nStatistik vom "); io.WriteString(filename);
    io.WriteString("\n=========\n\n");
    io.WriteString("\nAnzahl          : "); io.WriteInt(s.n+1,3); 
    io.WriteString("\nGrsstes x      : "); retbo:=lrio.WriteReal(s.maxx,6,6,TRUE);     
    io.WriteString("\nKleinstes x     : "); retbo:=lrio.WriteReal(s.minx,6,6,TRUE);     
    io.WriteString("\nGrsstes y      : "); retbo:=lrio.WriteReal(s.maxy,6,6,TRUE);     
    io.WriteString("\nKleinstes y     : "); retbo:=lrio.WriteReal(s.miny,6,6,TRUE);     
    io.WriteString("\nSumme x         : "); retbo:=lrio.WriteReal(s.Ex,6,6,TRUE);     
    io.WriteString("\nSumme y         : "); retbo:=lrio.WriteReal(s.Ey,6,6,TRUE);     
    io.WriteString("\nSumme x^2       : "); retbo:=lrio.WriteReal(s.Ex2,6,6,TRUE);     
    io.WriteString("\nSumme y^2       : "); retbo:=lrio.WriteReal(s.Ey2,6,6,TRUE);     
    io.WriteString("\nProdukt x*y     : "); retbo:=lrio.WriteReal(s.Exy,6,6,TRUE);     
    io.WriteString("\nMittelwert x    : "); retbo:=lrio.WriteReal(s.mx,6,6,TRUE);     
    io.WriteString("\nMittelwert y    : "); retbo:=lrio.WriteReal(s.my,6,6,TRUE);     
    io.WriteString("\nStreuung x      : "); retbo:=lrio.WriteReal(s.sx,6,6,TRUE);     
    io.WriteString("\nStreuung y      : "); retbo:=lrio.WriteReal(s.sy,6,6,TRUE);     
    io.WriteString("\nSteigung b      : "); retbo:=lrio.WriteReal(s.b,6,6,TRUE);     
    io.WriteString("\nAchsenabschn. c : "); retbo:=lrio.WriteReal(s.c,6,6,FALSE);     
    io.WriteString("\nStreuung b      : "); retbo:=lrio.WriteReal(s.sb,6,6,FALSE);     
    io.WriteString("\nStreuung c      : "); retbo:=lrio.WriteReal(s.sc,6,6,FALSE);     
    io.WriteString("\nKorrel.Koeff. r : "); retbo:=lrio.WriteReal(s.r,6,6,FALSE);     
    io.WriteLn; io.WriteLn;
  END;
END DoStat.
