(*------------------------------------------------------------------------------
     :Program.    ReadDat.mod
     :Contents.   Liest x/y-Werte aus einem ASCII-File
     :Author.     Matthias Scherrer
     :Address.    Baselstrasse 63, CH-4242 Laufen
     :Phone.      ++(0)61/7613975
     :Copyright.  PD
     :Language.   Oberon
     :Translator. Oberon V3.00d
     :History.    V1.0,01-Dec-92  fuer Oberon 2.14d
     :History.    V1.1,29-Dec-92  angepasst an Oberon V3.00d
------------------------------------------------------------------------------*)
MODULE ReadDat;  (* liest x/y daten in ein 2d-array of longreal *)

IMPORT
  lr   : LongRealConversions,
  d    : Dos,io,
  s    : Strings,
  f    : FileSystem;

(* gibt anzahl gelesener Daten oder -1 zurueck *)
PROCEDURE ReadDatas*(rf: ARRAY OF CHAR; VAR d: ARRAY OF ARRAY OF LONGREAL): INTEGER;
VAR
    retbo,Trenn    : BOOLEAN;
    fileR          : f.File;
    str,str1,str2  : ARRAY 200 OF CHAR; 
    val1,val2      : LONGREAL;          
    i,t,anz        : INTEGER;

  PROCEDURE CloseFile;
  BEGIN
    IF fileR.handle#NIL THEN
      retbo := f.Close(fileR);
    END; 
  END CloseFile;

BEGIN
  anz:=0;
  retbo := f.Open(fileR,rf,FALSE); 
  IF NOT retbo THEN CloseFile; RETURN -1 END;
  REPEAT
    retbo := f.ReadString(fileR,str);
    IF retbo THEN
      i:=0; Trenn:=FALSE;
      WHILE (i<s.Length(str)) AND NOT Trenn DO
        str1[i]:=str[i];
        INC(i);
        IF str[i]="," THEN str[i]:=CHR(32) END;
        IF (str[i]=CHR(32)) AND (str[i-1]>="0") AND (str[i-1]<="9") 
            THEN Trenn:=TRUE; 
        END;
      END;
      str1[i]:=0X;
      t:=0;
      WHILE i<s.Length(str) DO
        INC(i);
        IF str[i]="," THEN str[i]:=CHR(32) END;
        str2[t]:=str[i];
        INC(t); 
      END;  
      str2[i]:=0X;
    
      IF (s.Length(str1)>0) AND (s.Length(str2)>0) THEN
        retbo :=lr.StringToReal(str1,val1);
        retbo :=lr.StringToReal(str2,val2);
        d[anz,0]:=val1; d[anz,1]:=val2; 
        INC(anz);
        IF anz>499 THEN io.WriteString("ERROR - Too many Datas!"); HALT(20) END;
      END;
    END;
  UNTIL fileR.status=f.eof;
 
  CloseFile;
  RETURN anz-1;
END ReadDatas;

END ReadDat.
