(*----------------------------------------------------------------------------
 :Program.     StopWatch.mod
 :Contents.    Sehr genaue Zeitmessungen mittels der neuen ReadEClock Funktion
 :Author.      Christian Stiens
 :Address.     Snail-Mail:           E-Mail:
 :Address.     Heustiege 2           FIDO: 2:245/5802.25
 :Address.     W-4710 Ldinghausen   UUCP: Christian_Stiens@ouzonix.bo.open.de
 :Copyright.   public domain
 :Language.    Oberon-2
 :Translator.  Amiga Oberon 3.01
 :History.     V1.0, 03-Mar-93: First release
 :Imports.     DeviceSupport37
----------------------------------------------------------------------------*)

MODULE StopWatch;

  (* $OvflChk- $RangeChk- $NilChk- $StackChk- *)


  IMPORT
    e   := Exec,
    ds  := DeviceSupport37,
    t   := Timer,
    SYS := SYSTEM;


  VAR
    tio   : t.TimeRequestPtr;
    scal  : REAL;
    adj   : LONGINT;
    e1,e2 : t.EClockVal;



  PROCEDURE Start* ();
  BEGIN
    SYS.SETREG(0,t.ReadEClock(e1));
  END Start;
  
  

  PROCEDURE Stop* (): LONGINT;
  BEGIN
    SYS.SETREG(0,t.ReadEClock(e2));
    RETURN ENTIER((e2.lo-e1.lo)*scal)-adj;
  END Stop;


  PROCEDURE Adjust* ;
  BEGIN
    adj := 0;
    e.Disable;
    Start;
    adj := Stop();
    e.Enable;
  END Adjust;


BEGIN

  IF e.exec.libNode.version >= 36 THEN
    tio := ds.OpenDev(t.timerName,t.eClock,LONGSET{},SIZE(tio^),NIL);
    IF tio=NIL THEN HALT(0) END;
    t.base := tio.node.device;
    scal := 1000000 / e.exec.eClockFrequency;
    Adjust;
  END;

CLOSE

  ds.CloseDev(tio);

END StopWatch.

