(*---------------------------------------------------------------------------
  :Version.    $VER: CxSupport.mod 1.41 (27.04.93) by Thomas Igracki
  :Address.    Obstallee 45, 1000 Berlin 20, W-Germany
  :E-Mail.     ZNET: T.Igracki@BAMP.ZER
  :E-Mail.     FIDO: Thomas_Igracki%2:2403_10.40
  :E-Mail.     UUCP: t_igracki@bamp.berlinet.in-berlin.de -oder-
  :E-Mail.           lokai@cs.tu-berlin.de
  :Copyright.  Me
  :Language.   Oberon
  :Translator. Amiga Oberon 3.00d
  :Contents.   Commodities.library support functions
  :Usage.      IMPORT CxSupport;
  :Remark.     OS2.0 Only!
  :Remark.     If you use a custom function then compile & link _WITHOUT_
  :Remark.     SmallData (-d)! But you can link with option s (SMALL) and
  :Remark.     use (* $StackChk- $SaveRegs+ $ClearVars- $DeallocPars- *)
  :Remark.     for this Procedure!!
  :History.    1.1 : Added HotFunc()!
  :History.    1.2 : New Function: Translate (fromHotKey,toHotKey).
  :History.    1.21 (03.10.92): The HotKey() and other funcs are now bool funcs!
  :History.    1.22 (14.03.93):
  :History.          I forgot some 'RETURN TRUE's in the bool funcs, sorry!
  :History.          If InitBroker() returnes -1, look for 'brokerError'
  :History.          Changed the exported vars to read-only vars.
  :History.    1.30 (05.04.93):
  :History.	     I forgot the ReplyMsg()'s in GetID() & HandleExCh();-)
  :History.	     RemBroker() now removes all outstandings msgs from both ports!
  :History.	     If someone tries to open a broker with your name, 'show' will be
  :History.	     TRUE in HandleExCh() instead of 'kill'.
  :History.    1.40 (10.04.93):
  :History.          New Function: GetLastDescrObj(), ChangeDescr()
  :History.          The hotkey functions will check the descr.
  :History.    1.41 (27.04.93): Translate() Hotkeys konnte man nicht ndern.
---------------------------------------------------------------------------*)
MODULE CxSupport;
IMPORT
   s: SYSTEM, e: Exec, c: Commodities, ie: InputEvent, OberonLib;
VAR
   cxBase    : e.LibraryPtr;

   broker    : c.CxObjPtr; (* Only 1 Broker is supported! *)
   SendPort,
   ComPort   : e.MsgPortPtr;

   brokerErr-: LONGINT;    (* Error from InitBroker *)
   ExChSig-  : SHORTINT;   (* IF this Signal arrives then call HandleExCh() *)
   cxo,     		   (* the last CxObj *)
   cxDescr   : c.CxObjPtr; (* the last CxObj from SetFilter() *)

(* first the CORRECT definition of some commodities procs *)

PROCEDURE SetTranslate   *{cxBase,-114}(translator{8}: c.CxObjPtr; ie{9}   : ie.InputEvent);
PROCEDURE SetFilter      *{cxBase,-120}(filter{8}    : c.CxObjPtr; descr{9}: ARRAY OF CHAR);

(* Jetzt meine eigenen *)
PROCEDURE InitBroker* (name, title, descr: ARRAY OF CHAR; showHide: BOOLEAN): SHORTINT; (* $CopyArrays- *)
VAR nb: c.NewBroker;
BEGIN
     IF broker # NIL THEN RETURN -1 END; (* Only 1! *)

     ComPort := e.CreateMsgPort(); IF ComPort = NIL THEN RETURN -1 END;
     SendPort:= e.CreateMsgPort(); IF SendPort= NIL THEN e.DeleteMsgPort(ComPort); RETURN -1 END;

     nb := c.NewBroker (c.nbVersion, NIL,NIL,NIL, {c.notify}, {},0,NIL,0);
     nb.name := s.ADR(name); nb.title := s.ADR(title); nb.descr := s.ADR(descr);
     nb.port := ComPort; ExChSig := ComPort.sigBit;
     IF showHide THEN nb.flags := {c.showHide} END;
     broker := c.CxBroker (nb,brokerErr);

     IF brokerErr # c.ErrOk THEN
        e.DeleteMsgPort (ComPort); e.DeleteMsgPort (SendPort); RETURN -1
     ELSE
        RETURN SendPort.sigBit
     END;
END InitBroker;

PROCEDURE InitBroker2* (name : ARRAY OF CHAR;
		        title: e.STRPTR; (* damit man hier auch SYSTEM.ADR(VERSION[6]) angeben kann *)
		        descr: ARRAY OF CHAR; showHide: BOOLEAN): SHORTINT; (* $CopyArrays- *)
BEGIN
     RETURN InitBroker (name,title^,descr,showHide);
END InitBroker2;

PROCEDURE Activate* (on: BOOLEAN);
BEGIN     IF broker # NIL THEN s.SETREG (0,c.ActivateCxObj (broker,s.VAL(SHORTINT,on))) END;
END Activate;

PROCEDURE HotKeyID* (descr: ARRAY OF CHAR; ID: INTEGER): BOOLEAN; (* $CopyArrays- *)
BEGIN
     IF broker = NIL THEN RETURN FALSE END; (* First InitBroker() *)

     cxo := c.CxFilter (s.ADR(descr)); IF c.CxObjError(cxo) # LONGSET{} THEN RETURN FALSE END;
     cxDescr := cxo; (* to change the descr later with ChangeDescr() *)

     c.AttachCxObj (cxo, c.CxSender (SendPort, ID));
     c.AttachCxObj (cxo, c.CxTranslate (NIL));
     c.AttachCxObj (broker, cxo);
     RETURN TRUE
END HotKeyID;

PROCEDURE HotKeySig* (descr: ARRAY OF CHAR; sig: SHORTINT): BOOLEAN; (* $CopyArrays- *)
BEGIN
     IF broker = NIL THEN RETURN FALSE END; (* First InitBroker() *)

     cxo := c.CxFilter (s.ADR(descr)); IF c.CxObjError(cxo) # LONGSET{} THEN RETURN FALSE END;
     cxDescr := cxo; (* to change the descr later with ChangeDescr() *)

     c.AttachCxObj (cxo, c.CxSignal (OberonLib.Me, sig));
     c.AttachCxObj (cxo, c.CxTranslate (NIL));
     c.AttachCxObj (broker, cxo);
     RETURN TRUE
END HotKeySig;

PROCEDURE CxFuncID* (func: c.CustomProcType; ID: INTEGER): BOOLEAN;
BEGIN
     IF broker = NIL THEN RETURN FALSE END; (* First InitBroker() *)

     cxo := c.CxCustom (func,0); IF cxo = NIL THEN RETURN FALSE END;
     c.AttachCxObj (cxo, c.CxSender (SendPort, ID));
     c.AttachCxObj (cxo, c.CxTranslate (NIL));
     c.AttachCxObj (broker, cxo);
     RETURN TRUE
END CxFuncID;

PROCEDURE CxFunc* (func: c.CustomProcType): BOOLEAN;
BEGIN
     IF broker = NIL THEN RETURN FALSE END; (* First InitBroker()!! *)

     cxo := c.CxCustom (func,0); IF cxo = NIL THEN RETURN FALSE END;
     c.AttachCxObj (cxo, c.CxTranslate (NIL));
     c.AttachCxObj (broker, cxo);
     RETURN TRUE
END CxFunc;

PROCEDURE HotFunc* (descr: ARRAY OF CHAR; func: c.CustomProcType): BOOLEAN; (* $CopyArrays- *)
BEGIN
     IF broker = NIL THEN RETURN FALSE END; (* First InitBroker() *)

     cxo := c.CxFilter (s.ADR(descr)); IF c.CxObjError(cxo) # LONGSET{} THEN RETURN FALSE END;
     cxDescr := cxo; (* to change the descr later with ChangeDescr() *)

     c.AttachCxObj (cxo, c.CxCustom (func, 0));
     c.AttachCxObj (cxo, c.CxTranslate (NIL));
     c.AttachCxObj (broker, cxo);
     RETURN TRUE
END HotFunc;

PROCEDURE Translate* (fromDescr,toDescr: ARRAY OF CHAR): BOOLEAN; (* $CopyArrays- *)
VAR ix: c.IXPtr; ev: ie.InputEventPtr;
BEGIN
     IF broker = NIL THEN RETURN FALSE END; (* First InitBroker() *)

     NEW(ev); (* IF ev = NIL THEN RETURN FALSE END; *)
     NEW(ix); (* IF ix = NIL THEN DISPOSE(ev); RETURN FALSE END; *)
     IF c.ParseIX (toDescr,ix^) # 0 THEN DISPOSE(ev); DISPOSE(ix); RETURN FALSE END;

     cxo := c.CxFilter (s.ADR(fromDescr));
     cxDescr := cxo; (* to change the descr later with ChangeDescr() *)
     IF c.CxObjError(cxo) # LONGSET{} THEN DISPOSE(ev); DISPOSE(ix); RETURN FALSE END;
     (* copying the needed fields of ix to ev *)
     ev.class := ix.class; ev.code := s.VAL(INTEGER,ix.code);
     ev.qualifier := ix.qualifier;

     c.AttachCxObj (cxo, c.CxTranslate (ev));
     c.AttachCxObj (broker, cxo);
     RETURN TRUE
END Translate;

PROCEDURE GetLastDescrObj* (VAR descrObj: c.CxObjPtr): BOOLEAN;
BEGIN     IF cxDescr = NIL THEN RETURN FALSE ELSE descrObj := cxDescr; RETURN TRUE END;
END GetLastDescrObj;

PROCEDURE ChangeDescr* (VAR descrObj: c.CxObjPtr; newDescr: ARRAY OF CHAR): BOOLEAN; (* $CopyArrays- *)
BEGIN     SetFilter (descrObj, newDescr); RETURN c.CxObjError(descrObj) = LONGSET{}
END ChangeDescr;

PROCEDURE GetID*(): INTEGER;
VAR msg: e.MessagePtr; cxID: INTEGER;
BEGIN
     IF broker = NIL THEN RETURN -1 END;

     cxID := -1;
     msg := e.GetMsg (SendPort); IF msg = NIL THEN RETURN -1 END;
     cxID := SHORT(c.CxMsgID(s.VAL(c.CxMsgPtr,msg)));
     e.ReplyMsg (msg);

     RETURN cxID
END GetID;

PROCEDURE HandleExCh* (VAR show, hide, kill: BOOLEAN);
VAR msg: e.MessagePtr; cxID: INTEGER;
BEGIN
     show := FALSE; hide := FALSE; kill := FALSE;

     msg := e.GetMsg (ComPort); IF msg = NIL THEN RETURN END;
     cxID := SHORT(c.CxMsgID(s.VAL(c.CxMsgPtr,msg)));
     e.ReplyMsg (msg);

     CASE cxID OF
          c.cmdDisable   : Activate(FALSE)
         |c.cmdEnable    : Activate(TRUE)
         |c.cmdAppear,
          c.cmdUnique    : show := TRUE
         |c.cmdDisappear : hide := TRUE
         |c.cmdKill      : kill := TRUE
     ELSE
     END
END HandleExCh;

PROCEDURE InformBroker* (co: c.CxObjPtr; cxm: c.CxMsgPtr);
BEGIN     c.DivertCxMsg (cxm,co,co);
END InformBroker;

PROCEDURE RemBroker*;

  PROCEDURE ReplyMsgs (port: e.MsgPortPtr);
  VAR msg: e.MessagePtr;
  BEGIN     LOOP  msg := e.GetMsg (port); IF msg = NIL THEN EXIT ELSE e.ReplyMsg (msg) END;  END;
  END ReplyMsgs;

BEGIN
     IF ComPort  # NIL THEN ReplyMsgs (ComPort);  e.DeleteMsgPort (ComPort);  ComPort  := NIL END;
     IF SendPort # NIL THEN ReplyMsgs (SendPort); e.DeleteMsgPort (SendPort); SendPort := NIL END;
     IF broker   # NIL THEN c.DeleteCxObjAll (broker); broker := NIL END;
END RemBroker;

BEGIN
    cxBase := c.base;
CLOSE
    RemBroker()
END CxSupport.
