(*---------------------------------------------------------------------------
  :Program.    CxSupportTest
  :Author.     Thomas Igracki
  :Address.    Obstallee 45, 1000 Berlin 20, W-Germany
  :E-Mail.     ZNET: T.Igracki@BAMP.ZER
  :E-Mail.     FIDO: Thomas_Igracki%2:2403_10.40
  :E-Mail.     UUCP: t_igracki@bamp.berlinet.in-berlin.de -oder-
  :E-Mail.           lokai@cs.tu-berlin.de
  :Version.    V1.2
  :Date.       27-Apr-1993
  :Copyright.  Me
  :Language.   Oberon
  :Translator. Amiga Oberon 3.00d
  :Contents.   Testprogramm fr CxSupport.mod
  :Usage.      CxSupportTest
  :Remark.     OS2.0 Only!
---------------------------------------------------------------------------*)
MODULE CxSupportTest;  (* $IF SmallData *) Bitte ohne -d compilieren und linken (* $END *)
IMPORT
   s: SYSTEM, e: Exec, d: Dos,
   c: Commodities, ie: InputEvent, OberonLib, cx: CxSupport;
CONST
   alt1ID = 0; cxFuncID = 1; hotFuncID = 2;
VAR
   hotFuncSig,
   hotKeySig,
   brokerSig        : SHORTINT;
   ls               : LONGSET;
   show, hide, kill : BOOLEAN;
   LEDToggle        : BOOLEAN;
   alt2Obj	    : c.CxObjPtr;
   changed	    : BOOLEAN;

(* $CopyArrays- *)
PROCEDURE Halt (txt: ARRAY OF CHAR); BEGIN d.PrintF("%s\n",s.ADR(txt)); HALT(d.warn) END Halt;

(* $StackChk- $SaveRegs+ $ClearVars- $DeallocPars- *)
PROCEDURE *LeftyMouse (co: c.CxObjPtr; cxm: c.CxMsgPtr);
VAR ev: ie.InputEventPtr; newQuals: SET; upPref: INTEGER;
BEGIN
     ev := c.CxMsgData(cxm);

     (* change left & right mouse button *)
     IF ev.class = ie.rawmouse THEN
        newQuals := ev.qualifier;
        (* first check the qualifiers *)
        IF ie.rightButton IN ev.qualifier THEN
           EXCL (newQuals,ie.rightButton); INCL (newQuals,ie.leftButton);
        END;
        IF ie.leftButton IN ev.qualifier THEN
           EXCL (newQuals,ie.leftButton); INCL (newQuals,ie.rightButton);
        END;
        ev.qualifier := newQuals;
        (* now check the code field *)
        IF ev.code >= ie.upPrefix THEN upPref := ie.upPrefix; DEC (ev.code,ie.upPrefix)
                                  ELSE upPref := 0
        END;
        IF    ev.code = ie.rButton THEN ev.code := ie.lButton+upPref
        ELSIF ev.code = ie.lButton THEN ev.code := ie.rButton+upPref
        END;

        IF ev.code = ie.mButton THEN cx.InformBroker (co,cxm) END;

     END;
END LeftyMouse; (* $StackChk= $ClearVars= *)

PROCEDURE PowerLED* (onOff{0}: BOOLEAN);
VAR ciaapra [0BFE001H]: SHORTSET;
BEGIN   IF onOff THEN EXCL(ciaapra,1) ELSE INCL(ciaapra,1) END
END PowerLED;

(* $StackChk- $SaveAllRegs+ $ClearVars- $DeallocPars- *)
PROCEDURE *HotFunc (co: c.CxObjPtr; cxm: c.CxMsgPtr);
BEGIN
     PowerLED (LEDToggle); LEDToggle := ~LEDToggle;
     IF LEDToggle THEN e.Signal (OberonLib.Me,LONGSET{hotFuncSig}) END;
END HotFunc; (* $StackChk= $ClearVars= *)

BEGIN

     LEDToggle := TRUE;
     hotFuncSig := -1; (* falls hotKeySig nicht alloziiert werden kann! *)

     hotKeySig  := e.AllocSignal(-1); IF hotKeySig  = -1 THEN Halt ('No HotKeySig!') END;
     hotFuncSig := e.AllocSignal(-1); IF hotFuncSig = -1 THEN Halt ('No HotFuncSig!') END;

     brokerSig := cx.InitBroker ('CxSupportTest','This is a test of my CxSupport-Modul','for the commodities.library',TRUE);
     IF brokerSig = -1 THEN Halt('No Broker!') END;

     IF ~cx.HotKeyID  ("alt 1",alt1ID)     THEN Halt('HotKeyID() failed!') END;
     IF ~cx.HotKeySig ("alt 2",hotKeySig)  THEN Halt('HotKeySig() failed!') END;
     IF ~cx.GetLastDescrObj(alt2Obj)	   THEN Halt('GetLastDescrObj() failed!') END;
     IF ~cx.HotFunc ("alt 3",HotFunc) 	   THEN Halt('HotFunc() failed!') END;
     IF ~cx.Translate('','help') 	   THEN Halt('Translate() failed!') END;
     IF ~cx.CxFuncID (LeftyMouse,cxFuncID) THEN Halt('CxFuncID() failed!') END;

     cx.Activate (TRUE);

     d.PrintF ('CxSupportTestModul activated:\n'
               '  - The left & right mousebuttons changed (for lefthanders)!\n'
               '  - Two hotkeys installed (alt 1 and alt 2).\n'
               '  - A hotfunction (alt 3) to toggle the PowerLED.\n'
               '  - Translated "" to HELP.\n'
               '\nQuit with Ctrl-C or with the ExChange program.\n\n');

     LOOP
        ls := e.Wait (LONGSET{d.ctrlC..d.ctrlF,hotKeySig,hotFuncSig,brokerSig,cx.ExChSig});

        IF d.ctrlC    IN ls THEN Halt ('Break detected!') END;
        IF d.ctrlD    IN ls THEN d.PrintF ('Commodity disabled\n'); cx.Activate(FALSE) END;
        IF d.ctrlE    IN ls THEN d.PrintF ('Commodity enabled\n'); cx.Activate(TRUE) END;
        IF d.ctrlF    IN ls THEN d.PrintF ('Now you should show your Interface.\n') END;

        IF hotKeySig  IN ls THEN
	   IF ~changed THEN
	      d.PrintF ('Alt 2 pressed!\n');
	      IF ~cx.ChangeDescr(alt2Obj,'alt 4') THEN
	         d.PrintF ("Couldn't change the description!\n");
	      ELSE
	         d.PrintF ("Change Hotkey to Alt 4\n"); changed := TRUE;
	      END;
	   ELSE
	      d.PrintF ('Alt 4 pressed!\n');
	      IF ~cx.ChangeDescr(alt2Obj,'alt 2') THEN
	         d.PrintF ("Couldn't change the description!\n");
	      ELSE
	         d.PrintF ("Change Hotkey to Alt 2\n"); changed := FALSE;
	      END;
	   END;
        END;
        IF hotFuncSig IN ls THEN d.PrintF ('Hotfunc signalled us!\n') END;

        IF brokerSig IN ls THEN
            (* get the id of the hotkey or custom function *)
            CASE cx.GetID() OF
               |alt1ID   : d.PrintF ('Alt 1 pressed!\n')
               |cxFuncID : d.PrintF ('LeftyMouse signalled us!\n')
            ELSE
            END;
        END;

        IF cx.ExChSig IN ls THEN
           cx.HandleExCh (show,hide,kill);
           IF show  THEN d.PrintF ('Now you should show your Interface.\n') END;
           IF hide  THEN d.PrintF ('And now hide your Interface.\n') END;
           IF kill  THEN d.PrintF ("Ciao!!!\n"); EXIT END;
        END;
     END
CLOSE
    e.FreeSignal (hotKeySig); e.FreeSignal (hotFuncSig);
END CxSupportTest.
