MODULE FontSupport;

IMPORT D := DiskFont, e := Exec, g := Graphics, S := SYSTEM;

VAR
  Font        - : g.TextAttrPtr;
  Fontname      : e.STRPTR;
  Fonthoehe   -,
  Gadgethoehe -,
  Fontbreite  -,
  Baseline    - : INTEGER;
  Diskfont    - : g.TextFontPtr;

PROCEDURE OpenFont * (Name : ARRAY OF CHAR; Hoehe : INTEGER);
BEGIN
  S.ALLOCATE (Font);     IF Font     = NIL THEN RETURN END;
  S.ALLOCATE (Fontname); IF Fontname = NIL THEN RETURN END;
  IF Name # "" THEN
    COPY (Name, Fontname^);
    IF Hoehe > 0 THEN
      Font^.ySize := Hoehe
    ELSE
      Font^.ySize := Fonthoehe
    END
  ELSE
    e.Forbid;
    COPY (g.base^.defaultFont^.message.node.name^, Fontname^);
    Font^.ySize := g.base^.defaultFont^.ySize;
    e.Permit
  END;
  Font^.name := Fontname;
  Font^.style := SHORTSET {};
  Font^.flags := SHORTSET {g.diskFont};
  Diskfont := D.OpenDiskFont (Font^);
  IF Diskfont # NIL THEN
    Fonthoehe   := Diskfont^.ySize;
    Fontbreite  := Diskfont^.xSize;
    Baseline    := Diskfont^.baseline;
    Gadgethoehe := Fonthoehe + 4
  END
END OpenFont;

PROCEDURE CloseFont *;
BEGIN
  DISPOSE (Font); Font := NIL; DISPOSE (Fontname);
  IF Diskfont # NIL THEN g.CloseFont (Diskfont); Diskfont := NIL END
END CloseFont;

BEGIN
  Font := NIL; Diskfont := NIL;
  Fonthoehe := 8; Fontbreite := 8; Baseline := 6; Gadgethoehe := 12
END FontSupport.
